	subroutine initarrays
c+
c       Startvalues for all important arrays.
c
c       Version : 1.0
c       Date    : 02 Oct 96
c
c       Authors : R.B. Neder  (reinhard.neder@mail.uni-wuerzburg.de)
c                 Th. Proffen (proffen@pa.msu.edu)
c-
	implicit  	none
c
	include 	'config.inc'
	include 	'atom_env.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
	include 	'gen_add.inc'
	include 	'microdis.inc'
	include 	'microsta.inc'
	include 	'molecule.inc'
	include 	'output.inc'
	include 	'patters.inc'
	include 	'powder.inc'
	include 	'plot.inc'
	include 	'save.inc'
	include 	'stack.inc'
	include 	'sym_add.inc'
	include 	'symm.inc'
	include 	'transfrm.inc'
	include 	'waves.inc'
	include 	'rmc.inc'
	include 	'pdf.inc'
	include 	'mc.inc'
	include 	'chem.inc'
	include 	'diffuse.inc'
c
	integer		i,j,k,l,m
        integer         stift(0:4)
c
        data    stift   /5,3,1,2,4/
c
c------ common  /at_env/ 
c
	do i=1,MAX_ATOM_ENV
	  atom_env(i)=0.0
	enddo
c
c------	common
c
	cr_newtype  =.true.
	cr_at_lis(0)='VOID'
	as_at_lis(0)='VOID'
	cr_scat_int(0)=.true.
	cr_delf_int(0)=.true.
	do i=1,MAXSCAT
	  cr_at_lis(i)='    '
	  as_at_lis(i)='    '
	  cr_scat_int(i)=.true.
	  cr_delf_int(i)=.true.
	enddo
c
c------	common /errors/
c
	ier_num = 0
	ier_typ = ER_NONE
	ier_sta = ER_S_CONT
	do i=1,3
	  ier_msg(i) = ' '
	enddo
c
c------	common /gen_add/
c
	gen_add_n = 0
	do k=1,GEN_ADD_MAX
	  do i=1,4
	    do j=1,4
	      gen_add(i,j,k) = 0.0
	    enddo
	  enddo
	  gen_add  (4,4,k) = 1.0
	  gen_add_power(k) = 1
	enddo
c
c------	common /fourier_cmm/
c
	lxray   =.true.
	ano     =.false.
	ldbw    =.false.
	lambda  ='CUA1'
	rlambda =1.5405
c
	eck(1,1)=-0.5
	eck(2,1)=-0.5
	eck(3,1)= 0.0
	eck(1,2)= 5.5
	eck(2,2)=-0.5
	eck(3,2)= 0.0
	eck(1,3)=-0.5
	eck(2,3)= 5.5
	eck(3,3)= 0.0
c
	inc(1)  = 121
	inc(2)  = 121
c
	vi(1,1) = 0.05
	vi(2,1) = 0.00
	vi(3,1) = 0.00
	vi(1,2) = 0.00
	vi(2,2) = 0.05
	vi(3,2) = 0.00
c
c------	common /microdef/ 
c
	mv_cont   = MD_STRUC
	mv_orient = 1
	mv_rad    = 10.0
	mv_rad_si = 0.0
c
	do i=1,MAX_MD_HKL
	  mvv_rad(i)    = 10.0
	  mvv_rad_si(i) = 0.0
	enddo
	mv_hkl_n = 0
c
	do i=1,MAX_MD_HKL
	  do j=1,3
	    mv_hkl(j,i)=0.0
	  enddo
	enddo
c
	mv_bound = MD_FACE
	mv_unit  = MD_ANG
	mv_file  = ' '
c
c------ common /microdis/
c
	md_num     = 0
	md_num_cre = 0
	md_num_run = 0
	md_distr   = MD_PARA
	md_dens    = 0.1
	md_grid    = MD_G_HOST
	md_infile  = ' '
c
	md_overlap = MD_ERROR
c
	do i=1,4
	  do j=0,MAX_MD_TY
	    md_ty_fl(i,j)=0
	  enddo
	enddo
c
	md_hkl_n(0)=0
	do i=1,MAX_MD_TY
	  md_hkl_n(i)=0
	enddo
c
	md_ori_n   = 1
	md_log_pos = .false.
	md_sep_fuz = 0.5
c
	do i=0,MAX_MD_TY
	  do j=0,MAX_MD_TY
	    md_corr(i,j)=0.0
	  enddo
	  md_corr(i,i)=1.0
	enddo
c
	do i=1,3
	  md_shift(i)=0.0
	  do j=1,3
	    md_base(i,j)=0.0
	    md_si  (i,j)=0.0
	  enddo
	enddo
c
	do i=1,3
	  do j=1,MAX_MD_HKL
	    do k=0,MAX_MD_TY	
	      md_hkl(i,j,k)=0.0
	    enddo
	  enddo
	enddo
c
	do k=1,MAX_MD_ORI
	  do i=1,4
	    do j=1,4
	      md_orient(i,j,k)=0.0
	      md_or_inv(i,j,k)=0.0
	    enddo
	    md_orient(i,i,k)=1.0
	    md_or_inv(i,i,k)=1.0
	  enddo
	enddo
c
	do i=0,MAX_MD_HKL
	  do j=0,MAX_MD_TY
	    md_rad(i,j)=0.0
	  enddo
	enddo
c
	do i=1,MAX_MD_HKL
	  do j=0,MAX_MD_TY
	    md_rad_si(i,j)=0.0
	  enddo
	enddo
c
	do i=1,3
	  do j=1,3
	    md_rbase(i,j)=0.0
	  enddo
	enddo
c
	do i=0,MAX_MD_TY
	  md_co_fi(i)=' '
	enddo
c
	do i=1,3
	  md_dim(i,1)=  100000.0
	  md_dim(i,2)= -100000.0
	enddo
c
c------ common /microsta/
c
	cmic_s(0) = 'Microdomains and host structure  '
	cmic_s(1) = 'Only atoms outside microdomains  '
	cmic_s(2) = 'Only atoms inside any microdomain'
	cmic_s(3) = 'Only atoms inside microdomains:  ' 
c
c------ common /microlis/
c
	mc_num     = 0
	mc_num_run = 0
c
	do i=0,MC_MAX_MICRO
	  mc_type(i)=0
	enddo
c
	do j=0,MC_MAX_MICRO
	  mc_rad(j)=0.0
	  do i=1,3
	    mc_orig(i,j)=0.0
	  enddo
	enddo
c
c------	common /molecule/
c
	mole_num_mole = 0
	mole_num_curr = 0
	mole_num_act  = 0
	mole_num_type = 0
	mole_num_unit = 0
	mole_num_atom = 0
	mole_num_acur = 0
	mole_gene_n = 0
	mole_symm_n = 0
	do k=1,MOLE_MAX_GENE
	  do i=1,4
	    do j=1,4
	      mole_gene(i,j,k) = 0.0
	      mole_symm(i,j,k) = 0.0
	    enddo
	  enddo
	  mole_gene  (4,4,k) = 1.0
	  mole_symm  (4,4,k) = 1.0
	  mole_gene_power(k) = 1
	  mole_symm_power(k) = 1
	enddo
c
c------ common /output/
c
	outfile    = 'fcalc.dat'
	ityp       = 0
	extr_abs   = 1
	extr_ord   = 2
c
	rho_extr_abs = 1
	rho_extr_ord = 2
c
c------ common /patters/
c
	rho_inc(1) = 51
	rho_inc(2) = 51
c
	rho_eck(1,1) = 0.0
	rho_eck(2,1) = 0.0
	rho_eck(3,1) = 0.0
	rho_eck(1,2) = 1.0
	rho_eck(2,2) = 0.0
	rho_eck(3,2) = 0.0
	rho_eck(1,3) = 0.0
	rho_eck(2,3) = 1.0
	rho_eck(3,3) = 0.0
c
	rho_vi (1,1) = 0.02
	rho_vi (2,1) = 0.00
	rho_vi (3,1) = 0.00
	rho_vi (1,2) = 0.00
	rho_vi (2,2) = 0.02
	rho_vi (3,2) = 0.00
c
	rho_type(1)  = 4
	rho_type(2)  = 5
	rho_file(1)  = ' '
	rho_file(2)  = ' '
c
	patt_scale   = 1.0
	patt_accu    = 0
	patt_sign    = -1
	ftyp         = 0
	patt_excl9999 = .false.
	patt_excl_val = -9999.
c
c------	common /plotting/ 
c
	pl_col          = 'xyz'
	pl_prog         = 'kupl'
	pl_vrml         = 'u'
	pl_md_nr        = 0
	pl_md_s         = 0
	pl_out          = 'plot.dat'
	pl_dens         = .false.
	pl_sel_atom     = .true.
	pl_mol_all      = .true.
	pl_vrml_scaling = 0.05
c
	do i=0,MAXSCAT
	  pl_latom(i)=.false.
	  pl_color(i)=stift(mod(i,5))
	  pl_typ(i)=3
 	  pl_siz(i)=1.0
	  pl_batom_a(i)=.false.
	  pl_batom_e(i)=.false.
	  do j=0,MAXSCAT
	    pl_bond    (  i,j) = .false.
	    pl_bond_len(1,i,j) = 0.0
	    pl_bond_len(2,i,j) = 0.0
	    pl_bond_rad(  i,j) = 0.2
	    pl_bond_col(1,i,j) = 0.8
	    pl_bond_col(2,i,j) = 0.8
	    pl_bond_col(3,i,j) = 0.8
	  enddo
	enddo
c
	do i=1,3
	  do j=1,2
	    pl_dim(i,j)=0.0
	    pl_mat(i,j)=0.0
	    pl_inv(i,j)=0.0
	  enddo
	  pl_mat(i,i)=1.0
	  pl_inv(i,i)=1.0
	  pl_abs(i)  =0.0
	  pl_ord(i)  =0.0
	enddo
	pl_abs(1)  =1.0
	pl_ord(2)  =1.0
c
c	common /powder/
c
	pow_four_mode=0
	pow_four_type=POW_COMPL
c
	pow_delta=0.1
c
	pow_tthmin=0.1
	pow_tthmax=40.0
	pow_deltatth=0.05
c
	pow_hkl_del(1)=0.05
	pow_hkl_del(2)=0.05
	pow_hkl_del(3)=0.05
c
	pow_hkl_shift(1)=0.00
	pow_hkl_shift(2)=0.00
	pow_hkl_shift(3)=0.00
c
	do i=0,POW_MAXPKT
	  pow_qsp(i) = 0.00
	enddo
c
c------	common  /qspace/
c
	ps_high   = 1.2
	ps_low    = 0.01
c
	sav_file     = ' '
	sav_keyword  = .true.
c
	sav_r_ncell  = .false.
	sav_w_ncell  = .true.
	sav_w_scat   = .false.
	sav_w_adp    = .false.
	sav_w_gene   = .true.
	sav_w_symm   = .true.
	sav_w_mole   = .true.
c
	sav_md_nr    =  0
	sav_md_s     =  0
	sav_start    =  1
	sav_end      = -1
	sav_ncell(1) =  1
	sav_ncell(2) =  1
	sav_ncell(3) =  1
	sav_ncatoms  =  1
c
	do i=0,MAXSCAT
	  sav_latom(i) = .true.
	enddo
c
c------	common /space_group/
c
	call spcgr_setup
c
c------ common /stack_fault/
c
	st_distr  = ST_DIST_MATRIX
	st_infile = ' '
	st_infile_l = 1
	st_nlayer   = 0
	st_ntypes   = 0
	st_nchem    = 0
	st_aver     = 0.0
	st_mod_sta  = .false.
	st_tra_aver = .false.
	st_prob     = 0.0
	st_rot_mode      = .false.
	st_rot_status    = .false.
	st_rot_no_lspace = .true.
	st_rot_m1_lspace = .true.
	st_rot_m2_lspace = .true.
	st_rot_si_no     = 0.0
	st_rot_si_m1     = 0.0
	st_rot_si_m2     = 0.0
c
	do i=1,3
	  do j=1,3
	    st_mod(i,j) = 0.0
	  enddo
	  st_t_aver   (i) = 0.0
	  st_off      (i) = 0.0
	  st_sigma_off(i) = 0.0
	  st_rot_no   (i) = 0.0
	  st_rot_m1   (i) = 0.0
	  st_rot_m2   (i) = 0.0
	enddo
c
	do i=1,ST_MAXTYPE
	  st_layer  (i) = ' '
	  st_layer_c(i) = ' '
	  st_llayer (i) = 0
	  st_number (i) = 0
	  st_ndisp  (i) = 0
	  st_chem   (i) = 0
	  do j=1,ST_MAXTYPE
	    st_corr(i,j) = 0.0
	    do k=1,3
	      st_sigma(i,j,k) = 0.0
	      st_trans(i,j,k) = 0.0
	    enddo
	  enddo
	  do j=1,3
	    st_disp  (j,i) = 0.0
	  enddo
	enddo
c
	do i=1,ST_MAXLAYER
	  st_type      (i) = 0
	  st_rot_ang_no(i) = 0.0
	  st_rot_ang_m1(i) = 0.0
	  st_rot_ang_m2(i) = 0.0
	  do j=1,3
	    st_origin(j,i) = 0.0
	  enddo
	enddo
c
c------	common /sym_add/
c
	sym_add_n = 0
	do k=1,SYM_ADD_MAX
	  do i=1,4
	    do j=1,4
	      sym_add(i,j,k) = 0.0
	    enddo
	  enddo
	  sym_add  (4,4,k) = 1.0
	  sym_add_power(k) = 1
	enddo
c
c------ common /symm_par/
c
	sym_incl  = 'list'
	sym_md_nr = 0
	sym_md_s  = 0
	sym_start = 0
	sym_end   = 0
	sym_power = 1
c
	do i=0,MAXSCAT
	  sym_latom(i) = .false.
	enddo
c
	sym_mode       = .true.
	sym_new        = .false.
	sym_power_mult = .true.
	sym_orig_mol   = .true.
	sym_type       = .true.
	sym_angle      = 0.0
	sym_sel_atom   = .true.
c
	do i=1,3
	  sym_hkl(i)   = 0.0
	  sym_orig(i)  = 0.0
	  sym_trans(i) = 0.0
	  sym_uvw(i)   = 0.0
	enddo
c
c------	common /tran/
c
	tran_md_nr = 0
	tran_md_s  = 0
	tran_start = 0
	tran_end   = 0
	tran_inp   = TRAN_INP_G
	tran_oold  = .true.
c
	do i=0,MAXSCAT
	  tran_latom(i) = .false.
	enddo
c
	do i=1,3
	  tran_orig(i) = 0.0
	enddo
c
	do i=1,4
	  do j=1,4
	    tran_g (i,j) = 0.0
	    tran_gi(i,j) = 0.0
	    tran_f (i,j) = 0.0
	    tran_fi(i,j) = 0.0
	   enddo
	enddo
	tran_f (4,4) = 1.0
	tran_fi(4,4) = 1.0
	tran_deltahkl= 0.001
c
c------	common /waves_cmm/
c
	wv_wave(1)  = 1.0
	wv_wave(2)  = 0.0
	wv_wave(3)  = 0.0
c
	wv_iwave    = WV_LONG
	wv_ifunc    = WV_SINUS
	wv_rlam     = 50.0
	wv_amp      = 0.5
	wv_amp0     = 0.0
	wv_plow     = 0.0
	wv_phigh    = 1.0
	wv_asym     = 0.5
c
	wv_md_nr     = 0
	wv_phase_typ = WV_FIX
c
	do i=0,MAXSCAT
	  wv_latom(i)=.false.
	  wv_repl(i) = 0
	enddo
c
	wv_lacoust  = .true.
	wv_swing(1) = 0.0
	wv_swing(2) = 1.0
	wv_swing(3) = 0.0
	wv_phase    = 0.0
	wv_md_s     = 0
	wv_func     = 'sinu'
	wv_sel_atom = .true.
c
c------	common	/chem/ 
c
	chem_fname        = 'blen.xy'
	chem_ncor         = 1
	chem_blen_cut(1)  = 2.5
	chem_blen_cut(2)  = 7.5
	chem_bang_cut(1)  = 0.0
	chem_bang_cut(2)  = 180.0
	chem_bin          = 250
	chem_quick        = .true.
	chem_period(1)    = .true.
	chem_period(2)    = .true.
	chem_period(3)    = .true.
	chem_sel_atom     = .true.
c
	do i=1,CHEM_MAX_VEC
	  chem_cvec(1,i) = -9999
	  do j=1,CHEM_MAX_COR
	    chem_use_vec(i,j) = 1
	  enddo
	enddo
c
	do i=1,CHEM_MAX_ANG
	  chem_cwin(1,i) = -9999
	  do j=1,CHEM_MAX_COR
	    chem_use_win(i,j) = 1
	  enddo
	enddo
c
	do i=1,CHEM_MAX_ENV
	  chem_cenv(0,i) = -9999
	  do j=1,CHEM_MAX_COR
	    chem_use_env(i,j) = 1
	    chem_env_neig(j)  = 0
	  enddo
	  do j=1,MAX_ATOM_ENV
	    chem_cenv(j,i) = 0
	  enddo
	  chem_rmin_env(i) = 0.1
	  chem_rmax_env(i) = 3.5
	enddo
c
	do i=1,CHEM_MAX_RAN
	  do k=1,48
	    do j=1,3
	      chem_cran_uvw(j,k,i) = 0.0
	    enddo
	  enddo
	  chem_cran_uvw(1,1,i)  = -9999
	  chem_cran_sig(i)    = 0.00
	  chem_cran_wsig(i)   = 0.00
	  chem_cran_cent(0,i) =  0
	  chem_cran_neig(0,i) =  0
	  do j=1,CHEM_MAX_COR
	    chem_use_ran(i,j) = 1
	  enddo
	enddo
c
	do i=1,CHEM_MAX_COR
	  chem_ldall(i)     = .true.
          chem_cang(i)      = .false.
	  chem_ctyp(i)      = CHEM_NONE
	  chem_nvec(i)      = 0
	  chem_freq_sigma(i)= 0.05
	  chem_wink_sigma(i)= 0.05
	  chem_dir(1,1,i)   = -9999
	enddo
c
c------	common	/mcbl/
c
	mo_energy   = MC_NONE
	mo_mode     = RMC_MODE_SWCHEM
	mo_local    = RMC_LOCAL_ALL
	mo_cyc      = 100
	mo_feed     = 10
	mo_kt       = 1.0
	mo_atom(1)  = 'ALL '
	mo_atom(2)  = 'ALL '
	mo_atom(3)  = '    '
	mo_sel_atom = .true.
c
	do k=1,CHEM_MAX_COR
	  do i=0,MAXSCAT
	  do j=0,MAXSCAT
	    mo_disp(k,i,j) = 0.0
	  enddo
	  enddo
	enddo
c
	mo_maxmove(1,0)=0.0
	mo_maxmove(2,0)=0.0
	mo_maxmove(3,0)=0.0
	do i=1,MAXSCAT
	  mo_maxmove(1,i)=0.2
	  mo_maxmove(2,i)=0.2
	  mo_maxmove(3,i)=0.2
	enddo
c
	do i=1,CHEM_MAX_COR
	  mo_const(i) = 0.0
	  mo_cfac (i) = 1.0
	enddo
	mo_const(0) = 1.0
c
c------	common  /mmcbl/
c
	call mmc_init
c
c------ common  /pdfbl/ 
c
	pdf_rmax    = 15.0
	pdf_deltar  = 0.05
	pdf_bin     = nint(pdf_rmax/pdf_deltar)
	pdf_rfmin   = 0.05
	pdf_rfmax   = 15.0
	pdf_qmax    = 22.0
	pdf_sigmaq  = 0.04
	pdf_skal    = 1.0
	pdf_xq      = 0.0
	pdf_lxray   = .false.
	pdf_gauss   = .false.
	pdf_2d      = .false.
	pdf_delta   = 0.0
	pdf_rcut    = 0.0
	pdf_srat    = 1.0
	pdf_dnorm   = 1.0
	pdf_rho0    = 0.0
c
	do i=1,MAXSCAT
	  pdf_allowed_i(i) = .true.
	  pdf_allowed_j(i) = .true.
	enddo
c
	pdf_obs(1)=-9999.
c
c------	common	/rmbl/
c
	rmc_display  = 500
	rmc_maxcyc   = 5000
	rmc_nplane   = 0
	rmc_calc_f   = .TRUE.
	rmc_doskal   = .FALSE.
	rmc_doback   = .FALSE.
	rmc_dosym    = .FALSE.
	rmc_nosym    = .FALSE.
	rmc_log      = .FALSE.
	rmc_ranloc   = .TRUE.
	rmc_sel_atom = .TRUE.
	rmc_sigma    = 0.01
	rmc_ave      = 0.0
	rmc_ilots    = LOT_OFF
	rmc_nlots    = 1
        rmc_qmin     =  9999.0
        rmc_qmax     = -9999.0
	rmc_data     = RMC_DATA_NIPL
	rmc_mode     = RMC_MODE_SHIFT
	rmc_local    = RMC_LOCAL_ALL
c
	rmc_allowed(0)=.TRUE.
	rmc_maxmove(1,0)=0.0
	rmc_maxmove(2,0)=0.0
	rmc_maxmove(3,0)=0.0
	do i=1,MAXSCAT
	  rmc_allowed(i)=.TRUE.
	  rmc_maxmove(1,i)=0.2
	  rmc_maxmove(2,i)=0.2
	  rmc_maxmove(3,i)=0.2
	  do j=1,MAXSCAT
	    rmc_mindist(i,j)=0.5
	  enddo
	enddo
c
	do i=1,RMC_MAX_PLANES
	  rmc_fname(i)     = ' '
	  rmc_num(1,i)     = 0
	  rmc_num(2,i)     = 0
	  rmc_ldbw(i)      = .FALSE.
	  rmc_ano(i)       = .FALSE.
	  rmc_skal(i)      = 1.0
	  rmc_back(i)      = 0.0
	  rmc_wic_typ(i)   = RMC_WIC_EINS
	  rmc_constrain(i) = i
	  offq(i)      = 0
	  do j=1,RMC_MAX_SYM
	    offsq(i,j) = 0
	  enddo
	enddo
c
c------ common /diffuse/
c
	ffour   = .FALSE.
	lperiod = .TRUE.
	ilots   = LOT_OFF
	nlots   = 1
	fave    = 0.0
c
	do i=1,3
	  ls_xyz(i) = 5
	enddo
c
c------ Values for bond valence sums (generated by bvconf ..)
c
       do i=0,BVAMAX
         do j=0,BVAMAX
           bv_index(i,j) = 0
         enddo
       enddo
c
       bv_index(  6, 16) =   162
       bv_index(  6, 30) =   163
       bv_index(  6, 74) =   164
       bv_index(  6,116) =   165
       bv_index(  6,213) =   161
       bv_index(  8,  3) =    33
       bv_index(  8, 16) =    29
       bv_index(  8, 30) =    30
       bv_index(  8, 74) =    31
       bv_index(  8,116) =    32
       bv_index(  8,213) =    28
       bv_index( 19,  3) =   202
       bv_index( 19, 16) =   198
       bv_index( 19, 30) =   199
       bv_index( 19, 74) =   200
       bv_index( 19,116) =   201
       bv_index( 19,213) =   197
       bv_index( 21,  3) =   177
       bv_index( 21, 16) =   173
       bv_index( 21, 30) =   174
       bv_index( 21, 74) =   175
       bv_index( 21,116) =   176
       bv_index( 21,213) =   172
       bv_index( 23,  3) =    14
       bv_index( 23, 16) =    10
       bv_index( 23, 30) =    11
       bv_index( 23, 74) =    12
       bv_index( 23,116) =    13
       bv_index( 23,213) =     9
       bv_index( 26,  3) =   308
       bv_index( 26, 16) =   304
       bv_index( 26, 30) =   305
       bv_index( 26, 74) =   306
       bv_index( 26,116) =   307
       bv_index( 26,213) =   303
       bv_index( 33,  3) =   154
       bv_index( 33, 16) =   150
       bv_index( 33, 30) =   151
       bv_index( 33, 74) =   152
       bv_index( 33,116) =   153
       bv_index( 33,213) =   149
       bv_index( 35,  3) =    47
       bv_index( 35, 16) =    43
       bv_index( 35, 30) =    44
       bv_index( 35, 74) =    45
       bv_index( 35,116) =    46
       bv_index( 35,213) =    42
       bv_index( 37,  3) =   302
       bv_index( 37, 16) =   298
       bv_index( 37, 30) =   299
       bv_index( 37, 74) =   300
       bv_index( 37,116) =   301
       bv_index( 37,213) =   297
       bv_index( 39, 16) =   345
       bv_index( 39, 30) =   346
       bv_index( 39, 74) =   347
       bv_index( 40, 16) =   349
       bv_index( 40, 30) =   350
       bv_index( 40,116) =   351
       bv_index( 40,213) =   348
       bv_index( 41, 16) =   353
       bv_index( 41, 30) =   354
       bv_index( 41, 74) =   355
       bv_index( 41,213) =   352
       bv_index( 43, 16) =   384
       bv_index( 43, 30) =   385
       bv_index( 43,213) =   383
       bv_index( 44, 16) =   387
       bv_index( 44, 30) =   388
       bv_index( 44, 74) =   389
       bv_index( 44,213) =   386
       bv_index( 45, 16) =   391
       bv_index( 45, 30) =   392
       bv_index( 45,213) =   390
       bv_index( 47, 16) =    67
       bv_index( 47, 30) =    68
       bv_index( 47, 74) =    69
       bv_index( 47,116) =    70
       bv_index( 47,213) =    66
       bv_index( 48, 16) =    72
       bv_index( 48, 30) =    73
       bv_index( 48, 74) =    74
       bv_index( 48,213) =    71
       bv_index( 50, 16) =   179
       bv_index( 50, 30) =   180
       bv_index( 50, 74) =   181
       bv_index( 50,213) =   178
       bv_index( 51, 16) =   183
       bv_index( 51, 30) =   184
       bv_index( 51,213) =   182
       bv_index( 52, 16) =   186
       bv_index( 52, 30) =   187
       bv_index( 52,213) =   185
       bv_index( 55, 16) =   113
       bv_index( 55, 30) =   114
       bv_index( 55,213) =   112
       bv_index( 57, 16) =    61
       bv_index( 57, 30) =    62
       bv_index( 57,213) =    60
       bv_index( 58, 16) =    64
       bv_index( 58, 30) =    65
       bv_index( 58,213) =    63
       bv_index( 60, 16) =   217
       bv_index( 60, 30) =   218
       bv_index( 60, 74) =   219
       bv_index( 60,116) =   220
       bv_index( 60,213) =   216
       bv_index( 61, 16) =   222
       bv_index( 61,213) =   221
       bv_index( 63, 16) =    82
       bv_index( 63, 30) =    83
       bv_index( 63, 74) =    84
       bv_index( 63,116) =    85
       bv_index( 63,213) =    81
       bv_index( 64,  3) =    91
       bv_index( 64, 16) =    87
       bv_index( 64, 30) =    88
       bv_index( 64, 74) =    89
       bv_index( 64,116) =    90
       bv_index( 64,213) =    86
       bv_index( 66,  3) =   413
       bv_index( 66, 16) =   409
       bv_index( 66, 30) =   410
       bv_index( 66, 74) =   411
       bv_index( 66,116) =   412
       bv_index( 66,213) =   408
       bv_index( 68, 16) =   116
       bv_index( 68, 30) =   117
       bv_index( 68, 74) =   118
       bv_index( 68,116) =   119
       bv_index( 68,213) =   115
       bv_index( 70, 16) =   126
       bv_index( 70, 30) =   127
       bv_index( 70,213) =   125
       bv_index( 77,  3) =   280
       bv_index( 77, 16) =   276
       bv_index( 77, 30) =   277
       bv_index( 77, 74) =   278
       bv_index( 77,116) =   279
       bv_index( 77,213) =   275
       bv_index( 79,  3) =   329
       bv_index( 79, 16) =   325
       bv_index( 79, 30) =   326
       bv_index( 79, 74) =   327
       bv_index( 79,116) =   328
       bv_index( 79,213) =   324
       bv_index( 81,  3) =   401
       bv_index( 81, 16) =   397
       bv_index( 81, 30) =   398
       bv_index( 81, 74) =   399
       bv_index( 81,116) =   400
       bv_index( 81,213) =   396
       bv_index( 83,  3) =   419
       bv_index( 83, 16) =   415
       bv_index( 83, 30) =   416
       bv_index( 83, 74) =   417
       bv_index( 83,116) =   418
       bv_index( 83,213) =   414
       bv_index( 85, 16) =   204
       bv_index( 85, 30) =   205
       bv_index( 85, 74) =   206
       bv_index( 85,213) =   203
       bv_index( 86, 16) =   208
       bv_index( 86, 30) =   209
       bv_index( 86,116) =   210
       bv_index( 86,213) =   207
       bv_index( 88, 16) =   189
       bv_index( 88, 30) =   190
       bv_index( 88, 74) =   191
       bv_index( 88,213) =   188
       bv_index( 89, 30) =   193
       bv_index( 89,213) =   192
       bv_index( 90, 16) =   195
       bv_index( 90, 30) =   196
       bv_index( 90,213) =   194
       bv_index( 93, 16) =   286
       bv_index( 93, 30) =   287
       bv_index( 96, 16) =   282
       bv_index( 96, 30) =   283
       bv_index( 96, 74) =   284
       bv_index( 96,213) =   281
       bv_index( 97, 16) =   285
       bv_index( 99, 16) =   245
       bv_index( 99, 30) =   246
       bv_index( 99, 74) =   247
       bv_index( 99,116) =   248
       bv_index( 99,213) =   244
       bv_index(100, 16) =   249
       bv_index(102, 16) =     6
       bv_index(102, 30) =     7
       bv_index(102,213) =     5
       bv_index(103, 16) =     8
       bv_index(105,  3) =    53
       bv_index(105, 16) =    49
       bv_index(105, 30) =    50
       bv_index(105, 74) =    51
       bv_index(105,116) =    52
       bv_index(105,213) =    48
       bv_index(107, 16) =   143
       bv_index(107, 30) =   144
       bv_index(107, 74) =   145
       bv_index(107,116) =   146
       bv_index(107,213) =   142
       bv_index(109, 16) =   316
       bv_index(109, 30) =   317
       bv_index(109, 74) =   318
       bv_index(109,116) =   319
       bv_index(109,213) =   315
       bv_index(110, 16) =   321
       bv_index(110, 30) =   322
       bv_index(110, 74) =   323
       bv_index(110,213) =   320
       bv_index(112, 16) =   289
       bv_index(112, 30) =   290
       bv_index(112, 74) =   291
       bv_index(112,116) =   292
       bv_index(112,213) =   288
       bv_index(113, 16) =   294
       bv_index(113, 30) =   295
       bv_index(113, 74) =   296
       bv_index(113,213) =   293
       bv_index(119,  3) =    80
       bv_index(119, 16) =    76
       bv_index(119, 30) =    77
       bv_index(119, 74) =    78
       bv_index(119,116) =    79
       bv_index(119,213) =    75
       bv_index(121,  3) =    27
       bv_index(121, 16) =    23
       bv_index(121, 30) =    24
       bv_index(121, 74) =    25
       bv_index(121,116) =    26
       bv_index(121,213) =    22
       bv_index(123,  3) =   160
       bv_index(123, 16) =   156
       bv_index(123, 30) =   157
       bv_index(123, 74) =   158
       bv_index(123,116) =   159
       bv_index(123,213) =   155
       bv_index(125, 16) =    55
       bv_index(125, 30) =    56
       bv_index(125, 74) =    57
       bv_index(125,213) =    54
       bv_index(126, 16) =    59
       bv_index(126,213) =    58
       bv_index(128,  3) =   258
       bv_index(128, 16) =   254
       bv_index(128, 30) =   255
       bv_index(128, 74) =   256
       bv_index(128,116) =   257
       bv_index(128,213) =   253
       bv_index(131, 16) =   212
       bv_index(131, 30) =   213
       bv_index(131, 74) =   214
       bv_index(131,116) =   215
       bv_index(131,213) =   211
       bv_index(133, 16) =   250
       bv_index(133, 30) =   251
       bv_index(133, 74) =   252
       bv_index(135,  3) =   314
       bv_index(135, 16) =   310
       bv_index(135, 30) =   311
       bv_index(135, 74) =   312
       bv_index(135,116) =   313
       bv_index(135,213) =   309
       bv_index(137, 16) =   103
       bv_index(137, 30) =   104
       bv_index(137, 74) =   105
       bv_index(137,116) =   106
       bv_index(137,213) =   102
       bv_index(138, 16) =   108
       bv_index(138, 30) =   109
       bv_index(138, 74) =   110
       bv_index(138,116) =   111
       bv_index(138,213) =   107
       bv_index(140, 16) =   121
       bv_index(140, 30) =   122
       bv_index(140, 74) =   123
       bv_index(140,116) =   124
       bv_index(140,213) =   120
       bv_index(142,  3) =   338
       bv_index(142, 16) =   334
       bv_index(142, 30) =   335
       bv_index(142, 74) =   336
       bv_index(142,116) =   337
       bv_index(142,213) =   333
       bv_index(144, 16) =    93
       bv_index(144, 30) =    94
       bv_index(144, 74) =    95
       bv_index(144,116) =    96
       bv_index(144,213) =    92
       bv_index(146, 16) =   140
       bv_index(146, 30) =   141
       bv_index(146,213) =   139
       bv_index(148, 16) =    98
       bv_index(148, 30) =    99
       bv_index(148, 74) =   100
       bv_index(148,116) =   101
       bv_index(148,213) =    97
       bv_index(150,  3) =   370
       bv_index(150, 16) =   366
       bv_index(150, 30) =   367
       bv_index(150, 74) =   368
       bv_index(150,116) =   369
       bv_index(150,213) =   365
       bv_index(153,  3) =   407
       bv_index(153, 16) =   403
       bv_index(153, 30) =   404
       bv_index(153, 74) =   405
       bv_index(153,116) =   406
       bv_index(153,213) =   402
       bv_index(155,  3) =   171
       bv_index(155, 16) =   167
       bv_index(155, 30) =   168
       bv_index(155, 74) =   169
       bv_index(155,116) =   170
       bv_index(155,213) =   166
       bv_index(157, 16) =   129
       bv_index(157, 30) =   130
       bv_index(157,213) =   128
       bv_index(159, 16) =   331
       bv_index(159, 30) =   332
       bv_index(159,213) =   330
       bv_index(161, 16) =   394
       bv_index(161, 30) =   395
       bv_index(161,213) =   393
       bv_index(164, 16) =   232
       bv_index(164, 30) =   233
       bv_index(164, 74) =   234
       bv_index(164,213) =   231
       bv_index(167, 16) =   148
       bv_index(167,213) =   147
       bv_index(169, 16) =   260
       bv_index(169, 30) =   261
       bv_index(169, 74) =   262
       bv_index(169,213) =   259
       bv_index(170, 16) =   264
       bv_index(170, 30) =   265
       bv_index(170, 74) =   266
       bv_index(170,213) =   263
       bv_index(172, 30) =    15
       bv_index(172,116) =    16
       bv_index(173, 16) =    18
       bv_index(173, 30) =    19
       bv_index(173, 74) =    20
       bv_index(173,116) =    21
       bv_index(173,213) =    17
       bv_index(175, 16) =   132
       bv_index(175, 30) =   133
       bv_index(175,213) =   131
       bv_index(176, 16) =   135
       bv_index(176, 30) =   136
       bv_index(176, 74) =   137
       bv_index(176,116) =   138
       bv_index(176,213) =   134
       bv_index(178, 16) =   357
       bv_index(178, 30) =   358
       bv_index(178, 74) =   359
       bv_index(178,116) =   360
       bv_index(178,213) =   356
       bv_index(179, 16) =   362
       bv_index(179, 30) =   363
       bv_index(179, 74) =   364
       bv_index(179,213) =   361
       bv_index(181, 16) =   236
       bv_index(181, 30) =   237
       bv_index(181, 74) =   238
       bv_index(181,116) =   239
       bv_index(181,213) =   235
       bv_index(182, 16) =   241
       bv_index(182, 30) =   242
       bv_index(182, 74) =   243
       bv_index(182,213) =   240
       bv_index(184, 16) =    35
       bv_index(184, 30) =    36
       bv_index(184, 74) =    37
       bv_index(184,116) =    38
       bv_index(184,213) =    34
       bv_index(185, 16) =    40
       bv_index(185, 30) =    41
       bv_index(185,213) =    39
       bv_index(193, 16) =     2
       bv_index(193, 30) =     3
       bv_index(193, 74) =     4
       bv_index(193,213) =     1
       bv_index(195,  3) =   344
       bv_index(195, 16) =   340
       bv_index(195, 30) =   341
       bv_index(195, 74) =   342
       bv_index(195,116) =   343
       bv_index(195,213) =   339
       bv_index(198, 16) =   371
       bv_index(198, 30) =   372
       bv_index(198, 74) =   373
       bv_index(198,116) =   374
       bv_index(199, 16) =   376
       bv_index(199, 30) =   377
       bv_index(199, 74) =   378
       bv_index(199,116) =   379
       bv_index(199,213) =   375
       bv_index(200, 16) =   381
       bv_index(200, 30) =   382
       bv_index(200,213) =   380
       bv_index(202, 16) =   223
       bv_index(202, 30) =   224
       bv_index(202, 74) =   225
       bv_index(202,116) =   226
       bv_index(203, 16) =   228
       bv_index(203, 30) =   229
       bv_index(203,213) =   227
       bv_index(204, 16) =   230
       bv_index(206, 16) =   268
       bv_index(206, 30) =   269
       bv_index(206, 74) =   270
       bv_index(206,116) =   271
       bv_index(206,213) =   267
       bv_index(207, 16) =   272
       bv_index(207, 30) =   273
       bv_index(208, 16) =   274
c
       bv_r0(  1) =  2.2400
       bv_b (  1) =  0.3700
       bv_r0(  2) =  2.1300
       bv_b (  2) =  0.3700
       bv_r0(  3) =  2.6300
       bv_b (  3) =  0.3700
       bv_r0(  4) =  2.7500
       bv_b (  4) =  0.4000
       bv_r0(  5) =  1.8420
       bv_b (  5) =  0.3700
       bv_r0(  6) =  1.8000
       bv_b (  6) =  0.3700
       bv_r0(  7) =  2.0900
       bv_b (  7) =  0.3700
       bv_r0(  8) =  1.7900
       bv_b (  8) =  0.3700
       bv_r0(  9) =  1.6200
       bv_b (  9) =  0.3700
       bv_r0( 10) =  1.5450
       bv_b ( 10) =  0.3700
       bv_r0( 11) =  2.0320
       bv_b ( 11) =  0.3700
       bv_r0( 12) =  2.2000
       bv_b ( 12) =  0.3700
       bv_r0( 13) =  2.4100
       bv_b ( 13) =  0.3700
       bv_r0( 14) =  1.4500
       bv_b ( 14) =  0.3700
       bv_r0( 15) =  2.0200
       bv_b ( 15) =  0.3700
       bv_r0( 16) =  2.3500
       bv_b ( 16) =  0.3700
       bv_r0( 17) =  1.8900
       bv_b ( 17) =  0.3700
       bv_r0( 18) =  1.8900
       bv_b ( 18) =  0.3700
       bv_r0( 19) =  2.1700
       bv_b ( 19) =  0.3700
       bv_r0( 20) =  2.3200
       bv_b ( 20) =  0.3700
       bv_r0( 21) =  2.5400
       bv_b ( 21) =  0.3700
       bv_r0( 22) =  2.2850
       bv_b ( 22) =  0.3700
       bv_r0( 23) =  2.1880
       bv_b ( 23) =  0.3700
       bv_r0( 24) =  2.6900
       bv_b ( 24) =  0.3700
       bv_r0( 25) =  2.8800
       bv_b ( 25) =  0.3700
       bv_r0( 26) =  3.1300
       bv_b ( 26) =  0.3700
       bv_r0( 27) =  2.2200
       bv_b ( 27) =  0.3700
       bv_r0( 28) =  1.3810
       bv_b ( 28) =  0.3700
       bv_r0( 29) =  1.2810
       bv_b ( 29) =  0.3700
       bv_r0( 30) =  1.7600
       bv_b ( 30) =  0.3700
       bv_r0( 31) =  1.9000
       bv_b ( 31) =  0.3700
       bv_r0( 32) =  2.1000
       bv_b ( 32) =  0.3700
       bv_r0( 33) =  1.1100
       bv_b ( 33) =  0.3700
       bv_r0( 34) =  2.0940
       bv_b ( 34) =  0.3700
       bv_r0( 35) =  1.9900
       bv_b ( 35) =  0.3700
       bv_r0( 36) =  2.4800
       bv_b ( 36) =  0.3700
       bv_r0( 37) =  2.5900
       bv_b ( 37) =  0.3700
       bv_r0( 38) =  2.8200
       bv_b ( 38) =  0.3700
       bv_r0( 39) =  2.0600
       bv_b ( 39) =  0.3700
       bv_r0( 40) =  1.9700
       bv_b ( 40) =  0.3700
       bv_r0( 41) =  2.4400
       bv_b ( 41) =  0.3700
       bv_r0( 42) =  1.9670
       bv_b ( 42) =  0.3700
       bv_r0( 43) =  1.8420
       bv_b ( 43) =  0.3700
       bv_r0( 44) =  2.3700
       bv_b ( 44) =  0.3700
       bv_r0( 45) =  2.5070
       bv_b ( 45) =  0.3700
       bv_r0( 46) =  2.7200
       bv_b ( 46) =  0.3700
       bv_r0( 47) =  1.8300
       bv_b ( 47) =  0.3700
       bv_r0( 48) =  1.9040
       bv_b ( 48) =  0.3700
       bv_r0( 49) =  1.8110
       bv_b ( 49) =  0.3700
       bv_r0( 50) =  2.2120
       bv_b ( 50) =  0.3700
       bv_r0( 51) =  2.3500
       bv_b ( 51) =  0.3700
       bv_r0( 52) =  2.5700
       bv_b ( 52) =  0.3700
       bv_r0( 53) =  1.6600
       bv_b ( 53) =  0.3700
       bv_r0( 54) =  2.1510
       bv_b ( 54) =  0.3700
       bv_r0( 55) =  2.0360
       bv_b ( 55) =  0.3700
       bv_r0( 56) =  2.5200
       bv_b ( 56) =  0.3700
       bv_r0( 57) =  2.6500
       bv_b ( 57) =  0.3500
       bv_r0( 58) =  2.0280
       bv_b ( 58) =  0.3700
       bv_r0( 59) =  1.9950
       bv_b ( 59) =  0.3700
       bv_r0( 60) =  1.6920
       bv_b ( 60) =  0.3700
       bv_r0( 61) =  1.6400
       bv_b ( 61) =  0.3700
       bv_r0( 62) =  2.0330
       bv_b ( 62) =  0.3700
       bv_r0( 63) =  1.6370
       bv_b ( 63) =  0.3700
       bv_r0( 64) =  1.6200
       bv_b ( 64) =  0.3700
       bv_r0( 65) =  2.0500
       bv_b ( 65) =  0.3700
       bv_r0( 66) =  1.7300
       bv_b ( 66) =  0.3700
       bv_r0( 67) =  1.6700
       bv_b ( 67) =  0.3700
       bv_r0( 68) =  2.0900
       bv_b ( 68) =  0.3700
       bv_r0( 69) =  2.2600
       bv_b ( 69) =  0.3700
       bv_r0( 70) =  2.4800
       bv_b ( 70) =  0.3700
       bv_r0( 71) =  1.7240
       bv_b ( 71) =  0.3700
       bv_r0( 72) =  1.6570
       bv_b ( 72) =  0.3700
       bv_r0( 73) =  2.0800
       bv_b ( 73) =  0.3700
       bv_r0( 74) =  2.2800
       bv_b ( 74) =  0.3700
       bv_r0( 75) =  2.4170
       bv_b ( 75) =  0.3700
       bv_r0( 76) =  2.3300
       bv_b ( 76) =  0.3700
       bv_r0( 77) =  2.7910
       bv_b ( 77) =  0.3700
       bv_r0( 78) =  2.9500
       bv_b ( 78) =  0.3700
       bv_r0( 79) =  3.1800
       bv_b ( 79) =  0.3700
       bv_r0( 80) =  2.4400
       bv_b ( 80) =  0.3700
       bv_r0( 81) =  1.6100
       bv_b ( 81) =  0.3700
       bv_r0( 82) =  1.6000
       bv_b ( 82) =  0.3700
       bv_r0( 83) =  1.8500
       bv_b ( 83) =  0.3700
       bv_r0( 84) =  2.0300
       bv_b ( 84) =  0.3700
       bv_r0( 85) =  2.1080
       bv_b ( 85) =  0.3700
       bv_r0( 86) =  1.6790
       bv_b ( 86) =  0.3700
       bv_r0( 87) =  1.5940
       bv_b ( 87) =  0.3700
       bv_r0( 88) =  2.0000
       bv_b ( 88) =  0.3700
       bv_r0( 89) =  1.9900
       bv_b ( 89) =  0.3700
       bv_r0( 90) =  2.1600
       bv_b ( 90) =  0.3700
       bv_r0( 91) =  1.2100
       bv_b ( 91) =  0.3700
       bv_r0( 92) =  2.0010
       bv_b ( 92) =  0.3700
       bv_r0( 93) =  1.9220
       bv_b ( 93) =  0.3700
       bv_r0( 94) =  2.4100
       bv_b ( 94) =  0.3700
       bv_r0( 95) =  2.5300
       bv_b ( 95) =  0.4000
       bv_r0( 96) =  2.7600
       bv_b ( 96) =  0.4000
       bv_r0( 97) =  1.9880
       bv_b ( 97) =  0.3700
       bv_r0( 98) =  1.9040
       bv_b ( 98) =  0.3700
       bv_r0( 99) =  2.3900
       bv_b ( 99) =  0.3700
       bv_r0(100) =  2.5100
       bv_b (100) =  0.4000
       bv_r0(101) =  2.7500
       bv_b (101) =  0.4000
       bv_r0(102) =  2.1300
       bv_b (102) =  0.3700
       bv_r0(103) =  2.0400
       bv_b (103) =  0.3700
       bv_r0(104) =  2.5300
       bv_b (104) =  0.3700
       bv_r0(105) =  2.6700
       bv_b (105) =  0.3700
       bv_r0(106) =  2.9000
       bv_b (106) =  0.3700
       bv_r0(107) =  2.0740
       bv_b (107) =  0.3700
       bv_r0(108) =  1.9610
       bv_b (108) =  0.3700
       bv_r0(109) =  2.4800
       bv_b (109) =  0.3700
       bv_r0(110) =  2.5700
       bv_b (110) =  0.4000
       bv_r0(111) =  2.7900
       bv_b (111) =  0.4000
       bv_r0(112) =  1.7590
       bv_b (112) =  0.3700
       bv_r0(113) =  1.6790
       bv_b (113) =  0.3700
       bv_r0(114) =  2.0900
       bv_b (114) =  0.3700
       bv_r0(115) =  1.7300
       bv_b (115) =  0.3700
       bv_r0(116) =  1.6200
       bv_b (116) =  0.3700
       bv_r0(117) =  2.0700
       bv_b (117) =  0.3700
       bv_r0(118) =  2.2000
       bv_b (118) =  0.3500
       bv_r0(119) =  2.4600
       bv_b (119) =  0.3700
       bv_r0(120) =  2.0650
       bv_b (120) =  0.3700
       bv_r0(121) =  1.9500
       bv_b (121) =  0.3700
       bv_r0(122) =  2.4450
       bv_b (122) =  0.3700
       bv_r0(123) =  2.5600
       bv_b (123) =  0.4000
       bv_r0(124) =  2.7800
       bv_b (124) =  0.4000
       bv_r0(125) =  1.7480
       bv_b (125) =  0.3700
       bv_r0(126) =  1.6600
       bv_b (126) =  0.3700
       bv_r0(127) =  2.1400
       bv_b (127) =  0.3700
       bv_r0(128) =  1.9230
       bv_b (128) =  0.3700
       bv_r0(129) =  1.8500
       bv_b (129) =  0.3700
       bv_r0(130) =  2.2400
       bv_b (130) =  0.3700
       bv_r0(131) =  1.9000
       bv_b (131) =  0.3700
       bv_r0(132) =  1.8100
       bv_b (132) =  0.3700
       bv_r0(133) =  2.0000
       bv_b (133) = 28.0000
       bv_r0(134) =  1.9720
       bv_b (134) =  0.3700
       bv_r0(135) =  2.1700
       bv_b (135) =  0.3700
       bv_r0(136) =  2.3300
       bv_b (136) =  0.3700
       bv_r0(137) =  2.3800
       bv_b (137) =  0.3700
       bv_r0(138) =  2.6200
       bv_b (138) =  0.3700
       bv_r0(139) =  2.0250
       bv_b (139) =  0.3700
       bv_r0(140) =  1.9080
       bv_b (140) =  0.3700
       bv_r0(141) =  2.4010
       bv_b (141) =  0.3700
       bv_r0(142) =  1.9020
       bv_b (142) =  0.3700
       bv_r0(143) =  1.7920
       bv_b (143) =  0.3700
       bv_r0(144) =  2.2800
       bv_b (144) =  0.3700
       bv_r0(145) =  2.5100
       bv_b (145) =  0.3500
       bv_r0(146) =  2.6300
       bv_b (146) =  0.3700
       bv_r0(147) =  1.8700
       bv_b (147) =  0.3700
       bv_r0(148) =  1.8000
       bv_b (148) =  0.3700
       bv_r0(149) =  2.1320
       bv_b (149) =  0.3700
       bv_r0(150) =  1.9920
       bv_b (150) =  0.3700
       bv_r0(151) =  2.5190
       bv_b (151) =  0.3700
       bv_r0(152) =  2.6600
       bv_b (152) =  0.3700
       bv_r0(153) =  2.8800
       bv_b (153) =  0.3700
       bv_r0(154) =  2.1000
       bv_b (154) =  0.3700
       bv_r0(155) =  2.1720
       bv_b (155) =  0.3700
       bv_r0(156) =  2.0800
       bv_b (156) =  0.3700
       bv_r0(157) =  2.5450
       bv_b (157) =  0.3700
       bv_r0(158) =  2.7200
       bv_b (158) =  0.3700
       bv_r0(159) =  2.9300
       bv_b (159) =  0.3700
       bv_r0(160) =  2.0600
       bv_b (160) =  0.3700
       bv_r0(161) =  1.4660
       bv_b (161) =  0.3700
       bv_r0(162) =  1.3600
       bv_b (162) =  0.3700
       bv_r0(163) =  1.9100
       bv_b (163) =  0.3700
       bv_r0(164) =  2.0200
       bv_b (164) =  0.3700
       bv_r0(165) =  2.2200
       bv_b (165) =  0.3700
       bv_r0(166) =  1.9710
       bv_b (166) =  0.3700
       bv_r0(167) =  1.8760
       bv_b (167) =  0.3700
       bv_r0(168) =  2.3610
       bv_b (168) =  0.3700
       bv_r0(169) =  2.5000
       bv_b (169) =  0.3700
       bv_r0(170) =  2.7300
       bv_b (170) =  0.3700
       bv_r0(171) =  1.8200
       bv_b (171) =  0.3700
       bv_r0(172) =  1.6930
       bv_b (172) =  0.3700
       bv_r0(173) =  1.5780
       bv_b (173) =  0.3700
       bv_r0(174) =  2.0800
       bv_b (174) =  0.3700
       bv_r0(175) =  2.2800
       bv_b (175) =  0.3700
       bv_r0(176) =  2.4600
       bv_b (176) =  0.3700
       bv_r0(177) =  1.5300
       bv_b (177) =  0.3700
       bv_r0(178) =  1.7900
       bv_b (178) =  0.3700
       bv_r0(179) =  1.6980
       bv_b (179) =  0.3700
       bv_r0(180) =  2.1330
       bv_b (180) =  0.3700
       bv_r0(181) =  2.3400
       bv_b (181) =  0.3700
       bv_r0(182) =  1.7600
       bv_b (182) =  0.3700
       bv_r0(183) =  1.6600
       bv_b (183) =  0.3700
       bv_r0(184) =  2.1400
       bv_b (184) =  0.3700
       bv_r0(185) =  1.7530
       bv_b (185) =  0.3700
       bv_r0(186) =  1.7100
       bv_b (186) =  0.3700
       bv_r0(187) =  2.1300
       bv_b (187) =  0.3700
       bv_r0(188) =  2.2000
       bv_b (188) =  0.3500
       bv_r0(189) =  1.7600
       bv_b (189) =  0.3500
       bv_r0(190) =  2.2200
       bv_b (190) =  0.3700
       bv_r0(191) =  2.3400
       bv_b (191) =  0.3700
       bv_r0(192) =  1.8500
       bv_b (192) =  0.3700
       bv_r0(193) =  2.2600
       bv_b (193) =  0.3700
       bv_r0(194) =  1.9070
       bv_b (194) =  0.3700
       bv_r0(195) =  1.8100
       bv_b (195) =  0.3700
       bv_r0(196) =  2.2800
       bv_b (196) =  0.3700
       bv_r0(197) =  1.8030
       bv_b (197) =  0.3700
       bv_r0(198) =  1.6770
       bv_b (198) =  0.3700
       bv_r0(199) =  2.1500
       bv_b (199) =  0.3700
       bv_r0(200) =  2.3300
       bv_b (200) =  0.3700
       bv_r0(201) =  2.5600
       bv_b (201) =  0.3700
       bv_r0(202) =  1.6800
       bv_b (202) =  0.3700
       bv_r0(203) =  1.9100
       bv_b (203) =  0.3500
       bv_r0(204) =  1.7100
       bv_b (204) =  0.3700
       bv_r0(205) =  2.2000
       bv_b (205) =  0.3700
       bv_r0(206) =  2.3500
       bv_b (206) =  0.3700
       bv_r0(207) =  1.9110
       bv_b (207) =  0.3700
       bv_r0(208) =  1.8700
       bv_b (208) =  0.3700
       bv_r0(209) =  2.2700
       bv_b (209) =  0.3700
       bv_r0(210) =  2.7700
       bv_b (210) =  0.3700
       bv_r0(211) =  2.1050
       bv_b (211) =  0.3700
       bv_r0(212) =  2.0080
       bv_b (212) =  0.3700
       bv_r0(213) =  2.4920
       bv_b (213) =  0.3700
       bv_r0(214) =  2.6600
       bv_b (214) =  0.3700
       bv_r0(215) =  2.8700
       bv_b (215) =  0.3700
       bv_r0(216) =  1.6540
       bv_b (216) =  0.3700
       bv_r0(217) =  1.5960
       bv_b (217) =  0.3700
       bv_r0(218) =  2.0200
       bv_b (218) =  0.3700
       bv_r0(219) =  2.2000
       bv_b (219) =  0.3700
       bv_r0(220) =  2.4000
       bv_b (220) =  0.3700
       bv_r0(221) =  1.7400
       bv_b (221) =  0.3700
       bv_r0(222) =  1.5800
       bv_b (222) =  0.3700
       bv_r0(223) =  2.0000
       bv_b (223) =  0.4000
       bv_r0(224) =  2.4800
       bv_b (224) =  0.4000
       bv_r0(225) =  2.6200
       bv_b (225) =  0.4000
       bv_r0(226) =  2.8500
       bv_b (226) =  0.4000
       bv_r0(227) =  2.1800
       bv_b (227) =  0.3700
       bv_r0(228) =  2.0200
       bv_b (228) =  0.3700
       bv_r0(229) =  2.4600
       bv_b (229) =  0.4000
       bv_r0(230) =  1.9700
       bv_b (230) =  0.4000
       bv_r0(231) =  1.8110
       bv_b (231) =  0.3700
       bv_r0(232) =  1.7200
       bv_b (232) =  0.3700
       bv_r0(233) =  2.1900
       bv_b (233) =  0.3700
       bv_r0(234) =  2.3700
       bv_b (234) =  0.3700
       bv_r0(235) =  2.1120
       bv_b (235) =  0.3700
       bv_r0(236) =  2.0300
       bv_b (236) =  0.3700
       bv_r0(237) =  2.5300
       bv_b (237) =  0.3700
       bv_r0(238) =  2.6800
       bv_b (238) =  0.3700
       bv_r0(239) =  2.8300
       bv_b (239) =  0.3700
       bv_r0(240) =  2.0420
       bv_b (240) =  0.3700
       bv_r0(241) =  1.9400
       bv_b (241) =  0.3700
       bv_r0(242) =  2.4300
       bv_b (242) =  0.3700
       bv_r0(243) =  3.0400
       bv_b (243) =  0.3500
       bv_r0(244) =  1.7920
       bv_b (244) =  0.3700
       bv_r0(245) =  1.7400
       bv_b (245) =  0.3700
       bv_r0(246) =  2.0500
       bv_b (246) =  0.3700
       bv_r0(247) =  2.2000
       bv_b (247) =  0.3700
       bv_r0(248) =  2.3600
       bv_b (248) =  0.3700
       bv_r0(249) =  1.6600
       bv_b (249) =  0.3700
       bv_r0(250) =  1.9600
       bv_b (250) =  0.4000
       bv_r0(251) =  2.4500
       bv_b (251) =  0.4000
       bv_r0(252) =  2.5900
       bv_b (252) =  0.4000
       bv_r0(253) =  2.1380
       bv_b (253) =  0.3700
       bv_r0(254) =  2.0220
       bv_b (254) =  0.3700
       bv_r0(255) =  2.5000
       bv_b (255) =  0.3700
       bv_r0(256) =  2.6700
       bv_b (256) =  0.3700
       bv_r0(257) =  2.8900
       bv_b (257) =  0.3700
       bv_r0(258) =  2.0200
       bv_b (258) =  0.3700
       bv_r0(259) =  1.7680
       bv_b (259) =  0.3700
       bv_r0(260) =  1.6800
       bv_b (260) =  0.3700
       bv_r0(261) =  2.0500
       bv_b (261) =  0.3700
       bv_r0(262) =  2.2000
       bv_b (262) =  0.3700
       bv_r0(263) =  1.8790
       bv_b (263) =  0.3700
       bv_r0(264) =  1.7590
       bv_b (264) =  0.3700
       bv_r0(265) =  2.1700
       bv_b (265) =  0.3700
       bv_r0(266) =  2.6000
       bv_b (266) =  0.3500
       bv_r0(267) =  2.1100
       bv_b (267) =  0.3700
       bv_r0(268) =  2.0000
       bv_b (268) =  0.3700
       bv_r0(269) =  2.4800
       bv_b (269) =  0.3700
       bv_r0(270) =  2.6000
       bv_b (270) =  0.4000
       bv_r0(271) =  2.8400
       bv_b (271) =  0.4000
       bv_r0(272) =  1.9700
       bv_b (272) =  0.4000
       bv_r0(273) =  2.4400
       bv_b (273) =  0.4000
       bv_r0(274) =  1.9600
       bv_b (274) =  0.4000
       bv_r0(275) =  2.2630
       bv_b (275) =  0.3700
       bv_r0(276) =  2.1600
       bv_b (276) =  0.3700
       bv_r0(277) =  2.6520
       bv_b (277) =  0.3700
       bv_r0(278) =  2.8600
       bv_b (278) =  0.3700
       bv_r0(279) =  3.0100
       bv_b (279) =  0.3700
       bv_r0(280) =  2.2600
       bv_b (280) =  0.3700
       bv_r0(281) =  1.7930
       bv_b (281) =  0.3700
       bv_r0(282) =  1.7100
       bv_b (282) =  0.3700
       bv_r0(283) =  2.0800
       bv_b (283) =  0.3700
       bv_r0(284) =  2.2700
       bv_b (284) =  0.3500
       bv_r0(285) =  1.5900
       bv_b (285) =  0.3700
       bv_r0(286) =  2.1200
       bv_b (286) =  0.3700
       bv_r0(287) =  2.2500
       bv_b (287) =  0.3700
       bv_r0(288) =  1.9730
       bv_b (288) =  0.3700
       bv_r0(289) =  1.8830
       bv_b (289) =  0.3700
       bv_r0(290) =  2.3500
       bv_b (290) =  0.3700
       bv_r0(291) =  2.5100
       bv_b (291) =  0.3700
       bv_r0(292) =  2.7600
       bv_b (292) =  0.3700
       bv_r0(293) =  1.9420
       bv_b (293) =  0.3700
       bv_r0(294) =  1.7970
       bv_b (294) =  0.3700
       bv_r0(295) =  2.3000
       bv_b (295) =  0.3700
       bv_r0(296) =  2.4800
       bv_b (296) =  0.3700
       bv_r0(297) =  1.8490
       bv_b (297) =  0.3700
       bv_r0(298) =  1.7600
       bv_b (298) =  0.3700
       bv_r0(299) =  2.3600
       bv_b (299) =  0.3700
       bv_r0(300) =  2.3800
       bv_b (300) =  0.3700
       bv_r0(301) =  2.5900
       bv_b (301) =  0.3700
       bv_r0(302) =  1.6800
       bv_b (302) =  0.3700
       bv_r0(303) =  1.6240
       bv_b (303) =  0.3700
       bv_r0(304) =  1.5800
       bv_b (304) =  0.3700
       bv_r0(305) =  2.0300
       bv_b (305) =  0.3700
       bv_r0(306) =  2.2000
       bv_b (306) =  0.3700
       bv_r0(307) =  2.4100
       bv_b (307) =  0.3700
       bv_r0(308) =  1.4700
       bv_b (308) =  0.3700
       bv_r0(309) =  2.0880
       bv_b (309) =  0.3700
       bv_r0(310) =  2.0000
       bv_b (310) =  0.3700
       bv_r0(311) =  1.9770
       bv_b (311) =  0.3700
       bv_r0(312) =  2.6600
       bv_b (312) =  0.3700
       bv_r0(313) =  2.8400
       bv_b (313) =  0.3700
       bv_r0(314) =  1.9600
       bv_b (314) =  0.3700
       bv_r0(315) =  1.9400
       bv_b (315) =  0.3700
       bv_r0(316) =  1.9250
       bv_b (316) =  0.3700
       bv_r0(317) =  2.4100
       bv_b (317) =  0.3700
       bv_r0(318) =  2.5300
       bv_b (318) =  0.3500
       bv_r0(319) =  2.8100
       bv_b (319) =  0.3700
       bv_r0(320) =  1.9050
       bv_b (320) =  0.3700
       bv_r0(321) =  1.8430
       bv_b (321) =  0.3700
       bv_r0(322) =  2.2760
       bv_b (322) =  0.3700
       bv_r0(323) =  2.4000
       bv_b (323) =  0.3700
       bv_r0(324) =  2.1180
       bv_b (324) =  0.3700
       bv_r0(325) =  2.0190
       bv_b (325) =  0.3700
       bv_r0(326) =  2.5100
       bv_b (326) =  0.3700
       bv_r0(327) =  2.6800
       bv_b (327) =  0.3700
       bv_r0(328) =  2.8800
       bv_b (328) =  0.3700
       bv_r0(329) =  2.0100
       bv_b (329) =  0.3700
       bv_r0(330) =  1.9200
       bv_b (330) =  0.3700
       bv_r0(331) =  1.8800
       bv_b (331) =  0.3700
       bv_r0(332) =  2.3000
       bv_b (332) =  0.3700
       bv_r0(333) =  2.0320
       bv_b (333) =  0.3700
       bv_r0(334) =  1.9360
       bv_b (334) =  0.3700
       bv_r0(335) =  2.4270
       bv_b (335) =  0.3700
       bv_r0(336) =  2.5800
       bv_b (336) =  0.3700
       bv_r0(337) =  2.8000
       bv_b (337) =  0.3700
       bv_r0(338) =  1.9100
       bv_b (338) =  0.3700
       bv_r0(339) =  2.1670
       bv_b (339) =  0.3700
       bv_r0(340) =  2.0680
       bv_b (340) =  0.3700
       bv_r0(341) =  2.5500
       bv_b (341) =  0.3700
       bv_r0(342) =  2.7100
       bv_b (342) =  0.3700
       bv_r0(343) =  2.9300
       bv_b (343) =  0.3700
       bv_r0(344) =  2.0700
       bv_b (344) =  0.3700
       bv_r0(345) =  2.1500
       bv_b (345) =  0.3700
       bv_r0(346) =  2.3100
       bv_b (346) =  0.3700
       bv_r0(347) =  2.4900
       bv_b (347) =  0.3700
       bv_r0(348) =  1.7910
       bv_b (348) =  0.3700
       bv_r0(349) =  1.7230
       bv_b (349) =  0.3700
       bv_r0(350) =  2.2200
       bv_b (350) =  0.3700
       bv_r0(351) =  2.5200
       bv_b (351) =  0.3700
       bv_r0(352) =  1.8150
       bv_b (352) =  0.3700
       bv_r0(353) =  1.7600
       bv_b (353) =  0.3700
       bv_r0(354) =  2.1900
       bv_b (354) =  0.3700
       bv_r0(355) =  2.3600
       bv_b (355) =  0.3700
       bv_r0(356) =  2.1240
       bv_b (356) =  0.3700
       bv_r0(357) =  2.1500
       bv_b (357) =  0.3700
       bv_r0(358) =  2.5600
       bv_b (358) =  0.3700
       bv_r0(359) =  2.6900
       bv_b (359) =  0.3700
       bv_r0(360) =  2.8220
       bv_b (360) =  0.3700
       bv_r0(361) =  2.0030
       bv_b (361) =  0.3700
       bv_r0(362) =  1.8800
       bv_b (362) =  0.3700
       bv_r0(363) =  2.3200
       bv_b (363) =  0.3700
       bv_r0(364) =  2.6500
       bv_b (364) =  0.3500
       bv_r0(365) =  2.0000
       bv_b (365) =  0.3700
       bv_r0(366) =  1.8420
       bv_b (366) =  0.3700
       bv_r0(367) =  2.3800
       bv_b (367) =  0.3700
       bv_r0(368) =  2.5300
       bv_b (368) =  0.3700
       bv_r0(369) =  2.7400
       bv_b (369) =  0.3700
       bv_r0(370) =  1.8500
       bv_b (370) =  0.3700
       bv_r0(371) =  2.0900
       bv_b (371) =  0.3700
       bv_r0(372) =  2.4900
       bv_b (372) =  0.4000
       bv_r0(373) =  2.6400
       bv_b (373) =  0.4000
       bv_r0(374) =  2.8700
       bv_b (374) =  0.4000
       bv_r0(375) =  2.1120
       bv_b (375) =  0.3700
       bv_r0(376) =  2.0380
       bv_b (376) =  0.3700
       bv_r0(377) =  2.4700
       bv_b (377) =  0.4000
       bv_r0(378) =  2.6100
       bv_b (378) =  0.3700
       bv_r0(379) =  2.8800
       bv_b (379) =  0.3700
       bv_r0(380) =  2.0750
       bv_b (380) =  0.3700
       bv_r0(381) =  1.9800
       bv_b (381) =  0.4000
       bv_r0(382) =  2.4200
       bv_b (382) =  0.4000
       bv_r0(383) =  1.7000
       bv_b (383) =  0.3700
       bv_r0(384) =  2.1600
       bv_b (384) =  0.3700
       bv_r0(385) =  2.4400
       bv_b (385) =  0.3700
       bv_r0(386) =  1.7430
       bv_b (386) =  0.3700
       bv_r0(387) =  1.7020
       bv_b (387) =  0.3700
       bv_r0(388) =  2.1900
       bv_b (388) =  0.3700
       bv_r0(389) =  2.3300
       bv_b (389) =  0.3500
       bv_r0(390) =  1.8030
       bv_b (390) =  0.3700
       bv_r0(391) =  1.7000
       bv_b (391) =  0.3700
       bv_r0(392) =  2.1600
       bv_b (392) =  0.3700
       bv_r0(393) =  1.9170
       bv_b (393) =  0.3700
       bv_r0(394) =  1.8300
       bv_b (394) =  0.3700
       bv_r0(395) =  2.2700
       bv_b (395) =  0.3700
       bv_r0(396) =  2.0190
       bv_b (396) =  0.3700
       bv_r0(397) =  1.9040
       bv_b (397) =  0.3700
       bv_r0(398) =  2.4000
       bv_b (398) =  0.3700
       bv_r0(399) =  2.5500
       bv_b (399) =  0.3700
       bv_r0(400) =  2.7700
       bv_b (400) =  0.3700
       bv_r0(401) =  1.8600
       bv_b (401) =  0.3700
       bv_r0(402) =  1.9650
       bv_b (402) =  0.3700
       bv_r0(403) =  1.8750
       bv_b (403) =  0.3700
       bv_r0(404) =  2.3710
       bv_b (404) =  0.3700
       bv_r0(405) =  2.4510
       bv_b (405) =  0.3700
       bv_r0(406) =  2.7200
       bv_b (406) =  0.3700
       bv_r0(407) =  1.8200
       bv_b (407) =  0.3700
       bv_r0(408) =  1.7040
       bv_b (408) =  0.3700
       bv_r0(409) =  1.6200
       bv_b (409) =  0.3700
       bv_r0(410) =  2.0270
       bv_b (410) =  0.3700
       bv_r0(411) =  2.2400
       bv_b (411) =  0.3700
       bv_r0(412) =  2.3600
       bv_b (412) =  0.3700
       bv_r0(413) =  1.4200
       bv_b (413) =  0.3700
       bv_r0(414) =  1.9280
       bv_b (414) =  0.3700
       bv_r0(415) =  1.8460
       bv_b (415) =  0.3700
       bv_r0(416) =  2.3300
       bv_b (416) =  0.3700
       bv_r0(417) =  2.4800
       bv_b (417) =  0.3700
       bv_r0(418) =  2.6900
       bv_b (418) =  0.3700
       bv_r0(419) =  1.7900
       bv_b (419) =  0.3700
c
      	end
c*****7********************************************************************
	subroutine mmc_init
c+
c	initializes all mmc variables
c-
	implicit  	none
c
	include 	'config.inc'
	include 	'mmc.inc'
	include 	'rmc.inc'
c
	integer		i,j,k,l,m
c
c------	common  /mmcbl/
c
	mmc_move = 0
	do i=1,MC_N_MOVE
	  mmc_local(i)      = rmc_local_all
	  mmc_move_prob(i)  = 0.0
	  mmc_move_cprob(i) = 0.0
	enddo
	do i=1,CHEM_MAX_COR
	  do j=0,MC_N_ENERGY
	    mmc_cor_energy (i,j) =.false.
	    mmc_const      (i,j) = 1.0
	    mmc_cfac       (i,j) = 1.0
	    mmc_ach_corr   (i,j) = 0.0
	    mmc_target_corr(i,j) = 0.0
	  enddo
	enddo
	do m=0,MAXSCAT
	  do l=0,MAXSCAT
	    do k=1,CHEM_MAX_COR
	      do j=1,12
	        do i=1,4
	          mmc_vec(i,j,k,l,m) = 0.0
	        enddo
	      enddo
	      mmc_nvec(k,l,m) = 0
	      do j=0,MC_N_ENERGY
	        mmc_disp(k,j,l,m) = 0.0
	      enddo
	    enddo
	  enddo
	enddo
	do i=1,MC_N_MOVE
	  mmc_local     (i) = rmc_local_all
	  mmc_move_prob (i) = 0.0
	  mmc_move_cprob(i) = 0.0
	enddo
c
	mmc_l_constrains = .false.
	do i=1,3
	  mmc_c_min(i) = -1.e10
	  mmc_c_max(i) =  1.e10
	enddo
c
c------	common  /mmcav/
c
	do i=0,MC_N_ENERGY
	  n_e_av_p(i) = 0
	  n_e_av_m(i) = 0
	  n_e_av_z(i) = 0
	  e_aver_p(i) = 0.0
	  e_aver_m(i) = 0.0
	enddo
c
	end
c*****7********************************************************************
	subroutine autodef
c-
c	Tries to open a default file for the integer and real variables
c+
	include      'envir.inc'
	include      'errlist.inc'
	include      'param.inc'
	include      'prompt.inc'
c
	integer      idef
c
	data         idef/34/
c
	ier_num = 0
	ier_typ = ER_NONE
	call open_def(idef)
	if(ier_num.eq.0) then
	  ier_num = -3
	  ier_typ = ER_IO
	  read(idef,*,end=998,err=998) inpara
	  read(idef,*,end=998,err=998) rpara
	endif
	ier_num = 0
	ier_typ = ER_NONE
998	continue
	if(ier_num.ne.0) then
	  call errlist
	  ier_num = 0
	  ier_typ = ER_NONE
	endif
	close(idef)
c
	write(output_io,*)
1000	format(a)
	end
