c
c	This file contains subroutines for:
c	include file for generator matrizes for all space groups
c
c	ng                    Number of different generators in I.T
c	ig                    Maximum number of generators needed for any
c	                      spacegroup
c	generators(4,4,ng)    List of all generators in I.T.
c	generpower(ng)        Power used for each generator, is 1 for all
c	                      except threefold axes
c	generspcgr(0:ig,230)  List of the generators a spacegroup needs
c	                      Element (0,i) gives the number of generators
c	                      needed by spacegroup i
c
c*****7*****************************************************************
c
	integer    ng,ig
	real       six1,six2,six4,six5
	parameter (ng=97,ig=7)
	parameter (six1=1./6., six2=1./3., six4=2./3., six5=5./6.)
c
	integer    generpower(ng),generspcgr(0:ig,308)
	real       generators(4,4,0:ng)
c
c------	List of all generator matrizes used in I.T. Vol. A
c
c	#  0:  1
	data ((generators(i,j,  0),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.00,
     &	  0.00, 1.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c
c	#  1:  t  (1/2, 1/2,   0)
	data ((generators(i,j,  1),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.50,
     &	  0.00, 1.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	#  2:  t  (1/2,   0, 1/2)
	data ((generators(i,j,  2),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.50,
     &	  0.00, 1.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	#  3:  t  (0  , 1/2, 1/2)
	data ((generators(i,j,  3),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.00,
     &	  0.00, 1.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	#  4:  t  (1/2, 1/2, 1/2)
	data ((generators(i,j,  4),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.50,
     &	  0.00, 1.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	#  5:  t  (2/3, 1/3, 1/3)
	data ((generators(i,j,  5),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, six4,
     &	  0.00, 1.00, 0.00, six2,
     &	  0.00, 0.00, 1.00, six2,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	#  6: -1                   0,0,0
	data ((generators(i,j,  6),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.00,
     &	  0.00,-1.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	#  7: -1                   1/4,1/4,0
	data ((generators(i,j,  7),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.50,
     &	  0.00,-1.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	#  8: -1                   0,1/4,1/4
	data ((generators(i,j,  8),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.00,
     &	  0.00,-1.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	#  9: -1                   0,1/4,1/8
	data ((generators(i,j,  9),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.00,
     &	  0.00,-1.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.25,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 10: -1                   1/8,1/8,1/8
	data ((generators(i,j, 10),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.25,
     &	  0.00,-1.00, 0.00, 0.25,
     &	  0.00, 0.00,-1.00, 0.25,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 11: -1                   1/4,1/4,1/4
	data ((generators(i,j, 11),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.50,
     &	  0.00,-1.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 12: -1                   3/8,3/8,3/8
	data ((generators(i,j, 12),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.75,
     &	  0.00,-1.00, 0.00, 0.75,
     &	  0.00, 0.00,-1.00, 0.75,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 13:  2                   0,y,0
	data ((generators(i,j, 13),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.00,
     &	  0.00, 1.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 14:  2                   1/4,y,0
	data ((generators(i,j, 14),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.50,
     &	  0.00, 1.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 15:  2                   1/8,y,1/8
	data ((generators(i,j, 15),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.25,
     &	  0.00, 1.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.25,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 16:  2                   1/4,y,1/8
	data ((generators(i,j, 16),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.50,
     &	  0.00, 1.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.25,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 17:  2                   0,y,1/4
	data ((generators(i,j, 17),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.00,
     &	  0.00, 1.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 18:  2                   1/4,y,1/4
	data ((generators(i,j, 18),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.50,
     &	  0.00, 1.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 19:  2                   1/4,y,3/8
	data ((generators(i,j, 19),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.50,
     &	  0.00, 1.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.75,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 20:  2                   3/8,y,3/8
	data ((generators(i,j, 20),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.75,
     &	  0.00, 1.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.75,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 21:  2  (  0, 1/2,   0)  0,y,0
	data ((generators(i,j, 21),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.00,
     &	  0.00, 1.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 22:  2  (  0, 1/2,   0)  1/4,y,0
	data ((generators(i,j, 22),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.50,
     &	  0.00, 1.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 23:  2  (  0, 1/2,   0)  1/4,y,1/8
	data ((generators(i,j, 23),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.50,
     &	  0.00, 1.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.25,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 24:  2  (  0, 1/2,   0)  3/8,y,1/8
	data ((generators(i,j, 24),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.75,
     &	  0.00, 1.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.25,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
	data ((generators(i,j, 25),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.00,
     &	  0.00, 1.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 26:  2  (  0, 1/2,   0)  1/4,y,1/4
	data ((generators(i,j, 26),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.50,
     &	  0.00, 1.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 27:  2  (  0, 1/2,   0)  1/8,y,3/8
	data ((generators(i,j, 27),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.25,
     &	  0.00, 1.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.75,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 28:  2  (  0, 1/2,   0)  1/4,y,3/8
	data ((generators(i,j, 28),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.50,
     &	  0.00, 1.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.75,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 29:  2                   0,0,z
	data ((generators(i,j, 29),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.00,
     &	  0.00,-1.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 30:  2                   1/4,0,z
	data ((generators(i,j, 30),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.50,
     &	  0.00,-1.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 31:  2                   1/8,1/8,z
	data ((generators(i,j, 31),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.25,
     &	  0.00,-1.00, 0.00, 0.25,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 32:  2                   0,1/4,z
	data ((generators(i,j, 32),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.00,
     &	  0.00,-1.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 33:  2                   1/4,1/4,z
	data ((generators(i,j, 33),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.50,
     &	  0.00,-1.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 34:  2                   3/8,3/8,z
	data ((generators(i,j, 34),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.75,
     &	  0.00,-1.00, 0.00, 0.75,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 35:  2  (  0,   0, 1/2)  0,0,z
	data ((generators(i,j, 35),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.00,
     &	  0.00,-1.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
	data ((generators(i,j, 36),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.50,
     &	  0.00,-1.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 37:  2  (  0,   0, 1/2)  3/8,1/8,z
	data ((generators(i,j, 37),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.75,
     &	  0.00,-1.00, 0.00, 0.25,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 38:  2  (  0,   0, 1/2)  0,1/4,z
	data ((generators(i,j, 38),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.00,
     &	  0.00,-1.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 39:  2  (  0,   0, 1/2)  1/4,1/4,z
	data ((generators(i,j, 39),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.50,
     &	  0.00,-1.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 40:  2  (  0,   0, 1/2)  1/8,3/8,z
	data ((generators(i,j, 40),j=1,4),i=1,4)
     &	/-1.00, 0.00, 0.00, 0.25,
     &	  0.00,-1.00, 0.00, 0.75,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 41:  2                   x,x,0
	data ((generators(i,j, 41),j=1,4),i=1,4)
     &	/ 0.00, 1.00, 0.00, 0.00,
     &	  1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 42:  2                   x,x,1/6
	data ((generators(i,j, 42),j=1,4),i=1,4)
     &	/ 0.00, 1.00, 0.00, 0.00,
     &	  1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, six2,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 43:  2                   x,x,1/4
	data ((generators(i,j, 43),j=1,4),i=1,4)
     &	/ 0.00, 1.00, 0.00, 0.00,
     &	  1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 44:  2                   x,x,1/3
	data ((generators(i,j, 44),j=1,4),i=1,4)
     &	/ 0.00, 1.00, 0.00, 0.00,
     &	  1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, six4,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 45:  2  (1/2, 1/2,   0)  x,x,0
	data ((generators(i,j, 45),j=1,4),i=1,4)
     &	/ 0.00, 1.00, 0.00, 0.50,
     &	  1.00, 0.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 46:  2  (1/2, 1/2,   0)  x,x-1/4,0
	data ((generators(i,j, 46),j=1,4),i=1,4)
     &	/ 0.00, 1.00, 0.00, 0.75,
     &	  1.00, 0.00, 0.00, 0.25,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 47:  2  (1/2, 1/2,   0)  x,x-1/4,1/8
	data ((generators(i,j, 47),j=1,4),i=1,4)
     &	/ 0.00, 1.00, 0.00, 0.75,
     &	  1.00, 0.00, 0.00, 0.25,
     &	  0.00, 0.00,-1.00, 0.25,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 48:  2  (1/2, 1/2,   0)  x,x-1/4,1/4
	data ((generators(i,j, 48),j=1,4),i=1,4)
     &	/ 0.00, 1.00, 0.00, 0.75,
     &	  1.00, 0.00, 0.00, 0.25,
     &	  0.00, 0.00,-1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 49:  2  (1/2, 1/2,   0)  x,x,1/4
	data ((generators(i,j, 49),j=1,4),i=1,4)
     &	/ 0.00, 1.00, 0.00, 0.50,
     &	  1.00, 0.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 50:  2  (1/2, 1/2,   0)  x,x-1/4,3/8
	data ((generators(i,j, 50),j=1,4),i=1,4)
     &	/ 0.00, 1.00, 0.00, 0.75,
     &	  1.00, 0.00, 0.00, 0.25,
     &	  0.00, 0.00,-1.00, 0.75,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 51:  2  (1/2, 1/2,   0)  x,x+1/4,3/8
	data ((generators(i,j, 51),j=1,4),i=1,4)
     &	/ 0.00, 1.00, 0.00, 0.25,
     &	  1.00, 0.00, 0.00, 0.75,
     &	  0.00, 0.00,-1.00, 0.75,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 52:  2                   x,-x,0
	data ((generators(i,j, 52),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.00,
     &	 -1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 53:  2                   x,-x,1/6
	data ((generators(i,j, 53),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.00,
     &	 -1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, six2,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 54:  2                   x,-x,1/4
	data ((generators(i,j, 54),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.00,
     &	 -1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 55:  2                   x,-x+1/2,1/4
	data ((generators(i,j, 55),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.50,
     &	 -1.00, 0.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 56:  2                   x,-x,1/3
	data ((generators(i,j, 56),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.00,
     &	 -1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, six4,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 57:  3                   0,0,z
	data ((generators(i,j, 57),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.00,
     &	  1.00,-1.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 58:  3  (  0,   0, 1/3)  0,0,z
	data ((generators(i,j, 58),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.00,
     &	  1.00,-1.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, six2,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 59:  3  (  0,   0, 2/3)  0,0,z
	data ((generators(i,j, 59),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.00,
     &	  1.00,-1.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, six4,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 60:  3                   x,x,x
	data ((generators(i,j, 60),j=1,4),i=1,4)
     &	/ 0.00, 0.00, 1.00, 0.00,
     &	  1.00, 0.00, 0.00, 0.00,
     &	  0.00, 1.00, 0.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 61:  4                   0,0,z
	data ((generators(i,j, 61),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.00,
     &	  1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 62:  4                   1/4,1/4,z
	data ((generators(i,j, 62),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.50,
     &	  1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 63:  4                   0,1/2,z
	data ((generators(i,j, 63),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.50,
     &	  1.00, 0.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 64:  4  (  0,   0, 1/4)  0,0,z
	data ((generators(i,j, 64),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.00,
     &	  1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.25,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 65:  4  (  0,   0, 1/4) -1/4,1/4,z
	data ((generators(i,j, 65),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.00,
     &	  1.00, 0.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.25,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 66:  4  (  0,   0, 1/4)  0,1/2,z
	data ((generators(i,j, 66),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.50,
     &	  1.00, 0.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.25,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 67:  4  (  0,   0, 1/4) -1/4,1/2,z
	data ((generators(i,j, 67),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.25,
     &	  1.00, 0.00, 0.00, 0.75,
     &	  0.00, 0.00, 1.00, 0.25,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 68:  4  (  0,   0, 1/4)  1/4,1/2,z
	data ((generators(i,j, 68),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.75,
     &	  1.00, 0.00, 0.00, 0.25,
     &	  0.00, 0.00, 1.00, 0.25,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 69:  4  (  0,   0, 1/2)  0,0,z
	data ((generators(i,j, 69),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.00,
     &	  1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 70:  4  (  0,   0, 1/2) -1/4,1/4,z
	data ((generators(i,j, 70),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.00,
     &	  1.00, 0.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 71:  4  (  0,   0, 1/2)  1/4,1/4,z
	data ((generators(i,j, 71),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.50,
     &	  1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 72:  4  (  0,   0, 1/2)  0,1/2,z
	data ((generators(i,j, 72),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.50,
     &	  1.00, 0.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 73:  4  (  0,   0, 3/4)  0,0,z
	data ((generators(i,j, 73),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.00,
     &	  1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.75,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 74:  4  (  0,   0, 3/4)  0,1/2,z
	data ((generators(i,j, 74),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.50,
     &	  1.00, 0.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.75,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 75: -4                   0,0,z; 0,0,0
	data ((generators(i,j, 75),j=1,4),i=1,4)
     &	/ 0.00, 1.00, 0.00, 0.00,
     &	 -1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 76:  m                   x,0,z
	data ((generators(i,j, 76),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.00,
     &	  0.00,-1.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 77:  m                   x,1/4,z
	data ((generators(i,j, 77),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.00,
     &	  0.00,-1.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 78:  a                   x,0,z
	data ((generators(i,j, 78),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.50,
     &	  0.00,-1.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 79:  a                   x,1/4,z
	data ((generators(i,j, 79),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.50,
     &	  0.00,-1.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 80:  c                   x,0,z
	data ((generators(i,j, 80),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.00,
     &	  0.00,-1.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 81:  c                   x,1/4,z
	data ((generators(i,j, 81),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.00,
     &	  0.00,-1.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 82:  n  (1/2,   0, 1/2)  x,0,z
	data ((generators(i,j, 82),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.50,
     &	  0.00,-1.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 83:  n  (1/2,   0, 1/2)  x,1/4,z
	data ((generators(i,j, 83),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.50,
     &	  0.00,-1.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 84:  d  (1/4,   0, 1/4)  x,1/8,z
	data ((generators(i,j, 84),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.25,
     &	  0.00,-1.00, 0.00, 0.25,
     &	  0.00, 0.00, 1.00, 0.25,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 85:  m                   x,y,0
	data ((generators(i,j, 85),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.00,
     &	  0.00, 1.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 86:  m                   x,y,1/4
	data ((generators(i,j, 86),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.00,
     &	  0.00, 1.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 87:  a                   x,y,0
	data ((generators(i,j, 87),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.50,
     &	  0.00, 1.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 88:  b                   x,y,0
	data ((generators(i,j, 88),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.00,
     &	  0.00, 1.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 89:  n  (1/2, 1/2,   0)  x,y,0
	data ((generators(i,j, 89),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.50,
     &	  0.00, 1.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 90:  m                   x,x,z
	data ((generators(i,j, 90),j=1,4),i=1,4)
     &	/ 0.00, 1.00, 0.00, 0.00,
     &	  1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 91:  c                   x,x,z
	data ((generators(i,j, 91),j=1,4),i=1,4)
     &	/ 0.00, 1.00, 0.00, 0.00,
     &	  1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 92:  n  (1/2, 1/2, 1/2)  x,x,z
	data ((generators(i,j, 92),j=1,4),i=1,4)
     &	/ 0.00, 1.00, 0.00, 0.50,
     &	  1.00, 0.00, 0.00, 0.50,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 93:  d  (1/4, 1/4, 1/4)  x,x,z
	data ((generators(i,j, 93),j=1,4),i=1,4)
     &	/ 0.00, 1.00, 0.00, 0.25,
     &	  1.00, 0.00, 0.00, 0.25,
     &	  0.00, 0.00, 1.00, 0.25,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 94:  m                   x,-x,z
	data ((generators(i,j, 94),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.00,
     &	 -1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 95:  c                   x,-x,z
	data ((generators(i,j, 95),j=1,4),i=1,4)
     &	/ 0.00,-1.00, 0.00, 0.00,
     &	 -1.00, 0.00, 0.00, 0.00,
     &	  0.00, 0.00, 1.00, 0.50,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 96:  2  (1/2,   0,   0)  x,1/4,0
	data ((generators(i,j, 96),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.50,
     &	  0.00,-1.00, 0.00, 0.50,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c	# 97:  2  (  0,   0,   0)  x,  0,0
	data ((generators(i,j, 97),j=1,4),i=1,4)
     &	/ 1.00, 0.00, 0.00, 0.00,
     &	  0.00,-1.00, 0.00, 0.00,
     &	  0.00, 0.00,-1.00, 0.00,
     &	  0.00, 0.00, 0.00, 1.00/
c
c------	List of powers for each generator
c
	data (generpower(i),i= 1,ng)
     &  /1,1,1,1,2, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1,
     &   1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1,
     &   1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,2,2,2,2,
     &   1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1,
     &   1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1       /
C
c------	List of generators needed for each spacegroup
c
c
c	#   1 , P1
	data (generspcgr(i,  1),i=0,7)
     &	/ 0,  0,  0,  0,  0,  0,  0,  0/
c
c	#   2 , P-1
	data (generspcgr(i,  2),i=0,7)
c	#  6: -1                   0,0,0
     &	/ 1,  6,  0,  0,  0,  0,  0,  0/
c
c	#   3 , P2
	data (generspcgr(i,  3),i=0,7)
c	# 13:  2                   0,y,0
     &	/ 1, 13,  0,  0,  0,  0,  0,  0/
c
c	#   4 , P21
	data (generspcgr(i,  4),i=0,7)
c	# 21:  2  (  0, 1/2,   0)  0,y,0
     &	/ 1, 21,  0,  0,  0,  0,  0,  0/
c
c	#   5 , C2
	data (generspcgr(i,  5),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 13:  2                   0,y,0
     &	/ 2,  1, 13,  0,  0,  0,  0,  0/
c
c	#   6 , Pm
	data (generspcgr(i,  6),i=0,7)
c	# 76:  m                   x,0,z
     &	/ 1, 76,  0,  0,  0,  0,  0,  0/
c
c	#   7 , Pc
	data (generspcgr(i,  7),i=0,7)
c	# 80:  c                   x,0,z
     &	/ 1, 80,  0,  0,  0,  0,  0,  0/
c
c	#   8 , Cm
	data (generspcgr(i,  8),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 76:  m                   x,0,z
     &	/ 2,  1, 76,  0,  0,  0,  0,  0/
c
c	#   9 , Cc
	data (generspcgr(i,  9),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 80:  c                   x,0,z
     &	/ 2,  1, 80,  0,  0,  0,  0,  0/
c
c	#  10 , P2/m
	data (generspcgr(i, 10),i=0,7)
c	# 13:  2                   0,y,0
c	#  6: -1                   0,0,0
     &	/ 2, 13,  6,  0,  0,  0,  0,  0/
c
c	#  11 , P21/m
	data (generspcgr(i, 11),i=0,7)
c	# 21:  2  (  0, 1/2,   0)  0,y,0
c	#  6: -1                   0,0,0
     &	/ 2, 21,  6,  0,  0,  0,  0,  0/
c
c	#  12 , C2/m
	data (generspcgr(i, 12),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 13:  2                   0,y,0
c	#  6: -1                   0,0,0
     &	/ 3,  1, 13,  6,  0,  0,  0,  0/
c
c	#  13 , P2/c
	data (generspcgr(i, 13),i=0,7)
c	# 17:  2                   0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 2, 17,  6,  0,  0,  0,  0,  0/
c
c	#  14 , P21/c
	data (generspcgr(i, 14),i=0,7)
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 2, 25,  6,  0,  0,  0,  0,  0/
c
c	#  15 , C2/c
	data (generspcgr(i, 15),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 17:  2                   0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 3,  1, 17,  6,  0,  0,  0,  0/
c
c	#  16 , P222
	data (generspcgr(i, 16),i=0,7)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
     &	/ 2, 29, 13,  0,  0,  0,  0,  0/
c
c	#  17 , P2221
	data (generspcgr(i, 17),i=0,7)
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 17:  2                   0,y,1/4
     &	/ 2, 35, 17,  0,  0,  0,  0,  0/
c
c	#  18 , P21212
	data (generspcgr(i, 18),i=0,7)
c	# 29:  2                   0,0,z
c	# 22:  2  (  0, 1/2,   0)  1/4,y,0
     &	/ 2, 29, 22,  0,  0,  0,  0,  0/
c
c	#  19 , P212121
	data (generspcgr(i, 19),i=0,7)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
     &	/ 2, 36, 25,  0,  0,  0,  0,  0/
c
c	#  20 , C2221
	data (generspcgr(i, 20),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 17:  2                   0,y,1/4
     &	/ 3,  1, 35, 17,  0,  0,  0,  0/
c
c	#  21 , C222
	data (generspcgr(i, 21),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
     &	/ 3,  1, 29, 13,  0,  0,  0,  0/
c
c	#  22 , F222
	data (generspcgr(i, 22),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
     &	/ 4,  3,  2, 29, 13,  0,  0,  0/
c
c	#  23 , I222
	data (generspcgr(i, 23),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
     &	/ 3,  4, 29, 13,  0,  0,  0,  0/
c
c	#  24 , I212121
	data (generspcgr(i, 24),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
     &	/ 3,  4, 36, 25,  0,  0,  0,  0/
c
c	#  25 , Pmm2
	data (generspcgr(i, 25),i=0,7)
c	# 29:  2                   0,0,z
c	# 76:  m                   x,0,z
     &	/ 2, 29, 76,  0,  0,  0,  0,  0/
c
c	#  26 , Pmc21
	data (generspcgr(i, 26),i=0,7)
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 80:  c                   x,0,z
     &	/ 2, 35, 80,  0,  0,  0,  0,  0/
c
c	#  27 , Pcc2
	data (generspcgr(i, 27),i=0,7)
c	# 29:  2                   0,0,z
c	# 80:  c                   x,0,z
     &	/ 2, 29, 80,  0,  0,  0,  0,  0/
c
c	#  28 , Pma2
	data (generspcgr(i, 28),i=0,7)
c	# 29:  2                   0,0,z
c	# 78:  a                   x,0,z
     &	/ 2, 29, 78,  0,  0,  0,  0,  0/
c
c	#  29 , Pca21
	data (generspcgr(i, 29),i=0,7)
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 78:  a                   x,0,z
     &	/ 2, 35, 78,  0,  0,  0,  0,  0/
c
c	#  30 , Pnc2
	data (generspcgr(i, 30),i=0,7)
c	# 29:  2                   0,0,z
c	# 81:  c                   x,1/4,z
     &	/ 2, 29, 81,  0,  0,  0,  0,  0/
c
c	#  31 , Pmn21
	data (generspcgr(i, 31),i=0,7)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 82:  n  (1/2,   0, 1/2)  x,0,z
     &	/ 2, 36, 82,  0,  0,  0,  0,  0/
c
c	#  32 , Pba2
	data (generspcgr(i, 32),i=0,7)
c	# 29:  2                   0,0,z
c	# 79:  a                   x,1/4,z
     &	/ 2, 29, 79,  0,  0,  0,  0,  0/
c
c	#  33 , Pna21
	data (generspcgr(i, 33),i=0,7)
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 79:  a                   x,1/4,z
     &	/ 2, 35, 79,  0,  0,  0,  0,  0/
c
c	#  34 , Pnn2
	data (generspcgr(i, 34),i=0,7)
c	# 29:  2                   0,0,z
c	# 83:  n  (1/2,   0, 1/2)  x,1/4,z
     &	/ 2, 29, 83,  0,  0,  0,  0,  0/
c
c	#  35 , Cmm2
	data (generspcgr(i, 35),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 29:  2                   0,0,z
c	# 76:  m                   x,0,z
     &	/ 3,  1, 29, 76,  0,  0,  0,  0/
c
c	#  36 , Cmc21
	data (generspcgr(i, 36),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 80:  c                   x,0,z
     &	/ 3,  1, 35, 80,  0,  0,  0,  0/
c
c	#  37 , Ccc2
	data (generspcgr(i, 37),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 29:  2                   0,0,z
c	# 80:  c                   x,0,z
     &	/ 3,  1, 29, 80,  0,  0,  0,  0/
c
c	#  38 , Amm2
	data (generspcgr(i, 38),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 76:  m                   x,0,z
     &	/ 3,  3, 29, 76,  0,  0,  0,  0/
c
c	#  39 , Abm2
	data (generspcgr(i, 39),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 77:  m                   x,1/4,z
     &	/ 3,  3, 29, 77,  0,  0,  0,  0/
c
c	#  40 , Ama2
	data (generspcgr(i, 40),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 78:  a                   x,0,z
     &	/ 3,  3, 29, 78,  0,  0,  0,  0/
c
c	#  41 , Aba2
	data (generspcgr(i, 41),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 79:  a                   x,1/4,z
     &	/ 3,  3, 29, 79,  0,  0,  0,  0/
c
c	#  42 , Fmm2
	data (generspcgr(i, 42),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 29:  2                   0,0,z
c	# 76:  m                   x,0,z
     &	/ 4,  3,  2, 29, 76,  0,  0,  0/
c
c	#  43 , Fdd2
	data (generspcgr(i, 43),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 29:  2                   0,0,z
c	# 84:  d  (1/4,   0, 1/4)  x,1/8,z
     &	/ 4,  3,  2, 29, 84,  0,  0,  0/
c
c	#  44 , Imm2
	data (generspcgr(i, 44),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 76:  m                   x,0,z
     &	/ 3,  4, 29, 76,  0,  0,  0,  0/
c
c	#  45 , Iba2
	data (generspcgr(i, 45),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 79:  a                   x,1/4,z
     &	/ 3,  4, 29, 79,  0,  0,  0,  0/
c
c	#  46 , Ima2
	data (generspcgr(i, 46),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 78:  a                   x,0,z
     &	/ 3,  4, 29, 78,  0,  0,  0,  0/
c
c	#  47 , Pmmm
	data (generspcgr(i, 47),i=0,7)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	#  6: -1                   0,0,0
     &	/ 3, 29, 13,  6,  0,  0,  0,  0/
c
c	#  48 , Pnnn
	data (generspcgr(i, 48),i=0,7)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 11: -1                   1/4,1/4,1/4
     &	/ 3, 29, 13, 11,  0,  0,  0,  0/
c
c	#  49 , Pccm
	data (generspcgr(i, 49),i=0,7)
c	# 29:  2                   0,0,z
c	# 17:  2                   0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 3, 29, 17,  6,  0,  0,  0,  0/
c
c	#  50 , Pban
	data (generspcgr(i, 50),i=0,7)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	#  7: -1                   1/4,1/4,0
     &	/ 3, 29, 13,  7,  0,  0,  0,  0/
c
c	#  51 , Pmma
	data (generspcgr(i, 51),i=0,7)
c	# 30:  2                   1/4,0,z
c	# 13:  2                   0,y,0
c	#  6: -1                   0,0,0
     &	/ 3, 30, 13,  6,  0,  0,  0,  0/
c
c	#  52 , Pnna
	data (generspcgr(i, 52),i=0,7)
c	# 30:  2                   1/4,0,z
c	# 26:  2  (  0, 1/2,   0)  1/4,y,1/4
c	#  6: -1                   0,0,0
     &	/ 3, 30, 26,  6,  0,  0,  0,  0/
c
c	#  53 , Pmna
	data (generspcgr(i, 53),i=0,7)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 18:  2                   1/4,y,1/4
c	#  6: -1                   0,0,0
     &	/ 3, 36, 18,  6,  0,  0,  0,  0/
c
c	#  54 , Pcca
	data (generspcgr(i, 54),i=0,7)
c	# 30:  2                   1/4,0,z
c	# 17:  2                   0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 3, 30, 17,  6,  0,  0,  0,  0/
c
c	#  55 , Pbam
	data (generspcgr(i, 55),i=0,7)
c	# 29:  2                   0,0,z
c	# 22:  2  (  0, 1/2,   0)  1/4,y,0
c	#  6: -1                   0,0,0
     &	/ 3, 29, 22,  6,  0,  0,  0,  0/
c
c	#  56 , Pccn
	data (generspcgr(i, 56),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 3, 33, 25,  6,  0,  0,  0,  0/
c
c	#  57 , Pbcm
	data (generspcgr(i, 57),i=0,7)
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 3, 35, 25,  6,  0,  0,  0,  0/
c
c	#  58 , Pnnm
	data (generspcgr(i, 58),i=0,7)
c	# 29:  2                   0,0,z
c	# 26:  2  (  0, 1/2,   0)  1/4,y,1/4
c	#  6: -1                   0,0,0
     &	/ 3, 29, 26,  6,  0,  0,  0,  0/
c
c	#  59 , Pmmn
	data (generspcgr(i, 59),i=0,7)
c	# 29:  2                   0,0,z
c	# 22:  2  (  0, 1/2,   0)  1/4,y,0
c	#  7: -1                   1/4,1/4,0
     &	/ 3, 29, 22,  7,  0,  0,  0,  0/
c
c	#  60 , Pbcn
	data (generspcgr(i, 60),i=0,7)
c	# 39:  2  (  0,   0, 1/2)  1/4,1/4,z
c	# 17:  2                   0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 3, 39, 17,  6,  0,  0,  0,  0/
c
c	#  61 , Pbca
	data (generspcgr(i, 61),i=0,7)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 3, 36, 25,  6,  0,  0,  0,  0/
c
c	#  62 , Pnma
	data (generspcgr(i, 62),i=0,7)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 21:  2  (  0, 1/2,   0)  0,y,0
c	#  6: -1                   0,0,0
     &	/ 3, 36, 21,  6,  0,  0,  0,  0/
c
c	#  63 , Cmcm
	data (generspcgr(i, 63),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 17:  2                   0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 4,  1, 35, 17,  6,  0,  0,  0/
c
c	#  64 , Cmca
	data (generspcgr(i, 64),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 38:  2  (  0,   0, 1/2)  0,1/4,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 4,  1, 38, 25,  6,  0,  0,  0/
c
c	#  65 , Cmmm
	data (generspcgr(i, 65),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	#  6: -1                   0,0,0
     &	/ 4,  1, 29, 13,  6,  0,  0,  0/
c
c	#  66 , Cccm
	data (generspcgr(i, 66),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 29:  2                   0,0,z
c	# 17:  2                   0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 4,  1, 29, 17,  6,  0,  0,  0/
c
c	#  67 , Cmma
	data (generspcgr(i, 67),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 32:  2                   0,1/4,z
c	# 21:  2  (  0, 1/2,   0)  0,y,0
c	#  6: -1                   0,0,0
     &	/ 4,  1, 32, 21,  6,  0,  0,  0/
c
c	#  68 , Ccca
	data (generspcgr(i, 68),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 33:  2                   1/4,1/4,z
c	# 13:  2                   0,y,0
c	#  8: -1                   0,1/4,1/4
     &	/ 4,  1, 33, 13,  8,  0,  0,  0/
c
c	#  69 , Fmmm
	data (generspcgr(i, 69),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	#  6: -1                   0,0,0
     &	/ 5,  3,  2, 29, 13,  6,  0,  0/
c
c	#  70 , Fddd
	data (generspcgr(i, 70),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 10: -1                   1/8,1/8,1/8
     &	/ 5,  3,  2, 29, 13, 10,  0,  0/
c
c	#  71 , Immm
	data (generspcgr(i, 71),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	#  6: -1                   0,0,0
     &	/ 4,  4, 29, 13,  6,  0,  0,  0/
c
c	#  72 , Ibam
	data (generspcgr(i, 72),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 22:  2  (  0, 1/2,   0)  1/4,y,0
c	#  6: -1                   0,0,0
     &	/ 4,  4, 29, 22,  6,  0,  0,  0/
c
c	#  73 , Ibca
	data (generspcgr(i, 73),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 4,  4, 36, 25,  6,  0,  0,  0/
c
c	#  74 , Imma
	data (generspcgr(i, 74),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 32:  2                   0,1/4,z
c	# 21:  2  (  0, 1/2,   0)  0,y,0
c	#  6: -1                   0,0,0
     &	/ 4,  4, 32, 21,  6,  0,  0,  0/
c
c	#  75 , P4
	data (generspcgr(i, 75),i=0,7)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
     &	/ 2, 29, 61,  0,  0,  0,  0,  0/
c
c	#  76 , P41
	data (generspcgr(i, 76),i=0,7)
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 64:  4  (  0,   0, 1/4)  0,0,z
     &	/ 2, 35, 64,  0,  0,  0,  0,  0/
c
c	#  77 , P42
	data (generspcgr(i, 77),i=0,7)
c	# 29:  2                   0,0,z
c	# 69:  4  (  0,   0, 1/2)  0,0,z
     &	/ 2, 29, 69,  0,  0,  0,  0,  0/
c
c	#  78 , P43
	data (generspcgr(i, 78),i=0,7)
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 73:  4  (  0,   0, 3/4)  0,0,z
     &	/ 2, 35, 73,  0,  0,  0,  0,  0/
c
c	#  79 , I4
	data (generspcgr(i, 79),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
     &	/ 3,  4, 29, 61,  0,  0,  0,  0/
c
c	#  80 , I41
	data (generspcgr(i, 80),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 39:  2  (  0,   0, 1/2)  1/4,1/4,z
c	# 65:  4  (  0,   0, 1/4) -1/4,1/4,z
     &	/ 3,  4, 39, 65,  0,  0,  0,  0/
c
c	#  81 , P-4
	data (generspcgr(i, 81),i=0,7)
c	# 29:  2                   0,0,z
c	# 75: -4                   0,0,z; 0,0,0
     &	/ 2, 29, 75,  0,  0,  0,  0,  0/
c
c	#  82 , I-4
	data (generspcgr(i, 82),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 75: -4                   0,0,z; 0,0,0
     &	/ 3,  4, 29, 75,  0,  0,  0,  0/
c
c	#  83 , P4/m
	data (generspcgr(i, 83),i=0,7)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	#  6: -1                   0,0,0
     &	/ 3, 29, 61,  6,  0,  0,  0,  0/
c
c	#  84 , P42/m
	data (generspcgr(i, 84),i=0,7)
c	# 29:  2                   0,0,z
c	# 69:  4  (  0,   0, 1/2)  0,0,z
c	#  6: -1                   0,0,0
     &	/ 3, 29, 69,  6,  0,  0,  0,  0/
c
c	#  85 , P4/n
	data (generspcgr(i, 85),i=0,7)
c	# 29:  2                   0,0,z
c	# 63:  4                   0,1/2,z
c	#  7: -1                   1/4,1/4,0
     &	/ 3, 29, 63,  7,  0,  0,  0,  0/
c
c	#  86 , P42/n
	data (generspcgr(i, 86),i=0,7)
c	# 29:  2                   0,0,z
c	# 72:  4  (  0,   0, 1/2)  0,1/2,z
c	# 11: -1                   1/4,1/4,1/4
     &	/ 3, 29, 72, 11,  0,  0,  0,  0/
c
c	#  87 , I4/m
	data (generspcgr(i, 87),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	#  6: -1                   0,0,0
     &	/ 4,  4, 29, 61,  6,  0,  0,  0/
c
c	#  88 , I41/a
	data (generspcgr(i, 88),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 39:  2  (  0,   0, 1/2)  1/4,1/4,z
c	# 65:  4  (  0,   0, 1/4) -1/4,1/4,z
c	#  9: -1                   0,1/4,1/8
     &	/ 4,  4, 39, 65,  9,  0,  0,  0/
c
c	#  89 , P422
	data (generspcgr(i, 89),i=0,7)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	# 13:  2                   0,y,0
     &	/ 3, 29, 61, 13,  0,  0,  0,  0/
c
c	#  90 , P4212
	data (generspcgr(i, 90),i=0,7)
c	# 29:  2                   0,0,z
c	# 63:  4                   0,1/2,z
c	# 22:  2  (  0, 1/2,   0)  1/4,y,0
     &	/ 3, 29, 63, 22,  0,  0,  0,  0/
c
c	#  91 , P4122
	data (generspcgr(i, 91),i=0,7)
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 64:  4  (  0,   0, 1/4)  0,0,z
c	# 13:  2                   0,y,0
     &	/ 3, 35, 64, 13,  0,  0,  0,  0/
c
c	#  92 , P41212
	data (generspcgr(i, 92),i=0,7)
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 66:  4  (  0,   0, 1/4)  0,1/2,z
c	# 23:  2  (  0, 1/2,   0)  1/4,y,1/8
     &	/ 3, 35, 66, 23,  0,  0,  0,  0/
c
c	#  93 , P4222
	data (generspcgr(i, 93),i=0,7)
c	# 29:  2                   0,0,z
c	# 69:  4  (  0,   0, 1/2)  0,0,z
c	# 13:  2                   0,y,0
     &	/ 3, 29, 69, 13,  0,  0,  0,  0/
c
c	#  94 , P42212
	data (generspcgr(i, 94),i=0,7)
c	# 29:  2                   0,0,z
c	# 72:  4  (  0,   0, 1/2)  0,1/2,z
c	# 26:  2  (  0, 1/2,   0)  1/4,y,1/4
     &	/ 3, 29, 72, 26,  0,  0,  0,  0/
c
c	#  95 , P4322
	data (generspcgr(i, 95),i=0,7)
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 73:  4  (  0,   0, 3/4)  0,0,z
c	# 13:  2                   0,y,0
     &	/ 3, 35, 73, 13,  0,  0,  0,  0/
c
c	#  96 , P43212
	data (generspcgr(i, 96),i=0,7)
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 74:  4  (  0,   0, 3/4)  0,1/2,z
c	# 28:  2  (  0, 1/2,   0)  1/4,y,3/8
     &	/ 3, 35, 74, 28,  0,  0,  0,  0/
c
c	#  97 , I422
	data (generspcgr(i, 97),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	# 13:  2                   0,y,0
     &	/ 4,  4, 29, 61, 13,  0,  0,  0/
c
c	#  98 , I4122
	data (generspcgr(i, 98),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 39:  2  (  0,   0, 1/2)  1/4,1/4,z
c	# 65:  4  (  0,   0, 1/4) -1/4,1/4,z
c	# 19:  2                   1/4,y,3/8
     &	/ 4,  4, 39, 65, 19,  0,  0,  0/
c
c	#  99 , P4mm
	data (generspcgr(i, 99),i=0,7)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	# 76:  m                   x,0,z
     &	/ 3, 29, 61, 76,  0,  0,  0,  0/
c
c	# 100 , P4bm
	data (generspcgr(i,100),i=0,7)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	# 79:  a                   x,1/4,z
     &	/ 3, 29, 61, 79,  0,  0,  0,  0/
c
c	# 101 , P42cm
	data (generspcgr(i,101),i=0,7)
c	# 29:  2                   0,0,z
c	# 69:  4  (  0,   0, 1/2)  0,0,z
c	# 80:  c                   x,0,z
     &	/ 3, 29, 69, 80,  0,  0,  0,  0/
c
c	# 102 , P42nm
	data (generspcgr(i,102),i=0,7)
c	# 29:  2                   0,0,z
c	# 72:  4  (  0,   0, 1/2)  0,1/2,z
c	# 83:  n  (1/2,   0, 1/2)  x,1/4,z
     &	/ 3, 29, 72, 83,  0,  0,  0,  0/
c
c	# 103 , P4cc
	data (generspcgr(i,103),i=0,7)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	# 80:  c                   x,0,z
     &	/ 3, 29, 61, 80,  0,  0,  0,  0/
c
c	# 104 , P4nc
	data (generspcgr(i,104),i=0,7)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	# 83:  n  (1/2,   0, 1/2)  x,1/4,z
     &	/ 3, 29, 61, 83,  0,  0,  0,  0/
c
c	# 105 , P42mc
	data (generspcgr(i,105),i=0,7)
c	# 29:  2                   0,0,z
c	# 69:  4  (  0,   0, 1/2)  0,0,z
c	# 76:  m                   x,0,z
     &	/ 3, 29, 69, 76,  0,  0,  0,  0/
c
c	# 106 , P42bc
	data (generspcgr(i,106),i=0,7)
c	# 29:  2                   0,0,z
c	# 69:  4  (  0,   0, 1/2)  0,0,z
c	# 79:  a                   x,1/4,z
     &	/ 3, 29, 69, 79,  0,  0,  0,  0/
c
c	# 107 , I4mm
	data (generspcgr(i,107),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	# 76:  m                   x,0,z
     &	/ 4,  4, 29, 61, 76,  0,  0,  0/
c
c	# 108 , I4cm
	data (generspcgr(i,108),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	# 80:  c                   x,0,z
     &	/ 4,  4, 29, 61, 80,  0,  0,  0/
c
c	# 109 , I41md
	data (generspcgr(i,109),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 39:  2  (  0,   0, 1/2)  1/4,1/4,z
c	# 65:  4  (  0,   0, 1/4) -1/4,1/4,z
c	# 76:  m                   x,0,z
     &	/ 4,  4, 39, 65, 76,  0,  0,  0/
c
c	# 110 , I41cd
	data (generspcgr(i,110),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 39:  2  (  0,   0, 1/2)  1/4,1/4,z
c	# 65:  4  (  0,   0, 1/4) -1/4,1/4,z
c	# 80:  c                   x,0,z
     &	/ 4,  4, 39, 65, 80,  0,  0,  0/
c
c	# 111 , P-42m
	data (generspcgr(i,111),i=0,7)
c	# 29:  2                   0,0,z
c	# 75: -4                   0,0,z; 0,0,0
c	# 13:  2                   0,y,0
     &	/ 3, 29, 75, 13,  0,  0,  0,  0/
c
c	# 112 , P-42c
	data (generspcgr(i,112),i=0,7)
c	# 29:  2                   0,0,z
c	# 75: -4                   0,0,z; 0,0,0
c	# 17:  2                   0,y,1/4
     &	/ 3, 29, 75, 17,  0,  0,  0,  0/
c
c	# 113 , P-421m
	data (generspcgr(i,113),i=0,7)
c	# 29:  2                   0,0,z
c	# 75: -4                   0,0,z; 0,0,0
c	# 22:  2  (  0, 1/2,   0)  1/4,y,0
     &	/ 3, 29, 75, 22,  0,  0,  0,  0/
c
c	# 114 , P-421c
	data (generspcgr(i,114),i=0,7)
c	# 29:  2                   0,0,z
c	# 75: -4                   0,0,z; 0,0,0
c	# 26:  2  (  0, 1/2,   0)  1/4,y,1/4
     &	/ 3, 29, 75, 26,  0,  0,  0,  0/
c
c	# 115 , P-4m2
	data (generspcgr(i,115),i=0,7)
c	# 29:  2                   0,0,z
c	# 75: -4                   0,0,z; 0,0,0
c	# 76:  m                   x,0,z
     &	/ 3, 29, 75, 76,  0,  0,  0,  0/
c
c	# 116 , P-4c2
	data (generspcgr(i,116),i=0,7)
c	# 29:  2                   0,0,z
c	# 75: -4                   0,0,z; 0,0,0
c	# 80:  c                   x,0,z
     &	/ 3, 29, 75, 80,  0,  0,  0,  0/
c
c	# 117 , P-4b2
	data (generspcgr(i,117),i=0,7)
c	# 29:  2                   0,0,z
c	# 75: -4                   0,0,z; 0,0,0
c	# 79:  a                   x,1/4,z
     &	/ 3, 29, 75, 79,  0,  0,  0,  0/
c
c	# 118 , P-4n2
	data (generspcgr(i,118),i=0,7)
c	# 29:  2                   0,0,z
c	# 75: -4                   0,0,z; 0,0,0
c	# 83:  n  (1/2,   0, 1/2)  x,1/4,z
     &	/ 3, 29, 75, 83,  0,  0,  0,  0/
c
c	# 119 , I-4m2
	data (generspcgr(i,119),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 75: -4                   0,0,z; 0,0,0
c	# 76:  m                   x,0,z
     &	/ 4,  4, 29, 75, 76,  0,  0,  0/
c
c	# 120 , I-4c2
	data (generspcgr(i,120),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 75: -4                   0,0,z; 0,0,0
c	# 80:  c                   x,0,z
     &	/ 4,  4, 29, 75, 80,  0,  0,  0/
c
c	# 121 , I-42m
	data (generspcgr(i,121),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 75: -4                   0,0,z; 0,0,0
c	# 13:  2                   0,y,0
     &	/ 4,  4, 29, 75, 13,  0,  0,  0/
c
c	# 122 , I-42d
	data (generspcgr(i,122),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 75: -4                   0,0,z; 0,0,0
c	# 19:  2                   1/4,y,3/8
     &	/ 4,  4, 29, 75, 19,  0,  0,  0/
c
c	# 123 , P4/mmm
	data (generspcgr(i,123),i=0,7)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	# 13:  2                   0,y,0
c	#  6: -1                   0,0,0
     &	/ 4, 29, 61, 13,  6,  0,  0,  0/
c
c	# 124 , P4/mcc
	data (generspcgr(i,124),i=0,7)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	# 17:  2                   0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 4, 29, 61, 17,  6,  0,  0,  0/
c
c	# 125 , P4/nbm
	data (generspcgr(i,125),i=0,7)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	# 13:  2                   0,y,0
c	#  7: -1                   1/4,1/4,0
     &	/ 4, 29, 61, 13,  7,  0,  0,  0/
c
c	# 126 , P4/nnc
	data (generspcgr(i,126),i=0,7)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	# 13:  2                   0,y,0
c	# 11: -1                   1/4,1/4,1/4
     &	/ 4, 29, 61, 13, 11,  0,  0,  0/
c
c	# 127 , P4/mbm
	data (generspcgr(i,127),i=0,7)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	# 22:  2  (  0, 1/2,   0)  1/4,y,0
c	#  6: -1                   0,0,0
     &	/ 4, 29, 61, 22,  6,  0,  0,  0/
c
c	# 128 , P4/mnc
	data (generspcgr(i,128),i=0,7)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	# 26:  2  (  0, 1/2,   0)  1/4,y,1/4
c	#  6: -1                   0,0,0
     &	/ 4, 29, 61, 26,  6,  0,  0,  0/
c
c	# 129 , P4/nmm
	data (generspcgr(i,129),i=0,7)
c	# 29:  2                   0,0,z
c	# 63:  4                   0,1/2,z
c	# 22:  2  (  0, 1/2,   0)  1/4,y,0
c	#  7: -1                   1/4,1/4,0
     &	/ 4, 29, 63, 22,  7,  0,  0,  0/
c
c	# 130 , P4/ncc
	data (generspcgr(i,130),i=0,7)
c	# 29:  2                   0,0,z
c	# 63:  4                   0,1/2,z
c	# 26:  2  (  0, 1/2,   0)  1/4,y,1/4
c	#  7: -1                   1/4,1/4,0
     &	/ 4, 29, 63, 26,  7,  0,  0,  0/
c
c	# 131 , P42/mmc
	data (generspcgr(i,131),i=0,7)
c	# 29:  2                   0,0,z
c	# 69:  4  (  0,   0, 1/2)  0,0,z
c	# 13:  2                   0,y,0
c	#  6: -1                   0,0,0
     &	/ 4, 29, 69, 13,  6,  0,  0,  0/
c
c	# 132 , P42/mcm
	data (generspcgr(i,132),i=0,7)
c	# 29:  2                   0,0,z
c	# 69:  4  (  0,   0, 1/2)  0,0,z
c	# 17:  2                   0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 4, 29, 69, 17,  6,  0,  0,  0/
c
c	# 133 , P42/nbc
	data (generspcgr(i,133),i=0,7)
c	# 29:  2                   0,0,z
c	# 72:  4  (  0,   0, 1/2)  0,1/2,z
c	# 17:  2                   0,y,1/4
c	# 11: -1                   1/4,1/4,1/4
     &	/ 4, 29, 72, 17, 11,  0,  0,  0/
c
c	# 134 , P42/nnn
	data (generspcgr(i,134),i=0,7)
c	# 29:  2                   0,0,z
c	# 72:  4  (  0,   0, 1/2)  0,1/2,z
c	# 13:  2                   0,y,0
c	# 11: -1                   1/4,1/4,1/4
     &	/ 4, 29, 72, 13, 11,  0,  0,  0/
c
c	# 135 , P42/mbc
	data (generspcgr(i,135),i=0,7)
c	# 29:  2                   0,0,z
c	# 69:  4  (  0,   0, 1/2)  0,0,z
c	# 22:  2  (  0, 1/2,   0)  1/4,y,0
c	#  6: -1                   0,0,0
     &	/ 4, 29, 69, 22,  6,  0,  0,  0/
c
c	# 136 , P42/mnm
	data (generspcgr(i,136),i=0,7)
c	# 29:  2                   0,0,z
c	# 72:  4  (  0,   0, 1/2)  0,1/2,z
c	# 26:  2  (  0, 1/2,   0)  1/4,y,1/4
c	#  6: -1                   0,0,0
     &	/ 4, 29, 72, 26,  6,  0,  0,  0/
c
c	# 137 , P42/nmc
	data (generspcgr(i,137),i=0,7)
c	# 29:  2                   0,0,z
c	# 72:  4  (  0,   0, 1/2)  0,1/2,z
c	# 26:  2  (  0, 1/2,   0)  1/4,y,1/4
c	# 11: -1                   1/4,1/4,1/4
     &	/ 4, 29, 72, 26, 11,  0,  0,  0/
c
c	# 138 , P42/ncm
	data (generspcgr(i,138),i=0,7)
c	# 29:  2                   0,0,z
c	# 72:  4  (  0,   0, 1/2)  0,1/2,z
c	# 22:  2  (  0, 1/2,   0)  1/4,y,0
c	# 11: -1                   1/4,1/4,1/4
     &	/ 4, 29, 72, 22, 11,  0,  0,  0/
c
c	# 139 , I4/mmm
	data (generspcgr(i,139),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	# 13:  2                   0,y,0
c	#  6: -1                   0,0,0
     &	/ 5,  4, 29, 61, 13,  6,  0,  0/
c
c	# 140 , I4/mcm
	data (generspcgr(i,140),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 61:  4                   0,0,z
c	# 17:  2                   0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 5,  4, 29, 61, 17,  6,  0,  0/
c
c	# 141 , I41/amd
	data (generspcgr(i,141),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 39:  2  (  0,   0, 1/2)  1/4,1/4,z
c	# 65:  4  (  0,   0, 1/4) -1/4,1/4,z
c	# 19:  2                   1/4,y,3/8
c	#  9: -1                   0,1/4,1/8
     &	/ 5,  4, 39, 65, 19,  9,  0,  0/
c
c	# 142 , I41/acd
	data (generspcgr(i,142),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 39:  2  (  0,   0, 1/2)  1/4,1/4,z
c	# 65:  4  (  0,   0, 1/4) -1/4,1/4,z
c	# 16:  2                   1/4,y,1/8
c	#  9: -1                   0,1/4,1/8
     &	/ 5,  4, 39, 65, 16,  9,  0,  0/
c
c	# 143 , P3
	data (generspcgr(i,143),i=0,7)
c	# 57:  3                   0,0,z
     &	/ 1, 57,  0,  0,  0,  0,  0,  0/
c
c	# 144 , P31
	data (generspcgr(i,144),i=0,7)
c	# 58:  3  (  0,   0, 1/3)  0,0,z
     &	/ 1, 58,  0,  0,  0,  0,  0,  0/
c
c	# 145 , P32
	data (generspcgr(i,145),i=0,7)
c	# 59:  3  (  0,   0, 2/3)  0,0,z
     &	/ 1, 59,  0,  0,  0,  0,  0,  0/
c
c	# 146 , R3, hexagonal axes
	data (generspcgr(i,146),i=0,7)
c	#  5:  t  (2/3, 1/3, 1/3)
c	# 57:  3                   0,0,z
     &	/ 2,  5, 57,  0,  0,  0,  0,  0/
c
c	# 147 , P-3
	data (generspcgr(i,147),i=0,7)
c	# 57:  3                   0,0,z
c	#  6: -1                   0,0,0
     &	/ 2, 57,  6,  0,  0,  0,  0,  0/
c
c	# 148 , R-3, hexagonal axes
	data (generspcgr(i,148),i=0,7)
c	#  5:  t  (2/3, 1/3, 1/3)
c	# 57:  3                   0,0,z
c	#  6: -1                   0,0,0
     &	/ 3,  5, 57,  6,  0,  0,  0,  0/
c
c	# 149 , P312
	data (generspcgr(i,149),i=0,7)
c	# 57:  3                   0,0,z
c	# 52:  2                   x,-x,0
     &	/ 2, 57, 52,  0,  0,  0,  0,  0/
c
c	# 150 , P321
	data (generspcgr(i,150),i=0,7)
c	# 57:  3                   0,0,z
c	# 41:  2                   x,x,0
     &	/ 2, 57, 41,  0,  0,  0,  0,  0/
c
c	# 151 , P3112
	data (generspcgr(i,151),i=0,7)
c	# 58:  3  (  0,   0, 1/3)  0,0,z
c	# 56:  2                   x,-x,1/3
     &	/ 2, 58, 56,  0,  0,  0,  0,  0/
c
c	# 152 , P3121
	data (generspcgr(i,152),i=0,7)
c	# 58:  3  (  0,   0, 1/3)  0,0,z
c	# 41:  2                   x,x,0
     &	/ 2, 58, 41,  0,  0,  0,  0,  0/
c
c	# 153 , P3212
	data (generspcgr(i,153),i=0,7)
c	# 59:  3  (  0,   0, 2/3)  0,0,z
c	# 53:  2                   x,-x,1/6
     &	/ 2, 59, 53,  0,  0,  0,  0,  0/
c
c	# 154 , P3221
	data (generspcgr(i,154),i=0,7)
c	# 59:  3  (  0,   0, 2/3)  0,0,z
c	# 41:  2                   x,x,0
     &	/ 2, 59, 41,  0,  0,  0,  0,  0/
c
c	# 155 , R32, hexagonal axes
	data (generspcgr(i,155),i=0,7)
c	#  5:  t  (2/3, 1/3, 1/3)
c	# 57:  3                   0,0,z
c	# 41:  2                   x,x,0
     &	/ 3,  5, 57, 41,  0,  0,  0,  0/
c
c	# 156 , P3m1
	data (generspcgr(i,156),i=0,7)
c	# 57:  3                   0,0,z
c	# 94:  m                   x,-x,z
     &	/ 2, 57, 94,  0,  0,  0,  0,  0/
c
c	# 157 , P31m
	data (generspcgr(i,157),i=0,7)
c	# 57:  3                   0,0,z
c	# 90:  m                   x,x,z
     &	/ 2, 57, 90,  0,  0,  0,  0,  0/
c
c	# 158 , P3c1
	data (generspcgr(i,158),i=0,7)
c	# 57:  3                   0,0,z
c	# 95:  c                   x,-x,z
     &	/ 2, 57, 95,  0,  0,  0,  0,  0/
c
c	# 159 , P31c
	data (generspcgr(i,159),i=0,7)
c	# 57:  3                   0,0,z
c	# 91:  c                   x,x,z
     &	/ 2, 57, 91,  0,  0,  0,  0,  0/
c
c	# 160 , R3m, hexagonal axes
	data (generspcgr(i,160),i=0,7)
c	#  5:  t  (2/3, 1/3, 1/3)
c	# 57:  3                   0,0,z
c	# 94:  m                   x,-x,z
     &	/ 3,  5, 57, 94,  0,  0,  0,  0/
c
c	# 161 , R3c, hexagonal axes
	data (generspcgr(i,161),i=0,7)
c	#  5:  t  (2/3, 1/3, 1/3)
c	# 57:  3                   0,0,z
c	# 95:  c                   x,-x,z
     &	/ 3,  5, 57, 95,  0,  0,  0,  0/
c
c	# 162 , P-31m
	data (generspcgr(i,162),i=0,7)
c	# 57:  3                   0,0,z
c	# 52:  2                   x,-x,0
c	#  6: -1                   0,0,0
     &	/ 3, 57, 52,  6,  0,  0,  0,  0/
c
c	# 163 , P-31c
	data (generspcgr(i,163),i=0,7)
c	# 57:  3                   0,0,z
c	# 54:  2                   x,-x,1/4
c	#  6: -1                   0,0,0
     &	/ 3, 57, 54,  6,  0,  0,  0,  0/
c
c	# 164 , P-3m1
	data (generspcgr(i,164),i=0,7)
c	# 57:  3                   0,0,z
c	# 41:  2                   x,x,0
c	#  6: -1                   0,0,0
     &	/ 3, 57, 41,  6,  0,  0,  0,  0/
c
c	# 165 , P-3c1
	data (generspcgr(i,165),i=0,7)
c	# 57:  3                   0,0,z
c	# 43:  2                   x,x,1/4
c	#  6: -1                   0,0,0
     &	/ 3, 57, 43,  6,  0,  0,  0,  0/
c
c	# 166 , R-3m, hexagonal axes
	data (generspcgr(i,166),i=0,7)
c	#  5:  t  (2/3, 1/3, 1/3)
c	# 57:  3                   0,0,z
c	# 41:  2                   x,x,0
c	#  6: -1                   0,0,0
     &	/ 4,  5, 57, 41,  6,  0,  0,  0/
c
c	# 167 , R-3c, hexagonal axes
	data (generspcgr(i,167),i=0,7)
c	#  5:  t  (2/3, 1/3, 1/3)
c	# 57:  3                   0,0,z
c	# 43:  2                   x,x,1/4
c	#  6: -1                   0,0,0
     &	/ 4,  5, 57, 43,  6,  0,  0,  0/
c
c	# 168 , P6
	data (generspcgr(i,168),i=0,7)
c	# 57:  3                   0,0,z
c	# 29:  2                   0,0,z
     &	/ 2, 57, 29,  0,  0,  0,  0,  0/
c
c	# 169 , P61
	data (generspcgr(i,169),i=0,7)
c	# 58:  3  (  0,   0, 1/3)  0,0,z
c	# 35:  2  (  0,   0, 1/2)  0,0,z
     &	/ 2, 58, 35,  0,  0,  0,  0,  0/
c
c	# 170 , P65
	data (generspcgr(i,170),i=0,7)
c	# 59:  3  (  0,   0, 2/3)  0,0,z
c	# 35:  2  (  0,   0, 1/2)  0,0,z
     &	/ 2, 59, 35,  0,  0,  0,  0,  0/
c
c	# 171 , P62
	data (generspcgr(i,171),i=0,7)
c	# 59:  3  (  0,   0, 2/3)  0,0,z
c	# 29:  2                   0,0,z
     &	/ 2, 59, 29,  0,  0,  0,  0,  0/
c
c	# 172 , P64
	data (generspcgr(i,172),i=0,7)
c	# 58:  3  (  0,   0, 1/3)  0,0,z
c	# 29:  2                   0,0,z
     &	/ 2, 58, 29,  0,  0,  0,  0,  0/
c
c	# 173 , P63
	data (generspcgr(i,173),i=0,7)
c	# 57:  3                   0,0,z
c	# 35:  2  (  0,   0, 1/2)  0,0,z
     &	/ 2, 57, 35,  0,  0,  0,  0,  0/
c
c	# 174 , P-6
	data (generspcgr(i,174),i=0,7)
c	# 57:  3                   0,0,z
c	# 85:  m                   x,y,0
     &	/ 2, 57, 85,  0,  0,  0,  0,  0/
c
c	# 175 , P6/m
	data (generspcgr(i,175),i=0,7)
c	# 57:  3                   0,0,z
c	# 29:  2                   0,0,z
c	#  6: -1                   0,0,0
     &	/ 3, 57, 29,  6,  0,  0,  0,  0/
c
c	# 176 , P63/m
	data (generspcgr(i,176),i=0,7)
c	# 57:  3                   0,0,z
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	#  6: -1                   0,0,0
     &	/ 3, 57, 35,  6,  0,  0,  0,  0/
c
c	# 177 , P622
	data (generspcgr(i,177),i=0,7)
c	# 57:  3                   0,0,z
c	# 29:  2                   0,0,z
c	# 41:  2                   x,x,0
     &	/ 3, 57, 29, 41,  0,  0,  0,  0/
c
c	# 178 , P6122
	data (generspcgr(i,178),i=0,7)
c	# 58:  3  (  0,   0, 1/3)  0,0,z
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 42:  2                   x,x,1/6
     &	/ 3, 58, 35, 42,  0,  0,  0,  0/
c
c	# 179 , P6522
	data (generspcgr(i,179),i=0,7)
c	# 59:  3  (  0,   0, 2/3)  0,0,z
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 44:  2                   x,x,1/3
     &	/ 3, 59, 35, 44,  0,  0,  0,  0/
c
c	# 180 , P6222
	data (generspcgr(i,180),i=0,7)
c	# 59:  3  (  0,   0, 2/3)  0,0,z
c	# 29:  2                   0,0,z
c	# 44:  2                   x,x,1/3
     &	/ 3, 59, 29, 44,  0,  0,  0,  0/
c
c	# 181 , P6422
	data (generspcgr(i,181),i=0,7)
c	# 58:  3  (  0,   0, 1/3)  0,0,z
c	# 29:  2                   0,0,z
c	# 42:  2                   x,x,1/6
     &	/ 3, 58, 29, 42,  0,  0,  0,  0/
c
c	# 182 , P6322
	data (generspcgr(i,182),i=0,7)
c	# 57:  3                   0,0,z
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 41:  2                   x,x,0
     &	/ 3, 57, 35, 41,  0,  0,  0,  0/
c
c	# 183 , P6mm
	data (generspcgr(i,183),i=0,7)
c	# 57:  3                   0,0,z
c	# 29:  2                   0,0,z
c	# 94:  m                   x,-x,z
     &	/ 3, 57, 29, 94,  0,  0,  0,  0/
c
c	# 184 , P6cc
	data (generspcgr(i,184),i=0,7)
c	# 57:  3                   0,0,z
c	# 29:  2                   0,0,z
c	# 95:  c                   x,-x,z
     &	/ 3, 57, 29, 95,  0,  0,  0,  0/
c
c	# 185 , P63cm
	data (generspcgr(i,185),i=0,7)
c	# 57:  3                   0,0,z
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 95:  c                   x,-x,z
     &	/ 3, 57, 35, 95,  0,  0,  0,  0/
c
c	# 186 , P63mc
	data (generspcgr(i,186),i=0,7)
c	# 57:  3                   0,0,z
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 94:  m                   x,-x,z
     &	/ 3, 57, 35, 94,  0,  0,  0,  0/
c
c	# 187 , P-6m2
	data (generspcgr(i,187),i=0,7)
c	# 57:  3                   0,0,z
c	# 85:  m                   x,y,0
c	# 94:  m                   x,-x,z
     &	/ 3, 57, 85, 94,  0,  0,  0,  0/
c
c	# 188 , P-6c2
	data (generspcgr(i,188),i=0,7)
c	# 57:  3                   0,0,z
c	# 86:  m                   x,y,1/4
c	# 95:  c                   x,-x,z
     &	/ 3, 57, 86, 95,  0,  0,  0,  0/
c
c	# 189 , P-62m
	data (generspcgr(i,189),i=0,7)
c	# 57:  3                   0,0,z
c	# 85:  m                   x,y,0
c	# 41:  2                   x,x,0
     &	/ 3, 57, 85, 41,  0,  0,  0,  0/
c
c	# 190 , P-62c
	data (generspcgr(i,190),i=0,7)
c	# 57:  3                   0,0,z
c	# 86:  m                   x,y,1/4
c	# 41:  2                   x,x,0
     &	/ 3, 57, 86, 41,  0,  0,  0,  0/
c
c	# 191 , P6/mmm
	data (generspcgr(i,191),i=0,7)
c	# 57:  3                   0,0,z
c	# 29:  2                   0,0,z
c	# 41:  2                   x,x,0
c	#  6: -1                   0,0,0
     &	/ 4, 57, 29, 41,  6,  0,  0,  0/
c
c	# 192 , P6/mcc
	data (generspcgr(i,192),i=0,7)
c	# 57:  3                   0,0,z
c	# 29:  2                   0,0,z
c	# 43:  2                   x,x,1/4
c	#  6: -1                   0,0,0
     &	/ 4, 57, 29, 43,  6,  0,  0,  0/
c
c	# 193 , P63/mcm
	data (generspcgr(i,193),i=0,7)
c	# 57:  3                   0,0,z
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 43:  2                   x,x,1/4
c	#  6: -1                   0,0,0
     &	/ 4, 57, 35, 43,  6,  0,  0,  0/
c
c	# 194 , P63/mmc
	data (generspcgr(i,194),i=0,7)
c	# 57:  3                   0,0,z
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	# 41:  2                   x,x,0
c	#  6: -1                   0,0,0
     &	/ 4, 57, 35, 41,  6,  0,  0,  0/
c
c	# 195 , P23
	data (generspcgr(i,195),i=0,7)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
     &	/ 3, 29, 13, 60,  0,  0,  0,  0/
c
c	# 196 , F23
	data (generspcgr(i,196),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
     &	/ 5,  3,  2, 29, 13, 60,  0,  0/
c
c	# 197 , I23
	data (generspcgr(i,197),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
     &	/ 4,  4, 29, 13, 60,  0,  0,  0/
c
c	# 198 , P213
	data (generspcgr(i,198),i=0,7)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	# 60:  3                   x,x,x
     &	/ 3, 36, 25, 60,  0,  0,  0,  0/
c
c	# 199 , I213
	data (generspcgr(i,199),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	# 60:  3                   x,x,x
     &	/ 4,  4, 36, 25, 60,  0,  0,  0/
c
c	# 200 , Pm-3
	data (generspcgr(i,200),i=0,7)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	#  6: -1                   0,0,0
     &	/ 4, 29, 13, 60,  6,  0,  0,  0/
c
c	# 201 , Pn-3
	data (generspcgr(i,201),i=0,7)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 11: -1                   1/4,1/4,1/4
     &	/ 4, 29, 13, 60, 11,  0,  0,  0/
c
c	# 202 , Fm-3
	data (generspcgr(i,202),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	#  6: -1                   0,0,0
     &	/ 6,  3,  2, 29, 13, 60,  6,  0/
c
c	# 203 , Fd-3
	data (generspcgr(i,203),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 10: -1                   1/8,1/8,1/8
     &	/ 6,  3,  2, 29, 13, 60, 10,  0/
c
c	# 204 , Im-3
	data (generspcgr(i,204),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	#  6: -1                   0,0,0
     &	/ 5,  4, 29, 13, 60,  6,  0,  0/
c
c	# 205 , Pa-3
	data (generspcgr(i,205),i=0,7)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	# 60:  3                   x,x,x
c	#  6: -1                   0,0,0
     &	/ 4, 36, 25, 60,  6,  0,  0,  0/
c
c	# 206 , Ia-3
	data (generspcgr(i,206),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	# 60:  3                   x,x,x
c	#  6: -1                   0,0,0
     &	/ 5,  4, 36, 25, 60,  6,  0,  0/
c
c	# 207 , P432
	data (generspcgr(i,207),i=0,7)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 41:  2                   x,x,0
     &	/ 4, 29, 13, 60, 41,  0,  0,  0/
c
c	# 208 , P4232
	data (generspcgr(i,208),i=0,7)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 49:  2  (1/2, 1/2,   0)  x,x,1/4
     &	/ 4, 29, 13, 60, 49,  0,  0,  0/
c
c	# 209 , F432
	data (generspcgr(i,209),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 41:  2                   x,x,0
     &	/ 6,  3,  2, 29, 13, 60, 41,  0/
c
c	# 210 , F4132
	data (generspcgr(i,210),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 22:  2  (  0, 1/2,   0)  1/4,y,0
c	# 60:  3                   x,x,x
c	# 50:  2  (1/2, 1/2,   0)  x,x-1/4,3/8
     &	/ 6,  3,  2, 36, 22, 60, 50,  0/
c
c	# 211 , I432
	data (generspcgr(i,211),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 41:  2                   x,x,0
     &	/ 5,  4, 29, 13, 60, 41,  0,  0/
c
c	# 212 , P4332
	data (generspcgr(i,212),i=0,7)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	# 60:  3                   x,x,x
c	# 51:  2  (1/2, 1/2,   0)  x,x+1/4,3/8
     &	/ 4, 36, 25, 60, 51,  0,  0,  0/
c
c	# 213 , P4132
	data (generspcgr(i,213),i=0,7)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	# 60:  3                   x,x,x
c	# 47:  2  (1/2, 1/2,   0)  x,x-1/4,1/8
     &	/ 4, 36, 25, 60, 47,  0,  0,  0/
c
c	# 214 , I4132
	data (generspcgr(i,214),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	# 60:  3                   x,x,x
c	# 47:  2  (1/2, 1/2,   0)  x,x-1/4,1/8
     &	/ 5,  4, 36, 25, 60, 47,  0,  0/
c
c	# 215 , P-43m
	data (generspcgr(i,215),i=0,7)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 90:  m                   x,x,z
     &	/ 4, 29, 13, 60, 90,  0,  0,  0/
c
c	# 216 , F-43m
	data (generspcgr(i,216),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 90:  m                   x,x,z
     &	/ 6,  3,  2, 29, 13, 60, 90,  0/
c
c	# 217 , I-43m
	data (generspcgr(i,217),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 90:  m                   x,x,z
     &	/ 5,  4, 29, 13, 60, 90,  0,  0/
c
c	# 218 , P-43n
	data (generspcgr(i,218),i=0,7)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 92:  n  (1/2, 1/2, 1/2)  x,x,z
     &	/ 4, 29, 13, 60, 92,  0,  0,  0/
c
c	# 219 , F-43c
	data (generspcgr(i,219),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 92:  n  (1/2, 1/2, 1/2)  x,x,z
     &	/ 6,  3,  2, 29, 13, 60, 92,  0/
c
c	# 220 , I-43d
	data (generspcgr(i,220),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	# 60:  3                   x,x,x
c	# 93:  d  (1/4, 1/4, 1/4)  x,x,z
     &	/ 5,  4, 36, 25, 60, 93,  0,  0/
c
c	# 221 , Pm-3m
	data (generspcgr(i,221),i=0,7)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 41:  2                   x,x,0
c	#  6: -1                   0,0,0
     &	/ 5, 29, 13, 60, 41,  6,  0,  0/
c
c	# 222 , Pn-3n
	data (generspcgr(i,222),i=0,7)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 41:  2                   x,x,0
c	# 11: -1                   1/4,1/4,1/4
     &	/ 5, 29, 13, 60, 41, 11,  0,  0/
c
c	# 223 , Pm-3n
	data (generspcgr(i,223),i=0,7)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 49:  2  (1/2, 1/2,   0)  x,x,1/4
c	#  6: -1                   0,0,0
     &	/ 5, 29, 13, 60, 49,  6,  0,  0/
c
c	# 224 , Pn-3m
	data (generspcgr(i,224),i=0,7)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 49:  2  (1/2, 1/2,   0)  x,x,1/4
c	# 11: -1                   1/4,1/4,1/4
     &	/ 5, 29, 13, 60, 49, 11,  0,  0/
c
c	# 225 , Fm-3m
	data (generspcgr(i,225),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 41:  2                   x,x,0
c	#  6: -1                   0,0,0
     &	/ 7,  3,  2, 29, 13, 60, 41,  6/
c
c	# 226 , Fm-3c
	data (generspcgr(i,226),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 49:  2  (1/2, 1/2,   0)  x,x,1/4
c	#  6: -1                   0,0,0
     &	/ 7,  3,  2, 29, 13, 60, 49,  6/
c
c	# 227 , Fd-3m
	data (generspcgr(i,227),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 38:  2  (  0,   0, 1/2)  0,1/4,z
c	# 22:  2  (  0, 1/2,   0)  1/4,y,0
c	# 60:  3                   x,x,x
c	# 50:  2  (1/2, 1/2,   0)  x,x-1/4,3/8
c	# 10: -1                   1/8,1/8,1/8
     &	/ 7,  3,  2, 38, 22, 60, 50, 10/
c
c	# 228 , Fd-3c
	data (generspcgr(i,228),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 38:  2  (  0,   0, 1/2)  0,1/4,z
c	# 22:  2  (  0, 1/2,   0)  1/4,y,0
c	# 60:  3                   x,x,x
c	# 50:  2  (1/2, 1/2,   0)  x,x-1/4,3/8
c	# 12: -1                   3/8,3/8,3/8
     &	/ 7,  3,  2, 38, 22, 60, 50, 12/
c
c	# 229 , Im-3m
	data (generspcgr(i,229),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	# 13:  2                   0,y,0
c	# 60:  3                   x,x,x
c	# 41:  2                   x,x,0
c	#  6: -1                   0,0,0
     &	/ 6,  4, 29, 13, 60, 41,  6,  0/
c
c	# 230 , Ia-3d
	data (generspcgr(i,230),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	# 60:  3                   x,x,x
c	# 47:  2  (1/2, 1/2,   0)  x,x-1/4,1/8
c	#  6: -1                   0,0,0
     &	/ 6,  4, 36, 25, 60, 47,  6,  0/
c
c	# 231 , P112, #   3, P2 , unique c axis 
	data (generspcgr(i,231),i=0,7)
c	# 29:  2                   0,0,z
     &	/ 1, 29,  0,  0,  0,  0,  0,  0/
c
c	# 232 , P1121, #   4, P21 , unique c axis
	data (generspcgr(i,232),i=0,7)
c	# 35:  2  (  0,   0, 1/2)  0,0,z
     &	/ 1, 35,  0,  0,  0,  0,  0,  0/
c
c	# 233 , A121, #   5, C2 , unique b axis, cell choice 2
	data (generspcgr(i,233),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	# 13:  2                   0,y,0
     &	/ 2,  3, 13,  0,  0,  0,  0,  0/
c
c	# 234 , I121, #   5, C2 , unique b axis, cell choice 3
	data (generspcgr(i,234),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 13:  2                   0,y,0
     &	/ 2,  4, 13,  0,  0,  0,  0,  0/
c
c	# 235 , A112, #   5, C2 , unique c axis, cell choice 1
	data (generspcgr(i,235),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	# 29:  2                   0,0,z
     &	/ 2,  3, 29,  0,  0,  0,  0,  0/
c
c	# 236 , B112, #   5, C2 , unique c axis, cell choice 2
	data (generspcgr(i,236),i=0,7)
c	#  2:  t  (1/2,   0, 1/2)
c	# 29:  2                   0,0,z
     &	/ 2,  2, 29,  0,  0,  0,  0,  0/
c
c	# 237 , I112, #   5, C2 , unique c axis, cell choice 3
	data (generspcgr(i,237),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
     &	/ 2,  4, 29,  0,  0,  0,  0,  0/
c
c	# 238 , P11m, #   6, Pm , unique c axis 
	data (generspcgr(i,238),i=0,7)
c	# 85:  m                   x,y,0
     &	/ 1, 85,  0,  0,  0,  0,  0,  0/
c
c	# 239 , P1n1, #   7, Pc , unique b axis, cell choice 2
	data (generspcgr(i,239),i=0,7)
c	# 82:  n  (1/2,   0, 1/2)  x,0,z
     &	/ 1, 82,  0,  0,  0,  0,  0,  0/
c
c	# 240 , P1a1, #   7, Pc , unique b axis, cell choice 3
	data (generspcgr(i,240),i=0,7)
c	# 78:  a                   x,0,z
     &	/ 1, 78,  0,  0,  0,  0,  0,  0/
c
c	# 241 , P11a, #   7, Pc , unique c axis, cell choice 1
	data (generspcgr(i,241),i=0,7)
c	# 87:  a                   x,y,0
     &	/ 1, 87,  0,  0,  0,  0,  0,  0/
c
c	# 242 , P11n, #   7, Pc , unique c axis, cell choice 2
	data (generspcgr(i,242),i=0,7)
c	# 89:  n  (1/2, 1/2,   0)  x,y,0
     &	/ 1, 89,  0,  0,  0,  0,  0,  0/
c
c	# 243 , P11b, #   7, Pc , unique c axis, cell choice 3
	data (generspcgr(i,243),i=0,7)
c	# 88:  b                   x,y,0
     &	/ 1, 88,  0,  0,  0,  0,  0,  0/
c
c	# 244 , A1m1, #   8, Cm , unique b axis, cell choice 2
	data (generspcgr(i,244),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	# 76:  m                   x,0,z
     &	/ 2,  3, 76,  0,  0,  0,  0,  0/
c
c	# 245 , I1m1, #   8, Cm , unique b axis, cell choice 3
	data (generspcgr(i,245),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 76:  m                   x,0,z
     &	/ 2,  4, 76,  0,  0,  0,  0,  0/
c
c	# 246 , A11m, #   8, Cm , unique c axis, cell choice 1
	data (generspcgr(i,246),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	# 85:  m                   x,y,0
     &	/ 2,  3, 85,  0,  0,  0,  0,  0/
c
c	# 247 , B11m, #   8, Cm , unique c axis, cell choice 2
	data (generspcgr(i,247),i=0,7)
c	#  2:  t  (1/2,   0, 1/2)
c	# 85:  m                   x,y,0
     &	/ 2,  2, 85,  0,  0,  0,  0,  0/
c
c	# 248 , I11m, #   8, unique c axis, cell choice 3
	data (generspcgr(i,248),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 85:  m                   x,y,0
     &	/ 2,  4, 85,  0,  0,  0,  0,  0/
c
c	# 249 , A1n1, #   9, Cc , unique b axis, cell choice 2
	data (generspcgr(i,249),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	# 82:  n  (1/2,   0, 1/2)  x,0,z
     &	/ 2,  3, 82,  0,  0,  0,  0,  0/
c
c	# 250 , I1a1, #   9, Cc , unique b axis, cell choice 3
	data (generspcgr(i,250),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 78:  a                   x,0,z
     &	/ 2,  4, 78,  0,  0,  0,  0,  0/
c
c	# 251 , A11a, #   9, Cc , unique c axis, cell choice 1
	data (generspcgr(i,251),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	# 87:  a                   x,y,0
     &	/ 2,  3, 87,  0,  0,  0,  0,  0/
c
c	# 252 , B11n, #   9, Cc , unique c axis, cell choice 2
	data (generspcgr(i,252),i=0,7)
c	#  2:  t  (1/2,   0, 1/2)
c	# 89:  n  (1/2, 1/2,   0)  x,y,0
     &	/ 2,  2, 89,  0,  0,  0,  0,  0/
c
c	# 253 , I11b, #   9, Cc , unique c axis, cell choice 3
	data (generspcgr(i,253),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 88:  b                   x,y,0
     &	/ 2,  4, 88,  0,  0,  0,  0,  0/
c
c	# 254 , P112/m, #  10, P2/m , unique c axis
	data (generspcgr(i,254),i=0,7)
c	# 29:  2                   0,0,z
c	#  6: -1                   0,0,0
     &	/ 2, 29,  6,  0,  0,  0,  0,  0/
c
c	# 255 , P1121/m, #  11, P21/m , unique c axis
	data (generspcgr(i,255),i=0,7)
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	#  6: -1                   0,0,0
     &	/ 2, 35,  6,  0,  0,  0,  0,  0/
c
c	# 256 , A12/m1, #  12, C2/m , unique b axis, cell choice 2
	data (generspcgr(i,256),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	# 13:  2                   0,y,0
c	#  6: -1                   0,0,0
     &	/ 3,  3, 13,  6,  0,  0,  0,  0/
c
c	# 257 , I12/m1, #  12, C2/m , unique b axis, cell choice 3
	data (generspcgr(i,257),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 13:  2                   0,y,0
c	#  6: -1                   0,0,0
     &	/ 3,  4, 13,  6,  0,  0,  0,  0/
c
c	# 258 , A112/m, #  12, C2/m , unique c axis, cell choice 1
	data (generspcgr(i,258),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	# 29:  2                   0,0,z
c	#  6: -1                   0,0,0
     &	/ 3,  3, 29,  6,  0,  0,  0,  0/
c
c	# 259 , B112/m, #  12, C2/m , unique c axis, cell choice 2
	data (generspcgr(i,259),i=0,7)
c	#  2:  t  (1/2,   0, 1/2)
c	# 29:  2                   0,0,z
c	#  6: -1                   0,0,0
     &	/ 3,  2, 29,  6,  0,  0,  0,  0/
c
c	# 260 , I112/m, #  12, C2/m , unique c axis, cell choice 3
	data (generspcgr(i,260),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 29:  2                   0,0,z
c	#  6: -1                   0,0,0
     &	/ 3,  4, 29,  6,  0,  0,  0,  0/
c
c	# 261 , P12/n1, #  13, P2/c , unique b axis, cell choice 2
	data (generspcgr(i,261),i=0,7)
c	# 18:  2                   1/4,y,1/4
c	#  6: -1                   0,0,0
     &	/ 2, 18,  6,  0,  0,  0,  0,  0/
c
c	# 262 , P12/a1, #  13, P2/c , unique b axis, cell choice 3
	data (generspcgr(i,262),i=0,7)
c	# 14:  2                   1/4,y,0
c	#  6: -1                   0,0,0
     &	/ 2, 14,  6,  0,  0,  0,  0,  0/
c
c	# 263 , P112/a, #  13, P2/c , unique c axis, cell choice 1
	data (generspcgr(i,263),i=0,7)
c	# 30:  2                   1/4,0,z
c	#  6: -1                   0,0,0
     &	/ 2, 30,  6,  0,  0,  0,  0,  0/
c
c	# 264 , P112/n, #  13, P2/c , unique c axis, cell choice 2
	data (generspcgr(i,264),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	#  6: -1                   0,0,0
     &	/ 2, 33,  6,  0,  0,  0,  0,  0/
c
c	# 265 , P112/b, #  13, P2/c , unique c axis, cell choice 3
	data (generspcgr(i,265),i=0,7)
c	# 32:  2                   0,1/4,z
c	#  6: -1                   0,0,0
     &	/ 2, 32,  6,  0,  0,  0,  0,  0/
c
c	# 266 , P121/n1, #  14, P21/c , unique b axis, cell choice 2
	data (generspcgr(i,266),i=0,7)
c	# 26:  2  (  0, 1/2,   0)  1/4,y,1/4
c	#  6: -1                   0,0,0
     &	/ 2, 26,  6,  0,  0,  0,  0,  0/
c
c	# 267 , P121/a1, #  14, P21/c , unique b axis, cell choice 3
	data (generspcgr(i,267),i=0,7)
c	# 22:  2  (  0, 1/2,   0)  1/4,y,0
c	#  6: -1                   0,0,0
     &	/ 2, 22,  6,  0,  0,  0,  0,  0/
c
c	# 268 , P1121/a, #  14, P21/c , unique c axis, cell choice 1
	data (generspcgr(i,268),i=0,7)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	#  6: -1                   0,0,0
     &	/ 2, 36,  6,  0,  0,  0,  0,  0/
c
c	# 269 , P1121/n, #  14, P21/c , unique c axis, cell choice 2
	data (generspcgr(i,269),i=0,7)
c	# 39:  2  (  0,   0, 1/2)  1/4,1/4,z
c	#  6: -1                   0,0,0
     &	/ 2, 39,  6,  0,  0,  0,  0,  0/
c
c	# 270 , P1121/b, #  14, P21/c , unique c axis, cell choice 3
	data (generspcgr(i,270),i=0,7)
c	# 38:  2  (  0,   0, 1/2)  0,1/4,z
c	#  6: -1                   0,0,0
     &	/ 2, 38,  6,  0,  0,  0,  0,  0/
c
c	# 271 , A12/n1, #  15, C2/c , unique b axis, cell choice 2
	data (generspcgr(i,271),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	# 18:  2                   1/4,y,1/4
c	#  6: -1                   0,0,0
     &	/ 3,  3, 18,  6,  0,  0,  0,  0/
c
c	# 272 , I12/a1, #  15, C2/c , unique b axis, cell choice 3
	data (generspcgr(i,272),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 14:  2                   1/4,y,0
c	#  6: -1                   0,0,0
     &	/ 3,  4, 141, 6,  0,  0,  0,  0/
c
c	# 273 , A112/a, #  15, C2/c , unique c axis, cell choice 1
	data (generspcgr(i,273),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	# 30:  2                   1/4,0,z
c	#  6: -1                   0,0,0
     &	/ 3,  3, 30,  6,  0,  0,  0,  0/
c
c	# 274 , B112/n, #  15, C2/c , unique c axis, cell choice 2
	data (generspcgr(i,274),i=0,7)
c	#  2:  t  (1/2,   0, 1/2)
c	# 33:  2                   1/4,1/4,z
c	#  6: -1                   0,0,0
     &	/ 3,  2, 33,  6,  0,  0,  0,  0/
c
c	# 275 , I112/b, #  15, C2/c , unique c axis, cell choice 3
	data (generspcgr(i,275),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 32:  2                   0,1/4,z
c	#  6: -1                   0,0,0
     &	/ 3,  4, 32,  6,  0,  0,  0,  0/
c
c	# 276 , Pnnn, #  48, origin choice 2
	data (generspcgr(i,276),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 18:  2                   1/4,y,1/4
c	#  6: -1                   0,0,0
     &	/ 3, 33, 18,  6,  0,  0,  0,  0/
c
c	# 277 , Pban, #  50, origin choice 2
	data (generspcgr(i,277),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 14:  2                   1/4,y,0
c	#  6: -1                   0,0,0
     &	/ 3, 33, 14,  6,  0,  0,  0,  0/
c
c	# 278 , Pmmn, #  59, origin choice 2
	data (generspcgr(i,278),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 21:  2  (  0, 1/2,   0)  0,y,0
c	#  6: -1                   0,0,0
     &	/ 3, 33, 21,  6,  0,  0,  0,  0/
c
c	# 279 , Ccca, #  68, origin choice 2
	data (generspcgr(i,279),i=0,7)
c	#  1:  t  (1/2, 1/2,   0)
c	# 30:  2                   1/4,0,z
c	# 17:  2                   0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 4,  1, 30, 17,  6,  0,  0,  0/
c
c	# 280 , Fddd, #  70, origin choice 2
	data (generspcgr(i,280),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 34:  2                   3/8,3/8,z
c	# 20:  2                   3/8,y,3/8
c	#  6: -1                   0,0,0
     &	/ 5,  3,  2, 34, 20,  6,  0,  0/
c
c	# 281 , P4/n, #  85, origin choice 2
	data (generspcgr(i,281),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 62:  4                   1/4,1/4,z
c	#  6: -1                   0,0,0
     &	/ 3, 33, 62,  6,  0,  0,  0,  0/
c
c	# 282 , P42/n, #  86, origin choice 2
	data (generspcgr(i,282),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 70:  4  (  0,   0, 1/2) -1/4,1/4,z
c	#  6: -1                   0,0,0
     &	/ 3, 33, 70,  6,  0,  0,  0,  0/
c
c	# 283 , I41/a, #  88, origin choice 2
	data (generspcgr(i,283),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 68:  4  (  0,   0, 1/4)  1/4,1/2,z
c	#  6: -1                   0,0,0
     &	/ 4,  4, 36, 68,  6,  0,  0,  0/
c
c	# 284 , P4/nbm, # 125, origin choice 2
	data (generspcgr(i,284),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 62:  4                   1/4,1/4,z
c	# 14:  2                   1/4,y,0
c	#  6: -1                   0,0,0
     &	/ 4, 33, 62, 14,  6,  0,  0,  0/
c
c	# 285 , P4/nnc, # 126, origin choice 2
	data (generspcgr(i,285),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 62:  4                   1/4,1/4,z
c	# 18:  2                   1/4,y,1/4
c	#  6: -1                   0,0,0
     &	/ 4, 33, 62, 18,  6,  0,  0,  0/
c
c	# 286 , P4/nmm, # 129, origin choice 2
	data (generspcgr(i,286),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 62:  4                   1/4,1/4,z
c	# 21:  2  (  0, 1/2,   0)  0,y,0
c	#  6: -1                   0,0,0
     &	/ 4, 33, 62, 21,  6,  0,  0,  0/
c
c	# 287 , P4/ncc, # 130, origin choice 2
	data (generspcgr(i,287),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 62:  4                   1/4,1/4,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 4, 33, 62, 25,  6,  0,  0,  0/
c
c	# 288 , P42/nbc, # 133, origin choice 2
	data (generspcgr(i,288),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 71:  4  (  0,   0, 1/2)  1/4,1/4,z
c	# 14:  2                   1/4,y,0
c	#  6: -1                   0,0,0
     &	/ 4, 33, 71, 14,  6,  0,  0,  0/
c
c	# 289 , P42/nnn, # 134, origin choice 2
	data (generspcgr(i,289),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 71:  4  (  0,   0, 1/2)  1/4,1/4,z
c	# 18:  2                   1/4,y,1/4
c	#  6: -1                   0,0,0
     &	/ 4, 33, 71, 18,  6,  0,  0,  0/
c
c	# 290 , P42/nmc, # 137, origin choice 2
	data (generspcgr(i,290),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 71:  4  (  0,   0, 1/2)  1/4,1/4,z
c	# 21:  2  (  0, 1/2,   0)  0,y,0
c	#  6: -1                   0,0,0
     &	/ 4, 33, 71, 21,  6,  0,  0,  0/
c
c	# 291 , P42/ncm, # 138, origin choice 2
	data (generspcgr(i,291),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 71:  4  (  0,   0, 1/2)  1/4,1/4,z
c	# 25:  2  (  0, 1/2,   0)  0,y,1/4
c	#  6: -1                   0,0,0
     &	/ 4, 33, 71, 25,  6,  0,  0,  0/
c
c	# 292 , I41/amd, # 141, origin choice 2
	data (generspcgr(i,292),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 67:  4  (  0,   0, 1/4) -1/4,1/2,z
c	# 18:  2                   1/4,y,1/4
c	#  6: -1                   0,0,0
     &	/ 5,  4, 36, 67, 18,  6,  0,  0/
c
c	# 293 , I41/acd, # 142, origin choice 2
	data (generspcgr(i,293),i=0,7)
c	#  4:  t  (1/2, 1/2, 1/2)
c	# 36:  2  (  0,   0, 1/2)  1/4,0,z
c	# 67:  4  (  0,   0, 1/4) -1/4,1/2,z
c	# 14:  2                   1/4,y,0
c	#  6: -1                   0,0,0
     &	/ 5,  4, 36, 67, 14,  6,  0,  0/
c
c	# 294 , R3, # 146 rhombohedral axes
	data (generspcgr(i,294),i=0,7)
c	# 60:  3                   x,x,x
     &	/ 1, 60,  0,  0,  0,  0,  0,  0/
c
c	# 295 , R-3, # 148 rhombohedral axes
	data (generspcgr(i,295),i=0,7)
c	# 60:  3                   x,x,x
c	#  6: -1                   0,0,0
     &	/ 2, 60,  6,  0,  0,  0,  0,  0/
c
c	# 296 , R32, # 155 rhombohedral axes
	data (generspcgr(i,296),i=0,7)
c	# 60:  3                   x,x,x
c	# 52:  2                   x,-x,0
     &	/ 2, 60, 52,  0,  0,  0,  0,  0/
c
c	# 297 , R3m, # 160 rhombohedral axes
	data (generspcgr(i,297),i=0,7)
c	# 60:  3                   x,x,x
c	# 90:  m                   x,x,z
     &	/ 2, 60, 90,  0,  0,  0,  0,  0/
c
c	# 298 , R3c, # 161 rhombohedral axes
	data (generspcgr(i,298),i=0,7)
c	# 60:  3                   x,x,x
c	# 92:  n  (1/2, 1/2, 1/2)  x,x,z
     &	/ 2, 60, 92,  0,  0,  0,  0,  0/
c
c	# 299 , R-3m, # 166 rhombohedral axes
	data (generspcgr(i,299),i=0,7)
c	# 60:  3                   x,x,x
c	# 52:  2                   x,-x,0
c	#  6: -1                   0,0,0
     &	/ 3, 60, 52,  6,  0,  0,  0,  0/
c
c	# 300 , R-3c, # 167 rhombohedral axes
	data (generspcgr(i,300),i=0,7)
c	# 60:  3                   x,x,x
c	# 55:  2                   x,-x+1/2,1/4
c	#  6: -1                   0,0,0
     &	/ 3, 60, 55,  6,  0,  0,  0,  0/
c
c	# 301 , Pn-3, # 201, origin choice 2
	data (generspcgr(i,301),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 18:  2                   1/4,y,1/4
c	# 60:  3                   x,x,x
c	#  6: -1                   0,0,0
     &	/ 4, 33, 18, 60,  6,  0,  0,  0/
c
c	# 302 , Fd-3, # 203, origin choice 2
	data (generspcgr(i,302),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 31:  2                   1/8,1/8,z
c	# 15:  2                   1/8,y,1/8
c	# 60:  3                   x,x,x
c	#  6: -1                   0,0,0
     &	/ 6,  3,  2, 31, 15, 60,  6,  0/
c
c	# 303 , Pn-3n, # 222, origin choice 2
	data (generspcgr(i,303),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 18:  2                   1/4,y,1/4
c	# 60:  3                   x,x,x
c	# 43:  2                   x,x,1/4
c	#  6: -1                   0,0,0
     &	/ 5, 33, 18, 60, 43,  6,  0,  0/
c
c	# 304 , Pn-3m, # 224, origin choice 2
	data (generspcgr(i,304),i=0,7)
c	# 33:  2                   1/4,1/4,z
c	# 18:  2                   1/4,y,1/4
c	# 60:  3                   x,x,x
c	# 45:  2  (1/2, 1/2,   0)  x,x,0
c	#  6: -1                   0,0,0
     &	/ 5, 33, 18, 60, 45,  6,  0,  0/
c
c	# 305 , Fd-3m, # 227, origin choice 2
	data (generspcgr(i,305),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 37:  2  (  0,   0, 1/2)  3/8,1/8,z
c	# 27:  2  (  0, 1/2,   0)  1/8,y,3/8
c	# 60:  3                   x,x,x
c	# 48:  2  (1/2, 1/2,   0)  x,x-1/4,1/4
c	#  6: -1                   0,0,0
     &	/ 7,  3,  2, 37, 27, 60, 48,  6/
c
c	# 306 , Fd-3c, # 228, origin choice 2
	data (generspcgr(i,306),i=0,7)
c	#  3:  t  (0  , 1/2, 1/2)
c	#  2:  t  (1/2,   0, 1/2)
c	# 40:  2  (  0,   0, 1/2)  1/8,3/8,z
c	# 24:  2  (  0, 1/2,   0)  3/8,y,1/8
c	# 60:  3                   x,x,x
c	# 46:  2  (1/2, 1/2,   0)  x,x-1/4,0
c	#  6: -1                   0,0,0
     &	/ 7,  3,  2, 40, 24, 60, 46,  6/
c
c	# 307 , Pbnm, #  62, nonstandard Pnma
	data (generspcgr(i,307),i=0,7)
c	# 96:  2  (1/2,   0,   0)  x,1/4,0
c	# 35:  2  (  0,   0, 1/2)  0,0,z
c	#  6: -1                   0,0,0
     &	/ 3, 96, 35,  6,  0,  0,  0,  0/
c
c	# 308 , Pmnn, #  58, nonstandard Pnnm
	data (generspcgr(i,308),i=0,7)
c	# 97:  2  (  0,   0,   0)  x,0,0
c	# 39:  2  (  0,   0, 1/2)  1/4,1/4,z
c	#  6: -1                   0,0,0
     &	/ 3, 97, 39,  6,  0,  0,  0,  0/
c
