c*****7*****************************************************************
	subroutine do_niplps(linverse)
c-
c	This sublevel contains all routines used to write the output
c	of the Fourier transform/Patterson to an output file in
c	various formats.
c
c	Version : 1.2
c	Date    : 16. May 1997
c
c	Authors : R.B. Neder  (reinhard.neder@mail.uni-wuerzburg.de)
c	          Th. Proffen (tproffen@lanl.gov)
c
c+
	implicit       none
c
	include        'config.inc'
	include        'doact.inc'
	include        'errlist.inc'
	include        'learn.inc'
	include        'macro.inc'
	include        'output.inc'
	include        'prompt.inc'
	include        'diffuse.inc'
c
	integer        maxp,maxw,iff
	parameter     (maxp=11,maxw=1,iff=2)
c
	character*5     befehl
	character*11    prom
	character*14    cvalue(0:6)
	character*22    cgraphik(0:8)
	character*40    infile
	character*200   zeile
	character*200   line,cpara(maxp)
	integer         lpara(maxp)
	integer         ix,iy,ianz,value,lp,length,lbef
	integer         indxg
	logical         laver,lread,linverse
	real            xmin,ymin,xmax,ymax,werte(maxp)
c
	logical         str_comp
c
	data cgraphik 	/'Standard','Postscript','Pseudo Grey Map',
     &	                 'Gnuplot', 'Portable Any Map',
     &	                 'Powder Pattern','SHELX','SHELXL List 5',
     &	                 'SHELXL List 5 real HKL'/
	data cvalue 	/'undefined     ', 'Intensity     ',
     &	                 'Amplitude     ', 'Phase angle   ',
     &	                 'Real Part     ', 'Imaginary Part',
     &	                 'Random Phase  '/
c
	data value	/1/
	data laver	/.false./
c
	zmin=ps_low *diffumax
	zmax=ps_high*diffumax
10	continue
c
	call no_error
c
	prom=prompt//'/output'
	call get_command (line,length,befehl,lbef,zeile,lp,prom)
	if(ier_num.eq.0) then
	if(line(1:1).eq.' ' .or. line(1:1).eq.'#') goto 10
c
c------	search for "="
c
	indxg=index(line,'=')
	if(indxg.ne.0 .and. .not.(str_comp(befehl,'echo',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'syst',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'help',2,lbef,4) .or.
     &	                          str_comp(befehl,'?   ',2,lbef,4)))then
c
c------	--evaluatean expression and assign the value to a variabble
c
	   call do_math(line,indxg,length)
	else
c
c------ execute a macro file
c
        if(befehl(1:1).eq.'@') then
	  if(length.ge.2) then
	    call file_kdo(line(2:length),length-1)
	  else
	    ier_num = -13
	    ier_typ = ER_MAC
	  endif
c
c------	continues a macro 'continue'
c
	elseif(str_comp(befehl,'continue',1,lbef,8)) then
	  call macro_continue(zeile,lp)
c
c------ Echo a string, just for interactive check in a macro 'echo'
c
	elseif(str_comp(befehl,'echo',2,lbef,4)) then
	  call echo(zeile,lp)
c
c------	Evaluate an expression, just for interactive check 'eval'
c
	elseif(str_comp(befehl,'eval',2,lbef,4)) then
	  call do_eval(zeile,lp)
c
c------	Terminate output 'exit'
c
	elseif(str_comp(befehl,'exit',2,lbef,4)) then
	  goto 9999
c
c------	Determine format for output 'format'
c
	elseif(str_comp(befehl,'form',1,lbef,4)) then
	  call get_params(zeile,ianz,cpara,lpara,maxp,lp)
	  if(ier_num.eq.0) then
	    if(ianz.eq.1) then
c
c------	------Switch output type to GNUPLOT 'gnup'
c
	      if(str_comp(cpara(1),'gnup',1,lpara(1),4)) then
	        ityp=3
c
c------	------Switch output type to pgm 'pgm'
c
	      elseif(str_comp(cpara(1),'pgm ',2,lpara(1),4)) then
	        ityp=2
c
c------	------Switch output type to postscript 'post'
c
	      elseif(str_comp(cpara(1),'post',3,lpara(1),4)) then
	        ityp=1
c
c------	------Switch output type to powder pattern 'powd'
c
	      elseif(str_comp(cpara(1),'powd',3,lpara(1),4)) then
	        ityp=5
c
c------	------Switch output type to ppm 'ppm'
c
	      elseif(str_comp(cpara(1),'ppm ',2,lpara(1),4)) then
	        ityp=4
c
c------	------Switch output type to standard  'stan'
c
	      elseif(str_comp(cpara(1),'stan',2,lpara(1),4)) then
	        ityp=0
c
c------	------Switch output type to Shelx 'shel', or 'hklf4'
c
	      elseif(str_comp(cpara(1),'shel',2,lpara(1),4)) then
	        ityp=6
	      elseif(str_comp(cpara(1),'hklf4',2,lpara(1),5)) then
	        ityp=6
c
c------	------Switch output type to Shelx LIST 5   'list5'
c
	      elseif(str_comp(cpara(1),'list5',2,lpara(1),5)) then
	        ityp=7
c
c------	------Switch output type to Shelx LIST 5   'list9'
c
	      elseif(str_comp(cpara(1),'list9',2,lpara(1),5)) then
	        ityp=8
	      else
	        ier_num = -9
	        ier_typ = ER_APPL
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	help on output 'help'
c
	elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	       str_comp(befehl,'?   ',1,lbef,4)     ) then
	  if(str_comp(zeile,'errors',2,lp,6) ) then
	    lp = lp + 7
	    call do_hel('discus '//zeile,lp)
	  else
	    lp = lp + 14
	    call do_hel('discus output '//zeile,lp)
	  endif
c
c------	read an old output file (only for standard file type' 'inpu'
c
	elseif(str_comp(befehl,'inpu',1,lbef,4)) then
	  call get_params(zeile,ianz,cpara,lpara,maxp,lp)
	  if(ier_num.eq.0) then
	    infile=cpara(1)
	    lread = .true.
	    call oeffne(1,infile,'old',lread)
	    if(ier_num.eq.0) then
	      read (1,*) out_inc(1),out_inc(2)
	      read (1,*) xmin,xmax,ymin,ymax
	      read (1,*) zmax
	      zmin = zmax
	      backspace(1)
c
	      do iy=1,out_inc(2)
	        read (1,*) (dsi((ix-1)*out_inc(2)+iy),
     &	                           ix=1,out_inc(1))
	        do ix=1,out_inc(1)
	          zmax = max (zmax,dsi((ix-1)*out_inc(2)+iy))
	          zmin = min (zmin,dsi((ix-1)*out_inc(2)+iy))
	        enddo
	      enddo
	      write (output_io,1015       ) zmin,zmax
	      read  (*,*   ,end=20) zmin,zmax
20            continue
	    endif
	    close (1)
	  endif
c
c------	define name of output file 'outf'
c
	elseif(str_comp(befehl,'outf',1,lbef,4)) then
	  call get_params(zeile,ianz,cpara,lpara,maxp,lp)
	  if(ier_num.eq.0) then
	    call do_build_name(ianz,cpara,lpara,werte,maxp,1)
	    if(ier_num.eq.0) then
	      outfile = cpara(1)
	    endif
	  endif
c
c------	write output file 'run'
c
	elseif(str_comp(befehl,'run ',1,lbef,4)) then
	  call set_output(linverse)
	  if    (ityp.eq.0) then
	    call do_output(value,laver)
	  elseif(ityp.eq.1) then
	    call do_post(value,laver)
	  elseif(ityp.eq.2) then
	    call do_pgm(value,laver)
	  elseif(ityp.eq.3) then
	    call do_output(value,laver)
	  elseif(ityp.eq.4) then
	    call do_ppm(value,laver)
	  elseif(ityp.eq.5) then
	    call powder_out
	  elseif(ityp.eq.6) then
	    call do_output(value,laver)
	  elseif(ityp.eq.7) then
	    call do_output(value,laver)
	  elseif(ityp.eq.8) then
	    call do_output(value,laver)
	  else
	    ier_num = -9
	    ier_typ = ER_APPL
	  endif
c
c------	Show current settings for output 'show'
c
	elseif(str_comp(befehl,'show',2,lbef,4)) then
	  write (output_io,3000) outfile
          if(ityp.lt.0 .or. 8.lt.ityp) then
	    write (output_io,*) 'ityp undefiniert ',ityp
	  else
	    write (output_io,3100) cgraphik(ityp)
	    if (laver) then
	      write (output_io,3110) '<'//cvalue(value)//'>'
	    else
	      write (output_io,3110) cvalue(value)
	    endif
	  endif
	  write (output_io,3060) braggmin,braggmax,diffumin,diffumax,
     &	                diffuave,diffusig
	  write (output_io,3080) 100.0*ps_high,zmax
	  write (output_io,3090) 100.0*ps_low, zmin
c
c-------Operating System Kommandos 'syst'
c
	elseif(str_comp(befehl,'syst',2,lbef,4)) then
	  if(zeile.ne. ' ') then
	    call do_operating(zeile(1:lp),lp)
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c------	Set threshold for intensity written to bitmaps 'thresh'
c
	elseif(str_comp(befehl,'thre',2,lbef,4)) then
	  call get_params(zeile,ianz,cpara,lpara,maxp,lp)
	  if(ier_num.eq.0) then
	    if(ianz.eq.2) then
	      if(str_comp(cpara(1),'high',1,lpara(1),4)) then
	        call del_params (1,ianz,cpara,lpara,maxp)
	        call ber_params(ianz,cpara,lpara,werte,maxp)
	        if(ier_num.eq.0) then
	          ps_high=werte(1)*0.01
	          zmax   =diffumax*ps_high
	        endif
	      elseif(str_comp(cpara(1),'low',1,lpara(1),3)) then
	        call del_params (1,ianz,cpara,lpara,maxp)
	        call ber_params(ianz,cpara,lpara,werte,maxp)
	        if(ier_num.eq.0) then
	          ps_low =werte(1)*0.01
	          zmin   =diffumax*ps_low 
	        endif
	      elseif(str_comp(cpara(1),'sigma',1,lpara(1),5)) then
	        call del_params (1,ianz,cpara,lpara,maxp)
	        call ber_params(ianz,cpara,lpara,werte,maxp)
	        if (ier_num.eq.0) then
	          zmin=max(diffumin,diffuave-werte(1)*diffusig)
	          zmax=min(diffumax,diffuave+werte(1)*diffusig)
	          if(diffumax.ne.0) then
	            ps_high = zmax/diffumax
	            ps_low  = zmin/diffumax
	          else
	            ps_high = 0.0
	            ps_low  = 0.0
	          endif
	        endif
	      elseif(str_comp(cpara(1),'zmax',3,lpara(1),4)) then
	        call del_params (1,ianz,cpara,lpara,maxp)
	        call ber_params(ianz,cpara,lpara,werte,maxp)
	        if(ier_num.eq.0) then
	          zmax   =werte(1)
	          if(diffumax.ne.0) then
	            ps_high = zmax/diffumax
	          else
	            ps_high = 0.0
	          endif
	        endif
	      elseif(str_comp(cpara(1),'zmin',3,lpara(1),4)) then
	        call del_params (1,ianz,cpara,lpara,maxp)
	        call ber_params(ianz,cpara,lpara,werte,maxp)
	        if(ier_num.eq.0) then
	          zmin   =werte(1)
	          if(diffumax.ne.0) then
	            ps_low = zmin/diffumax
	          else
	            ps_low = 0.0
	          endif
	        endif
	      else
	        ier_num = -11
	        ier_typ = ER_APPL
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	Define output value 'value'
c
	elseif(str_comp(befehl,'valu',1,lbef,4)) then
	  call get_params(zeile,ianz,cpara,lpara,maxp,lp)
	  if(ier_num.eq.0) then
c------ ----Check if we want the average values <F> ?
	    if (cpara(1)(1:1).eq.'<') then
	      ix=2
	      laver=.true.
	    else
	      ix=1
	      laver=.false.
	    endif
c------	----Calculate intensity 'intensity'
	    if    (cpara(1)(ix:ix+1).eq.'in') then
	       value = 1
c------	----Calculate amplitude 'amplitude'
	    elseif(cpara(1)(ix:ix).eq.'a') then
	       value = 2
c------	----Calculate phase 'phase'
	    elseif(cpara(1)(ix:ix).eq.'p') then
	      if(ianz.eq.1) then
	        value = 3
	      elseif(ianz.eq.2 .and. cpara(2)(1:1).eq.'r') then
	        value = 6
	      endif
c------	----Calculate real part 'real'
	    elseif(cpara(1)(ix:ix).eq.'r') then
	       value = 4
c------	----Calculate imaginary part 'imaginary'
	    elseif(cpara(1)(ix:ix+1).eq.'im') then
	       value = 5
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	      value   = 0
	    endif
c------ ----check lots and allowed output
            if (nlots.ne.1 .and. value.ne.1 .and. .not.laver) then
              ier_num = -60
              ier_typ = ER_APPL
              value   = 0
            endif
	  endif
c
c------  -waiting for user input
c
	elseif(str_comp(befehl,'wait',3,lbef,4)) then
	  call do_input(zeile,lp)
c
c------ no valid subcommand found
c
	else
	  ier_num = -8
	  ier_typ = ER_COMM
	endif
	endif
	endif
	if(ier_num.ne.0) then
	  call errlist
	  if(lmakro) then
	    call macro_close
	    prompt_status = PROMPT_ON
	  endif
	  if(lblock) then
	    ier_num = -11
	    ier_typ = ER_COMM
	    return
	  endif
	  call no_error
	endif
	goto 10
9999  continue
c
1015	format ( /1x,'Z-MIN = ',G20.6,/,1x,'Z-MAX = ',G20.6,//
     &	          1x,'Give new values zmin, zmax    : ',$)
3000	format( ' Output file                  : ',a)
3060	format(/' Bragg minimum                : ',g12.6/
     &	        ' Bragg maximum                : ',g12.6/
     &	        ' Diffuse minimum              : ',g12.6/
     &	        ' Diffuse maximum              : ',g12.6/
     &	        ' Diffuse average intensity    : ',g12.6/
     &	        ' Diffuse intensity sigma      : ',g12.6)
3080	format(/' Maximum value for BITMAP'/
     &	        ' in % of highest diffuse value'/
     &	        ' and absolute                 : ',2x,f9.4,2x,g12.6)
3090	format( ' Minimum value for BITMAP'/
     &	        ' in % of highest diffuse value'/
     &	        ' and absolute                 : ',2x,f9.4,2x,g12.6)
3100	format( ' Graphicsformat               : ',A)
3110	format( ' Output value                 : ',A)
	end
c*****7*****************************************************************
	subroutine do_post(value,laver)
c-
c	Writes a POSTSCRIPT file
c+
	implicit      none
c
	include       'config.inc'
	include       'envir.inc'
	include       'errlist.inc'
	include       'output.inc'
	include       'diffuse.inc'
c
	integer        maxcol
	parameter     (maxcol=256)
c
	character*6   cout(maxqxy)
	character*6   cfarb(maxcol)
	integer       i,ix,iy,iqqq,k,value
	logical       lread,laver
	real          qqq
c
	real          qval
c
c------	Check whether data are 2-dimensional
c
	if(.not. (out_inc(1).gt.1 .and. out_inc(2).gt.1)) then
	  ier_num = -50
	  ier_typ = ER_APPL
	  return
	endif
c
c-------Farbtabelle einlesen
c
	lread   = .true.
	call oeffne(2,colorfile,'old',lread)
	if(ier_num.ne.0) return
	do i=1,255
	  read (2,100,end=20) cfarb (i)
100	  format (1x,a6)
	enddo
20	continue
	close(2)
	cfarb(256) = 'ffffff'
c
	lread = .false.
	call oeffne(2,outfile,'unknown',lread)
	if(ier_num.ne.0) return
c
	write(2,1111) '%!PS-Adobe-2.0'
	write(2,1111) '%%Creator: DISCUS, Version 3.0'
	write(2,1111) '50  150 translate'
	write(2,1111) '288 288 scale'
	write(2,2000) nint(3.0*out_inc(1)),out_inc(1),out_inc(2),i,
     &	              8,out_inc(1),0,0,out_inc(2),0,0
c
	do iy=1,out_inc(2)
	  do ix=1,out_inc(1)
	    k = (ix-1)*out_inc(2)+iy
	    qqq = qval(k,value,ix,iy,laver)
	    if (qqq.lt.zmin) then
	      qqq=zmin
	    elseif (qqq.gt.zmax) then
	      qqq=zmax
	    endif
	    iqqq=nint((maxcol-2)*(qqq-zmin)/(zmax-zmin))+1
	    write(cout(ix),1111) cfarb (iqqq)
	    do i=1,6
	      if(cout(ix)(i:i).eq.' ' .or. 
     &	         cout(ix)(i:i).eq.' '       ) cout(ix)(i:i)='0'
	    enddo
	  enddo
	  write (2,5000) (cout(ix),ix=1,out_inc(1))
	enddo
	write(2,1111) 'showpage'
c
	close(2)
c
1111	format (a)
2000	format (     '/DataString ',I4,' string def'/3(I3,1X),
     &	             ' [ ',6(I3,1X),']'/'{'/
     &	             '  currentfile DataString readhexstring pop'/
     &	             ' }  false 3 colorimage')
2200	format (Z8)
5000	format (10A6)
c
	end
C*****7*****************************************************************
	subroutine do_pgm(value,laver)
c-
c	Writes the data in a PGM format
c-
	implicit      none
c
	include       'config.inc'
	include       'errlist.inc'
	include       'output.inc'
	include       'diffuse.inc'
c
	integer        maxcol
	parameter     (maxcol=255)
c
	integer       iqqq(maxqxy),ncol,ix,iy,k,value
	logical       lread,laver
	real          qqq
c
	real           qval
c
c------	Check whether data are 2-dimensional
c
	if(.not. (out_inc(1).gt.1 .and. out_inc(2).gt.1)) then
	  ier_num = -50
	  ier_typ = ER_APPL
	  return
	endif
c
	lread = .false.
	ncol=maxcol
c
	call oeffne(2,outfile,'unknown',lread)
	if(ier_num.ne.0) return
c
	write(2,1111) 'P2'
	write(2,2000) out_inc(1),out_inc(2),ncol
c
	do iy=out_inc(2),1,-1
	  do ix=1,out_inc(1)
	    k = (ix-1)*out_inc(2)+iy
	    qqq = qval(k,value,ix,iy,laver)
	    if (qqq.lt.zmin) then
	      qqq=zmin
	    elseif (qqq.gt.zmax) then
	      qqq=zmax
	    endif
	    iqqq(ix)=nint(float(ncol-1)*(qqq-zmin)/(zmax-zmin))
	  enddo
	  write (2,5000) (iqqq(ix),ix=1,out_inc(1))
	enddo
c
	close(2)
c
1111	format (a)
2000	format(1x,2i4/1x,i8)
5000	format (7i8)
c
	end
c*****7*****************************************************************
	subroutine do_ppm(value,laver)
c+
c	Writes the data in a PGM format
c-
	implicit      none
c
	include       'config.inc'
	include       'envir.inc'
	include       'errlist.inc'
	include       'output.inc'
	include       'diffuse.inc'
c
	integer        maxcol
	parameter     (maxcol=255)
c
	integer        iqqq(maxqxy),ncol,ix,iy,k,value
	integer        icolor(maxcol,3)
	integer        i,j
	logical        lread,laver
	real           qqq
c
	real           qval
c
	character*6    cfarb(256)
c
c
c------	Check whether data are 2-dimensional
c
	if(.not. (out_inc(1).gt.1 .and. out_inc(2).gt.1)) then
	  ier_num = -50
	  ier_typ = ER_APPL
	  return
	endif
c
c-------Farbtabelle einlesen
c
	call set_colorfeld(cfarb)
	lread   = .true.
	call oeffne(2,colorfile,'old',lread)
	if(ier_num.ne.0) return
	do i=1,255
	  read (2,100,end=20) (icolor(i,j),j=1,3)
100	  format (1x,3z2)
	enddo
20	continue
	close(2)
c
	icolor(255,1) = 255 
	icolor(255,2) = 255
	icolor(255,3) = 255
c
	lread = .false.
	call oeffne(2,outfile,'unknown',lread)
	if(ier_num.ne.0) return
c
	ncol=maxcol
	write(2,1111) 'P3'
	write(2,2000) out_inc(1),out_inc(2),ncol
c
	do iy=out_inc(2),1,-1
	  do ix=1,out_inc(1)
	    k = (ix-1)*out_inc(2)+iy
	    qqq = qval(k,value,ix,iy,laver)
	    if (qqq.lt.zmin) then
	      qqq=zmin
	    elseif (qqq.gt.zmax) then
	      qqq=zmax
	    endif
	    iqqq(ix)=nint(float(ncol-1)*(qqq-zmin)/(zmax-zmin))+1
	  enddo
	  write (2,5000) ((icolor(iqqq(ix),j),j=1,3),ix=1,out_inc(1))
	enddo
c
	close(2)
c
1111	format (a)
2000	format(1x,2i4/1x,i8)
5000	format (15i4)
c
	end
c*****7*****************************************************************
	subroutine set_colorfeld (cfarb)
c+
c	This routine sets the pseudo color color map
c-
	integer        maxcol
	parameter     (maxcol=256)
c
	character*6   cfarb(maxcol)
	character*20  ccc(256)
	integer	      rgb(3)
c
	cfarb(1)='000000'
c
	do ifarb=2,256
	  rh = 0.1 + float (ifarb-1) / 283.0
	  rh = 6.0 * rh
	  i  = int (rh)
	  rf = rh - float(i)
	  rp = 0.0
	  rq = 1.0 - rf
	  rt = (1.0 - (1.0 - rf))
c
	  if (rt.gt.1.0) rt=1.0
	  if (rp.gt.1.0) rp=1.0
	  if (rq.gt.1.0) rq=1.0
c
	  if     (i.eq.0) then
	    rgb(1)=int(0.5 + 1.*255.0)
	    rgb(2)=int(0.5 + rt*255.0)
	    rgb(3)=int(0.5 + rp*255.0)
	  elseif (i.eq.1) then
            rgb(1)=int(0.5 + rq*255.0)
            rgb(2)=int(0.5 + 1.*255.0)
            rgb(3)=int(0.5 + rp*255.0)
          elseif (i.eq.2) then
            rgb(1)=int(0.5 + rp*255.0)
            rgb(2)=int(0.5 + 1.*255.0)
            rgb(3)=int(0.5 + rt*255.0)
          elseif (i.eq.3) then
            rgb(1)=int(0.5 + rp*255.0)
            rgb(2)=int(0.5 + rq*255.0)
            rgb(3)=int(0.5 + 1.*255.0)
          elseif (i.eq.4) then
            rgb(1)=int(0.5 + rt*255.0)
            rgb(2)=int(0.5 + rp*255.0)
            rgb(3)=int(0.5 + 1.*255.0)
          elseif (i.eq.5) then
            rgb(1)=int(0.5 + 1.*255.0)
            rgb(2)=int(0.5 + rp*255.0)
            rgb(3)=int(0.5 + rq*255.0)
	  endif
c
	  write (ccc(ifarb),1000) (rgb(j),j=3,1,-1)
	  do ii=1,6
	    if (ccc(ifarb)(ii:ii).eq.' ') ccc(ifarb)(ii:ii)='0'
	  enddo
c
	  write (cfarb(ifarb),1000) (rgb(j),j=3,1,-1)
	  do ii=1,6
	    if (cfarb(ifarb)(ii:ii).eq.' ') cfarb(ifarb)(ii:ii)='0'
	  enddo
	enddo
	do ifarb=256,2,-1
	  write (44,2000) ccc(ifarb)
	enddo
	close(44)
C
1000	format (3(z2))
2000	format('#',a6,'00')
	end
C*****7*****************************************************************
	subroutine do_output(value,laver)
c-
c	Writes output in standard or GNUPLOT format
c+
	implicit      none
c
	include       'config.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'errlist.inc'
	include       'output.inc'
	include       'diffuse.inc'
c
	integer        iff
	parameter     (iff=2)
c
	integer		HKLF4,LIST5,LIST9
	parameter	(HKLF4=6, LIST5=7 ,LIST9=8)
c
        integer        extr_ima,i,j,k,value
	logical        lread,laver
	real           h(3)
	real           sq,qq,out_fac
c
	integer        shel_inc(2)
	integer        shel_value
	real           shel_eck(3,3)
	real           shel_vi(3,2)
	real           shel_000
	complex        shel_csf
	complex        shel_acsf
	real           shel_dsi
	complex        shel_tcsf
	real           factor
c
	real           qval
c
c------	If output type is shelx, calculate qval(000) for scaling
c
	if(ityp.eq.HKLF4 .or. ityp.eq.LIST5 ) then
	  do i=1,2
	    shel_inc(i) = inc(i)
	  enddo
	  do i=1,3
	    do j=1,3
	      shel_eck(i,j) = eck(i,j)
	    enddo
	    do j=1,2
	      shel_vi(i,j) = vi(i,j)
	    enddo
	  enddo
	  shel_tcsf =  csf(1)
	  shel_acsf = acsf(1)
	  shel_dsi  =  dsi(1)
	  inc(1) = 1
	  inc(2) = 1
	  do i=1,3
	    do j=1,3
	      eck(i,j) = 0.0
	    enddo
	    do j=1,2
	      vi(i,j) = 0.0
	    enddo
          enddo
	  call four_run
	  shel_csf = csf(1)
	  shel_000 = qval(1,value,1,1,laver)
	        qq = qval(1,value,1,1,laver)/cr_icc(1)/cr_icc(2)/
     &	               cr_icc(3) 
	  if(ityp.eq.HKLF4) then
	    factor     = max(int(log(qq)/log(10.0))-4,0)
	  elseif(ityp.eq.LIST5) then
	    factor     = max(int(log(qq)/log(10.0))-2,0)
	  endif
	  out_fac = 10**(-factor)
	  csf(1)   = shel_tcsf
	  acsf(1)  = shel_acsf
	  dsi(1)   = shel_dsi
	  do i=1,2
	    inc(i) = shel_inc(i)
	  enddo
	  do i=1,3
	    do j=1,3
	      eck(i,j) = shel_eck(i,j)
	    enddo
	    do j=1,2
	      vi(i,j) = shel_vi(i,j)
	    enddo
	  enddo
	endif
c
        extr_ima = 6 - out_extr_abs - out_extr_ord
c
	lread = .false.
	call oeffne(iff,outfile,'unknown',lread)
	if(ier_num.eq.0) then
	  if(out_inc(1).gt.1 .and. out_inc(2).gt.1) then
	    if(ityp.eq.0) then
	      write(iff,*) out_inc
	      write(iff,*) out_eck(out_extr_abs,1),
     &	                   out_eck(out_extr_abs,2),
     &	                   out_eck(out_extr_ord,1),
     &	                   out_eck(out_extr_ord,3)
	      do j=1,out_inc(2)
	        write(iff,4) (qval((i-1)*out_inc(2)+j,value,i,j,laver),
     &	                      i=1,out_inc(1))
	        write(iff,100)
	      enddo
	    elseif(ityp.eq.HKLF4) then
	      do j=1,out_inc(2)
	        do i=1,out_inc(1)
                  do k=1,3
                    h(k)=out_eck(k,1) + out_vi(k,1)*float(i-1)
     &	                          + out_vi(k,2)*float(j-1)
	          enddo
	          k = (i-1)*out_inc(2)+j
	          qq = qval(k,value,i,j,laver)/cr_icc(1)/cr_icc(2)/
     &	               cr_icc(3) * out_fac
	          sq = sqrt(qq)
	          write(iff,7) int(h(1)),int(h(2)),int(h(3)),
     &	                       qq,sq
	        enddo
	      enddo
	    elseif(ityp.eq.LIST5) then
	      shel_value = 3
	      do j=1,out_inc(2)
	        do i=1,out_inc(1)
                  do k=1,3
                    h(k)=out_eck(k,1) + out_vi(k,1)*float(i-1)
     &	                          + out_vi(k,2)*float(j-1)
	          enddo
	          k = (i-1)*out_inc(2)+j
	          shel_value = 2
	          qq = qval(k,value,i,j,laver)/cr_icc(1)/cr_icc(2)/
     &	               cr_icc(3) * out_fac
	          shel_value = 3
	          sq = qval(k,shel_value,i,j,laver)/cr_icc(1)/cr_icc(2)/
     &	               cr_icc(3) * out_fac
	          write(iff,8) h(1),h(2),h(3),
     &	                       qq,qq,sq
	        enddo
	      enddo
	    elseif(ityp.eq.LIST9) then
	      shel_value = 3
	      do j=1,out_inc(2)
	        do i=1,out_inc(1)
                  do k=1,3
                    h(k)=out_eck(k,1) + out_vi(k,1)*float(i-1)
     &	                          + out_vi(k,2)*float(j-1)
	          enddo
	          k = (i-1)*out_inc(2)+j
	          shel_value = 2
	          qq = qval(k,value,i,j,laver)/cr_icc(1)/cr_icc(2)/
     &	               cr_icc(3)
	          shel_value = 3
	          sq = qval(k,shel_value,i,j,laver)/cr_icc(1)/cr_icc(2)/
     &	               cr_icc(3)
	          write(iff,9) int(h(1)),int(h(2)),int(h(3)),
     &	                       qq,qq,sq
	        enddo
	      enddo
	    else
	      do j=1,out_inc(2)
	        do i=1,out_inc(1)
                  do k=1,3
                    h(k)=out_eck(k,1) + out_vi(k,1)*float(i-1)
     &	                          + out_vi(k,2)*float(j-1)
	          enddo
	          k = (i-1)*out_inc(2)+j
	          write(iff,5) h(out_extr_abs),h(out_extr_ord),
     &	                       qval(k,value,i,j,laver),
     &	                       h(extr_ima)
	        enddo
	        write(iff,100)
	      enddo
	    endif
	  elseif(out_inc(1).eq.1) then
	    i = 1
	    do j=1,out_inc(2)
              do k=1,3
                h(k)=out_eck(k,1) + out_vi(k,1)*float(i-1)
     &	                          + out_vi(k,2)*float(j-1)
	      enddo
	      k = (i-1)*out_inc(2)+j
	      if(ityp.eq.HKLF4) then
	        qq = qval(k,value,i,j,laver)/cr_icc(1)/cr_icc(2)/
     &	             cr_icc(3) * out_fac
	        sq = sqrt(qq)
	        write(iff,7) int(h(1)),int(h(2)),int(h(3)),
     &	                     qq,sq
	      elseif(ityp.eq.LIST5) then
	        shel_value = 2
	        qq = qval(k,value,i,j,laver)/cr_icc(1)/cr_icc(2)/
     &	             cr_icc(3) * out_fac
	        shel_value = 3
	        sq = qval(k,shel_value,i,j,laver)/cr_icc(1)/cr_icc(2)/
     &	             cr_icc(3) * out_fac
	        write(iff,8) int(h(1)),int(h(2)),int(h(3)),
     &	                     qq,qq,sq
	      elseif(ityp.eq.LIST9) then
	        shel_value = 2
	        qq = qval(k,value,i,j,laver)/cr_icc(1)/cr_icc(2)/
     &	             cr_icc(3)
	        shel_value = 3
	        sq = qval(k,shel_value,i,j,laver)/cr_icc(1)/cr_icc(2)/
     &	             cr_icc(3)
	        write(iff,9) h(1),h(2),h(3),
     &	                     qq,qq,sq
	      else
	        write(iff,6) h(out_extr_ord),qval(k,value,i,j,laver)
	      endif
	    enddo
	  elseif(out_inc(2).eq.1) then
	    j = 1
	    do i=1,out_inc(1)
              do k=1,3
                h(k)=out_eck(k,1) + out_vi(k,1)*float(i-1)
     &	                          + out_vi(k,2)*float(j-1)
	      enddo
	      k = (i-1)*out_inc(2)+j
	      if(ityp.eq.HKLF4) then
	        qq = qval(k,value,i,j,laver)/cr_icc(1)/cr_icc(2)/
     &	             cr_icc(3) * out_fac
	        sq = sqrt(qq)
	        write(iff,7) int(h(1)),int(h(2)),int(h(3)),
     &	                     qq,sq
	      elseif(ityp.eq.LIST5) then
	        shel_value = 2
	        qq = qval(k,value,i,j,laver)/cr_icc(1)/cr_icc(2)/
     &	             cr_icc(3) * out_fac
	        shel_value = 3
	        sq = qval(k,shel_value,i,j,laver)/cr_icc(1)/cr_icc(2)/
     &	             cr_icc(3) * out_fac
	        write(iff,8) int(h(1)),int(h(2)),int(h(3)),
     &	                     qq,qq,sq
	      elseif(ityp.eq.LIST9) then
	        shel_value = 2
	        qq = qval(k,value,i,j,laver)/cr_icc(1)/cr_icc(2)/
     &	             cr_icc(3)
	        shel_value = 3
	        sq = qval(k,shel_value,i,j,laver)/cr_icc(1)/cr_icc(2)/
     &	             cr_icc(3)
	        write(iff,9) h(1),h(2),h(3),
     &	                     qq,qq,sq
	      else
	        write(iff,6) h(out_extr_abs),qval(k,value,i,j,laver)
	    endif
	    enddo
	  endif
	endif
c	if(ier_num.ne.0) then
c	  call errlist
c	endif
	close(iff)
c
4	format(5(1x,e11.5))
5	format(4(1x,e11.5))
6	format(2(1x,e11.5))
7	format(3i4,2f8.2)
8	format(3i4,2f10.2,f7.2)
9	format(3(f10.6,1x),2(e11.5,1x),f7.2)
100	format( )
c100	format(/)
c
	end
C*****7*****************************************************************
	real function qval(i,value,ix,iy,laver)
c-
c	transforms the real and imaginary part of the Fourier transform
c	into the desired output format
c+
	implicit       none
c
	real           DELTA
	parameter     (DELTA = 0.000001)
c
	include       'config.inc'
	include       'output.inc'
	include       'random.inc'
	include       'diffuse.inc'
c
	integer        i,value,ix,iy
	integer        k
c
	complex	       f
	real           h(3)
c
	real           atan2d
	real           ran1
	logical	       laver
c
c------ Get values of F or <F> 
c
	if (laver) then
	  f = acsf(i)
	else
	  f =  csf(i)
	endif
c
c------	Calculate intensity 'intensity'
c
c------ We have to store dsi() here, because if lots are
c------ used, csf() will only contain the values for the
c------ last lot !!
c
        if    (value .eq. 1) then
           if (laver) then
             qval = real(f*conjg(f))
           else
             qval = dsi(i)
           endif
c
c------	Calculate amplitude 'amplitude'
c
	elseif(value .eq. 2) then
	   qval = sqrt(real(f*conjg(f)))
c
c------	Calculate phase 'phase'
c
	elseif(value .eq. 3) then
	  if(f.eq.(0,0)) then
	    qval = 0.0
	  else
	    qval = atan2d(aimag(f),real(f))
	  endif
c
c------	Calculate real part 'real'
c
	elseif(value .eq. 4) then
	   qval = real(f)
c
c------	Calculate imaginary part 'imaginary'
c
	elseif(value .eq. 5) then
	   qval = aimag(f)
c
c------	Calculate phase 'phase', random, except for integer hkl
c
	elseif(value .eq. 6) then
          do k=1,3
            h(k)=out_eck(k,1) + out_vi(k,1)*float(ix-1)
     &	                      + out_vi(k,2)*float(iy-1)
	  enddo
	  if(abs(h(1)-nint(h(1))).lt.DELTA .and.
     &	     abs(h(2)-nint(h(2))).lt.DELTA .and.
     &	     abs(h(3)-nint(h(3))).lt.DELTA       ) then
	    if(f.eq.(0,0)) then
	      qval = 0.0
	    else
	      qval = atan2d(aimag(f),real(f))
	    endif
	  else
	    qval = (ran1(idum)-0.5) * 360.
	  endif
	endif
c
	end
C*****7*****************************************************************
	subroutine set_output(linverse)
c-
c	Sets the proper output values for either Fourier or
c	inverse Fourier and Patterson	
c+
	implicit       none
c
	include       'config.inc'
	include       'output.inc'
	include       'patters.inc'
	include       'diffuse.inc'
c
	logical        linverse
c
	integer        i,j
c
	if(linverse) then
	  out_extr_abs = rho_extr_abs
	  out_extr_ord = rho_extr_ord
c
	  do i=1,3
	    do j=1,3
	      out_eck(i,j) = rho_eck(i,j)
	    enddo
	  enddo
c
	  do i=1,2
	    do j=1,3
	      out_vi(j,i) = rho_vi(j,i)
	    enddo
	    out_inc(i) = rho_inc(i)
	  enddo
	else
	  out_extr_abs = extr_abs
	  out_extr_ord = extr_ord
c
	  do i=1,3
	    do j=1,3
	      out_eck(i,j) = eck(i,j)
	    enddo
	  enddo
c
	  do i=1,2
	    do j=1,3
	      out_vi(j,i) = vi(j,i)
	    enddo
	    out_inc(i) = inc(i)
	  enddo
	endif
c
	end
C*****7*****************************************************************
