c*****7*****************************************************************
	subroutine mache_kdo(line,lend,length)
c+
c	This is the main routine for command interpretation, each
c	command is identified here and the corresponding subroutine
c	executed. A leading @ indicates a macro.
c
c	Version : 1.0
c	Date    : 29 Sep 96
c
c       Authors : Th. Proffen (tproffen@lanl.gov)
c                 R.B. Neder  (reinhard.neder@mail.uni-wuerzburg.de)
c-
	implicit      none
c
	include      'learn.inc'
	include      'errlist.inc'
	include      'inverse.inc'
c
	integer       maxw
	parameter    (maxw=1)
c
	character*200 line,zeile
	character*70  command
	character*5   befehl
	integer       length
	integer       indxb,indxg,lcomm,lbef
	logical       lend,lout_rho,lkick
	logical       str_comp
c
	save          command
c
	data          lout_rho/.false./
c
	call no_error
c
c-------If a commentary return immediately
c
	if(line(1:1).EQ.' ' .or. line(1:1).eq.'#' .or. 
     &	   line(1:1).eq.'!' .or. length.eq.0           ) RETURN
c
c------	Only the first 5 characters are significant. The command consists
c	of the four nonblank characters 
c
	befehl = '    '
	indxb  = index(line,' ')
	lbef   = min(indxb-1,5)
	befehl = line(1:lbef )
c
c------	command parameters start at the first character following the blank
c
	zeile = ' '
	lcomm = 0
	if(indxb+1.le.length) then
	  zeile = line(indxb+1:length)
	  lcomm = length - indxb
	endif
C
C-------Suche nach einem "="
C
	indxg=index(line,'=')
        if(indxg.ne.0.and..not.(str_comp(befehl,'echo',2,lbef,4))
     &               .and..not.(str_comp(befehl,'syst',2,lbef,4))
     &               .and..not.(str_comp(befehl,'help',2,lbef,4) .or.
     &	                          str_comp(befehl,'?   ',2,lbef,4)) )then
C
C-------Zuweisung eines Funktionswertes
C
	  call do_math(line,indxg,length)
	else
c
c------	--execute a macro file
c
	  if(befehl(1:1).eq.'@') then
	    if(length.ge.2) then
	      call file_kdo(line(2:length),length-1)
	    else
	      ier_num = -13
	      ier_typ = ER_MAC
	    endif
c
c-------add two files 'addf'
c
	  elseif(str_comp(befehl,'addf',2,lbef,4)) then
	    call do_addfile(zeile,lcomm)
c
c------	append a new atom 'appe'
c
	  elseif(str_comp(befehl,'appe',2,lbef,4)) then
	    lkick = .false.
	    call do_app(zeile,lcomm,lkick)
c
c-------show the asymmetric unit 'asym'
c
	  elseif(str_comp(befehl,'asym',2,lbef,4)) then
	    call show_asym
c
c-------remove atomes outside a boundary 'boundary'
c
	  elseif(str_comp(befehl,'boundary',2,lbef,8)) then
	    call boundary(zeile,lcomm)
c
c-------show the atoms present in the crystal 'chem'
c
	  elseif(str_comp(befehl,'chem',2,lbef,4)) then
	    call chem
C
C-------copy an atom 'copy'
C
	  elseif(str_comp(befehl,'copy',3,lbef,4)) then
	    call do_copy(zeile,lcomm)
c
c------	Transform vector from direct to reciprocal space
c
	  elseif(str_comp(befehl,'d2r',2,lbef,3)) then
	    call d2r(zeile,lcomm,.true.)
c
c------	Difference  Fourier 'diff'
c
	  elseif(str_comp(befehl,'diff',2,lbef,4)) then
	    inverse_type = INV_DIFF
	    lout_rho     = .true.
            call patterson(inverse_type)
c
c-------Terminate DISCUS 'exit'
c
	  elseif(str_comp(befehl,'exit',2,lbef,4)) then
	    LEND=.TRUE.
c
c-------Find properties   'find'
c
	  elseif(str_comp(befehl,'find',2,lbef,4)) then
	    call do_find(zeile,lcomm)
c
c-------Fourier transform 'four'
c
	  elseif(str_comp(befehl,'four',2,lbef,4)) then
	    lout_rho = .false.
	    call fourier
c
c------	inserte a new atom 'inse'
c
	  elseif(str_comp(befehl,'inse',3,lbef,4)) then
	    call do_ins(zeile,lcomm)
c
c------	interpret an electron density 'interpret'
c
	  elseif(str_comp(befehl,'inte',3,lbef,4)) then
            call interpret
c
c------	inverse Fourier 'inverse'
c
	  elseif(str_comp(befehl,'inve',3,lbef,4)) then
	    inverse_type = INV_INV
	    lout_rho     = .true.
            call patterson(inverse_type)
c
c------	append a new atom while kicking out old atoms 'kick'
c
	  elseif(str_comp(befehl,'kick',2,lbef,4)) then
	    lkick = .true.
	    call do_app(zeile,lcomm,lkick)
c
c------	insert microdomains into the structure 'micr'
c
	  elseif(str_comp(befehl,'micr',1,lbef,4)) then
	    call do_micro
c
c------	Output routines 'outp'
c
	  elseif(str_comp(befehl,'outp',1,lbef,4)) then
	    call do_niplps(lout_rho)
c
c------	Patterson 'patterson'
c
	  elseif(str_comp(befehl,'patt',2,lbef,4)) then
	    inverse_type = INV_PATT
	    lout_rho     = .true.
            call patterson(inverse_type)
c
c------	PDF calculation and analysis
c
	  elseif(str_comp(befehl,'pdf',2,lbef,3)) then
	    call pdf
c
c------	Plot the crystal 'plot'
c
	  elseif(str_comp(befehl,'plot',2,lbef,4)) then
	    call plot
c
c------	Calculate Powder pattern
c
	  elseif(str_comp(befehl,'powder',2,lbef,6)) then
	    call do_powder
c
c------	Project a vector onto another and onto a plane 'proj'
c
	  elseif(str_comp(befehl,'proj',2,lbef,4)) then
	    call do_proj(zeile,lcomm)
c
c------	Purge the list of atoms 'purg'
c
	  elseif(str_comp(befehl,'purg',2,lbef,4)) then
	    call do_purge
c
c------	Transform vector from reciprocal to direct space
c
	  elseif(str_comp(befehl,'r2d',2,lbef,3)) then
	    call d2r(zeile,lcomm,.false.)
C
c-------Einlesen einer Struktur/Zelle 'read'
c
	  elseif(str_comp(befehl,'read',3,lbef,4)) then
	    call read_struc
c
c------	Remove a single atom 'remo'
c
	  elseif(str_comp(befehl,'remo',3,lbef,4)) then
	    call do_remove(zeile,lcomm)
c
c------	Replace atom(s) or molecule(s)
c
	  elseif(str_comp(befehl,'replace',3,lbef,7)) then
	    call do_replace(zeile,lcomm)
c
c------	Do Monte Carlo simulations 'rmc', 'mc', 'mmc' and 'amc'
c
	  elseif(str_comp(befehl,'rmc',2,lbef,3)) then
	    call rmc
	  elseif(str_comp(befehl,'mc',2,lbef,2)) then
	    call mc
	  elseif(str_comp(befehl,'mmc',2,lbef,3)) then
	    call mmc
c
c------	save structure to file 'save'
c
	  elseif(str_comp(befehl,'save',2,lbef,4)) then
	    call save_struc(zeile,lcomm)
c
c------	Reset the seed for the random number generator 'seed'
c
	  elseif(str_comp(befehl,'seed',3,lbef,4)) then
	    call do_seed(zeile,lcomm)
c
c------	Show something                                 'show'
c
	  elseif(str_comp(befehl,'show',2,lbef,4)) then
	    call do_show(zeile,lcomm)
c
c------	switch two atoms 'stack'
c
	  elseif(str_comp(befehl,'stac',2,lbef,4)) then
	    call stack
c
c------	switch two atoms 'swit'
c
	  elseif(str_comp(befehl,'swit',2,lbef,4)) then
	    call do_switch(zeile,lcomm)
c
c------	generalized symmetry operation 'symm'
c
	  elseif(str_comp(befehl,'symm',3,lbef,4)) then
	    call symm
c
c------	Thermal displacement of all atoms 'ther'
c
	  elseif(str_comp(befehl,'ther',2,lbef,4)) then
	    call ther_displ(zeile,lcomm)
c
c------	unit cell transformations      'tran'
c
	  elseif(str_comp(befehl,'tran',2,lbef,4)) then
	    call transform
c
c------	  Vector Product 'vprod'
c
	  elseif(str_comp(befehl,'vprod',1,lbef,5)) then
	    call vprod(zeile,lcomm)
c
c------   Waves traveling through the crystal 'wave'
c
	  elseif(str_comp(befehl,'wave',3,lbef,4)) then
	    call waves
c
c------   Try general commands
c
	  else
	    call kdo_all(befehl,lbef,zeile,lcomm)
	  endif
	endif
c
	end
c*****7****************************************************************
