c*****7*****************************************************************
	subroutine mc
c-
c	This sublevel includes all commands and functions for the
c	Monte-Carlo simulations in DISCUS. 
c
c	Version  : 1.00
c	Date     : 18. December 1997
c
c	Author   : Th. Proffen (tproffen@lanl.gov)
c
c+
	implicit	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'doact.inc'
	include 	'macro.inc'
	include 	'errlist.inc'
	include 	'learn.inc'
	include 	'param.inc'
	include 	'prompt.inc'
	include 	'mc.inc'
c
	integer		maxw
	parameter	(maxw=10)
c
	character*5    	befehl
	character*11   	prom
	character*40   	cdummy
	character*200  	line,zeile
	character*200	cpara(maxw)
	integer		lpara(maxw)
	integer        	lp,length
	integer        	indxg,lbef,ianz
	real		werte(maxw)
c
	integer		len_str
	logical         str_comp
c
10	continue
c
	call no_error
	prom=prompt//'/mc'
	call get_command (line,length,befehl,lbef,zeile,lp,prom)
	if(ier_num.eq.0) then
	if(line.eq.' '.or.line(1:1).eq.'#') goto 10
c
c------ search for "="
c
	indxg=index(line,'=')
	if(indxg.ne.0.and..not.(str_comp(befehl,'echo',2,lbef,4))
     &	             .and..not.(str_comp(befehl,'syst',2,lbef,4))
     &	             .and..not.(str_comp(befehl,'help',2,lbef,4) .or.
     &	                        str_comp(befehl,'?   ',2,lbef,4)) ) then
          call do_math(line,indxg,length)
c
c------ execute a macro file
c
        elseif(befehl(1:1).eq.'@') then
          call file_kdo(line(2:length),length-1)
c
c------ continues a macro 'continue'
c
        elseif(str_comp(befehl,'continue',3,lbef,8)) then
          call macro_continue(zeile,lp)
c
c------ Echo a string, just for interactive check in a macro 'echo'
c
	elseif(str_comp(befehl,'echo',2,lbef,4)) then
	  call echo(zeile,lp)
c
c------ Evaluate an expression
c
	elseif(str_comp(befehl,'eval',2,lbef,4)) then
	  call do_eval(zeile,lp)
c
c------	exit 'exit'
c
	elseif(str_comp(befehl,'exit',3,lbef,4)) then
	  goto 9999
c
c------	help 'help','?'
c
	elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	       str_comp(befehl,'?   ',1,lbef,4)     ) then
	  if(str_comp(zeile,'errors',2,lp,6) ) then
	    lp = lp + 7
	    call do_hel('discus '//zeile,lp)
	  else
	    lp = lp + 11
	    call do_hel('discus mc '//zeile,lp)
	  endif
c
c-------Operating System Kommandos 'syst'
c
	elseif(str_comp(befehl,'syst',2,lbef,4)) then
	  cdummy=' '
	  if(zeile.ne. ' ') then
	    cdummy(1:lp)=zeile(1:lp)
	    call do_operating(cdummy,lp)
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c------	Waiting for user input
c
	elseif(str_comp(befehl,'wait',3,lbef,4)) then
	  call do_input(zeile,lp)
c
c------ ------------------------------------------------------------
c------ Here start MC specific commands
c------ ------------------------------------------------------------
c
c------ command 'run'
c
	elseif(str_comp(befehl,'run',2,lbef,3)) then
	  call mc_run
c
c------ command 'save'
c
	elseif(str_comp(befehl,'save',2,lbef,4)) then
	  call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	  call do_build_name (ianz,cpara,lpara,werte,maxw,1)
	  if (ier_num.eq.0) then
	    write (output_io,1500) cpara(1)(1:len_str(cpara(1)))
	    call save_struc(cpara(1),lpara(1))
	  endif
c
c------ command 'set'
c
	elseif(str_comp(befehl,'set',2,lbef,3)) then
	  call mc_set(zeile,lp)
c
c------ command 'show'
c
	elseif(str_comp(befehl,'show',2,lbef,4)) then
	  call mc_show
c
c------ no command found
c
	else
	  ier_num = -8
	  ier_typ = ER_COMM
	endif
	endif
c
c------ any errors ?
c
	if(ier_num.ne.0) then
	  call errlist
	  if(lmakro) then
	    call macro_close
	    prompt_status = PROMPT_ON
	  endif
	  if(lblock) then
	    ier_num = -11
	    ier_typ = ER_COMM
	    return
	  endif
	  call no_error
	endif
	goto 10
c
9999	continue
c
1500    format (' Saving structure to file : ',a)
c
	end
c*****7*****************************************************************
	subroutine mc_show
c+
c	Show parameters of MC section
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'errlist.inc'
	include 	'chem.inc'
	include 	'rmc.inc'
	include 	'molecule.inc'
	include 	'mc.inc'
c
	character*200   zeile
	character*9 	at_name,at_name_i,at_name_j
	integer		i,j,k
c
c------ Information about MC running mode etc ..
c
	if (mo_mode.eq.rmc_mode_shift) then
	  write (output_io,1100) 'move atoms'
	elseif (mo_mode.eq.rmc_mode_swchem) then
	  write (output_io,1100) 'switch atoms'
	elseif (mo_mode.eq.rmc_mode_swdisp) then
	  write (output_io,1100) 'switch displacements'
	elseif (mo_mode.eq.rmc_mode_external) then
	  write (output_io,1100) 'defined in user supplied subroutine'
	else
	  write (output_io,1100) '??????????'
	endif
c
	if (mo_sel_atom) then
	  write (output_io,1105) 'atoms'
	else
	  write (output_io,1105) 'molecules'
	endif
c
	if (mo_energy.eq.mc_none) then
	  write (output_io,1110) 'not defined'
	elseif (mo_energy.eq.mc_occ) then
	  write (output_io,1110) 'correlations occupational'
	elseif (mo_energy.eq.mc_disp) then
	  write (output_io,1110) 'correlations displacements'
	elseif (mo_energy.eq.mc_spring) then
	  write (output_io,1110) 'distortions (Hookes law)'
	elseif (mo_energy.eq.mc_angle) then
	  write (output_io,1110) 'angular distortions'
	else
	  write (output_io,1110) '??????????'
	endif
c	
	if (mo_local.eq.rmc_local_all) then
	  write (output_io,1120) 'all'
	elseif (mo_local.eq.rmc_local_loc) then
	  write (output_io,1120) 'only local (+-1 unit cell)'
	elseif (mo_local.eq.rmc_local_locsite) then
	  write (output_io,1120) 'only local, same site'
	elseif (mo_local.eq.rmc_local_site) then
	  write (output_io,1120) 'all, same site'
	else
	  write (output_io,1120) '??????????'
	endif
c
	write (output_io,1250) mo_cyc
	write (output_io,1300) mo_feed
	write (output_io,1400) mo_kt
c
c------ Information about target values, constants etc ..
c
	write (output_io,2000) mo_const(0)
	do i=1,chem_ncor
	  write (output_io,2100) i,mo_const(i),mo_cfac(i),mo_ach_corr(i),
     &	                 mo_target_corr(i)
	enddo
c
c------ Information about defined correlations etc ..
c
	write (output_io,3000)
	zeile = 'corr'
	call chem_show(zeile)
c
c------ Information about defined desired distances
c
	if (mo_mode.eq.MC_SPRING) then
	  write (output_io,4000)
c
	  if (mo_sel_atom) then
	    do i=0,cr_nscat
	      do j=i,cr_nscat
	        at_name_i=at_name(i)
	        at_name_j=at_name(j)
	        do k=1,chem_ncor
	          if (mo_disp(k,i,j).ne.0.0) 
     &	            write (output_io,4100) at_name_i,at_name_j,k,
     &	                                   mo_disp(k,i,j)
	        enddo
	      enddo
	    enddo
	  else
	    do i=1,mole_num_type
	      do j=i,mole_num_type
	        do k=1,chem_ncor
	          if (mo_disp(k,i,j).ne.0.0) 
     &	            write (output_io,4200) i,j,k,mo_disp(k,i,j)
	        enddo
	      enddo
	    enddo
	  endif
	endif
c
c------ Maxmove settings in 'shift' mode
c
	if (mo_mode.eq.rmc_mode_shift .and. 
     &	   (mo_energy.eq.mc_disp .or. mo_energy.eq.mc_spring)) then
	  write (output_io,4300)
	  if (mo_sel_atom) then
	    do i=1,cr_nscat
	      at_name_i = at_name(i)
	      write (output_io,4310) at_name_i,(mo_maxmove(j,i),j=1,3)
	    enddo
	  else
	    do i=1,mole_num_type
	      write (output_io,4320) i,(mo_maxmove(j,i),j=1,3)
	    enddo
	  endif
	endif
c
1100	format (  ' MC running mode                : ',a)
1105	format (  '   Operation mode for MC        : ',a)
1110	format (  '   Energy calculation mode      : ',a)
1120	format (  '   Valid neighbours             : ',a)
1250	format (  '   Max. number of MC cycles     : ',i8)
1300	format (  '   Feedback/update intervall    : ',i8)
1400	format (  '   Temperature [kT]             : ',f8.4)
2000	format (/,' MC settings (C(0)=',f10.3,')  : ',//,
     &	        '    #',4x,'interaction',2x,'factor',5x,'curr. corr.',
     &	             2x,'target corr.',/,3x,55('-'))
2100	format (3x,i3,4x,f10.3,2x,f6.3,7x,f6.3,7x,f6.3)
3000	format (/,' Correlation definitions        : ',/)
4000	format (/,' Desired distortions for SPRING : ',/)
4100	format (  '   Atoms : ',a9,' - ',a9,'  neig. #',i3,
     &	          '   distance : ',f7.3,' A')
4200	format (  '   Molecule types : ',i4,' - ',i4,'  neig. #',i3,
     &	          '   distance : ',f7.3,' A')
4300	format (/,' Sigmas for MC shifts (l.u.)    : ')
4310	format (  '                 Atom ',a9,' : ',3(F7.3,1X))
4320	format (  '        Molecule type ',i9,' : ',3(F7.3,1X))
	end
c*****7*****************************************************************
	subroutine mc_set (zeile,lp)
c+
c	sets parameters for MC section
c-
	implicit	none
c
	include		'config.inc'
	include		'errlist.inc'
	include 	'chem.inc'
	include 	'mc.inc'
c
	integer		maxw
	parameter	(maxw=20)
c
	character*200 	zeile
	integer		lp
c
	character*200	cpara(maxw)
	real		uerte(maxw)
	real		verte(maxw)
	real		werte(maxw)
	integer		lpara(maxw)
	integer		ianz,iianz,jjanz,kkanz,is,js,ic,i,j
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.eq.0) then
	  if (ianz.ge.2) then
	    call do_cap(cpara(1))
c
c------ --- 'set atom': setting of atoms to be taken for MC 
c
            if(cpara(1)(1:2).eq.'AT' .or. 
     &	       cpara(1)(1:3).eq.'MOL') then
	      if (ianz.eq.3) then
	        mo_sel_atom = (cpara(1)(1:2).eq.'AT')
	        mo_atom(1)  = cpara(2)(1:lpara(2))
	        mo_atom(2)  = cpara(3)(1:lpara(3))
	      elseif (ianz.eq.4) then
	        mo_sel_atom = (cpara(1)(1:2).eq.'AT')
	        mo_atom(1)  = cpara(2)(1:lpara(2))
	        mo_atom(2)  = cpara(3)(1:lpara(3))
	        mo_atom(3)  = cpara(4)(1:lpara(4))
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ --- 'set angle' : setting of neighbouring angles
c
            elseif(cpara(1)(1:2).eq.'AN') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call chem_set_angle (ianz,cpara,lpara,werte,maxw)
c
c------ --- 'set envir' : setting of neighbouring environment
c
            elseif(cpara(1)(1:3).eq.'ENV') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call chem_set_envir (ianz,cpara,lpara,werte,maxw)
c
c------ --- 'set const': setting interactions and feedback factor
c
            elseif(cpara(1)(1:3).eq.'CON') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call ber_params (ianz,cpara,lpara,werte,maxw)
	      if (ier_num.ne.0) return
	      if (ianz.eq.2 .or. ianz.eq.3) then
	        ic = nint(werte(1))
	        if (ic.ge.0 .and. ic.le.chem_ncor) then
	          mo_const(ic)=werte(2)
	          if (ianz.eq.3) mo_cfac(ic)=werte(3)
	        else
	          ier_num = -14
	          ier_typ = ER_CHEM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ --- 'set cyc' : setting number of MC moves
c
            elseif(cpara(1)(1:2).eq.'CY') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call ber_params (ianz,cpara,lpara,werte,maxw)
	      mo_cyc = nint(werte(1))
c
c------ --- 'set energy' : setting of energy expression
c
            elseif(cpara(1)(1:3).eq.'ENE') then
	      call del_params (1,ianz,cpara,lpara,maxw)
c
	      if (ianz.ge.1) then
	        call do_cap(cpara(1))
	        if     (cpara(1)(1:2).eq.'CO') then
	          mo_energy = MC_OCC
	        elseif (cpara(1)(1:2).eq.'CD') then
	          mo_energy = MC_DISP
	        elseif (cpara(1)(1:2).eq.'DI') then
	          mo_energy = MC_SPRING
	        elseif (cpara(1)(1:2).eq.'AN') then
	          mo_energy = MC_ANGLE
	        else
	          ier_num = -1
	          ier_typ = ER_MC
	          return
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ --- 'set feed' : setting display/feedback intervall
c
            elseif(cpara(1)(1:2).eq.'FE') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call ber_params (ianz,cpara,lpara,werte,maxw)
	      mo_feed = nint(werte(1))
c
c------ --- 'set mode': sets operation mode for MC
c
	    elseif(cpara(1)(1:3).eq.'MOD') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      if (ier_num.ne.0) return
	      call rmc_set_mode(mo_mode,mo_local,ianz,cpara,lpara,maxw)
c
c------ --- 'set move': sets maxmove for shift MC mode
c
	    elseif(cpara(1)(1:3).eq.'MOV') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      if (ier_num.ne.0) return
	      call rmc_set_move(mo_maxmove,mo_sel_atom,ianz,cpara,
     &	                        werte,lpara,maxw)
c
c------ --- 'set neig': setting correlation determination method
c
            elseif(cpara(1)(1:2).eq.'NE') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call chem_set_neig (ianz,cpara,lpara,werte,maxw)
c
c------ --- 'set target' : setting of target correlations
c
            elseif(cpara(1)(1:2).eq.'TA') then
	      if (ianz.ge.3) then
	        call del_params (1,ianz,cpara,lpara,maxw)
	        call ber_params (1,cpara,lpara,werte,maxw)
	        ic = nint(werte(1))
	        if (ic.gt.0 .and. ic.le.chem_ncor) then
	          if (ianz.eq.2) then
	            call del_params (1,ianz,cpara,lpara,maxw)
	            call ber_params (1,cpara,lpara,werte,maxw)
	            mo_target_corr(ic) = werte(1)
	          elseif (ianz.eq.4) then
	            call del_params (1,ianz,cpara,lpara,maxw)
	            iianz = 1
	            jjanz = 1
	            call get_iscat(iianz,cpara,lpara,uerte,
     &	                           maxw,.false.)
	            call del_params(1,ianz,cpara,lpara,maxw)
	            call get_iscat(jjanz,cpara,lpara,verte,
     &	                           maxw,.false.)
	            call del_params (1,ianz,cpara,lpara,maxw)
	            call ber_params (1,cpara,lpara,werte,maxw)
	            do i=1,iianz
	              do j=1,jjanz
	                is=nint(uerte(i))
	                js=nint(verte(j))
	                call mc_set_disp(ic,is,js,werte(1))
	              enddo
	            enddo
	          elseif (ianz.eq.5) then
c
c------	------------Three atom names are listed on the traget instruction
c	            Required for angular correlations
c
	            call del_params (1,ianz,cpara,lpara,maxw)
	            iianz = 1
	            jjanz = 1
	            kkanz = 1
	            call get_iscat(iianz,cpara,lpara,uerte,
     &	                           maxw,.false.)
	            call del_params(1,ianz,cpara,lpara,maxw)
	            call get_iscat(jjanz,cpara,lpara,uerte,
     &	                           maxw,.false.)
	            call del_params (1,ianz,cpara,lpara,maxw)
	            call get_iscat(kkanz,cpara,lpara,verte,
     &	                           maxw,.false.)
	            call del_params (1,ianz,cpara,lpara,maxw)
	            call ber_params (1,cpara,lpara,werte,maxw)
	            do i=1,jjanz
	              do j=1,kkanz
	                is=nint(uerte(i))
	                js=nint(verte(j))
	                call mc_set_disp(ic,is,js,werte(1))
	              enddo
	            enddo
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        else
	          ier_num = -14
	          ier_typ = ER_CHEM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ --- 'set temp' : setting kT for MC simulation
c
            elseif(cpara(1)(1:2).eq.'TE') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call ber_params (ianz,cpara,lpara,werte,maxw)
	      mo_kt = werte(1)
c
c------ --- 'set vector' : setting of neighbouring vectors
c
            elseif(cpara(1)(1:2).eq.'VE') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call chem_set_vec (ianz,cpara,lpara,werte,maxw)
c
c------ --- no valid subcommand
c
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	endif
c
	end
c*****7*****************************************************************
	subroutine mc_set_disp(ic,is,js,dist)
c+
c	Set desired displacements
c-
c
	implicit      none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
	include 	'mc.inc'
c
	integer		ic,is,js,ii,jj
	real		dist
c

	if     (is.ne.-1 .and. js.ne.-1) then
	  mo_disp(ic,is,js) = dist
	  mo_disp(ic,js,is) = dist
	elseif (is.eq.-1 .and. js.ne.-1) then
	  do ii=0,cr_nscat
	    mo_disp(ic,ii,js) = dist
	    mo_disp(ic,js,ii) = dist
	  enddo  
	elseif (is.ne.-1 .and. js.eq.-1) then
	  do ii=0,cr_nscat
	    mo_disp(ic,ii,is) = dist
	    mo_disp(ic,is,ii) = dist
	  enddo  
	else
	  do ii=0,cr_nscat
	    do jj=0,cr_nscat
	      mo_disp(ic,ii,jj) = dist
	      mo_disp(ic,jj,ii) = dist
	    enddo
	  enddo  
	endif  
c
	end
c*****7*****************************************************************
	subroutine mc_run
c+
c	This is the main MC routine
c-
	implicit	none
c
	include		'config.inc'
	include		'errlist.inc'
	include		'mc.inc'
c
	character*1	a
c
	if(mo_cyc.le.0) then
	  ier_num = -4
	  ier_typ = ER_MC
	  return
	endif
c
	if(mo_feed.le.0) then
	  ier_num = -5
	  ier_typ = ER_MC
	  return
	endif
c
c------ Correlation occupational mode
c
	if     (mo_energy.eq.MC_OCC) then
	  if (mo_sel_atom) then
	    call mc_run_occ
	  else
	    call mc_run_occ_mol
	  endif
c
c------ Correlation displacement mode
c
	elseif (mo_energy.eq.MC_DISP) then
	  if (mo_sel_atom) then
	    call mc_run_dis
	  else
	    call mc_run_dis_mol
	  endif
c
c------ Spring mode
c
	elseif (mo_energy.eq.MC_SPRING) then
	  if (mo_sel_atom) then
	    call mc_run_spring
	  else
	    call mc_run_spring_mol
	  endif
c
c------ Angular mode
c
	elseif (mo_energy.eq.MC_ANGLE) then
	  if (mo_sel_atom) then
	    call mc_run_angle
	  endif
c
	else
	  ier_num = -1
	  ier_typ = ER_MC
	endif
c
	call update_cr_dim
c
	end
c*****7*****************************************************************
	subroutine mc_run_occ
c+
c	This is the MC routine for occupational correlations
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'random.inc'
	include		'errlist.inc'
	include		'chem.inc'
	include		'rmc.inc'
	include		'mc.inc'
c
	integer		maxw
	parameter	(maxw = MAXSCAT)
c
	character*200	cpara(maxw)
	integer		lpara(maxw)
	real		werte(maxw),wwerte(maxw)
	real		e_old,e_new
	real		start,zeit,seknds
	integer		igen,itry,iacc_good,iacc_bad
	integer		isel(chem_max_atom)
	integer		latom(2)
	integer		iscat,is1,is2,iz1(3),iz2(3)
	integer		i,natoms,ianz,janz,l
	integer         lbeg(3)
	integer         zh,zm,zs
	logical		loop,laccept,done
c
	real		mc_energy_occ
	logical		atom_allowed
	integer		len_str
c
c------ check for valid input and settings
c
	if (mo_mode.ne.rmc_mode_swchem) then
	  ier_num = -3
	  ier_typ = ER_MC
	  return
	endif
c
c------ reset some counters
c
	igen      = 0
	itry      = 0
	iacc_good = 0
	iacc_bad  = 0
	loop      = .true.
	done      = .true.
	lbeg(1)   = -1
	lbeg(2)   =  0
	lbeg(3)   =  0
c
	latom(1)  = len_str(mo_atom(1))
	latom(2)  = len_str(mo_atom(2))
c
	write (output_io,1000) (cr_icc(i),i=1,3),cr_natoms
c
c------ Setup atom arrays
c
	ianz     = 1
	cpara(1) = mo_atom(1)
	lpara(1) = latom(1)
c
	call get_iscat(ianz,cpara,lpara, werte,maxw,.false.)
c
	janz     = 1
	cpara(1) = mo_atom(2)
	lpara(1) = latom(2)
c
	call get_iscat(janz,cpara,lpara,wwerte,maxw,.false.)
	if (ier_num.ne.0) return
c
c------ Obtain starting interactions
c
	l = 2
	call chem_corr_occ(l,mo_atom,latom,2,.false.,lbeg  )
	do i=1,chem_ncor
	  mo_const(i) = mo_const(i) - mo_cfac(i)*
     &	                ((mo_target_corr(i)-mo_ach_corr(i))/2.)
	enddo
c
c------ Main MC loop here
c
	start = seknds(0.0)
	do while (loop)
	  laccept = .true.
	  igen = igen + 1
c
	  natoms  = 2
	  call rmc_select (mo_local,natoms,isel,iz1,iz2,is1,is2)
	  laccept = atom_allowed(isel(1), werte,ianz,maxw) .and.
     &	            atom_allowed(isel(2),wwerte,janz,maxw) .and.
     &	            cr_iscat(isel(1)).ne.cr_iscat(isel(2))
c
	  if (laccept) then
	    itry = itry + 1
	    done = .false.
c
c------ --- Calc energy 
c
	    e_old = mc_energy_occ(natoms,isel,ianz,werte,maxw)
c
	    iscat             = cr_iscat(isel(2))
	    cr_iscat(isel(2)) = cr_iscat(isel(1))
	    cr_iscat(isel(1)) = iscat
c
	    e_new = mc_energy_occ(natoms,isel,ianz,werte,maxw)
	    if (ier_num.ne.0) return
c
c------ --- Test and accept/reject move
c
	    call mc_test(iacc_good,iacc_bad,e_new,e_old,laccept)
	    if (.not.laccept) then
	      iscat             = cr_iscat(isel(2))
	      cr_iscat(isel(2)) = cr_iscat(isel(1))
	      cr_iscat(isel(1)) = iscat
	    endif
	  endif
c
	  loop = (itry.lt.mo_cyc)
c
	  if (igen.gt.1000*mo_feed .and. itry.eq.0) then
	    ier_num = -2
	    ier_typ = ER_MC
	    loop    = .false.
	  endif
c
c-------  Feedback ?
c
	  if (mod(itry,mo_feed).eq.0 .and. .not.done .and. loop) then
	    l = 2
	    call chem_corr_occ(l,mo_atom,latom,2,.false.,lbeg  )
	    write (output_io,2000) igen,itry,iacc_good,iacc_bad
	    do i=1,chem_ncor
	      write (output_io,2100) i,mo_const(i),mo_ach_corr(i),
     &	                     mo_target_corr(i)
	      mo_const(i) = mo_const(i) - mo_cfac(i)*
     &	                    ((mo_target_corr(i)-mo_ach_corr(i))/2.)
	    enddo
	    done = .true.
	  endif
	enddo
c
c------ Loop finished
c
	write (output_io,3000)
	l = 2
	call chem_corr_occ(l,mo_atom,latom,2,.false.,lbeg  )
	write (output_io,2000) igen,itry,iacc_good,iacc_bad
	do i=1,chem_ncor
	  write (output_io,2100) i,mo_const(i),mo_ach_corr(i),
     &	                 mo_target_corr(i)
	enddo
c
c------ Write timing results
c
	zeit = seknds(start)
	zh = int (zeit / 3600.)
	zm = int ((zeit - zh*3600.) / 60.)
	zs = int ( zeit - zh*3600 - zm*60.)
	write (output_io,4000) zh,zm,zs,zeit/itry
c
1000    format (' Running MC simulation ...',//
     &          ' Size of model crystal     : ',I3,' x ',I3,' x ',I3,
     &          ' containing ',I9,' atoms')
2000	format (/,' Gen: ',I8,' try: ',I8,' acc: (good/bad): ',I7,
     &	          ' / ',I7,'  MC moves ')
2100	format ('    Neig. ',i3,'  const: ',f10.3,'   achieved: ',f6.3,
     &	          '  target: ',f6.3)
3000	format (/,' --- Final configuration ---')
4000	format (/,' Elapsed time : ',I4,' h ',I2,' min ',I2,' sec ',/
     &	          ' Time/cycle   : ',F9.3,' sec',/)
c
	end
c*****7*****************************************************************
	subroutine mc_run_occ_mol
c+
c	This is the MC routine for occupational correlations
c	Molecules version ..
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'random.inc'
	include		'errlist.inc'
	include		'chem.inc'
	include		'molecule.inc'
	include		'rmc.inc'
	include		'mc.inc'
c
	integer		maxw
	parameter	(maxw = MAXSCAT)
c
	real		e_old,e_new
	real		start,zeit,seknds
	real		mol(2)
	integer		igen,itry,iacc_good,iacc_bad
	integer		i,imol(2),mtyp(2),amol(2),latom(2),l
	integer         lbeg(3)
	integer         zh,zm,zs
	logical		loop,laccept,done
c
	real		mc_energy_occ_mol,ran1
	integer		len_str
c
c------ check for valid input and settings
c
	if (mo_mode.ne.rmc_mode_swchem) then
	  ier_num = -3
	  ier_typ = ER_MC
	  return
	endif
c
c------ reset some counters
c
	igen      = 0
	itry      = 0
	iacc_good = 0
	iacc_bad  = 0
	loop      = .true.
	done      = .true.
	lbeg(1)   = -1
	lbeg(2)   =  0
	lbeg(3)   =  0
c
	latom(1)  = len_str(mo_atom(1))
	latom(2)  = len_str(mo_atom(2))
c
	write (output_io,1000) (cr_icc(i),i=1,3),mole_num_mole
c
c------ Get molecule type numbers
c
	call ber_params (2,mo_atom,latom,mol,2)
	if (ier_num.ne.0) return
c
	amol(1) = nint(mol(1))
	amol(2) = nint(mol(2))
c
c------ Obtain starting interactions
c
	l = 2
	call chem_corr_occ_mol(l,mo_atom,latom,2,.false.,lbeg  )
	do i=1,chem_ncor
	  mo_const(i) = mo_const(i) - mo_cfac(i)*
     &	                ((mo_target_corr(i)-mo_ach_corr(i))/2.)
	enddo
c
c------ Main MC loop here
c
	start = seknds(0.0)
	do while (loop)
	  laccept = .true.
	  igen = igen + 1
c
	  imol(1) = int(ran1(idum)*mole_num_mole)+1
	  imol(2) = int(ran1(idum)*mole_num_mole)+1
	  mtyp(1) = mole_type(imol(1))
	  mtyp(2) = mole_type(imol(2))
	  laccept = (mtyp(1).eq.amol(1).or.mtyp(1).eq.amol(2)) .and.
     &	            (mtyp(2).eq.amol(1).or.mtyp(2).eq.amol(2)) .and.
     &	            (mtyp(1).ne.mtyp(2))
c
	  if (laccept) then
	    itry = itry + 1
	    done = .false.
c
c------ --- Calc energy 
c
	    e_old = mc_energy_occ_mol (2,imol,amol)
	    call do_swap_mole (imol(1),imol(2),.true.)
	    e_new = mc_energy_occ_mol (2,imol,amol)
	    if (ier_num.ne.0) return
c
c------ --- Test and accept/reject move
c
	    call mc_test(iacc_good,iacc_bad,e_new,e_old,laccept)
	    if (.not.laccept) then
	      call do_swap_mole (imol(1),imol(2),.true.)
	    endif
	  endif
c
	  loop = (itry.lt.mo_cyc)
c
	  if (igen.gt.1000*mo_feed .and. itry.eq.0) then
	    ier_num = -2
	    ier_typ = ER_MC
	    loop    = .false.
	  endif
c
c-------  Feedback ?
c
	  if (mod(itry,mo_feed).eq.0 .and. .not.done .and. loop) then
	    l = 2
	    call chem_corr_occ_mol (l,mo_atom,latom,2,.false.,lbeg  )
	    write (output_io,2000) igen,itry,iacc_good,iacc_bad
	    do i=1,chem_ncor
	      write (output_io,2100) i,mo_const(i),mo_ach_corr(i),
     &	                     mo_target_corr(i)
	      mo_const(i) = mo_const(i) - mo_cfac(i)*
     &	                    ((mo_target_corr(i)-mo_ach_corr(i))/2.)
	    enddo
	    done = .true.
	  endif
	enddo
c
c------ Loop finished
c
	write (output_io,3000)
	l = 2
	call chem_corr_occ_mol (l,mo_atom,latom,2,.false.,lbeg  )
	write (output_io,2000) igen,itry,iacc_good,iacc_bad
	do i=1,chem_ncor
	  write (output_io,2100) i,mo_const(i),mo_ach_corr(i),
     &	                 mo_target_corr(i)
	enddo
c
c------ Write timing results
c
	zeit = seknds(start)
	zh = int (zeit / 3600.)
	zm = int ((zeit - zh*3600.) / 60.)
	zs = int ( zeit - zh*3600 - zm*60.)
	write (output_io,4000) zh,zm,zs,zeit/itry
c
1000    format (' Running MC simulation ...',//
     &          ' Size of model crystal     : ',I3,' x ',I3,' x ',I3,
     &          ' containing ',I9,' molecules')
2000	format (/,' Gen: ',I8,' try: ',I8,' acc: (good/bad): ',I7,
     &	          ' / ',I7,'  MC moves ')
2100	format ('    Neig. ',i3,'  const: ',f10.3,'   achieved: ',f6.3,
     &	          '  target: ',f6.3)
3000	format (/,' --- Final configuration ---')
4000	format (/,' Elapsed time : ',I4,' h ',I2,' min ',I2,' sec ',/
     &	          ' Time/cycle   : ',F9.3,' sec',/)
c
	end
c*****7*****************************************************************
	subroutine mc_run_dis
c+
c	This is the MC routine for displacement correlations,
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'random.inc'
	include		'errlist.inc'
	include		'chem.inc'
	include		'rmc.inc'
	include		'mc.inc'
c
	integer		maxw
	parameter	(maxw = MAXSCAT)
c
	character*200	cpara(maxw)
	integer		lpara(maxw)
	real		werte(maxw),wwerte(maxw)
	real		e_old,e_new
	real		start,zeit,seknds
	real		disp1,disp2
	real		idir(3),jdir(3)
	real		disp(3,rmc_max_atom)
	real		pos (3,rmc_max_atom)
	real		rdi(chem_max_cor)
	real		rdj(chem_max_cor)
	integer		igen,itry,iacc_good,iacc_bad
	integer		isel(chem_max_atom)
	integer		latom(2)
	integer         lbeg(3)
	integer		is1,is2,iz1(3),iz2(3)
	integer		i,j,k,natoms,ianz,janz,ia,l
	integer         zh,zm,zs
	logical		loop,laccept,done
c
	real		mc_energy_dis,ran1,gasdev,skalpro
	integer		len_str
	logical		atom_allowed
c
c------ check for valid input and settings
c
	if (mo_mode.eq.rmc_mode_swchem) then
	  ier_num = -3
	  ier_typ = ER_MC
	  return
	endif
c
c------ reset some counters
c
	igen      = 0
	itry      = 0
	iacc_good = 0
	iacc_bad  = 0
	loop      = .true.
	done      = .true.
	lbeg(1)   = -1
	lbeg(2)   =  0
	lbeg(3)   =  0
c
	latom(1)  = len_str(mo_atom(1))
	latom(2)  = len_str(mo_atom(2))
c
	write (output_io,1000) (cr_icc(i),i=1,3),cr_natoms
c
c------ Setup atom arrays
c
	ianz = 1
	cpara(1)=mo_atom(1)
	lpara(1)=latom(1)
c
	call get_iscat(ianz,cpara,lpara, werte,maxw,.false.)
c	call del_params(1,ianz,cpara,lpara,maxw)
c
	janz = 1
	cpara(1)=mo_atom(2)
	lpara(1)=latom(2)
c
	call get_iscat(janz,cpara,lpara,wwerte,maxw,.false.)
	if (ier_num.ne.0) return
c
c------ Normalise correlation directions
c
	call chem_aver(.false.)
	do k=1,chem_ncor
	  do i=1,3
	    idir(i) = chem_dir(i,1,k)
	    jdir(i) = chem_dir(i,2,k)
	  enddo
c
	  rdi(k)=skalpro(idir,idir,cr_gten)
	  rdj(k)=skalpro(jdir,jdir,cr_gten)
	  rdi(k)=sqrt(rdi(k))
	  rdj(k)=sqrt(rdj(k))
	enddo
c
c------ Obtain starting interactions
c
	l = 2
	call chem_corr_dis(l,mo_atom,latom,2,.false.,lbeg  )
	do i=1,chem_ncor
	  mo_const(i) = mo_const(i) - mo_cfac(i)*
     &	                ((mo_target_corr(i)-mo_ach_corr(i))/2.)
	enddo
c
c------ Main MC loop here
c
	start = seknds(0.0)
	do while (loop)
	  laccept = .true.
	  igen = igen + 1
c
c------ - selecting sites
c
	  if (mo_mode.eq.rmc_mode_shift) then
	    natoms  = 1
10	    continue
	    isel(1) = int(ran1(idum)*cr_natoms)+1
	    if (isel(1).gt.cr_natoms .or. isel(1).lt.1) goto 10
	    laccept = atom_allowed(isel(1),werte,ianz,maxw)
	    if (laccept) then
	      do i=1,3
     	        disp(i,1) = gasdev(mo_maxmove(i,cr_iscat(isel(1))))
	      enddo
	    endif
c
	  elseif (mo_mode.eq.rmc_mode_swdisp) then
	    natoms  = 2
	    call rmc_select (mo_local,natoms,isel,iz1,iz2,is1,is2)
	    laccept = atom_allowed(isel(1), werte,ianz,maxw) .and.
     &	              atom_allowed(isel(2),wwerte,janz,maxw)     
	    if (laccept) then
	      do j=1,3
	        disp1 = cr_pos(j,isel(1))-chem_ave_pos(j,is1)-
     &	                float(iz1(j)-1)-cr_dim0(j,1)
	        disp2 = cr_pos(j,isel(2))-chem_ave_pos(j,is2)-
     &	                float(iz2(j)-1)-cr_dim0(j,1)
	        disp(j,1) = - disp1 + disp2
	        disp(j,2) = - disp2 + disp1
	      enddo
	    endif
	  endif
c
c----- -- Try move
c
	  if (laccept) then
	    itry = itry + 1
	    done = .false.
c
c------ --- Calc energy (energy calculates DELTA E !!) 
c
	    e_old = 0.0
c
	    do i=1,3
	      do ia=1,natoms
	        pos(i,ia)          = cr_pos(i,isel(ia))
	        cr_pos(i,isel(ia)) = cr_pos(i,isel(ia)) + disp(i,ia)
	      enddo
	    enddo
c
	    e_new = mc_energy_dis(natoms,isel,disp,rdi,rdj)
	    if (ier_num.ne.0) return
c
c------ --- Test and accept/reject move
c
	    call mc_test(iacc_good,iacc_bad,e_new,e_old,laccept)
	    if (.not.laccept) then
	      do i=1,3
	        do ia=1,natoms
	          cr_pos(i,isel(ia)) = pos(i,ia)
	        enddo
	      enddo
	    endif
	  endif
c
	  loop = (itry.lt.mo_cyc)
c
	  if (igen.gt.1000*mo_feed .and. itry.eq.0) then
	    ier_num = -2
	    ier_typ = ER_MC
	    loop    = .false.
	  endif
c
c-------  Feedback ?
c
	  if (mod(itry,mo_feed).eq.0 .and. .not.done .and. loop) then
	    l = 2
	    call chem_corr_dis(l,mo_atom,latom,2,.false.,lbeg  )
	    write (output_io,2000) igen,itry,iacc_good,iacc_bad
	    do i=1,chem_ncor
	      write (output_io,2100) i,mo_const(i),mo_ach_corr(i),
     &	                     mo_target_corr(i)
	      mo_const(i) = mo_const(i) - mo_cfac(i)*
     &	                    ((mo_target_corr(i)-mo_ach_corr(i))/2.)
	    enddo
	    done = .true.
	  endif
	enddo
c
c------ Loop finished
c
	write (output_io,3000)
	l = 2
	call chem_corr_dis(l,mo_atom,latom,2,.false.,lbeg  )
	write (output_io,2000) igen,itry,iacc_good,iacc_bad
	do i=1,chem_ncor
	  write (output_io,2100) i,mo_const(i),mo_ach_corr(i),
     &	                 mo_target_corr(i)
	enddo
c
c------ Write timing results
c
	zeit = seknds(start)
	zh = int (zeit / 3600.)
	zm = int ((zeit - zh*3600.) / 60.)
	zs = int ( zeit - zh*3600 - zm*60.)
	write (output_io,4000) zh,zm,zs,zeit/itry
c
1000    format (' Running MC simulation ...',//
     &          ' Size of model crystal     : ',I3,' x ',I3,' x ',I3,
     &          ' containing ',I9,' atoms')
2000	format (/,' Gen: ',I8,' try: ',I8,' acc: (good/bad): ',I7,
     &	          ' / ',I7,'  MC moves ')
2100	format ('    Neig. ',i3,'  const: ',f10.3,'   achieved: ',f6.3,
     &	          '  target: ',f6.3)
3000	format (/,' --- Final configuration ---')
4000	format (/,' Elapsed time : ',I4,' h ',I2,' min ',I2,' sec ',/
     &	          ' Time/cycle   : ',F9.3,' sec',/)
c
	end
c*****7*****************************************************************
	subroutine mc_run_dis_mol
c+
c	This is the MC routine for displacement correlations,
c	Molecule mode ..
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'random.inc'
	include		'errlist.inc'
	include		'chem.inc'
	include		'molecule.inc'
	include		'rmc.inc'
	include		'mc.inc'
c
	real		e_old,e_new
	real		start,zeit,seknds
	real		disp1,disp2
	real		idir(3),jdir(3)
	real		disp(3,rmc_max_atom)
	real		pos (3,rmc_max_atom)
	real		rdi(chem_max_cor)
	real		rdj(chem_max_cor)
	real		mol(2)
	integer		imol(2),amol(2),mtyp(2),nmol
	integer		igen,itry,iacc_good,iacc_bad
	integer		latom(2)
	integer		is1,is2,iz1(3),iz2(3)
	integer		i,j,k,ia,l
	integer		is,js,ii,jj,im
	integer         lbeg(3)
	integer         zh,zm,zs
	logical		loop,laccept,done
c
	real		mc_energy_dis_mol,ran1,gasdev,skalpro
	integer		len_str
c
c------ check for valid input and settings
c
	if (mo_mode.eq.rmc_mode_swchem) then
	  ier_num = -3
	  ier_typ = ER_MC
	  return
	endif
c
c------ reset some counters
c
	igen      = 0
	itry      = 0
	iacc_good = 0
	iacc_bad  = 0
	loop      = .true.
	done      = .true.
	lbeg(1) = -1.0
	lbeg(2) =  0.0
	lbeg(3) =  0.0
c
	latom(1)  = len_str(mo_atom(1))
	latom(2)  = len_str(mo_atom(2))
c
	write (output_io,1000) (cr_icc(i),i=1,3),mole_num_mole
c
c------ Get molecule type numbers
c
	call ber_params (2,mo_atom,latom,mol,2)
	if (ier_num.ne.0) return
c
	amol(1)=nint(mol(1))
	amol(2)=nint(mol(2))
c
c------ Normalise correlation directions
c
	do k=1,chem_ncor
	  do i=1,3
	    idir(i) = chem_dir(i,1,k)
	    jdir(i) = chem_dir(i,2,k)
	  enddo
c
	  rdi(k)=skalpro(idir,idir,cr_gten)
	  rdj(k)=skalpro(jdir,jdir,cr_gten)
	  rdi(k)=sqrt(rdi(k))
	  rdj(k)=sqrt(rdj(k))
	enddo
c
c------ Obtain starting interactions
c
	l = 2
	call chem_corr_dis_mol(l,mo_atom,latom,2,.false.,lbeg  )
	do i=1,chem_ncor
	  mo_const(i) = mo_const(i) - mo_cfac(i)*
     &	                ((mo_target_corr(i)-mo_ach_corr(i))/2.)
	enddo
c
c------ Main MC loop here
c
	start = seknds(0.0)
	do while (loop)
	  laccept = .true.
	  igen = igen + 1
c
c------ - selecting sites
c
	  if (mo_mode.eq.rmc_mode_shift) then
	    nmol  = 1
	    imol(1) = int(ran1(idum)*mole_num_mole)+1
	    mtyp(1) = mole_type(imol(1))
	    laccept = (mtyp(1).eq.amol(1).or.mtyp(1).eq.amol(2))
	    if (laccept) then
	      do i=1,3
     	        disp(i,1) = gasdev(mo_maxmove(i,mtyp(1)))
	      enddo
	    endif
c
	  elseif (mo_mode.eq.rmc_mode_swdisp) then
	    nmol  = 2
	    imol(1) = int(ran1(idum)*mole_num_mole)+1
	    imol(2) = int(ran1(idum)*mole_num_mole)+1
	    mtyp(1) = mole_type(imol(1))
	    mtyp(2) = mole_type(imol(2))
	    is = mole_cont(mole_off(imol(1)))+1
	    js = mole_cont(mole_off(imol(2)))+1
	    laccept = (mtyp(1).eq.amol(1).or.mtyp(1).eq.amol(2)) .and.
     &	              (mtyp(2).eq.amol(1).or.mtyp(2).eq.amol(2))
c
	    if (laccept) then
	      call indextocell(is,iz1,is1)
	      call indextocell(js,iz2,is2)
	      do j=1,3
	        disp1 = cr_pos(j,is)-chem_ave_pos(j,is1)-
     &	                float(iz1(j)-1)-cr_dim0(j,1)
	        disp2 = cr_pos(j,js)-chem_ave_pos(j,is2)-
     &	                float(iz2(j)-1)-cr_dim0(j,1)
	        disp(j,1) = - disp1 + disp2
	        disp(j,2) = - disp2 + disp1
	      enddo
	    endif
	  endif
c
c----- -- Try move
c
	  if (laccept) then
	    itry = itry + 1
	    done = .false.
c
c------ --- Calc energy (energy calculates DELTA E !!) 
c
	    e_old = 0.0
c
	    jj = 0
c
	    do ia=1,nmol
	      do im=1,mole_len(imol(ia))
	        ii = mole_cont(mole_off(imol(ia))+im)
	        jj = jj+1
	        do i=1,3
	          pos(i,jj)    = cr_pos(i,ii)
	          cr_pos(i,ii) = cr_pos(i,ii) + disp(i,ia)
	        enddo
	      enddo
	    enddo
c
	    e_new = mc_energy_dis_mol(nmol,imol,disp,rdi,rdj)
	    if (ier_num.ne.0) return
c
c------ --- Test and accept/reject move
c
	    call mc_test(iacc_good,iacc_bad,e_new,e_old,laccept)
	    if (.not.laccept) then
	      jj = 0
c
	      do ia=1,nmol
	        do im=1,mole_len(imol(ia))
	          ii = mole_cont(mole_off(imol(ia))+im)
	          jj = jj+1
	          do i=1,3
	            cr_pos(i,ii) = pos(i,jj)
	          enddo
	        enddo
	      enddo
	    endif
	  endif
c
	  loop = (itry.lt.mo_cyc)
c
	  if (igen.gt.1000*mo_feed .and. itry.eq.0) then
	    ier_num = -2
	    ier_typ = ER_MC
	    loop    = .false.
	  endif
c
c-------  Feedback ?
c
	  if (mod(itry,mo_feed).eq.0 .and. .not.done .and. loop) then
	    l = 2
	    call chem_corr_dis_mol(l,mo_atom,latom,2,.false.,lbeg  )
	    write (output_io,2000) igen,itry,iacc_good,iacc_bad
	    do i=1,chem_ncor
	      write (output_io,2100) i,mo_const(i),mo_ach_corr(i),
     &	                     mo_target_corr(i)
	      mo_const(i) = mo_const(i) - mo_cfac(i)*
     &	                    ((mo_target_corr(i)-mo_ach_corr(i))/2.)
	    enddo
	    done = .true.
	  endif
	enddo
c
c------ Loop finished
c
	write (output_io,3000)
	l = 2
	call chem_corr_dis(l,mo_atom,latom,2,.false.,lbeg  )
	write (output_io,2000) igen,itry,iacc_good,iacc_bad
	do i=1,chem_ncor
	  write (output_io,2100) i,mo_const(i),mo_ach_corr(i),
     &	                 mo_target_corr(i)
	enddo
c
c------ Write timing results
c
	zeit = seknds(start)
	zh = int (zeit / 3600.)
	zm = int ((zeit - zh*3600.) / 60.)
	zs = int ( zeit - zh*3600 - zm*60.)
	write (output_io,4000) zh,zm,zs,zeit/itry
c
1000    format (' Running MC simulation ...',//
     &          ' Size of model crystal     : ',I3,' x ',I3,' x ',I3,
     &          ' containing ',I9,' molecules')
2000	format (/,' Gen: ',I8,' try: ',I8,' acc: (good/bad): ',I7,
     &	          ' / ',I7,'  MC moves ')
2100	format ('    Neig. ',i3,'  const: ',f10.3,'   achieved: ',f6.3,
     &	          '  target: ',f6.3)
3000	format (/,' --- Final configuration ---')
4000	format (/,' Elapsed time : ',I4,' h ',I2,' min ',I2,' sec ',/
     &	          ' Time/cycle   : ',F9.3,' sec',/)
c
	end
c*****7*****************************************************************
	subroutine mc_run_spring
c+
c	This is the MC routine for distortions (Hook's law)
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'random.inc'
	include		'errlist.inc'
	include		'chem.inc'
	include		'rmc.inc'
	include		'mc.inc'
c
	integer		maxw
	parameter	(maxw = MAXSCAT)
c
	character*200	cpara(maxw)
	character*9	at_name_i,at_name_j,at_name
	real		werte(maxw),wwerte(maxw)
	real		e_old,e_new
	real		start,zeit,seknds
	real		disp1,disp2
	real		disp(3,rmc_max_atom)
	real		pos (3,rmc_max_atom)
	integer		lpara(maxw)
	integer		igen,itry,iacc_good,iacc_bad
	integer		isel(chem_max_atom)
	integer		latom(2)
	integer		is1,is2,iz1(3),iz2(3)
	integer		i,j,k,natoms,ianz,janz,ia,l
	integer         zh,zm,zs
	logical		loop,laccept,done
c
	real		mc_energy_spr,ran1,gasdev
	integer		len_str
	logical		atom_allowed
c
c------ check for valid input and settings
c
	if (mo_mode.eq.rmc_mode_swchem) then
	  ier_num = -3
	  ier_typ = ER_MC
	  return
	endif
c
c------ reset some counters
c
	igen      = 0
	itry      = 0
	iacc_good = 0
	iacc_bad  = 0
	loop      = .true.
	done      = .true.
c
	latom(1)  = len_str(mo_atom(1))
	latom(2)  = len_str(mo_atom(2))
c
	write (output_io,1000) (cr_icc(i),i=1,3),cr_natoms
c
c------ Setup atom arrays
c
	ianz = 1
	janz = 1
	cpara(1)=mo_atom(1)
	cpara(2)=mo_atom(2)
	lpara(1)=latom(1)
	lpara(2)=latom(2)
c
	call get_iscat(ianz,cpara,lpara, werte,maxw,.false.)
	call del_params(1,ianz,cpara,lpara,maxw)
	call get_iscat(janz,cpara,lpara,wwerte,maxw,.false.)
	if (ier_num.ne.0) return
c
	l       =2
	cpara(1)='all'
	cpara(2)='all'
	lpara(1)=3
	lpara(2)=3
c
	do i=1,chem_ncor
	  if (mo_const(i).eq.0.0) mo_const(i) = mo_cfac(i)*1.0
	enddo
c
	call chem_aver(.false.)
c
c------ Main MC loop here
c
	start = seknds(0.0)
	do while (loop)
	  laccept = .true.
	  igen = igen + 1
c
c------ - selecting sites
c
	  if (mo_mode.eq.rmc_mode_shift) then
	    natoms  = 1
10	    continue
	    isel(1) = int(ran1(idum)*cr_natoms)+1
	    if (isel(1).gt.cr_natoms .or. isel(1).lt.1) goto 10
	    laccept = atom_allowed(isel(1), werte,ianz,maxw) .or.
     &	              atom_allowed(isel(1),wwerte,ianz,maxw)
	    if (laccept) then
	      do i=1,3
     	        disp(i,1) = gasdev(mo_maxmove(i,cr_iscat(isel(1))))
	      enddo
	    endif
c
	  elseif (mo_mode.eq.rmc_mode_swdisp) then
	    natoms  = 2
	    call rmc_select (mo_local,natoms,isel,iz1,iz2,is1,is2)
	    laccept = atom_allowed(isel(1), werte,ianz,maxw) .and.
     &	              atom_allowed(isel(2),wwerte,janz,maxw)     
	    if (laccept) then
	      do j=1,3
	        disp1 = cr_pos(j,isel(1))-chem_ave_pos(j,is1)-
     &	                float(iz1(j)-1)-cr_dim0(j,1)
	        disp2 = cr_pos(j,isel(2))-chem_ave_pos(j,is2)-
     &	                float(iz2(j)-1)-cr_dim0(j,1)
	        disp(j,1) = - disp1 + disp2
	        disp(j,2) = - disp2 + disp1
	      enddo
	    endif
	  endif
c
c----- -- Try move
c
	  if (laccept) then
	    itry = itry + 1
	    done = .false.
c
c------ --- Calc energy 
c
	    e_old = mc_energy_spr(natoms,isel)
c
	    do i=1,3
	      do ia=1,natoms
	        pos(i,ia)          = cr_pos(i,isel(ia))
	        cr_pos(i,isel(ia)) = cr_pos(i,isel(ia)) + disp(i,ia)
	      enddo
	    enddo
c
	    e_new = mc_energy_spr(natoms,isel)
	    if (ier_num.ne.0) return
c
c------ --- Test and accept/reject move
c
	    call mc_test(iacc_good,iacc_bad,e_new,e_old,laccept)
	    if (.not.laccept) then
	      do i=1,3
	        do ia=1,natoms
	          cr_pos(i,isel(ia)) = pos(i,ia)
	        enddo
	      enddo
	    endif
	  endif
c
	  loop = (itry.lt.mo_cyc)
c
	  if (igen.gt.1000*mo_feed .and. itry.eq.0) then
	    ier_num = -2
	    ier_typ = ER_MC
	    loop    = .false.
	  endif
c
c-------  Feedback ?
c
	  if (mod(itry,mo_feed).eq.0 .and. .not.done .and. loop) then
	    write (output_io,2000) igen,itry,iacc_good,iacc_bad
	    call chem_disp(l,cpara,lpara,werte,maxw,.false.)
	    do i=0,cr_nscat
	      do j=i,cr_nscat
	        at_name_i=at_name(i)
	        at_name_j=at_name(j)
	        do k=1,chem_ncor
	          if (mo_disp(k,i,j).ne.0.0) then
	            write (output_io,2300) k,at_name_i,at_name_j,
     &	                           mo_disp(k,i,j),
     &	                           chem_disp_ave(k,i,j),
     &	                           chem_disp_sig(k,i,j)
	          endif
	        enddo
	      enddo
	    enddo
	    done = .true.
	  endif
	enddo
c
c------ Loop finished
c
	write (output_io,3000)
	write (output_io,2000) igen,itry,iacc_good,iacc_bad
	call chem_disp(l,cpara,lpara,werte,maxw,.false.)
	do i=0,cr_nscat
	  do j=i,cr_nscat
	    at_name_i=at_name(i)
	    at_name_j=at_name(j)
	    do k=1,chem_ncor
	      if (mo_disp(k,i,j).ne.0.0) then
	        write (output_io,2300) k,at_name_i,at_name_j,
     &	                       mo_disp(k,i,j),
     &	                       chem_disp_ave(k,i,j),
     &	                       chem_disp_sig(k,i,j)
	      endif
	    enddo
	  enddo
	enddo
c
c------ Write timing results
c
	zeit = seknds(start)
	zh = int (zeit / 3600.)
	zm = int ((zeit - zh*3600.) / 60.)
	zs = int ( zeit - zh*3600 - zm*60.)
	write (output_io,4000) zh,zm,zs,zeit/itry
c
1000    format (' Running MC simulation ...',//
     &          ' Size of model crystal     : ',I3,' x ',I3,' x ',I3,
     &          ' containing ',I9,' atoms')
2000	format (/,' Gen: ',I8,' try: ',I8,' acc: (good/bad): ',I7,
     &	          ' / ',I7,'  MC moves ')
2300	format ('    Neig. ',i3,' : ',a9,'- ',a9,'target: ',
     &	        f7.3,' ach.: ',f7.3,' +- ',f7.3)
3000	format (/,' --- Final configuration ---')
4000	format (/,' Elapsed time : ',I4,' h ',I2,' min ',I2,' sec ',/
     &	          ' Time/cycle   : ',F9.3,' sec',/)
c
	end
c*****7*****************************************************************
	subroutine mc_run_spring_mol
c+
c	This is the MC routine for distortions (Hook's law)
c	Molecules version ..
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'random.inc'
	include		'errlist.inc'
	include		'chem.inc'
	include		'molecule.inc'
	include		'rmc.inc'
	include		'mc.inc'
c
	real		e_old,e_new
	real		start,zeit,seknds
	real		disp1,disp2
	real		disp(3,rmc_max_atom)
	real		pos (3,rmc_max_atom)
	real		mol(2)
	real		werte(2)
	integer		igen,itry,iacc_good,iacc_bad
	integer		amol(2),imol(2),mtyp(2),nmol
	integer		latom(2)
	integer		is1,is2,iz1(3),iz2(3)
	integer		i,j,k,is,js,im,ia,ii,jj,l
	integer         zh,zm,zs
	logical		loop,laccept,done
c
	real		mc_energy_spr_mol,ran1,gasdev
	integer		len_str
c
c------ check for valid input and settings
c
	if (mo_mode.eq.rmc_mode_swchem) then
	  ier_num = -3
	  ier_typ = ER_MC
	  return
	endif
c
c------ reset some counters
c
	l         = 2
	igen      = 0
	itry      = 0
	iacc_good = 0
	iacc_bad  = 0
	loop      = .true.
	done      = .true.
c
	latom(1)  = len_str(mo_atom(1))
	latom(2)  = len_str(mo_atom(2))
c
	write (output_io,1000) (cr_icc(i),i=1,3),mole_num_mole
c
c------ Get molecule type numbers
c
	call ber_params (2,mo_atom,latom,mol,2)
	if (ier_num.ne.0) return
c
	amol(1) = nint(mol(1))
	amol(2) = nint(mol(2))
c
	do i=1,chem_ncor
	  if (mo_const(i).eq.0.0) mo_const(i) = mo_cfac(i)*1.0
	enddo
c
	call chem_aver(.false.)
c
c------ Main MC loop here
c
	start = seknds(0.0)
	do while (loop)
	  laccept = .true.
	  igen = igen + 1
c
c------ - selecting sites
c
	  if (mo_mode.eq.rmc_mode_shift) then
	    nmol  = 1
	    imol(1) = int(ran1(idum)*mole_num_mole)+1
	    mtyp(1) = mole_type(imol(1))
	    laccept = (mtyp(1).eq.amol(1).or.mtyp(1).eq.amol(2))
	    if (laccept) then
	      do i=1,3
     	        disp(i,1) = gasdev(mo_maxmove(i,mtyp(1)))
	      enddo
	    endif
c
	  elseif (mo_mode.eq.rmc_mode_swdisp) then
	    nmol  = 2
	    imol(1) = int(ran1(idum)*mole_num_mole)+1
	    imol(2) = int(ran1(idum)*mole_num_mole)+1
	    mtyp(1) = mole_type(imol(1))
	    mtyp(2) = mole_type(imol(2))
	    is = mole_cont(mole_off(imol(1)))+1
	    js = mole_cont(mole_off(imol(2)))+1
	    laccept = (mtyp(1).eq.amol(1).or.mtyp(1).eq.amol(2)) .and.
     &	              (mtyp(2).eq.amol(1).or.mtyp(2).eq.amol(2))
c
	    if (laccept) then
	      call indextocell(is,iz1,is1)
	      call indextocell(js,iz2,is2)
	      do j=1,3
	        disp1 = cr_pos(j,is)-chem_ave_pos(j,is1)-
     &	                float(iz1(j)-1)-cr_dim0(j,1)
	        disp2 = cr_pos(j,js)-chem_ave_pos(j,is2)-
     &	                float(iz2(j)-1)-cr_dim0(j,1)
	        disp(j,1) = - disp1 + disp2
	        disp(j,2) = - disp2 + disp1
	      enddo
	    endif
	  endif
c
c----- -- Try move
c
	  if (laccept) then
	    itry = itry + 1
	    done = .false.
c
c------ --- Calc energy 
c
	    e_old = mc_energy_spr_mol(nmol,imol)
c
	    jj = 0
c
	    do ia=1,nmol
	      do im=1,mole_len(imol(ia))
	        ii = mole_cont(mole_off(imol(ia))+im)
	        jj = jj+1
	        do i=1,3
	          pos(i,jj)    = cr_pos(i,ii)
	          cr_pos(i,ii) = cr_pos(i,ii) + disp(i,ia)
	        enddo
	      enddo
	    enddo
c
	    e_new = mc_energy_spr_mol(nmol,imol)
	    if (ier_num.ne.0) return
c
c------ --- Test and accept/reject move
c
	    call mc_test(iacc_good,iacc_bad,e_new,e_old,laccept)
	    if (.not.laccept) then
	      jj = 0
c
	      do ia=1,nmol
	        do im=1,mole_len(imol(ia))
	          ii = mole_cont(mole_off(imol(ia))+im)
	          jj = jj+1
	          do i=1,3
	            cr_pos(i,ii) = pos(i,jj)
	          enddo
	        enddo
	      enddo
	    endif
	  endif
c
	  loop = (itry.lt.mo_cyc)
c
	  if (igen.gt.1000*mo_feed .and. itry.eq.0) then
	    ier_num = -2
	    ier_typ = ER_MC
	    loop    = .false.
	  endif
c
c-------  Feedback ?
c
	  if (mod(itry,mo_feed).eq.0 .and. .not.done .and. loop) then
	    write (output_io,2000) igen,itry,iacc_good,iacc_bad
	    call chem_disp_mol (l,mo_atom,latom,werte,2,.false.)
	    do i=1,mole_num_type
	      do j=i,mole_num_type
	        do k=1,chem_ncor
	          if (mo_disp(k,i,j).ne.0.0) then
	            write (output_io,2300) k,i,j,mo_disp(k,i,j),
     &	                           chem_disp_ave(k,i,j),
     &	                           chem_disp_sig(k,i,j)
	          endif
	        enddo
	      enddo
	    enddo
	    done = .true.
	  endif
	enddo
c
c------ Loop finished
c
	write (output_io,3000)
	write (output_io,2000) igen,itry,iacc_good,iacc_bad
	call chem_disp_mol (l,mo_atom,latom,werte,2,.false.)
	do i=1,mole_num_type
	  do j=i,mole_num_type
	    do k=1,chem_ncor
	      if (mo_disp(k,i,j).ne.0.0) then
	        write (output_io,2300) k,i,j,mo_disp(k,i,j),
     &	                       chem_disp_ave(k,i,j),
     &	                       chem_disp_sig(k,i,j)
	      endif
	    enddo
	  enddo
	enddo
c
c------ Write timing results
c
	zeit = seknds(start)
	zh = int (zeit / 3600.)
	zm = int ((zeit - zh*3600.) / 60.)
	zs = int ( zeit - zh*3600 - zm*60.)
	write (output_io,4000) zh,zm,zs,zeit/itry
c
1000    format (' Running MC simulation ...',//
     &          ' Size of model crystal     : ',I3,' x ',I3,' x ',I3,
     &          ' containing ',I9,' molecules')
2000	format (/,' Gen: ',I8,' try: ',I8,' acc: (good/bad): ',I7,
     &	          ' / ',I7,'  MC moves ')
2300	format ('    Neig. ',i3,' : Mol',i4,'  - Mol',i4,'  target: ',
     &	        f7.3,' ach.: ',f7.3,' +- ',f7.3)
3000	format (/,' --- Final configuration ---')
4000	format (/,' Elapsed time : ',I4,' h ',I2,' min ',I2,' sec ',/
     &	          ' Time/cycle   : ',F9.3,' sec',/)
c
	end
c*****7*****************************************************************
	subroutine mc_run_angle
c+
c	This is the MC routine for angular distortions using displacements
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'random.inc'
	include		'errlist.inc'
	include		'chem.inc'
	include		'rmc.inc'
	include		'mc.inc'
c
	integer		maxw
	parameter	(maxw = MAXSCAT)
c
	character*200	cpara(maxw)
	character*9	at_name_i,at_name_j,at_name
	real		werte(maxw),wwerte(maxw),wwwerte(maxw)
	real		verte(maxw)
	real		e_old,e_new
	real		start,zeit,seknds
	real		disp1,disp2
	real		disp(3,0:CHEM_MAX_NEIG)
	real		posz(3)
	real		pos (3,0:CHEM_MAX_NEIG,CHEM_MAX_COR)
	real		patom(3,0:CHEM_MAX_NEIG)
	integer		iatom(0:CHEM_MAX_NEIG)
	integer		jatom(CHEM_MAX_NEIG,CHEM_MAX_COR)
	integer		natom_ic(CHEM_MAX_COR)
	integer		lpara(maxw)
	integer		igen,itry,iacc_good,iacc_bad
	integer		isel(CHEM_MAX_ATOM)
	integer		iselz
	integer		latom(3)
	integer		ic,is1,is2,iz1(3),iz2(3)
	integer		i,j,k,natoms,ianz,janz,ia,l,kanz
	integer		natom
	integer         zh,zm,zs
	logical		loop,laccept,done
c
	real		mc_energy_angle,ran1,gasdev
	integer		len_str
	logical		atom_allowed
c
c------ check for valid input and settings
c
	if (mo_mode.eq.rmc_mode_swchem) then
	  ier_num = -3
	  ier_typ = ER_MC
	  return
	endif
c
c------ reset some counters
c
	igen      = 0
	itry      = 0
	iacc_good = 0
	iacc_bad  = 0
	loop      = .true.
	done      = .true.
c
	latom(1)  = len_str(mo_atom(1))
	latom(2)  = len_str(mo_atom(2))
	latom(3)  = len_str(mo_atom(3))
c
	write (output_io,1000) (cr_icc(i),i=1,3),cr_natoms
c
c------ Setup atom arrays
c
	ianz = 1
	cpara(1)=mo_atom(1)
	lpara(1)=latom(1)
CDBG
CDBG	write(*,*) 'cpara   : ',cpara(1)(1:lpara(1))
	call get_iscat(ianz,cpara,lpara, werte,maxw,.false.)
	janz = 1
	cpara(1)=mo_atom(2)
	lpara(1)=latom(2)
CDBG
CDBG	write(*,*) 'cpara   : ',cpara(1)(1:lpara(1))
	call get_iscat(janz,cpara,lpara,wwerte,maxw,.false.)
	kanz = 1
	cpara(1)=mo_atom(3)
	lpara(1)=latom(3)
CDBG
CDBG	write(*,*) 'cpara   : ',cpara(1)(1:lpara(1))
	call get_iscat(kanz,cpara,lpara,wwwerte,maxw,.false.)

c
c	call del_params(1,ianz,cpara,lpara,maxw)
c	call del_params(1,ianz,cpara,lpara,maxw)
CDBG
CDBG	write(*,*) '   werte : ',(werte(i),i=1,ianz)
CDBG	write(*,*) '  wwerte : ',(wwerte(i),i=1,janz)
CDBG	write(*,*) ' wwwerte : ',(wwwerte(i),i=1,kanz)
CDBG	write(*,*) ' ende  of get_iscat'
CDBG	read(*,*) i
	if (ier_num.ne.0) return
c
	l       =3
	cpara(1)=mo_atom(1)
	cpara(2)=mo_atom(2)
	cpara(3)=mo_atom(3)
	lpara(1)=latom(1)
	lpara(2)=latom(2)
	lpara(3)=latom(3)
c
	do i=1,chem_ncor
	  if (mo_const(i).eq.0.0) mo_const(i) = mo_cfac(i)*1.0
	enddo
c
c	call chem_aver(.false.)
c
c------ Main MC loop here
c
	start = seknds(0.0)
	do while (loop)
	  laccept = .true.
	  igen = igen + 1
c
	  l       =3
	  cpara(1)=mo_atom(1)
	  cpara(2)=mo_atom(2)
	  cpara(3)=mo_atom(3)
	  lpara(1)=latom(1)
	  lpara(2)=latom(2)
	  lpara(3)=latom(3)
c
c
c------ - selecting sites
c
	  natoms  = 1
10	  continue
	  isel(1) = int(ran1(idum)*cr_natoms)+1
	  iselz   = isel(1)
	  if (isel(1).gt.cr_natoms .or. isel(1).lt.1) goto 10
	  laccept = atom_allowed(iselz,  werte,ianz,maxw) .or.
     &	   	    atom_allowed(iselz, wwerte,ianz,maxw) .or.
     &	            atom_allowed(iselz,wwwerte,ianz,maxw)
c	  if (laccept) then
c	    do i=1,3
c     	      disp(i,1) = gasdev(mo_maxmove(i,cr_iscat(isel(1))))
c	    enddo
c	  endif
c
c----- -- Try move
c
	  if (laccept) then
CDBG
CDBG	write(*,*) '================================================='
CDBG	write(*,*) ' Accepted Atom: ', isel(1),cr_iscat(isel(1))
CDBG	do i=1,3
CDBG	write(*,*) ' Position     : ',cr_pos(i,isel(1))
CDBG	enddo
CDBG	write(*,*)
	    itry = itry + 1
	    done = .false.
c
c------ --- Calc energy 
c
CDBG
CDBG	write(*,*) ' Rufe Energie(alt) auf'
	    e_old = mc_energy_angle(natoms,isel)
c
c------	----Modify the central atom
c
	    do i=1,3
     	        disp(i,0) = gasdev(mo_maxmove(i,cr_iscat(iselz)))
	        posz(i)        = cr_pos(i,iselz)
	        cr_pos(i,iselz) = cr_pos(i,iselz) + disp(i,0)
CDBG
CDBG	write(*,'(a,i3,i5,4(f6.3,1x))') 'Zentral     ', 0,iselz,
CDBG     &	cr_iscat(iselz),
CDBG     &	cr_pos(i,iselz),posz(i),disp(i,0)
	    enddo
c
CDBG
CDBG	write(*,*) ' Rufe Energie(neu) auf'
	    e_new = mc_energy_angle(natoms,isel)
	    if (ier_num.ne.0) return
c
c------ --- Test and accept/reject move
c
	    call mc_test(iacc_good,iacc_bad,e_new,e_old,laccept)
CDBG
CDBG	write(*,*) ' accept : ',laccept
	    if (.not.laccept) then
c
c------ - Loop over all defined interactions
c
	      do i=1,3
	          cr_pos(i,iselz) = posz(i)
CDBG
CDBG	write(*,*) 'Restored to  IC ATOM SCAT CR_POS   POS   DISP'
CDBG	write(*,'(a,i3,2i5,3(f6.3,1x))') 
CDBG     &	'Restored to ',0,iselz,
CDBG     &	cr_iscat(iselz),
CDBG     &	cr_pos(i,iselz),posz(i),disp(i,0)
	      enddo
	    endif
	  endif
c
	  loop = (itry.lt.mo_cyc)
c
	  if (igen.gt.1000*mo_feed .and. itry.eq.0) then
	    ier_num = -2
	    ier_typ = ER_MC
	    loop    = .false.
	  endif
c
c-------  Feedback ?
c
	  if (mod(itry,mo_feed).eq.0 .and. .not.done .and. loop) then
	    write (output_io,2000) igen,itry,iacc_good,iacc_bad
	    call chem_angle(l,cpara,lpara,verte,wwerte,wwwerte,
     &	                    maxw,.false.)
CDBG
CDBG	write(*,*) ' l ', l
CDBG	write(*,*) ' cpara(1) ', cpara(1)(1:lpara(1))
CDBG	write(*,*) ' cpara(2) ', cpara(2)(1:lpara(2))
CDBG	write(*,*) ' cpara(3) ', cpara(3)(1:lpara(3))
	    do i=0,cr_nscat
	      do j=i,cr_nscat
	        at_name_i=at_name(i)
	        at_name_j=at_name(j)
	        do k=1,chem_ncor
	          if (mo_disp(k,i,j).ne.0.0) then
	            write (output_io,2300) k,at_name_i,at_name_j,
     &	                           mo_disp(k,i,j),
     &	                           chem_disp_ave(k,i,j),
     &	                           chem_disp_sig(k,i,j)
	          endif
	        enddo
	      enddo
	    enddo
	    done = .true.
CDBG
CDBG	read(*,*) i
	  endif
	enddo
c
c------ Loop finished
c
	l       =3
	cpara(1)=mo_atom(1)
	cpara(2)=mo_atom(2)
	cpara(3)=mo_atom(3)
	lpara(1)=latom(1)
	lpara(2)=latom(2)
	lpara(3)=latom(3)
c
	write (output_io,3000)
	write (output_io,2000) igen,itry,iacc_good,iacc_bad
	    call chem_angle(l,cpara,lpara,verte,wwerte,wwwerte,
     &	                    maxw,.false.)
	do i=0,cr_nscat
	  do j=i,cr_nscat
	    at_name_i=at_name(i)
	    at_name_j=at_name(j)
	    do k=1,chem_ncor
	      if (mo_disp(k,i,j).ne.0.0) then
	        write (output_io,2300) k,at_name_i,at_name_j,
     &	                       mo_disp(k,i,j),
     &	                       chem_disp_ave(k,i,j),
     &	                       chem_disp_sig(k,i,j)
	      endif
	    enddo
	  enddo
	enddo
c
c------ Write timing results
c
	zeit = seknds(start)
	zh = int (zeit / 3600.)
	zm = int ((zeit - zh*3600.) / 60.)
	zs = int ( zeit - zh*3600 - zm*60.)
	write (output_io,4000) zh,zm,zs,zeit/itry
c
1000    format (' Running MC simulation ...',//
     &          ' Size of model crystal     : ',I3,' x ',I3,' x ',I3,
     &          ' containing ',I9,' atoms')
2000	format (/,' Gen: ',I8,' try: ',I8,' acc: (good/bad): ',I7,
     &	          ' / ',I7,'  MC moves ')
2300	format ('    Neig. ',i3,' : ',a9,'- ',a9,'target: ',
     &	        f7.3,' ach.: ',f7.3,' +- ',f7.3)
3000	format (/,' --- Final configuration ---')
4000	format (/,' Elapsed time : ',I4,' h ',I2,' min ',I2,' sec ',/
     &	          ' Time/cycle   : ',F9.3,' sec',/)
c
	end
c*****7*****************************************************************
	subroutine mc_test(iacc_good,iacc_bad,e_new,e_old,laccept)
c+
c	Tests performed MC move
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'random.inc'
	include 	'mc.inc'
c
	integer		iacc_good,iacc_bad
	real		e_new,e_old,e_del
	logical		laccept
c
	real		ran1
c
	e_del = e_new - e_old
	if (e_del.lt.0) then
	  laccept = .true.
	else
	  if (mo_kt.lt.1.0e-10) then
	    laccept = .false.
	  else
	    e_del   = exp(-e_del/mo_kt)
	    e_del   = e_del / (1 + e_del)
	    laccept = (e_del.gt.ran1(idum))
	  endif
	endif
c
	if (laccept) then
	  if (e_del.lt.0.0) then
	    iacc_good = iacc_good + 1
	  else
	    iacc_bad  = iacc_bad  + 1
	  endif
	endif
c
	end
c*****7*****************************************************************
	real function mc_energy_occ(natoms,isel,ianz,werte,maxw)
c+
c	Calculates the energy for occupational disorder according to
c
c	  E = SUM si * (J1*s(i-1) + J2*s(i+1) + ...) with si = +-1.
c
c	Note there is no need for H term because concentration is
c	fixed using SWCHEM mode.
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'chem.inc'
	include 	'rmc.inc'
	include 	'mc.inc'
c
	integer		maxatom
	parameter	(maxatom = chem_max_neig)
c
	integer		isel(chem_max_atom)
	integer		natoms,ianz,maxw
	real		werte(maxw)
c
	integer		iatom(0:maxatom),natom
	integer 	ic,in,ia,ival1,ival2
	real		patom(3,0:maxatom)
c
	logical		atom_allowed
c
	mc_energy_occ = 0.0
c
c------ Loop over all modified atoms
c
	do ia=1,natoms
	  ival1 = -1
	  if (atom_allowed(isel(ia),werte,ianz,maxw)) ival1=1
c
c------ - Loop over all defined interactions
c
	  do ic=1,chem_ncor
c
c------ --- Get the neighbours
c
	    call chem_neighbour(isel(ia),ic,iatom,patom,natom,maxatom)
	    if (natom.ne.0) then
	      do in=1,natom
	        ival2 = -1
	        if (atom_allowed(iatom(in),werte,ianz,maxw)) ival2=1
	        mc_energy_occ = mc_energy_occ+mo_const(ic)*ival1*ival2
	      enddo
	    endif
	  enddo
	enddo
c
	end
c*****7*****************************************************************
	real function mc_energy_occ_mol(ianz,imol,amol)
c+
c	Calculates the energy for occupational disorder for
c	molecules.
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'chem.inc'
	include 	'rmc.inc'
	include 	'molecule.inc'
	include 	'mc.inc'
c
	integer		maxmol
	parameter	(maxmol = chem_max_neig)
c
	integer		ianz
	integer		imol(ianz)
	integer		amol(ianz)
c
	integer		ineig(0:maxmol),nneig
	integer 	ic,in,ia,ival1,ival2
c
	mc_energy_occ_mol = 0.0
c
c------ Loop over all modified atoms
c
	do ia=1,ianz
	  ival1 = -1
	  if (mole_type(imol(ia)).eq.amol(1)) ival1=1
c
c------ - Loop over all defined interactions
c
	  do ic=1,chem_ncor
c
c------ --- Get the neighbours
c
	    call chem_neighbour_mol(imol(ia),ic,ineig,nneig,maxmol)
	    if (nneig.ne.0) then
	      do in=1,nneig
	        ival2 = -1
	        if (mole_type(ineig(in)).eq.amol(1)) ival2=1
	        mc_energy_occ_mol = mc_energy_occ_mol+
     &	                                 mo_const(ic)*ival1*ival2
	      enddo
	    endif
	  enddo
	enddo
c
	end
c*****7*****************************************************************
	real function mc_energy_dis(natoms,isel,disp,rdi,rdj)
c+
c	Calculates the DELTA energy for distortions according to
c
c	  DE = SUM k*disp*x
c
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'chem.inc'
	include 	'rmc.inc'
	include 	'mc.inc'
c
	integer		maxatom
	parameter	(maxatom = chem_max_neig)
c
	integer		isel(chem_max_atom),natoms
	real		disp(3,rmc_max_atom)
	real		rdi(chem_max_cor)
	real		rdj(chem_max_cor)
c
	integer		iatom(0:maxatom),natom
	integer		cell(3),site
	integer 	i,ic,in,ia
	real		patom(3,0:maxatom)
	real		idir(3),jdir(3)
	real		delta,dx,u(3),v(3)
c
	real		skalpro
c
	mc_energy_dis = 0.0
c
c------ Loop over all modified atoms
c
	do ia=1,natoms
c
	  call indextocell(isel(ia),cell,site)
	  do i=1,3
	    v(i) = cr_pos(i,isel(ia))-chem_ave_pos(i,site)-
     &	           float(cell(i)-1)-cr_dim0(i,1)
	    v(i) = v(i) + disp(i,ia)
	  enddo
c
c------ - Loop over all defined interactions
c
	  do ic=1,chem_ncor
c
	    if (chem_ldall(ic)) then
	      do i=1,3
	        jdir(i) = v(i)
	      enddo
	      rdj(ic) = skalpro(jdir,jdir,cr_gten)
	      if (rdj(ic).gt.0.0) then
	        rdj(ic) = sqrt(rdj(ic))
	      else
	        rdj(ic) = 1.0
	      endif
	      delta = 1.0
	    else
	      do i=1,3
	        idir(i) = chem_dir(i,1,ic)
	        jdir(i) = chem_dir(i,2,ic)
	      enddo
	      delta = skalpro(v,idir,cr_gten)/rdi(ic)
	    endif
c
c------ --- Get the neighbours
c
	    call chem_neighbour(isel(ia),ic,iatom,patom,natom,maxatom)
	    if (natom.ne.0) then
	      do in=1,natom
	        call indextocell(iatom(in),cell,site)
	        do i=1,3
	          u(i) = cr_pos(i,iatom(in))-chem_ave_pos(i,site)-
     &	                 float(cell(i)-1)-cr_dim0(i,1)
	        enddo
	        dx = skalpro(u,jdir,cr_gten)/rdj(ic)
c
	        mc_energy_dis = mc_energy_dis + mo_const(ic)*delta*dx
c
	      enddo
	    endif
	  enddo
	enddo
c
	end
c*****7*****************************************************************
	real function mc_energy_dis_mol(nmol,imol,disp,rdi,rdj)
c+
c	Calculates the DELTA energy for distortions according to
c
c	  DE = SUM k*disp*x
c
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'chem.inc'
	include 	'rmc.inc'
	include 	'molecule.inc'
	include 	'mc.inc'
c
	integer		maxmol
	parameter	(maxmol = chem_max_neig)
c
	integer		nmol,imol(2)
	real		disp(3,rmc_max_atom)
	real		rdi(chem_max_cor)
	real		rdj(chem_max_cor)
c
	integer		ineig(0:maxmol),nneig
	integer		cell(3),site
	integer		iatom,jatom
	integer 	i,ic,in,ia
	real		idir(3),jdir(3)
	real		delta,dx,u(3),v(3)
c
	real		skalpro
c
	mc_energy_dis_mol = 0.0
c
c------ Loop over all modified atoms
c
	do ia=1,nmol
	  iatom = mole_cont(mole_off(imol(ia))+1)
c
	  call indextocell(iatom,cell,site)
	  do i=1,3
	    v(i) = cr_pos(i,iatom)-chem_ave_pos(i,site)-
     &	           float(cell(i)-1)-cr_dim0(i,1)
	    v(i) = v(i) + disp(i,ia)
	  enddo
c
c------ - Loop over all defined interactions
c
	  do ic=1,chem_ncor
c
	    if (chem_ldall(ic)) then
	      do i=1,3
	        jdir(i) = v(i)
	      enddo
	      rdj(ic) = skalpro(jdir,jdir,cr_gten)
	      if (rdj(ic).gt.0.0) then
	        rdj(ic) = sqrt(rdj(ic))
	      else
	        rdj(ic) = 1.0
	      endif
	      delta = 1.0
	    else
	      do i=1,3
	        idir(i) = chem_dir(i,1,ic)
	        jdir(i) = chem_dir(i,2,ic)
	      enddo
	      delta = skalpro(v,idir,cr_gten)/rdi(ic)
	    endif
c
c------ --- Get the neighbours
c
	    call chem_neighbour_mol(imol(ia),ic,ineig,nneig,maxmol)
	    if (nneig.ne.0) then
	      do in=1,nneig
	        jatom = mole_cont(mole_off(ineig(in))+1)
	        call indextocell(jatom,cell,site)
	        do i=1,3
	          u(i) = cr_pos(i,iatom)-chem_ave_pos(i,site)-
     &	                 float(cell(i)-1)-cr_dim0(i,1)
	        enddo
	        dx = skalpro(u,jdir,cr_gten)/rdj(ic)
c
	        mc_energy_dis_mol = mc_energy_dis_mol + 
     &	                            mo_const(ic)*delta*dx
c
	      enddo
	    endif
	  enddo
	enddo
c
	end
c*****7*****************************************************************
	real function mc_energy_spr(natoms,isel)
c+
c	Calculates the energy for distortions according to
c
c	  E = SUM k*(d-d0)**2
c
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'chem.inc'
	include 	'rmc.inc'
	include 	'mc.inc'
c
	integer		maxatom
	parameter	(maxatom = chem_max_neig)
c
	integer		isel(chem_max_atom),natoms
c
	integer		iatom(0:maxatom),natom
	integer		cell(3),site
	integer 	i,is,js,ic,in,ia
	real		patom(3,0:maxatom)
	real		d,u(3),v(3)
c
	real		do_blen
c
	mc_energy_spr = 0.0
c
c------ Loop over all modified atoms
c
	do ia=1,natoms
c
c------ - Restoring force to lattice (displ. from average position)
c
	  call indextocell(isel(ia),cell,site)
	  do i=1,3
	    u(i) = cr_pos(i,isel(ia))-
     &	           chem_ave_pos(i,site)-float(cell(i)-1)-cr_dim0(i,1)
	  enddo
	  d = do_blen(.true.,u,u)
c
	  mc_energy_spr = mc_energy_spr + mo_const(0)*d**2
c
c------ - Loop over all defined interactions
c
	  do ic=1,chem_ncor
	  if(chem_ctyp(ic).eq.CHEM_VEC) then
c
c------ --- Get the neighbours
c
	    call chem_neighbour(isel(ia),ic,iatom,patom,natom,
     &	                       maxatom)
	    if (natom.ne.0) then
	      do in=1,natom
	        is=cr_iscat(isel(ia))
	        js=cr_iscat(iatom(in))
	        if (mo_disp(ic,is,js).ne.0.0) then
	          do i=1,3
	            u(i)=cr_pos(i,isel(ia))
	            v(i)=patom(i,in)
	          enddo
	          d = do_blen(.true.,u,v)
c
	          mc_energy_spr = mc_energy_spr +
     &	                          mo_const(ic)*(d-mo_disp(ic,is,js))**2
c
	        endif
	      enddo
	    endif
	    endif
	  enddo
	enddo
c
	end
c*****7*****************************************************************
	real function mc_energy_spr_mol (nmol,imol)
c+
c	Calculates the energy for distortions for molecules ..
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'chem.inc'
	include 	'rmc.inc'
	include 	'molecule.inc'
	include 	'mc.inc'
c
	integer		maxmol
	parameter	(maxmol = chem_max_neig)
c
	integer		imol(2),nmol
c
	integer		ineig(0:maxmol),nneig
	integer		iatom,jatom
	integer		cell(3),site
	integer 	i,is,js,ic,in,ia
	real		d,u(3),v(3)
c
	real		do_blen
c
	mc_energy_spr_mol = 0.0
c
c------ Loop over all modified atoms
c
	do ia=1,nmol
	  iatom = mole_cont(mole_off(imol(ia))+1)
c
c------ - Restoring force to lattice (displ. from average position)
c
	  call indextocell(iatom,cell,site)
	  do i=1,3
	    u(i) = cr_pos(i,iatom)-
     &	           chem_ave_pos(i,site)-float(cell(i)-1)-cr_dim0(i,1)
	  enddo
	  d = do_blen(.true.,u,u)
c
	  mc_energy_spr_mol = mc_energy_spr_mol + mo_const(0)*d**2
c
c------ - Loop over all defined interactions
c
	  do ic=1,chem_ncor
	  if(chem_ctyp(ic).eq.CHEM_VEC) then
c
c------ --- Get the neighbours
c
	    call chem_neighbour_mol(imol(ia),ic,ineig,nneig,maxmol)
	    if (nneig.ne.0) then
	      do in=1,nneig
	        is=mole_type(imol (ia))
	        js=mole_type(ineig(in))
	        jatom = mole_cont(mole_off(ineig(in))+1)
	        if (mo_disp(ic,is,js).ne.0.0) then
	          do i=1,3
	            u(i)=cr_pos(i,iatom)
	            v(i)=cr_pos(i,jatom)
	          enddo
	          d = do_blen(.true.,u,v)
c
	          mc_energy_spr_mol = mc_energy_spr_mol +
     &	                  mo_const(ic)*(d-mo_disp(ic,is,js))**2
c
	        endif
	      enddo
	    endif
	    endif
	  enddo
	enddo
c
	end
c*****7*****************************************************************
	real function mc_energy_angle(natoms,isel)
c+
c	Calculates the energy for angular deviations according to
c
c	  E = SUM k*(a-a0)**2
c
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'chem.inc'
	include 	'rmc.inc'
	include 	'mc.inc'
c
	integer		maxatom
	parameter	(maxatom = chem_max_neig)
c
	integer		isel(CHEM_MAX_ATOM),natoms
c
	integer		iatom(0:maxatom),natom
	integer		cell(3),site
	integer 	i,is,js,ic,in,ia,io
	integer		ii
	logical		lnoneig
	real		patom(3,0:maxatom)
	real		a,u(3),v(3),w(3)
c
	real		do_bang
c
	mc_energy_angle = 0.0
	lnoneig = .true.
c
c------ Loop over all modified atoms
c
	do ia=1,natoms
c
c------ - Position of zentral atom 
c
	  call indextocell(isel(ia),cell,site)
c
c	  mc_energy_angle = mc_energy_angle + mo_const(0)*d**2
c
c------ - Loop over all defined interactions
c
	  do ic=1,chem_ncor
	  if(chem_ctyp(ic).eq.CHEM_ANG) then
c
c------ --- Get the neighbours
c
	    call chem_neighbour(isel(ia),ic,iatom,patom,natom,maxatom)
	    if (natom.ne.0) then
	      do ii=1,natom,3
CDBG
	lnoneig = .false.
CDBG	write(*,*) ' MC_ENERGY_ANGLE ,natom,ic ',natom,ic
	        do i=1,3
	          u(i) = patom(i,ii)
	        enddo
CDBG	write(*,*) ' Zentral Atom  : ',iatom(ii),cr_iscat(iatom(ii)),u
	        in=ii+1
	        is=cr_iscat(iatom(in))
	        js=cr_iscat(iatom(in+1))
	        if (mo_disp(ic,is,js).ne.0.0) then
	          do i=1,3
	            v(i)=patom(i,in)
	            w(i)=patom(i,in+1)
	          enddo
	          a = do_bang(.true.,v,u,w)
CDBG
CDBG	write(*,*) ' Nachbar 1     : ',iatom(in),is,v
CDBG	write(*,*) ' Nachbar 2     : ',iatom(in+1),js,w
CDBG	write(*,*) ' Target,win    : ',mo_disp(ic,is,js),a
c
	          mc_energy_angle = mc_energy_angle +
     &	                        mo_const(ic)*(a-mo_disp(ic,is,js))**2
CDBG	write(*,*) ' Energie       : ',mc_energy_angle
c
	        endif
	      enddo
	    endif
	    endif
	  enddo
	enddo
CDBG
	if(lnoneig) then
	write(*,*) ' No neighbour found ',natom
	write(*,*) ' Zentral Atom  : ',isel(ia),cr_iscat(ia),u
	endif
CDBG
CDBG	write(*,*) ' Natoms am Ende von mc_energy_angle ',natoms
c
	end
c*****7*****************************************************************
	subroutine errlist_mc
c-
c	Displays error Messages for the error type MC
c+
	implicit      none
c
	include      'errlist.inc'
c
	integer       iu,io
	parameter    (IU=-5,IO=0)
c
	character*41  ERROR(IU:IO)
c
	DATA ERROR/
     &  'Number of feedback intervalls is zero      ',      ! -5 
     &  'Number of MC cycles is zero                ',      ! -4 
     &  'Invalid mode selected for COCC MC run      ',      ! -3 
     &  'No valid move after 1000 cycles            ',      ! -2 
     &  'Invalid or no energy type selected         ',      ! -1 
     &  ' '       !  0
     &	/
c
	call disp_error ('MC  ',error,iu,io)
	end
C*****7****************************************************************
