c*****7*****************************************************************
	subroutine mmc
c-
c	This sublevel includes all commands and functions for the
c	Monte-Carlo simulations in DISCUS. 
c
c	Version  : 1.00
c	Date     : 18. December 1997
c
c	Author   : Th. Proffen (proffen@pa.msu.edu)
c
c+
	implicit	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'doact.inc'
	include 	'macro.inc'
	include 	'errlist.inc'
	include 	'learn.inc'
	include 	'param.inc'
	include 	'prompt.inc'
	include 	'mc.inc'
c
	integer		maxw
	parameter	(maxw=10)
c
	character*5    	befehl
	character*10   	prom
	character*40   	cdummy
	character*200  	line,zeile
	character*200	cpara(maxw)
	integer		lpara(maxw)
	integer        	lp,length
	integer        	indxg,lbef,ianz
	real		werte(maxw)
c
	integer		len_str
	logical         str_comp
c
10	continue
c
	call no_error
	prom=prompt//'/mmc'
	call get_command (line,length,befehl,lbef,zeile,lp,prom)
	if(ier_num.eq.0) then
	if(line.eq.' '.or.line(1:1).eq.'#') goto 10
c
c------ search for "="
c
	indxg=index(line,'=')
	if(indxg.ne.0.and..not.(str_comp(befehl,'echo',2,lbef,4))
     &	             .and..not.(str_comp(befehl,'syst',2,lbef,4))
     &	             .and..not.(str_comp(befehl,'help',2,lbef,4) .or.
     &	                        str_comp(befehl,'?   ',2,lbef,4)) ) then
          call do_math(line,indxg,length)
c
c------ execute a macro file
c
        elseif(befehl(1:1).eq.'@') then
          call file_kdo(line(2:length),length-1)
c
c------ continues a macro 'continue'
c
        elseif(str_comp(befehl,'continue',3,lbef,8)) then
          call macro_continue(zeile,lp)
c
c------ Echo a string, just for interactive check in a macro 'echo'
c
	elseif(str_comp(befehl,'echo',2,lbef,4)) then
	  call echo(zeile,lp)
c
c------ Evaluate an expression
c
	elseif(str_comp(befehl,'eval',2,lbef,4)) then
	  call do_eval(zeile,lp)
c
c------	exit 'exit'
c
	elseif(str_comp(befehl,'exit',3,lbef,4)) then
	  goto 9999
c
c------	help 'help','?'
c
	elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	       str_comp(befehl,'?   ',1,lbef,4)     ) then
	  if(str_comp(zeile,'errors',2,lp,6) ) then
	    lp = lp + 7
	    call do_hel('discus '//zeile,lp)
	  else
	    lp = lp + 11
	    call do_hel('discus mc '//zeile,lp)
	  endif
c
c-------Operating System Kommandos 'syst'
c
	elseif(str_comp(befehl,'syst',2,lbef,4)) then
	  cdummy=' '
	  if(zeile.ne. ' ') then
	    cdummy(1:lp)=zeile(1:lp)
	    call do_operating(cdummy,lp)
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c------	Waiting for user input
c
	elseif(str_comp(befehl,'wait',3,lbef,4)) then
	  call do_input(zeile,lp)
c
c------ ------------------------------------------------------------
c------ Here start MC specific commands
c------ ------------------------------------------------------------
c
c------ command 'run'
c
	elseif(str_comp(befehl,'run',2,lbef,3)) then
	  call mmc_run_multi
c
c------ command 'save'
c
	elseif(str_comp(befehl,'save',2,lbef,4)) then
	  call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	  call do_build_name (ianz,cpara,lpara,werte,maxw,1)
	  if (ier_num.eq.0) then
	    write (output_io,1500) cpara(1)(1:len_str(cpara(1)))
	    call save_struc(cpara(1),lpara(1))
	  endif
c
c------ command 'set'
c
	elseif(str_comp(befehl,'set',2,lbef,3)) then
	  call mmc_set(zeile,lp)
c
c------ command 'show'
c
	elseif(str_comp(befehl,'show',2,lbef,4)) then
	  call mmc_show
c
c------ no command found
c
	else
	  ier_num = -8
	  ier_typ = ER_COMM
	endif
	endif
c
c------ any errors ?
c
	if(ier_num.ne.0) then
	  call errlist
	  if(lmakro) then
	    call macro_close
	    prompt_status = PROMPT_ON
	  endif
	  if(lblock) then
	    ier_num = -11
	    ier_typ = ER_COMM
	    return
	  endif
	  call no_error
	endif
	goto 10
c
9999	continue
c
1500    format (' Saving structure to file : ',a)
c
	end
c*****7*****************************************************************
	subroutine mmc_show
c+
c	Show parameters of MMC section
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'errlist.inc'
	include 	'chem.inc'
	include 	'rmc.inc'
	include 	'molecule.inc'
	include 	'mc.inc'
	include 	'mmc.inc'
c
	character*200   zeile
	character*24	c_energy(0:MC_N_ENERGY)
	character*20	c_move(MC_N_MOVE)
	character*20	c_site(4)
	character*9 	at_name,at_name_i,at_name_j
	integer		i,j,k,l,m
	integer		ie
c
	data c_energy/
     &	 '                        ',
     &	 'Occupation correlation  ',
     &	 'Displacement correlation',
     &	 'Displacement energy     ',
     &	 'Angular energy          ',
     &	 'Vector energy           ',
     &	 'Bond length energy      ',
     &	 'Lennard Jones Potential '/
	data c_move/
     &	 'switch chemistry    ',
     &	 'switch displacement ',
     &	 'shift atom          ',
     &	 'inverse displacement'/
	data c_site/
     &	 'all                 ',
     &	 'local +- 1 unit cell',
     &	 'local, same site    ',
     &	 'all,   same site    '/
c
c------ Information about MC running mode etc ..
c
CDBG	if (mo_mode.eq.rmc_mode_shift) then
CDBG	  write (output_io,1100) 'move atoms'
CDBG	elseif (mo_mode.eq.rmc_mode_swchem) then
CDBG	  write (output_io,1100) 'switch atoms'
CDBG	elseif (mo_mode.eq.rmc_mode_swdisp) then
CDBG	  write (output_io,1100) 'switch displacements'
CDBG	elseif (mo_mode.eq.rmc_mode_external) then
CDBG	  write (output_io,1100) 'defined in user supplied subroutine'
CDBG	else
CDBG	  write (output_io,1100) '??????????'
CDBG	endif
c
	if (mo_sel_atom) then
	  write (output_io,1105) 'atoms'
	else
	  write (output_io,1105) 'molecules'
	endif
c
CDBG	if (mo_energy.eq.mc_none) then
CDBG	  write (output_io,1110) 'not defined'
CDBG	elseif (mo_energy.eq.mc_occ) then
CDBG	  write (output_io,1110) 'correlations occupational'
CDBG	elseif (mo_energy.eq.mc_disp) then
CDBG	  write (output_io,1110) 'correlations displacements'
CDBG	elseif (mo_energy.eq.mc_spring) then
CDBG	  write (output_io,1110) 'distortions (Hookes law)'
CDBG	elseif (mo_energy.eq.mc_angle) then
CDBG	  write (output_io,1110) 'angular distortions'
CDBG	else
CDBG	  write (output_io,1110) '??????????'
CDBG	endif
c	
CDBG	if (mo_local.eq.rmc_local_all) then
CDBG	  write (output_io,1120) 'all'
CDBG	elseif (mo_local.eq.rmc_local_loc) then
CDBG	  write (output_io,1120) 'only local (+-1 unit cell)'
CDBG	elseif (mo_local.eq.rmc_local_locsite) then
CDBG	  write (output_io,1120) 'only local, same site'
CDBG	elseif (mo_local.eq.rmc_local_site) then
CDBG	  write (output_io,1120) 'all, same site'
CDBG	else
CDBG	  write (output_io,1120) '??????????'
CDBG	endif
c
	write (output_io,1250) mo_cyc
	write (output_io,1300) mo_feed
	write (output_io,1400) mo_kt
c
c------	Information about the moves
c
	write(output_io,5000)
	do i=1,MC_N_MOVE
	  write(output_io,5100) c_move(i),mmc_move_prob(i),
     &	  c_site(mmc_local(i))
	enddo
c
c------ Information about target values, constants etc ..
c
	write (output_io,2000) mo_const(0)
	do i=1,chem_ncor
CDBG	  write(*,2100)  
	  do ie=1,MC_N_ENERGY
	    if(mmc_cor_energy(i,ie)) then
CDBG	  write (output_io,2100) i,mo_const(i),mo_cfac(i),mo_ach_corr(i),
CDBG     &	                 mo_target_corr(i)
	  write(*,2150) i,
     &	                c_energy(ie),
     &	                mmc_const(i,ie),mmc_cfac(i,ie),
     &	                mmc_ach_corr(i,ie),
     &	                mmc_target_corr(i,ie)
	    endif
	  enddo
	enddo
c
c------ Information about defined correlations etc ..
c
	write (output_io,3000)
	zeile = 'corr'
	call chem_show(zeile)
c
c------ Information about defined desired distances
c
CDBG	if (mo_mode.eq.MC_SPRING) then
	  write (output_io,4000)
c
	  if (mo_sel_atom) then
	    do i=0,cr_nscat
	      do j=i,cr_nscat
	        at_name_i=at_name(i)
	        at_name_j=at_name(j)
	        do k=1,chem_ncor
	          if (mmc_disp(k,MC_SPRING,i,j).ne.0.0) 
     &	            write (output_io,4100) at_name_i,at_name_j,k,
     &	                                   mmc_disp(k,MC_SPRING,i,j)
	        enddo
	      enddo
	    enddo
	  else
	    do i=1,mole_num_type
	      do j=i,mole_num_type
	        do k=1,chem_ncor
	          if (mmc_disp(k,MC_SPRING,i,j).ne.0.0) 
     &	            write (output_io,4200) 
     &	            i,j,k,mmc_disp(k,MC_SPRING,i,j)
	        enddo
	      enddo
	    enddo
	  endif
CDBG	endif
c
c------ Information about defined desired angles
c
CDBG	if (mo_mode.eq.MC_ANGLE) then
	  write (output_io,4010)
c
	  if (mo_sel_atom) then
	    do i=0,cr_nscat
	      do j=i,cr_nscat
	        at_name_i=at_name(i)
	        at_name_j=at_name(j)
	        do k=1,chem_ncor
	          if (mmc_disp(k,MC_ANGLE,i,j).ne.0.0) 
     &	            write (output_io,4100) at_name_i,at_name_j,k,
     &	                                   mmc_disp(k,MC_ANGLE,i,j)
	        enddo
	      enddo
	    enddo
	  else
	    do i=1,mole_num_type
	      do j=i,mole_num_type
	        do k=1,chem_ncor
	          if (mmc_disp(k,MC_ANGLE,i,j).ne.0.0) 
     &	            write (output_io,4200) 
     &	            i,j,k,mmc_disp(k,MC_ANGLE,i,j)
	        enddo
	      enddo
	    enddo
	  endif
CDBG	endif
c
c------ Information about defined desired vector differences
c
CDBG	if (mo_mode.eq.MC_VECTOR) then
	  write (output_io,4020)
c
	  if (mo_sel_atom) then
	    do i=0,cr_nscat
	      do j=i,cr_nscat
	        at_name_i=at_name(i)
	        at_name_j=at_name(j)
	        do k=1,chem_ncor
	          do l=1,mmc_nvec(k,i,j)
	            write (output_io,4120) at_name_i,at_name_j,k,
     &	                                   (mmc_vec(m,l,k,i,j),m=1,4)
	          enddo
	        enddo
	      enddo
	    enddo
	  else
	    do i=1,mole_num_type
	      do j=i,mole_num_type
	        do k=1,chem_ncor
	          do l=1,mmc_nvec(k,i,j)
	            write (output_io,4220) 
     &	              i,j,k,(mmc_vec(m,l,k,i,j),m=1,4)
	          enddo
	        enddo
	      enddo
	    enddo
	  endif
CDBG	endif
c
c------ Maxmove settings in 'shift' mode
c
	if (mo_mode.eq.rmc_mode_shift) then
	  write (output_io,6000)
	  if (mo_sel_atom) then
	    do i=1,cr_nscat
	      at_name_i = at_name(i)
	      write (output_io,6010) at_name_i,(mo_maxmove(j,i),j=1,3)
	    enddo
	  else
	    do i=1,mole_num_type
	      write (output_io,6020) i,(mo_maxmove(j,i),j=1,3)
	    enddo
	  endif
	endif
c
1100	format (  ' MC running mode                : ',a)
1105	format (  '   Operation mode for MC        : ',a)
1110	format (  '   Energy calculation mode      : ',a)
1120	format (  '   Valid neighbours             : ',a)
1250	format (  '   Max. number of MC cycles     : ',i8)
1300	format (  '   Feedback/update intervall    : ',i8)
1400	format (  '   Temperature [kT]             : ',f8.4)
2000	format (/,' MMC settings (C(0)=',f10.3,')  : ',//,
     &	        '    #',4x,'interaction',2x,'factor',5x,'curr. corr.',
     &	             2x,'target corr.',/,3x,55('-'))
2100	format (/)
2150	format (3x,i3,1x,a24,1x,f10.3,2x,f6.3,7x,f6.3,5x,f8.3)
3000	format (/,' Correlation definitions        : ',/)
4000	format (/,' Desired distortions for SPRING : ',/)
4010	format (/,' Desired distortions for ANGLE  : ',/)
4020	format (/,' Desired distortions for VECTOR : ',/)
4100	format (  '   Atoms : ',a4,' - ',a4,'  neig. #',i3,
     &	          '   distance : ',f7.3,' A')
4120	format (  '   Atoms : ',a4,' - ',a4,'  neig. #',i3,
     &	          '   vector : ',3(f7.3,2x),f7.3)
4200	format (  '   Molecule types : ',i4,' - ',i4,'  neig. #',i3,
     &	          '   distance : ',f7.3,' A')
4220	format (  '   Molecule types : ',i4,' - ',i4,'  neig. #',i3,
     &	          '   vector : ',3(f7.3,2x),f7.3)
6000	format (/,' Sigmas for MC shifts (l.u.)    : ')
6010	format (  '                 Atom ',a9,' : ',3(F7.3,1X))
6020	format (  '        Molecule type ',i9,' : ',3(F7.3,1X))
5000	format (/' Operation modes for MMC '/
     &	        '   Mode                  Probability',
     &	        '  two-atom correlation'/3x,55('-'))
5100	format (3x,a20,2x,f7.5,6x,a20)
	end
c*****7*****************************************************************
	subroutine mmc_set (zeile,lp)
c+
c	sets parameters for MMC section
c-
	implicit	none
c
	include		'config.inc'
	include		'errlist.inc'
	include 	'chem.inc'
	include 	'mc.inc'
	include 	'mmc.inc'
c
	integer		maxw
	parameter	(maxw=200)
c
	character*200 	zeile
	integer		lp
c
	character*200	cpara(maxw)
	real		uerte(maxw)
	real		verte(maxw)
	real		werte(maxw)
	integer		lpara(maxw)
	integer		ianz,iianz,jjanz,kkanz,is,js,ic,i,j
c
	logical		str_comp
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.eq.0) then
	  if (ianz.ge.2) then
	    call do_cap(cpara(1))
c
c------ --- 'set atom': setting of atoms to be taken for MC 
c
            if(cpara(1)(1:2).eq.'AT' .or. 
     &	       cpara(1)(1:3).eq.'MOL') then
	      if (ianz.eq.3) then
	        mo_sel_atom = (cpara(1)(1:2).eq.'AT')
	        mo_atom(1)  = cpara(2)(1:lpara(2))
	        mo_atom(2)  = cpara(3)(1:lpara(3))
	      elseif (ianz.eq.4) then
	        mo_sel_atom = (cpara(1)(1:2).eq.'AT')
	        mo_atom(1)  = cpara(2)(1:lpara(2))
	        mo_atom(2)  = cpara(3)(1:lpara(3))
	        mo_atom(3)  = cpara(4)(1:lpara(4))
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ --- 'set angle' : setting of neighbouring angles
c
            elseif(cpara(1)(1:2).eq.'AN') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call chem_set_angle (ianz,cpara,lpara,werte,maxw)
c
c------ --- 'set envir' : setting of neighbouring environment
c
            elseif(cpara(1)(1:3).eq.'ENV') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call chem_set_envir (ianz,cpara,lpara,werte,maxw)
c
c------ --- 'set const': setting interactions and feedback factor
c
            elseif(cpara(1)(1:3).eq.'CON') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call ber_params (1,cpara,lpara,werte,maxw)
	      if (ier_num.ne.0) return
	      if (ianz.eq.3 .or. ianz.eq.4) then
	        ic = nint(werte(1))
	        if (ic.ge.0 .and. ic.le.chem_ncor) then
	          if (str_comp(cpara(2),'corr',2,lpara(2),4)) then
	            call del_params (2,ianz,cpara,lpara,maxw)
	            call ber_params (ianz,cpara,lpara,werte,maxw)
	            mmc_const(ic,MC_OCC)=werte(1)
	            if (ianz.eq.2) mmc_cfac(ic,MC_OCC)=werte(2)
	          elseif(str_comp(cpara(2),'cd',2,lpara(2),2)) then
	            call del_params (2,ianz,cpara,lpara,maxw)
	            call ber_params (ianz,cpara,lpara,werte,maxw)
	            mmc_const(ic,MC_DISP)=werte(1)
	            if (ianz.eq.2) mmc_cfac(ic,MC_DISP)=werte(2)
	          elseif(str_comp(cpara(2),'spring',2,lpara(2),6)) then
	            call del_params (2,ianz,cpara,lpara,maxw)
	            call ber_params (ianz,cpara,lpara,werte,maxw)
	            mmc_const(ic,MC_SPRING)=werte(1)
	            if (ianz.eq.2) mmc_cfac(ic,MC_SPRING)=werte(2)
	          elseif(str_comp(cpara(2),'angle',2,lpara(2),5)) then
	            call del_params (2,ianz,cpara,lpara,maxw)
	            call ber_params (ianz,cpara,lpara,werte,maxw)
	            mmc_const(ic,MC_ANGLE)=werte(1)
	            if (ianz.eq.2) mmc_cfac(ic,MC_ANGLE)=werte(2)
	          elseif(str_comp(cpara(2),'vector',2,lpara(2),6)) then
	            call del_params (2,ianz,cpara,lpara,maxw)
	            call ber_params (ianz,cpara,lpara,werte,maxw)
	            mmc_const(ic,MC_VECTOR)=werte(1)
	            if (ianz.eq.2) mmc_cfac(ic,MC_VECTOR)=werte(2)
	          elseif(str_comp(cpara(2),'lennard',2,lpara(2),6)) then
	            call del_params (2,ianz,cpara,lpara,maxw)
	            call ber_params (ianz,cpara,lpara,werte,maxw)
	            mmc_const(ic,MC_LENNARD)=werte(1)
	            if (ianz.eq.2) mmc_cfac(ic,MC_LENNARD)=werte(2)
	          endif
	        else
	          ier_num = -14
	          ier_typ = ER_CHEM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ --- 'set cyc' : setting number of MC moves
c
            elseif(cpara(1)(1:2).eq.'CY') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call ber_params (ianz,cpara,lpara,werte,maxw)
	      mo_cyc = nint(werte(1))
c
c------ --- 'set energy' : setting of energy expression
c
            elseif(cpara(1)(1:3).eq.'ENE') then
	      call del_params (1,ianz,cpara,lpara,maxw)
c
	      if (ianz.ge.1) then
	        call do_cap(cpara(1))
	        if     (cpara(1)(1:2).eq.'CO') then
	          mo_energy = MC_OCC
	        elseif (cpara(1)(1:2).eq.'CD') then
	          mo_energy = MC_DISP
	        elseif (cpara(1)(1:2).eq.'DI') then
	          mo_energy = MC_SPRING
	        elseif (cpara(1)(1:2).eq.'AN') then
	          mo_energy = MC_ANGLE
	        elseif (cpara(1)(1:2).eq.'LE') then
	          mo_energy = MC_LENNARD
	          call del_params (1,ianz,cpara,lpara,maxw)
	          call ber_params (ianz,cpara,lpara,werte,maxw)
	          mmc_len_a = werte(1)
	          mmc_len_b = werte(2)
	          mmc_len_d = werte(3)
	        else
	          ier_num = -1
	          ier_typ = ER_MC
	          return
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ --- 'set feed' : setting display/feedback intervall
c
            elseif(cpara(1)(1:2).eq.'FE') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call ber_params (ianz,cpara,lpara,werte,maxw)
	      mo_feed = nint(werte(1))
c
c------ --- 'set limited': sets limited selction range for atoms
c
	    elseif(cpara(1)(1:3).eq.'LIM') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      if(cpara(1)(1:4).eq.'cell') then
	        call del_params (1,ianz,cpara,lpara,maxw)
	        call ber_params (ianz,cpara,lpara,werte,maxw)
	        if (ier_num.ne.0) return
	        do i=1,3
	          mmc_l_center(i) = werte(i)
	          mmc_l_extend(i) = werte(i+3)
	        enddo
	        mmc_l_limited = .true.
	        mmc_l_type    = MMC_L_CELLS
	      elseif(cpara(1)(1:3).eq.'OFF') then
	        mmc_l_limited = .false.
	      endif
c
c------ --- 'set mode': sets operation mode for MMC
c
	    elseif(cpara(1)(1:3).eq.'MOD') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      if (ier_num.ne.0) return
	      j=1
	      call ber_params (j,cpara,lpara,werte,maxw)
	      if (ier_num.ne.0) return
	      call del_params (1,ianz,cpara,lpara,maxw)
	      if (ier_num.ne.0) return
	      call mmc_set_mode(ianz,cpara,lpara,werte,maxw)
c
c------ --- 'set move': sets maxmove for shift MMC mode
c
	    elseif(cpara(1)(1:3).eq.'MOV') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      if (ier_num.ne.0) return
	      call rmc_set_move(mo_maxmove,mo_sel_atom,ianz,cpara,
     &	                        werte,lpara,maxw)
c
c------ --- 'set neig': setting correlation determination method
c
            elseif(cpara(1)(1:2).eq.'NE') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call chem_set_neig (ianz,cpara,lpara,werte,maxw)
c
c------ --- 'set range' : setting of neighbouring ranges
c
            elseif(cpara(1)(1:2).eq.'RA') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call chem_set_ranges (ianz,cpara,lpara,werte,maxw)
c
c------ --- 'set target' : setting of target correlations
c
            elseif(cpara(1)(1:2).eq.'TA') then
	      if (ianz.ge.3) then
	        call del_params (1,ianz,cpara,lpara,maxw)
	        call ber_params (1,cpara,lpara,werte,maxw)
	        ic = nint(werte(1))
	        if (ic.gt.0 .and. ic.le.chem_ncor) then
	          if (str_comp(cpara(2),'corr',2,lpara(2),4)) then
	            call del_params (2,ianz,cpara,lpara,maxw)
	            call ber_params (1,cpara,lpara,werte,maxw)
	            mo_target_corr(ic) = werte(1)
	            mmc_cor_energy(ic,MC_OCC) = .true.
	            mmc_cor_energy(0 ,MC_OCC) = .true.
	            mmc_target_corr(ic,MC_OCC) = werte(1)
	          elseif(str_comp(cpara(2),'cd',2,lpara(2),2)) then
	            call del_params (2,ianz,cpara,lpara,maxw)
	            call ber_params (1,cpara,lpara,werte,maxw)
	            mo_target_corr(ic) = werte(1)
	            mmc_cor_energy(ic,MC_DISP) = .true.
	            mmc_cor_energy(0 ,MC_DISP) = .true.
	            mmc_target_corr(ic,MC_DISP) = werte(1)
	          elseif(str_comp(cpara(2),'spring',2,lpara(2),6)) then
	            call del_params (2,ianz,cpara,lpara,maxw)
	            iianz = 1
	            jjanz = 1
	            call get_iscat(iianz,cpara,lpara,uerte,
     &	                           maxw,.false.)
	            call del_params(1,ianz,cpara,lpara,maxw)
	            call get_iscat(jjanz,cpara,lpara,verte,
     &	                           maxw,.false.)
	            call del_params (1,ianz,cpara,lpara,maxw)
	            call ber_params (1,cpara,lpara,werte,maxw)
	            do i=1,iianz
	              do j=1,jjanz
	                is=nint(uerte(i))
	                js=nint(verte(j))
	                call mmc_set_disp(ic,MC_SPRING,is,js,werte(1))
	              enddo
	            enddo
	            mmc_cor_energy(ic,MC_SPRING) = .true.
	            mmc_cor_energy(0 ,MC_SPRING) = .true.
	            mmc_target_corr(ic,MC_SPRING) = werte(1)
	          elseif(str_comp(cpara(2),'angle',2,lpara(2),5)) then
c
c------	------------Three atom names are listed on the traget instruction
c	            Required for angular correlations
c
	            call del_params (2,ianz,cpara,lpara,maxw)
	            iianz = 1
	            jjanz = 1
	            kkanz = 1
	            call get_iscat(iianz,cpara,lpara,uerte,
     &	                           maxw,.false.)
	            call del_params(1,ianz,cpara,lpara,maxw)
	            call get_iscat(jjanz,cpara,lpara,uerte,
     &	                           maxw,.false.)
	            call del_params (1,ianz,cpara,lpara,maxw)
	            call get_iscat(kkanz,cpara,lpara,verte,
     &	                           maxw,.false.)
	            call del_params (1,ianz,cpara,lpara,maxw)
	            call ber_params (1,cpara,lpara,werte,maxw)
	            do i=1,jjanz
	              do j=1,kkanz
	                is=nint(uerte(i))
	                js=nint(verte(j))
	                call mmc_set_disp(ic,MC_ANGLE,is,js,werte(1))
	              enddo
	            enddo
	            mmc_cor_energy(ic,MC_ANGLE) = .true.
	            mmc_cor_energy(0 ,MC_ANGLE) = .true.
	            mmc_target_corr(ic,MC_ANGLE) = werte(1)
	          elseif(str_comp(cpara(2),'vector',2,lpara(2),6)) then
	            call del_params (2,ianz,cpara,lpara,maxw)
	            iianz = 1
	            jjanz = 1
	            call get_iscat(iianz,cpara,lpara,uerte,
     &	                           maxw,.false.)
	            call del_params(1,ianz,cpara,lpara,maxw)
	            call get_iscat(jjanz,cpara,lpara,verte,
     &	                           maxw,.false.)
	            call del_params (1,ianz,cpara,lpara,maxw)
	            call ber_params (4,cpara,lpara,werte,maxw)
	            do i=1,iianz
	              do j=1,jjanz
	                is=nint(uerte(i))
	                js=nint(verte(j))
	                call mmc_set_vec(ic,is,js,werte,maxw)
	              enddo
	            enddo
	            mmc_cor_energy(ic,MC_VECTOR) = .true.
	            mmc_cor_energy(0 ,MC_VECTOR) = .true.
	            mmc_target_corr(ic,MC_VECTOR) = 0.0
	          elseif(str_comp(cpara(2),'lennard',2,lpara(2),6)) then
	            call del_params (2,ianz,cpara,lpara,maxw)
	            iianz = 1
	            jjanz = 1
	            call get_iscat(iianz,cpara,lpara,uerte,
     &	                           maxw,.false.)
	            call del_params(1,ianz,cpara,lpara,maxw)
	            call get_iscat(jjanz,cpara,lpara,verte,
     &	                           maxw,.false.)
	            call del_params (1,ianz,cpara,lpara,maxw)
	            call ber_params (1,cpara,lpara,werte,maxw)
	            do i=1,iianz
	              do j=1,jjanz
	                is=nint(uerte(i))
	                js=nint(verte(j))
	                call mmc_set_disp(ic,MC_SPRING,is,js,werte(1))
	              enddo
	            enddo
	            mmc_cor_energy(ic,MC_SPRING) = .true.
	            mmc_cor_energy(0 ,MC_SPRING) = .true.
	            mmc_target_corr(ic,MC_SPRING) = werte(1)
	            mmc_len_a = werte(2)
	            mmc_len_b = werte(3)
	            mmc_len_d = werte(4)
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        else
	          ier_num = -14
	          ier_typ = ER_CHEM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ --- 'set temp' : setting kT for MC simulation
c
            elseif(cpara(1)(1:2).eq.'TE') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call ber_params (ianz,cpara,lpara,werte,maxw)
	      mo_kt = werte(1)
c
c------ --- 'set vector' : setting of neighbouring vectors
c
            elseif(cpara(1)(1:2).eq.'VE') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call chem_set_vec (ianz,cpara,lpara,werte,maxw)
c
c------ --- 'set fixed' : setting fixed atom coordinate ranges
c
            elseif(cpara(1)(1:2).eq.'FI') then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      if(str_comp(cpara(1),'OFF',2,lpara(1),3)) then
	        mmc_l_constrains = .false.
	      elseif(str_comp(cpara(1),'X',1,lpara(1),1)) then
	        call del_params (1,ianz,cpara,lpara,maxw)
	        call ber_params (ianz,cpara,lpara,werte,maxw)
	        mmc_c_min(1) = werte(1)
	        mmc_c_max(1) = werte(2)
	        mmc_constrain_type   = MMC_C_XYZ
	      elseif(str_comp(cpara(1),'Y',1,lpara(1),1)) then
	        call del_params (1,ianz,cpara,lpara,maxw)
	        call ber_params (ianz,cpara,lpara,werte,maxw)
	        mmc_c_min(2) = werte(1)
	        mmc_c_max(2) = werte(2)
	        mmc_constrain_type   = MMC_C_XYZ
	      elseif(str_comp(cpara(1),'Z',1,lpara(1),1)) then
	        call del_params (1,ianz,cpara,lpara,maxw)
	        call ber_params (ianz,cpara,lpara,werte,maxw)
	        mmc_c_min(3) = werte(1)
	        mmc_c_max(3) = werte(2)
	        mmc_constrain_type   = MMC_C_XYZ
	      elseif(str_comp(cpara(1),'RAD',1,lpara(1),3)) then
	        call del_params (1,ianz,cpara,lpara,maxw)
	        call ber_params (ianz,cpara,lpara,werte,maxw)
	        mmc_c_rad    = werte(1)
	        mmc_constrain_type   = MMC_C_RADIUS
	      endif
c
c------ --- no valid subcommand
c
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	endif
c
	end
c*****7*****************************************************************
	subroutine mmc_set_disp(ic,ie,is,js,dist)
c+
c	Set desired displacements
c-
c
	implicit      none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
	include 	'mmc.inc'
c
	integer		ic,ie,is,js,ii,jj
	real		dist
c

	if     (is.ne.-1 .and. js.ne.-1) then
	  mmc_disp(ic,ie,is,js) = dist
	  mmc_disp(ic,ie,js,is) = dist
	elseif (is.eq.-1 .and. js.ne.-1) then
	  do ii=0,cr_nscat
	    mmc_disp(ic,ie,ii,js) = dist
	    mmc_disp(ic,ie,js,ii) = dist
	  enddo  
	elseif (is.ne.-1 .and. js.eq.-1) then
	  do ii=0,cr_nscat
	    mmc_disp(ic,ie,ii,is) = dist
	    mmc_disp(ic,ie,is,ii) = dist
	  enddo  
	else
	  do ii=0,cr_nscat
	    do jj=0,cr_nscat
	      mmc_disp(ic,ie,ii,jj) = dist
	      mmc_disp(ic,ie,jj,ii) = dist
	    enddo
	  enddo  
	endif  
c
	end
c*****7*****************************************************************
	subroutine mmc_set_vec(ic,is,js,werte,maxw)
c+
c	Set desired displacements
c-
c
	implicit      none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
	include 	'mmc.inc'
c
	integer		maxw
c
	integer		ic,is,js,ii,jj
	integer		i,nv
	real		werte(maxw)
c

	if     (is.ne.-1 .and. js.ne.-1) then
	write(*,*) ' mmc_nvec(ic,js,is) ', mmc_nvec(ic,js,is)
	write(*,*) ' mmc_nvec(ic,is,js) ', mmc_nvec(ic,is,js)
	  mmc_nvec(ic,js,is) = mmc_nvec(ic,js,is) + 1
	  mmc_nvec(ic,is,js) = mmc_nvec(ic,js,is)
	  nv                 = mmc_nvec(ic,is,js)
	write(*,*) ' mmc_nvec(ic,js,is) ', mmc_nvec(ic,js,is)
	write(*,*) ' mmc_nvec(ic,is,js) ', mmc_nvec(ic,is,js)
	write(*,*) ' nv                 ', nv
	  do i=1,4
	    mmc_vec(i,nv,ic,is,js) = werte(i)
	    mmc_vec(i,nv,ic,js,is) = werte(i)
	  enddo
	elseif (is.eq.-1 .and. js.ne.-1) then
	  do ii=0,cr_nscat
	      mmc_nvec(ic,js,ii) = mmc_nvec(ic,js,ii) + 1
	      mmc_nvec(ic,ii,js) = mmc_nvec(ic,js,is)
	      nv                 = mmc_nvec(ic,ii,js)
	    do i=1,4
	      mmc_vec(i,nv,ic,ii,js) = werte(i)
	      mmc_vec(i,nv,ic,js,ii) = werte(i)
	    enddo
	  enddo  
	elseif (is.ne.-1 .and. js.eq.-1) then
	  do ii=0,cr_nscat
	      mmc_nvec(ic,is,ii) = mmc_nvec(ic,is,ii) + 1
	      mmc_nvec(ic,ii,is) = mmc_nvec(ic,is,ii)
	      nv                 = mmc_nvec(ic,ii,is)
	    do i=1,4
	      mmc_vec(i,nv,ic,ii,is) = werte(i)
	      mmc_vec(i,nv,ic,is,ii) = werte(i)
	    enddo
	  enddo
	else
	  do ii=0,cr_nscat
	    do jj=ii,cr_nscat
	      mmc_nvec(ic,jj,ii) = mmc_nvec(ic,jj,ii) + 1
	      mmc_nvec(ic,ii,jj) = mmc_nvec(ic,jj,ii)
	      nv                 = mmc_nvec(ic,ii,jj)
	      do i=1,4
	        mmc_vec(i,nv,ic,ii,jj) = werte(i)
	        mmc_vec(i,nv,ic,jj,ii) = werte(i)
	      enddo
	    enddo
	  enddo
	endif
c
	end
c*****7*****************************************************************
	subroutine mmc_set_mode(ianz,cpara,lpara,werte,maxw)
c+
c	Sets MMC    mode
c-
	implicit      none
c
	include 	'config.inc'
	include 	'errlist.inc'
	include 	'mmc.inc'
	include 	'rmc.inc'
c
	integer		maxw
c
	character*200	cpara(maxw)
	integer		lpara(maxw)
	integer		ianz,imode,i
	real		werte(maxw)
	real		sump
c
	if (ianz.ge.1) then
	  call do_cap (cpara(1))
	  if (cpara(1)(1:3).eq.'SHI') then
	    imode = MC_MOVE_DISP  
	  elseif (cpara(1)(1:3).eq.'SWD') then
	    imode = MC_MOVE_SWDISP
	  elseif (cpara(1)(1:3).eq.'SWC') then
	    imode = MC_MOVE_SWCHEM
	  elseif (cpara(1)(1:3).eq.'INV') then
	    imode = MC_MOVE_INVDISP
	  else
	    ier_typ = ER_RMC
	    ier_num = -9
	  endif
c
	  if (ianz.eq.2) then
	    call do_cap(cpara(2))
	    if (cpara(2)(1:1).eq.'A') then
	      mmc_local(imode) = rmc_local_all
	    elseif (cpara(2)(1:1).eq.'L') then
	      mmc_local(imode) = rmc_local_loc
	    elseif (cpara(2)(1:2).eq.'SL') then
	      mmc_local(imode) = rmc_local_locsite
	    elseif (cpara(2)(1:2).eq.'SI') then
	      mmc_local(imode) = rmc_local_site
	    else
	      ier_typ = ER_RMC
	      ier_num = -9
	    endif
	  else
	    mmc_local(imode) = rmc_local_all
	  endif
c
c------	--Set probabilities for the different moves
c
	  mmc_move_prob(imode) = werte(1)
	  sump = 0.0
	  do i=1,MC_N_MOVE
	    sump = sump + mmc_move_prob(i)
	  enddo
	  if(sump.gt.0) then
	    mmc_move_cprob(1) = mmc_move_prob(1)/sump
	    do i=2,MC_N_MOVE
	      mmc_move_cprob(i) = mmc_move_cprob(i-1) + 
     &	                          mmc_move_prob(i)/sump
	    enddo
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine mmc_run_multi
c+
c	This is the MC routine for multiple energy calculations
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'debug.inc'
	include		'random.inc'
	include		'errlist.inc'
	include		'chem.inc'
	include		'rmc.inc'
	include		'mc.inc'
	include		'mmc.inc'
c
	integer		maxw
	parameter	(maxw = MAXSCAT)
c
	integer		maxatom
	parameter	(maxatom = CHEM_MAX_NEIG)
c
	character*200	cpara(maxw)
	character*9	at_name_i,at_name_j,at_name
	character*24	c_energy(0:MC_N_ENERGY)
	real		werte(maxw),wwerte(maxw),wwwerte(maxw)
	real		verte(maxw),vverte(maxw),vvverte(maxw)
	real		start,zeit,seknds
	real		disp1,disp2
	real		disp(3,0:CHEM_MAX_NEIG,2)
	real		posz(3)
	real		posz2(3)
	real		patom (3,0:CHEM_MAX_NEIG,CHEM_MAX_CENT)
	integer		iatom (0:CHEM_MAX_NEIG,CHEM_MAX_CENT)
	integer		lpara(maxw)
	integer		igen,itry,iacc_good,iacc_bad
	integer		isel(CHEM_MAX_ATOM)
	integer		iselz,iselz2
	integer		latom(3)
	integer         lbeg(3)
	integer		ic,is(2),iz1(3),iz2(3),ie
	integer		iz(2,3)
	integer		i,j,k,natoms,ianz,janz,ia,l,kanz
	integer		natom(CHEM_MAX_CENT)
	integer		ncent
	integer		icent
	integer		imove
	integer		iscat
	integer         zh,zm,zs
	logical		loop,laccept,done
	logical		valid_e
	logical		valid_all
c
	real		d
	real		u(3)
	real		z
c
	real		e_old(0:MC_N_ENERGY)
	real		e_new(0:MC_N_ENERGY)
c
	real		mmc_energy_angle
	real		mmc_energy_occ
	real		mmc_energy_spr
	real		mmc_energy_vec
	real		mmc_energy_len
	real		ran1,gasdev
	integer		len_str
	logical		atom_allowed
	real		do_blen
c
	data c_energy/
     &	 '                        ',
     &	 'Occupation correlation  ',
     &	 'Displacement correlation',
     &	 'Displacement energy     ',
     &	 'Angular energy          ',
     &	 'Vector energy           ',
     &	 'Bond length energy      ',
     &	 'Lennard Jones Potential '/
c
	do i=0,MC_N_ENERGY
	  n_e_av_p(i) = 0
	  n_e_av_m(i) = 0
	  n_e_av_z(i) = 0
	  e_aver_p(i) = 0.0
	  e_aver_m(i) = 0.0
	enddo
	do i=1,maxw
	  werte  (i) = 0.0
	  wwerte (i) = 0.0
	  wwwerte(i) = 0.0
	enddo
CDBG
	if(dbg) then
	write(*,*) ' 0=both,i=1 angular, i=2, spring'
	read(*,*) i
	if(i.eq.0 .or. i.eq.1) then
	  mmc_cor_energy(0,MC_ANGLE)=.true.
	  do j=1,chem_ncor
	    if(chem_ctyp(j).eq.CHEM_ANG .or. 
     &	       chem_ctyp(j).eq.CHEM_ENVIR) then
	      mmc_cor_energy(j,MC_ANGLE)=.true.
	    endif
	  enddo
	endif
	if(i.eq.0 .or. i.eq.2) then
	  mmc_cor_energy(0,MC_SPRING)=.true.
	  do j=1,chem_ncor
	    if(chem_ctyp(j).eq.CHEM_VEC   .or.
     &	       chem_ctyp(j).eq.CHEM_DIST  .or.
     &	       chem_ctyp(j).eq.CHEM_RANGE .or.
     &	       chem_ctyp(j).eq.CHEM_ENVIR    ) then
	      mmc_cor_energy(j,MC_SPRING)=.true.
	write(*,*) 'mmc_cor_energy(j,MC_SPRING)',mmc_cor_energy(j,MC_SPRING)
	    endif
	  enddo
	endif
	endif
CDBG
CDBG	do j=1,chem_ncor
CDBG	  write(*,*) 'Neig , energies ',j,(mmc_cor_energy(j,i),i=0,6)
CDBG	enddo
CDBG	read(*,*) i
CDBG
CDBG	write(*,*) 'Selelect move 0=both, 1=disp,2=swdisp, 3=invdisp,4=swchem'
CDBG	read(*,*)  imove
c
c------ reset some counters
c
	igen      = 0
	itry      = 0
	iacc_good = 0
	iacc_bad  = 0
	loop      = .true.
	done      = .true.
	lbeg(1)   = -1
	lbeg(2)   =  0
	lbeg(3)   =  0
c
	latom(1)  = len_str(mo_atom(1))
	latom(2)  = len_str(mo_atom(2))
	latom(3)  = len_str(mo_atom(3))
c
	write (output_io,1000) (cr_icc(i),i=1,3),cr_natoms
CDBG
CDBG	natoms = 1
CDBG	iselz  = 1
CDBG	do while(iselz.ne.0)
CDBG	  call mmc_limit_selection(isel,natoms)
CDBG	  iselz = isel(1)
CDBG	  write(*,*) ' selected atom ',iselz
CDBG	  write(*,*) ' type, pos     ',cr_iscat(iselz),(cr_pos(j,iselz),j=1,3)
CDBG	  read (*,*) iselz
CDBG	enddo
CDBG	return
c
c------ Setup atom arrays
c
	ianz = 1
	cpara(1)=mo_atom(1)
	lpara(1)=latom(1)
	if(dbg) then
	  write(*,*) 'cpara   : ',cpara(1)(1:lpara(1)),lpara(1)
	endif
	if(lpara(1).gt.0) then
	  call get_iscat(ianz,cpara,lpara, werte,maxw,.false.)
	else
	  return
	endif
	janz = 1
	cpara(1)=mo_atom(2)
	lpara(1)=latom(2)
	if(dbg) then
	  write(*,*) 'cpara   : ',cpara(1)(1:lpara(1)),lpara(1)
	endif
	if(lpara(1).gt.0) then
	  call get_iscat(janz,cpara,lpara,wwerte,maxw,.false.)
	else
	  return
	endif
	kanz = 1
	cpara(1)=mo_atom(3)
	lpara(1)=latom(3)
	if(dbg) then
	  write(*,*) 'cpara   : ',cpara(1)(1:lpara(1)),lpara(1)
	endif
	if(lpara(1).gt.0) then
	  call get_iscat(kanz,cpara,lpara,wwwerte,maxw,.false.)
	endif
c
CDBG
CDBG	if(dbg) then
CDBG	  write(*,*) '   werte : ',(werte(i),i=1,ianz)
CDBG	  write(*,*) '  wwerte : ',(wwerte(i),i=1,janz)
CDBG	  write(*,*) ' wwwerte : ',(wwwerte(i),i=1,kanz)
CDBG	  write(*,*) ' ende  of get_iscat'
CDBG	  read(*,*) i
CDBG	endif
	if (ier_num.ne.0) return
c
	l       =3
	cpara(1)=mo_atom(1)
	cpara(2)=mo_atom(2)
	cpara(3)=mo_atom(3)
	lpara(1)=latom(1)
	lpara(2)=latom(2)
	lpara(3)=latom(3)
c
	do ic=1,chem_ncor
	  do ie=1,MC_N_ENERGY
	    if(mmc_cor_energy(ic,ie)) then
	      if (mmc_const(ic,ie).eq.0.0) then
	        mmc_const(ic,ie) = mmc_cfac(ic,ie)*1.0
	      endif
	    endif
	  enddo
	enddo
c
c------	Initialize the different energies
c
c------	Occupation Correlation
c
	if(mmc_cor_energy(0,MC_OCC)) then
c
c------ Obtain starting interactions
c
	  l = 2
	  call chem_corr_occ(l,mo_atom,latom,2,.false.,lbeg  )
	  do i=1,chem_ncor
	    mmc_ach_corr(i,MC_OCC) = mo_ach_corr(i)
	    mmc_const   (i,MC_OCC) = mmc_const(i,MC_OCC) - 
     &	                             mmc_cfac(i,MC_OCC)*
     &	    ((mmc_target_corr(i,MC_OCC)-mmc_ach_corr(i,MC_OCC))/2.)
	  enddo
	endif
c
c------	Displacement correlation
c
	if(mmc_cor_energy(0,MC_DISP)) then
	  continue
	endif
c
c------	Displacement (Hooke's law)
c
	if(mmc_cor_energy(0,MC_SPRING)) then
	  call chem_aver(.false.)
	endif
c
c------	Angular energy
c
	if(mmc_cor_energy(0,MC_ANGLE)) then
	  continue
	endif
c
c------	Vector energy, i.e. directional bond length
c
	if(mmc_cor_energy(0,MC_VECTOR)) then
	  continue
	endif
c
c------	Bond length energy, non - directional
c
	if(mmc_cor_energy(0,MC_BLEN)) then
	  continue
	endif
CDBG
CDBG	write(*,*) 'teste neues chem_neighbour'
CDBG	write(*,*) 'give zentral atom '
CDBG	read (*,*) iselz
CDBG1234	continue
CDBG	isel(1) = iselz
CDBG	natoms = 1
CDBG	do iselz = 166,168
CDBG	do iselz = 50,51
CDBG	write(*,*) ' Zentral Atom ',iselz
CDBG	ia = 1
CDBG	do ic=1,chem_ncor
CDBG	write(*,*) ' give Correlation'
CDBG	read(*,*) ic
CDBG	  write(*,*) 'altes Neighbour'
CDBG	      call chem_neighbour      (iselz,ic,iatom,patom,
CDBG     &	                          natom,CHEM_MAX_NEIG)
CDBG	  write(*,*) 'Energy Calculation mit neuem Neighbour'
CDBG	      call chem_neighbour_multi(isel(ia),ic,iatom,patom,natom,
CDBG     &	                       ncent,CHEM_MAX_CENT)
CDBG	    l       =2
CDBG	    cpara(1)='all'
CDBG	    cpara(2)='all'
CDBG	    lpara(1)=3
CDBG	    lpara(2)=3
CDBG	    call chem_vector_multi(l,cpara,lpara,verte,maxw,.false.)
CDBG	  write(*,*) 'Energy  Vector '
CDBG	    icent = 1
CDBG	      e_old(MC_VECTOR) = 
CDBG     &	             mmc_energy_vec(isel,ia,ic,iatom,patom,icent,natom)
CDBG	  write(*,*) 'Energy  Vector ', e_old(MC_VECTOR)
CDBG	enddo
CDBG	write(*,*) 'give zentral atom '
CDBG	read(*,*) iselz
CDBG	enddo
CDBG	if(iselz.ne.0) goto 1234
CDBG
CDBG	Define a dummy constallation
	natom(1) = 1
	iatom(0,1) = 166
	iatom(1,1) = 167
	patom(1,0,1) = 0.0
	patom(2,0,1) = 0.0
	patom(3,0,1) = 0.0
	patom(1,1,1) = 0.5
	patom(2,1,1) = 0.0
	patom(3,1,1) = 0.0
	if(mo_cyc.eq.0) loop = .false.
c
c------ Main MC loop here
c
	write(*,*) ' Starte Main loop '
	start = seknds(0.0)
	do while (loop)
	  laccept = .true.
	  igen    = igen + 1
c
c
c------ - selecting sites
c
	  natoms  = 1
10	  continue
c
c------	--- Choose a move at random
c
	    z = ran1(idum)
	    i = 1
	    do while (z.gt.mmc_move_cprob(i) .and. i.lt.MC_N_MOVE)
	      i = i + 1
	    enddo
	    mmc_move = i
	    mo_local = mmc_local(i)
CDBG	write(*,*) ' mmc_move,mo_local,z', mmc_move,mo_local,z
c
	    if(mmc_move.eq.MC_MOVE_DISP .or. 
     &	       mmc_move.eq.MC_MOVE_INVDISP           ) then
	      if(mmc_l_limited) then
	        call mmc_limit_selection(isel,natoms)
	      else
	        isel(1) = int(ran1(idum)*cr_natoms)+1
	      endif
CDBG
CDBG	write(*,*) 'select atom'
CDBG	read(*,*) isel(1)
	      iselz   = isel(1)
	      if (isel(1).gt.cr_natoms .or. isel(1).lt.1) goto 10
	      laccept = atom_allowed(iselz,  werte,ianz,maxw) .or.
     &	                atom_allowed(iselz, wwerte,janz,maxw) .or.
     &	                atom_allowed(iselz,wwwerte,kanz,maxw)
	      call indextocell(isel(1),iz1,is(1))
	      do i=1,3
	        iz(1,i) = iz1(i)
	      enddo
	    elseif(mmc_move.eq.MC_MOVE_SWDISP        ) then
	      natoms  = 2
	      mo_local = rmc_local_site
	      call rmc_select (mo_local,natoms,isel,iz1,iz2,is(1),is(2))
	      iselz   = isel(1)
	      iselz2  = isel(2)
	      do i=1,3
	        iz(1,i) = iz1(i)
	        iz(2,i) = iz2(i)
	      enddo
CDBG
CDBG	write(*,*) isel(1), cr_iscat(isel(1)),iz(1,i),i=1,3,is(1)
CDBG	write(*,*) isel(2), cr_iscat(isel(2)),iz(2,i),i=1,3,is(2)
CDBG	read(*,*) i
	      laccept = atom_allowed(isel(1),  werte,ianz,maxw) .and.
     &	                atom_allowed(isel(2),  werte,ianz,maxw)     .or.
     &	                atom_allowed(isel(1), wwerte,janz,maxw) .and.
     &	                atom_allowed(isel(2), wwerte,janz,maxw)     .or.
     &	                atom_allowed(isel(1),wwwerte,kanz,maxw) .and.
     &	                atom_allowed(isel(2),wwwerte,kanz,maxw)     
	    elseif(mmc_move.eq.MC_MOVE_SWCHEM        ) then
	      natoms  = 2
	      mo_local = rmc_local_site
	      call rmc_select (mo_local,natoms,isel,iz1,iz2,is(1),is(2))
CDBG	isel(1) = 74
CDBG	isel(2) = 75
CDBG	write(*,*) ' isel              ',isel(1),isel(2)
	      iselz   = isel(1)
	      iselz2  = isel(2)
	      do i=1,3
	        iz(1,i) = iz1(i)
	        iz(2,i) = iz2(i)
	      enddo
	      laccept = atom_allowed(isel(1),  werte,ianz,maxw) .and.
     &	                atom_allowed(isel(2), wwerte,janz,maxw)     .or.
     &	                atom_allowed(isel(1),  werte,janz,maxw) .and.
     &	                atom_allowed(isel(2),wwwerte,kanz,maxw)     .or.
     &	                atom_allowed(isel(1), wwerte,janz,maxw) .and.
     &	                atom_allowed(isel(2),wwwerte,kanz,maxw)     .or.
     &	                atom_allowed(isel(2),  werte,ianz,maxw) .and.
     &	                atom_allowed(isel(1), wwerte,janz,maxw)     .or.
     &	                atom_allowed(isel(2),  werte,janz,maxw) .and.
     &	                atom_allowed(isel(1),wwwerte,kanz,maxw)     .or.
     &	                atom_allowed(isel(2), wwerte,janz,maxw) .and.
     &	                atom_allowed(isel(1),wwwerte,kanz,maxw)
	    endif
c
c-----	----Check whether geometrical constrains apply
c
	    call check_geometry_multi(isel,natoms,laccept)
c
c----- -- Try move
c
	  if (laccept) then
CDBG	    write(*,*) ' isel              ',isel(1),isel(2)

CDBG	    if(cr_iscat(isel(1)).ne.1 ) then
CDBG	      write(*,*) '================================================='
CDBG	      write(*,*) ' Accepted Atom: ', isel(1),cr_iscat(isel(1))
CDBG	      write(*,*) ' Position     : ',(cr_pos(i,isel(1)),i=1,3)
CDBG	      write(*,*) ' Atome in werte   : ',(werte(i),i=1,ianz)
CDBG	      write(*,*) ' Atome in wwerte  : ',(wwerte(i),i=1,janz)
CDBG	      write(*,*) ' Atome in wwwerte : ',(wwwerte(i),i=1,kanz)
CDBG	      write(*,*)
CDBG	      read(*,*) i
CDBG	    endif
	    itry = itry + 1
	    done = .false.
c
c------	----Calculate old energy
c
	    do ic=1,chem_ncor
	      do ie=0,MC_N_ENERGY
	        e_old(ie) = 0.0
	      enddo
	    enddo
CDBG
CDBG	write(*,*) 'd,e_old(MC_SPRING),ier_num',d,e_old(MC_SPRING),ier_num,
CDBG     &	ier_typ
c
c------	----Loop over all modified atoms
c
	    do ia=1,natoms
	      do i=1,3
	        u(i) = cr_pos(i,isel(ia))-
     &	           chem_ave_pos(i,is(ia))-float(iz(ia,i)-1)-cr_dim0(i,1)
	      enddo
CDBG	      d = do_blen(.true.,u,u)
CDBG	      e_old(MC_SPRING) = mmc_const(0,MC_SPRING)*d**2
CDBG	write(*,*) 'e_old(MC_SPRING)',e_old(MC_SPRING)
c
c------	------Set the assumption of at least one propper energy to FALSE
c	      Will be set to TRUE if at least one energy calculation is fine
c
	      valid_all = .false.
c
c------	------Loop over all defined neighbour interactions
c
	      do ic=1,chem_ncor
	        call chem_neighbour_multi(isel(ia),ic,iatom,patom,natom,
     &	                       ncent,maxatom)
CDBG	read(*,*) i
CDBG	if(ic.eq.88 .or. ic.eq.89) then
CDBG	  if(cr_iscat(isel(ia)).eq.1) then
CDBG	    if(isel(ia).eq.1405) then
CDBG	  write(*,*) ' ic,ncent,ia,isel(ia),natom ',ic,ncent,ia,isel(ia),
CDBG     &	               natom(icent)
CDBG	endif
CDBG	endif
CDBG	endif
	        do icent=1,ncent
CDBG
CDBG	write(*,*) 'icent, natom ',icent,natom(icent)
	          if(natom(icent).gt.0) then
CDBG
CDBG	write(*,*) ' iatom ',(iatom(i,icent),i=1,natom(icent))
c
c------ ------- Calc old energy for those energies that are affected by the move
c
	            if(mmc_cor_energy(ic,MC_OCC)) then
c
c------	------- Occupation Correlation
c
	              e_old(MC_OCC) = e_old(MC_OCC) +
     &	               mmc_energy_occ(natoms,isel,ianz,werte,maxw,
     &	               valid_e)
	              valid_all = valid_all .or. valid_e
CDBG
CDBG	            write(*,*) ' e_old CORR   ',e_old(MC_OCC)
	            endif
c
c------	------- Displacement correlation
c
	            if(mmc_cor_energy(ic,MC_DISP)) then
	              e_old(MC_DISP) = 0.0
CDBG
CDBG	            write(*,*) ' e_old cdisp  ',e_old(MC_DISP)
	            endif
c
c------	------- Displacement (Hooke's law)
c
	            if(mmc_cor_energy(ic,MC_SPRING)) then
	              e_old(MC_SPRING) = e_old(MC_SPRING) +
     &	              mmc_energy_spr(isel,ia,ic,iatom,patom,icent,natom,
     &	              valid_e)
	              valid_all = valid_all .or. valid_e
CDBG
CDBG	if(ic.eq.89 .and. isel(ia).eq.1405) then
CDBG	if(               isel(1).eq.1405) then
CDBG	            write(*,*) ' ic,e_old spring',ic,e_old(MC_SPRING)
CDBG	endif
	            endif
c
c------	------- Angular energy
c
	            if(mmc_cor_energy(ic,MC_ANGLE)) then
	              e_old(MC_ANGLE) = e_old(MC_ANGLE) +
     &	              mmc_energy_angle(isel,ic,iatom,patom,icent,natom,
     &	              valid_e)
	              valid_all = valid_all .or. valid_e
CDBG
CDBG	            write(*,*) ' e_old angle ',e_old(MC_ANGLE)
	            endif
c
c------	------- Vector energy, i.e. directional bond length
c
	            if(mmc_cor_energy(ic,MC_VECTOR)) then
	              e_old(MC_VECTOR) = e_old(MC_VECTOR) +
     &	             mmc_energy_vec(isel,ia,ic,iatom,patom,icent,natom,
     &	             valid_e)
	              valid_all = valid_all .or. valid_e
	            endif
c
c------	------- Bond length energy, non - directional
c
	            if(mmc_cor_energy(ic,MC_BLEN)) then
	              continue
	            endif
c
c------	------- Lennard-Jones Potential   
c
	            if(mmc_cor_energy(ic,MC_LENNARD)) then
	              e_old(MC_LENNARD) = e_old(MC_LENNARD) +
     &	              mmc_energy_len(isel,ia,ic,iatom,patom,icent,natom,
     &	              valid_e)
	              valid_all = valid_all .or. valid_e
	            endif
	          endif
	        enddo
	      enddo
	    enddo
CBDG
CDBG	write(*,*) 'e_old &&&&&&&&&&&&&&',e_old
CDBG	read(*,*) i
c
c------	----If a proper energy was found, modify the atom
c
CDBG
CDBG	write(*,*) ' Proper old Energies ? ',valid_all
	    if(valid_all) then
C
c------	----Perform the modifications of the atoms
c
	    if(mmc_move.eq.MC_MOVE_DISP) then
c
c------	------Displace atoms from current positions
c
c
c------	------Modify the central atom
c
	      do i=1,3
     	          disp(i,0,1) = gasdev(mo_maxmove(i,cr_iscat(iselz)))
	          posz(i)        = cr_pos(i,iselz)
	          cr_pos(i,iselz) = cr_pos(i,iselz) + disp(i,0,1)
CDBG
CDBG	      if(dbg) then
CDBG	        write(*,'(a,i3,i5,4(f6.3,1x))') 'Zentral     ', 0,iselz,
CDBG     &        	cr_iscat(iselz),
CDBG     &	        cr_pos(i,iselz),posz(i),disp(i,0,1)
CDBG	      endif
	      enddo
CDBG	write(*,*) ' Displacement          ', (disp(j,0,1),j=1,3)
CDBG	write(*,*) ' Position              ', (cr_pos(j,isel(1)),j=1,3)
	    elseif(mmc_move.eq.MC_MOVE_SWDISP) then
c
c-----	------Switch displacement of two selected atoms and their neighbours
c
	      call indextocell(isel(1),iz1,is(1))
	      call indextocell(isel(2),iz2,is(2))
c
c------	------Modify the central atom
c
CDBG
CDBG	write(*,*) 'zentral atom 1'
CDBG	write(*,*) ' typ, index,isite,icell', cr_iscat(isel(1)),isel(1),is(1),iz1
CDBG	write(*,*) ' Position              ', (cr_pos(j,isel(1)),j=1,3)
CDBG	write(*,*) 'zentral atom 2'
CDBG	write(*,*) ' typ, index,isite,icell', cr_iscat(isel(2)),isel(2),is(2),iz2
CDBG	write(*,*) ' Position              ', (cr_pos(j,isel(2)),j=1,3)
	        do j=1,3
	          disp1 = cr_pos(j,isel(1))-chem_ave_pos(j,is(1))-
     &	                  float(iz(1,j)-1)-cr_dim0(j,1)
	          disp2 = cr_pos(j,isel(2))-chem_ave_pos(j,is(2))-
     &	                  float(iz(2,j)-1)-cr_dim0(j,1)
	          disp(j,0,1) = - disp1 + disp2
	          disp(j,0,2) = - disp2 + disp1
	          posz (j)          = cr_pos(j,isel(1))
	          cr_pos(j,isel(1)) = cr_pos(j,isel(1)) + disp(j,0,1)
	          posz2(j)          = cr_pos(j,isel(2))
	          cr_pos(j,isel(2)) = cr_pos(j,isel(2)) + disp(j,0,2)
	        enddo
CDBG
CDBG	write(*,*) 'zentral atom 1'
CDBG	write(*,*) ' Displacement          ', (disp(j,0,1),j=1,3)
CDBG	write(*,*) ' Position              ', (cr_pos(j,isel(1)),j=1,3)
CDBG	write(*,*) 'zentral atom 2'
CDBG	write(*,*) ' Displacement          ', (disp(j,0,2),j=1,3)
CDBG	write(*,*) ' Position              ', (cr_pos(j,isel(2)),j=1,3)
CDBG	read(*,*) i
	    elseif(mmc_move.eq.MC_MOVE_INVDISP) then
c
c-----	------Switch displacement of a selected atom
c
	      call indextocell(isel(1),iz1,is(1))
CDBG
CDBG	write(*,*) 'zentral atom 1'
CDBG	write(*,*) ' typ, index,isite,icell', cr_iscat(isel(1)),isel(1),is(1),iz1
CDBG	write(*,*) ' Position              ', (cr_pos(j,isel(1)),j=1,3)
	        do j=1,3
	          disp1 = cr_pos(j,isel(1))-chem_ave_pos(j,is(1))-
     &	                  float(iz(1,j)-1)-cr_dim0(j,1)
	          disp(j,0,1) = - 2* disp1 
	          posz (j)          = cr_pos(j,isel(1))
	          cr_pos(j,isel(1)) = cr_pos(j,isel(1)) + disp(j,0,1)
	        enddo
CDBG
CDBG	write(*,*) ' Displacement          ', (disp(j,0,1),j=1,3)
CDBG	write(*,*) ' Position              ', (cr_pos(j,isel(1)),j=1,3)
CDBG	read(*,*) i
	    elseif(mmc_move.eq.MC_MOVE_SWCHEM) then
c
c------	------Switch the Chemistry of two selected atoms
c
	      iscat             = cr_iscat(isel(2))
	      cr_iscat(isel(2)) = cr_iscat(isel(1))
	      cr_iscat(isel(1)) = iscat
c
c-----	------End of Modification of atoms according to different moves
c
	    endif
c
CDBG
CDBG	write(*,*) ' Rufe Energie(neu) auf ========================='
c
c------	----Calculate new energy
c
	    do ie=0,MC_N_ENERGY
	      e_new(ie) = 0.0
	    enddo
	    e_new(MC_SPRING) = mmc_const(0,MC_SPRING)*d**2
c
c------	------Set the assumption of at least one propper energy to FALSE
c	      Will be set to TRUE if at least one energy calculation is fine
c
	    valid_all = .false.
c
c------	----Loop over all modified atoms
c
	    do ia=1,natoms
	      do i=1,3
	        u(i) = cr_pos(i,isel(ia))-
     &	           chem_ave_pos(i,is(ia))-float(iz(ia,i)-1)-cr_dim0(i,1)
	      enddo
	      d = do_blen(.true.,u,u)
c
c------	------Loop over all defined neighbour interactions
c
	      do ic=1,chem_ncor
	        call chem_neighbour_multi(isel(ia),ic,iatom,patom,natom,
     &	                       ncent,maxatom)
	        do icent=1,ncent
	          if(natom(icent).gt.0) then
c
c------ ------- Calc new energy for those energies that are affected by the move
c
	            if(mmc_cor_energy(ic,MC_OCC)) then
c
c------	------- Occupation Correlation
c
	              e_new(MC_OCC) = e_new(MC_OCC) +
     &	               mmc_energy_occ(natoms,isel,ianz,werte,maxw,
     &	               valid_e)
	              valid_all = valid_all .or. valid_e
CDBG	            write(*,*) ' e_new OCC   ',e_new(MC_OCC   )
	            endif
c
c------	------- Displacement correlation
c
	            if(mmc_cor_energy(ic,MC_DISP)) then
	              e_new(MC_DISP) = 0.0
CDBG	            write(*,*) ' e_new CDISP ',e_new(MC_DISP  )
	            endif
c
c------	------- Displacement (Hooke's law)
c
	            if(mmc_cor_energy(ic,MC_SPRING)) then
	              e_new(MC_SPRING) = e_new(MC_SPRING) +
     &	             mmc_energy_spr(isel,ia,ic,iatom,patom,icent,natom,
     &	             valid_e)
	              valid_all = valid_all .or. valid_e
CDBG
CDBG	if(ic.eq.89 .and. isel(1).eq.1405) then
CDBG	            write(*,*) ' e_new spring',e_new(MC_SPRING)
CDBG	endif
	            endif
c
c------	------- Angular energy
c
	            if(mmc_cor_energy(ic,MC_ANGLE)) then
	              e_new(MC_ANGLE) = e_new(MC_ANGLE) +
     &	             mmc_energy_angle(isel,ic,iatom,patom,icent,natom,
     &	             valid_e)
	              valid_all = valid_all .or. valid_e
CDBG
CDBG	          write(*,*) ' e_new angle',e_new(MC_ANGLE)
	            endif
c
c------	------- Vector energy, i.e. directional bond length
c
	            if(mmc_cor_energy(ic,MC_VECTOR)) then
	              e_new(MC_VECTOR) = e_new(MC_VECTOR) +
     &	             mmc_energy_vec(isel,ia,ic,iatom,patom,icent,natom,
     &	             valid_e)
	              valid_all = valid_all .or. valid_e
	            endif
c
c------	------- Bond length energy, non - directional
c
	            if(mmc_cor_energy(ic,MC_BLEN)) then
	              continue
	            endif
c
c------	------- Lennard-Jones Potential   
c
	            if(mmc_cor_energy(ic,MC_LENNARD)) then
	              e_new(MC_LENNARD) = e_new(MC_LENNARD) +
     &	              mmc_energy_len(isel,ia,ic,iatom,patom,icent,natom,
     &	              valid_e)
	              valid_all = valid_all .or. valid_e
	            endif
	          endif
	        enddo
	      enddo
	    enddo
CDBG
CDBG	write(*,*) 'e_new ++++++++++++++',e_new
	    if (ier_num.ne.0) return
c
c------	------The comparison of the energies is done only if a proper 
c	      new energy was found. Otherwise the move is automatically
c	      rejected. This might happen, if an atom has moved outside
c	      the allowed sphere of influence.
c
CDBG
CDBG	write(*,*) ' Proper new Energies ? ',valid_all
	      if(valid_all) then
c
c------ --- Test and accept/reject move
c
CDBG
CDBG	write(*,*) ' e_new - e_old ANGLE  ',e_new(MC_ANGLE )-e_old(MC_ANGLE )
CDBG	write(*,*) ' e_new - e_old SPRING ',e_new(MC_SPRING)-e_old(MC_SPRING)
CDBG	write(*,*) ' e_new - e_old VECTOR ',e_new(MC_VECTOR)-e_old(MC_VECTOR)
	        call mmc_test_multi(iacc_good,iacc_bad,e_new,e_old,
     &	                            laccept)
	      else
	        laccept = .false.
	      endif
CDBG
CDBG	      write(*,*) ' accept: ',laccept
c
c------	----The move was not accepted, move atoms back to old places
c
	    if (.not.laccept) then
	      if(mmc_move.ne.MC_MOVE_SWCHEM) then
CDBG	write(*,*) 'Restored to  IC ATOM SCAT CR_POS   POS   DISP'
	        do i=1,3
	            cr_pos(i,iselz) = posz(i)
CDBG	write(*,'(a,i3,2i5,3(f9.3,1x))') 
CDBG     &	'Restored to ',0,iselz,
CDBG     &	cr_iscat(iselz),
CDBG     &	cr_pos(i,iselz),posz(i),disp(i,0,1)
	        enddo
CDBG	read(*,*) i
	        if(mmc_move.eq.MC_MOVE_SWDISP) then
CDBG
CDBG	write(*,*) 'Restored to  IC ATOM SCAT CR_POS   POS   DISP'
	          do i=1,3
	              cr_pos(i,iselz2) = posz2(i)
CDBG	write(*,'(a,i3,2i5,3(f9.3,1x))') 
CDBG     &	  'Restored to ',0,iselz2,
CDBG     &	  cr_iscat(iselz2),
CDBG     &	  cr_pos(i,iselz2),posz2(i),disp(i,0,2)
	          enddo
	        endif
CDBG	read(*,*) i
	      else
c
c------	------Switch the Chemistry of two selected atoms
c
	        iscat             = cr_iscat(isel(2))
	        cr_iscat(isel(2)) = cr_iscat(isel(1))
	        cr_iscat(isel(1)) = iscat
	      endif
	    endif
	  endif
c
c------	--End of modification of atoms if a proper "old" energy was found
c
	  endif
c
	  loop = (itry.lt.mo_cyc)
c
	  if (igen.gt.1000*mo_feed .and. itry.eq.0) then
	    ier_num = -2
	    ier_typ = ER_MC
	    loop    = .false.
	  endif
c
c-------  Feedback ?
c
	  if (mod(itry,mo_feed).eq.0 .and. .not.done .and. loop) then
	    done = .true.
	    write (output_io,2000) igen,itry,iacc_good,iacc_bad
	    if(mmc_cor_energy(0,MC_ANGLE)) then
c
c------	------Angular energy was selected, give feedback
c
	    l       =3
	    cpara(1)=mo_atom(1)
	    cpara(2)=mo_atom(2)
	    cpara(3)=mo_atom(3)
	    lpara(1)=latom(1)
	    lpara(2)=latom(2)
	    lpara(3)=latom(3)
	  cpara(1)='all'
	  cpara(2)='all'
	  cpara(3)='all'
	  lpara(1)=3
	  lpara(2)=3
	  lpara(3)=3
c
CDBG
	    if(dbg) then
	      write(*,*) ' l ', l
	      write(*,*) ' cpara(1) ', cpara(1)(1:lpara(1))
	      write(*,*) ' cpara(2) ', cpara(2)(1:lpara(2))
	      write(*,*) ' cpara(3) ', cpara(3)(1:lpara(3))
	      write(*,*) ' maxw     ', maxw
	    endif
	    call chem_angle_multi(l,cpara,lpara,verte,vverte,vvverte,
     &	                    maxw,.false.)
	        do k=1,chem_ncor
	          if(mmc_cor_energy(k,4)) then
	    do i=0,cr_nscat
	      do j=i,cr_nscat
	        at_name_i=at_name(i)
	        at_name_j=at_name(j)
	            if (mmc_disp(k,MC_ANGLE,i,j).ne.0.0) then
	              write (output_io,2300) k,at_name_i,at_name_j,
     &	                           mmc_disp(k,MC_ANGLE,i,j),
     &	                           chem_disp_ave(k,i,j),
     &	                           chem_disp_sig(k,i,j),
     &	             mmc_disp(k,MC_ANGLE,i,j)-chem_disp_ave(k,i,j)
	            endif
	      enddo
	    enddo
	          endif
	        enddo
	    endif
	    if(mmc_cor_energy(0,MC_SPRING)) then
c
c------	------SPRING  energy was selected, give feedback
c
	    l       =2
	    cpara(1)='all'
	    cpara(2)='all'
	    lpara(1)=3
	    lpara(2)=3
	    call chem_disp_multi(l,cpara,lpara,verte,maxw,.false.)
	    do i=0,cr_nscat
	      do j=i,cr_nscat
	        at_name_i=at_name(i)
	        at_name_j=at_name(j)
	        do k=1,chem_ncor
	  if(mmc_cor_energy(k,3)) then
	          if (mmc_disp(k,MC_SPRING,i,j).ne.0.0) then
	            write (output_io,2300) k,at_name_i,at_name_j,
     &	                           mmc_disp(k,MC_SPRING,i,j),
     &	                           chem_disp_ave(k,i,j),
     &	                           chem_disp_sig(k,i,j),
     &	             mmc_disp(k,MC_SPRING,i,j)-chem_disp_ave(k,i,j)
	          endif
	          endif
	        enddo
	      enddo
	    enddo
	    endif
	    if(mmc_cor_energy(0,MC_VECTOR)) then
c
c------	------VECTOR  energy was selected, give feedback
c
	    l       =2
	    cpara(1)='all'
	    cpara(2)='all'
	    lpara(1)=3
	    lpara(2)=3
	    call chem_vector_multi(l,cpara,lpara,verte,maxw,.false.)
	        do k=1,chem_ncor
	          if(mmc_cor_energy(k,MC_VECTOR)) then
	    do i=0,cr_nscat
	      do j=i,cr_nscat
	        at_name_i=at_name(i)
	        at_name_j=at_name(j)
	            do l=1,mmc_nvec(k,i,j)
CDBG	          if (mmc_vec(k,MC_VECTOR,i,j).ne.0.0) then
	            write (output_io,2400)
     &	                           mmc_vec      (1,l,k,i,j),
     &	                           chem_vect_ave(1,l,k,i,j),
     &	                           chem_vect_sig(1,l,k,i,j)
	            write (output_io,2410) k,at_name_i,at_name_j,
     &	                           mmc_vec      (2,l,k,i,j),
     &	                           chem_vect_ave(2,l,k,i,j),
     &	                           chem_vect_sig(2,l,k,i,j)
	            write (output_io,2420)
     &	                           mmc_vec      (3,l,k,i,j),
     &	                           chem_vect_ave(3,l,k,i,j),
     &	                           chem_vect_sig(3,l,k,i,j)
CDBG	          endif
	            enddo
	      enddo
	    enddo
	          endif
	        enddo
	    endif
CDBG
CDBG	    if(dbg) then
CDBG	      read(*,*) i
CDBG	    endif
	  endif
	enddo
c
c------ Loop finished
c
c
	write (output_io,3000)
	write (output_io,2000) igen,itry,iacc_good,iacc_bad
	if(mmc_cor_energy(0,MC_ANGLE)) then
c
c------	--Angular energy was selected, give feedback
c
	  l       =3
	  cpara(1)=mo_atom(1)
	  cpara(2)=mo_atom(2)
	  cpara(3)=mo_atom(3)
	  lpara(1)=latom(1)
	  lpara(2)=latom(2)
	  lpara(3)=latom(3)
	  cpara(1)='all'
	  cpara(2)='all'
	  cpara(3)='all'
	  lpara(1)=3
	  lpara(2)=3
	  lpara(3)=3
	  call chem_angle_multi(l,cpara,lpara,verte,wwerte,wwwerte,
     &	                      maxw,.false.)
	      do k=1,chem_ncor
	  do i=0,cr_nscat
	    do j=i,cr_nscat
	      at_name_i=at_name(i)
	      at_name_j=at_name(j)
	        if (mmc_disp(k,MC_ANGLE,i,j).ne.0.0) then
	          write (output_io,2300) k,at_name_i,at_name_j,
     &	                         mmc_disp(k,MC_ANGLE,i,j),
     &	                         chem_disp_ave(k,i,j),
     &	                         chem_disp_sig(k,i,j),
     &	             mmc_disp(k,MC_ANGLE,i,j)-chem_disp_ave(k,i,j)
	        endif
	      enddo
	    enddo
	  enddo
	endif
	if(mmc_cor_energy(0,MC_SPRING)) then
c
c------	--SPRING  energy was selected, give feedback
c
	  l       =2
	  cpara(1)='all'
	  cpara(2)='all'
	  lpara(1)=3
	  lpara(2)=3
	  call chem_disp_multi(l,cpara,lpara,verte,maxw,.false.)
	      do k=1,chem_ncor
	  do i=0,cr_nscat
	    do j=i,cr_nscat
	      at_name_i=at_name(i)
	      at_name_j=at_name(j)
	        if (mmc_disp(k,MC_SPRING,i,j).ne.0.0) then
	          write (output_io,2300) k,at_name_i,at_name_j,
     &	                         mmc_disp(k,MC_SPRING,i,j),
     &	                         chem_disp_ave(k,i,j),
     &	                         chem_disp_sig(k,i,j),
     &	             mmc_disp(k,MC_SPRING,i,j)-chem_disp_ave(k,i,j)
	        endif
	      enddo
	    enddo
	  enddo
	endif
	if(mmc_cor_energy(0,MC_VECTOR)) then
c
c------	--VECTOR  energy was selected, give feedback
c
	l       =2
	cpara(1)='all'
	cpara(2)='all'
	lpara(1)=3
	lpara(2)=3
	call chem_vector_multi(l,cpara,lpara,verte,maxw,.false.)
	do i=0,cr_nscat
	  do j=i,cr_nscat
	    at_name_i=at_name(i)
	    at_name_j=at_name(j)
	    do k=1,chem_ncor
	      if(mmc_cor_energy(k,MC_VECTOR)) then
	        do l=1,mmc_nvec(k,i,j)
	          write (output_io,2400)
     &	                         mmc_vec      (1,l,k,i,j),
     &	                         chem_vect_ave(1,l,k,i,j),
     &	                         chem_vect_sig(1,l,k,i,j)
	          write (output_io,2410) k,at_name_i,at_name_j,
     &	                         mmc_vec      (2,l,k,i,j),
     &	                         chem_vect_ave(2,l,k,i,j),
     &	                         chem_vect_sig(2,l,k,i,j)
	          write (output_io,2420)
     &	                         mmc_vec      (3,l,k,i,j),
     &	                         chem_vect_ave(3,l,k,i,j),
     &	                         chem_vect_sig(3,l,k,i,j)
	          enddo
	        endif
	      enddo
	    enddo
	  enddo
	endif
c
c------	Give average energy changes for the different energy terms
c
	write(*,5000)
	do i=1,MC_N_ENERGY
	  if(n_e_av_p(i).gt.0) then
	    e_aver_p(i) = e_aver_p(i)/float(n_e_av_p(i))
	  endif
	  if(n_e_av_m(i).gt.0) then
	    e_aver_m(i) = e_aver_m(i)/float(n_e_av_m(i))
	  endif
	  write(*,5010) c_energy(i),n_e_av_m(i),e_aver_m(i),
     &	                            n_e_av_z(i),
     &	                            n_e_av_p(i),e_aver_p(i)
	  n_e_av_p(i) = 0
	  n_e_av_m(i) = 0
	  n_e_av_z(i) = 0
	  e_aver_p(i) = 0.0
	  e_aver_m(i) = 0.0
	enddo
c
c------ Write timing results
c
	zeit = seknds(start)
	zh = int (zeit / 3600.)
	zm = int ((zeit - zh*3600.) / 60.)
	zs = int ( zeit - zh*3600 - zm*60.)
	write (output_io,4000) zh,zm,zs,zeit/itry
c
1000    format (' Running MC simulation ...',//
     &          ' Size of model crystal     : ',I3,' x ',I3,' x ',I3,
     &          ' containing ',I9,' atoms')
2000	format (/,' Gen: ',I8,' try: ',I8,' acc: (good/bad): ',I7,
     &	          ' / ',I7,'  MC moves ')
2300	format ('Neig. ',i3,' ',a9,'- ',a9,'target ',
     &	        f7.3,' ach. ',f7.3,' +- ',f7.3,' Dif ',f7.3)
2400	format (/36x,'(',f7.3,')    (',f7.3,')  (',f7.3,')')
2410	format ('Neig. ',i3,' ',a9,'- ',a9,'target(',
     &	        f7.3,')ach.(',f7.3,')+-(',f7.3,')')
2420	format ( 36x,'(',f7.3,')    (',f7.3,')  (',f7.3,')')
3000	format (/,' --- Final multiple energy configuration ---')
4000	format (/,' Elapsed time : ',I4,' h ',I2,' min ',I2,' sec ',/
     &	          ' Time/cycle   : ',F9.3,' sec',/)
5000	format (/,' --- Average energy changes ---',//,
     &	        ' Energy type',14x,'number',17x,'number',2x,'number',/,
     &	        27x,'E < 0',6x,' <E>', 8x,'E = 0',3x,'E > 0',6x,' <E>')
5010	format(a24, 2x,i6,f15.6,2x,i6,2x,i6,f15.6)
c
	end
c*****7*****************************************************************
	subroutine mmc_test_multi(iacc_good,iacc_bad,e_new,e_old,laccept)
c+
c	Tests performed MC move
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'random.inc'
	include 	'mc.inc'
	include 	'mmc.inc'
c
	integer		iacc_good,iacc_bad
	integer		i
c
	real		e_old(0:MC_N_MOVE)
	real		e_new(0:MC_N_MOVE)
	real		e_del
	real		e_delta
	logical		laccept
c
	real		ran1
c
CDBG
CDBG	write(*,*) ' Difference in energy'
	e_del = 0
	do i=1,MC_N_ENERGY
	  if(mmc_cor_energy(0,i)) then
CDBG	write(*,*) 'Energy # ', i,' delta ',
CDBG     &	           (e_new(i) - e_old(i))
	    e_delta =       (e_new(i) - e_old(i))
	    e_del = e_del + e_delta
	    if(e_delta.gt.0) then
	      e_aver_p(i) = e_aver_p(i) + e_delta
	      n_e_av_p(i) = n_e_av_p(i) + 1
	    elseif(e_delta.lt.0) then
	      e_aver_m(i) = e_aver_m(i) + e_delta
	      n_e_av_m(i) = n_e_av_m(i) + 1
	    else
	      n_e_av_z(i) = n_e_av_z(i) + 1
	    endif
	  endif
	enddo
CDBG	write(*,*) 'e_del ',e_del
CDBG	if(mmc_move.eq.MC_MOVE_INVDISP) then
CDBG	read(*,*) i
CDBG	endif
	if (e_del.lt.0) then
	  laccept = .true.
	elseif(e_del.eq.0) then
	  laccept = .false.
        else
	  if (mo_kt.lt.1.0e-10) then
	    laccept = .false.
	  else
	    e_del   = exp(-e_del/mo_kt)
	    e_del   = e_del / (1 + e_del)
	    laccept = (e_del.gt.ran1(idum))
	  endif
	endif
c
	if (laccept) then
	  if (e_del.lt.0.0) then
	    iacc_good = iacc_good + 1
	  else
	    iacc_bad  = iacc_bad  + 1
	  endif
	endif
c
	end
c*****7*****************************************************************
	real function mmc_energy_occ(natoms,isel,ianz,werte,maxw,
     &	                             valid_e)
c+
c	Calculates the energy for occupational disorder according to
c
c	  E = SUM si * (J1*s(i-1) + J2*s(i+1) + ...) with si = +-1.
c
c	Note there is no need for H term because concentration is
c	fixed using SWCHEM mode.
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'chem.inc'
	include 	'rmc.inc'
	include 	'mc.inc'
	include 	'mmc.inc'
c
	integer		maxatom
	parameter	(maxatom = chem_max_neig)
c
	integer		isel(chem_max_atom)
	integer		natoms,ianz,maxw
	logical		valid_e
	real		werte(maxw)
c
	integer		iatom(0:maxatom),natom
	integer 	ic,in,ia,ival1,ival2
	real		patom(3,0:maxatom)
c
	logical		atom_allowed
c
	mmc_energy_occ = 0.0
	valid_e        = .false.
c
c------ Loop over all modified atoms
c
	do ia=1,natoms
	  ival1 = -1
	  if (atom_allowed(isel(ia),werte,ianz,maxw)) ival1=1
c
c------ - Loop over all defined interactions
c
	  do ic=1,chem_ncor
c
c------ --- Get the neighbours
c
	    call chem_neighbour(isel(ia),ic,iatom,patom,natom,maxatom)
	    if (natom.ne.0) then
	      do in=1,natom
	        ival2 = -1
	        if (atom_allowed(iatom(in),werte,ianz,maxw)) ival2=1
	        mmc_energy_occ = mmc_energy_occ+
     &	        mmc_const(ic,MC_OCC)*ival1*ival2
	      enddo
	      valid_e        = .false.
	    endif
	  enddo
	enddo
	if(.not. valid_e) then
	  mmc_energy_occ = 0.0
	endif
c
	end
c*****7*****************************************************************
	real function mmc_energy_occ_mol(ianz,imol,amol,valid_e)
c+
c	Calculates the energy for occupational disorder for
c	molecules.
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'chem.inc'
	include 	'rmc.inc'
	include 	'molecule.inc'
	include 	'mc.inc'
	include 	'mmc.inc'
c
	integer		maxmol
	parameter	(maxmol = chem_max_neig)
c
	integer		ianz
	integer		imol(ianz)
	integer		amol(ianz)
	logical		valid_e
c
	integer		ineig(0:maxmol),nneig
	integer 	ic,in,ia,ival1,ival2
c
	mmc_energy_occ_mol = 0.0
	valid_e        = .true.
c
c------ Loop over all modified atoms
c
	do ia=1,ianz
	  ival1 = -1
	  if (mole_type(imol(ia)).eq.amol(1)) ival1=1
c
c------ - Loop over all defined interactions
c
	  do ic=1,chem_ncor
c
c------ --- Get the neighbours
c
	    call chem_neighbour_mol(imol(ia),ic,ineig,nneig,maxmol)
	    if (nneig.ne.0) then
	      do in=1,nneig
	        ival2 = -1
	        if (mole_type(ineig(in)).eq.amol(1)) ival2=1
	        mmc_energy_occ_mol = mmc_energy_occ_mol+
     &	                           mmc_const(ic,MC_OCC)*ival1*ival2
	      enddo
	    endif
	  enddo
	enddo
	if(.not. valid_e) then
	  mmc_energy_occ_mol = 0.0
	endif
c
	end
c*****7*****************************************************************
	real function mmc_energy_dis(natoms,isel,disp,rdi,rdj,valid_e)
c+
c	Calculates the DELTA energy for distortions according to
c
c	  DE = SUM k*disp*x
c
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'chem.inc'
	include 	'rmc.inc'
	include 	'mc.inc'
	include 	'mmc.inc'
c
	integer		maxatom
	parameter	(maxatom = chem_max_neig)
c
	integer		isel(chem_max_atom),natoms
	logical		valid_e
	real		disp(3,rmc_max_atom)
	real		rdi(chem_max_cor)
	real		rdj(chem_max_cor)
c
	integer		iatom(0:maxatom),natom
	integer		cell(3),site
	integer 	i,ic,in,ia
	real		patom(3,0:maxatom)
	real		idir(3),jdir(3)
	real		delta,dx,u(3),v(3)
c
	real		skalpro
c
	mmc_energy_dis = 0.0
	valid_e        = .false.
c
c------ Loop over all modified atoms
c
	do ia=1,natoms
c
	  call indextocell(isel(ia),cell,site)
	  do i=1,3
	    v(i) = cr_pos(i,isel(ia))-chem_ave_pos(i,site)-
     &	           float(cell(i)-1)-cr_dim0(i,1)
	    v(i) = v(i) + disp(i,ia)
	  enddo
c
c------ - Loop over all defined interactions
c
	  do ic=1,chem_ncor
c
	    if (chem_ldall(ic)) then
	      do i=1,3
	        jdir(i) = v(i)
	      enddo
	      rdj(ic) = skalpro(jdir,jdir,cr_gten)
	      if (rdj(ic).gt.0.0) then
	        rdj(ic) = sqrt(rdj(ic))
	      else
	        rdj(ic) = 1.0
	      endif
	      delta = 1.0
	    else
	      do i=1,3
	        idir(i) = chem_dir(i,1,ic)
	        jdir(i) = chem_dir(i,2,ic)
	      enddo
	      delta = skalpro(v,idir,cr_gten)/rdi(ic)
	    endif
c
c------ --- Get the neighbours
c
	    call chem_neighbour(isel(ia),ic,iatom,patom,natom,maxatom)
	    if (natom.ne.0) then
	      do in=1,natom
	        call indextocell(iatom(in),cell,site)
	        do i=1,3
	          u(i) = cr_pos(i,iatom(in))-chem_ave_pos(i,site)-
     &	                 float(cell(i)-1)-cr_dim0(i,1)
	        enddo
	        dx = skalpro(u,jdir,cr_gten)/rdj(ic)
c
	        mmc_energy_dis = mmc_energy_dis + 
     &	        mmc_const(ic,MC_DISP)*delta*dx
c
	        valid_e        = .true.
c
	      enddo
	    endif
	  enddo
	enddo
c
	if(.not. valid_e) then
	  mmc_energy_dis = 0.0
	endif
	end
c*****7*****************************************************************
	real function mmc_energy_dis_mol(nmol,imol,disp,rdi,rdj,valid_e)
c+
c	Calculates the DELTA energy for distortions according to
c
c	  DE = SUM k*disp*x
c
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'chem.inc'
	include 	'rmc.inc'
	include 	'molecule.inc'
	include 	'mc.inc'
	include 	'mmc.inc'
c
	integer		maxmol
	parameter	(maxmol = chem_max_neig)
c
	integer		nmol,imol(2)
	logical		valid_e
	real		disp(3,rmc_max_atom)
	real		rdi(chem_max_cor)
	real		rdj(chem_max_cor)
c
	integer		ineig(0:maxmol),nneig
	integer		cell(3),site
	integer		iatom,jatom
	integer 	i,ic,in,ia
	real		idir(3),jdir(3)
	real		delta,dx,u(3),v(3)
c
	real		skalpro
c
	mmc_energy_dis_mol = 0.0
	valid_e        = .false.
c
c------ Loop over all modified atoms
c
	do ia=1,nmol
	  iatom = mole_cont(mole_off(imol(ia))+1)
c
	  call indextocell(iatom,cell,site)
	  do i=1,3
	    v(i) = cr_pos(i,iatom)-chem_ave_pos(i,site)-
     &	           float(cell(i)-1)-cr_dim0(i,1)
	    v(i) = v(i) + disp(i,ia)
	  enddo
c
c------ - Loop over all defined interactions
c
	  do ic=1,chem_ncor
c
	    if (chem_ldall(ic)) then
	      do i=1,3
	        jdir(i) = v(i)
	      enddo
	      rdj(ic) = skalpro(jdir,jdir,cr_gten)
	      if (rdj(ic).gt.0.0) then
	        rdj(ic) = sqrt(rdj(ic))
	      else
	        rdj(ic) = 1.0
	      endif
	      delta = 1.0
	    else
	      do i=1,3
	        idir(i) = chem_dir(i,1,ic)
	        jdir(i) = chem_dir(i,2,ic)
	      enddo
	      delta = skalpro(v,idir,cr_gten)/rdi(ic)
	    endif
c
c------ --- Get the neighbours
c
	    call chem_neighbour_mol(imol(ia),ic,ineig,nneig,maxmol)
	    if (nneig.ne.0) then
	      do in=1,nneig
	        jatom = mole_cont(mole_off(ineig(in))+1)
	        call indextocell(jatom,cell,site)
	        do i=1,3
	          u(i) = cr_pos(i,iatom)-chem_ave_pos(i,site)-
     &	                 float(cell(i)-1)-cr_dim0(i,1)
	        enddo
	        dx = skalpro(u,jdir,cr_gten)/rdj(ic)
c
	        mmc_energy_dis_mol = mmc_energy_dis_mol + 
     &	                            mmc_const(ic,MC_DISP)*delta*dx
c
	        valid_e = .true.
	      enddo
	    endif
	  enddo
	enddo
c
	if(.not. valid_e) then
	  mmc_energy_dis_mol = 0.0
	endif
	end
c*****7*****************************************************************
	real function mmc_energy_spr(isel,ia,ic,iatom,patom,icent,natom,
     &	                             valid_e)
c+
c	Calculates the energy for distortions according to
c
c	  E = SUM k*(d-d0)**2
c
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'chem.inc'
	include 	'mc.inc'
	include 	'mmc.inc'
c
	integer		maxatom
	parameter	(maxatom = chem_max_neig)
c
	integer		isel(chem_max_atom)
c
	integer		iatom(0:maxatom,CHEM_MAX_CENT)
	integer		natom(CHEM_MAX_CENT)
	integer		icent
	logical		valid_e
c
	integer 	i,is,js,ic,in,ia
	integer		in_a,in_e
	integer		ncalc
	real		patom(3,0:maxatom,CHEM_MAX_CENT)
	real		d,u(3),v(3)
c
	real		do_blen
c
CDBG
CDBG	write(*,*) ' ================energy_spr==================='
	mmc_energy_spr = 0.0
	ncalc          = 0
	valid_e        = .false.
c
	if(chem_ctyp(ic).eq.CHEM_VEC .or.
     &	   chem_ctyp(ic).eq.CHEM_ENVIR .or.
     &	   chem_ctyp(ic).eq.CHEM_RANGE .or.
     &	   chem_ctyp(ic).eq.CHEM_DIST     ) then
c
CDBG
CDBG	write(*,*) ' selected atom,typ ',isel(ia),cr_iscat(isel(ia))
CDBG	write(*,*) ' selected pos      ',(cr_pos(i,isel(ia)),i=1,3)
CDBG	write(*,*) ' icent,natom       ',icent,natom(icent)
CDBG	write(*,*) ' iatom             ',(iatom(i,icent),i=0,natom(icent))
CDBG	write(*,*) ' central           ', u   
CDBG	do i=0,natom(icent)
CDBG	  write(*,*) ' patom             ',(patom(in,i,icent),in=1,3)
CDBG	enddo
	  if (natom(icent).ne.0) then
	    if(isel(ia).eq.iatom(0,icent)) then
CDBG	write(*,*) ' selected = central'
c
c------	----The selected atom is the central atom, check all atoms
c
	      do i=1,3
	        u(i)=patom(i,0,icent)
	      enddo
	      in_a = 1
	      in_e = natom(icent)
	      is=cr_iscat(iatom(0 ,icent))
	    else
c
c------	The selcted atom is a neighbour, use this atom only
c
CDBG	write(*,*) ' selected = neighbour'
	      do i=1,3
	        u(i) = cr_pos(i,isel(ia))
	      enddo
	      in_a = 0
	      in_e = 0
	      is=cr_iscat(isel(ia))
	    endif
	    do in=in_a,in_e
	      js=cr_iscat(iatom(in,icent))
CDBG	write(*,*) ' is,js ,mmc_disp   ',is,js,mmc_disp(ic,MC_SPRING,is,js)
	      if (mmc_disp(ic,MC_SPRING,is,js).ne.0.0) then
	        do i=1,3
	          v(i)=patom(i,in,icent)
	        enddo
	        d = do_blen(.true.,u,v)
CDBG	write(*,*) ' v, distance,iscat     ', v, d,js
c
	        mmc_energy_spr = mmc_energy_spr +
     &	          mmc_const(ic,MC_SPRING)*
     &	          (d-mmc_disp(ic,MC_SPRING,is,js))**2
CDBG	write(*,*) 'energy_spr ',mmc_energy_spr
	        ncalc = ncalc + 1
c
	      endif
	    enddo
	  endif
	endif
	if(ncalc.gt.0) then
	  mmc_energy_spr = mmc_energy_spr/float(ncalc)
	  valid_e        = .true.
	else
	  mmc_energy_spr = 0.0
	  valid_e        = .false.
	endif
CDBG	write(*,*) ' ncalc,e_spr,iscat  ',ncalc,mmc_energy_spr,
CDBG     &	             cr_iscat(isel(ia))
c
	end
c*****7*****************************************************************
	real function mmc_energy_spr_mol (nmol,imol,valid_e)
c+
c	Calculates the energy for distortions for molecules ..
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'chem.inc'
	include 	'rmc.inc'
	include 	'molecule.inc'
	include 	'mc.inc'
	include 	'mmc.inc'
c
	integer		maxmol
	parameter	(maxmol = chem_max_neig)
c
	integer		imol(2),nmol
	logical		valid_e
c
	integer		ineig(0:maxmol),nneig
	integer		iatom,jatom
	integer		cell(3),site
	integer 	i,is,js,ic,in,ia
	real		d,u(3),v(3)
c
	real		do_blen
c
	mmc_energy_spr_mol = 0.0
	valid_e        = .false.
c
c------ Loop over all modified atoms
c
	do ia=1,nmol
	  iatom = mole_cont(mole_off(imol(ia))+1)
c
c------ - Restoring force to lattice (displ. from average position)
c
	  call indextocell(iatom,cell,site)
	  do i=1,3
	    u(i) = cr_pos(i,iatom)-
     &	           chem_ave_pos(i,site)-float(cell(i)-1)-cr_dim0(i,1)
	  enddo
	  d = do_blen(.true.,u,u)
c
	  mmc_energy_spr_mol = mmc_energy_spr_mol + 
     &	                       mmc_const(0,MC_SPRING)*d**2
c
c------ - Loop over all defined interactions
c
	  do ic=1,chem_ncor
	  if(chem_ctyp(ic).eq.CHEM_VEC .or.
     &	     chem_ctyp(ic).eq.CHEM_ENVIR    ) then
c
c------ --- Get the neighbours
c
	    call chem_neighbour_mol(imol(ia),ic,ineig,nneig,maxmol)
	    if (nneig.ne.0) then
	      do in=1,nneig
	        is=mole_type(imol (ia))
	        js=mole_type(ineig(in))
	        jatom = mole_cont(mole_off(ineig(in))+1)
	        if (mmc_disp(ic,MC_SPRING,is,js).ne.0.0) then
	          do i=1,3
	            u(i)=cr_pos(i,iatom)
	            v(i)=cr_pos(i,jatom)
	          enddo
	          d = do_blen(.true.,u,v)
c
	          mmc_energy_spr_mol = mmc_energy_spr_mol +
     &	            mmc_const(ic,MC_SPRING)*
     &	            (d-mmc_disp(ic,MC_SPRING,is,js))**2
c
	          valid_e        = .true.
	        endif
	      enddo
	    endif
	    endif
	  enddo
	enddo
c
	if(.not. valid_e) then
	  mmc_energy_spr_mol = 0.0
	endif
c
	end
c*****7*****************************************************************
	real function mmc_energy_len(isel,ia,ic,iatom,patom,icent,natom,
     &	                             valid_e)
c+
c	Calculates the energy for distortions according to a Lennard-Jones
c	potential
c
c	  E = SUM a/k*(1/d**12+b/d**2-(1+b)/d**6)
c
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'chem.inc'
	include 	'mc.inc'
	include 	'mmc.inc'
c
	integer		maxatom
	parameter	(maxatom = chem_max_neig)
c
	integer		isel(chem_max_atom)
c
	integer		iatom(0:maxatom,CHEM_MAX_CENT)
	integer		natom(CHEM_MAX_CENT)
	integer		icent
	logical		valid_e
c
	integer 	i,is,js,ic,in,ia
	integer		in_a,in_e
	integer		ncalc
	real		patom(3,0:maxatom,CHEM_MAX_CENT)
	real		d,u(3),v(3)
c
	real		do_blen
c
CDBG
CDBG	write(*,*) ' ================energy_spr==================='
	mmc_energy_len = 0.0
	ncalc          = 0
	valid_e        = .false.
c
	if(chem_ctyp(ic).eq.CHEM_VEC .or.
     &	   chem_ctyp(ic).eq.CHEM_ENVIR .or.
     &	   chem_ctyp(ic).eq.CHEM_RANGE .or.
     &	   chem_ctyp(ic).eq.CHEM_DIST     ) then
c
CDBG
CDBG	write(*,*) ' selected atom,typ ',isel(ia),cr_iscat(isel(ia))
CDBG	write(*,*) ' selected pos      ',(cr_pos(i,isel(ia)),i=1,3)
CDBG	write(*,*) ' icent,natom       ',icent,natom(icent)
CDBG	write(*,*) ' iatom             ',(iatom(i,icent),i=0,natom(icent))
CDBG	write(*,*) ' central           ', u   
CDBG	do i=0,natom(icent)
CDBG	  write(*,*) ' patom             ',(patom(in,i,icent),in=1,3)
CDBG	enddo
	  if (natom(icent).ne.0) then
	    if(isel(ia).eq.iatom(0,icent)) then
CDBG	write(*,*) ' selected = central'
c
c------	----The selected atom is the central atom, check all atoms
c
	      do i=1,3
	        u(i)=patom(i,0,icent)
	      enddo
	      in_a = 1
	      in_e = natom(icent)
	      is=cr_iscat(iatom(0 ,icent))
	    else
c
c------	The selcted atom is a neighbour, use this atom only
c
CDBG	write(*,*) ' selected = neighbour'
	      do i=1,3
	        u(i) = cr_pos(i,isel(ia))
	      enddo
	      in_a = 0
	      in_e = 0
	      is=cr_iscat(isel(ia))
	    endif
	    do in=in_a,in_e
	      js=cr_iscat(iatom(in,icent))
CDBG	write(*,*) ' is,js ,mmc_disp   ',is,js,mmc_disp(ic,MC_SPRING,is,js)
	      if (mmc_disp(ic,MC_SPRING,is,js).ne.0.0) then
	        do i=1,3
	          v(i)=patom(i,in,icent)
	        enddo
	        d = do_blen(.true.,u,v)
CDBG	write(*,*) ' v, distance,iscat     ', v, d,js
c
	        d = 1.1*d/mmc_len_d
	        mmc_energy_len = mmc_energy_len +
     &	          mmc_const(ic,MC_SPRING)*
     &	          mmc_len_a*(1./d**12 + mmc_len_b/d**2 -
     &	                            (1.-mmc_len_b)/d**6)
CDBG	write(*,*) 'energy_spr ',mmc_energy_len
	        ncalc = ncalc + 1
c
	      endif
	    enddo
	  endif
	endif
	if(ncalc.gt.0) then
	  mmc_energy_len = mmc_energy_len/float(ncalc)
	  valid_e        = .true.
	else
	  mmc_energy_len = 0.0
	  valid_e        = .false.
	endif
CDBG	write(*,*) ' ncalc,e_spr,iscat  ',ncalc,mmc_energy_len,
CDBG     &	             cr_iscat(isel(ia))
c
	end
c*****7*****************************************************************
	real function mmc_energy_angle(isel,ic,iatom,patom,icent,natom,
     &	                               valid_e)
c+
c	Calculates the energy for angular deviations according to
c
c	  E = SUM k*(a-a0)**2
c
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'chem.inc'
	include 	'rmc.inc'
	include 	'mc.inc'
	include 	'mmc.inc'
c
	integer		maxatom
	parameter	(maxatom = chem_max_neig)
c
	integer		isel(CHEM_MAX_ATOM)
c
	integer		iatom(0:maxatom,CHEM_MAX_CENT)
	integer		natom(CHEM_MAX_CENT)
	integer		icent
	logical		valid_e
c
	integer 	i,is,js,ic
	integer		ii,jj
	logical		lnoneig
	real		patom(3,0:maxatom,CHEM_MAX_CENT)
	real		a,u(3),v(3),w(3)
c
	real		do_bang
c
	lnoneig = .true.
	mmc_energy_angle = 0.0
	valid_e        = .false.
c
	if(chem_ctyp(ic).eq.CHEM_ANG .or. 
     &	   chem_ctyp(ic).eq.CHEM_ENVIR    ) then
	  if (natom(icent).ne.0) then
	    do i=1,3
	      u(i) = patom(i,0,icent)
	    enddo
CDBG	write(*,*) ' Zentral Atom  : ',icent,iatom(0,icent),
CDBG     &	           cr_iscat(iatom(0,icent)),u
CDBG	write(*,*) ' MC_ENERGY_ANGLE ,natom,ic ',natom(icent),ic
CDBG	write(*,*) ' iatom ',(iatom(i,icent),i=1,natom(icent))
	    do ii=1,natom(icent)-1
	      do jj=ii+1,natom(icent)
CDBG
	lnoneig = .false.
	        is=cr_iscat(iatom(ii,icent))
	        js=cr_iscat(iatom(jj,icent))
	        if (mmc_disp(ic,MC_ANGLE,is,js).ne.0.0) then
	          do i=1,3
	            v(i)=patom(i,ii,icent)
	            w(i)=patom(i,jj,icent)
	          enddo
	          a = do_bang(.true.,v,u,w)
CDBG
CDBG	write(*,*) ' Nachbar 1     : ',iatom(ii,icent),is,v
CDBG	write(*,*) ' Nachbar 2     : ',iatom(jj,icent),js,w
CDBG	write(*,*) ' Target,win    : ',mmc_disp(ic,MC_ANGLE,is,js),a
c
	          mmc_energy_angle = mmc_energy_angle +
     &	            mmc_const(ic,MC_ANGLE)*
     &	          (a-mmc_disp(ic,MC_ANGLE,is,js))**2
CDBG	write(*,*) ' Energie       : ',mmc_energy_angle
c
	          valid_e        = .true.
	        endif
	      enddo
	    enddo
	  endif
	endif
CDBG
	if(lnoneig) then
CDBG	write(*,*) ' No neighbour found ',natom(icent)
	  valid_e        = .false.
CDBG	write(*,*) ' Zentral Atom  : ',isel(1),cr_iscat(1),u
	endif
CDBG
CDBG	write(*,*) ' Natoms am Ende von mmc_energy_angle ',natoms
c
	if(.not. valid_e) then
	  mmc_energy_angle = 0.0
	endif
	end
c*****7*****************************************************************
	real function mmc_energy_vec(isel,ia,ic,iatom,patom,icent,natom,
     &	                             valid_e)
c+
c	Calculates the energy for vector distributions according to
c
c	  E = SUM k*|(v-v0)|**2
c
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'chem.inc'
	include		'debug.inc'
	include 	'mc.inc'
	include 	'mmc.inc'
c
	integer		maxatom
	parameter	(maxatom = chem_max_neig)
c
	integer		isel(chem_max_atom)
c
	integer		iatom(0:maxatom,CHEM_MAX_CENT)
	integer		natom(CHEM_MAX_CENT)
	integer		icent
	logical		valid_e
	integer 	i,is,js,ic,in,ia,nv
	integer		in_a,in_e
	logical		found
	real		patom(3,0:maxatom,CHEM_MAX_CENT)
	real		an,dd,d,u(3),v(3),w(3)
	real		ddmin
	real		null(3)
c
	real		do_blen
	real		do_bang
c
	data		null/ 0.0, 0.0, 0.0 /
c
CDBG
	dbg = .true.
	dbg = .false.
	if(dbg) then
	write(*,*) ' ================energy_vec============================'
	endif
	mmc_energy_vec = 0.0
	valid_e        = .false.
	ddmin          = 1.1 * chem_rmax_env(ic)
	found          = .false.
c
	if(chem_ctyp(ic).eq.CHEM_VEC .or.
     &	   chem_ctyp(ic).eq.CHEM_ENVIR    ) then
c
CDBG
	if(dbg) then
	write(*,*) ' selected atom,typ ',isel(ia),cr_iscat(isel(ia))
	write(*,*) ' selected pos      ',(cr_pos(i,isel(ia)),i=1,3)
	write(*,*) ' icent,natom       ',icent,natom(icent)
	write(*,*) ' iatom             ',(iatom(i,icent),i=0,natom(icent))
	do nv=0,natom(icent)
	write(*,*) ' patom             ',(patom(i,nv,icent),i=1,3)
	enddo
	endif
	  if (natom(icent).ne.0) then
	    if(isel(ia).eq.iatom(0,icent)) then
	if(dbg) then
	write(*,*) ' selected = central'
	endif
c
c------	----The selected atom is the central atom, check all atoms
c
	      do i=1,3
	        u(i)=patom(i,0,icent)
	      enddo
	      in_a = 1
	      in_e = natom(icent)
	      is=cr_iscat(iatom(0 ,icent))
	    else
c
c------	The selcted atom is a neighbour, use this atom only
c
	if(dbg) then
	write(*,*) ' selected = neighbour'
	endif
	      do i=1,3
	        u(i) = cr_pos(i,isel(ia))
	      enddo
	      in_a = 0
	      in_e = 0
	      is=cr_iscat(isel(ia))
	    endif
	if(dbg) then
	write(*,*) ' central           ', u   
	endif
	    do in=in_a,in_e
	if(dbg) then
	write(*,*) '^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^'
	endif
	      js=cr_iscat(iatom(in,icent))
	      do nv=1,mmc_nvec(ic,is,js)
	if(dbg) then
	write(*,*) ' is,js ,mmc_vec    ',is,js,(mmc_vec(i,nv,ic,is,js),i=1,3)
	endif
	        do i=1,3
	          v(i) = patom(i,in,icent) - u(i)
	          w(i) = mmc_vec(i,nv,ic,is,js)
	        enddo
	if(dbg) then
	write(*,*) ' nachbar           ',(patom(i,in,icent),i=1,3)
	endif
	        an = do_bang(.true.,v,null,w)
	if(dbg) then
	write(*,*) ' Winkel            ',an
	write(*,*) ' Vektor Zen->Nei   ',(v(i),i=1,3)
	write(*,*) ' Differenz zu soll ',(w(i)-v(i),i=1,3)
	endif
	        if(an      .lt. mmc_vec(4,nv,ic,is,js) ) then
	          dd = do_blen(.true.,null,v)
	if(dbg) then
	write(*,*) ' Laenge            ',dd
	endif
	          if(dd.lt.ddmin) then
	            ddmin = dd
	            d     = do_blen(.true.,v,w)
CDBG	    mmc_energy_vec = mmc_energy_vec + 
CDBG     &	                     mmc_const(ic,MC_VECTOR) * d**2
	            found = .true.
	if(dbg) then
	write(*,*) ' distance           ', d
	endif
	          endif
	        elseif(180.-an .lt. mmc_vec(4,nv,ic,is,js) ) then
	        do i=1,3
	          v(i) = - v(i)
	        enddo
	          dd = do_blen(.true.,null,v)
	if(dbg) then
	write(*,*) ' Vektor Zen->Nei   ',(v(i),i=1,3)
	write(*,*) ' Differenz zu soll ',(w(i)-v(i),i=1,3)
	write(*,*) ' Laenge            ',dd
	endif
CDBG	          if(dd.lt.ddmin) then
	            ddmin = dd
	            d     = do_blen(.true.,v,w)
CDBG	    mmc_energy_vec = mmc_energy_vec + 
CDBG     &	                     mmc_const(ic,MC_VECTOR) * d**2
	            found = .true.
	if(dbg) then
	write(*,*) ' distance           ', d
	endif
CDBG	          endif
	        endif
CDBG	write(88,*) ' nv ',nv
	      enddo
	    mmc_energy_vec = mmc_energy_vec + 
     &	                     mmc_const(ic,MC_VECTOR) * d**2
	    enddo
	  endif
	  if(found) then
CDBG	    mmc_energy_vec = mmc_const(ic,MC_VECTOR) * d**2
	    valid_e        = .true.
	    continue
	  else
	    mmc_energy_vec = 0.0
	    valid_e        = .false.
	  endif
	if(dbg) then
	write(*,*) 'energy_vec ',mmc_energy_vec
	endif
	endif
	dbg = .false.
c
	if(.not. valid_e) then
	  mmc_energy_vec = 0.0
	endif
	end
c*****7*****************************************************************
	subroutine check_geometry_multi(isel,natoms,laccept)
c-
c	Check whether geometrical constrains apply to the movement of
c	the selected atoms
c+
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'debug.inc'
	include		'errlist.inc'
	include		'chem.inc'
	include		'mc.inc'
	include		'mmc.inc'
c
	integer		isel(CHEM_MAX_ATOM)
	integer		natoms
	logical		laccept
c
	integer		i,j
	logical		lspace
	parameter	(lspace=.true.)
	real		d
	real		u(3),null(3)
c
	real		do_blen
c
	data	null/0.0,0.0,0.0/
c
	laccept	= .true.
c
	if(mmc_l_constrains) then
	  if(mmc_constrain_type.eq.MMC_C_XYZ) then
	    do i=1,natoms
	      do j=1,3
	        if(cr_pos(j,isel(i)).lt.mmc_c_min(j) .or.
     &	           mmc_c_max(j).lt.cr_pos(j,isel(i))   ) then
	          laccept = .false.
	          goto 9000
	        endif
	      enddo
	    enddo
	  elseif(mmc_constrain_type.eq.MMC_C_RADIUS) then
	    do i=1,natoms
	      do j=1,3
	        u(j) = cr_pos(j,isel(i))
	      enddo
	      d = do_blen(lspace,u,null)
	      if(mmc_c_rad.lt.d) then
	        laccept = .false.
	        goto 9000
	      endif
	    enddo
	  endif
	else
	  laccept = .true.
	endif
c
9000	continue

CDBG
CDBG	if(isel(1).eq.1405) then
CDBG	  write(*,*) ' laccept ',laccept
CDBG	endif
c
	end
c*****7*****************************************************************
	subroutine mmc_limit_selection(isel,natoms)
c-
c	Selects an atom from a limited subset
c+
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'errlist.inc'
	include		'mmc.inc'
	include		'random.inc'
c
	integer		isel(CHEM_MAX_ATOM)
	integer		natoms
c
	integer		i,j
	integer		icell(3),isite,nsel
	integer		ntrial
c
	real		ran1
c
	if(mmc_l_type.eq.MMC_L_CELLS) then
	  do i=1,natoms
	    ntrial = mmc_l_extend(1) * mmc_l_extend(1)*
     &	             mmc_l_extend(1) * cr_ncatoms
	    nsel   = ran1(idum)*ntrial + 1
	    call mmc_indextocell(nsel,icell,isite,mmc_l_extend)
	    do j=1,3
	      icell(j) = icell(j) + mmc_l_center(j) - 1
	    enddo
	    call celltoindex(icell,isite,nsel)
	    isel(i) = nsel
	  enddo
	endif
c
	end
c*****7*****************************************************************
	subroutine mmc_indextocell (iatom,icell,isite,icc)
c-
c 	calculates in which unit cell on which site the atom <ia> is
c+
	implicit	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer		iatom,isite,icell(3),icc(3)
	integer		ia
c
        ia       = iatom-1
c
        icell(3) = int(ia/icc(1)/icc(2)/cr_ncatoms)+1
        ia       = ia-(icell(3)-1)*icc(1)*icc(2)*cr_ncatoms
        icell(2) = int(ia/icc(1)/cr_ncatoms)+1
        ia       = ia-(icell(2)-1)*icc(1)*cr_ncatoms
        icell(1) = int(ia/cr_ncatoms)+1
	isite    = ia-(icell(1)-1)*cr_ncatoms+1
c
	end
c*****7*****************************************************************
	subroutine errlist_mmc
c-
c	Displays error Messages for the error type MC
c+
	implicit      none
c
	include      'errlist.inc'
c
	integer       iu,io
	parameter    (IU=-5,IO=0)
c
	character*41  ERROR(IU:IO)
c
	DATA ERROR/
     &  'Number of feedback intervalls is zero      ',      ! -5 
     &  'Number of MC cycles is zero                ',      ! -4 
     &  'Invalid mode selected for COCC MC run      ',      ! -3 
     &  'No valid move after 1000 cycles            ',      ! -2 
     &  'Invalid or no energy type selected         ',      ! -1 
     &  ' '       !  0
     &	/
c
	call disp_error ('MMC ',error,iu,io)
	end
C*****7****************************************************************
