c+
c       Basic atom/molecule manipulation functions and conversion
c	and other support routines routines.
c
c       Version : 2.02
c       Date    : 31 October 1997
c
c       Author  : R.B. Neder  (reinhard.neder@mail.uni-wuerzburg.de)
c                 Th. Proffen (proffen@pa.msu.edu)
c
c*****7*****************************************************************
	subroutine do_replace(zeile,lp)
c-
c	Replaces atom(s) or molecule(s) within the crystal ..
c+
	implicit 	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'random.inc'
	include 	'molecule.inc'
	include 	'errlist.inc'
c
	integer 	maxw
	parameter	(maxw=5)
c
	character*(*)	zeile
	character*200	cpara(maxw),cc
	integer		lpara(maxw)
	integer		ianz,iianz,jjanz,lp,i
	integer		is1,is2,isite,itype
	integer		ja,jsite,jcell(3)
	logical         lexist,lrepl
	real		uerte(maxw)
	real		verte(maxw)
	real		werte(maxw)
	real		prob
c
	logical		str_comp
	real		ran1
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.2) then
	  cpara(3) = 'x'
	  lpara(3) = 1
	endif
c
c------ Here are molecule manipulations
c
	if (str_comp(cpara(3),'mol',2,lpara(3),3)) then
c
c------ - Single molecule will be changed
c
	  if (ianz.eq.3) then
	    ianz = ianz-1
	    call ber_params (ianz,cpara,lpara,werte,maxw)
	    is1 = nint(werte(1))
	    is2 = nint(werte(2))
	    call do_swap_mole(is1,is2,.false.)
	    call update_cr_dim
c
c------ - More molecules will be changed
c
	  elseif (ianz.eq.4) then
	    call ber_params (2,cpara,lpara,werte,maxw)
	    itype = nint(werte(1))
	    is2   = nint(werte(2))
	    call del_params (3,ianz,cpara,lpara,maxw)
	    call ber_params (ianz,cpara,lpara,werte,maxw)
	    prob  = werte(1)
c
	    if (itype.gt.0 .and. itype.le.mole_num_type) then
	      do ja=1,mole_num_mole
	        if(mole_type(ja).eq.itype .and. 
     &	           ran1(idum).le.prob          ) then
	          call do_swap_mole(ja,is2,.false.)
	        endif
	      enddo
	      call update_cr_dim
	    else
	      ier_num = -64
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c------ Here are atom manipulations
c
	else
c
c------ - Replace all given atoms with given probability
c
	  if (ianz.eq.4) then
	    iianz = 1
	    jjanz = 1
	    call get_iscat(iianz,cpara(1),lpara(1),uerte,maxw,.false.)
c
c------	----The first atom type does not exist, user error
c
	    if (ier_num.ne.0) return
c
c------	----Get second atom
c
	    call get_iscat(jjanz,cpara(2),lpara(2),verte,maxw,.false.)
	    if (ier_num.eq.-27) then
c
c------	----The second atom type does not exist, create new scattering curve(s)
c
	      do i=1,iianz
	        if(cr_nscat+1.le.maxscat) then
	          cr_nscat   = cr_nscat + 1
	          cr_at_lis(cr_nscat) = cpara(2)
	          cr_dw(cr_nscat)     = cr_dw(nint(uerte(i)))
	          call no_error
	          verte(i) = float(cr_nscat)
	        else
	          ier_num = -26
	          ier_typ = ER_APPL
	          return
	        endif
	      enddo
	    elseif(ier_num.ne.0) then
c
c------	------other errors, return
c
	      return
	    endif
	    is1 = nint(uerte(1))
	    is2 = nint(verte(1))
	    if (str_comp(cpara(3),'all',1,lpara(3),3)) then
	      call del_params (3,ianz,cpara,lpara,maxw)
	      call ber_params (ianz,cpara,lpara,werte,maxw)
	      isite = -1
	      prob  = werte(1)
	    else
	      call del_params (2,ianz,cpara,lpara,maxw)
	      call ber_params (ianz,cpara,lpara,werte,maxw)
	      isite = nint(werte(1))
	      prob  = werte(2)
	    endif
c
	    if (prob.le.0.0 .or. prob.gt.1.0 .or.
     &	        isite.gt.cr_ncatoms          .or.
     &	        is1.eq.-1   .or. is2.eq.-1         ) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      return
	    endif
c
	    do ja=1,cr_natoms
	      call indextocell(ja,jcell,jsite)
	      do i=1,iianz
	        if(cr_iscat(ja).eq.nint(uerte(i))    .and.
     &	           (jsite.eq.isite .or. isite.eq.-1) .and.
     &	           ran1(idum).le.prob                     ) then
	          cr_iscat(ja) = nint(verte(i))
	          goto 999
	        endif
              enddo
999	      continue
	      lrepl = .false.
c	      do i=1,iianz
c	        lrepl = lrepl .or. cr_iscat(ja).eq.nint(uerte(i))
c     &	                .and. (jsite.eq.isite .or. isite.eq.-1)
c	      enddo
c	      if (cr_iscat(ja).eq.is1               .and.
c     &	          (jsite.eq.isite .or. isite.eq.-1) .and.
c	      if (lrepl .and.
c     &	          ran1(idum).le.prob                     ) then
c	        cr_iscat(ja) = is2
c	      endif
	    enddo
c
c------ - Replace a single atom
c
	  elseif (ianz.eq.2 .or. ianz.eq.3) then
	    call ber_params (1,cpara,lpara,werte,maxw)
	    ja  = nint(werte(1))
	    iianz = 1
	    call get_iscat(iianz,cpara(2),lpara(2),uerte,maxw,.false.)
c
	    if (ianz.eq.3 .and. ier_num.eq.-27) then
	      if(cr_nscat+1.le.maxscat) then
	        cr_nscat   = cr_nscat + 1
	        cr_at_lis(cr_nscat) = cpara(2)
	        call del_params (2,ianz,cpara,lpara,maxw)
	        call ber_params (ianz,cpara,lpara,werte,maxw)
	        cr_dw(cr_nscat) = werte(1)
	        is1 = cr_nscat
	        call no_error
	      else
	        ier_num = -26
	        ier_typ = ER_APPL
	        return
	      endif
	    elseif (ianz.eq.3 .and. ier_num.eq.  0) then
c
c------	------Atom name exists, but since DW was given check this
c
	      cc = cpara(2)
	      call del_params (2,ianz,cpara,lpara,maxw)
	      call ber_params (ianz,cpara,lpara,werte,maxw)

	      lexist = .false.
	      do i=1,iianz
	        if(cr_dw(nint(uerte(i))).eq.werte(1)) then
c
c------	--------Atom exists with identical DW
c
	          is1 = nint(uerte(i))
	          lexist = .true.
	        endif
	      enddo
	      if(.not. lexist) then
	        if(cr_nscat+1.le.maxscat) then
	          cr_nscat   = cr_nscat + 1
	          cr_at_lis(cr_nscat) = cc
	          cr_dw(cr_nscat) = werte(1)
	          is1 = cr_nscat
	          call no_error
	        else
	          ier_num = -26
	          ier_typ = ER_APPL
	          return
	        endif
	      endif
	    else
	      is1 = nint(uerte(1))
	    endif
c
	    if (is1.eq.-1 .or. ja.le.0 .or. ja.gt.cr_natoms) then
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	    if (ier_num.ne.0) return
c
	    cr_iscat(ja) = is1
c
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	endif
c
	end
c*****7*****************************************************************
	subroutine do_swap_mole(idest,isource,lswap)
c-
c	Replaces molecule 'idest' with 'isource'. If 'lswap' is true
c	both molecule are swapped rather than one replaced by the other.
c+
	implicit 	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'molecule.inc'
	include 	'errlist.inc'
c
	integer		idest,isource,ityp,i,k,ii,jj,is,js,i0,j0
	real		i0pos(3),j0pos(3),ipos(3)
	logical		lswap
c
	if (mole_len(idest).ne.mole_len(isource)) then
	  ier_num = -67
	  ier_typ = ER_APPL
	  return
	endif
c
	if (idest.lt.0 .or. idest.gt.mole_num_mole .or.
     &	    isource.lt.0 .or. isource.gt.mole_num_mole    ) then
	  ier_num = -63
	  ier_typ = ER_APPL
	  return
	endif
c
c------ Get origin of molecules (atom 1)
c
	i0 = mole_cont(mole_off(idest)  +1)
	j0 = mole_cont(mole_off(isource)+1)
	do i=1,3
	  i0pos(i) = cr_pos(i,i0)
	  j0pos(i) = cr_pos(i,j0)
	enddo
c
c------ replace/swap atoms
c
	do k=1,mole_len(idest)
	  ii = mole_cont(mole_off(idest)  +k)
	  jj = mole_cont(mole_off(isource)+k)
	  is = cr_iscat(ii)
	  js = cr_iscat(jj)
c
	  cr_iscat(ii)=js
	  do i=1,3
	    ipos(i)      = cr_pos(i,ii)
	    cr_pos(i,ii) = cr_pos(i,jj) - j0pos(i) + i0pos(i)
	  enddo
c
	  if (lswap) then
	    cr_iscat(jj)=is
	    do i=1,3
	      cr_pos(i,jj) = ipos(i) - i0pos(i) + j0pos(i)
	    enddo
	  endif
	enddo
c
c------ replace/swap molecule types
c
	ityp = mole_type(idest)
	mole_type(idest) = mole_type(isource)
	if (lswap) mole_type(isource) = ityp
c
	end
c*****7*****************************************************************
	subroutine do_ins(line,laenge)
c-
c	Inserts a new atom into the structure. The name and position
c	must be given, optionally the temperature factor will be read.
c	If an atom of this type exists the temperature factor will be
c	that of the first type of temperature factor given for this atom
c	type, else the temperature factor will be 0.
c+
	implicit     	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'charact.inc'
	include 	'errlist.inc'
c
	integer       maxw
	parameter    (maxw=5)
c
	character*(*) line
	character*4   name
	character*200 cpara(maxw),zeile
	integer       lpara(maxw)
	integer       i,j,ianz,laenge,lp
	real          werte(maxw)
	real          berechne
c
	if(cr_natoms.lt.nmax) then
	  call get_params(line,ianz,cpara,lpara,maxw,laenge)
	  if(ier_num.eq.0) then
            i  = ichar(cpara(1)(1:1))
            if((a .le.i .and. i.le.z ).or.
     &         (aa.le.i .and. i.le.zz)     )  then
	      name=cpara(1)
	      j = 2
	    else
	      j = 1
	      name = 'yyyy'
	    endif
	    do i=j,ianz
	      lp=lpara(i)
	      zeile=' '
	      zeile(1:1)='('
	      zeile(2:lp+1)=cpara(i)(1:lp)
	      zeile(lp+2:lp+2)=')'
	      lp              = lp+2
	      werte(i)=0
	      werte(i)=berechne(zeile,lp)
	      if(ier_num.ne.0) return
	    enddo
	    if(ianz.ge.4) then
	      call do_ins_atom(name,werte,ianz)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -10
	  ier_typ = ER_APPL
	endif
	end
c*****7*****************************************************************
	subroutine do_app(line,laenge,lkick)
c-
c	Inserts a new atom into the structure. The name and position
c	must be given, optionally the temperature factor will be read.
c	If an atom of this type exists the temperature factor will be
c	that of the first type of temperature factor given for this atom
c	type, else the temperature factor will be 0.
c
c	Appends a new atom
c+
	implicit     	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'charact.inc'
	include 	'errlist.inc'
c
	integer       maxw
	parameter    (maxw=10)
c
	character*(*) line
	character*4   name
	character*200 cpara(maxw),zeile
	integer       lpara(maxw)
	integer       i,j,k,ianz,laenge,lp
	logical       lkick,lspace
	real          werte(maxw)
	real          w(3),v(3)
	real          berechne
	real          do_blen
c
	data          lspace/.true./
c
c
c------	If there is still space in the crystal, try to insert the atom
c
	if(cr_natoms.lt.nmax) then
	  call get_params(line,ianz,cpara,lpara,maxw,laenge)
	  if(ier_num.eq.0) then
	    if(ianz.ge.8) then
c
c------	------A minimum of eight parameters is required by 'append' and 'kick'
c
              i  = ichar(cpara(1)(1:1))
              if((a .le.i .and. i.le.z ).or.
     &           (aa.le.i .and. i.le.zz)     )  then
	        name=cpara(1)
	        j = 2
	      else
	        j = 1
	        name = 'yyyy'
	      endif
c
c------	------Evaluate parameters, old form will be replaced by ber_params
c
	      do i=j,ianz
	        lp=lpara(i)
	        zeile=' '
	        zeile(1:1)='('
	        zeile(2:lp+1)=cpara(i)(1:lp)
	        zeile(lp+2:lp+2)=')'
	        lp              = lp + 2	
	        werte(i)=0
	        werte(i)=berechne(zeile,lp)
	        if(ier_num.ne.0) return
	      enddo
	      j = nint(werte(6))
	      k = nint(werte(7))
c
c------	------j,k is the range of atoms to compare with the new atom
c	      is this range within the current crystal ?
c
	      if((0.lt.j .and. j.le.cr_natoms  .and.
     &	          0.lt.k .and. k.le.cr_natoms  .and. j.le.k) .or.
     &	         (j.eq.cr_natoms+1 .and. k.eq.cr_natoms)     ) then
c
c------	--------Apply default values
c
	        if(ianz.lt. 9) werte( 9)=werte( 8)
	        if(ianz.lt.10) werte(10)=werte( 9)
c
	        if(werte(8).lt.0) then
c
c------	----------Interpret parameter 8 as bondlength
c
	          if(lkick) then
c
c------	------------'kick' mode, remove all atoms from crystal that are
c	                         too close
c
	            do i=j,k
	              w(1) = cr_pos(1,i)
	              w(2) = cr_pos(2,i)
	              w(3) = cr_pos(3,i)
	              v(1) = werte(2)
	              v(2) = werte(3)
	              v(3) = werte(4)
	              if(do_blen(lspace,w,v).lt.-werte(8) ) then
	                cr_iscat(i) = 0
	                cr_ndel         =cr_ndel+1
	              endif
	            enddo
	          else
c
c------	------------'append' mode, insert new atom only if no other atom is
c	                           too close. Vacancies are ignored.
c
	            do i=j,k
	              if(cr_at_lis(cr_iscat(i)).ne.'VOID') then
	                w(1) = cr_pos(1,i)
	                w(2) = cr_pos(2,i)
	                w(3) = cr_pos(3,i)
	                v(1) = werte(2)
	                v(2) = werte(3)
	                v(3) = werte(4)
	                if(do_blen(lspace,w,v).lt.-werte(8) ) then
	                  goto 10
	                endif
	              endif
	            enddo
	          endif
	          call do_ins_atom(name,werte,ianz)
	        else
c
c------	----------Interpret parameters 8,9,10 as direct lattice units
c
	          if(lkick) then
c
c------	------------'kick' mode, remove all atoms from crystal that are
c	                         too close
c
	            do i=j,k
	              if(abs(cr_pos(1,i)-werte(2)).lt.werte( 8) .and.
     &	                 abs(cr_pos(2,i)-werte(3)).lt.werte( 9) .and.
     &	                 abs(cr_pos(3,i)-werte(4)).lt.werte(10) ) then
c	              cr_pos (1,i)=0.0
c	              cr_pos (2,i)=0.0
c	              cr_pos (3,i)=0.0
	                cr_iscat(i) =0
	                cr_ndel         =cr_ndel+1
	              endif
	            enddo
	          else
c
c------	------------'append' mode, insert new atom only if no other atom is
c	                           too close. Vacancies are ignored.
c
	            do i=j,k
	              if(cr_at_lis(cr_iscat(i)).ne.'VOID') then
	              if(abs(cr_pos(1,i)-werte(2)).lt.werte( 8) .and.
     &	                 abs(cr_pos(2,i)-werte(3)).lt.werte( 9) .and.
     &	                 abs(cr_pos(3,i)-werte(4)).lt.werte(10) ) then
	                goto 10
	              endif
	              endif
	            enddo
	          endif
	          call do_ins_atom(name,werte,ianz)
	        endif
	      elseif(cr_natoms.eq.0) then
c
c------	--------The crystal is empty. Insert atom in any case
c
	        call do_ins_atom(name,werte,ianz)
	      else
c
c------	--------Wrong range of atoms to compare to the new one
c
	        ier_num = -2
	        ier_typ = ER_APPL
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -10
	  ier_typ = ER_APPL
	endif
10	continue
	end
c****7******************************************************************
	subroutine do_ins_atom(name,werte,ianz)
c-
c	Inserts the atom given by name and position in werte into the
c	structure.
c+
	implicit     	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer       maxw
	parameter    (maxw=5)
c
	character*4   name
	integer       i,l,ianz
	logical       lda
	real          werte(maxw)
c
	if(cr_natoms.lt.NMAX) then
	  call do_cap(name)
	  i  =0
	  if(name.eq.'YYYY') then
	    i = nint(werte(1))
	    if(0.le.i .and. i.le.cr_nscat) then
	      ier_num = 0
	      ier_typ = ER_NONE
	      cr_natoms = cr_natoms+1
	      cr_iscat(cr_natoms)= i
	    else
	      ier_num = -27
	      ier_typ = ER_APPL
	    endif
	  else
	    lda=name    .eq.cr_at_lis(i)   .and.
     &	        werte(5).eq.cr_dw(i)
	    do while(.not.lda  .and. i.lt.cr_nscat)
	      i   = i+1
	      lda = name    .eq.cr_at_lis(i)   .and.
     &	            werte(5).eq.cr_dw(i)
	    enddo
	    if(lda) then
	      cr_natoms          = cr_natoms+1
	      cr_iscat(cr_natoms)= i
	    else
	      if(cr_nscat+1.le.maxscat) then
	        cr_natoms           = cr_natoms+1
	        cr_nscat            = cr_nscat +1
	        cr_iscat(cr_natoms) = cr_nscat
	        cr_at_lis(cr_nscat) = name
	        cr_dw(cr_nscat)     = werte(5)
	      else
	        ier_num = -26
	        ier_typ = ER_APPL
	      endif
	    endif
	  endif
	  if(ier_num.eq.0) then
	    cr_pos(1,cr_natoms) = werte(2)
	    cr_pos(2,cr_natoms) = werte(3)
	    cr_pos(3,cr_natoms) = werte(4)
	    do l=1,3
	      cr_dim(l,1)=amin1(cr_dim(l,1),cr_pos(l,cr_natoms))
	      cr_dim(l,2)=amax1(cr_dim(l,2),cr_pos(l,cr_natoms))
	    enddo
	  endif
	else
	  ier_num = -10
	  ier_typ = ER_APPL
	endif
	end
c*****7*****************************************************************
	subroutine do_remove(line,ll)
c-
c	Removes a single atom from the structure. line is evaluated to
c	give the index of the atom.
c+
	implicit     	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
	include 	'molecule.inc'
c
	integer         maxw
	parameter      (maxw=6)
c
	character*(*)   line
	character*200   cpara(maxw)
	integer         lpara(maxw)
	integer         i,j
	integer         ll,istart,iend,ianz
	integer         tstart,tend
	logical         l_mole
	logical         l_type
	real            werte(maxw)
c
	logical       str_comp
c
	l_mole = .false.
c
c------	Get parameters
c
	call  get_params(line,ianz,cpara,lpara,maxw,ll)
	if(ier_num.eq.0) then
c
c------	--Remove atoms or molecules ?
c
	  l_mole = .false.
	  tstart = 1
	  tend   = mole_num_type
	  if(ianz.gt.2 .and.
     &	     str_comp(cpara(3),'molecule',1,lpara(3),8)) then
	    cpara(3) = '0'
	    lpara(3) = 1
	    l_mole = .true.
	  elseif(ianz.gt.1 .and.
     &	     str_comp(cpara(2),'molecule',1,lpara(2),8)) then
	    do i=ianz,3,-1
	      cpara(i+1) = cpara(i)
	      lpara(i+1) = lpara(i)
	    enddo
	    cpara(3) = '0'
	    lpara(3) = 1
	    l_mole   = .true.
	    cpara(2) = cpara(1)
	    lpara(2) = lpara(1)
	    ianz     = ianz + 1
	  endif
	  if(ianz.gt.4 .and.
     &	     str_comp(cpara(4),'type',1,lpara(4),8)) then
	    cpara(4) = '0'
	    lpara(4) = 1
	    l_type = .true.
	  endif
c
c------	--Calculate value of parameters
c
	  if(str_comp(cpara(1),'all',1,lpara(1),3)) then
c
c------	----Remove all molecules or all atoms
c
	    write(cpara(1),3000) 1
	    if(l_mole) then
	      write(cpara(2),3000) mole_num_mole
	    else
	      write(cpara(2),3000) cr_natoms
	      if(ianz.eq.1) ianz = 2
	    endif
	    lpara(1) = 11
	    lpara(2) = 11
	  elseif(str_comp(cpara(1),'last',1,lpara(1),4)) then
c
c------	----Remove last molecule or last atom
c
	    if(l_mole) then
	      write(cpara(1),3000) mole_num_mole
	      write(cpara(2),3000) mole_num_mole
	    else
	      write(cpara(1),3000) cr_natoms
	      write(cpara(2),3000) cr_natoms
	      if(ianz.eq.1) ianz = 2
	    endif
	    lpara(1) = 11
	    lpara(2) = 11
	  endif
c
c------	--Select type of molecule
c
	  if(str_comp(cpara(5),'all',1,lpara(5),3)) then
c
c------	----Remove all types of molecules or all atoms
c
	    write(cpara(5),3000) 1
	    write(cpara(6),3000) mole_num_type
	    lpara(5) = 11
	    lpara(6) = 11
	  elseif(str_comp(cpara(5),'last',1,lpara(5),4)) then
c
c------	----Remove only the last type of molecule
c
	    write(cpara(5),3000) mole_num_type
	    write(cpara(6),3000) mole_num_type
	    lpara(5) = 11
	    lpara(6) = 11
	  endif
c
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if(ier_num.eq.0) then
	    istart = nint(werte(1))
	    if(ianz.eq.1) then
	      iend = istart
	    else
	      iend = nint(werte(2))
	    endif
c
c------	----Remove molecules
c
	    if(l_mole) then
	      if(0.lt.istart .and. istart.le.iend .and.
     &          iend.le.mole_num_mole                   ) then
c
c------	--------Set limits for types that can be removed
c
	        if(ianz.eq.5) then
	          tstart = werte(5)
	          tend   = werte(5)
	        elseif(ianz.eq.6) then
	          tstart = werte(5)
	          tend   = werte(6)
	        endif
	        if(0.lt.tstart .and. tstart.le.tend .and.
     &            tend.le.mole_num_type                   ) then
c
c------	----------Loop over all molecules in range
c
	          do i=istart,iend
	            if(tstart.le.mole_type(i) .and.
     &	               mole_type(i).le.tend        ) then
c
c------	--------------Set molecule type to zero and remove atoms
c
	              mole_type(i) = 0
	              do j=1,mole_len(i)
	                if(cr_iscat(mole_cont(mole_off(i)+j)).ne.0) then
	                  cr_iscat(mole_cont(mole_off(i)+j)) = 0
	                  cr_ndel     = cr_ndel+1
	                endif
	              enddo
	            endif
	          enddo
	        else
	          ier_num = -64
	          ier_typ = ER_APPL
	        endif
	      else
	        ier_num = -63
	        ier_typ = ER_APPL
	      endif
	    else
c
c------	------If index of atom is within limits, remove atom by
c	      Setting its scattering curve to zero
c
	      if(0.lt.istart .and. istart.le.iend .and.
     &	         iend.le.cr_natoms                     ) then
	        do i=istart,iend
	          if(cr_iscat(i).ne.0) then
	            cr_iscat(i) = 0
	            cr_ndel     = cr_ndel+1
	          endif
	        enddo
	      else
	        ier_num = -19
	        ier_typ = ER_APPL
	      endif
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	endif
c
3000	format(i11)
c
	end
c*****7**************************************************************
	subroutine do_purge
c-
c	Purges the list of atoms from all deleted atoms
c+
	implicit     	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer       i,ii,idel
c
	if(cr_ndel.ne.0) then
	  idel=0
	  do i=1,cr_natoms-cr_ndel
	    do while (cr_iscat(i+idel).eq.0)
	      idel=idel+1
	    enddo
	    ii            = i+idel
	    cr_pos(1,i)   = cr_pos(1,ii)
	    cr_pos(2,i)   = cr_pos(2,ii)
	    cr_pos(3,i)   = cr_pos(3,ii)
	    cr_iscat(i)   = cr_iscat(ii)
	    cr_md_next(i) = cr_md_next(ii)
	    cr_md_dist(i) = cr_md_dist(ii)
	  enddo
	  cr_natoms=cr_natoms-cr_ndel
	  cr_ndel  =0
	endif
	write (*,1000) char(7)
c
1000	format(
     &	' ****APPL****All functions that require identical     ****'/
     &	'         ****number of atoms in ALL unit cells might  ****'/
     &	'         ****not work correctly after a purge command ****',
     &	a1)
c
	end
c*****7***********************************************************************
	subroutine do_copy(line,lp)
c-
c	copies an atom to a new position given in relativ or absolute
c	fractional coordinates
c+
	implicit     	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer       maxw
	parameter    (maxw=5)
c
	character*(*) line
	character*80  zeile
	character*200 cpara(maxw)
	integer       lpara(maxw)
	integer       ianz,i,lp,ind
	real          werte(maxw)
	real          berechne
c
	zeile =' '
	call get_params(line,ianz,cpara,lpara,maxw,lp)
	if(ianz.ne.5) then
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
	if(ier_num.eq.0) then
	  do i=2,ianz
	    lp=lpara(i)
	    zeile=' '
	    zeile(1:1)='('
	    zeile(2:lp+1)=cpara(i)(1:lp)
	    zeile(lp+2:lp+2)=')'
	    lp              = lp+2
	    werte(i)=berechne(zeile,lp)
	    if(ier_num.ne.0) return
	  enddo
	  ind=int(werte(2))
	  zeile =' '
	  zeile(1:4)=cr_at_lis(cr_iscat(ind))
	  zeile(5:5)=','
	  if(cpara(1)(1:1).eq.'a') then
	    write(zeile(7:57),3000) (werte(i),i=3,5),
     &	    cr_dw(cr_iscat(ind))
	    lp = 57
	  elseif(cpara(1)(1:1).eq.'r') then
	    write(zeile(7:57),3000) (werte(i)+cr_pos(i-2,ind),i=3,5),
     &	    cr_dw(cr_iscat(ind))
	    lp = 57
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	    return
	  endif
	  call do_ins(zeile,lp)
	endif
3000	format(3(e12.5e1,','),e12.5e1)
	end
c*****7*****************************************************************
	subroutine do_switch(line,lp)
c-
c	Switches two atoms in the structure. The number of the two
c	atoms must be given. If the last parameter is "mol" then
c	two molecules are swapped.
c+
	implicit     	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'molecule.inc'
	include 	'errlist.inc'
c
	integer		maxw
	parameter	(maxw=3)
c
	character*(*)	line
	character*200	cpara(maxw)
	real		werte(maxw)
	integer		lpara(maxw)
	integer		i,j,ianz,lp,is
c
	logical		str_comp
c
	call get_params(line,ianz,cpara,lpara,maxw,lp)
	if(ier_num.ne.0) return
c
c------ Molecules
c
	if(ianz.eq.3) then
	  if (str_comp(cpara(3),'mol',2,lpara(3),3)) then
	    ianz=ianz-1
	    call ber_params (ianz,cpara,lpara,werte,maxw)
	    i=nint(werte(1))
	    j=nint(werte(2))
	    if(0.lt.i .and. i.le.mole_num_mole .and.
     &	       0.lt.j .and. j.le.mole_num_mole       ) then
	      call do_swap_mole(i,j,.true.)
	      call update_cr_dim
	    else
	      ier_num = -63
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c------ Atoms
c
	elseif (ianz.eq.2) then
	  call ber_params (ianz,cpara,lpara,werte,maxw)
	  i=nint(werte(1))
	  j=nint(werte(2))
	  if(0.lt.i .and. i.le.cr_natoms .and.
     &	     0.lt.j .and. j.le.cr_natoms       ) then
	    is         =cr_iscat(i)
	    cr_iscat(i)=cr_iscat(j)
	    cr_iscat(j)=is
	  else
	    ier_num = -19
	    ier_typ = ER_APPL
	  endif
c
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine do_find(line,laenge)
c-
c	Finds the environment around an atom
c+
	implicit     	none
c
	include 	'config.inc'
	include 	'charact.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer       maxw
	parameter    (maxw=15)
	integer       mmaxw
	parameter    (mmaxw=4)
c
	character*(*) line
	character*200 cpara(maxw)
	character*200 ccpara(mmaxw)
	integer       lpara(maxw)
	integer       llpara(maxw)
	integer       i,ii,ianz,iianz,laenge
	logical       lnew,fq,fp(3)
	real          radius
	real          werte(maxw)
	real          wwerte(maxw)
	real          x(3)
c
	parameter     (lnew=.false.)
c
	logical       str_comp
c
	fp(1) = .false.
	fp(2) = .false.
	fp(3) = .false.
	fq    = .false.
c
	call get_params(line,ianz,cpara,lpara,maxw,laenge)
	if(ier_num.eq.0) then
	  if(str_comp(cpara(1),'env',1,lpara(1),3)) then
c
c------	----Find environment
c
	    if(ianz.ge.6) then
c
c------	------copy last three parameters for evaluation
c
	      do i=ianz-3,ianz
	        ii         = i - (ianz-4)
	        ccpara(ii) = cpara(i)
	        llpara(ii) = lpara(i)
	      enddo
	      iianz = 4
	      call ber_params(iianz,ccpara,llpara,wwerte,mmaxw)
	      x(1)   = wwerte(1)
	      x(2)   = wwerte(2)
	      x(3)   = wwerte(3)
	      radius = wwerte(4)
	      if(ier_num.eq.0) then
c
c------	-------- shift remaining parameters one left
c
	        do i=2,ianz-4
	          cpara(i-1) = cpara(i)
	          lpara(i-1) = lpara(i)
	        enddo
	        ianz = ianz-5
c
c------	--------Get scattering curves
c
	        call get_iscat(ianz,cpara,lpara,werte,maxw,lnew)
	        if(ier_num.eq.0) then
	          call do_find_env(ianz,werte,maxw,x,0.0,radius,fq,fp)
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  elseif(str_comp(cpara(1),'menv',1,lpara(1),4)) then
c
c------	----Find molecular environment
c
	    if(ianz.ge.6) then
c
c------	------copy last three parameters for evaluation
c
	      do i=ianz-3,ianz
	        ii         = i - (ianz-4)
	        ccpara(ii) = cpara(i)
	        llpara(ii) = lpara(i)
	      enddo
	      iianz = 4
	      call ber_params(iianz,ccpara,llpara,wwerte,mmaxw)
	      x(1)   = wwerte(1)
	      x(2)   = wwerte(2)
	      x(3)   = wwerte(3)
	      radius = wwerte(4)
	      if(ier_num.eq.0) then
c
c------	-------- shift remaining parameters one left
c
	        do i=2,ianz-4
	          cpara(i-1) = cpara(i)
	          lpara(i-1) = lpara(i)
	        enddo
	        ianz = ianz-5
c
c------	--------Get allowed molecule types
c
	        if(str_comp(cpara(1),'all',1,lpara(1),3)) then
	          ianz = -1
	        else
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	        endif
	        if(ier_num.eq.0) then
	          call do_find_mol(ianz,werte,maxw,x,0.0,radius,fq,fp)
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -10
	  ier_typ = ER_APPL
	endif
c
	end
c*****7*****************************************************************
	subroutine do_find_env(ianz,werte,maxw,x,rmin,rmax,fq,fp)
c 
c	This routine finds all atoms around x with a minimal
c	distance of rmin and a maximum distance of rmax.
c-
	implicit      none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'atom_env.inc'
	include      'param.inc'
	include      'errlist.inc'
c
	integer       ianz,maxw
	real          werte(maxw)
	real          x(3)
	real          rmin,rmax
	logical       fq,fp(3)
c
	integer       i,j,k,ii
	integer       istart(3),iend(3),iii(3),cell(3),iatom
	real	      offset(3),nooffset(3)
	logical       ltype
c
	logical       atom_allowed
c
	data nooffset /0.0,0.0,0.0/
c
	atom_env(0) = 0
	res_para(0) = 0
	if (fq) then
c
c------ --quick version only looks at neighbouring unit cells
c
	  do i=1,3
	    iii(i)    = int(x(i) - cr_dim0(i,1))+1
	    istart(i) = iii(i)-1-int(rmax/cr_a0(i))
	    iend(i)   = iii(i)+1+int(rmax/cr_a0(i))
	  enddo
c
	  do k=istart(3),iend(3)
	  do j=istart(2),iend(2)
	  do i=istart(1),iend(1)
	    cell(1) = i
	    cell(2) = j
	    cell(3) = k
c
	    call check_bound (cell,offset,fp,ltype)
	    if (ltype) then
	      do ii=1,cr_ncatoms
	        call celltoindex (cell,ii,iatom)
	        ltype = atom_allowed (iatom,werte,ianz,maxw)
	        if(ltype) then
	          call check_blen (x,iatom,rmin,rmax,offset)
	          if (ier_num.ne.0) return
	        endif
	      enddo
	    endif
c
	  enddo
	  enddo
	  enddo
c
c------	--exact: loop over all atoms in crystal that have been added
c
	  do i=cr_ncatoms*cr_icc(1)*cr_icc(2)*cr_icc(3)+1,cr_natoms
c
	    if (fp(1).or.fp(2).or.fp(3)) then
	      ier_num = -16
	      ier_typ = ER_CHEM
	      return
	    endif
c
	    ltype = atom_allowed (i,werte,ianz,maxw)
	    if(ltype) then
	      call check_blen (x,i,rmin,rmax,nooffset)
	      if (ier_num.ne.0) return
	    endif
	  enddo
	else
c
c------	--exact: loop over all atoms in crystal
c
	  if (fp(1).or.fp(2).or.fp(3)) then
	    ier_num = -16
	    ier_typ = ER_CHEM
	    return
	  endif
c
	  do i=1,cr_natoms
	    ltype = atom_allowed (i,werte,ianz,maxw)
	    if(ltype) then
	      call check_blen (x,i,rmin,rmax,nooffset)
	      if (ier_num.ne.0) return
	    endif
	  enddo
	endif
c
	end
c*****7*****************************************************************
	subroutine check_bound (cell,offset,fp,ltype)
c+
c	This routine applies periodic boundaries if 'fp' is TRUE.
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'errlist.inc'
c
	integer		cell(3)
	real		offset(3)
	logical		fp(3),ltype,lok(3)
c
	integer		i
	integer		j
c
c------ Apply periodic boundaries
c
	do i=1,3
	  if (fp(i)) then
	    offset(i) = 0.0
c
	    if (cell(i).lt.1) then
	      if(cr_icc(i).eq.1) then
	        offset(i) = float(cell(i)-1)
	        cell(i)   = 1
	      else
	        j         = (-cell(i)/cr_icc(i)+1)*cr_icc(i)
	        cell(i)   = cell(i) + j
	        offset(i) = - float(j)
	      endif
	    elseif (cell(i).gt.cr_icc(i)) then
	      if(cr_icc(i).eq.1) then
	        offset(i) =  float(cell(i)-1)
	        cell(i)   = 1
	      else
	        j         = ((cell(i)-1)/cr_icc(i))*cr_icc(i)
	        cell(i)   = cell(i) - j
	        offset(i) = float(j)
	      endif
	    endif
c
	    lok(i) = .true.
c
c------ NO periodic boundaries
c
	  else
	    offset(i) = 0.0
	    lok(i)    = (cell(i).gt.0) .and. (cell(i).le.cr_icc(i))
	  endif
	enddo
c
	ltype = lok(1) .and. lok(2) .and. lok(3)
c
	end
c*****7*****************************************************************
	subroutine check_blen (x,iatom,rmin,rmax,offset)
c+
c	checks if atom 'iatom' is within rmin -> rmax awaz from
c	position x(3). All matching atoms are stored in the
c	arrays 'atom_env' and 'res_para'. The positions of the
c	atoms are stored in 'atom_pos' to retain information 
c	about possible periodic boundaries.
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'atom_env.inc'
	include		'param.inc'
	include		'errlist.inc'
c
	real		x(3),offset(3),rmin,rmax
	integer		iatom
c
	real		v(3),dist,do_blen
	integer		j
	logical		lspace
c
	lspace      = .true.
c    
	do j=1,3
	  v(j) = cr_pos(j,iatom) + offset(j)
	enddo
	dist = do_blen(lspace,x,v)
	if(dist.ge.rmin .and. dist.le.rmax) then
	  if(atom_env(0).lt.MAX_ATOM_ENV) then
	    if(atom_env(0).lt.MAXPAR_RES) then
	      atom_env(0) = atom_env(0) + 1
	      atom_env(atom_env(0)) = iatom
	      res_para(atom_env(0)) = dist
	      res_para(0)           = float(nint(res_para(0)) + 1)
	      do j=1,3
	        atom_pos (j,atom_env(0)) = v(j)
	      enddo
	    else
	      ier_num = -79
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -45
	    ier_typ = ER_APPL
	  endif
	endif
	end
c*****7*****************************************************************
	logical function atom_allowed (i,werte,ianz,maxw)
c+
c	checks if atom i is within the selected atom range in
c	werte(ianz).
c-
	implicit	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer		i,ianz,maxw
	real		werte(maxw)
c
	integer		j
	logical		ltype
c
	if(i.le.0) then
	  ltype = .false.
	else
	  if(werte(1).eq.-1) then
	    ltype = .true.
	  else
	    ltype = .false.
	    do j=1,ianz
	      ltype = ltype .or. cr_iscat(i).eq.nint(werte(j))
	    enddo
	  endif
	endif
	atom_allowed = ltype
	end
c*****7*****************************************************************
	logical function scat_allowed (is,werte,ianz,maxw)
c+
c	checks if atom i is within the selected atom range in
c	werte(ianz).
c-
	implicit	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer		is,ianz,maxw
	real		werte(maxw)
c
	integer		j
	logical		ltype
c
	if(werte(1).eq.-1) then
	  ltype = .true.
	else
	  ltype = .false.
	  do j=1,ianz
	    ltype = ltype .or. is.eq.nint(werte(j))
	  enddo
	endif
	scat_allowed = ltype
	end
c*****7*****************************************************************
	subroutine celltoindex (icell,isite,iatom)
c-
c 	calculates in which unit cell on which site the atom <ia> is
c+
	implicit	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer		iatom,isite,icell(3)
c
	iatom = ((icell(3)-1)*cr_icc(1)*cr_icc(2) +
     &	         (icell(2)-1)*cr_icc(1)           + 
     &	         (icell(1)-1)                      )*cr_ncatoms+isite
c
	end
c*****7*****************************************************************
	subroutine indextocell (iatom,icell,isite)
c-
c 	calculates in which unit cell on which site the atom <ia> is
c+
	implicit	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer		iatom,isite,icell(3)
	integer		ia
c
        ia       = iatom-1
c
        icell(3) = int(ia/cr_icc(1)/cr_icc(2)/cr_ncatoms)+1
        ia       = ia-(icell(3)-1)*cr_icc(1)*cr_icc(2)*cr_ncatoms
        icell(2) = int(ia/cr_icc(1)/cr_ncatoms)+1
        ia       = ia-(icell(2)-1)*cr_icc(1)*cr_ncatoms
        icell(1) = int(ia/cr_ncatoms)+1
	isite    = ia-(icell(1)-1)*cr_ncatoms+1
c
	end
c*****7*****************************************************************
	subroutine atom_select(zeile,lp,latom,repl,ival,lu,lo,sel_atom,
     &	                       md_s,md_nr,lold,lselect)
c+
c	This routine exectues the select command
c-
	implicit	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'microsta.inc'
	include 	'errlist.inc'
c
	integer		maxw
	parameter	(maxw=MAXSCAT)
c
	character*(*)	zeile
	integer		lu,lo,md_s,md_nr,lp
	integer		repl(lu:lo),ival
	logical		latom(lu:lo),sel_atom,lold,lselect
c
	character*200	cpara(maxw)
	real		werte(maxw)
	integer		ianz,i,is,lpara(maxw)
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if(ier_num.ne.0) return
c
c------ In case we had molecules before, deselect all
c
	if (.not. sel_atom) then
	  do i=0,cr_nscat
	    latom(i) = .false.
	    repl(i)  = ival
	  enddo
	endif
c
	sel_atom = .true.
c
c------ Microdomain subcommand
c
	if(cpara(1)(1:3).eq.'mic') then
c
c------ - Command was select
c
	  if (lselect) then
	    if (ianz.eq.2) then
	      if(cpara(2)(1:3).eq.'all') then
	        md_s  = MD_S_ALL
	        md_nr = 0
	      elseif(cpara(2)(1:3).eq.'non') then
	        md_s  = MD_S_NON
	        md_nr = 0
	      elseif(cpara(2)(1:3).eq.'eve') then
	        md_s  = MD_S_EVE
	        md_nr = 0
	      else
	        call del_params (1,ianz,cpara,lpara,maxw)
	        call ber_params (ianz,cpara,lpara,werte,maxw)
	        if (ier_num.eq.0) then
	          md_nr = nint(werte(1))
	          md_s  = MD_S_IND
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------ - Command was deselect
c
	  else
	    md_s  = MD_S_EVE
	    md_nr = 0
	  endif
c
c------ Select/deselect atoms
c
	else
	  call get_iscat(ianz,cpara,lpara,werte,maxw,lold)
	  if(ier_num.ne.0) return
c
	  if(werte(1).eq.-1) then
	    do i=0,cr_nscat
	      latom(i) = lselect
	      repl(i)  = ival
	    enddo
	  else
	    do i=1,ianz
	      is = nint(werte(i))
	      if (is.ge.0 .and. is.le.cr_nscat) then
	        latom(is) = lselect
	        repl(is)  = ival
	      else
	        ier_num = -27
	        ier_typ = ER_APPL
	      endif
	    enddo
	  endif
	endif
c
	end
c*****7*****************************************************************
	subroutine mole_select(zeile,lp,latom,repl,ival,lu,lo,sel_atom,
     &	                       md_s,md_nr,lold,lselect)
c+
c	This routine exectues the select command
c-
	implicit	none
c
	include 	'config.inc'
	include 	'molecule.inc'
	include 	'microsta.inc'
	include 	'errlist.inc'
c
	integer		maxw
	parameter	(maxw=MAXSCAT)
c
	character*(*)	zeile
	integer		lu,lo,md_s,md_nr,lp
	logical		latom(lu:lo),sel_atom,lold,lselect
c
	character*200	cpara(maxw)
	real		werte(maxw)
	integer		repl(lu:lo),ival
	integer		ianz,i,is,lpara(maxw)
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if(ier_num.ne.0) return
c
c------ In case we had atoms before, deselect all
c
	if (sel_atom) then
	  do i=1,mole_num_type
	    latom(i) = .false.
	    repl(i)  = ival
	  enddo
	endif
c
	sel_atom = .false.
c
c------ Microdomain subcommand
c
	if(cpara(1)(1:3).eq.'mic') then
c
c------ - Command was select
c
	  if (lselect) then
	    if (ianz.eq.2) then
	      if(cpara(2)(1:3).eq.'all') then
	        md_s  = MD_S_ALL
	        md_nr = 0
	      elseif(cpara(2)(1:3).eq.'non') then
	        md_s  = MD_S_NON
	        md_nr = 0
	      elseif(cpara(2)(1:3).eq.'eve') then
	        md_s  = MD_S_EVE
	        md_nr = 0
	      else
	        call del_params (1,ianz,cpara,lpara,maxw)
	        call ber_params (ianz,cpara,lpara,werte,maxw)
	        if (ier_num.eq.0) then
	          md_nr = nint(werte(2))
	          md_s  = MD_S_IND
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------ - Command was deselect
c
	  else
	    md_s  = MD_S_EVE
	    md_nr = 0
	  endif
c
c------ Select/deselect molecules
c
	else
	  if(cpara(1)(1:1).eq.'a') then
	    do i=1,mole_num_type
	      latom(i) = lselect
	      repl(i)  = ival
	    enddo
	  else
	    call ber_params (ianz,cpara,lpara,werte,maxw)
	    do i=1,ianz
	      is = nint(werte(i))
	      if (is.gt.0 .and. is.le.mole_num_type) then
	        latom(is) = lselect
	        repl(i)   = ival
	      else
	        ier_num = -64
	        ier_typ = ER_APPL
	      endif
	    enddo
	  endif
	endif
c
	end
c*****7*****************************************************************
	subroutine do_find_mol(ianz,werte,maxw,x,rmin,rmax,fq,fp)
c 
c	This routine finds all molecules around x with a minimal
c	distance of rmin and a maximum distance of rmax.
c-
	implicit      none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'param.inc'
	include      'errlist.inc'
	include      'molecule.inc'
	include      'mole_env.inc'
c
	integer       ianz,maxw
	real          werte(maxw)
	real          x(3)
	real          rmin,rmax
	logical       fq,fp(3)
c
	integer       i,j
c
	real	      nooffset(3)
	logical       ltype
c
	data nooffset /0.0,0.0,0.0/
c
	mole_env(0) = 0
	res_para(0) = 0
c
c	Exact loop over all molecules, no periodic boundary conditions
c
	do i=1,mole_num_mole
	  if(ianz.eq.-1) then 
	    ltype = .true.
	  else
	    ltype = .false.
	    do j=1,ianz
	      ltype = i.eq.nint(werte(j))
	    enddo
	  endif
	  if(ltype) then
	    call check_blen_mol (x,i,rmin,rmax,nooffset)
	  endif
	  if (ier_num.ne.0) return
	enddo
CDBG
CDBG	do i=1,mole_env(0)
CDBG	  write (output_io,*) 'molecule ',mole_env(i)
CDBG	enddo
	end
c*****7*****************************************************************
	subroutine check_blen_mol (x,imole,rmin,rmax,offset)
c+
c	checks if molecule 'imole' is within rmin -> rmax awaz from
c	position x(3). All matching molecules are stored in the
c	arrays 'mole_env' and 'res_para'. The positions of the
c	molecules are stored in 'mole_pos' to retain information 
c	about possible periodic boundaries.
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'param.inc'
	include		'errlist.inc'
	include		'molecule.inc'
	include         'mole_env.inc'
c
	real		x(3),offset(3),rmin,rmax
	integer		imole
c
	real		v(3),dist,do_blen
	integer		i,j
	logical		lspace
c
	lspace      = .true.
c    
	i = mole_cont(mole_off(imole)+1)
	do j=1,3
	  v(j) = cr_pos(j,i) + offset(j)
	enddo
	dist = do_blen(lspace,x,v)
	if(dist.ge.rmin .and. dist.le.rmax) then
	  if(mole_env(0).lt.MAX_MOLE_ENV) then
	    mole_env(0) = mole_env(0) + 1
	    mole_env(mole_env(0)) = imole
	    res_para(mole_env(0)) = dist
	    res_para(0)           = float(nint(res_para(0)) + 1)
	    do j=1,3
	      mole_pos (j,mole_env(0)) = v(j)
	    enddo
	  else
	    ier_num = -45
	    ier_typ = ER_APPL
	  endif
	endif
	end
c*****7*****************************************************************
	subroutine boundary (zeile,lp)
c+
c	This subroutine removes all atomes outside a given boundary.
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw = 6)
c
	character*200	zeile
	integer		lp
c
	character*200	cpara(maxw)
	integer		lpara(maxw)
	integer		i,ianz
	logical		lspace
	logical		linside
	real		h(3),d,dstar
	real		null(3)
	real		werte(maxw)
c
	logical		str_comp
	real		do_blen
c
	data null/0.0,0.0,0.0/
c
	linside = .true.
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if(ier_num.eq.0) then
	  if(str_comp(cpara(1),'hkl',    3,lpara(1),3) ) then
c
c------	----Crystal is limited by a plane
c
	    if(str_comp(cpara(ianz),'outside',3,lpara(ianz),7)    ) then
	      linside = .false.
	      ianz = ianz - 1
	    elseif(str_comp(cpara(ianz),'inside',3,lpara(ianz),6) ) then
	      linside = .true.
	      ianz = ianz - 1
	    endif
	    lspace = .false.
	    if(ianz.ge.4) then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      do i=1,3
	        h(i) = werte(i)
	      enddo
	      if(ianz.eq.4) then
	        dstar = do_blen(lspace,h,null)
	        do i=1,3
	          h(i) = h(i) / dstar / werte(4)
	        enddo
	      endif
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
	  if(ier_num.eq.0) then
	    do i=1,cr_natoms
	      d = 1.0-cr_pos(1,i)*h(1)-cr_pos(2,i)*h(2)-cr_pos(3,i)*h(3)
	      if((     linside .and. d.lt.0) .or. 
     &	         (.not.linside .and. d.gt.0)        ) then
	        if(cr_iscat(i).ne.0) then
	          cr_iscat(i) = 0
	          cr_ndel     = cr_ndel+1
	        endif
	      endif
	    enddo
	  endif
	endif
c
	end
