c*****7*****************************************************************
	subroutine patterson(inverse_type)
c-
c	patterson sets up the menu for inverse Fourier and Patterson
c	calculations.
c
c	Version  : 1.0
c	Date     : 05 Oct 96
c
c	Author   : R.B. Neder (reinhard.neder@mail.uni-wuerzburg.de)
c+
	implicit        none
c
	include        'config.inc'
	include        'crystal.inc'
	include        'crystal.cmm'
	include        'doact.inc'
	include        'intens.inc'
	include        'inverse.inc'
	include        'learn.inc'
	include        'macro.inc'
	include        'output.inc'
	include        'patters.inc'
	include        'prompt.inc'
	include        'diffuse.inc'
	include        'errlist.inc'
c
	integer         maxw
	parameter      (maxw=MAXSCAT)
	logical         lold
	parameter      (lold=.false.)
c
        character*1     extr_achs(0:3)
        character*1     rho_extr_achs(0:3)
	character*5     befehl
	character*16    prom
	character*14    cvalue(0:6)
	character*15    cgraphik(0:5)
	character*200   zeile,cpara(maxw)
	character*200   line
	logical         lspace
	logical         ltwo_files
	integer         lpara(maxw)
	integer         i,j,ianz,lp,length
	integer         indxg,lbef
	real            werte(maxw)
	real            divis(2)
	real            rho_divis(2)
	real            u(3),v(3),w(3),dvi1,dvi2,dvi3,dvi4,dvi5
c
	logical         str_comp
	real            do_blen,do_bang
c
        data extr_achs/' ','h','k','l'/
        data rho_extr_achs/' ','x','y','z'/
c
	data cgraphik
     &	/'Standard','Postscript','Pseudo Grey Map','Gnuplot',
     &	 'SHELXL','HKL F4'/
c
	data cvalue
     &	/'undefined     ',
     &	 'Intensity     ',
     &	 'Amplitude=Fobs',
     &	 'Phase angle   ',
     &	 'Real Part     ',
     &	 'Imaginary Part',
     &	 'Fcalc         '/
c
	if(cr_natoms.gt.0 .and. as_natoms.gt.0) then
	  patt_scale = float(cr_ncatoms)/float(cr_natoms)
	elseif(patt_scale.eq.0) then
	  patt_scale = 1.0
	endif
c
10	continue
c
	call no_error
c
	divis(1)     = float(max(1,    inc(1)-1))
	divis(2)     = float(max(1,    inc(2)-1))
	rho_divis(1) = float(max(1,rho_inc(1)-1))
	rho_divis(2) = float(max(1,rho_inc(2)-1))
c
	if(inverse_type.eq.INV_INV) then
	  prom = prompt//'/inverse'
	elseif(inverse_type.eq.INV_DIFF) then
	  prom = prompt//'/diff-four'
	elseif(inverse_type.eq.INV_PATT) then
	  prom = prompt//'/patterson'
	endif
	call get_command (line,length,befehl,lbef,zeile,lp,prom)
	if(ier_num.eq.0) then
	if(line(1:1).eq.' ' .or. line(1:1).eq.'#')  goto 10
c
c------	search for "="
c
	indxg=index(line,'=')
	if(indxg.ne.0 .and. .not.(str_comp(befehl,'echo',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'syst',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'help',2,lbef,4) .or.
     &	                          str_comp(befehl,'?   ',2,lbef,4)))then
c
c------	--evaluatean expression and assign the value to a variabble
c
	  call do_math(line,indxg,length)
	else
c
c------ execute a macro file
c
        if(befehl(1:1).eq.'@') then
	  if(length.ge.2) then
	    call file_kdo(line(2:length),length-1)
	  else
	    ier_num = -13
	    ier_typ = ER_MAC
	  endif
c
c------	Define the ascissa 'absc'
c
	elseif(str_comp(befehl,'absc',1,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ianz.eq.1) then
            if(cpara(1).eq.'h') then
              extr_abs=1
            elseif(cpara(1).eq.'k') then
              extr_abs=2
            elseif(cpara(1).eq.'l') then
              extr_abs=3
            else
              ier_num = -6
	      ier_typ = ER_COMM
            endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c------	continues a macro 'continue'
c
	elseif(str_comp(befehl,'continue',1,lbef,8)) then
	  call macro_continue(zeile,lp)
c
c------ Echo a string, just for interactive check in a macro 'echo'
c
	elseif(str_comp(befehl,'echo',2,lbef,4)) then
	  call echo(zeile,lp)
c
c------	 Evaluate an expression, just for interactive check 'eval'
c
	elseif(str_comp(befehl,'eval',2,lbef,4)) then
	  call do_eval(zeile,lp)
c
c------	Terminate invers Fourier / Patterson 'exit'
c
	elseif(str_comp(befehl,'exit',3,lbef,4)) then
	  goto 9999
c
c------	define the input file names 'file'
c
	elseif(str_comp(befehl,'file',1,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.ge.2) then
	      if(str_comp(cpara(1),'a    ',1,lpara(2),5)) then
		call do_build_name(ianz,cpara,lpara,werte,maxw,2)
	        if(ier_num.eq.0) then
	          i = 1
	          rho_file(i) = cpara(2)
	        endif
	      elseif(str_comp(cpara(1),'b    ',1,lpara(2),5)) then
		call do_build_name(ianz,cpara,lpara,werte,maxw,2)
	        if(ier_num.eq.0) then
	          i = 2
	          rho_file(i) = cpara(2)
	        endif
	      else
	        ier_num = -41
	        ier_typ = ER_APPL
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	Determine format for input 'format'
c
	elseif(str_comp(befehl,'form',1,lbef,4)) then
	  call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	  if(ier_num.eq.0) then
	    if(ianz.eq.1 .or. ianz.eq.2) then
c
c------	--Switch input type to GNUPLOT 'gnup'
c
	      if(str_comp(cpara(1),'gnup',1,lpara(1),4)) then
	        ftyp=3
c
c------	Switch input type to standard  'stan'
c
	      elseif(str_comp(cpara(1),'stan',2,lpara(1),4)) then
	        ftyp=0
c
c------	Switch input type to SHELXL List Type 5 'shelxl'
c
	      elseif(str_comp(cpara(1),'shelx',2,lpara(1),5)) then
	        ftyp=4
	        rho_type(1) = AMPLITUDE
	        if(ianz.eq.2) then
	          if(str_comp(cpara(2),'fobs',2,lpara(2),4)) then
	            rho_type(1) = AMPLITUDE
	          elseif(str_comp(cpara(2),'fcalc',2,lpara(2),5)) then
	            rho_type(1) = FCALC
	          else
	            ier_num = -52
	            ier_typ = ER_APPL
	          endif
	        endif
c
c------	Switch input type to SHELXS 'hklf4'
c
	      elseif(str_comp(cpara(1),'hklf4',2,lpara(1),5)) then
	        ftyp=5
	        rho_type(1) = INTENSITY
	        inverse_type = INV_PATT
	      else
	        ier_num = -9
	        ier_typ = ER_APPL
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	help 'help' , '?'
c
	elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	       str_comp(befehl,'?   ',1,lbef,4)     ) then
	  if(str_comp(zeile,'errors',2,lp,6) ) then
	    lp = lp + 7
	    call do_hel('discus '//zeile,lp)
	  else
	    if(inverse_type.eq.INV_INV) then
	      lp = lp+15
	      call do_hel('discus inverse '//zeile,lp)
	    elseif(inverse_type.eq.INV_DIFF) then
	      lp = lp+17
	      call do_hel('discus diff-four '//zeile,lp)
	    elseif(inverse_type.eq.INV_PATT) then
	      lp = lp+17
	      call do_hel('discus patterson '//zeile,lp)
	    endif
	  endif
c
c------	define the whole layer 'laye'
c
	elseif(str_comp(befehl,'laye',2,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.11) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        do j=1,3
	          do i=1,3
	            eck(i,j)=werte((j-1)*3+i)
	          enddo
	        enddo
	        inc(1)=nint(werte(10))
	        inc(2)=nint(werte(11))
	        divis(1) = float(max(1,inc(1)-1))
	        divis(2) = float(max(1,inc(2)-1))
	        do i=1,3              
	          vi(i,1)=(eck(i,2)-eck(i,1))/divis(1)
	          vi(i,2)=(eck(i,3)-eck(i,1))/divis(2)
	        enddo
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the lower left corner 'll'
c
	elseif(str_comp(befehl,'ll  ',2,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.3) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        j=1
	        do i=1,3
	          eck(i,j)=werte(i)
	        enddo
	        do i=1,3              
	          vi(i,1)=(eck(i,2)-eck(i,1))/divis(1)
	          vi(i,2)=(eck(i,3)-eck(i,1))/divis(2)
	        enddo
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the lower right corner 'lr'
c
	elseif(str_comp(befehl,'lr  ',2,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.3) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        j=2
	        do i=1,3
	          eck(i,j)=werte(i)
	        enddo
	        do i=1,3              
	          vi(i,1)=(eck(i,2)-eck(i,1))/divis(1)
	          vi(i,2)=(eck(i,3)-eck(i,1))/divis(2)
	        enddo
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the number of points along the abscissa 'na'
c
	elseif(str_comp(befehl,'nabs',2,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.1) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        if(werte(1).gt.0) then
	          inc(1)   = nint(werte(1))
	          divis(1) = float(max(1,inc(1)-1))
	          do i=1,3              
	            vi(i,1)=(eck(i,2)-eck(i,1))/divis(1)
	            vi(i,2)=(eck(i,3)-eck(i,1))/divis(2)
	          enddo
	        else
	          ier_num = -12
	          ier_typ = ER_APPL
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c------	define the number of points along the ordinate 'no'
c
	elseif(str_comp(befehl,'nord',2,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.1) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        if(werte(1).gt.0) then
	          inc(2)   = nint(werte(1))
	          divis(2) = float(max(1,inc(2)-1))
	          do i=1,3              
	            vi(i,1)=(eck(i,2)-eck(i,1))/divis(1)
	            vi(i,2)=(eck(i,3)-eck(i,1))/divis(2)
	          enddo
	        else
	          ier_num = -12
	          ier_typ = ER_APPL
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the ordinate  'ordi'
c
	elseif(str_comp(befehl,'ordi',2,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ianz.eq.1) then
            if(cpara(1).eq.'h') then
              extr_ord=1
            elseif(cpara(1).eq.'k') then
              extr_ord=2
            elseif(cpara(1).eq.'l') then
              extr_ord=3
            else
              ier_num = -6
	      ier_typ = ER_COMM
            endif
	  endif
c
c------	Define the real space ascissa 'rhoabsc'
c
	elseif(str_comp(befehl,'rhoab',4,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ianz.eq.1) then
            if(cpara(1).eq.'x') then
              rho_extr_abs=1
            elseif(cpara(1).eq.'y') then
              rho_extr_abs=2
            elseif(cpara(1).eq.'z') then
              rho_extr_abs=3
            else
              ier_num = -6
	      ier_typ = ER_COMM
            endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c------	define the whole real space layer 'rholayer'
c
	elseif(str_comp(befehl,'rhola',5,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.11) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        do j=1,3
	          do i=1,3
	            rho_eck(i,j)=werte((j-1)*3+i)
	          enddo
	        enddo
	        rho_inc(1)=nint(werte(10))
	        rho_inc(2)=nint(werte(11))
	        rho_divis(1) = float(max(1,rho_inc(1)-1))
	        rho_divis(2) = float(max(1,rho_inc(2)-1))
	        do i=1,3              
	          rho_vi(i,1)=(rho_eck(i,2)-rho_eck(i,1))/rho_divis(1)
	          rho_vi(i,2)=(rho_eck(i,3)-rho_eck(i,1))/rho_divis(2)
	        enddo
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the real space lower left corner 'rholl'
c
	elseif(str_comp(befehl,'rholl',5,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.3) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        j=1
	        do i=1,3
	          rho_eck(i,j)=werte(i)
	        enddo
	        do i=1,3              
	          rho_vi(i,1)=(rho_eck(i,2)-rho_eck(i,1))/rho_divis(1)
	          rho_vi(i,2)=(rho_eck(i,3)-rho_eck(i,1))/rho_divis(2)
	        enddo
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the real space lower right corner 'rholr'
c
	elseif(str_comp(befehl,'rholr',5,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.3) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        j=2
	        do i=1,3
	          rho_eck(i,j)=werte(i)
	        enddo
	        do i=1,3              
	          rho_vi(i,1)=(rho_eck(i,2)-rho_eck(i,1))/rho_divis(1)
	          rho_vi(i,2)=(rho_eck(i,3)-rho_eck(i,1))/rho_divis(2)
	        enddo
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the real space number of points along the abscissa 'rhonabs'
c
	elseif(str_comp(befehl,'rhona',5,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.1) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        if(werte(1).gt.0) then
	          rho_inc(1)   = nint(werte(1))
	          rho_divis(1) = float(max(1,rho_inc(1)-1))
	          do i=1,3              
	            rho_vi(i,1)=(rho_eck(i,2)-rho_eck(i,1))/
     &		    rho_divis(1)
	            rho_vi(i,2)=(rho_eck(i,3)-rho_eck(i,1))/
     &		    rho_divis(2)
	          enddo
	        else
	          ier_num = -12
	          ier_typ = ER_APPL
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the real space number of points along the ordinate 'rhonord'
c
	elseif(str_comp(befehl,'rhono',5,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.1) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        if(werte(1).gt.0) then
	          rho_inc(2)   = nint(werte(1))
	          rho_divis(2) = float(max(1,rho_inc(2)-1))
	          do i=1,3              
	            rho_vi(i,1)=(rho_eck(i,2)-rho_eck(i,1))/rho_divis(1)
	            rho_vi(i,2)=(rho_eck(i,3)-rho_eck(i,1))/rho_divis(2)
	          enddo
	        else
	          ier_num = -12
	          ier_typ = ER_APPL
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the real space ordinate  'rhoordi'
c
	elseif(str_comp(befehl,'rhoor',5,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ianz.eq.1) then
            if(cpara(1).eq.'x') then
              rho_extr_ord=1
            elseif(cpara(1).eq.'y') then
              rho_extr_ord=2
            elseif(cpara(1).eq.'z') then
              rho_extr_ord=3
            else
              ier_num = -6
	      ier_typ = ER_COMM
            endif
	  endif
c
c------	define the real space  upper left corner 'rhoul'
c
	elseif(str_comp(befehl,'rhoul',4,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.3) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        j=3
	        do i=1,3
	          rho_eck(i,j)=werte(i)
	        enddo
	        do i=1,3              
	          rho_vi(i,1)=(rho_eck(i,2)-rho_eck(i,1))/rho_divis(1)
	          rho_vi(i,2)=(rho_eck(i,3)-rho_eck(i,1))/rho_divis(2)
	        enddo
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	start the inverse Fourier transform 'run'
c
	elseif(str_comp(befehl,'run ',1,lbef,4)) then
	  if(rho_inc(1)*rho_inc(2).le.MAXQXY) then
	    if(rho_type(2).eq.INTENSITY       .or.
     &	       rho_type(2).eq.AMPLITUDE       .or.
     &	       rho_type(2).eq.REAL_PART            ) then
	      line = ' '
	      line = rho_file(2)
	      i    = rho_type(2)
	      rho_file(2) = rho_file(1)
	      rho_type(2) = rho_type(1)
	      rho_file(1) = line
	      rho_type(1) = i
	    endif
	    if(ftyp.eq.4) then
	      ltwo_files = .false.
	      if(rho_type(1).eq.AMPLITUDE  .or. 
     &	         rho_type(1).eq.FCALC                ) then
	        call no_error
	      else
	        ier_num = -51
	        ier_typ = ER_APPL
	      endif
	    else
	      ltwo_files = .true.
	      if(inverse_type.eq.INV_INV) then
	        if(rho_type(1).eq.INTENSITY .and. 
     &	           rho_type(2).eq.PHASE_ANG       .or.
     &	           rho_type(1).eq.AMPLITUDE .and.
     &	           rho_type(2).eq.PHASE_ANG       .or.
     &	           rho_type(1).eq.REAL_PART .and.
     &	           rho_type(2).eq.IMAG_PART           ) then
	          call no_error
	        else
	          ier_num = -36
	          ier_typ = ER_APPL
	        endif
	      elseif(inverse_type.eq.INV_PATT) then
	        if(rho_type(1).eq.INTENSITY       .or.
     &	           rho_type(1).eq.AMPLITUDE       .or.
     &	           rho_type(1).eq.REAL_PART .and.
     &	           rho_type(2).eq.IMAG_PART           ) then
	          call no_error
	        else
	          ier_num = -38
	          ier_typ = ER_APPL
	        endif
	        if(rho_type(1).eq.INTENSITY ) then
	          ltwo_files = .false.
	        endif
	      elseif(inverse_type.eq.INV_DIFF) then
	        ltwo_files = .false.
	      endif
	    endif
	    if(ier_num.eq.0) then
	      call do_patters(inverse_type,ltwo_files,cr_vr,
     &	                      cr_acentric)
	    endif
	  else
	    ier_num = -71
	    ier_typ = ER_APPL
	  endif
c
c------	Run statistics on the normalized structure factor 'stat'
c
	elseif(str_comp(befehl,'stat',1,lbef,4)) then
	  call e_create
c
c------	Define the type of the input file 'type'
c
	elseif(str_comp(befehl,'type',1,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.2) then
	      if(str_comp(cpara(1),'a    ',1,lpara(1),5)) then
	        i = 1
	      elseif(str_comp(cpara(1),'b    ',1,lpara(1),5)) then
	        i = 2
	      else
	        ier_num = -41
	        ier_typ = ER_APPL
	      endif
	      if(ier_num.eq.0) then
	        if(str_comp(cpara(2),'inten',2,lpara(2),5)) then
	          rho_type(i) = INTENSITY
	        elseif(str_comp(cpara(2),'ampli',1,lpara(2),5)) then
	          rho_type(i) = AMPLITUDE
	        elseif(str_comp(cpara(2),'phase',1,lpara(2),5)) then
	          rho_type(i) = PHASE_ANG
	        elseif(str_comp(cpara(2),'real ',1,lpara(2),5)) then
	          rho_type(i) = REAL_PART
	        elseif(str_comp(cpara(2),'imagi',2,lpara(2),5)) then
	          rho_type(i) = IMAG_PART
	        elseif(str_comp(cpara(2),'fobs' ,2,lpara(2),4)) then
	          rho_type(i) = AMPLITUDE
	        elseif(str_comp(cpara(2),'fcalc',2,lpara(2),5)) then
	          rho_type(i) = FCALC
	        else
	          rho_type(i) = 0
	          ier_num = -42
	          ier_typ = ER_APPL
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the scale factor
c
	elseif(str_comp(befehl,'scale',2,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.1) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
		patt_scale = werte(1)
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	set various parameters 'set'
c
	elseif(str_comp(befehl,'set',2,lbef,3)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.2) then
c
c------	------set mode for accumulation 'accu'
c	      either initialize or add to previous patterson.
c
	      if(str_comp(cpara(1),'accu',1,lpara(1),4)) then
	        if(str_comp(cpara(2),'init',1,lpara(2),4)) then
	          patt_accu = PATT_INIT
	        elseif(str_comp(cpara(2),'add',1,lpara(2),3)) then
	          patt_accu = PATT_ADD
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      elseif(str_comp(cpara(1),'excl',1,lpara(1),4)) then
	        if(str_comp(cpara(2),'none',1,lpara(2),4)) then
	          patt_excl9999 = .false.
	        else
	          cpara(1) = '0'
	          lpara(1) = 1
                  call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            patt_excl9999 = .true.
	            patt_excl_val = werte(2)
	          endif
	        endif
	      elseif(str_comp(cpara(1),'rsym',1,lpara(1),4)) then
	        if(str_comp(cpara(2),'igno',1,lpara(2),4)) then
	          patt_rsym = .false.
	        elseif(str_comp(cpara(2),'appl',1,lpara(2),4)) then
	          patt_rsym = .true.
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the sign for inverse or direct Fourier 'sign'
c
	elseif(str_comp(befehl,'sign',2,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
	    if(str_comp(cpara(1),'inverse',1,lpara(1),7)) then
	      patt_sign = -1
	    elseif(str_comp(cpara(1),'fourier',1,lpara(1),7)) then
	      patt_sign =  1
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	Show the current settings for the Fourier 'show'
c
	elseif(str_comp(befehl,'show',2,lbef,4)) then
	  if(inverse_type.eq.INV_INV) then
	    write (output_io,*) ' technique           : inverse Fourier'
	  elseif(inverse_type.eq.INV_DIFF) then
c23456789 123456789  123456789 123456789 123456789 123456789 123456789 12
	    write (output_io,*) 
     &           ' technique           : Difference Fourier '
	  elseif(inverse_type.eq.INV_PATT) then
	    write (output_io,*) ' technique           : Patterson '
	  endif
	  if(patt_accu.eq.PATT_INIT) then
	    write (output_io,*) ' Accumulation mode   : Initialize'
	  elseif(patt_accu.eq.PATT_ADD) then
	    write (output_io,*) ' Accumulation mode   : Add to previous'
	  endif
	  if(patt_excl9999) then
	    write (output_io,30605) patt_excl_val
30605	format('  Exclusions          : Data points equal to ',
     &	g13.6e2,' will be excluded')
	  else
	    write (output_io,*) 
     &           ' Exclusions          : All data points will ',
     &	               'be treated as data'
	  endif
	  write (output_io,*)
	  write (output_io,*) ' Geometry            : reciprocal space'
	  if(ftyp.eq.4 .or. ftyp.eq.5) then
	    if(patt_rsym) then
	      write (output_io,*) ' Input file format   : ',
     &	       cgraphik(ftyp),' reciprocal space symmetry is applied'
	    else
	      write (output_io,*) ' Input file format   : ',
     &	       cgraphik(ftyp),' reciprocal space symmetry is ignored'
	    endif
	  else
	    write (output_io,*) ' Input file format   : ',cgraphik(ftyp)
	  endif
	  write (output_io,*) ' Input file A        : ',rho_file(1)
	  write (output_io,*) ' File type  A        : ',
     &           cvalue(rho_type(1))
	  write (output_io,*) ' Input file B        : ',rho_file(2)
	  write (output_io,*) ' File type  B        : ',
     &           cvalue(rho_type(2))
	  write (output_io,*) ' Scale factor        : ',patt_scale
	  write (output_io,*) ' Sign in exponent    : ',patt_sign
c
c------	--Output of reciprocal space geometry only for non-SHELXL files
c
	  if(ftyp.ne.4 .and. ftyp.ne.5) then
	    write (output_io,3060) ((eck(i,j),i=1,3),j=1,3)
	    write (output_io,3061) inc
	    do i=1,3
	      u(i) = vi(i,1)
	      v(i) = 0.0
	      w(i) = vi(i,2)
	    enddo
	    lspace = .false.
	    dvi1   = do_blen(lspace,u,v)
	    dvi2   = do_blen(lspace,w,v)
	    if(inc(1).gt.1 .and. inc(2).gt.1) then
	      dvi3   = do_bang(lspace,u,v,w)
	    else
	      dvi3 = 0.0
	    endif
	    if(dvi3.gt.0) then
	      dvi4   = dvi2/dvi1
	      if(abs(u(extr_abs)).gt.0.0  .and.
     &	         abs(w(extr_ord)).gt.0.0) then
	        dvi5 = (dvi2/w(extr_ord))/(dvi1/u(extr_abs))
	      else
	        ier_num = -4
	        ier_typ = ER_FOUR
	      endif
	    else
	      dvi4   = 0.0
	      dvi5   = 0.0
	    endif
	    write (output_io,3062) (vi(i,1),i=1,3),dvi1,
     &	          (vi(i,2),i=1,3),dvi2,dvi3,dvi4,dvi5
	    write (output_io,3063) extr_achs(extr_abs)
	    write (output_io,3064) extr_achs(extr_ord)
	    if(ier_num.ne.0) then
	      call errlist
	      call no_error
	    endif
	  endif
c
	  write (output_io,*)
	  write (output_io,*   ) ' Geometry   : real space'
	  write (output_io,*)
	  write (output_io,3260) ((rho_eck(i,j),i=1,3),j=1,3)
	  write (output_io,3061) rho_inc
	  do i=1,3
	    u(i) = rho_vi(i,1)
	    v(i) = 0.0
	    w(i) = rho_vi(i,2)
	  enddo
	  lspace = .true.
	  dvi1   = do_blen(lspace,u,v)
	  dvi2   = do_blen(lspace,w,v)
	  if(rho_inc(1).gt.1 .and. rho_inc(2).gt.1) then
	    dvi3   = do_bang(lspace,u,v,w)
	  else
	    dvi3 = 0.0
	  endif
	  if(dvi3.gt.0) then
	    dvi4   = dvi2/dvi1
	    if(abs(u(rho_extr_abs)).gt.0.0  .and.
     &	       abs(w(rho_extr_ord)).gt.0.0) then
	      dvi5 = (dvi2/w(rho_extr_ord))/(dvi1/u(rho_extr_abs))
	    else
	      ier_num = -4
	      ier_typ = ER_FOUR
	    endif
	  else
	    dvi4   = 0.0
	    dvi5   = 0.0
	  endif
	  write (output_io,3262) (rho_vi(i,1),i=1,3),dvi1,
     &	                (rho_vi(i,2),i=1,3),dvi2,
     &	                                dvi3,dvi4,dvi5
	  write (output_io,3063) rho_extr_achs(rho_extr_abs)
	  write (output_io,3064) rho_extr_achs(rho_extr_ord)
	  if(ier_num.ne.0) then
	    call errlist
	    call no_error
	  endif
c
c------	define the upper left corner 'ul'
c
	elseif(str_comp(befehl,'ul  ',1,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.3) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        j=3
	        do i=1,3
	          eck(i,j)=werte(i)
	        enddo
	        do i=1,3              
	          vi(i,1)=(eck(i,2)-eck(i,1))/divis(1)
	          vi(i,2)=(eck(i,3)-eck(i,1))/divis(2)
	        enddo
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c-------Operating System Kommandos 'syst'
c
	elseif(str_comp(befehl,'syst',2,lbef,4)) then
	  if(zeile.ne. ' ') then
	    call do_operating(zeile(1:lp),lp)
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c
c------	waiting for user input
c
	elseif(str_comp(befehl,'wait',3,lbef,4)) then
	  call do_input(zeile,lp)
c
c------	unknown command
c
	else
	  ier_num = -8
	  ier_typ = ER_COMM
	endif
	endif
	endif
	if(ier_num.ne.0) then
	  call errlist
	  if(lmakro) then
	    call macro_close
	    prompt_status = PROMPT_ON
	  endif
	  if(lblock) then
	    ier_num = -11
	    ier_typ = ER_COMM
	    return
	  endif
	  call no_error
	endif
	goto 10
9999	continue
3060	format(/' reciprocal layer    :'/
     &	       ' lower left  corner  : ',3(2x,f9.4)/
     &	       ' lower right corner  : ',3(2x,f9.4)/
     &	       ' upper left  corner  : ',3(2x,f9.4))
3061	format(/' number of points '/
     &	       ' horizontally        : ',2x,i4/
     &	       ' vertically          : ',2x,i4)
3062	format(' increment vectors   :',
     &	  7x,'h',10x,'k',10x,'l',15x,'A**-1'/
     &	  ' horizontally        : ',3(2x,f9.4) ,7x,F9.4/
     &	  ' vertically          : ',3(2x,f9.4) ,7x,F9.4/
     &	 /' Angle               : ',2x,f9.4,' degrees'/
     &	  ' Ratio/Aver   v/h    : ',2(2x,F9.4))
3063	format(' Abszisse            : ', a)
3064	format(' Ordinate            : ', a)
3260	format(/' real space layer    :'/
     &	       ' lower left  corner  : ',3(2x,f9.4)/
     &	       ' lower right corner  : ',3(2x,f9.4)/
     &	       ' upper left  corner  : ',3(2x,f9.4))
3262	format(' increment vectors   :',
     &	  7x,'x',10x,'y',10x,'z',15x,'A'/
     &	  ' horizontally        : ',3(2x,f9.4) ,7x,F9.4/
     &	  ' vertically          : ',3(2x,f9.4) ,7x,F9.4/
     &	 /' Angle               : ',2x,f9.4,' degrees'/
     &	  ' Ratio/Aver    v/h   : ',2(2x,F9.4))
c
      end
c*****7*****************************************************************
	subroutine do_patters(inverse_type,ltwo_files,vr,
     &	                      acentric)
c-
c	Reads the files, if necessary calculates the values and
c	calls the patterson function
c+
	implicit       none
c
	include        'config.inc'
	include        'prompt.inc'
	include        'crystal.inc'
	include        'crystal.cmm'
	include        'errlist.inc'
	include        'intens.inc'
	include        'inverse.inc'
	include        'output.inc'
	include        'patters.inc'
	include        'recipro.inc'
	include        'diffuse.inc'
c
	logical      ltwo_files
	logical      acentric
	real         vr
c
	integer      ifa,ifb
	parameter   (ifa=21,ifb=22)
c
	integer      KUPL  ,GNU  ,SHELXL  ,HKLF4  ,HKLF4ALL
	parameter   (KUPL=0,GNU=3,SHELXL=4,HKLF4=5,HKLF4ALL=6)
c
	character*200  line
	integer      i,j,ii,k,itic
	integer      extr_ima
	integer      nx(2),ny(2)
	logical      l_incl
	real	     h(3)
	real         y(3),phase
	real         xmin(2),xmax(2)
	real         ymin(2),ymax(2)
	real         x1,x2,y1,y2,zz1,zz2,zz3,zz4
	real         z1(10000),z2(10000)
	complex      a_b
c
	zz1 = 0.0
	zz2 = 0.0
	zz3 = 0.0
	zz4 = 0.0
c
	call oeffne(ifa,rho_file(1),'old',.true.)
	if(ier_num.ne.0) then
	  return
	endif
	if(ltwo_files) then
	  call oeffne(ifb,rho_file(2),'old',.true.)
	  if(ier_num.ne.0) then
	    return
	  endif
	endif
c
	if(patt_accu.eq.PATT_INIT) then
	  ii = 0
	  do i=1,rho_inc(1)
	    do j=1,rho_inc(2)
	      ii = ii + 1
	      csf(ii) = cmplx(0.0d0,0.0d0)
	    enddo
	  enddo
	endif
c
	if(ftyp.eq.SHELXL.and.(.not.patt_rsym)) then
10	  continue
c
c------	----read hkl,fobs,fcalc,phase
c
	    read(ifa,*,end=20,err=900) y,zz1,zz2,zz3
	    zz4 = zz3 
c
c------	------Calculate appropriate value, contribute to invers/Patterson
c
	    call set_patt_value_s(a_b,inverse_type,rho_type,
     &	                          zz1,zz2,zz4)
	    a_b = a_b * patt_scale * vr
	    call calc_patters(a_b,y)
	  goto 10
20	  continue
	elseif(ftyp.eq.SHELXL.and.patt_rsym) then
15	  continue
c
c------	----read hkl,fobs,fcalc,phase
c
	    read(ifa,*,end=25,err=900) h,zz1,zz2,zz3
c
c------	----Apply reciprocal space symmetry operations
c
	    do k=1,rec_n_sym
	      phase = 0.0
	      do i=1,3
	        y(i) = 0
	        do j=1,3
	          y(i) = y(i) + rec_sym(i,j,k)*h(j)
	        enddo
	        phase = phase + y(i)*rec_sym(i,4,k)
	      enddo
	      zz4 = zz3 + 360.0 * phase
c
c------	------Calculate appropriate value, contribute to invers/Patterson
c
	      call set_patt_value_s(a_b,inverse_type,rho_type,
     &	                            zz1,zz2,zz4)
	      a_b = a_b * patt_scale * vr
	      call calc_patters(a_b,y)
c
c------	------If the space group is acentric, apply -1 operation
c
	      if(acentric) then
	        do i=1,3
	          y(i) = -y(i)
	        enddo
	        zz4 = -zz4
	        call set_patt_value_s(a_b,inverse_type,rho_type,
     &	                              zz1,zz2,zz4)
	        a_b = a_b * patt_scale * vr
	        call calc_patters(a_b,y)
	      endif
	    enddo
	  goto 15
25	  continue
	elseif(ftyp.eq.HKLF4.and.patt_rsym) then
30	  continue
c
c------	----read hkl,intensity,sigma(intensity)
c
	    read(ifa,*,end=40,err=900) h,zz1
c
c------	----Apply reciprocal space symmetry operations
c
	    do k=1,rec_n_sym
	      phase = 0.0
	      do i=1,3
	        y(i) = 0
	        do j=1,3
	          y(i) = y(i) + rec_sym(i,j,k)*h(j)
	        enddo
	        phase = phase + y(i)*rec_sym(i,4,k)
	      enddo
	      zz4 = zz3 + 360.0 * phase
c
c------	------Calculate appropriate value, contribute to invers/Patterson
c
CDBG	      call set_patt_value_s(a_b,inverse_type,rho_type,
CDBG     &	                            zz1,zz2,zz4)
CDBG	      call set_patt_value(a_b,inverse_type,rho_type,z1,z2,1,
CDBG     &	                          patt_excl9999,patt_excl_val,l_incl)
	      a_b = cmplx( zz1, 0.0 )
	      a_b = a_b * patt_scale * vr
	      call calc_patters(a_b,y)
c
c------	------If the space group is acentric, apply -1 operation
c
	      if(acentric) then
	        do i=1,3
	          y(i) = -y(i)
	        enddo
	        zz4 = -zz4
CDBG	        call set_patt_value_s(a_b,inverse_type,rho_type,
CDBG     &	                              zz1,zz2,zz4)
CDBG	      call set_patt_value(a_b,inverse_type,rho_type,z1,z2,1,
CDBG     &	                          patt_excl9999,patt_excl_val,l_incl)
	      a_b = cmplx( zz1, 0.0 )
	        a_b = a_b * patt_scale * vr
	        call calc_patters(a_b,y)
	      endif
	    enddo
	  goto 30
40	  continue
	elseif(ftyp.eq.HKLF4.and.(.not.patt_rsym)) then
50	  continue
c
c------	----read hkl,intensity,sigma(intensity)
c
	    read(ifa,*,end=60,err=900) y,zz1
c
c------	------Calculate appropriate value, contribute to invers/Patterson
c
	      a_b = cmplx( zz1, 0.0 ) * patt_scale * vr
	      call calc_patters(a_b,y)
	  goto 50
60	  continue
	else
	  extr_ima = 6 - extr_abs - extr_ord
c
c------	--One dimensional input files
c
	  if(inc(1).eq.1 .or. inc(2).eq.1) then
	    ii = max(inc(1),inc(2))
	    itic = max(5,ii/10)
	    do i=1,ii
	      if(mod(i,itic).eq.0) write (output_io,*) i
	      read(ifa,*,end=900,err=900) h(extr_abs),z1(1)
	      if(ltwo_files) then
	        read(ifb,*,end=900,err=900) h(extr_abs),z2(1)
	      else
	        z2(1) = 0.0
	      endif
c	      write (output_io,*) h(extr_abs),z1(1),z2(1)
	      j = 1
	      do k=1,3
	        h(k) = eck(k,1) + vi(k,1)*float(i-1) + 
     &	                          vi(k,2)*float(j-1)
	      enddo
	      call set_patt_value(a_b,inverse_type,rho_type,z1,z2,1,
     &	                          patt_excl9999,patt_excl_val,l_incl)
	      if(l_incl) then
	        a_b = a_b * patt_scale * vr
	        call calc_patters(a_b,h)
	      endif
	    enddo
c
c------	--Two dimensional Files (KUPL Format)
c
	  else
	    if(ftyp.eq.KUPL) then
	      ier_num = -3
	      ier_typ = ER_IO
	      read(ifa,*,err=900,end=900) nx(1),ny(1)
	      read(ifa,*,err=900,end=900) xmin(1),xmax(1),ymin(1),ymax(1)
	      if(ltwo_files) then
	        read(ifb,*,err=900,end=900) nx(2),ny(2)
	        read(ifb,*,err=900,end=900) xmin(2),xmax(2),
     &	                                    ymin(2),ymax(2)
	      else
	          nx(2)   = nx(1)
	        ny(2)   = ny(1)
	        xmin(2) = xmin(1)
	        xmax(2) = xmax(1)
	        ymin(2) = ymin(1)
	        ymax(2) = ymax(1)
	      endif
	      ier_num = 0
	      ier_typ = ER_NONE
	      if(nx(1)  .eq.nx(2)   .and. ny(1)  .eq.ny(2)   .and.
     &	         xmin(1).eq.xmin(2) .and. ymin(1).eq.ymin(2) .and.
     &	         xmax(1).eq.xmax(2) .and. ymax(1).eq.ymax(2) ) then
	        itic = max(5,inc(2)/10)
	        do j=1,ny(1)
	          if(mod(j,itic).eq.0) write (output_io,*) j
	          ier_num = -3
	          ier_typ = ER_IO
	          read(ifa,*,err=900,end=900) (z1(i),i=1,nx(1))
	          if(ltwo_files) then
	            read(ifb,*,err=900,end=900) (z2(i),i=1,nx(1))
	          endif
	          ier_num = 0
	          ier_typ = ER_NONE
	          do i=1,inc(1)
	            call set_patt_value(a_b,inverse_type,rho_type,
     &	                                z1,z2,i,patt_excl9999,
     &	                                patt_excl_val,l_incl)
	            if(l_incl) then
	              do k=1,3
	                h(k) = eck(k,1) + vi(k,1)*float(i-1) + 
     &	                                  vi(k,2)*float(j-1)
	              enddo
	              a_b = a_b * patt_scale * vr
	              call calc_patters(a_b,h)
	            endif
	          enddo
	        enddo
	      else
	        ier_num = -22
	        ier_typ = ER_APPL
	      endif
	    elseif(ftyp.eq.GNU) then
	      ier_num = -23
	      ier_typ = ER_APPL
	      itic = max(5,inc(2)/10)
	      do j=1,inc(2)
	        if(mod(j,itic).eq.0) write (output_io,*) j
	        do i=1,inc(1)
	          read(ifa,*,end=900,err=900) x1,y1,z1(1),zz1
	          if(ltwo_files) then
	            read(ifb ,*,end=900,err=900) x2,y2,z2(1),zz2
	          endif
	          if(.not. ltwo_files  .or. (ltwo_files .and.
     &	             (x1.eq.x2 .and. y1.eq.y2 .and. zz1.eq.zz2)) ) then
	            h(extr_abs) = x1
	            h(extr_ord) = y1
	            h(extr_ima) = zz1
	            call set_patt_value(a_b,inverse_type,rho_type,
     &	                                z1,z2,1,patt_excl9999,
     &	                                patt_excl_val,l_incl)
	            if(l_incl) then
	              a_b = a_b * patt_scale * vr
	              call calc_patters(a_b,h)
	            endif
	          else
	            ier_num = -24
	            ier_typ = ER_APPL
	            goto 900
	          endif
	        enddo
	        read(ifa,1000,end=900,err=900) line
	        if(line.eq.' ') then
	          if(ltwo_files) then
	            read(ifb,1000,end=900,err=900) line
	          endif
	          if(line.ne.' ') then
	            ier_num = -23
	            ier_typ = ER_APPL
	            goto 900
	          endif
	        endif
	      enddo
	      ier_num =  0
	      ier_typ = ER_NONE
	    endif
	  endif
	endif
c
900	continue
c
	close(ifa)
	if(ltwo_files) then
	  close(ifb)
	endif
c
1000	format(a)
2000	format(5(f9.3,2x))
	end
c*****7*****************************************************************
	subroutine calc_patters(a_b,h)
c-
c	Calculates the patterson or inverse Fourier at all points
c	in real space.
c+
	implicit      none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'patters.inc'
	include      'diffuse.inc'
c
	real          h(3)
c
	real*8	      xarg0,xincu,xincv
	integer	      iarg,iarg0,iincu,iincv,iadd
	integer       i,j,ii
	complex       a_b
c
	integer       ISHFT,IAND
c
	call four_cexpt
	ii = max(5,rho_inc(2)/10)
c
	xarg0 = rho_eck(1,1)*h(1)+rho_eck(2,1)*h(2)+rho_eck(3,1)*h(3)
	xincu = rho_vi (1,1)*h(1)+rho_vi (2,1)*h(2)+rho_vi (3,1)*h(3)
	xincv = rho_vi (1,2)*h(1)+rho_vi (2,2)*h(2)+rho_vi (3,2)*h(3)
c
	iarg0 = nint( 64*I2PI*( xarg0-int(xarg0)+1.0d0))
	iincu = nint( 64*I2PI*( xincu-int(xincu)+1.0d0))
	iincv = nint( 64*I2PI*( xincv-int(xincv)+1.0d0))
c
	iarg0 = patt_sign*iarg0
	iarg  = iarg0
c
	ii = 0
c
	do j=1,rho_inc(1)
	  do i=1,rho_inc(2)
	    iadd = ISHFT(iarg,-6)
	    iadd = IAND (iadd,MASK)
	    ii = ii + 1
	    csf(ii) = csf(ii) + cex(iadd)*a_b
	    iarg = iarg + iincv * patt_sign
	  enddo
	  iarg = iarg0 + iincu*j * patt_sign
	enddo
c
	end
c*****7*******1**********************************************************
	subroutine set_patt_value(a_b,inverse_type,rho_type,z1,z2,i,
     &	                          patt_excl9999,patt_excl_val,l_incl)
c-
c	Sets the appropriate values for the inverse Fourier or
c	Patterson.
c+
	implicit      none
c
	include      'intens.inc'
	include      'inverse.inc'
c
	integer       rho_type(2)
	logical       patt_excl9999
	logical       l_incl
	real          z1(10000),z2(10000)
	real          patt_excl_val
	complex       a_b
c
	integer       i
c
	real          cosd,sind
c
	l_incl = .true.
	if(inverse_type.eq.INV_INV) then
	  if(patt_excl9999) then
	    if(z1(i).eq.patt_excl_val  .or. 
     &	       z2(i).eq.patt_excl_val) then
	      l_incl = .false.
	      return
	    endif
	  endif
	  if(    rho_type(1).eq.REAL_PART .and.
     &	         rho_type(2).eq.IMAG_PART       ) then
	    a_b = cmplx( z1(i),
     &	                 z2(i) )
	  elseif(rho_type(1).eq.INTENSITY .and.
     &	         rho_type(2).eq.PHASE_ANG       ) then
c
c------	----Ignore negative intensities
c
	    if(z1(i).lt.0.0) then
	      l_incl = .false.
	      return
	    endif
	    a_b = cmplx( sqrt(z1(i)) * cosd(z2(i)),
     &	                 sqrt(z1(i)) * sind(z2(i)) )
	  elseif(rho_type(1).eq.AMPLITUDE .and.
     &	         rho_type(2).eq.PHASE_ANG       ) then
	    a_b = cmplx(      z1(i)  * cosd(z2(i)),
     &	                      z1(i)  * sind(z2(i)) )
	  endif
	elseif(inverse_type.eq.INV_PATT) then
	  if(patt_excl9999) then
	    if(    rho_type(1).eq.INTENSITY       ) then
	      if(z1(i).eq.patt_excl_val) then
	        l_incl = .false.
	        return
	      endif
	      a_b = cmplx( z1(i),
     &	                   0.0   )
	    elseif(rho_type(1).eq.REAL_PART .and.
     &	           rho_type(2).eq.IMAG_PART       ) then
	      if(z1(i).eq.patt_excl_val .or.
     &	         z2(i).eq.patt_excl_val) then
	        l_incl = .false.
	        return
	      endif
	      a_b = cmplx( z1(i)*z1(i) + z2(i)*z2(i),
     &	                   0.0                       )
	    elseif(rho_type(1).eq.AMPLITUDE       ) then
	      if(z1(i).eq.patt_excl_val) then
	        l_incl = .false.
	        return
	      endif
	      a_b = cmplx( z1(i)*z1(i),
     &	                   0.0         )
	    endif
	  else
	    if(    rho_type(1).eq.INTENSITY       ) then
	      a_b = cmplx( z1(i),
     &	                   0.0   )
	    elseif(rho_type(1).eq.REAL_PART .and.
     &	           rho_type(2).eq.IMAG_PART       ) then
	      a_b = cmplx( z1(i)*z1(i) + z2(i)*z2(i),
     &	                   0.0                       )
	    elseif(rho_type(1).eq.AMPLITUDE       ) then
	      a_b = cmplx( z1(i)*z1(i),
     &	                   0.0         )
	    endif
	  endif
	endif
c
	end
c*****7*****************************************************************
	subroutine set_patt_value_s(a_b,inverse_type,rho_type,
     &	                            zz1,zz2,zz3)
c-
c	Sets the appropriate values for the inverse Fourier or
c	Patterson. Special Version for SHELXL list file 5 Input
c+
	implicit      none
c
	include      'intens.inc'
	include      'inverse.inc'
c
	integer       rho_type(2)
	real          zz1,zz2,zz3
	complex       a_b
c
	real          cosd,sind
c
	if(inverse_type.eq.INV_INV) then
	  if(    rho_type(1).eq.AMPLITUDE       ) then
	    a_b = cmplx(      zz1    * cosd(zz3  ) ,
     &	                      zz1    * sind(zz3  )  )
	  elseif(rho_type(1).eq.FCALC           ) then
	    a_b = cmplx(      zz2    * cosd(zz3  ) ,
     &	                      zz2    * sind(zz3  )  )
	  endif
	elseif(inverse_type.eq.INV_PATT) then
	  if(    rho_type(1).eq.INTENSITY       ) then
	    a_b = cmplx(      zz1    *   zz1 ,
     &	                      0.0             )
	  elseif(rho_type(1).eq.AMPLITUDE       ) then
	    a_b = cmplx(      zz1    *   zz1 ,
     &	                      0.0             )
	  elseif(rho_type(1).eq.FCALC           ) then
	    a_b = cmplx(      zz2    *   zz2 ,
     &	                      0.0             )
	  endif
	elseif(inverse_type.eq.INV_DIFF) then
	  a_b = cmplx( (zz1 - zz2) * cosd(zz3  ) ,
     &	               (zz1 - zz2) * sind(zz3  )  )
	endif
c
	end
c*****7*****************************************************************
	subroutine  e_create
c-
c	reads the input file and creates normalized structure factors
c
c	Version  : 1.0
c	Date     : 27 Nov 2000
c
c	Author   : R.B. Neder (reinhard.neder@mail.uni-wuerzburg.de)
c+
	implicit        none
	include		'patters.inc'
	include		'prompt.inc'
c
	integer		MAXW
	parameter	(MAXW = 50000)
	integer		KUPL  ,GNU  ,SHELXL  ,HKLF4
	parameter	(KUPL=0,GNU=3,SHELXL=4,HKLF4=5)
c
	integer		i,n,j,lcomm
	real		h(3)
	real		zz1,zz2,zz3,zz4
c
	integer		e_num_hkl(20)
	integer		e_num_hk0(20)
	integer		e_num_h0l(20)
	integer		e_num_0kl(20)
	integer		e_num_hhl(20)
	integer		e_n
	integer		e_n_hk0
	integer		e_n_h0l
	integer		e_n_0kl
	integer		e_n_hhl
	integer		n_hk0
	integer		n_h0l
	integer		n_0kl
	integer		n_hhl
	integer		ifa
	parameter	(ifa=21)
	real		e_aver_f2    (MAXW)
	real		e_aver_f2_hk0(MAXW)
	real		e_aver_f2_h0l(MAXW)
	real		e_aver_f2_0kl(MAXW)
	real		e_aver_f2_hhl(MAXW)
	real		e_f
	real		e_e1_hkl, e_e2_hkl,   e_e3_hkl, e_e4_hkl
	real		e_e5_hkl, e_e6_hkl, e_e2m1_hkl
	real		e_e2m1_2_hkl,e_e2m1_3_hkl,e_abs_e2m1_3_hkl
	real		e_e1_hk0, e_e2_hk0,   e_e3_hk0, e_e4_hk0
	real		e_e5_hk0, e_e6_hk0, e_e2m1_hk0
	real		e_e2m1_2_hk0,e_e2m1_3_hk0,e_abs_e2m1_3_hk0
	real		e_e1_h0l, e_e2_h0l,   e_e3_h0l, e_e4_h0l
	real		e_e5_h0l, e_e6_h0l, e_e2m1_h0l
	real		e_e2m1_2_h0l,e_e2m1_3_h0l,e_abs_e2m1_3_h0l
	real		e_e1_0kl, e_e2_0kl,   e_e3_0kl, e_e4_0kl
	real		e_e5_0kl, e_e6_0kl, e_e2m1_0kl
	real		e_e2m1_2_0kl,e_e2m1_3_0kl,e_abs_e2m1_3_0kl
	real		e_e1_hhl, e_e2_hhl,   e_e3_hhl, e_e4_hhl
	real		e_e5_hhl, e_e6_hhl, e_e2m1_hhl
	real		e_e2m1_2_hhl,e_e2m1_3_hhl,e_abs_e2m1_3_hhl
c
	integer		e_hist
c
	e_e1_hkl         = 0.0
	e_e2_hkl         = 0.0
	e_e3_hkl         = 0.0
	e_e4_hkl         = 0.0
	e_e5_hkl         = 0.0
	e_e6_hkl         = 0.0
	e_e2m1_hkl       = 0.0
	e_e2m1_2_hkl     = 0.0
	e_e2m1_3_hkl     = 0.0
	e_abs_e2m1_3_hkl = 0.0
c
	e_e1_hk0         = 0.0
	e_e2_hk0         = 0.0
	e_e3_hk0         = 0.0
	e_e4_hk0         = 0.0
	e_e5_hk0         = 0.0
	e_e6_hk0         = 0.0
	e_e2m1_hk0       = 0.0
	e_e2m1_2_hk0     = 0.0
	e_e2m1_3_hk0     = 0.0
	e_abs_e2m1_3_hk0 = 0.0
c
	e_e1_h0l         = 0.0
	e_e2_h0l         = 0.0
	e_e3_h0l         = 0.0
	e_e4_h0l         = 0.0
	e_e5_h0l         = 0.0
	e_e6_h0l         = 0.0
	e_e2m1_h0l       = 0.0
	e_e2m1_2_h0l     = 0.0
	e_e2m1_3_h0l     = 0.0
	e_abs_e2m1_3_h0l = 0.0
c
	e_e1_0kl         = 0.0
	e_e2_0kl         = 0.0
	e_e3_0kl         = 0.0
	e_e4_0kl         = 0.0
	e_e5_0kl         = 0.0
	e_e6_0kl         = 0.0
	e_e2m1_0kl       = 0.0
	e_e2m1_2_0kl     = 0.0
	e_e2m1_3_0kl     = 0.0
	e_abs_e2m1_3_0kl = 0.0
c
	e_e1_hhl         = 0.0
	e_e2_hhl         = 0.0
	e_e3_hhl         = 0.0
	e_e4_hhl         = 0.0
	e_e5_hhl         = 0.0
	e_e6_hhl         = 0.0
	e_e2m1_hhl       = 0.0
	e_e2m1_2_hhl     = 0.0
	e_e2m1_3_hhl     = 0.0
	e_abs_e2m1_3_hhl = 0.0
	zz1 = 0.0
	zz2 = 0.0
	zz3 = 0.0
	zz4 = 0.0
	n   = 0
	do i=1,20
	  e_num_hkl(i) = 0
	  e_num_hk0(i) = 0
	  e_num_h0l(i) = 0
	  e_num_0kl(i) = 0
	  e_num_hhl(i) = 0
	enddo
c
	call oeffne(ifa,rho_file(1),'old',.true.)
c
	if(ftyp.eq.HKLF4) then
30	  continue
c
c------	----read hkl,intensity,sigma(intensity)
c
	    read(ifa,*,end=40,err=900) h,zz1
	    n = n + 1
	    j = e_hist(h)
	    e_aver_f2(j) = e_aver_f2(j) + abs(zz1) 
	    e_num_hkl(j) = e_num_hkl(j) + 1
	    if(h(1).eq.0) then
	      e_aver_f2_0kl(j) = e_aver_f2_0kl(j) + abs(zz1)
	      e_num_0kl(j) = e_num_0kl(j) + 1
	    endif
	    if(h(2).eq.0) then
	      e_aver_f2_h0l(j) = e_aver_f2_h0l(j) + abs(zz1)
	      e_num_h0l(j) = e_num_h0l(j) + 1
	    endif
	    if(h(3).eq.0) then
	      e_aver_f2_hk0(j) = e_aver_f2_hk0(j) + abs(zz1)
	      e_num_hk0(j) = e_num_hk0(j) + 1
	    endif
	    if(h(1).eq.h(2) .or. h(1).eq.-h(2)) then
	      e_aver_f2_hhl(j) = e_aver_f2_hhl(j) + abs(zz1)
	      e_num_hhl(j) = e_num_hhl(j) + 1
	    endif
	  goto 30
40	  continue
	else
	  close(ifa)
	  return
	endif
	close(ifa)
	do j=1,20
	  if(e_num_hkl(j).gt.0) then
	    e_aver_f2(j) = sqrt(e_aver_f2(j)/e_num_hkl(j))
	  endif
	  if(e_num_hk0(j).gt.0) then
	    e_aver_f2_hk0(j) = sqrt(e_aver_f2_hk0(j)/e_num_hk0(j))
	  endif
	  if(e_num_h0l(j).gt.0) then
	    e_aver_f2_h0l(j) = sqrt(e_aver_f2_h0l(j)/e_num_h0l(j))
	  endif
	  if(e_num_0kl(j).gt.0) then
	    e_aver_f2_0kl(j) = sqrt(e_aver_f2_0kl(j)/e_num_0kl(j))
	  endif
	  if(e_num_hhl(j).gt.0) then
	    e_aver_f2_hhl(j) = sqrt(e_aver_f2_hhl(j)/e_num_hhl(j))
	  endif
	enddo
	call oeffne(ifa,rho_file(1),'old',.true.)
	n_0kl = 0
	n_h0l = 0
	n_hk0 = 0
	n_hhl = 0
	do i=1,n
	  read(ifa,*,end=900,err=900) h,zz1
	  j   = e_hist(h)
	  e_f = sqrt(abs(zz1))/e_aver_f2(j)
	  call e_accum(e_f,e_e1_hkl,e_e2_hkl,e_e3_hkl,e_e4_hkl,
     &	     e_e5_hkl,e_e6_hkl,e_e2m1_hkl,e_e2m1_2_hkl,e_e2m1_3_hkl,
     &	     e_abs_e2m1_3_hkl)
	  if(h(3).eq.0) then
	    n_hk0 = n_hk0 + 1
	    e_f = sqrt(abs(zz1))/e_aver_f2_hk0(j)
	    call e_accum(e_f,e_e1_hk0,e_e2_hk0,e_e3_hk0,e_e4_hk0,
     &	       e_e5_hk0,e_e6_hk0,e_e2m1_hk0,e_e2m1_2_hk0,e_e2m1_3_hk0,
     &	       e_abs_e2m1_3_hk0)
	  endif
	  if(h(2).eq.0) then
	    n_h0l = n_h0l + 1
	    e_f = sqrt(abs(zz1))/e_aver_f2_h0l(j)
	    call e_accum(e_f,e_e1_h0l,e_e2_h0l,e_e3_h0l,e_e4_h0l,
     &	       e_e5_h0l,e_e6_h0l,e_e2m1_h0l,e_e2m1_2_h0l,e_e2m1_3_h0l,
     &	       e_abs_e2m1_3_h0l)
	  endif
	  if(h(1).eq.0) then
	    n_0kl = n_0kl + 1
	    e_f = sqrt(abs(zz1))/e_aver_f2_0kl(j)
	    call e_accum(e_f,e_e1_0kl,e_e2_0kl,e_e3_0kl,e_e4_0kl,
     &	       e_e5_0kl,e_e6_0kl,e_e2m1_0kl,e_e2m1_2_0kl,e_e2m1_3_0kl,
     &	       e_abs_e2m1_3_0kl)
	  endif
	  if(h(1).eq.h(2) .or. h(1).eq.-h(2)) then
	    n_hhl = n_hhl + 1
	    e_f = sqrt(abs(zz1))/e_aver_f2_hhl(j)
	    call e_accum(e_f,e_e1_hhl,e_e2_hhl,e_e3_hhl,e_e4_hhl,
     &	       e_e5_hhl,e_e6_hhl,e_e2m1_hhl,e_e2m1_2_hhl,e_e2m1_3_hhl,
     &	       e_abs_e2m1_3_hhl)
	  endif
	enddo
c
c------	Write results
c
	lcomm = 3
	call e_write(n,'HKL',lcomm,e_e1_hkl,e_e2_hkl,e_e3_hkl,e_e4_hkl,
     &	     e_e5_hkl,e_e6_hkl,e_e2m1_hkl,e_e2m1_2_hkl,e_e2m1_3_hkl,
     &	     e_abs_e2m1_3_hkl)
	if(n_0kl.gt.0) then
	lcomm = 3
	  call e_write(n_0kl,'0KL',lcomm,e_e1_0kl,e_e2_0kl,e_e3_0kl,
     &	     e_e4_0kl,
     &	     e_e5_0kl,e_e6_0kl,e_e2m1_0kl,e_e2m1_2_0kl,e_e2m1_3_0kl,
     &	     e_abs_e2m1_3_0kl)
	endif
	if(n_h0l.gt.0) then
	lcomm = 3
	  call e_write(n_h0l,'H0L',lcomm,e_e1_h0l,e_e2_h0l,e_e3_h0l,
     &	     e_e4_h0l,
     &	     e_e5_h0l,e_e6_h0l,e_e2m1_h0l,e_e2m1_2_h0l,e_e2m1_3_h0l,
     &	     e_abs_e2m1_3_h0l)
	endif
	if(n_hk0.gt.0) then
	lcomm = 3
	  call e_write(n_hk0,'HK0',lcomm,e_e1_hk0,e_e2_hk0,e_e3_hk0,
     &	     e_e4_hk0,
     &	     e_e5_hk0,e_e6_hk0,e_e2m1_hk0,e_e2m1_2_hk0,e_e2m1_3_hk0,
     &	     e_abs_e2m1_3_hk0)
	endif
	if(n_hhl.gt.0) then
	  lcomm = 9
	  call e_write(n_hhl,'HHL; H-HL',lcomm,e_e1_hhl,e_e2_hhl,
     &	     e_e3_hhl,e_e4_hhl,
     &	     e_e5_hhl,e_e6_hhl,e_e2m1_hhl,e_e2m1_2_hhl,e_e2m1_3_hhl,
     &	     e_abs_e2m1_3_hhl)
	endif
c
900	continue
c
	end
c*****7*****************************************************************
	integer function e_hist(h)
c-
c	Determines the slot for dstar
c
c	Version  : 1.0
c	Date     : 27 Nov 2000
c
c	Author   : R.B. Neder (reinhard.neder@mail.uni-wuerzburg.de)
c+
	implicit        none
c
	include        'config.inc'
	include        'crystal.inc'
	include        'crystal.cmm'
c
	real		h(3)
c
	integer		i
	real		null(3)
	real		e_hist_limit(20)
	real		dstar
	logical		lspace
	parameter	(lspace=.false.)
c
	real		do_blen
c
	data null/ 0.0, 0.0, 0.0/
	data e_hist_limit/ 0.2, 0.4, 0.6, 0.8, 1.0,
     &	                   1.2, 1.4, 1.6, 1.8, 2.0,
     &	                   2.2, 2.4, 2.6, 2.8, 3.0,
     &	                   3.2, 3.4, 3.6, 3.8, 1e6/
c
	dstar = do_blen(lspace,h,null)
c
	do i=1,20
CDBG	write(*,*) 'in der Schleife, dstar, e_hist_limit(i)',
CDBG     &	dstar, e_hist_limit(i)
	  if(dstar .lt. e_hist_limit(i)) then
	    e_hist = i
CDBG	write(*,*) 'h,dstar,i',h,dstar,i
	    return
	  endif
	enddo
	e_hist = 20
CDBG	write(*,*) 'h,dstar,i',h,dstar,i
c	
	end
c*****7*****************************************************************
	subroutine e_accum(e_f,e_e1_hkl,e_e2_hkl,e_e3_hkl,e_e4_hkl,
     &	     e_e5_hkl,e_e6_hkl,e_e2m1_hkl,e_e2m1_2_hkl,e_e2m1_3_hkl,
     &	     e_abs_e2m1_3_hkl)
c-
c	Accumulates the E statistics 
c
c	Version  : 1.0
c	Date     : 27 Nov 2000
c
c	Author   : R.B. Neder (reinhard.neder@mail.uni-wuerzburg.de)
c+
	implicit        none
c
	real		e_f
	real		e_e1_hkl, e_e2_hkl,   e_e3_hkl, e_e4_hkl
	real		e_e5_hkl, e_e6_hkl, e_e2m1_hkl
	real		e_e2m1_2_hkl,e_e2m1_3_hkl,e_abs_e2m1_3_hkl
c
	  e_e1_hkl   = e_e1_hkl   + e_f
	  e_e2_hkl   = e_e2_hkl   + e_f**2
	  e_e3_hkl   = e_e3_hkl   + e_f**3
	  e_e4_hkl   = e_e4_hkl   + e_f**4
	  e_e5_hkl   = e_e5_hkl   + e_f**5
	  e_e6_hkl   = e_e6_hkl   + e_f**6
	  e_e2m1_hkl     = e_e2m1_hkl +      abs(e_f**2 - 1.0)
	  e_e2m1_2_hkl     = e_e2m1_2_hkl +         (e_f**2 - 1.0)**2
	  e_e2m1_3_hkl     = e_e2m1_3_hkl +         (e_f**2 - 1.0)**3
	  e_abs_e2m1_3_hkl = e_abs_e2m1_3_hkl + (abs(e_f**2 - 1.0))**3
c
	end
c*****7*****************************************************************
	subroutine e_write(n,e_name,lcomm,e_e1_hkl,e_e2_hkl,e_e3_hkl,
     &	     e_e4_hkl,
     &	     e_e5_hkl,e_e6_hkl,e_e2m1_hkl,e_e2m1_2_hkl,e_e2m1_3_hkl,
     &	     e_abs_e2m1_3_hkl)
c-
c	write the E statistics to the output device
c
c	Version  : 1.0
c	Date     : 27 Nov 2000
c
c	Author   : R.B. Neder (reinhard.neder@mail.uni-wuerzburg.de)
c+
	implicit        none
c
	include		'prompt.inc'
c
	character*6	zeile
	character*9	e_name
	integer		lcomm
	integer		n
	real		e_e1_hkl, e_e2_hkl,   e_e3_hkl, e_e4_hkl
	real		e_e5_hkl, e_e6_hkl, e_e2m1_hkl
	real		e_e2m1_2_hkl,e_e2m1_3_hkl,e_abs_e2m1_3_hkl
c
	real		cent(10),acent(10)
c
	data  cent/0.798, 1.000, 1.596, 3.000, 6.383,15.000, 0.968,
     &	           2.000, 8.000, 8.691/
	data acent/0.886, 1.000, 1.329, 2.000, 3.323, 6.000, 0.736,
     &	           1.000, 2.000, 2.415/
c
c
c------	Write results
c
	write(output_io,1000) 'Number of ',e_name(1:lcomm),
     &	                      ' reflections:  ',n
	write(output_io,1010) '<|E|**1>        : ',e_e1_hkl/n,
     &	                        cent( 1),acent( 1)
	write(output_io,1010) '<|E|**2>        : ',e_e2_hkl/n,
     &	                        cent( 2),acent( 2)
	write(output_io,1010) '<|E|**3>        : ',e_e3_hkl/n,
     &	                        cent( 3),acent( 3)
	write(output_io,1010) '<|E|**4>        : ',e_e4_hkl/n,
     &	                        cent( 4),acent( 4)
	write(output_io,1010) '<|E|**5>        : ',e_e5_hkl/n,
     &	                        cent( 5),acent( 5)
	write(output_io,1010) '<|E|**6>        : ',e_e6_hkl/n,
     &	                        cent( 6),acent( 6)
	write(output_io,1010) '<|E**2 - 1|>    : ',e_e2m1_hkl/n,
     &	                        cent( 7),acent( 7)
	write(output_io,1010) '<(E**2 - 1)**2> : ',e_e2m1_2_hkl/n,
     &	                        cent( 8),acent( 8)
	write(output_io,1010) '<(E**2 - 1)**3> : ',e_e2m1_3_hkl/n,
     &	                        cent( 9),acent( 9)
	write(output_io,1010) '<|E**2 - 1|**3> : ',
     &	                   e_abs_e2m1_3_hkl/n,cent(10),acent(10)
	zeile = 'return'
	lcomm = 6
	call do_input(zeile,lcomm)
c
1000	format(/,3a,i6,/,
     &	' Criterion',11x,'observed,  centric, acentric')
1010	format(a,3f10.3)
c
	end
