c*****7*****************************************************************
	subroutine pdf
c-
c	This sublevel contains all routines dealing with the
c	PDF anlysis part of DISCUS. This segment uses variables
c	of the RMC and CHEM segment which are simply overwritten !!
c
c	Version  : 1.2
c	Date     : 08. June 1999
c	
c	Author   : Th. Proffen (tproffen@lanl.gov)
c+
	implicit	none
c
	include		'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'doact.inc'
	include 	'macro.inc'
	include 	'errlist.inc'
	include 	'learn.inc'
	include 	'param.inc'
	include 	'prompt.inc'
	include 	'chem.inc'
	include 	'pdf.inc'
	include 	'rmc.inc'
c
	integer       	maxw
	parameter    	(maxw=20)
c
	character*5    	befehl
	character*11   	prom
	character*200  	line,zeile,cpara(maxw),cdummy
	real           	werte(maxw),wwerte(maxw),wwwerte(maxw)
	integer		repl(0:MAXSCAT)
	integer		lbeg(3)
	integer        	lpara(maxw),lp,length,idummy
	integer        	indxg,ianz,lbef,i,ia,is,ic(3),iianz,jjanz
	logical        	lout,ldummy
c
	logical         str_comp
c
	call no_error
c
10	continue
c
	prom=prompt//'/pdf'
	call get_command (line,length,befehl,lbef,zeile,lp,prom)
	if(ier_num.eq.0) then
	if(line.eq.' '.or.line(1:1).eq.'#') goto 10
c
c------ search for "="
c
	indxg=index(line,'=')
	if(indxg.ne.0.and..not.(str_comp(befehl,'echo',2,lbef,4))
     &	             .and..not.(str_comp(befehl,'syst',2,lbef,4))
     &	             .and..not.(str_comp(befehl,'help',2,lbef,4) .or.
     &	                        str_comp(befehl,'?   ',2,lbef,4)) ) then
          call do_math(line,indxg,length)
c
c------ execute a macro file
c
        elseif(befehl(1:1).eq.'@') then
          call file_kdo(line(2:length),length-1)
c
c------	continues a macro 'continue'
c
	elseif(str_comp(befehl,'continue',3,lbef,8)) then
	  call macro_continue(zeile,lp)
c
c------ Echo a string, just for interactive check in a macro 'echo'
c
	elseif(str_comp(befehl,'echo',2,lbef,4)) then
	  call echo(zeile,lp)
c
c------ Evaluate an expression 'eval'
c
	elseif(str_comp(befehl,'eval',2,lbef,4)) then
	  call do_eval(zeile,lp)
c
c------	exit 'exit'
c
	elseif(str_comp(befehl,'exit',3,lbef,4)) then
	  goto 9999
c
c------	help 'help','?'
c
	elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	       str_comp(befehl,'?   ',1,lbef,4)     ) then
	  if(str_comp(zeile,'errors',2,lp,6) ) then
	    lp = lp + 7
	    call do_hel('discus '//zeile,lp)
	  else
	    lp = lp + 11
	    call do_hel('discus pdf '//zeile,lp)
	  endif
c
c-------Operating System Kommandos 'syst'
c
	  elseif(str_comp(befehl,'syst',2,lbef,4)) then
	    cdummy=' '
	    if(zeile.ne. ' ') then
	      cdummy(1:lp)=zeile(1:lp)
	      call do_operating(cdummy,lp)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------ Waiting for user input
c
	elseif(str_comp(befehl,'wait',3,lbef,4)) then
	  call do_input(zeile,lp)
c
c------ ------------------------------------------------------------
c------ Here start the PDF specific commands ...
c------ ------------------------------------------------------------
c
c------ Just calculate PDF for current parameters
c
	elseif(str_comp(befehl,'calc',2,lbef,4)) then
	  call pdf_setup
	  if (ier_num.eq.0) then
	    pdf_skal = 1.0
	    call pdf_determine (.true.)
	  endif
c
c------ Read observed PDF from XY file (ASCII)
c
	elseif(str_comp(befehl,'data',2,lbef,4)) then
	  call pdf_readdata(zeile,lp)
c
c------ Runs PDF fit
c
	elseif(str_comp(befehl,'run',2,lbef,3)) then
	  call pdf_setup
	  if (ier_num.eq.0) then
	    call pdf_run
	  endif
c
c------ Save structure or PDF
c
	elseif(str_comp(befehl,'save',2,lbef,4)) then
	  call pdf_save(zeile,lp)
c
c------ Set PDF parameters
c
	elseif(str_comp(befehl,'set',2,lbef,3)) then
	  call pdf_set(zeile,lp)
c
c------ Show current PDF parameters
c
	elseif(str_comp(befehl,'show',2,lbef,4)) then
	  call get_params (zeile,ianz,cpara,lpara,maxw,lp)
	  if (ier_num.eq.0) then
	    if (ianz.eq.0) then
	      call pdf_show ('PDF')
	    elseif (ianz.eq.1) then
	      call do_cap(cpara(1))
	      call pdf_show (cpara(1)(1:3))
	    else
	      ier_typ = ER_COMM
	      ier_num = -6
	    endif
	  endif
c
c------ selecting/deselecting atoms for PDF calculation
c
	elseif(str_comp(befehl,'isele',3,lbef,5) .or.
     &	       str_comp(befehl,'idese',3,lbef,5)     ) then
c
	call atom_select(zeile,lp,pdf_allowed_i,repl,0,0,maxscat,
     &	                 ldummy,idummy,idummy,.false.,
     &	                 str_comp(befehl,'isele',3,lbef,5))
c
	elseif(str_comp(befehl,'jsele',3,lbef,5) .or.
     &	       str_comp(befehl,'jdese',3,lbef,5)     ) then
c
	call atom_select(zeile,lp,pdf_allowed_j,repl,0,0,maxscat,
     &	                 ldummy,idummy,idummy,.false.,
     &	                 str_comp(befehl,'jsele',3,lbef,5))
c
c
c------ selecting/deselecting atoms
c
	elseif(str_comp(befehl,'sele',3,lbef,4) .or.
     &	       str_comp(befehl,'dese',2,lbef,4)     ) then
c
	call atom_select(zeile,lp,rmc_allowed,repl,0,0,maxscat,
     &	                 rmc_sel_atom,idummy,idummy,.false.,
     &	                 str_comp(befehl,'sele',3,lbef,4))
c
c------ selecting/deselecting of molecules
c
	elseif(str_comp(befehl,'msel',2,lbef,4) .or.
     &	       str_comp(befehl,'mdes',2,lbef,4)     ) then
c
	call mole_select(zeile,lp,rmc_allowed,repl,0,0,maxscat,
     &	                 rmc_sel_atom,idummy,idummy,.false.,
     &	                 str_comp(befehl,'msel',2,lbef,4))
c
c------ no command found
c
	else
	  ier_num = -8
	  ier_typ = ER_COMM
	endif
	endif
c
c------ any errors ?
c
	if(ier_num.ne.0) then
	  call errlist
	  if(lmakro) then
	    call macro_close
	    prompt_status = PROMPT_ON
	  endif
	  if(lblock) then
	    ier_num = -11
	    ier_typ = ER_COMM
	    return
	  endif
	  call no_error
	endif
	goto 10
c
9999	continue
c
	end
c*****7*****************************************************************
	subroutine pdf_setup 
c+
c	Setup for various arrays and functions for PDF calculation.
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'debug.inc'
	include		'diffuse.inc'
	include		'errlist.inc'
	include		'pdf.inc'
	include		'wink.inc'
c
	real		sincut,rcut,z,bave,hh,fac,rtot,ract
	integer		i,j,ia,is,js,nn,nnn
	logical		ltot
c
	real		form,quad
c
	write (output_io,1000)
c
c------ Do we have a crystal ?
c
	if (cr_natoms.lt.2) then
	  ier_num = -4
	  ier_typ = ER_PDF  
	  return
	endif
c
c------ Setting up array for periodic boundaries
c
	if (cr_icc(1).gt.MAXBND .or.
     &	    cr_icc(2).gt.MAXBND .or.
     &	    cr_icc(3).gt.MAXBND     ) then
	  ier_num = -3
	  ier_typ = ER_PDF
	  return
	endif
c
	do j=1,3
	  do i=-MAXBND,MAXBND+MAXBND
	    pdf_bnd(j,i)=i
	    do while (pdf_bnd(j,i).le.0) 
	      pdf_bnd(j,i)=pdf_bnd(j,i)+cr_icc(j)
	    enddo
	    do while (pdf_bnd(j,i).gt.cr_icc(j)) 
	      pdf_bnd(j,i)=pdf_bnd(j,i)-cr_icc(j)
	    enddo
	  enddo
	enddo
c
c------ Setting up weighting (b(i)b(j)/<b**2>)
c
	call dlink(pdf_lxray,ano,lambda,rlambda)
	bave = 0.0
	hh   = pdf_xq**2
c
	do ia=1,cr_natoms
	  bave  = bave + form(cr_iscat(ia),cr_scat,pdf_lxray,hh)
	enddo
	bave = bave/float(cr_natoms)
	do is=0,cr_nscat
	  do js=0,cr_nscat
	    pdf_weight(is,js)=form(is,cr_scat,pdf_lxray,hh)*
     &	                      form(js,cr_scat,pdf_lxray,hh)/bave**2
	  enddo
	enddo
c
c------ Get the ratio total pairs/selected weight in structure
c
	ltot = .true.
	do is=1,cr_nscat
	  ltot = ltot .and. pdf_allowed_i(is) 
     &	              .and. pdf_allowed_j(is)
	enddo
c
	if (.not. ltot) then
	  rtot = 0.0
	  ract = 0.0
c	
	  do i=1,cr_natoms
	    do j=1,cr_natoms
	      is = cr_iscat(i)
	      js = cr_iscat(j)
	      rtot = rtot + pdf_weight(is,js)
	      if ((pdf_allowed_i(is) .and. 
     &	           pdf_allowed_j(js)      ).or.
     &	          (pdf_allowed_j(is) .and.
     &	           pdf_allowed_i(js))          ) 
     &	       ract = ract + pdf_weight(is,js)
	    enddo
	  enddo
	  pdf_dnorm = ract/rtot
	else
	  pdf_dnorm = 1.0
	endif
c
c------ Setting up SINC function for convolution with PDF
c
	if (pdf_qmax.gt.0.0) then
	  sincut = 0.025
	  rcut   = 1.0 / (pdf_qmax*sincut)
	  z      = pdf_deltar*pdf_qmax
	  nn     = int(rcut/pdf_deltar) + 100
c
	  if ((pdf_rfmax + rcut) .gt. pdf_rmax) then
	    nnn = int((pdf_rfmax+rcut)/pdf_deltar)
	    if (nnn.le.MAXDAT) then
	      pdf_rmax = pdf_rfmax + rcut
	      pdf_bin  = int(pdf_rmax/pdf_deltar)
	      write (output_io,1100) pdf_rmax
	    else
	      ier_num = -2
	      ier_typ = ER_PDF
	      return
	    endif
	  endif
c
	  do i=1,nn
	    pdf_sinc(i) = sin(z*float(i))/(pdf_deltar*float(i))
	  enddo
	  do i=nn+1,2*MAXDAT
	    pdf_sinc(i) = 0.0
	  enddo
	endif
c
1000	format (' Setting up PDF segment ...')
1100	format (' Extending PDF search distance to ',F8.4,' A ...')
	end
c*****7*****************************************************************
	subroutine pdf_show (cmd)
c+
c	Shows current parameters
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'pdf.inc'
	include		'chem.inc'
	include		'errlist.inc'
c
	character*9	at_name,at_lis(MAXSCAT)
	character*3	cmd
	integer		i,j,k
c
	if (cmd.eq.'ALL' .or. cmd.eq.'PDF') then
	  call pdf_setup
	  if (ier_num.ne.0) return
c
	  write (output_io,1000) 
	  write (output_io,2000) pdf_rmax,pdf_deltar,pdf_bin
c
	  if (pdf_lxray) then
	    write (output_io,2010) 'X-Rays',pdf_xq
	  else
	    write (output_io,2015) 'Neutrons'
	  endif
c
	  write (output_io,2100)
	  if (pdf_qmax.eq.0.0) then
	    write (output_io,2110)
	  else
	    write (output_io,2120) pdf_qmax
	  endif
	  if (pdf_sigmaq.eq.0.0) then
	    write (output_io,2210)
	  else
	    write (output_io,2220) pdf_sigmaq
	  endif
	  if (chem_period(1).and.chem_period(2).and.chem_period(3)) then
	    if (pdf_2d) then
	      write (output_io,2300) 'applied - 2D'
	    else
	      write (output_io,2300) 'applied - 3D'
	    endif
	  else
	    write (output_io,2300) 'not applied'
	  endif
	  if (pdf_gauss) then
	    write (output_io,2400) 'applied'
	    write (output_io,2410) pdf_delta
	    write (output_io,2420) pdf_srat,pdf_rcut
	  else
	    write (output_io,2400) 'not applied'
	  endif
	  write (output_io,2445) pdf_rho0
	  write (output_io,2450) pdf_dnorm
c
	  write (output_io,3000) 
	  write (output_io,3010) pdf_rfmin,int(pdf_rfmin/pdf_deltar)
	  write (output_io,3020) pdf_rfmax,int(pdf_rfmax/pdf_deltar)
	  write (output_io,3030) pdf_skal
c
          j=0
          do i=1,cr_nscat
            if (pdf_allowed_i(i)) then
              j=j+1
              at_lis(j)=at_name(i)
            endif
          enddo
          write (output_io,3100) (at_lis(k),k=1,j)

          j=0
          do i=1,cr_nscat
            if (pdf_allowed_j(i)) then
              j=j+1
              at_lis(j)=at_name(i)
            endif
          enddo
          write (output_io,3110) (at_lis(k),k=1,j)
	endif
c
	if (cmd.ne.'PDF') write (output_io,4000)
	if (cmd.eq.'ALL' .or. cmd.eq.'RMC') then
	  call rmc_show('MOD')
	  call rmc_show('ATO')
	else
	  call rmc_show(cmd)
	endif
c
1000	format (' Current PDF calculation settings : ')
2000	format ('   Maximum r [A]              : ',F8.4,/
     &	        '   Grid size DR [A]           : ',F8.4,4X,
     &	                                      '(',I13,' pts)')
2010	format ('   Radiation                  : ',A8,4X,'(at ',F8.4,
     &	                                      ' A**-1)')
2015	format ('   Radiation                  : ',A8)
2100	format (/,'   Applied corrections        : ')
2110	format ('     Q termination (SINC)     : not applied')
2120	format ('     Q termination (SINC)     : applied, Qmax = ',
     &	                                         F8.4,' A**-1')
2210	format ('     Instrument resolution    : not applied')
2220	format ('     Instrument resolution    : applied, sigQ = ',
     &	                                         F8.4,' A**-1')
2300	format ('     Periodic boundaries      : ',a)
2400	format ('     Convolution therm. Gauss.: ',a)
2410	format ('     Dynamic correlation fac. : ',F8.4)
2420	format ('     PDF peak width ratio     : ',F8.4, ' below ',
     &	                                           F8.4,' A')
2445	format ('     Number density (0=auto)  : ',F8.4)
2450	format ('     Correction for RHO0      : ',F8.4)
3000	format (/,'   Refinement settings        : ')
3010	format ('     Fit minimum r [A]        : ',F8.4,3X,'(pt.',I5,')')
3020	format ('     Fit maximum r [A]        : ',F8.4,3X,'(pt.',I5,')')
3030	format ('     Current scale factor     : ',F8.4)
3100	format (/,'   Selected atoms for PDF calculation :',/
     &	        '     Atoms (i)                : ',100(A9,1X))
3110	format ('     Atoms (j)                : ',100(A9,1X))
4000	format (/,' Current RMC settings (not all used here) :')
c
	end
c*****7*****************************************************************
	subroutine pdf_save (zeile,lp)
c+
c	Save PDF or current structure
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'errlist.inc'
	include 	'pdf.inc'
c
	integer		maxw
	parameter	(maxw=10)
c
	character*(*)	zeile
	integer		i,il,lp,nmi,nma
	real		r
c
	character*200	cdummy,cpara(maxw)
	integer		ianz,lpara(maxw),ip,is
	real		werte(maxw)
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if(ianz.ge.2) then
	  call do_cap(cpara(1))
	  cdummy = cpara(1)
	  if (ier_num.ne.0) return
c
c------ - Save structure
c
	  if (cdummy(1:3).eq.'STR') then
	    call del_params (1,ianz,cpara,lpara,maxw)
	    call do_build_name (ianz,cpara,lpara,werte,maxw,1)
	    write (output_io,1500) cpara(1)(1:lpara(1))
	    call save_struc(cpara(1),lpara(1))
c
c------ - Save PDF (G(r))
c
	  elseif (cdummy(1:3).eq.'PDF') then
	    call del_params (1,ianz,cpara,lpara,maxw)
	    call do_build_name (ianz,cpara,lpara,werte,maxw,1)
	    write (output_io,1505) cpara(1)(1:lpara(1))
	    call oeffne (57,cpara(1),'unknown',.false.)
	    if (ier_num.eq.0) then
	      nmi = int(pdf_rfmin/pdf_deltar)
	      nma = int(pdf_rfmax/pdf_deltar)
	      do i=nmi,nma
	        r = float(i)*pdf_deltar
	        write (57,5000) r,pdf_skal*pdf_calc(i),0.0,1.0
	      enddo
	      close (57)
	    endif
c
c------ --unknown subcommand given
c
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
1500	format (' Saving structure to file : ',A,' ...')
1505	format (' Saving PDF to file : ',A,' ...')
5000	format (F9.4,3X,F16.5,5X,2(F6.2,1X))
	end
c*****7*****************************************************************
	subroutine pdf_readdata (zeile,lp)
c+
c	Reads observed PDF as xy ASCII file. 
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'prompt.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
	include 	'debug.inc'
	include 	'pdf.inc'
c
	integer		maxw
	parameter	(maxw=5)
c
	character*(*)	zeile
	integer		lp
c
	character*200	cpara(maxw)
	integer		lpara(maxw)
	integer		ianz,ip
	real		ra,re,dr
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
c------ Read observed PDF for given plane
c
	if (ianz.eq.1) then
	  call oeffne (17,cpara(1),'old',.false.)
	  if (ier_num.ne.0) return
	  call extract_hist (17)
	  call skip_spec (17)
	  ip=1
	  read (17,*,end=20,err=999) ra,pdf_obs(ip),dr,pdf_wic(ip)
	  ip = ip+1
10	  continue
	    read (17,*,end=20,err=999) re,pdf_obs(ip),dr,pdf_wic(ip)
	    ip = ip+1
	    if (ip.gt.MAXDAT) goto 9999
	    goto 10
20	  continue
	  close (17)
	  if (ier_num.ne.0) return
c
	  pdf_rmax   = re
	  pdf_bin    = ip-1
	  pdf_deltar = re/float(pdf_bin)
	  pdf_rfmin  = pdf_deltar
	  pdf_rfmax  = re
c
	  write (output_io,9000) ra,re,pdf_bin
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
	return
c
999	continue
	close (17)
	ier_num = -3
	ier_typ = ER_IO
C
9999	continue
	close (17)
	ier_num = -1
	ier_typ = ER_PDF
	return
c
9000	format (' Read PDF data (r = ',F7.3,' to ',F7.3,' A, ',I5,
     &	        ' points) ...')
	end
c*****7*****************************************************************
	subroutine extract_hist(ifil)
c
c	Extract history information if present
c
	implicit	none
c
	include		'config.inc'
	include		'param.inc'
	include		'prompt.inc'
	include		'pdf.inc'
c
	integer		ifil
c
	character*200	line
	integer		is,ie
c
	integer		len_str
c
	read(ifil,5000) line
	if (line(1:7).eq.'History') then
	  res_para(0)=0
22	  continue
	    read(ifil,5000) line
	    call extract_key(line,'temp=')
	    call extract_key(line,'Qmax=')
	    if (line(1:16) .eq. '##### start data') goto 33
	  goto 22
33	  continue
	  pdf_qmax=res_para(2)
	  write (output_io,1000) pdf_qmax
	else
	  backspace(ifil)
	endif
c
1000	format( ' History information found, setting Qmax=',f5.1,
     &	        ' A**-1 ...')
5000	format(a)
c
	end
c*****7*****************************************************************
	subroutine skip_spec (ifil)
c+
c	Reads over #xxx lines (SPEC headers)
c-
	implicit      	none
c
	integer		ifil
c
	character*1	cstr
c
11	continue
	  read (ifil,1000,end=22) cstr
	  if (cstr(1:1).eq.'#') goto 11
22	continue
	backspace(ifil)
c
1000	format (a)
	end
c*****7*****************************************************************
	subroutine extract_key (line,key)
c+
c	Gets numbers from history part of data file
c-
	implicit      	none
c
	include		'config.inc'
	include		'param.inc'
c
	character*(*)	line,key
	integer		is,ie,ll,lk
c
	integer		len_str
c
	ll = len_str(line)
	lk = len_str(key)
c
	is = index(line,key(1:lk))
	if (is.ne.0) then
	  is = is+lk
	  do while (line(is:is).eq.' ')
	    is = is+1
	  enddo
	  ie = index(line(is:ll),' ')
	  if (ie.eq.0) ie = ll
	  res_para(0) = res_para(0)+1
	  read(line(is:is+ie),*) res_para(res_para(0))
	endif
c
	end
c*****7****************************************************************
	subroutine pdf_set (zeile,lp)
c+
c	Sets most parameters for 'pdf' section
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'diffuse.inc'
	include		'errlist.inc'
	include 	'chem.inc'
	include 	'pdf.inc'
c
	integer		maxw
	parameter	(maxw=20)
c
	character*(*)	zeile
	integer		lp
c
	character*200	cpara(maxw)
	real		werte(maxw)
	integer		lpara(maxw)
	integer		ianz,nn
c
	logical		str_comp
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
	if (ianz.ge.2) then
	  call do_cap(cpara(1))
c
c------ - set boundary: toggle periodic boundaries
c
	  if (cpara(1)(1:3).eq.'BOU') then
	    if (ianz.eq.2 .or. ianz.eq.3) then
	      chem_period(1) = str_comp(cpara(2),'period',3,lpara(2),6)
	      chem_period(2) = chem_period(1)
	      chem_period(3) = chem_period(1)
	      if (ianz.eq.3) then
	        pdf_2d = str_comp(cpara(3),'2D',1,lpara(3),2)
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------ - set delta: sets dyn. correlation factor
c
	  elseif (cpara(1)(1:3).eq.'DEL') then
	    call del_params (1,ianz,cpara,lpara,maxw)
	    call ber_params(ianz,cpara,lpara,werte,maxw)
	    if (ier_num.ne.0) return
	    if (ianz.eq.1) then
	      pdf_delta = werte(1)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------ - set density: sets number density
c
	  elseif (cpara(1)(1:3).eq.'DEN') then
	    call del_params (1,ianz,cpara,lpara,maxw)
	    call ber_params(ianz,cpara,lpara,werte,maxw)
	    if (ier_num.ne.0) return
	    if (ianz.eq.1) then
	      pdf_rho0 = werte(1)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------ - set frange: sets range in r to be used for fit
c
	  elseif (cpara(1)(1:3).eq.'FRA') then
	    call del_params (1,ianz,cpara,lpara,maxw)
	    call ber_params(ianz,cpara,lpara,werte,maxw)
	    if (ier_num.ne.0) return
	    if (ianz.eq.2) then
	      pdf_rfmin = werte(1)
	      pdf_rfmax = werte(2)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------ - set qmax: sets Qmax for termination correction
c
	  elseif (cpara(1)(1:3).eq.'QMA') then
	    call del_params (1,ianz,cpara,lpara,maxw)
	    call ber_params(ianz,cpara,lpara,werte,maxw)
	    if (ier_num.ne.0) return
	    if (ianz.eq.1) then
	      pdf_qmax = werte(1)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------ - set qsig: sets SIGMA Q for resolution correction
c
	  elseif (cpara(1)(1:3).eq.'QSI') then
	    call del_params (1,ianz,cpara,lpara,maxw)
	    call ber_params(ianz,cpara,lpara,werte,maxw)
	    if (ier_num.ne.0) return
	    if (ianz.eq.1) then
	      pdf_sigmaq = werte(1)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------ - set radiation: sets radiation uses
c
	  elseif (cpara(1)(1:3).eq.'RAD') then
	    call del_params (1,ianz,cpara,lpara,maxw)
	    if (ier_num.ne.0) return
	    if (ianz.eq.1 .or. ianz.eq.2) then
	      call do_cap(cpara(1))
	      if     (cpara(1)(1:1).eq.'N') then
	        pdf_lxray = .false.
	      elseif (cpara(1)(1:1).eq.'X') then
	        pdf_lxray = .true.
	        if (ianz.eq.2) then
	          call del_params (1,ianz,cpara,lpara,maxw)
	          call ber_params (ianz,cpara,lpara,werte,maxw)
	          if (ier_num.ne.0) return
	          pdf_xq = werte(1)
	        else
	          pdf_xq = 0.0
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------ - set range: set range in r for PDF calculation 
c
	  elseif (cpara(1)(1:3).eq.'RAN') then
	    call del_params (1,ianz,cpara,lpara,maxw)
	    call ber_params(ianz,cpara,lpara,werte,maxw)
	    if (ier_num.ne.0) return
	    if (ianz.eq.2) then
	      nn = int(werte(1)/werte(2))
	      if (nn.lt.1 .or. nn.gt.MAXDAT) then
	        ier_num = -1
	        ier_typ = ER_PDF
	        return
	      endif
	      pdf_rmax   = werte(1)
	      pdf_deltar = werte(2)
	      pdf_rfmin  = werte(2)
	      pdf_rfmax  = pdf_rmax
	      pdf_bin    = nn
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------ - set srat: sets peak sharpening SRAT
c
	  elseif (cpara(1)(1:3).eq.'SRA') then
	    call del_params (1,ianz,cpara,lpara,maxw)
	    call ber_params(ianz,cpara,lpara,werte,maxw)
	    if (ier_num.ne.0) return
	    if (ianz.eq.2) then
	      pdf_srat = werte(1)
	      pdf_rcut = werte(2)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------ - set therm: toggle convolution with thermal Gaussian
c
	  elseif (cpara(1)(1:3).eq.'THE') then
	    if (ianz.eq.2) then
	      pdf_gauss = str_comp(cpara(2),'gaus',3,lpara(2),4)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------ - if not found here try rmc_set (thats where the rest is)
c
	  elseif (cpara(1)(1:3).eq.'CYC' .or. 
     &	          cpara(1)(1:3).eq.'DIS' .or.
     &	          cpara(1)(1:3).eq.'SIG' .or.
     &	          cpara(1)(1:3).eq.'MOD' .or.
     &	          cpara(1)(1:3).eq.'MDI' .or.
     &	          cpara(1)(1:3).eq.'MOV'      ) then
	    call rmc_set(zeile,lp)
c
c------ - invalid command entered
C
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine pdf_run
c+
c	Main PDF fit loop - called by run command
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'prompt.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'random.inc'
	include 	'errlist.inc'
	include		'chem.inc'
	include		'param.inc'
	include 	'rmc.inc'
	include		'diffuse.inc'
	include		'pdf.inc'
c
	real*8		cc,c,ce,e,ee,wtot
	real		pdf_old(MAXDAT)
	real		cnew,cold,sig2,sum
	real		prob,psum,p2sum,pave,psig,pmax,pn
	real		start,zeit,seknds
	real		p_new(3,rmc_max_atom)
	real		p_old(3,rmc_max_atom)
	integer		i_new(rmc_max_atom)
	integer		i_old(rmc_max_atom)
	integer		isel(rmc_max_atom),natoms
	integer		imol(rmc_max_atom)
	integer		zh,zm,zs,nmi,nma
	integer		i,j,ip,iq,is,iii
	integer		igen,itry,iacc_good,iacc_bad
	logical		loop,laccept
c
	real		ran1
c
	if (pdf_obs(1).eq.-9999.) then
	  ier_num = -4
	  ier_typ = ER_RMC
	  return
	endif
c
	igen      = 0
	itry      = 0
	iacc_good = 0
	iacc_bad  = 0
	loop      = .true.
	laccept   = .true.
c
	psum      = 0.0
	p2sum     = 0.0
	pmax      = 0.0
	pn        = 0.0
c
	nmi = int(pdf_rfmin/pdf_deltar)
	nma = int(pdf_rfmax/pdf_deltar)
c
	call chem_aver(.false.)
c
c------ Write some start information
c
	write (output_io,1000) (cr_icc(i),i=1,3),cr_natoms
c
c------ calculate sums from exp. data needed and initial chi2
c
	call pdf_determine(.false.)
c
	cold = 0.0
	wtot = 0.0
	e    = 0.0
	ee   = 0.0
	c    = 0.0
	cc   = 0.0
	ce   = 0.0
C
	do ip=nmi,nma
	  wtot = wtot + pdf_wic(ip)
	  e    = e  + pdf_wic(ip)*pdf_obs(ip)
	  ee   = ee + pdf_wic(ip)*pdf_obs(ip)**2
	  c    = c  + pdf_wic(ip)*pdf_calc(ip)
	  cc   = cc + pdf_wic(ip)*pdf_calc(ip)**2
	  ce   = ce + pdf_wic(ip)*pdf_calc(ip)*pdf_obs(ip)
	enddo
	pdf_skal = ce/cc
	cold     = ee + pdf_skal**2*cc - 2.0*pdf_skal*ce
	cold     = cold/wtot
c
c------ Here is the main loop
c
	start = seknds(0.0)
	if     (rmc_mode.eq.rmc_mode_swchem) then
	  write (output_io,2000) 'Mode SWCHEM'
	elseif (rmc_mode.eq.rmc_mode_swdisp) then
	  write (output_io,2000) 'Mode SWDISP'
	elseif (rmc_mode.eq.rmc_mode_shift) then
	  write (output_io,2000) 'Mode SHIFT'
	elseif (rmc_mode.eq.rmc_mode_external) then
	  write (output_io,2000) 'external defined mode'
	endif
c
	sig2 = rmc_sigma**2/2.0
c
	do while (loop)
	  laccept = .true.
	  igen = igen + 1
c
c-------- generate move and check for limits
c
	  if (rmc_sel_atom) then
	    call rmc_genmove (laccept,natoms,p_new,i_new,isel)
	  else
	    call rmc_genmove_mol (laccept,natoms,p_new,i_new,isel,imol)
	  endif
	  if (ier_num.ne.0) return
	  if (laccept) then
c
c-------- - save old positions ...
c
	    do i=1,natoms
	      i_old(i)   = cr_iscat(isel(i))
	      p_old(1,i) = cr_pos(1,isel(i))
	      p_old(2,i) = cr_pos(2,isel(i))
	      p_old(3,i) = cr_pos(3,isel(i))
	    enddo
c
	    do i=1,pdf_bin
	      pdf_old(i) = pdf_corr(i)
	    enddo
c
c-------- - Calc new PDF and chi2
c
	    do i=1,natoms
	      call pdf_addcorr(isel(i),-2.0,sum)
	    enddo
	    call pdf_makemove (natoms,i_new,p_new,isel,imol)
	    do i=1,natoms
	      call pdf_addcorr(isel(i), 2.0,sum)
	    enddo
	    call pdf_convert
c
	    itry = itry + 1
	    cnew = 0.0
	    c    = 0.0
	    cc   = 0.0
	    ce   = 0.0
C
	    do ip=nmi,nma
	      c  = c  + pdf_wic(ip)*pdf_calc(ip)
	      cc = cc + pdf_wic(ip)*pdf_calc(ip)**2
	      ce = ce + pdf_wic(ip)*pdf_calc(ip)*pdf_obs(ip)
	    enddo
	    pdf_skal = ce/cc
	    cnew     = ee + pdf_skal**2*cc - 2.0*pdf_skal*ce
	    cnew     = cnew/wtot
c
c------	----Accept move ?
c
	    prob = cnew - cold
c
	    if (prob.lt.0) then
	      laccept = .true.
	    else
	      if (sig2.gt.0.0) then
	        psum    = psum  + prob
	        p2sum   = p2sum  + prob**2
	        pmax    = max (pmax,prob)
	        pn      = pn + 1
	        prob    = exp(-prob/sig2)
	        laccept = (prob.gt.ran1(idum))
	      else
	        laccept = .false.
	      endif
	    endif
c
	    if (rmc_sigma.eq.-9999.) laccept = .true.
c
c------ ----if accepted make move	  
c
	    if (laccept) then
	      cold = cnew
	      if (prob.lt.0) then
	        iacc_good = iacc_good + 1
	      else
	        iacc_bad  = iacc_bad + 1
	      endif
	    else
	      call pdf_makemove (natoms,i_old,p_old,isel,imol)
	      do i=1,pdf_bin
	        pdf_corr(i) = pdf_old(i)
	      enddo
	      call pdf_convert
	    endif
c
c------ --write info and terminate or loop again
c
	  endif
c
2222	  continue
c
	  loop = (itry.lt.rmc_maxcyc)
c
	  if (igen.gt.1000*rmc_display .and. itry.eq.0) then
	    ier_num = -20
	    ier_typ = ER_RMC
	    loop    = .false.
	  endif
c
	  if (mod(igen,rmc_display).eq.0 .or. .not.loop) then
	    if (.not.loop) write (output_io,1250) pdf_skal
	    write (output_io,1300) igen,itry,iacc_good,iacc_bad,cold
	  endif
	enddo
c
c------ write timing summary and "prob" statistics
c
	if (pn.gt.0) then
	  pave = psum / pn
	  psig = sqrt (p2sum/pn - (psum/pn)**2)
	  write (output_io,3000) pave,psig,pmax
	endif
c
	zeit = seknds(start)
	zh = int (zeit / 3600.)
	zm = int ((zeit - zh*3600.) / 60.)
	zs = int ( zeit - zh*3600 - zm*60.)
	write (output_io,4000) zh,zm,zs,zeit/itry
c	
c------ Update crystal dimensions
c
        call update_cr_dim
c
c------ formats
c
1000	format (' Running PDF-Fit ...',//
     &	        ' Size of model crystal     : ',I3,' x ',I3,' x ',I3,
     &	        ' containing ',I9,' atoms')
1250	format (/,' ---- Final configuration (s= ',F8.4,') ---- ',/)
1300	format (  ' Gen: ',I6,' try: ',I6,' acc: (good/bad): ',I6,
     &	          ' / ',I6,' s2x2: ',G15.8)
2000	format (/,' Starting main RMC loop ...',/,' (',A,') ',/)
3000	format (/,' Delta Chi    : ave: ',G15.4,' sig: ',G15.4,
     &	          ' max: ',G15.4)
4000	format (/,' Elapsed time : ',I4,' h ',I2,' min ',I2,' sec ',/
     &	          ' Time/cycle   : ',F9.3,' sec',/)
	end
c*****7*****************************************************************
      	subroutine pdf_makemove (natoms,i_new,p_new,isel,imol)
c+
c	make accepted move
c
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'molecule.inc'
	include 	'rmc.inc'
c
	real		p_new(3,rmc_max_atom)
	integer		i_new(rmc_max_atom)
	integer		isel(rmc_max_atom)
	integer		imol(rmc_max_atom)
	integer		natoms
c
	integer		i,j,is
c
	do i=1,natoms
	  cr_iscat(isel(i))=i_new(i)
	  do j=1,3
	    cr_pos(j,isel(i))=p_new(j,i)
	  enddo
	enddo
c
	if (.not. rmc_sel_atom .and. rmc_mode.eq.rmc_mode_swchem) then
	  is = mole_type(imol(1))
	  mole_type(imol(1)) = mole_type(imol(2))
	  mole_type(imol(2)) = is
	endif
c
	end
c*****7*****************************************************************
	subroutine pdf_determine (lout)
c+
c	Calculate PDF of current structure
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'pdf.inc'
c
	integer		i,ia,id
	real		done,sum
	logical		lout
c
	if (lout) write (output_io,500)
c
c------ Reset arrays
c
	do i=1,MAXDAT
	  pdf_corr(i) = 0.0
	enddo
c
	sum = 0.0
c
c------ Start the calculation
c
	id=max(1,cr_natoms/20)
c
	do ia=1,cr_natoms
	  call pdf_addcorr(ia,1.0,sum)
	  if (lout .and. (mod(ia,id).eq.0)) then
	    done = 100.0*float(ia)/float(cr_natoms)
	    write (output_io,1000) done
	  endif
	enddo
c
c------ Convert to proper G(r)
c
	call pdf_convert
c
	if (lout) write (output_io,2000) sum
c
500	format (  ' Calculating PDF ...')
1000	format (  '   ',f6.2,' % done  ...')
2000	format (/,' Total sum of weights : ',g18.10)
	end
c*****7*****************************************************************
	subroutine pdf_convert
c+
c	Convert to G(r) and do convolution
c-
	implicit	none
c
	include		'config.inc'
	include		'atom_env.inc'
	include 	'chem.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'errlist.inc'
	include		'param.inc'
	include		'pdf.inc'
	include		'wink.inc'
c
	integer		i,k,ia,ncc
	real		ppp(MAXDAT)
	real		norm,fac,r,r0
c
c
	ncc  = cr_icc(1)*cr_icc(2)*cr_icc(3)
	if (pdf_rho0.gt.0.0) then
	  r0 = pdf_rho0
	else
	  r0 = cr_ncatoms/cr_v
	endif
	norm = 1.0/cr_ncatoms/ncc
	if (.not. pdf_gauss) then
	  norm = norm/pdf_deltar
	endif
c
	do i=1,pdf_bin
	  r = float(i)*pdf_deltar
	  pdf_calc(i) = norm*pdf_corr(i)/r - 2.0*zpi*r*r0*pdf_dnorm
	enddo
c
c------ Apply instrument resolution correction 
c
	if (pdf_sigmaq.gt.0.0) then
	  do i=1,pdf_bin
	    r = float(i)*pdf_deltar
	    pdf_calc(i) = pdf_calc(i)*exp(-(r*pdf_sigmaq)**2/2.0)
	  enddo
	endif
c
c------ Convolute with SINC function
c
	if (pdf_qmax.gt.0.0) then
	  do i=1,pdf_bin
	    ppp(i) = pdf_calc(i)*(pdf_qmax-pdf_sinc(2*i))
	    do k=1,i-1
	      ppp(i) = ppp(i) + pdf_calc(k)*(pdf_sinc(i-k)-pdf_sinc(i+k))
	    enddo
	    do k=i+1,pdf_bin
	      ppp(i) = ppp(i) + pdf_calc(k)*(pdf_sinc(k-i)-pdf_sinc(k+i))
	    enddo
	  enddo
c
	  do i=1,pdf_bin
	    pdf_calc(i) = ppp(i)*pdf_deltar/zpi*2.0
	  enddo
	endif
c
	end
c*****7*****************************************************************
	subroutine pdf_addcorr (ia,rsign,sum)
c+
c	Calculate correlation for given atom ia
c-
	implicit	none
c
	include		'config.inc'
	include		'atom_env.inc'
	include 	'chem.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'errlist.inc'
	include		'param.inc'
	include		'pdf.inc'
	include		'wink.inc'
c
	integer		ig,igaus,ib,ie
	integer		i,j,k,ii,jj,kk,is,js,ks,ia,iatom,ibin,nn,ncc
	integer       	istart(3),iend(3),iii(3),cell(3)
	real		gnorm,norm,dist,dist2,r,r0,rg,rsign
	real		sigma02,sigma,sigmap,fac,ui,uj,sum
	real		dd(3),d(3),offset(3)
	real		ppp(MAXDAT),gaus(MAXDAT)
	logical		lout,lspace
c
	real		skalpro
c
	data lspace     /.true./
c
	fac = 1.0 / (2.0*zpi**2)
c
        is = cr_iscat(ia)
	if (pdf_allowed_i(is) .or. pdf_allowed_j(is)) then
	  call indextocell (ia,iii,ks)
	  do i=1,3
	    istart(i) = iii(i)-1-int(pdf_rmax/cr_a0(i))
	    iend(i)   = iii(i)+1+int(pdf_rmax/cr_a0(i))
	    if (pdf_2d .and. cr_icc(i).le.1) then
	      istart(i)=iii(i)
	      iend(i)  =iii(i)
	    endif
	  enddo
c
c------ - In case we do not want to loop around cut range
c
	  if ((.not. chem_period(1)) .and. (.not. chem_period(2)) .and.
     &	      (.not. chem_period(3))) then
	    do i=1,3
	      istart(i) = max(1,istart(i))
	      iend(i)   = min(cr_icc(i),iend(i))
	    enddo
	  endif
c
c------ - Here starts the inner loop
c
	  do k=istart(3),iend(3)
	  do j=istart(2),iend(2)
	  do i=istart(1),iend(1)
	    cell(1) = i
	    cell(2) = j
	    cell(3) = k
c	
c---------- Here we apply periodic boundaries
c---------- Modified to allow more than a single cycle !
c
	    do ii=1,3
	      iii(ii)    = cell(ii)
	      cell(ii)   = pdf_bnd(ii,cell(ii))
	      offset(ii) = float(iii(ii)-cell(ii))
	    enddo
c
c------ --- Now look for neighbours in surrounding unit cells only
c
	    do ii=1,cr_ncatoms
	      call celltoindex (cell,ii,iatom)
              js   = cr_iscat(iatom)
              if ((pdf_allowed_i(is) .and.
     &             pdf_allowed_j(js)      ).or.
     &            (pdf_allowed_j(is) .and.
     &             pdf_allowed_i(js))          ) then
	        do jj=1,3
	          dd(jj) = cr_pos(jj,ia)    -
     &	                   cr_pos(jj,iatom) - offset(jj)
	          d(jj)  = abs(dd(jj)) * cr_a0(jj)
	        enddo
	        dist2 = skalpro(dd,dd,cr_gten)
	        dist  = sqrt(dist2)
c
	        if (dist.le.pdf_rmax .and. dist.gt.pdf_deltar) then
       	          ibin = nint (dist/pdf_deltar)
c
c------ --------- Convolute with Gaussian
c
	          if (pdf_gauss) then
	            ui = cr_dw(is)*fac
	            uj = cr_dw(js)*fac
	            sigma02 = (ui+uj)*(d(1)*d(1)+d(2)*d(2)+d(3)*d(3))
	            sigmap  = sqrt(abs(sigma02)/dist2)
	            sigma   = sigmap - pdf_delta/dist2
	            if (dist.le.pdf_rcut) then
	              sigma = sigma*pdf_srat
	            endif
	            igaus = 1 + nint(5.0*sigma/pdf_deltar)
	            ib    = max(1,ibin-igaus+1)
	            ie    = min(pdf_bin,ibin+igaus-1)
	            gnorm = 1.0/(sqrt(zpi)*sigma)
c
	            do ig=1,igaus
	              rg       = (ig-1)*pdf_deltar
	              gaus(ig) = gnorm * exp(-0.5*(rg/sigma)**2)
	            enddo
c
	            do ig=ib,ie
	              kk      = abs(ibin-ig)+1
	              pdf_corr(ig) = pdf_corr(ig) + 
     &	                             rsign*pdf_weight(is,js)*gaus(kk)
	            enddo
c
c------ --------- Just take the distance
c
	          else
	            pdf_corr(ibin) = pdf_corr(ibin) +
     &	                             rsign*pdf_weight(is,js)
	          endif
	          sum = sum + pdf_weight(is,js)
	        endif
	      endif
            enddo
	  enddo
	  enddo
	  enddo
1111	  continue
	endif
c
	end
c*****7*****************************************************************
	subroutine errlist_pdf
c-
c	Displays error Messages for the error type PDF 
c+
	implicit      none
c
	include      'errlist.inc'
c
	integer       iu,io
	parameter    (IU=-4,IO=0)
c
	character*41  ERROR(IU:IO)
c
	DATA ERROR/
     &  'No structure defined yet (>= 2 atoms)',            ! -4 
     &  'Crystal too large to create peridic bound. ',      ! -3 
     &  'Cannot extend r-range for corr. convolution',      ! -2 
     &  'Too many points in PDF                     ',      ! -1 
     &  ' '       !  0
     &	/
c
	call disp_error ('PDF ',error,iu,io)
	end
C*****7****************************************************************
