c*****7*****************************************************************
	subroutine plot
c-
c	Write the structure properly formatted for structure display
c	programs and KUPLOT
c
c	Version  : 1.21
c	Date     : 12 January 1998
c
c	Authors  : R.B. Neder  (reinhard.neder@mail.uni-wuerzburg.de)
c	           Th. Proffen (tproffen@lanl.gov)
c+
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'doact.inc'
	include 	'errlist.inc'
	include 	'learn.inc'
	include 	'macro.inc'
	include 	'plot.inc'
	include 	'prompt.inc'
c
	integer		maxw
	parameter	(maxw=MAXSCAT)
	logical		lold
	parameter	(lold=.false.)
c
	character*200	line,zeile,cpara(maxw)
	character*11	prom
	character*5	befehl
	character*1	cdum
	real		werte(maxw)
	real            size,rr,rg,rb
	integer		repl(0:MAXSCAT)
	integer		lpara(maxw),lp,length
	integer		ianz,i,j,is,it,ic,lbef
	integer         indxg
	logical		lend,l_select
c
	logical         str_comp
c
	include 	'microsta.inc'
c
	lend=.false.
c
	do while (.not. lend)
	  call no_error
	  prom=prompt//'/plot'
	  call get_command (line,length,befehl,lbef,zeile,lp,prom)
	  if(ier_num.eq.0) then
	  if(line.ne.' ' .and. line(1:1).ne.'#') then
c
c------	----search for "="
c
	    indxg=index(line,'=')
	    if(indxg.ne.0 
     &	              .and. .not.(str_comp(befehl,'echo',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'syst',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'help',2,lbef,4) .or.
     &	                          str_comp(befehl,'?   ',2,lbef,4)) )then
c
c------	------evaluatean expression and assign the value to a variabble
c
	      call do_math(line,indxg,length)
	    else
c
c------ ----execute a macro file
c
            if(befehl(1:1).eq.'@') then
	      if(length.ge.2) then
	        call file_kdo(line(2:length),length-1)
	      else
	        ier_num = -13
	        ier_typ = ER_MAC
	      endif
c
c------	----Select the abscissa for a projection onto a to plot slice 'absc'
c
	    elseif(str_comp(befehl,'absc',2,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            pl_abs(i) = werte(i)
	          enddo
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ ----list asymmetric unit 'asym'
c
	    elseif(str_comp(befehl,'asym',2,lbef,4)) then
              call show_asym
c
c------ ----list atoms present in the crystal 'chem'
c
	    elseif(str_comp(befehl,'chem',2,lbef,4)) then
              call show_chem
c
c------	----Set the sequence of columns 'colu'
c
	    elseif(str_comp(befehl,'colu',3,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.1) then
	          if(cpara(1).eq.'xyz' .or. cpara(1).eq.'yzx' .or.
     &	             cpara(1).eq.'zxy' .or. cpara(1).eq.'xzy' .or.
     &	             cpara(1).eq.'zyx' .or. cpara(1).eq.'yxz' ) then
	            pl_col = cpara(1)
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	--continues a macro 'continue'
c
	    elseif(str_comp(befehl,'continue',3,lbef,8)) then
	      call macro_continue(zeile,lp)
c
c------ --selecting/deselecting atoms
c
	    elseif(str_comp(befehl,'sele',3,lbef,4) .or.
     &	           str_comp(befehl,'dese',2,lbef,4)     ) then
c
	    call atom_select(zeile,lp,pl_latom,repl,0,0,maxscat,
     &	                     pl_sel_atom,pl_md_s,pl_md_nr,lold,
     &	                     str_comp(befehl,'sele',3,lbef,4))
c
c------ --selecting/deselecting of molecules
c
	    elseif(str_comp(befehl,'msel',2,lbef,4) .or.
     &	           str_comp(befehl,'mdes',2,lbef,4)     ) then
c
	    call mole_select(zeile,lp,pl_latom,repl,0,0,maxscat,
     &	                     pl_sel_atom,pl_md_s,pl_md_nr,lold,
     &	                     str_comp(befehl,'msel',2,lbef,4))
c
c------	----Select the bonds 'bond'
c
	    elseif(str_comp(befehl,'bonds',2,lbef,5)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. (ianz.eq.6 .or. ianz.eq.8)) then
c
	        do j=0,MAXSCAT
	          pl_batom_a(j) = .false.
	          pl_batom_e(j) = .false.
	        enddo
	        zeile = cpara(1)(1:lpara(1))
	        call atom_select(zeile,lp,pl_batom_a,repl,0,0,maxscat,
     &	                   pl_sel_atom,pl_md_s,pl_md_nr,lold,
     &	                   .true.)
	        zeile = cpara(2)(1:lpara(2))
	        call atom_select(zeile,lp,pl_batom_e,repl,0,0,maxscat,
     &	                   pl_sel_atom,pl_md_s,pl_md_nr,lold,
     &	                   .true.)
	        call del_params (2,ianz,cpara,lpara,maxw)
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=0,MAXSCAT
	            do j=0,MAXSCAT
	            if(pl_batom_a(i) .and. pl_batom_e(j)) then
	              pl_bond(      i,j) = .true.
	              pl_bond_len(1,i,j) = werte(1)
	              pl_bond_len(2,i,j) = werte(2)
	              pl_bond_rad(  i,j) = werte(3)
	              pl_bond_col(1,i,j) = werte(4)
	              if(ianz.eq.4) then
	                pl_bond_col(2,i,j) = werte(4)
	                pl_bond_col(3,i,j) = werte(4)
	              elseif(ianz.eq.6) then
	                pl_bond_col(2,i,j) = werte(5)
	                pl_bond_col(3,i,j) = werte(6)
	              endif
	            endif
	            enddo
	          enddo
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ ----Echo a string, just for interactive check in a macro 'echo'
c
	    elseif(str_comp(befehl,'echo',2,lbef,4)) then
	      call echo(zeile,lp)
c
c------	----exit 'exit'
c
	    elseif(str_comp(befehl,'exit',3,lbef,4)) then
	      lend=.true.
c
c------	----Select the extend of crystal space to be plotted 'exte'
c
	    elseif(str_comp(befehl,'exte',3,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.1 .and. cpara(1)(1:3).eq.'all') then
	          do i=1,3
	            do j=1,2
	              pl_dim(i,j) = cr_dim(i,j)
	            enddo
	          enddo
	        elseif(ianz.eq.3) then
	          cdum = cpara(1)(1:1)
	          cpara(1) = '0.0'
	          lpara(1) = 3
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            if    (cdum.eq.'x') then
	              pl_dim(1,1) = werte(2)
	              pl_dim(1,2) = werte(3)
	            elseif(cdum.eq.'y') then
	              pl_dim(2,1) = werte(2)
	              pl_dim(2,2) = werte(3)
	            elseif(cdum.eq.'z') then
	              pl_dim(3,1) = werte(2)
	              pl_dim(3,2) = werte(3)
	            else
	              ier_num = -6
	              ier_typ = ER_COMM
	            endif
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----help 'help','?'
c
	    elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	           str_comp(befehl,'?   ',1,lbef,4)     ) then
	      if(str_comp(zeile,'errors',2,lp,6) ) then
	        lp = lp + 7
	        call do_hel('discus '//zeile,lp)
	      else
	        lp = lp + 12
	        call do_hel('discus plot '//zeile,lp)
	      endif
c
c------	----Select the reciprocal space direction normal to plot slice 'hkl'
c
	    elseif(str_comp(befehl,'hkl',2,lbef,3)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            pl_hkl(i) = werte(i)
	          enddo
	          call trans(pl_hkl,cr_rten,pl_uvw,3)
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Define output of complete molecules/only origin
c
	    elseif(str_comp(befehl,'mole',2,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if (ier_num.eq.0) then
	        if (ianz.eq.1) then
	          call do_cap(cpara(1))
	          pl_mol_all=(cpara(1)(1:1).eq.'A')
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----Select the ordinate for a projection onto a to plot slice 'ordi'
c
	    elseif(str_comp(befehl,'ordi',2,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            pl_ord(i) = werte(i)
	          enddo
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ define name of output file 'outf'
c
	    elseif(str_comp(befehl,'outf',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
                call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	        if(ier_num.eq.0) then
	          pl_out=cpara(1)
	        endif
	      endif
c
c------	----Select plotting program 'prog'
c
	    elseif(str_comp(befehl,'prog',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.1) then
	        call do_cap(cpara(1))
	        if    (cpara(1)(1:1).eq.'K') then
	          pl_prog = 'kupl'
	        elseif(cpara(1)(1:1).eq.'G') then
	          pl_prog = 'gnuplot'
	        elseif(cpara(1)(1:1).eq.'A') then
	          pl_prog = 'atoms'
	        elseif(cpara(1)(1:1).eq.'X') then
	          pl_prog = 'xbs'
	        elseif(cpara(1)(1:1).eq.'D') then
	          pl_prog = 'diamond'
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----run plot 'run'
c
	    elseif(str_comp(befehl,'run',1,lbef,3)) then
	      if(pl_out.ne.' ') then
	        if(.not. (pl_dim(1,1).eq.pl_dim(1,2) .and. 
     &	                  pl_dim(2,1).eq.pl_dim(2,2) .and. 
     &	                  pl_dim(3,1).eq.pl_dim(3,2) )) then
	          l_select = .false.
	          do i=0,cr_nscat
	            if(pl_latom(i)) then
	              l_select = .true.
	            endif
	          enddo
	          if(l_select) then
	            call do_plot
	          else
	            ier_num = -3
	            ier_typ = ER_APPL
	          endif
	        else
	          ier_num = -4
	          ier_typ = ER_APPL
	        endif
	      else
	        ier_num = -37
	        ier_typ = ER_APPL
	      endif
c
c------	----set atom representation for KUPLOT
c
	    elseif(str_comp(befehl,'set',3,lbef,3)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if (ier_num.eq.0) then
	        if (ianz.eq.4 .or. ianz.eq.6) then
c
c------	----------store 1. parameter for later analysis
c
	          line = cpara(1)
	          lp   = lpara(1)
	          cpara(1) = '0'
	          lpara(1) = 1
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            it=nint(werte(2))
	            ic=nint(werte(3))
	            if(ianz.eq.4) then
	              rr=     werte(3)
	              rg=     werte(3)
	              rb=     werte(3)
	            elseif(ianz.eq.6) then
	              rr=     werte(3)
	              rg=     werte(4)
	              rb=     werte(5)
	            endif
	            if((ic.gt.0 .and. ic.le.15 .and. 
     &	                it.gt.0 .and. it.le.12      ).or.
     &	                pl_prog.eq.'xbs'                  ) then
	              size=werte(ianz)
c
c------	--------------Now analyse the atom name/type
c
	              cpara(1) = line
	              lpara(1) = 1
	              ianz     = 1
	              call get_iscat(ianz,cpara,lpara,werte,maxw,lold)
	              if(nint(werte(1)).eq.-1) then
	                do is=1,cr_nscat
	                  pl_typ(is)   = it
	                  pl_color(is) = ic
	                  pl_siz(is)   = size
	                  pl_rgb(1,is) = rr
	                  pl_rgb(2,is) = rg
	                  pl_rgb(3,is) = rb
	                enddo
	              else
	                do i=1,ianz
	                  is = nint(werte(i))
	                  pl_typ(is)   = it
	                  pl_color(is) = ic
	                  pl_siz(is)   = size
	                  pl_rgb(1,is) = rr
	                  pl_rgb(2,is) = rg
	                  pl_rgb(3,is) = rb
	                enddo
	              endif
	            else
	              ier_num = -59
	              ier_typ = ER_APPL
	            endif
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----show current parameters 'show'
c
	    elseif(str_comp(befehl,'show',2,lbef,4)) then
	      call plot_show
c
c------	----Thickness of the plot slice in Angstroem 'thickness'
c
	    elseif(str_comp(befehl,'thic',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.1) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          pl_width  = werte(1)
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Select the direct space direction normal to plot slice 'uvw'
c
	    elseif(str_comp(befehl,'uvw',1,lbef,3)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            pl_uvw(i) = werte(i)
	          enddo
	          call trans(pl_uvw,cr_gten,pl_hkl,3)
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Select a point in direct space within the plot slice 'vec'
c
	    elseif(str_comp(befehl,'vect',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            pl_vec(i) = werte(i)
	          enddo
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c-----  ------Operating System Kommandos 'syst'
c
	    elseif(str_comp(befehl,'syst',2,lbef,4)) then
	      if(zeile.ne. ' ') then
	        call do_operating(zeile,lp)
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----set typ of output
c
	    elseif(str_comp(befehl,'type',2,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if (ier_num.eq.0) then
	        if (ianz.eq.1) then
	          call do_cap(cpara(1))
	          pl_dens=(cpara(1)(1:1).eq.'P')
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------  -----waiting for user input
c
	    elseif(str_comp(befehl,'wait',3,lbef,4)) then
	      call do_input(zeile,lp)
c
	    else
	      ier_num = -8
	      ier_typ = ER_COMM
	    endif
	    endif
	  endif
	  endif
c
	  if(ier_num.ne.0) then
	    call errlist
	    if(lmakro) then
	      call macro_close
	      prompt_status = PROMPT_ON
	    endif
	    if(lblock) then
	      ier_num = -11
	      ier_typ = ER_COMM
	      return
	    endif
	    call no_error
	  endif
	enddo
c
9999	continue
c
	end
c*****7*****************************************************************
	subroutine plot_show
c
	implicit      	none
c
	include 	'config.inc'
	include 	'prompt.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'molecule.inc'
	include 	'microsta.inc'
	include 	'errlist.inc'
	include 	'plot.inc'
c
	character*9	at_name,at_name_i
	integer		i,j
	logical         lspace
	real            null(3),w_na,w_no,w_ao,aver
	real            u(3),w(3),angl,b_a,b_o
c
	real            do_bang,do_blen
c
	lspace = .true.
	null(1)=0.0
	null(2)=0.0
	null(3)=0.0
c
	write (output_io,3000) pl_prog
	write (output_io,3005) pl_out
	if (pl_dens) then
	  write (output_io,3007) 'projection in single unit cell'
	else
	  write (output_io,3007) 'crystal'
	endif
	write (output_io,3010) ((pl_dim(i,j),j=1,2),i=1,3)
	write (output_io,3020) pl_col
	write (output_io,3021) pl_hkl
	write (output_io,3022) pl_uvw
c
	if(do_blen(lspace,null,pl_uvw).ne.0.0) then
c
c------	--A slice is to be plottet normal to a vector
c
	  write (output_io,3025) pl_abs
	  write (output_io,3026) pl_ord
	  w_na = do_bang(lspace,pl_uvw,null,pl_abs)
	  w_no = do_bang(lspace,pl_uvw,null,pl_ord)
	  w_ao = do_bang(lspace,pl_abs,null,pl_ord)
	  write (output_io,3027) w_na,w_no,w_ao
c
c------	--Make sure that none of the abscissa or ordinate are zero
c
	  b_o  = do_blen(lspace,null,pl_ord)
	  if(b_o.eq.0) then
	    ier_msg(1) = 'length of ordinate is zero'
	    ier_num = -32
	    ier_typ = ER_APPL
	    return
	  endif
	  b_a  = do_blen(lspace,null,pl_abs)
	  if(b_a.eq.0) then
	    ier_msg(1) = 'length of abscissa is zero'
	    ier_num = -32
	    ier_typ = ER_APPL
	    return
	  endif
c
c------	--Determine correct ratio for the plot. Depends on pl_col
c
	  if(pl_col(2:2).eq.'x') then
	    u(1) = pl_abs(1)
	    u(2) = pl_abs(2)
	    u(3) = pl_abs(3)
	  elseif(pl_col(2:2).eq.'y') then
	    u(1) = pl_ord(1)
	    u(2) = pl_ord(2)
	    u(3) = pl_ord(3)
	  elseif(pl_col(2:2).eq.'z') then
	    u(1) = pl_uvw(1)
	    u(2) = pl_uvw(2)
	    u(3) = pl_uvw(3)
	  endif
	  b_o = do_blen(lspace,null,u)
	  if(pl_col(1:1).eq.'x') then
	    w(1) = pl_abs(1)
	    w(2) = pl_abs(2)
	    w(3) = pl_abs(3)
	  elseif(pl_col(1:1).eq.'y') then
	    w(1) = pl_ord(1)
	    w(2) = pl_ord(2)
	    w(3) = pl_ord(3)
	  elseif(pl_col(1:1).eq.'z') then
	    w(1) = pl_uvw(1)
	    w(2) = pl_uvw(2)
	    w(3) = pl_uvw(3)
	  endif
	  b_a = do_blen(lspace,null,w)
	  aver = b_o/b_a
	  angl = do_bang(lspace,u,null,w)
	  write (output_io,3028) aver
	  write (output_io,3029) angl
	else
c
c------	--Projection onto xy, yz or zx plane
c
	  if(pl_col(2:2).eq.'x') then
	    u(1) = 1.0
	    u(2) = 0.0
	    u(3) = 0.0
	  elseif(pl_col(2:2).eq.'y') then
	    u(1) = 0.0
	    u(2) = 1.0
	    u(3) = 0.0
	  elseif(pl_col(2:2).eq.'z') then
	    u(1) = 0.0
	    u(2) = 0.0
	    u(3) = 1.0
	  endif
	  b_o  = do_blen(lspace,null,u)
	  if(pl_col(1:1).eq.'x') then
	    w(1) = 1.0
	    w(2) = 0.0
	    w(3) = 0.0
	  elseif(pl_col(1:1).eq.'y') then
	    w(1) = 0.0
	    w(2) = 1.0
	    w(3) = 0.0
	  elseif(pl_col(1:1).eq.'z') then
	    w(1) = 0.0
	    w(2) = 0.0
	    w(3) = 1.0
	  endif
	  b_a  = do_blen(lspace,null,w)
	  aver = b_o/b_a
	  angl = do_bang(lspace,u,null,w)
	  write (output_io,3028) aver
	  write (output_io,3029) angl
	endif
	write (output_io,3023) pl_vec
	write (output_io,3024) pl_width
	write (output_io,3030) cmic_s(pl_md_s)
	if(pl_md_s.eq.MD_S_IND) then
	  write (output_io,3040) pl_md_nr
	endif
c
	if (pl_sel_atom) then
	  write (output_io,3050)
	  do i=0,cr_nscat
	    if(pl_latom(i)) then
	      at_name_i = at_name(i)
	      write (output_io,3060) i,at_name_i,pl_typ(i),pl_color(i),
     &	                    pl_siz(i)
	    endif
	  enddo
	else
	  if (pl_mol_all) then
	    write (output_io,3065) 'All atoms in molecule'
	  else
	    write (output_io,3065) 'Origin of molecule only'
	  endif
	  write (output_io,3070)
	  do i=1,mole_num_type
	    if(pl_latom(i)) then
	      write (output_io,3080) i,pl_typ(i),pl_color(i),pl_siz(i)
	    endif
	  enddo
	endif
c
3000	format(' Plotting Program        : ',a)
3005	format(' Output file             : ',a)
3007	format(' Output type             : ',a)
3010	format(/' Extend of Crystal       : '/
     &	       ' Xmin, Xmax              : ',2(f8.3)/
     &	       ' Ymin, Ymax              : ',2(f8.3)/
     &	       ' Zmin, Zmax              : ',2(f8.3))
3020	format(' Sequence of coordinates : ',a)
3021	format(/' HKL of Normal           : ',3(f8.3))
3022	format(' UVW of Normal           : ',3(f8.3))
3025	format(/' Abscissa of slice       : ',3(f8.3))
3026	format(' Ordinate of slice       : ',3(f8.3))
3027	format(' <(N,A), <(N,O), <(A,O)  : ',3(f8.3))
3028	format(' Aver v/h for KUPLOT     : ', (f8.3))
3029	format(' Angle                   : ', (f8.3),' degrees')
3023	format(/' Point in plot slice     :  ',3(f8.3))
3024	format(' Half thickness of slice : ',  f9.3,' Angstroem' )
3030	format(/' Select status           : ',a)
3040	format(26x,i4)
3050	format(' Selected atoms          : ',
     &	       '  #  name       mtyp  color  size ')
3065	format(' Plotting status         : ',a)
3060	format(27x,i3,2x,a9,3x,i2,4x,i2,2x,f6.2)
3070	format(' Selected molecules      : ',
     &	       '  #   mtyp  color  size ')
3080	format(27x,i3,4x,i2,4x,i2,2x,f6.2)
	end
c*****7*****************************************************************
	subroutine do_plot
c
	implicit      	none
c
	integer       	iff
	parameter    	(iff=2)
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
	include 	'plot.inc'
c
	logical      	lread
c
	lread = .false.
	call oeffne(iff,pl_out,'unknown',lread)
	if(ier_num.ne.0) return
c
c------ Output program KUPLOT or GNUPLOT
c
	if(pl_prog.eq.'kupl' .or. pl_prog.eq.'gnuplot') then
c
c------ - Atom or molecule mode
c
	  if (pl_sel_atom) then
	    call plot_kuplot(iff,(pl_prog.eq.'kupl'))
	  else
	    call plot_kuplot_mol(iff,(pl_prog.eq.'kupl'))
	  endif
c
c------ Output ATOMS
c
	elseif (pl_prog.eq.'atoms') then
c
c------ - Atom or molecule mode
c
	  if (pl_sel_atom) then
	    call plot_atoms(iff)
	  else
	    ier_num = -76
	    ier_typ = ER_APPL
	  endif
c
c------ Output XBS
c
	elseif (pl_prog.eq.'xbs') then
c
c------ - Atom or molecule mode
c
	  if (pl_sel_atom) then
	    call plot_xbs(iff)
	  else
	    ier_num = -76
	    ier_typ = ER_APPL
	  endif
c
c------ Output DIAMOND
c
	elseif (pl_prog.eq.'diamond') then
c
c------ - Atom or molecule mode
c
	  if (pl_sel_atom) then
	    call plot_diamond(iff)
	  else
	    ier_num = -76
	    ier_typ = ER_APPL
	  endif
	endif
c
	close(iff)
c
	end
c*****7*****************************************************************
	subroutine plot_atoms(iff)
c-
c	Writes the selected atoms for plotting with ATOMS
c+
	implicit      	none
c
	integer         idim
	parameter      (idim=3)
c
	include 	'config.inc'
	include 	'crystal.inc'
	include		'crystal.cmm'
	include 	'microdis.inc'
	include 	'plot.inc'
	include 	'wink.inc'
	include 	'microsta.inc'
	include 	'errlist.inc'
c
	real         	d,dist,fac
	real         	v(3)
	integer      	i,j,iff
	logical      	lno_slice,latom
c
	integer		len_str
	real         	skalpro
c
	write (iff, 500) cr_name(1:len_str(cr_name))
	write (iff, 510) (cr_a0(i)*cr_icc(i),i=1,3),(cr_win(i),i=1,3)
	write (iff, 520) 'P1'
	write (iff, 530)
c
	latom = .false.
	fac = 1.0 / (8.0*pi**2)
c
	if(pl_hkl(1).eq.0.and.pl_hkl(2).eq.0.and.pl_hkl(3).eq.0) then
	  lno_slice = .true.
	  d         = 1.0
	else
	  lno_slice = .false.
	  d         = sqrt(skalpro(pl_uvw,pl_uvw,cr_gten))
	  do j=1,3
	    pl_mat(j,1) = pl_abs(j)
	    pl_mat(j,2) = pl_ord(j)
	    pl_mat(j,3) = pl_uvw(j)
	  enddo
	  call invmat(pl_inv,pl_mat)
	  if(ier_num.eq.-1) then
	    return
	  endif
	endif
c
	do i=1,cr_natoms
c
c------	--Select atom if:
c	  type has been selected and
c	       all atoms are selected                            or
c	       all microdomains have been selected               or
c	       a specific microdomain type has been selected     or
c	       microdomains are deselected and atom is outside
c
	  if(pl_latom(cr_iscat(i)) .and. 
     &	     ( pl_md_s.eq.MD_S_EVE                                 .or.
     &	       pl_md_s.eq.MD_S_ALL .and. cr_md_next(i).lt.0        .or.
     &	       pl_md_s.eq.MD_S_IND .and. cr_md_next(i).lt.0 .and.
     &                    mc_type(-cr_md_next(i)).eq.pl_md_nr      .or.
     &	       pl_md_s.eq.MD_S_NON .and. pl_md_nr.eq.0      .and.
     &	                           cr_md_next(i).ge.0      )  ) then
c
c------	--Check dimensions of plotting space
c
	    if(pl_dim(1,1) .le. cr_pos(1,i) .and.
     &	       cr_pos(1,i) .le. pl_dim(1,2) .and.
     &	       pl_dim(2,1) .le. cr_pos(2,i) .and.
     &	       cr_pos(2,i) .le. pl_dim(2,2) .and.
     &	       pl_dim(3,1) .le. cr_pos(3,i) .and.
     &	       cr_pos(3,i) .le. pl_dim(3,2)       ) then
c
c------	------Determine distance to point in plot slice
c
	      do j=1,3
	        v(j) = cr_pos(j,i) - pl_vec(j)
	      enddo
	      dist = abs(skalpro(pl_uvw,v,cr_gten))/d
c
c------	------Write atom if inside slice or if slice has been deselected
c
	      if(dist.le.pl_width .or. lno_slice) then
c
c------	------write atom position or projection onto abscissa/ordinate
c
	        do j=1,3
	          v(j) = cr_pos(j,i)
	        enddo
c
c------	------Write atom position in desired sequence of coordinates
c
	        latom = .true.
	        write(iff,1000) cr_at_lis(cr_iscat(i)),cr_iscat(i),
     &	                        (v(j)/cr_icc(j),j=1,3),
     &	                        fac*cr_dw(cr_iscat(i)),
     &	                        0.0,0.0,0.0,0.0,0.0
	      endif
	    endif
	  endif
	enddo
c
	if (.not. latom) then
	  ier_num = -58
	  ier_typ = ER_APPL
	endif
c
500	format ('TITL ',a)
510	format ('CELL ',6(f10.6,1x))
520	format ('SPGP ',a)
530	format ('FIELDS LAB TYP COO TFU')
1000	format (a4,1x,i4,3x,3(f11.6,1x),/,6(f8.6,1x))
	end
c*****7*****************************************************************
	subroutine plot_kuplot(iff,lkupl)
c-
c	Writes the selected atoms in a format suitable for plotting 
c	using KUPLOT or GNUPLOT
c+
	implicit      	none
c
	integer         idim
	parameter      (idim=3)
c
	include 	'config.inc'
	include 	'crystal.inc'
	include		'crystal.cmm'
	include 	'microdis.inc'
	include 	'plot.inc'
	include 	'microsta.inc'
	include 	'errlist.inc'
c
	real         	d,dist,ps
	real         	v(3),u(3)
	integer      	i,j,iff,pt,pc
	logical      	lno_slice,latom,lkupl
c
	real         	skalpro
c
	latom = .false.
	if(pl_hkl(1).eq.0.and.pl_hkl(2).eq.0.and.pl_hkl(3).eq.0) then
	  lno_slice = .true.
	  d         = 1.0
	else
	  lno_slice = .false.
	  d         = sqrt(skalpro(pl_uvw,pl_uvw,cr_gten))
	  do j=1,3
	    pl_mat(j,1) = pl_abs(j)
	    pl_mat(j,2) = pl_ord(j)
	    pl_mat(j,3) = pl_uvw(j)
	  enddo
	  call invmat(pl_inv,pl_mat)
	  if(ier_num.eq.-1) then
	    return
	  endif
	endif
c
	do i=1,cr_natoms
c
c------	--Select atom if:
c	  type has been selected and
c	       all atoms are selected                            or
c	       all microdomains have been selected               or
c	       a specific microdomain type has been selected     or
c	       microdomains are deselected and atom is outside
c
	  if(pl_latom(cr_iscat(i)) .and. 
     &	     ( pl_md_s.eq.MD_S_EVE                                 .or.
     &	       pl_md_s.eq.MD_S_ALL .and. cr_md_next(i).lt.0        .or.
     &	       pl_md_s.eq.MD_S_IND .and. cr_md_next(i).lt.0 .and.
     &                    mc_type(-cr_md_next(i)).eq.pl_md_nr      .or.
     &	       pl_md_s.eq.MD_S_NON .and. pl_md_nr.eq.0      .and.
     &	                           cr_md_next(i).ge.0      )  ) then
c
c------	--Check dimensions of plotting space
c
	    if(pl_dim(1,1) .le. cr_pos(1,i) .and.
     &	       cr_pos(1,i) .le. pl_dim(1,2) .and.
     &	       pl_dim(2,1) .le. cr_pos(2,i) .and.
     &	       cr_pos(2,i) .le. pl_dim(2,2) .and.
     &	       pl_dim(3,1) .le. cr_pos(3,i) .and.
     &	       cr_pos(3,i) .le. pl_dim(3,2)       ) then
c
c------	------Determine distance to point in plot slice
c
	      do j=1,3
	        v(j) = cr_pos(j,i) - pl_vec(j)
	      enddo
	      dist = abs(skalpro(pl_uvw,v,cr_gten))/d
c
c------	------Write atom if inside slice or if slice has been deselected
c
	      if(dist.le.pl_width .or. lno_slice) then
c
c------	------write atom position or projection onto abscissa/ordinate
c
	        if(lno_slice) then
	          do j=1,3
	            v(j) = cr_pos(j,i)
	          enddo
	        else
	          do j=1,3
	            u(j) = cr_pos(j,i)
	          enddo
	          call trans(u,pl_inv,v,idim)
	        endif
c
c------	------Write atom position in desired sequence of coordinates
c
	        latom = .true.
	        pt    = pl_typ  (cr_iscat(i))
	        pc    = pl_color(cr_iscat(i))
	        ps    = pl_siz  (cr_iscat(i))
c
	        if    (pl_col.eq.'xyz') then
	          call write_atom(lkupl,iff,i,v(1),v(2),v(3),
     &	                               pt,pc,ps)
	        elseif(pl_col.eq.'yzx') then
	          call write_atom(lkupl,iff,i,v(2),v(3),v(1),
     &	                               pt,pc,ps)
	        elseif(pl_col.eq.'zxy') then
	          call write_atom(lkupl,iff,i,v(3),v(1),v(2),
     &	                               pt,pc,ps)
	        elseif(pl_col.eq.'zyx') then
	          call write_atom(lkupl,iff,i,v(3),v(2),v(1),
     &	                               pt,pc,ps)
	        elseif(pl_col.eq.'yxz') then
	          call write_atom(lkupl,iff,i,v(2),v(1),v(3),
     &	                               pt,pc,ps)
	        elseif(pl_col.eq.'xzy') then
	          call write_atom(lkupl,iff,i,v(1),v(3),v(2),
     &	                               pt,pc,ps)
	        endif
	      endif
	    endif
	  endif
	enddo
c
	if (.not. latom) then
	  ier_num = -58
	  ier_typ = ER_APPL
	endif
c
	end
c*****7*****************************************************************
	subroutine plot_kuplot_mol(iff,lkupl)
c-
c	Writes the selected molecules in a format suitable 
c	for plotting using KUPLOT or GNUPLOT
c+
	implicit      	none
c
	integer         idim
	parameter      (idim=3)
c
	include 	'config.inc'
	include 	'crystal.inc'
	include		'crystal.cmm'
	include 	'microdis.inc'
	include 	'plot.inc'
	include 	'microsta.inc'
	include 	'molecule.inc'
	include 	'errlist.inc'
c
	real         	d,dist,ps
	real         	v(3),u(3)
	integer      	i,j,k,i0,iff,pt,pc
	integer		i_start,i_end,imol
	logical      	lno_slice,latom,lkupl
c
	real         	skalpro
c
	latom = .false.
	if(pl_hkl(1).eq.0.and.pl_hkl(2).eq.0.and.pl_hkl(3).eq.0) then
	  lno_slice = .true.
	  d         = 1.0
	else
	  lno_slice = .false.
	  d         = sqrt(skalpro(pl_uvw,pl_uvw,cr_gten))
	  do j=1,3
	    pl_mat(j,1) = pl_abs(j)
	    pl_mat(j,2) = pl_ord(j)
	    pl_mat(j,3) = pl_uvw(j)
	  enddo
	  call invmat(pl_inv,pl_mat)
	  if(ier_num.eq.-1) then
	    return
	  endif
	endif
c
	do i=1,mole_num_mole
c
c------	--Select molecule if:
c	  type has been selected and
c	       all molecules are selected                        or
c	       all microdomains have been selected               or
c	       a specific microdomain type has been selected     or
c	       microdomains are desel. and molecule is outside
c
	  if(pl_latom(mole_type(i)) .and. 
     &	     ( pl_md_s.eq.MD_S_EVE                                 .or.
     &	       pl_md_s.eq.MD_S_ALL .and. cr_md_next(i).lt.0        .or.
     &	       pl_md_s.eq.MD_S_IND .and. cr_md_next(i).lt.0 .and.
     &                    mc_type(-cr_md_next(i)).eq.pl_md_nr      .or.
     &	       pl_md_s.eq.MD_S_NON .and. pl_md_nr.eq.0      .and.
     &	                           cr_md_next(i).ge.0      )  ) then
c
c------	--Check dimensions of plotting space
c
	    i0 = mole_cont(mole_off(i)+1)
	    if(pl_dim(1, 1) .le. cr_pos(1,i0) .and.
     &	       cr_pos(1,i0) .le. pl_dim(1, 2) .and.
     &	       pl_dim(2, 1) .le. cr_pos(2,i0) .and.
     &	       cr_pos(2,i0) .le. pl_dim(2, 2) .and.
     &	       pl_dim(3, 1) .le. cr_pos(3,i0) .and.
     &	       cr_pos(3,i0) .le. pl_dim(3, 2)       ) then
c
c------	------Determine distance to point in plot slice
c------ ------This is done only for the molecules origin
c
	      do j=1,3
	        v(j) = cr_pos(j,i0) - pl_vec(j)
	      enddo
	      dist = abs(skalpro(pl_uvw,v,cr_gten))/d
c
c------	------Write atom if inside slice or if slice has been deselected
c
	      if(dist.le.pl_width .or. lno_slice) then
c
c------	------Write atom position in desired sequence of coordinates
c
	        latom = .true.
	        pt    = pl_typ  (mole_type(i))
	        pc    = pl_color(mole_type(i))
	        ps    = pl_siz  (mole_type(i))
c
	        if (pl_mol_all) then
	          i_start = 1
	          i_end   = mole_len(i)
	        else
	          i_start = 1
	          i_end   = 1
	        endif
c
	        do imol=i_start,i_end
	          j = mole_cont(mole_off(i)+imol)
c
c------	------write atom position or projection onto abscissa/ordinate
c
	          if(lno_slice) then
	            do k=1,3
	              v(k) = cr_pos(k,j)
	            enddo
	          else
	            do k=1,3
	              u(k) = cr_pos(k,j)
	            enddo
	            call trans(u,pl_inv,v,idim)
	          endif
	          if    (pl_col.eq.'xyz') then
	            call write_atom(lkupl,iff,j,v(1),
     &	                            v(2),v(3),pt,pc,ps)
	          elseif(pl_col.eq.'yzx') then
	            call write_atom(lkupl,iff,j,v(2),
     &	                            v(3),v(1),pt,pc,ps)
	          elseif(pl_col.eq.'zxy') then
	            call write_atom(lkupl,iff,j,v(3),
     &	                            v(1),v(2),pt,pc,ps)
	          elseif(pl_col.eq.'zyx') then
	            call write_atom(lkupl,iff,j,v(3),
     &	                            v(2),v(1),pt,pc,ps)
	          elseif(pl_col.eq.'yxz') then
	            call write_atom(lkupl,iff,j,v(2),
     &	                            v(1),v(3),pt,pc,ps)
	          elseif(pl_col.eq.'xzy') then
	            call write_atom(lkupl,iff,j,v(1),
     &	                            v(3),v(2),pt,pc,ps)
	          endif
	        enddo
	      endif
	    endif
	  endif
	enddo
c
	if (.not. latom) then
	  ier_num = -58
	  ier_typ = ER_APPL
	endif
c
	end
c*****7*****************************************************************
	subroutine write_atom(lkupl,iff,iatom,x,y,z,pt,pc,ps)
c
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'plot.inc'
c
	real		x,y,z,ps
	integer*4	cr_end
	integer		i,pt,pc,iff,iatom,isite,icell(3)
	logical		lkupl
c
	cr_end = cr_ncatoms*cr_icc(1)*cr_icc(2)*cr_icc(3) + 1
c
	if (pl_dens) then
	  if (iatom.lt.cr_end) then
	    call indextocell(iatom,icell,isite)
	  else
	    do i=1,3
	      icell(i) = int(cr_pos(i,iatom) - cr_dim0(i,1)) + 1
	    enddo
	  endif
	  x=x-float(icell(1)-1)-cr_dim0(1,1)
	  y=y-float(icell(2)-1)-cr_dim0(2,1)
	  z=z-float(icell(3)-1)-cr_dim0(3,1)
	endif
c
	if (lkupl) then
	  write (iff,1000) x,y,z,pt,pc,ps
	else
	  write (iff,2000) x,y,z
	endif
c
1000    format(3(2x,f12.6),2(2x,i2),2x,f6.2)
2000    format(3(2x,f12.6))
	end
c*****7*****************************************************************
	subroutine plot_xbs(iff,lkupl)
c-
c	Writes the selected atoms in a format suitable for plotting 
c	using xbs
c+
	implicit      	none
c
	integer         idim
	parameter      (idim=3)
c
	include 	'config.inc'
	include 	'crystal.inc'
	include		'crystal.cmm'
	include 	'microdis.inc'
	include 	'microsta.inc'
	include 	'plot.inc'
	include 	'param.inc'
	include 	'errlist.inc'
c
	character*200	zeile
	integer		laenge
	integer      	i,j,k,iff
	logical      	latom,lkupl,lspace
	logical		lscreen
	real		uvw(4)
	real		absz(3)
	real		xmin(3),xmax(3),null(3)
	real		xx
c
	real         	do_bang
	real         	do_blen
	real         	skalpro
c
	data	lscreen/.false./
	data	lspace/.true./
	data	null/0.0,0.0,0.0/
c
	call plot_ini_trans
c
	latom = .false.
	uvw(4) = 1.0
	do j= 1,3
	  xmin(j)   = 0.0
	  xmax(j)   = 0.0
	enddo
	xx = 0.0
c
	do i=1,cr_natoms
c
c------	--Select atom if:
c	  type has been selected and
c	       all atoms are selected                            or
c	       all microdomains have been selected               or
c	       a specific microdomain type has been selected     or
c	       microdomains are deselected and atom is outside
c
	  if(pl_latom(cr_iscat(i)) .and. 
     &	     ( pl_md_s.eq.MD_S_EVE                                 .or.
     &	       pl_md_s.eq.MD_S_ALL .and. cr_md_next(i).lt.0        .or.
     &	       pl_md_s.eq.MD_S_IND .and. cr_md_next(i).lt.0 .and.
     &                    mc_type(-cr_md_next(i)).eq.pl_md_nr      .or.
     &	       pl_md_s.eq.MD_S_NON .and. pl_md_nr.eq.0      .and.
     &	                           cr_md_next(i).ge.0      )  ) then
c
c------	--Check dimensions of plotting space
c
	    if(pl_dim(1,1) .le. cr_pos(1,i) .and.
     &	       cr_pos(1,i) .le. pl_dim(1,2) .and.
     &	       pl_dim(2,1) .le. cr_pos(2,i) .and.
     &	       cr_pos(2,i) .le. pl_dim(2,2) .and.
     &	       pl_dim(3,1) .le. cr_pos(3,i) .and.
     &	       cr_pos(3,i) .le. pl_dim(3,2)       ) then
c
c------	------write atom position 
c
	       latom = .true.
	       do j=1,3
	         uvw(j) = cr_pos(j,i)
	       enddo
	       call tran_ca(uvw,pl_tran_f ,lscreen)
	       do j=1,3
	         xmin(j) = min(xmin(j),uvw(j))
	         xmax(j) = max(xmax(j),uvw(j))
	       enddo
	       write(iff,2100) cr_at_lis(cr_iscat(i)),(uvw(j),j=1,3)
	    endif
	  endif
	enddo
c
c------	determine scale
c
	xx = max(abs(xmax(1)-xmin(1)),abs(xmax(2)-xmin(1)),
     &	         abs(xmax(3)-xmin(1)))
	pl_scale = 200./xx
c
c------	write Atom specifications
c
	write(iff,*)
	do i=0,cr_nscat
	  if(pl_latom(i)) then
	    write(iff,2200) cr_at_lis(i),pl_siz(i),(pl_rgb(j,i),j=1,3)
	  endif
	enddo
c
c------	Check that normal and asbzissa are not parallel
c
	xx = do_bang(lspace,pl_uvw,null,pl_abs)
	if(xx.eq.0.0) then
	  ier_num = -80
	  ier_typ = ER_APPL
	  return
	endif
c
	write(zeile,1000) pl_abs,pl_uvw
	laenge = 82
	call do_proj(zeile,laenge)
	absz(1) = res_para(4)
	absz(2) = res_para(5)
	absz(3) = res_para(6)
c
	xx = do_blen(lspace,pl_uvw,null)
	if(xx.eq.0.0) then
	  ier_num = -32
	  ier_typ = ER_APPL
	  return
	endif
	do j=1,3
	  uvw(j) = pl_uvw(j)/xx
	enddo
	call tran_ca(uvw,pl_tran_f ,lscreen)
	do j=1,3
	  pl_tran_gi(3,j) = uvw(j)
	enddo
c
	xx = do_blen(lspace,absz,null)
	if(xx.eq.0.0) then
	  ier_num = -32
	  ier_typ = ER_APPL
	  return
	endif
	do j=1,3
	  uvw(j) = absz(j)/xx
	enddo
	call tran_ca(uvw,pl_tran_f ,lscreen)
	do j=1,3
	  pl_tran_gi(1,j) = uvw(j)
	enddo
	pl_tran_gi(2,1) = pl_tran_gi(3,2)*pl_tran_gi(1,3) - 
     &	                  pl_tran_gi(3,3)*pl_tran_gi(1,2)
	pl_tran_gi(2,2) = pl_tran_gi(3,3)*pl_tran_gi(1,1) - 
     &	                  pl_tran_gi(3,1)*pl_tran_gi(1,3)
	pl_tran_gi(2,3) = pl_tran_gi(3,1)*pl_tran_gi(1,2) - 
     &	                  pl_tran_gi(3,2)*pl_tran_gi(1,1)
c
	do i=1,4
	  do j=1,4
	    pl_tran_g (i,j) = pl_tran_gi(i,j)
	  enddo
	enddo
c
	call invmat4(pl_tran_g)
c
c------	write Bond types
c
	write(iff,*)
	do i=1,cr_nscat
	  do j=1,cr_nscat
	    if(pl_bond(i,j)) then
	      write(iff,2300) cr_at_lis(      i),
     &	                      cr_at_lis(      j),
     &	                      pl_bond_len(1,i,j),
     &	                      pl_bond_len(2,i,j),
     &	                      pl_bond_rad(  i,j),
     &	                     (pl_bond_col(k,i,j),k=1,3)
	    endif
	  enddo
	enddo
c
c------	write trailer, for right now a standard
c
	write(iff,*)
	write(iff,2400) ((pl_tran_g(i,j),i=1,3),j=1,3)
	write(iff,2500) 12.0
	write(iff,2600)  1.0
	write(iff,2700) pl_scale
	write(iff,2800)  1.0
	write(iff,2900)  1.0
	write(iff,3000)  0.00, 0.00
	write(iff,3100)  1,0,1,0,0,1,0,0,0
c
	if (.not. latom) then
	  ier_num = -58
	  ier_typ = ER_APPL
	endif
c
1000	format(6(f12.6,','),'dddd')
2000	format('*',a)
2100	format('atom      ',a4,3f11.3)
2200	format('spec      ',a4,f10.3,3f7.2)
2300	format('bonds     ',a4,4x,a4,6f9.3)
2400	format('tmat',9f7.3)
2500	format('dist   ',f7.3)
2600	format('inc    ',f7.3)
2700	format('scale  ',f7.3)
2800	format('rfac   ',f7.3)
2900	format('bfac   ',f7.3)
3000	format('pos    ',2f7.3)
3100	format('switches',9i2)
c
	end
c*****7*****************************************************************
	subroutine plot_diamond(iff,lkupl)
c-
c	Writes the selected atoms in a format suitable for plotting 
c	using diamond
c+
	implicit      	none
c
	integer         idim
	parameter      (idim=3)
c
	include 	'config.inc'
	include 	'crystal.inc'
	include		'crystal.cmm'
	include 	'microdis.inc'
	include 	'microsta.inc'
	include 	'plot.inc'
	include 	'errlist.inc'
c
	character*200	zeile
	integer		laenge
	integer      	i,j,iff
	logical      	latom,lkupl,lspace
	logical		lscreen
	real		uvw(4)
c
	data	lscreen/.false./
	data	lspace/.true./
c
	call plot_ini_trans
c
	latom = .false.
c
c------	Write number of atoms
c
	write(zeile,1000) cr_natoms
	laenge = 20
	call rem_bl(zeile,laenge)
	write(iff,1100) zeile(1:laenge)
c
c------	Write title
c
	write(iff,1100) cr_name
c
	do i=1,cr_natoms
c
c------	--Select atom if:
c	  type has been selected and
c	       all atoms are selected                            or
c	       all microdomains have been selected               or
c	       a specific microdomain type has been selected     or
c	       microdomains are deselected and atom is outside
c
	  if(pl_latom(cr_iscat(i)) .and. 
     &	     ( pl_md_s.eq.MD_S_EVE                                 .or.
     &	       pl_md_s.eq.MD_S_ALL .and. cr_md_next(i).lt.0        .or.
     &	       pl_md_s.eq.MD_S_IND .and. cr_md_next(i).lt.0 .and.
     &                    mc_type(-cr_md_next(i)).eq.pl_md_nr      .or.
     &	       pl_md_s.eq.MD_S_NON .and. pl_md_nr.eq.0      .and.
     &	                           cr_md_next(i).ge.0      )  ) then
c
c------	--Check dimensions of plotting space
c
	    if(pl_dim(1,1) .le. cr_pos(1,i) .and.
     &	       cr_pos(1,i) .le. pl_dim(1,2) .and.
     &	       pl_dim(2,1) .le. cr_pos(2,i) .and.
     &	       cr_pos(2,i) .le. pl_dim(2,2) .and.
     &	       pl_dim(3,1) .le. cr_pos(3,i) .and.
     &	       cr_pos(3,i) .le. pl_dim(3,2)       ) then
c
c------	------write atom position 
c
	       latom = .true.
	       do j=1,3
	         uvw(j) = cr_pos(j,i)
	       enddo
	       call tran_ca(uvw,pl_tran_f ,lscreen)
	       write(iff,2100) cr_at_lis(cr_iscat(i)),(uvw(j),j=1,3)
	    endif
	  endif
	enddo
c
	if (.not. latom) then
	  ier_num = -58
	  ier_typ = ER_APPL
	endif
c
1000	format(i20)
1100	format(a)
2100	format(a4,3f11.3)
c
	end
c*****7*****************************************************************
	subroutine plot_ini_trans
c-
c	Initializes the transformation matrix to cartesian coordinates
c+
	implicit      	none
c
	integer         idim
	parameter      (idim=3)
c
	include 	'config.inc'
	include 	'crystal.inc'
	include		'crystal.cmm'
	include 	'plot.inc'
	include 	'errlist.inc'
c
	integer      	i,j
	logical      	lspace
	real		dwert
	real		u(3),v(3),w(3),null(3)
c
	real         	do_blen
c
	data	null/0.0,0.0,0.0/
c
	lspace  = .true.
c
c------	cartesian b-axis is parallel to b, length = 1
c
	v(1) = 0.0
	v(2) = 1.0
	v(3) = 0.0
	dwert = do_blen(lspace,v,null)
	v(2) = v(2)/dwert
	pl_tran_g(2,1) = 0.0
	pl_tran_g(2,2) = v(2)
	pl_tran_g(2,3) = 0.0
c
c------	cartesian c-axis is parallel to c*, length = 1
c
	u(1) = 0.0
	u(2) = 0.0
	u(3) = 1.0
	call trans(u,cr_rten,w,3)
	dwert = do_blen(lspace,w,null)
	w(1) = w(1)/dwert
	w(2) = w(2)/dwert
	w(3) = w(3)/dwert
	pl_tran_g(3,1) = w(1)
	pl_tran_g(3,2) = w(2)
	pl_tran_g(3,3) = w(3)
c
c------	cartesian a-axis is parallel to vector product (b X c*)
c
	call vekprod(v,w,u,cr_eps,cr_rten)
	pl_tran_g(1,1) = u(1)
	pl_tran_g(1,2) = u(2)
	pl_tran_g(1,3) = u(3)
c
c------	calculate matrix for atom transformation
c
	do i=1,4
	  pl_tran_g(4,i) = 0.0
	  pl_tran_g(i,4) = 0.0
	  pl_tran_f(4,i) = 0.0
	  pl_tran_f(i,4) = 0.0
	enddo
	pl_tran_f(4,4) = 1.0
c
	do i=1,4
	  do j=1,4
	    pl_tran_gi(i,j) = pl_tran_g(i,j)
	  enddo
	enddo
c
	call invmat4(pl_tran_gi)
c
	do i=1,3
	  do j=1,3
	    pl_tran_f (j,i) = pl_tran_gi(i,j)
	  enddo
	enddo
CDBG	write (*,3010) ((pl_tran_g (i,j),j=1,3),i=1,3)
CDBG	write (*,3020) ((pl_tran_gi(i,j),j=1,3),i=1,3)
CDBG	write (*,3030) ((pl_tran_f (i,j),j=1,4),i=1,3)
c
3010	format(
     &	' ( a(new) ) = ( ',2(F9.5,','),f9.5,' )   ( a(old) )'/
     &	' ( b(new) ) = ( ',2(F9.5,','),f9.5,' ) * ( b(old) )'/
     &	' ( c(new) ) = ( ',2(F9.5,','),f9.5,' )   ( c(old) )'/)
3020	format(
     &	' ( a(old) ) = ( ',2(F9.5,','),f9.5,' )   ( a(new) )'/
     &	' ( b(old) ) = ( ',2(F9.5,','),f9.5,' ) * ( b(new) )'/
     &	' ( c(old) ) = ( ',2(F9.5,','),f9.5,' )   ( c(new) )'/)
3030	format(
     &	' ( x(new) ) = ( ',2(F9.5,','),f9.5,' )   ( x(old) )',
     &	'   (',f9.5,')'/
     &	' ( y(new) ) = ( ',2(F9.5,','),f9.5,' ) * ( y(old) )',
     &	' + (',f9.5,')'/
     &	' ( z(new) ) = ( ',2(F9.5,','),f9.5,' )   ( z(old) )',
     &	'   (',f9.5,')'/)
c
	end
c*****7*****************************************************************
