c+
c	Calculation of powder diffraction pattern.
c
c	Version : 3.0
c	Date    : 1 Apr 98
c
c	Author  : R.B. Neder  (reinhard.neder@mail.uni-wuerzburg.de)
c
C*****7*****************************************************************
	subroutine do_powder
c-
c	Main menu for powder diffraction pattern
c+
	implicit      none
c
	include       'config.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'doact.inc'
	include       'diffuse.inc'
	include       'errlist.inc'
	include       'learn.inc'
	include       'macro.inc'
	include       'prompt.inc'
	include       'powder.inc'
c
	integer        maxw
	parameter     (maxw=MAXSCAT)
	logical        lnew,lold
	parameter     (lnew=.true.,lold=.false.)
c
	character*5    befehl
	character*11   prom
	character*200  line,zeile,cpara(maxw)
	integer        lpara(maxw),lp,length,lbef
	integer        indxg,ianz,i,j
	logical        lend,lspace
	real           hkl(4)
	real           werte(maxw)
c
	logical        str_comp
c
	lend=.false.
	call no_error
c
	do while (.not. lend)
	  prom=prompt//'/powd'
	  call get_command (line,length,befehl,lbef,zeile,lp,prom)
	  if(ier_num.eq.0) then
	  if(line.ne.' ' .and. line(1:1).ne.'#') then
c
c------	----search for "="
c
	    indxg=index(line,'=')
	    if(indxg.ne.0 
     &	              .and. .not.(str_comp(befehl,'echo',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'syst',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'help',2,lbef,4) .or.
     &	                          str_comp(befehl,'?   ',2,lbef,4)) )then
c
c------	------evaluatean expression and assign the value to a variabble
c
	      call do_math(line,indxg,length)
	    else
c
c------ ----execute a macro file
c
            if(befehl(1:1).eq.'@') then
	      if(length.ge.2) then
	        call file_kdo(line(2:length),length-1)
	      else
	        ier_num = -13
	        ier_typ = ER_MAC
	      endif
c
c------	----list asymmetric unit 'asym'
c
	    elseif(str_comp(befehl,'asym',2,lbef,4)) then
	      call show_asym
c
c------	----continues a macro 'continue'
c
	    elseif(str_comp(befehl,'continue',2,lbef,8)) then
	      call macro_continue(zeile,lp)
c
c------	----list atoms present in the crystal 'chem'
c
	    elseif(str_comp(befehl,'chem',2,lbef,4)) then
	      call show_chem
c
c------ ----Echo a string, just for interactive check in a macro 'echo'
c
	    elseif(str_comp(befehl,'echo',2,lbef,4)) then
	      call echo(zeile,lp)
c
c------	 ---Evaluate an expression, just for interactive check 'eval'
c
	    elseif(str_comp(befehl,'eval',2,lbef,4)) then
	      call do_eval(zeile,lp)
c
c------	----exit 'exit'
c
	    elseif(str_comp(befehl,'exit',2,lbef,4)) then
	      lend=.true.
c
c------	----help 'help','?'
c
	    elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	           str_comp(befehl,'?   ',1,lbef,4)     ) then
	      if(str_comp(zeile,'errors',2,lp,6) ) then
	        lp = lp + 7
	        call do_hel('discus '//zeile,lp)
	      else
	        lp = lp + 12
	        call do_hel('discus powd '//zeile,lp)
	      endif
c
c------	switch to neutron diffraction 'neut'
c
	  elseif(str_comp(befehl,'neut',1,lbef,4)) then
	    lxray = .false.
c
c------	----run transformation 'run'
c
	    elseif(str_comp(befehl,'run ',1,lbef,4)) then
	      call dlink(lxray,ano,lambda,rlambda)
	      if(ier_num.eq.0) then
	        call powder_run
	      endif
c
c------	----show current parameters 'show'
c
	    elseif(str_comp(befehl,'show',2,lbef,4)) then
	      call dlink(lxray,ano,lambda,rlambda)
	      call pow_show
c
c------- -Set values 'set'
c
	  elseif(str_comp(befehl,'set',2,lbef,3)) then
	    call do_pow_set(zeile,lp)
c
c------- -Operating System Kommandos 'syst'
c
	  elseif(str_comp(befehl,'syst',2,lbef,4)) then
	    if(zeile.ne. ' ') then
	      call do_operating(zeile(1:lp),lp)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------  -----waiting for user input
c
	    elseif(str_comp(befehl,'wait',3,lbef,4)) then
	      call do_input(zeile,lp)
c
c------	switch to x-ray diffraction 'xray'
c
	  elseif(str_comp(befehl,'xray',1,lbef,4)) then
	    lxray = .true.
c
c------	------unknown command
c
	    else
	      ier_num = -8
	      ier_typ = ER_COMM
	    endif
	    endif
	  endif
	  endif
	  if(ier_num.ne.0) then
	    call errlist
	    if(lmakro) then
	      call macro_close
	      prompt_status = PROMPT_ON
	    endif
	    if(lblock) then
	      ier_num = -11
	      ier_typ = ER_COMM
	      return
	    endif
	    call no_error
	  endif
	enddo
c
9999	continue
c
	end
c*****7*****************************************************************
	subroutine  pow_show
c-
c	Prints summary of powder diffraction settings
c+
	implicit     none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'prompt.inc'
	include      'errlist.inc'
	include      'diffuse.inc'
	include      'powder.inc'
	include      'wink.inc'
c
	character*7     radiation
	character*14    cfour(0:1)
c
	real		hkl(3),h1,h2,dstar,ttheta
	real		del_tth_min(3)
	real		del_tth_max(3)
c
	real		skalpro
	real		asind
	real		cosd
	real         sind
c
	data cfour/'normal Fourier','Stacking fault'/
c
	write (output_io,1000)
c
	radiation = 'neutron'
	if (lxray) radiation = 'x-ray'
	if (lambda.eq.' ') then
	  write (output_io,1200) radiation,rlambda
	else
	  write (output_io,1210) radiation,lambda,rlambda
	endif
c
	if(rlambda.ne.0.0) then
	  pow_ds_max = 2.*sind(pow_tthmax*0.5)/rlambda
	  pow_ds_min = 2.*sind(pow_tthmin*0.5)/rlambda
	endif
	write (output_io,1220) pow_tthmin,pow_tthmax
	write (output_io,1221) pow_ds_min,pow_ds_max
	write (output_io,1230) pow_deltatth
	write (output_io,1235) pow_delta
	write (output_io,1240) pow_hkl_del
c
	hkl(1) = 1.0
	hkl(2) = 0.0
	hkl(3) = 0.0
	h1 = pow_ds_min/sqrt(skalpro(hkl,hkl,cr_rten))
	h2 = h1 + pow_hkl_del(1)
	hkl(1) = h2
	dstar = sqrt(skalpro(hkl,hkl,cr_rten))
	ttheta = 2.0*asind(rlambda*0.5*dstar)
	del_tth_min(1) = abs(ttheta-pow_tthmin)
	hkl(1) = 1.0
	hkl(2) = 0.0
	hkl(3) = 0.0
	h1 = pow_ds_max/sqrt(skalpro(hkl,hkl,cr_rten))
	h2 = h1 - pow_hkl_del(1)
	hkl(1) = h2
	dstar = sqrt(skalpro(hkl,hkl,cr_rten))
	ttheta = 2.0*asind(rlambda*0.5*dstar)
	del_tth_max(1) = abs(ttheta-pow_tthmax)
c
	hkl(2) = 1.0
	hkl(1) = 0.0
	hkl(3) = 0.0
	h1 = pow_ds_min/sqrt(skalpro(hkl,hkl,cr_rten))
	h2 = h1 + pow_hkl_del(2)
	hkl(2) = h2
	dstar = sqrt(skalpro(hkl,hkl,cr_rten))
	ttheta = 2.0*asind(rlambda*0.5*dstar)
	del_tth_min(2) = abs(ttheta-pow_tthmin)
	hkl(2) = 1.0
	hkl(1) = 0.0
	hkl(3) = 0.0
	h1 = pow_ds_max/sqrt(skalpro(hkl,hkl,cr_rten))
	h2 = h1 - pow_hkl_del(2)
	hkl(2) = h2
	dstar = sqrt(skalpro(hkl,hkl,cr_rten))
	ttheta = 2.0*asind(rlambda*0.5*dstar)
	del_tth_max(2) = abs(ttheta-pow_tthmax)
c
	hkl(3) = 1.0
	hkl(2) = 0.0
	hkl(1) = 0.0
	h1 = pow_ds_min/sqrt(skalpro(hkl,hkl,cr_rten))
	h2 = h1 + pow_hkl_del(3)
	hkl(3) = h2
	dstar = sqrt(skalpro(hkl,hkl,cr_rten))
	ttheta = 2.0*asind(rlambda*0.5*dstar)
	del_tth_min(3) = abs(ttheta-pow_tthmin)
	hkl(3) = 1.0
	hkl(2) = 0.0
	hkl(1) = 0.0
	h1 = pow_ds_max/sqrt(skalpro(hkl,hkl,cr_rten))
	h2 = h1 - pow_hkl_del(3)
	hkl(3) = h2
	dstar = sqrt(skalpro(hkl,hkl,cr_rten))
	ttheta = 2.0*asind(rlambda*0.5*dstar)
	del_tth_max(3) = abs(ttheta-pow_tthmax)
c
	write (output_io,1245)
	write (output_io,1250) del_tth_min
	write (output_io,1260) del_tth_max
	write (output_io,1270) pow_hkl_shift
c	
	if (ldbw) then
	  write (output_io,1300) 'used'
	else
	  write (output_io,1300) 'ignored'
	endif
c
	if (ano) then
	  write (output_io,1310) 'used'
	else
	  write (output_io,1310) 'ignored'
	endif
c
	write (output_io,1400) cfour(pow_four_mode)
c
1000	format (  ' Settings for Powder Diffraction segment :')
1200	format (  '   Radiation             : ',A,', wavelength = ',
     &	              F7.4,' A')
1210	format (  '   Radiation             : ',A,', wavelength = ',A4,
     &	          ' = ',F7.4,' A')
1220	format (  '   TTHmin, TTHmax        : ',f9.4,2x,f9.4)
1221	format (  '   d* min, d* max        : ',f9.4,2x,f9.4)
1230	format (  '   DELTA TTH             : ',f9.4)
1235	format (  '   Instrument resolution : ',f9.4,2x,'(0.0 = off)')
1240	format (  '   dH, dK, dL            : ',3(f9.4,2x))
1245	format (  '   Corr. steps in TTH')
1250	format (  '   at TTHmin             : ',3(f9.4,2x))
1260	format (  '   at TTHmax             : ',3(f9.4,2x))
1270	format (  '   shift for dH,dK,dL    : ',3(f9.4,2x))
1300	format (  '   Temp. factors         : ',A)
1310	format (  '   Anomalous scat.       : ',A)
1400	format (  '   Fourier Mode          : ',A)
	end
c*****7*****************************************************************
	subroutine do_pow_set(zeile,lcomm)
c-
c	Set various paramters for the powder diffraction
c+
	implicit     none
c
	integer       MAXW
	parameter    (MAXW=2)
c
	include      'config.inc'
	include      'errlist.inc'
	include      'diffuse.inc'
	include      'powder.inc'
c
	character*200 cpara(MAXW)
	character*200 zeile
	integer       lpara(MAXW)
	integer       lcomm
	integer       ianz
	real          werte(MAXW)
c
	logical       str_comp
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lcomm)
	if(ier_num.eq.0) then
	  if    (str_comp(cpara(1),'disp',2,lpara(1),4)) then
	    if(ianz.eq.2) then
	      if    (str_comp(cpara(2),'anom',1,lpara(1),4)) then
	        ano=.true.
	      elseif(str_comp(cpara(2),'off',1,lpara(1),3)) then
	        ano = .false.
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  elseif(str_comp(cpara(1),'delta',2,lpara(1),5)) then
	    if(ianz.eq.2) then
	      cpara(1)='0'
	      lpara(1)=1
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if(ier_num.eq.0) then
	        pow_delta = werte(2)
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  elseif(str_comp(cpara(1),'dtth',2,lpara(1),4)) then
	    if(ianz.eq.2) then
	      cpara(1)='0'
	      lpara(1)=1
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if(ier_num.eq.0) then
	        pow_deltatth = werte(2)
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  elseif(str_comp(cpara(1),'dh',2,lpara(1),2)) then
	    if(ianz.eq.2) then
	      cpara(1)='0'
	      lpara(1)=1
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if(ier_num.eq.0) then
	        pow_hkl_del(1) = werte(2)
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  elseif(str_comp(cpara(1),'dk',2,lpara(1),2)) then
	    if(ianz.eq.2) then
	      cpara(1)='0'
	      lpara(1)=1
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if(ier_num.eq.0) then
	        pow_hkl_del(2) = werte(2)
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  elseif(str_comp(cpara(1),'dl',2,lpara(1),2)) then
	    if(ianz.eq.2) then
	      cpara(1)='0'
	      lpara(1)=1
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if(ier_num.eq.0) then
	        pow_hkl_del(3) = werte(2)
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  elseif(str_comp(cpara(1),'sh',2,lpara(1),2)) then
	    if(ianz.eq.2) then
	      cpara(1)='0'
	      lpara(1)=1
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if(ier_num.eq.0) then
	        pow_hkl_shift(1) = werte(2)
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  elseif(str_comp(cpara(1),'sk',2,lpara(1),2)) then
	    if(ianz.eq.2) then
	      cpara(1)='0'
	      lpara(1)=1
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if(ier_num.eq.0) then
	        pow_hkl_shift(2) = werte(2)
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  elseif(str_comp(cpara(1),'sl',2,lpara(1),2)) then
	    if(ianz.eq.2) then
	      cpara(1)='0'
	      lpara(1)=1
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if(ier_num.eq.0) then
	        pow_hkl_shift(3) = werte(2)
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------	Switch Fourier type between normal Fourier and DEBYE calculation
c
	  elseif(str_comp(cpara(1),'calc',1,lpara(1),4)) then
	    if(ianz.eq.2) then
	      if(str_comp(cpara(2),'comp',1,lpara(2),4)) then
	        pow_four_type = POW_COMPL
	      elseif(str_comp(cpara(2),'debye',1,lpara(2),5)) then
	        pow_four_type = POW_DEBYE
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------	Switch Fourier mode between normal Fourier and Stacking Fault 'four'
c
	  elseif(str_comp(cpara(1),'four',1,lpara(1),4)) then
	    if(ianz.eq.2) then
	      if(str_comp(cpara(2),'four',1,lpara(2),4)) then
	        pow_four_mode = POW_FOURIER
	      elseif(str_comp(cpara(2),'stack',1,lpara(2),5)) then
	        pow_four_mode = POW_STACK
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------	Switch usage of temperature coefficients on/off 'temp'
c
	  elseif(str_comp(cpara(1),'temp',1,lpara(1),4)) then
	    if(ianz.eq.2) then
	      if(str_comp(cpara(2),'igno',1,lpara(2),4)) then
	        ldbw=.false.
	      elseif(str_comp(cpara(2),'use',1,lpara(2),3)) then
	        ldbw=.true.
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  elseif(str_comp(cpara(1),'tthmax',5,lpara(1),6)) then
	    if(ianz.eq.2) then
	      cpara(1)='0'
	      lpara(1)=1
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if(ier_num.eq.0) then
	        pow_tthmax = werte(2)
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  elseif(str_comp(cpara(1),'tthmin',5,lpara(1),6)) then
	    if(ianz.eq.2) then
	      cpara(1)='0'
	      lpara(1)=1
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if(ier_num.eq.0) then
	        pow_tthmin = werte(2)
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------	set the wave length to be used 'wvle'
c
	  elseif(str_comp(cpara(1),'wvle',1,lpara(1),4)) then
	    call do_cap (cpara(2))
	    if(ianz.eq.2) then
	      if(ichar('A') .le. ichar(cpara(2)(1:1)) .and.
     &	         ichar(cpara(2)(1:1)) .le. ichar('Z')      ) then
	        lambda = cpara(2)
	      else
	        cpara(1)='0'
	        lpara(1)=1
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          rlambda=werte(2)
	          lambda=' '
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  else
	    ier_num = -8
	    ier_typ = ER_COMM
	  endif
	endif
c
	end
c*****7*****************************************************************
	subroutine powder_run
c-
c	Calculate global parameters and start the individual modes
c+
	implicit     none
c
	integer       MAXW
	parameter    (MAXW=2)
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'errlist.inc'
	include      'diffuse.inc'
	include      'powder.inc'
c
	real          sind
c
c------	Calculate the global maximum h,k,l
c
	if(rlambda.ne.0.0) then
	  pow_ds_max = 2.*sind(pow_tthmax*0.5)/rlambda
	  pow_ds_min = 2.*sind(pow_tthmin*0.5)/rlambda
	  pow_hkl_max(1) = cr_a0(1)*pow_ds_max
	  pow_hkl_max(2) = cr_a0(2)*pow_ds_max
	  pow_hkl_max(3) = cr_a0(3)*pow_ds_max
c
	  if(pow_four_type.eq.POW_COMPL) THEN
	    call powder_complete
	  elseif(pow_four_type.eq.POW_DEBYE) then
	    call powder_debye
	  endif
	endif
c
	end
c*****7*****************************************************************
	subroutine powder_complete
c-
c	Calculate global parameters and start the individual modes
c+
	implicit     none
c
	integer       MAXW
	parameter    (MAXW=2)
c
	include      'config.inc'
	include      'prompt.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'errlist.inc'
	include      'diffuse.inc'
	include      'powder.inc'
c
	integer       i
	integer       h_start,h_end
	integer       k_start,k_end
	integer       l_start,l_end
	integer       ih,ik
	integer       itth
	real          kkstart,kkend
	real          llstart,llend
	real          hh,kk,dk
	real          rr,rrr,rtm
	real          ds_010
	real          ds_001
	real          hkl(3)
	real          u_100(3),u_010(3)
	real          h_100(3),h_010(3)
	real          r_001(3)
	real          op(3),opp(3)
	real          ttheta,dstar
c
	real   skalpro
	real   asind
c
c------	Set Fourier definitions
c
	inc(2) = 1
	do i=1,3
	  vi(i,1) = 0.0
	  vi(i,2) = 0.0
	enddo
	vi(3,1) = pow_hkl_del(3)
	four_log = .false.
c
c------	Calculate some usefull constants
c	Transformation of [100],[010] into reciprocal space etc.
c
	u_100(1) = 1.0
	u_100(2) = 0.0
	u_100(3) = 0.0
	call trans(u_100,cr_gten,h_100,3)
	hh = h_100(1)
	h_100(1) = h_100(1)/hh
	h_100(2) = h_100(2)/hh
	h_100(3) = h_100(3)/hh
	u_010(1) = 0.0
	u_010(2) = 1.0
	u_010(3) = 0.0
	call trans(u_010,cr_gten,h_010,3)
	ds_010  =       skalpro(h_010,h_010,cr_rten)
	r_001(1) = 0.0
	r_001(2) = 0.0
	r_001(3) = 1.0
	ds_001   = sqrt(skalpro(r_001,r_001,cr_rten))
c
c------	reset powder diagramm
c
	do i=1,POW_MAXPKT
	  pow_qsp(i) = 0.0
	enddo
c
c------ calculate complex exponent table
c
	call four_cexpt
c
c------	calculate global limits along h
c
	h_start = -pow_hkl_max(1)/pow_hkl_del(1)
	h_end   =  pow_hkl_max(1)/pow_hkl_del(1)
c
c------	loop over h
c
	do ih=h_start,h_end
	  hh = ih*pow_hkl_del(1) + pow_hkl_shift(1)
	  hkl(1) = hh
c
c------	--op is the center of the intersection of the Ewald sphere and
c	  the plane normal to [100] through h
c
	  op(1) = h_100(1)*hh
	  op(2) = h_100(2)*hh
	  op(3) = h_100(3)*hh
c
c------	--Produce output to keep the user informed
c
	  write (output_io,5000) hh,pow_hkl_del(1),pow_hkl_max(1)
c
c------	--Calculate radius of circle in Anstroem**-1. If positiv, 
c	  perform loop over k
c
	  rr    = pow_ds_max**2 - skalpro(op,op,cr_rten)
	  if(rr.gt.0) then
	    eck(1,1) = hh
	    eck(1,2) = hh
	    eck(1,3) = hh
c
c------	----k is origin +- radius along (010)
c
	    kkstart = op(2) - cr_a0(2)*sqrt(rr)
	    kkend   = op(2) + cr_a0(2)*sqrt(rr)
	    k_start = kkstart/pow_hkl_del(2)
	    k_end   = kkend  /pow_hkl_del(2)
c
c------	----Start loop over k
c
	    do ik=k_start,k_end
	      kk = ik*pow_hkl_del(2) + pow_hkl_shift(2)
	      hkl(2) = kk
c
c------	------New origin is op + [010] with length proportional k
c
	      dk = (kk -op(2))/ds_010
	      opp(1) = op(1) + h_010(1)*dk
	      opp(2) = op(2) + h_010(2)*dk
	      opp(3) = op(3) + h_010(3)*dk
c
c------	--Produce output to keep the user informed
c
c	  write (output_io,5010) kk,pow_hkl_del(2),pow_hkl_max(2)
c
c------	------Diameter of intersecting line
c
	      rrr    = pow_ds_max**2 - skalpro(opp,opp,cr_rten)
	      if(rrr.gt.0) then
	        rtm    = pow_ds_min**2 - skalpro(opp,opp,cr_rten)
	        eck(2,1) = kk
	        eck(2,2) = kk
	        eck(2,3) = kk
c
c------	--------Distinguish between intersection with tthmin and no
c
	        if(rtm.le.0.0) then
c
c------	----------No intersection with 2Theta min sphere
c
c
c------	--------Limits in l are opp +- diameter along (001)
c
	        llstart = opp(3) - sqrt(rrr)/ds_001
	        llend   = opp(3) + sqrt(rrr)/ds_001
	        l_start = llstart/pow_hkl_del(3)
	        l_end   = llend  /pow_hkl_del(3)
	        eck(3,1) = l_start*pow_hkl_del(3) + pow_hkl_shift(3)
	        eck(3,2) = l_end  *pow_hkl_del(3) + pow_hkl_shift(3)
	        eck(3,3) = l_start*pow_hkl_del(3) + pow_hkl_shift(3)
CDBG	write(*,*) 'l_start , l_end ',l_start , l_end
CDBG	write(*,*) 'eck(3,*)        ',eck(3,1),eck(3,2),eck(3,3)
	        inc(1)   = nint((eck(3,2)-eck(3,1))/pow_hkl_del(3)) + 1
	        if(inc(1).gt.MAXQXY) then
	          ier_num = -8
	          ier_typ = ER_APPL
	          write (ier_msg(1),8888) inc(1)
	          write (ier_msg(2),8889) MAXQXY
	          ier_msg(3) =  'Increase dl or reduce TTHMAX'
	          return
	        endif
	        if(pow_four_mode.eq.POW_FOURIER) then
	          call four_run
	        elseif(pow_four_mode.eq.POW_STACK) then
	          call st_fourier
	        endif
	        do i=1,inc(1)
	          hkl(3)=eck(3,1)+(i-1)*vi(3,1)
	          dstar = sqrt(skalpro(hkl,hkl,cr_rten))
	          ttheta = 2.0*asind(rlambda*0.5*dstar)
	          if(pow_tthmin.le.ttheta .and. 
     &	             ttheta.le.pow_tthmax        ) then
	            itth  = (ttheta-pow_tthmin)/pow_deltatth
	            pow_qsp(itth) = pow_qsp(itth) +
     &	            real(csf(i)*conjg(csf(i)))
	          endif
	        enddo
	      else
c
c------	----------Intersection with 2Theta min sphere, calculate two 
c	          sections along line
c
c
c------	--------Limits in l are opp - diameter along (001) (2theta max)
c      	                        opp - diameter along (001) (2theta min)
c
	        llstart = opp(3) - sqrt(rrr)/ds_001
	        llend   = opp(3) - sqrt(rtm)/ds_001
	        l_start = llstart/pow_hkl_del(3)
	        l_end   = llend  /pow_hkl_del(3)
	        eck(3,1) = l_start*pow_hkl_del(3)
	        eck(3,2) = l_end  *pow_hkl_del(3)
	        eck(3,3) = l_start*pow_hkl_del(3)
	        inc(1)   = nint((eck(3,2)-eck(3,1))/pow_hkl_del(3)) + 1
	        if(inc(1).gt.MAXQXY) then
	          ier_num = -8
	          ier_typ = ER_APPL
	          write (ier_msg(1),8888) inc(1)
	          write (ier_msg(2),8889) MAXQXY
	          ier_msg(3) =  'Increase dl or adjust TTHMIN / TTHMAX'
	          return
	        endif
	        if(pow_four_mode.eq.POW_FOURIER) then
	          call four_run
	        elseif(pow_four_mode.eq.POW_STACK) then
	          call st_fourier
	        endif
	        do i=1,inc(1)
	          hkl(3)=eck(3,1)+(i-1)*vi(3,1)
	          dstar = sqrt(skalpro(hkl,hkl,cr_rten))
	          ttheta = 2.0*asind(rlambda*0.5*dstar)
	          if(pow_tthmin.le.ttheta .and. 
     &	             ttheta.le.pow_tthmax        ) then
	            itth  = (ttheta-pow_tthmin)/pow_deltatth
	            pow_qsp(itth) = pow_qsp(itth) +
     &	            real(csf(i)*conjg(csf(i)))
	          endif
	        enddo
c
c------	--------Limits in l are opp + diameter along (001) (2theta min)
c      	                        opp + diameter along (001) (2theta max)
c
	        llstart = opp(3) + sqrt(rtm)/ds_001
	        llend   = opp(3) + sqrt(rrr)/ds_001
c
c------	--------To avoid calculating the same point twice do max(old+1,new)
	        l_start = max ( l_start+1,int(llstart/pow_hkl_del(3)))
	        l_end   = llend  /pow_hkl_del(3)
	        eck(3,1) = l_start*pow_hkl_del(3)
	        eck(3,2) = l_end  *pow_hkl_del(3)
	        eck(3,3) = l_start*pow_hkl_del(3)
	        inc(1)   = nint((eck(3,2)-eck(3,1))/pow_hkl_del(3)) + 1
	        if(inc(1).gt.MAXQXY) then
	          ier_num = -8
	          ier_typ = ER_APPL
	          write (ier_msg(1),8888) inc(1)
	          write (ier_msg(2),8889) MAXQXY
	          ier_msg(3) =  'Increase dl or adjust TTHMIN / TTHMAX'
	          return
	        endif
	        if(pow_four_mode.eq.POW_FOURIER) then
	          call four_run
	        elseif(pow_four_mode.eq.POW_STACK) then
	          call st_fourier
	        endif
	        do i=1,inc(1)
	          hkl(3)=eck(3,1)+(i-1)*vi(3,1)
	          dstar = sqrt(skalpro(hkl,hkl,cr_rten))
	          ttheta = 2.0*asind(rlambda*0.5*dstar)
	          if(pow_tthmin.le.ttheta .and. 
     &	             ttheta.le.pow_tthmax        ) then
	            itth  = (ttheta-pow_tthmin)/pow_deltatth
	            pow_qsp(itth) = pow_qsp(itth) +
     &	            real(csf(i)*conjg(csf(i)))
	          endif
	        enddo
	        endif
	      endif
	    enddo
	  endif
	enddo
c
5000	format (' Currently at H = ',f9.4,'   (dH = ',f9.4,
     &	        ', maxH = ',f9.4,')')
5010	format (' Currently at L = ',f9.4,'   (dL = ',f9.4,
     &	        ', maxL = ',f9.4,')')
8888	format('Current number = ',i10)
8889	format('Maximum number = ',i10)
	end
c*****7*****************************************************************
	subroutine powder_out
c-
c	Write the powder pattern
c+
	implicit     none
c
	integer       iff
	parameter    (iff=2)
c
	include      'config.inc'
	include      'errlist.inc'
	include      'diffuse.inc'
	include      'output.inc'
	include      'powder.inc'
c
	integer       ii,j
	logical       lread
	real          ttheta,lp
c
	real          cosd,sind
c
	lread = .false.
	call oeffne(iff,outfile,'unknown',lread)
	if(ier_num.eq.0) then
	if(pow_four_type.eq.POW_COMPL) then
	  if (pow_delta.gt.0.0) then
	    call powder_conv_res(pow_qsp,pow_tthmin,pow_tthmax,
     &	                         pow_deltatth,pow_delta)
	  endif
	  j = (pow_tthmax-pow_tthmin)/pow_deltatth
	  do ii=0,j
	    ttheta = ii*pow_deltatth+pow_tthmin
	    if(ttheta.eq.0) then
	      lp = 0.0
	    else
	      lp = (1+(cosd(ttheta))**2)/(sind(0.5*ttheta))**2
	    endif
	    write(iff,*) ttheta,pow_qsp(ii)*lp
	  enddo
	elseif(pow_four_type.eq.POW_DEBYE) then
	  do ii=1,num(1)
	    write(iff,*) float(ii),real(csf(ii))
	  enddo
	endif
	  close(iff)
	endif
c
	end
c*****7*****************************************************************
	subroutine powder_conv_res(dat,tthmin,tthmax,dtth,delta)
c-
c	Convolute powder pattern with resolution function (Gaussian)
c+
	implicit     none
c
	include		'config.inc'
	include		'wink.inc'
c
	real		dat(0:POW_MAXPKT)
	real		tthmin,tthmax,dtth,delta
c
	real		dummy(0:POW_MAXPKT)
	real		gauss(0:2*POW_MAXPKT)
	real		tth,ysum
	integer		imax,i,j,ii
c
c------ Setup Gaussian
c
	imax = (10.0*delta)/dtth
	do i=0,imax
	  tth=i*dtth
	  gauss(i)=1.0/sqrt(pi)/delta * exp(-(tth**2 / delta**2))
	enddo
c
	do i=imax+1,2*POW_MAXPKT
	  gauss(i)=0.0
	enddo
c
c------ Now convolute
c
	imax = (tthmax-tthmin)/dtth
	do i=0,imax
	  dummy(i) = dat(i)*(gauss(0)-gauss(2*i))
	  do j=0,i-1
	    dummy(i) = dummy(i) + dat(j)*(gauss(i-j)-gauss(i+j))
	  enddo
	  do j=i+1,imax
	    dummy(i) = dummy(i) + dat(j)*(gauss(j-i)-gauss(j+i))
	  enddo
	enddo
c
	do i=0,imax
	  dat(i)=dummy(i)*dtth
	enddo
c
	end
c*****7*****************************************************************
	subroutine powder_debye
c-
c	Calculate the powder pattern by using the Debye Formula according
c	to Giacovacco
c+
	implicit     none
c
	integer       iff
	parameter    (iff=2)
c
	include      'config.inc'
	include      'prompt.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'errlist.inc'
	include      'diffuse.inc'
	include      'output.inc'
	include      'powder.inc'
c
	integer       j
	integer       i,iscat
	integer       natom(0:MAXSCAT)
	real          ss
	real          u(3),v(3)
c
	real          do_blen
	real          seknds
c
	ier_num = 0
CDBG
CDBG	write (output_io,*) ' in powder_debye'
CDBG	write (output_io,*) ' cr_nscat ',cr_nscat
c
c------ preset some values
c
	num(1) = 1021
	num(2) = 1
	do i=1,3
	  u  (i) = 0.0
	  v  (i) = 0.0
	  xm (i) = 0.0
	  uin(i) = 0.0
	  vin(i) = 0.0
	enddo
	xm(1)  = 0.05
	u(1)   = 0.005
	uin(1) = do_blen(.false.,u,v)
CDBG
CDBG	write (output_io,*) 'xm   ', xm
CDBG	write (output_io,*) 'uin  ', uin
CDBG	write (output_io,*) 'vin  ', vin
	ss = seknds(0.0)
c
c------ zero some arrays
c
	do i=1,num(1)*num(2)
	   csf(i) = cmplx(0.0d0,0.0d0)
	  acsf(i) = cmplx(0.0d0,0.0d0)
	   dsi(i) = 0.0d0
	enddo
	do i=0,cr_nscat
	  natom(i)=0
	enddo
c
c------ preset some tables, calculate average structure
c
	call powder_cexpt
	call powder_stltab
	if (ier_num.ne.0) return
	call four_formtab
c
c------	loop over all atoms
c
	do j=1,cr_natoms
CDBG
	if(mod(j,10).eq.0 ) then
	  write (output_io,*) ' Current atom : ',j
	endif
c
c------	- get info on relative amount of atoms
c
	  natom(cr_iscat(j))=natom(cr_iscat(j))+1
c
c------ - loop over all different atom types
c
	  do iscat=1,cr_nscat
c
c------	--- get all atoms of current scattering type
c
	    call powder_getatm (iscat,j)
c
c------	--- Calculate the Fourier
c
	    call powder_strucf (iscat,.true.)
c
c------ --- Now we multiply with formfactor of current atom
c
	    do i=1,num(1)*num(2)
	      tcsf(i) = tcsf(i)*cfact(istl(i),cr_iscat(j))
	    enddo
c
c------ --- Add this part of the structur factor to the total
c
	    do i=1,num(1)*num(2)
	      csf(i) = csf(i) + tcsf(i)
	    enddo
	  enddo
	enddo
c
c------	add the f**2 wheighted by relative amount to cex
c
CDBG
	open(9,file='csf.inte',status='unknown')
	do i=1,num(1)*num(2)
	  csf(i) = 2.0*csf(i)
CDBG
	  write(9,*) i,real(csf(i))
	enddo
	do iscat=1,cr_nscat
	  do i=1,num(1)*num(2)
	    csf(i) =     csf(i) + cfact(istl(i),iscat)*
     &	                    conjg(cfact(istl(i),iscat))*
     &	                    cmplx(dble(natom(iscat)),0.0d0)
	  enddo
	enddo
	ss = seknds(ss)
	write (output_io,4000) ss
c
4000	format (/,' Elapsed time    : ',G12.6,' sec')
	end
c*****7*****************************************************************
	subroutine powder_strucf (iscat,lform)
c+
c	Here the complex structure factor of 'nxat' identical atoms
c	from array 'xat' is computed.
c-
	implicit	none
c
	include		'config.inc'
	include		'diffuse.inc'
c
	real*8		xarg0,xincu,twopi
	integer		iscat
	integer		i,ii,j,k,iarg,iarg0,iincu,iadd
	logical		lform
c
	integer		IAND,ISHFT
c
	twopi = 8.0d0 * datan(1.0d0)
c
c------ zero fourier array
c
	do i=1,num(1)*num(2)
	  tcsf(i)=cmplx(0.0d0,0.0d0)
	enddo
c
c------ Loop over all atoms in 'xat'
c
	do k=1,nxat
	  xarg0 =  xm(1)*xat(k,1)+ xm(2)*xat(k,2)+ xm(3)*xat(k,3)
	  xincu = uin(1)*xat(k,1)+uin(2)*xat(k,2)+uin(3)*xat(k,3)
CDBG	  xincv = vin(1)*xat(k,1)+vin(2)*xat(k,2)+vin(3)*xat(k,3)
c
	  iarg0 = nint( 64*I2PI*( xarg0-int(xarg0)+1.0d0))
	  iincu = nint( 64*I2PI*( xincu-int(xincu)+1.0d0))
CDBG	  iincv = nint( 64*I2PI*( xincv-int(xincv)+1.0d0))
	  iarg  = iarg0
c
c------ - Loop over all points in Q. 'iadd' is the address of the
c------ - complex exponent table. 'IADD' divides out the 64 and
c------ - ISHFT acts as MOD so that the argument stays in the table
c------ - boundaries.
c
	  ii = 0
c
	  do j=1,num(1)
CDBG	    do i=1,num(2)
	      iadd = ISHFT(iarg,-6)
	      iadd = IAND (iadd,MASK)
	      ii = ii + 1
	      tcsf(ii) = tcsf(ii) + cex(iadd)/
     &	            real((xarg0+float(j-1)*xincu)*twopi)
CDBG	      iarg = iarg + iincv
CDBG	    enddo
	    iarg = iarg0 + iincu*j
	  enddo  
	enddo
c
c------ Now we multiply with formfactor
c
	if (lform) then
	  do i=1,num(1)*num(2)
	    tcsf(i) = tcsf(i)*cfact(istl(i),iscat)
	  enddo
	endif
c
	end
c*****7*****************************************************************
	subroutine powder_cexpt
c+
c	This routine initialises the complex exponent table and
c	is called only at the first Powder run.
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'diffuse.inc'
c
	real*8		twopi,xmult,xarg,xt
	integer		i
c
	write (output_io,1000)
c
	xt    = 1.0d0 / float(I2PI)
	twopi = 8.0d0 * datan(1.0d0)
c
	open(9,file='CEX.DAT',status='unknown')
	do i=0,MASK
	  xmult    = float(i)*xt
	  xarg     = twopi*xmult
	    cex(i) = cmplx(sin(xarg),0.0d0)
	write(9,*) xarg,real(cex(i))
	enddo
	ffour = .false.
	close(9)
c
1000	format (' Computing complex exponent table ...')
	end
c*****7*****************************************************************
	subroutine powder_getatm (iscat,i_start)
c+
c	This routine creates an atom list of atoms of type 'iscat'
c	which are within the current lot.
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'diffuse.inc'
c
	integer         iscat,i_start
	integer         i,j
	real            u(3),v(3)
c
	real          do_blen
c
	nxat   = 0
c
	do i=i_start+1,cr_natoms
	  if (cr_iscat(i).eq.iscat) then
	    nxat=nxat+1
	    do j=1,3
	      u(j)= cr_pos(j,i_start) 
	      v(j)= cr_pos(j,i)
	      xat(nxat,j)=0.0
	    enddo
	    xat(nxat,1) = do_blen(.true.,u,v)
	  endif
	enddo
	end
c*****7*****************************************************************
	subroutine powder_stltab
c+
c	Sets up an integer array containing the corresponding integers
c	to the formfactor table for each sin(theta)/lambda.
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'diffuse.inc'
	include		'errlist.inc'
c
	real		q2
	integer		i
c
	if(four_log) then
	  write (output_io,1000)
	endif
c
	  do i=1,num(1)
	    q2=((xm(1)+uin(1)*float(i-1))**2)/4.0
	    istl(i)=nint(sqrt(q2)*(1.0/CFINC))
c
	    if (istl(i).gt.CFPKT) then
	      ier_num = -3
	      ier_typ = ER_FOUR
	      return
	    endif
c
	  enddo
c
1000	format (' Computing sin(theta)/lambda table ...')
	end
