c+
c	Menu for the structure saveing part of DISCUS. The user
c	can define what structural information is saves to the structure
c	file.
c	If the Menu is called with one or two parameters, the structure
c	is written immedeately to the file defined by the first parameter.
c	In this case, the format is taken from the current settings.
c
c	Version : 3.0
c	Date    : 11 Jul 97
c
c	Author  : R.B. Neder  (reinhard.neder@mail.uni-wuerzburg.de)
c
C*****7*****************************************************************
	subroutine save_struc(zeile,lcomm)
c-
c	Main menu for generalized transformation operations
c+
	implicit      none
c
	include       'config.inc'
	include       'prompt.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'doact.inc'
	include       'errlist.inc'
	include       'learn.inc'
	include       'macro.inc'
	include       'save.inc'
c
	integer        maxw
	parameter     (maxw=MAXSCAT)
	logical        lnew,lold
	parameter     (lnew=.true.,lold=.false.)
c
	character*5    befehl
	character*11   prom
	character*200  line,zeile,cpara(maxw)
	integer        lpara(maxw),lp,length,lbef
	integer        indxg,ianz,i
	integer        lcomm,sav_flen
	logical        lend
	real           werte(maxw)
c
	logical        str_comp
c
	include 'microsta.inc'
c
	data sav_flen /1/
c
c
c------	Interpret parameters used by 'save' command
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lcomm)
	if(ier_num.eq.0) then
	  if(ianz.gt.0) then
c
c------	----Parameters were found, write file immedeatly, and return
c	    to calling routine
c
	    call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	    if(ier_num.eq.0) then
	      sav_file = cpara(1)
	      sav_flen = lpara(1)
c
	      if(sav_keyword) then
c
c-----	------Write new type of structur file
c
	        call save_keyword(cpara(1))
	      else
c
c-----	------Write old type of structur file
c
	        call save_nokeyword(cpara(1))
	      endif
	    endif
c
c------	----File was written, return to caller
c
	    return
	  endif
	else
	  return
	endif
C**********************************************************************
c
c	Beginn of the normal menu structure
c
c
	lend=.false.
	call no_error
c
	do while (.not. lend)
	  prom=prompt//'/save'
	  call get_command (line,length,befehl,lbef,zeile,lp,prom)
	  if(ier_num.eq.0) then
	  if(line.ne.' ' .and. line(1:1).ne.'#') then
c
c------	----search for "="
c
	    indxg=index(line,'=')
	    if(indxg.ne.0 
     &	              .and. .not.(str_comp(befehl,'echo',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'syst',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'help',2,lbef,4) .or.
     &	                          str_comp(befehl,'?   ',2,lbef,4)) )then
c
c------	------evaluatean expression and assign the value to a variabble
c
	      call do_math(line,indxg,length)
	    else
c
c------ ----execute a macro file
c
            if(befehl(1:1).eq.'@') then
	      if(length.ge.2) then
	        call file_kdo(line(2:length),length-1)
	      else
	        ier_num = -13
	        ier_typ = ER_MAC
	      endif
c
c------	----list asymmetric unit 'asym'
c
	    elseif(str_comp(befehl,'asym',2,lbef,4)) then
	      call show_asym
c
c------	----continues a macro 'continue'
c
	    elseif(str_comp(befehl,'continue',2,lbef,8)) then
	      call macro_continue(zeile,lp)
c
c------	----list atoms present in the crystal 'chem'
c
	    elseif(str_comp(befehl,'chem',2,lbef,4)) then
	      call show_chem
c
c------	----Deselect which atoms are included in the wave 'dese'
c
	    elseif(str_comp(befehl,'dese',1,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 ) then
	        if(cpara(1)(1:3).eq.'mic') then
	          sav_md_s  = MD_S_EVE
	          sav_md_nr = 0
	        else
	          call get_iscat(ianz,cpara,lpara,werte,maxw,lold)
	          if(ier_num.eq.0) then
	            if(werte(1).eq.-1) then
	              do i=0,cr_nscat
	                sav_latom(i) = .false.
	              enddo
	            else
	              do i=1,ianz
	                sav_latom(nint(werte(i))) = .false.
	              enddo
	            endif
	          endif
	        endif
	      endif
c
c------ ----Echo a string, just for interactive check in a macro 'echo'
c
	    elseif(str_comp(befehl,'echo',2,lbef,4)) then
	      call echo(zeile,lp)
c
c------	 ---Evaluate an expression, just for interactive check 'eval'
c
	    elseif(str_comp(befehl,'eval',2,lbef,4)) then
	      call do_eval(zeile,lp)
c
c------	----exit 'exit'
c
	    elseif(str_comp(befehl,'exit',2,lbef,4)) then
	      lend=.true.
c
c------	define format of output file 'format'
c
	    elseif(str_comp(befehl,'format',1,lbef,6)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(str_comp(cpara(1),'keyword',1,lpara(1),7)) then
	          sav_keyword = .true.
	        elseif(str_comp(cpara(1),'nokeywo',1,lpara(1),7)) then
	          sav_keyword = .false.
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----help 'help','?'
c
	    elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	           str_comp(befehl,'?   ',1,lbef,4)     ) then
	      if(str_comp(zeile,'errors',2,lp,6) ) then
	        lp = lp + 7
	        call do_hel('discus '//zeile,lp)
	      else
	        lp = lp + 12
	        call do_hel('discus save '//zeile,lp)
	      endif
c
c------	----Select range of atoms within crystal to be included 'incl'
c
	    elseif(str_comp(befehl,'incl',1,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.2) then
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            sav_start = nint(werte(1))
	            sav_end   = nint(werte(2))
	          endif
	        elseif(ianz.eq.1) then
	          if(str_comp(cpara(1),'all',1,lpara(1),3)) then
	            sav_start =  1
	            sav_end   = -1
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----omit parameters from the keyword list  'omit'
c
	    elseif(str_comp(befehl,'omit',1,lbef,4)) then
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(str_comp(cpara(1),'all',1,lpara(1),3)) then
	          sav_w_gene  = .false.
	          sav_w_ncell = .false.
	          sav_w_symm  = .false.
	          sav_w_scat  = .false.
	          sav_w_adp   = .false.
	        elseif(str_comp(cpara(1),'gene',1,lpara(1),4)) then
	          sav_w_gene  = .false.
	        elseif(str_comp(cpara(1),'mole',1,lpara(1),4)) then
	          sav_w_mole  = .false.
	        elseif(str_comp(cpara(1),'ncell',1,lpara(1),5)) then
	          sav_w_ncell = .false.
	        elseif(str_comp(cpara(1),'symm',2,lpara(1),4)) then
	          sav_w_symm  = .false.
	        elseif(str_comp(cpara(1),'scat',2,lpara(1),4)) then
	          sav_w_scat  = .false.
	        elseif(str_comp(cpara(1),'adp',1,lpara(1),3)) then
	          sav_w_adp   = .false.
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	define name of output file 'outfile'
c
	    elseif(str_comp(befehl,'outfile',1,lbef,7)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	        if(ier_num.eq.0) then
	          sav_file = cpara(1)
	          sav_flen = lpara(1)
	        endif
	      endif
c
c------	----run transformation 'run'
c
	    elseif(str_comp(befehl,'run ',1,lbef,4)) then
	      if(sav_keyword) then
	        call save_keyword(sav_file)
	      else
	        call save_nokeyword(sav_file)
	      endif
c
c------	----Select which atoms are copied to their image 'sele'
c
	    elseif(str_comp(befehl,'sele',2,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(cpara(1)(1:3).eq.'mic' .and. ianz.eq.2) then
	          if(cpara(2)(1:3).eq.'all') then
	            sav_md_s  = MD_S_ALL
	            sav_md_nr = 0
	          elseif(cpara(2)(1:3).eq.'non') then
	            sav_md_s  = MD_S_NON
	            sav_md_nr = 0
	          elseif(cpara(2)(1:3).eq.'eve') then
	            sav_md_s  = MD_S_EVE
	            sav_md_nr = 0
	          else
	            cpara(1) = '0.0'
	            lpara(1) = 3
	            call ber_params(ianz,cpara,lpara,werte,maxw)
	            sav_md_nr = nint(werte(2))
	            sav_md_s  = MD_S_IND
	          endif
	        else
	          call get_iscat(ianz,cpara,lpara,werte,maxw,lold)
	          if(ier_num.eq.0) then
	            if(werte(1).eq.-1) then
	              do i=0,cr_nscat
	                sav_latom(i) = .true.
	              enddo
	            else
	              do i=1,ianz
	                sav_latom(nint(werte(i))) = .true.
	              enddo
	            endif
	          endif
	        endif
	      endif
c
c------	----show current parameters 'show'
c
	    elseif(str_comp(befehl,'show',2,lbef,4)) then
	      if(sav_flen.gt.0) then
	        write (output_io,3000) sav_file(1:sav_flen)
	      else
	        write (output_io,3000) ' '
	      endif
	      if(sav_keyword) then
	        write (output_io,3005)
	        if(sav_w_scat) then
	          write (output_io,3008) 'written'
	        else
	          write (output_io,3008) 'omitted'
	        endif
	        if(sav_w_adp ) then
	          write (output_io,3009) 'written'
	        else
	          write (output_io,3009) 'omitted'
	        endif
	        if(sav_w_gene) then
	          write (output_io,3010) 'written'
	        else
	          write (output_io,3010) 'omitted'
	        endif
	        if(sav_w_symm) then
	          write (output_io,3020) 'written'
	        else
	          write (output_io,3020) 'omitted'
	        endif
	        if(sav_w_ncell) then
	          write (output_io,3030) 'written'
	        else
	          write (output_io,3030) 'omitted'
	        endif
	        if(sav_w_mole) then
	          write (output_io,3040) 'written'
	        else
	          write (output_io,3040) 'omitted'
	        endif
c
	        write (output_io,3070) cmic_s(sav_md_s)
	        if(sav_md_s.eq.MD_S_IND) then
	          write (output_io,3075) sav_md_nr
	        endif
	        write (output_io,3090)
	        write (output_io,3091)
	        do i=0,cr_nscat
	          if(sav_latom(i)) then
	            write (output_io,3092) i,cr_at_lis(i)
	          endif
	        enddo
	        if(sav_end.eq.-1) then
	          write (output_io,3080) 
	        else
	          write (output_io,3081) sav_start,sav_end
	        endif
	      else
	        write (output_io,3006)
	      endif
c
c------- -Operating System Kommandos 'syst'
c
	  elseif(str_comp(befehl,'syst',2,lbef,4)) then
	    if(zeile.ne. ' ') then
	      call do_operating(zeile(1:lp),lp)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------  -----waiting for user input
c
	    elseif(str_comp(befehl,'wait',2,lbef,4)) then
	      call do_input(zeile,lp)
c
c------	----write parameters from the keyword list  'write'
c
	    elseif(str_comp(befehl,'write',2,lbef,5)) then
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(str_comp(cpara(1),'all',1,lpara(1),3)) then
	          sav_w_gene  = .true.
	          sav_w_ncell = .true.
	          sav_w_symm  = .true.
	          sav_w_scat  = .true.
	          sav_w_adp   = .true.
	        elseif(str_comp(cpara(1),'gene',1,lpara(1),4)) then
	          sav_w_gene  = .true.
	        elseif(str_comp(cpara(1),'mole',1,lpara(1),4)) then
	          sav_w_mole  = .true.
	        elseif(str_comp(cpara(1),'ncell',1,lpara(1),5)) then
	          sav_w_ncell = .true.
	        elseif(str_comp(cpara(1),'symm',2,lpara(1),4)) then
	          sav_w_symm  = .true.
	        elseif(str_comp(cpara(1),'scat',2,lpara(1),4)) then
	          sav_w_scat  = .true.
	        elseif(str_comp(cpara(1),'adp',1,lpara(1),3)) then
	          sav_w_adp   = .true.
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
	    else
	      ier_num = -8
	      ier_typ = ER_COMM
	    endif
	    endif
	  endif
	  endif
	  if(ier_num.ne.0) then
	    call errlist
	    if(lmakro) then
	      call macro_close
	      prompt_status = PROMPT_ON
	    endif
	    if(lblock) then
	      ier_num = -11
	      ier_typ = ER_COMM
	      return
	    endif
	    call no_error
	  endif
	enddo
c
9999	continue
c
3000	format(20x,'    Data written to structure file '/
     &	       20x,' ===================================='//
     &	       ' Structure file                            : ',a/)
3005	format(' Format of structure file                  :',
     &	       ' Keyword controlled'/
     &	       ' Title           ',26x,': written'/
     &	       ' Space group     ',26x,': written'/
     &	       ' Cell constants  ',26x,': written')
3006	format(' Format of structure file                  :',
     &	       ' No keywords in structure file'/
     &	       ' First line      ',26x,': title'/
     &	       ' Second line     ',26x,': space group'/
     &	       ' Third line      ',26x,': cell constants'/
     &	       ' Following lines ',26x,': atoms'/)
3008	format(' Explicit list of atomic names             : ',a7)
3009	format(' Explicit list of atomic displacement par. : ',a7)
3010	format(' Additional generator matrizes             : ',a7)
3020	format(' Additional symmetry operators             : ',a7)
3030	format(' Number of unit cells, atoms per unit cell : ',a7)
3040	format(' Molecule information: content etc.        : ',a7)
3070	format(/' select status           : ',a)
3075	format(22x,i4)
3080	format(' Range of atoms from to    : All atoms included')
3081	format(' Range of atoms from to    : ',2(2x,i9))
3090	format(' Selected atoms    :')
3091	format('                      type name')
3092	format(20x,2(4x,i2,1x,a4))
c
	end
c*****7*****************************************************************
	subroutine  save_nokeyword(strucfile)
c+
c	This subroutine saves the structure and/or the unit cell
c	onto a file in the format used until DISCUS 3.0 i.e. without
c	keywords.
c+
	implicit	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	character*200 strucfile
	integer       ist,i,j
	logical       lread
c
	integer       len_str
c
	data ist /7/
c
	lread = .false.
	call oeffne(ist,strucfile,'unknown',lread)
	if(ier_num.eq.0) then
c
c-----	--Write old type of structur file
c
	  j = len_str(cr_name)
	  write(ist,3)    cr_name(1:j)
	  write(ist,33)   cr_spcgr
	  write(ist,34)   (cr_a0(i),i=1,3),(cr_win(i),i=1,3)
	  do i=1,cr_natoms
	    write(ist,4)  cr_at_lis(cr_iscat(i)),
     &	                 (cr_pos(j,i),j=1,3),
     &	                  cr_dw(cr_iscat(i))
	  enddo
	endif
	close(ist)
c
3	format(a)
33	format(a16)
34	format(6(1x,f10.6))
4	format(a4,3(2x,f14.6),5x,f8.4)
	end
C**********************************************************************
	subroutine save_keyword(strucfile)
c+
c	This subroutine saves the structure and/or the unit cell
c	onto a file. The format uses keyword description.
c+
	implicit	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
	include         'gen_add.inc'
	include         'microdis.inc'
	include         'molecule.inc'
	include 	'save.inc'
	include         'sym_add.inc'
c
	character*200 strucfile
	character*31  fform
	integer       ist,i,j,k,j_end,l1,l2
	integer       i_start,i_end
	integer       is,ie
	logical       lread
c
	integer       len_str
c
	include         'microsta.inc'
c
	data ist /7/
c
c------	Set the appropriate starting end ending number for the atoms
c
	i_start = sav_start
	i_end   = sav_end
	if(sav_end.eq.-1) i_end = cr_natoms
c
	lread = .false.
	call oeffne(ist,strucfile,'unknown',lread)
	if(ier_num.eq.0) then
c
c-----	--Write new type of structur file
c
	  j = len_str(cr_name)
	  if(j.eq.0) then
	    cr_name = ' '
	    j       = 1
	  endif
	  write(ist,3000)    cr_name(1:j)
	  write(ist,3010)   cr_spcgr
	  write(ist,3020)   (cr_a0(i),i=1,3),(cr_win(i),i=1,3)
	  if(sav_w_scat) then
	    j = (cr_nscat-1)/7
	    do i=1,j
	      is = (i-1)*7 + 1
	      ie = is + 6
	      write(ist,3110) (cr_at_lis(k),k=is,ie)
	    enddo
	    if(cr_nscat-j*7.eq.1) then
	      write(ist,3111)  cr_at_lis(cr_nscat)
	    elseif(cr_nscat-j*7.gt.1) then
	      write(fform,7010) cr_nscat-j*7-1
	      write(ist,fform) (cr_at_lis(i),i=j*7+1,cr_nscat)
	    endif
	  endif
	  if(sav_w_adp) then
	    j = (cr_nscat-1)/7
	    do i=1,j
	      is = (i-1)*7 + 1
	      ie = is + 6
	      write(ist,3120) (cr_dw(k),k=is,ie)
	    enddo
	    if(cr_nscat-j*7.eq.1) then
	      write(ist,3121)  cr_dw(cr_nscat)
	    elseif(cr_nscat-j*7.gt.1) then
	      write(fform,7020) cr_nscat-j*7-1
	      write(ist,fform) (cr_dw(i),i=j*7+1,cr_nscat)
	    endif
	  endif
	  if(sav_w_gene) then
	    do k=1,gen_add_n
	      write(ist,3021) ((gen_add(i,j,k),j=1,4),i=1,3),
     &	                        gen_add_power(k)
	    enddo
	  endif
	  if(sav_w_symm) then
	    do k=1,sym_add_n
	      write(ist,3022) ((sym_add(i,j,k),j=1,4),i=1,3),
     &	                        sym_add_power(k)
	    enddo
	  endif
	  if(sav_w_ncell) then
	    write(ist,3030) cr_icc,cr_ncatoms
	  endif
	  write(ist,3900)
	  do i=i_start,i_end
c
c------	----Select atom if:
c	    type has been selected and
c	       all atoms are selected                            or
c	       all microdomains have been selected               or
c	       a specific microdomain type has been selected     or
c	       microdomains are deselected and atom is outside
c
	    if(sav_latom(cr_iscat(i)) .and. 
     &	     ( sav_md_s.eq.MD_S_EVE                               .or.
     &	       sav_md_s.eq.MD_S_ALL .and. cr_md_next(i).lt.0      .or.
     &	       sav_md_s.eq.MD_S_IND .and. cr_md_next(i).lt.0 .and.
     &                     mc_type(-cr_md_next(i)).eq.sav_md_nr   .or.
     &	       sav_md_s.eq.MD_S_NON .and. sav_md_nr.eq.0      .and.
     &	                            cr_md_next(i).ge.0      )  ) then
	        write(ist,4)  cr_at_lis(cr_iscat(i)),
     &	                     (cr_pos(j,i),j=1,3),
     &	                      cr_dw(cr_iscat(i))
	    endif
	  enddo
	endif
c
c------	Write content of molecules
c
	if(sav_w_mole) then
	  do i=1,mole_num_mole
	    write(ist,4000) mole_type(i),i
	    j_end = int(mole_len(i)/7.)
	    do j=1,j_end
	      l1 = mole_off(i) + (j-1)*7 + 1
	      l2 = l1 + 7 - 1
	      write(ist,4010) (',',mole_cont(k),k=l1,l2)
	    enddo
	    l1= mole_off(i) + int((mole_len(i)-1)/7.)*7 + 1
	    l2= mole_off(i) + mole_len(i)
	    write(ist,4010) (',',mole_cont(k),k=l1,l2)
	    write(ist,4900)
	  enddo
	endif
	close(ist)
c
3000	format('title ',a)
3010	format('spcgr ',a16)
3020	format('cell  ',5(f10.6,2x ),f10.6)
3021	format('gene  ',12(f9.6,','),i3)
3022	format('symm  ',12(f9.6,','),i3)
3030	format('ncell ',3(i8,','),i10)
3110	format(('scat  ', a4,6(',',5x,a4)))
3111	format(('scat  ', a4))
3120	format(('adp   ', f9.6,6(',',5x,f9.6)))
3121	format(('adp   ', f9.6))
3900	format('atoms ')
4000	format('molecule content,',i8,',',i8)
4010	format('molecule atoms',7(a1,i8))
4900	format('molecule end')
4	format(a4,3(2x,f14.6),5x,f8.4)
7010	format('(''scat  '', a4  ,',i1,'('','',5x,a4  ))')
7020	format('(''adp   '', f9.6,',i1,'('','',5x,f9.6))')
	end
C**********************************************************************
