c*****7*****************************************************************
	subroutine do_show(line,laenge)
c-
c	These subroutine is the main routine for showing various
c	parameters.
c
c	Version  : 1.0
c	Date     : 03 Jul 96
c
c	Author   : R.B. Neder (reinhard.neder@mail.uni-wuerzburg.de)
c+
	implicit       none
c
	include       'config.inc'
	include       'prompt.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'errlist.inc'
	include       'param.inc'
c
	integer        maxw
	parameter     (maxw=7)
c
	character*200  cpara(maxw),line
	integer        lpara(maxw)
	integer        ianz
	integer        i,j
	integer        laenge
	real           werte(maxw)
c
	logical        str_comp
c
	call get_params(line,ianz,cpara,lpara,maxw,laenge)
	if(ier_num.eq.0) then
c
c------	--Interprete first parameter as command
c
c
c------	----Show composition of asymmetric unit 'asym'
c
	  if(str_comp(cpara(1),'asym',2,lpara(1),4)) then
	    call show_asym
c
c------	----Show an atom                     'atom'
c
	  elseif(str_comp(cpara(1),'atom',2,lpara(1),4)) then
	    call do_show_atom(ianz,cpara,lpara,werte,maxw)
c
c------	----Show bond valence parameters     'bval'
c
	  elseif(str_comp(cpara(1),'bval',2,lpara(1),4)) then
	    call do_show_bval(ianz,cpara,lpara,werte,maxw)
c
c------	----Show the chemistry               'chem'
c
	  elseif(str_comp(cpara(1),'chem',2,lpara(1),4)) then
	    call show_chem
c
c------	----Show current configuration       'config'
c
	  elseif(str_comp(cpara(1),'config',2,lpara(1),6)) then
	    call do_show_config
c
c------	----Show the dimensions              'cdim'
c
	  elseif(str_comp(cpara(1),'cdim',2,lpara(1),4)) then
	    write (output_io,2000) ((cr_dim(j,i),i=1,2),j=1,3)
c
c------	----Show the atom environment        'envi'
c
	  elseif(str_comp(cpara(1),'envi',2,lpara(1),4)) then
	    call do_show_env
	    cpara(2)='envi'
	    lpara(2)=4
	    call do_show_atom(ianz,cpara,lpara,werte,maxw)
c
c------	----Show the error status            'error'
c
	  elseif(str_comp(cpara(1),'error',1,lpara(1),5)) then
	    if(ier_sta.eq.ER_S_CONT) then
	      write (output_io,2100)
	    else
	      write (output_io,2105)
	    endif
c
c------	----Show the molecular environment        'menvi'
c
	  elseif(str_comp(cpara(1),'menvi',2,lpara(1),5)) then
	    call do_show_menv
	    if(ianz.eq.2) then
	      if(str_comp(cpara(2),'full',1,lpara(2),4)) then
	        cpara(2)='envi'
	        lpara(2)=4
	        call do_show_molecule(ianz,cpara,lpara,werte,maxw)
	      endif
	    endif
c
c------	----Show a molecule                  'molecule'
c
	  elseif(str_comp(cpara(1),'molecule',2,lpara(1),8)) then
	    call do_show_molecule(ianz,cpara,lpara,werte,maxw)
c
c------	----Show result array                'result'
c
	  elseif(str_comp(cpara(1),'result',1,lpara(1),6)) then
	    call do_show_res
c
c------	----Show scattering curve            'scat'
c
	  elseif(str_comp(cpara(1),'scat',1,lpara(1),4)) then
	    call do_show_scat(ianz,cpara,lpara,werte,maxw)
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	endif
c
2000	format(' Current crystal dimensions:'/
     &	       '          minimum       maximum'/
     &	       '  X ',2(2x,f12.4)/
     &	       '  Y ',2(2x,f12.4)/
     &	       '  Z ',2(2x,f12.4))
2100	format(' Program continues after display of error message')
2105	format(' Program terminates after display of error message')
c
	end
c*****7*****************************************************************
	subroutine show_asym
c-
c	This subroutine shows the content of the asymmetric unit
c+
	implicit      none
c
	include       'config.inc'
	include       'prompt.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'macro.inc'
	include       'envir.inc'
c
	character*1   cdummy
	integer       i,j,k,l
c
	do j=1,as_natoms/(LINES-2)
	  write (output_io,2000)
	  do i=1,LINES-2
	    k = (j-1)*(LINES-2) + i
	    write (output_io,2010) as_at_lis(k),as_iscat(k),
     &	                  (as_pos(l,k),l=1,3),as_dw(as_iscat(k))
	  enddo
	  if (.not. lmakro) then
	    write (output_io,2020)
	    read (*,1000) cdummy
	  endif
	enddo
	write (output_io,2000)
	j=as_natoms/(LINES-2)+1
	do i=1,as_natoms-(as_natoms/(LINES-2))*(lines-2)
	  k = (j-1)*(LINES-2) + i
	  write (output_io,2010) as_at_lis(k),as_iscat(k),
     &	                (as_pos(l,k),l=1,3),as_dw(as_iscat(k))
	enddo
c
1000	format(a)
2000	format(' Asymmetric unit'/ ' Name    Type       x',
     &	'             y             z               B')
2010	format(1x,a4,2x,i4,3(2x,f12.5),4x,f12.5)
2020	format(' Press RETURN for more ...')
	end
c*****7*****************************************************************
	subroutine show_chem
c-
c	This subroutine shows the different atom types present
c	in the crystal
c+
	implicit      none
c
	include       'config.inc'
	include       'prompt.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'macro.inc'
	include       'envir.inc'
c
	character*1   cdummy
	integer       i,j,k
	integer       kvoid
c
	character*9   at_name_d
	character*9   at_name
c
	if(cr_ndel.gt.0) then
	  kvoid = -1
	else
	  kvoid =  0
	endif
c
	do j=1,(cr_nscat - kvoid)/(LINES-2)
	  write (output_io,2000)
	  do i=1,LINES-2
	    k = (j-1)*(LINES-2) + i + kvoid
	    at_name_d = at_name(k)
	    write (output_io,2010) at_name_d ,k,cr_dw(k)
	  enddo
	  if (.not. lmakro) then
	    write (output_io,2020)
	    read (*,1000) cdummy
	  endif
	enddo
	write (output_io,2000)
	j=(cr_nscat - kvoid)/(LINES-2)+1
	do i=1,cr_nscat-((cr_nscat-kvoid)/(LINES-2))*(LINES-2) - kvoid
	  k = (j-1)*(LINES-2) + i + kvoid
	  write (output_io,2010) cr_at_lis(k),k,cr_dw(k)
	enddo
c
1000	format(a)
2000	format(' Atoms present  '/ ' Name         Type       B')
2010	format(1x,a9,2x,i4,2x,f12.5)
2020	format(' Press RETURN for more ...')
	end
c*****7*****************************************************************
	subroutine do_show_res
c-
c	Shows the result array
c+
	implicit       none
c
	include       'errlist.inc'
	include       'prompt.inc'
	include       'param.inc'
c
	integer        i,j,k,k1,k2
c
	if(nint(res_para(0)).eq.0) then
	  write (output_io,*) 'Result array is empty'
	else
	  write (output_io,2000) nint(res_para(0))
	  j = nint(res_para(0))/5
	  if(mod(nint(res_para(0)),5).eq.0) then
	    j = j-1
	  endif
	  do i=0,j
	    k1 =     5*i+1
	    k2 = min(5*i+5,nint(res_para(0)))
	    write (output_io,2001) (res_para(k),k=k1,k2)
	  enddo
	endif
c
2000	format( i8,' Values in the result array')
2001	format(5(2x,g13.7))
	end
c*****7*****************************************************************
	subroutine do_show_config
c-
c	Shows current configuration
c+
	implicit       none
c
	include       'config.inc'
	include       'prompt.inc'
c
	write (output_io,1000)
c
	write (output_io,1005) MAXSCAT
	write (output_io,1010) NMAX
	write (output_io,1020) MAXQXY
c
	write (output_io,1030) RMC_MAX_Q
	write (output_io,1040) RMC_MAX_PLANES
	write (output_io,1050) RMC_MAX_SYM
	write (output_io,1060) RMC_MAX_ATOM
	write (output_io,1070) RMC_MAX_LOTS
c
	write (output_io,1080) CHEM_MAX_VEC
	write (output_io,1090) CHEM_MAX_COR
	write (output_io,1100) CHEM_MAX_BIN
	write (output_io,1110) CHEM_MAX_ATOM
	write (output_io,1120) CHEM_MAX_NEIG
c
	write (output_io,1130) MMAX
	write (output_io,1140) MK_MAX_SCAT
	write (output_io,1150) MC_MAX_MICRO
c
	write (output_io,1160) ST_MAXQXY
	write (output_io,1170) ST_MAXLAYER
	write (output_io,1180) ST_MAXTYPE
c
	write (output_io,1190) MAXDAT
c
1000	format(' Current configuration of DISCUS : ')
1005	format('   Maximum number of different atomtypes         : ',i8)
1010	format('   Maximum number of atoms                       : ',i8)
1020	format('   Maximum number of points in Q                 : ',i8)
1030	format('   Maximum number of RMC input data points       : ',i8)
1040	format('   Maximum number of RMC input data planes       : ',i8)
1050	format('   Maximum number of RMC sym. equivalent planes  : ',i8)
1060	format('   Maximum number of atoms moved in one RMC move : ',i8)
1070	format('   Maximum number of RMC lots allowed            : ',i8)
1080	format('   Maximum number of neighbour vec. definitions  : ',i8)
1090	format('   Maximum number of correlations                : ',i8)
1100	format('   Maximum number of points for histograms       : ',i8)
1110	format('   Maximum number of different atoms             : ',i8)
1120	format('   Maximum number of neighbouring atoms/mol.     : ',i8)
1130	format('   Maximum number of atoms in microdomain        : ',i8)
1140	format('   Maximum number of atom types in microdomain   : ',i8)
1150	format('   Maximum number of microdomains                : ',i8)
1160	format('   Maximum number of points of Fourier           : ',i8)
1170	format('   Maximum number of layers                      : ',i8)
1180	format('   Maximum number of layer types                 : ',i8)
1190	format('   Maximum number of points in PDF               : ',i8)
c
	end
c*****7*****************************************************************
	subroutine do_show_env
c-
c	Shows the atom_environment array
c+
	implicit       none
c
	include       'config.inc'
	include       'prompt.inc'
	include       'atom_env.inc'
	include       'errlist.inc'
c
	integer        i,j,k,k1,k2
c
	if(atom_env(0).eq.0) then
	  write (output_io,*) 'Atom environment array is empty'
	else
	  write (output_io,2000) atom_env(0)
	  j = atom_env(0)/5
	  if(mod(atom_env(0),5).eq.0) then
	    j = j-1
	  endif
	  do i=0,j
	    k1 =     5*i+1
	    k2 = min(5*i+5,atom_env(0))
	    write (output_io,2001) (atom_env(k),k=k1,k2)
	  enddo
	endif
c
2000	format( i8,' Atom numbers in the environment array')
2001	format(5(2x,i13))
	end
c*****7*****************************************************************
	subroutine do_show_menv
c-
c	Shows the molecular _environment array
c+
	implicit       none
c
	include       'config.inc'
	include       'prompt.inc'
	include       'mole_env.inc'
	include       'errlist.inc'
c
	integer        i,j,k,k1,k2
c
	if(mole_env(0).eq.0) then
	  write (output_io,*) 'Molecular environment array is empty'
	else
	  write (output_io,2000) mole_env(0)
	  j = mole_env(0)/5
	  if(mod(mole_env(0),5).eq.0) then
	    j = j-1
	  endif
	  do i=0,j
	    k1 =     5*i+1
	    k2 = min(5*i+5,mole_env(0))
	    write (output_io,2001) (mole_env(k),k=k1,k2)
	  enddo
	endif
c
2000	format( i8,' Molecule numbers in the environment array')
2001	format(5(2x,i13))
	end
c*****7*****************************************************************
	subroutine do_show_atom(ianz,cpara,lpara,werte,maxw)
c-
c	Shows information about an atom.
c+
	implicit       none
c
	include       'config.inc'
	include       'prompt.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'atom_env.inc'
	include       'errlist.inc'
c
	integer        maxw
c
	character*200  cpara(maxw)
	integer        ianz
	integer        lpara(maxw)
	real           werte(maxw)
c
	integer        i,istart,iend,l
c
	character*9    at_name_d
	character*9    at_name
c
	logical        str_comp
c
	cpara(1) = '0.0'
	lpara(1) = 3
c
	if(str_comp(cpara(2),'all',1,lpara(2),3)) then
	  werte(2) = 1
	  werte(3) = cr_natoms
	  ianz     = 3
	elseif(str_comp(cpara(2),'last',1,lpara(2),4)) then
	  werte(2) = cr_natoms
	  werte(3) = cr_natoms
	  ianz     = 3
	else
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	endif
	if(ier_num.eq.0) then
c
c------	--List atom environment
c
	  if(str_comp(cpara(2),'envi',1,lpara(2),4)) then
	    write (output_io,3000)
	    do l=1,atom_env(0)
	      i=atom_env(l)
	      at_name_d = at_name(cr_iscat(i))
	      write (output_io,3010) at_name_d,
     &	          cr_pos(1,i),cr_pos(2,i),cr_pos(3,i),
     &	          cr_dw(cr_iscat(i))
	    enddo
c
c------	--List sequence of atoms
c
	  else
	    if(ianz.eq.2 .or. ianz.eq.3) then
	      istart = nint(werte(2))
	      if(ianz.eq.2) then
	        iend = istart
	      else
	        iend = nint(werte(3))
	      endif
	      iend = min(iend,cr_natoms)
	      write (output_io,3000)
	      do i=istart,iend
	        at_name_d = at_name(cr_iscat(i))
	        write (output_io,3010) at_name_d,
     &	            cr_pos(1,i),cr_pos(2,i),cr_pos(3,i),
     &	            cr_dw(cr_iscat(i))
	      enddo
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
	endif
c
3000	format(' Name',11x,'x',13x,'y',13x,'z',11x,'B')
3010	format(1x,a9,3(2x,f12.6),4x,f10.6)
	end
c*****7*****************************************************************
	subroutine do_show_bval(ianz,cpara,lpara,werte,maxw)
c-
c	Shows bond valence parameters for an atom.
c+
	implicit       none
c
	include       'config.inc'
	include       'prompt.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'chem.inc'
	include       'errlist.inc'
c
	integer        maxw
c
	character*200  cpara(maxw)
	integer        ianz
	integer        lpara(maxw)
	real           werte(maxw)
c
	integer        elem_1,elem_2,ie_1,ie_2,i
c
	if (ianz.eq.3) then
	  call do_cap(cpara(2))
	  call do_cap(cpara(3))
	  read(cpara(2)(1:4),1000) elem_1
	  read(cpara(3)(1:4),1000) elem_2
	  call symbf(elem_1,ie_1)
	  call symbf(elem_2,ie_2)
	  if (bv_index(ie_1,ie_2).ne.0) then
	    i = bv_index(ie_1,ie_2)
	    write (output_io,2000) cpara(2)(1:4),cpara(3)(1:4),
     &	                           bv_r0(i),bv_b(i)
	  else
	    ier_num = -75
	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
1000	format(a4)
2000	format(' Bond valence parameters ',a4,' - ',a4,' : r0 = ',
     &	        f7.4,' b = ',f7.4)
	end
c*****7*****************************************************************
	subroutine do_show_molecule(ianz,cpara,lpara,werte,maxw)
c-
c	Shows information about a molecule.
c+
	implicit       none
c
	include       'config.inc'
	include       'prompt.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'errlist.inc'
	include       'molecule.inc'
	include       'mole_env.inc'
c
	integer        maxw
c
	character*200  cpara(maxw)
	integer        ianz
	integer        lpara(maxw)
	real           werte(maxw)
c
	integer        i,istart,iend,j,k
c
	character*9    at_name_d
	character*9    at_name
c
	logical        str_comp
c
	cpara(1) = '0.0'
	lpara(1) = 3
c
	if (ianz.eq.2 .or. ianz.eq.3) then
	  if(str_comp(cpara(2),'all',1,lpara(2),3)) then
	    istart = 1
	    iend   = mole_num_mole
	  elseif(str_comp(cpara(2),'last',1,lpara(2),5)) then
	    istart = mole_num_mole
	    iend   = mole_num_mole
c
c------	--List molecular environment
c
	  elseif(str_comp(cpara(2),'envi',1,lpara(2),4)) then
	    write (output_io,3000)
	    do i=1,mole_env(0)
	      write (output_io,3000) mole_env(i),mole_type(mole_env(i))
	      do j=1,mole_len(i)
	        k = mole_cont(mole_off(i)+j)
	        at_name_d = at_name(cr_iscat(k))
	        write (output_io,3010) at_name_d,k,
     &	          cr_pos(1,k),cr_pos(2,k),cr_pos(3,k),
     &	          cr_dw(cr_iscat(k))
	      enddo
	    enddo
	    return
	  else
	    call ber_params(ianz,cpara,lpara,werte,maxw)
	    if (ier_num.ne.0) return
	    if (ianz.eq.2) then
	      istart = nint(werte(2))
	      iend   = istart
	    else
	      istart = nint(werte(2))
	      iend   = nint(werte(3))
	    endif
	    istart = max(istart,1)
	    iend   = min(iend,mole_num_mole)
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	do i=istart,iend
	  write (output_io,3000) i,mole_type(i)
	  do j=1,mole_len(i)
	    k = mole_cont(mole_off(i)+j)
	    at_name_d = at_name(cr_iscat(k))
	    write (output_io,3010) at_name_d,k,
     &	      cr_pos(1,k),cr_pos(2,k),cr_pos(3,k),
     &	      cr_dw(cr_iscat(k))
	  enddo
	enddo
c
3000	format(/' Molecule Number: ',i11,' Type: ',i11/
     &	' Name',11x,'Number',6x,'x',13x,'y',13x,'z',15x,'B')
3010	format(1x,a9,i11,1x,3(2x,f12.6),4x,f10.6)
	end
c*****7*****************************************************************
	subroutine do_show_scat(ianz,cpara,lpara,werte,maxw)
c-
c	Shows the scattering curve of an atom type.
c+
	implicit       none
c
	include       'config.inc'
	include       'prompt.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'errlist.inc'
	include       'diffuse.inc'
	include       'molecule.inc'
c
	integer        maxw
c
	character*200  cpara(maxw)
	integer        ianz
	integer        lpara(maxw)
	real           werte(maxw)
c
	logical        lold
	parameter     (lold=.false.)
c
	integer        i,j
c
	character*9    at_name_d
	character*9    at_name
c
	logical        latom(0:MAXSCAT)
c
	do i=2,ianz
	  cpara(i-1) = cpara(i)
	  lpara(i-1) = lpara(i)
	enddo
	ianz = ianz - 1
c
	call dlink(lxray,ano,lambda,rlambda)
c
	do i=0,cr_nscat
	  latom(i) = .false.
	enddo
	call get_iscat(ianz,cpara,lpara,werte,maxw,lold)
	if(ier_num.eq.0) then
	  if(werte(1).eq.-1) then
	    do i=0,cr_nscat
	      latom(i) = .true.
	    enddo
	  else
	    do i=1,ianz
	      latom(nint(werte(i))) = .true.
	    enddo
	  endif
	endif
	if(lxray) then
	  write (output_io,3000) 'Xray',lambda,rlambda
	else
	  write (output_io,3000) 'Neutronen',lambda,rlambda
	endif
	if(ano) then
	  write (output_io,3005) 'calculated'
	else
	  write (output_io,3005) 'ignored'
	endif
	do i=0,cr_nscat
	  if(latom(i)) then
	    at_name_d = at_name((i))
	    write (output_io,3010) at_name_d,(cr_scat(2*j,i),j=1,4),
     &	                  (cr_scat(2*j+1,i),j=1,4),
     &	                   cr_scat(1,i),
     &	                   cr_delfr(i),cr_delfi(i)
	endif
	enddo
c
3000	format(' Scattering technique : ',a/
     &	       ' Wave length symbol   : ',a/
     &	       ' Wave length          : ',f7.5)
3005	format(' Anomalous scat.      : ',a/)
3010	format(1x,a9,    'a(i)        : ',4(f12.7,2x)/
     &	       '          b(i)        : ',4(f12.7,2x)/
     &	       '          c           : ',  f12.7/
     &	    '          f'',f''''      : ',2(f12.7,2x)/)
c
	end
