	subroutine stack
c+
c	This subroutines contain the generator for stacking faults.
c	The menu defines the names of the files containing the different 
c	levels. The subroutine generates the sequence of levels and the 
c	list of corresponding origins. Optionally the whole crystal is 
c	created.
c
c	Version : 2.0
c	Date    : 05 Oct 96
c
c	Author  : R.B. Neder  (reinhard.neder@mail.uni-wuerzburg.de)
c-
	implicit      none
c
	include       'config.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'diffuse.inc'
	include       'doact.inc'
	include       'errlist.inc'
	include       'learn.inc'
	include       'macro.inc'
	include       'prompt.inc'
	include       'stack.inc'
c
	integer        maxw
	parameter     (maxw=MAXSCAT)
	logical        lnew,lold
	parameter     (lnew=.true.,lold=.false.)
c
	character*5    befehl
	character*12   prom
	character*200  line,zeile,cpara(maxw)
	integer        lpara(maxw),lp,length,lbef
	integer        indxg,ianz,i,j,k
	logical        lend,linit
	real           werte(maxw)
c
	logical        str_comp
c
	include       'microsta.inc'
c
	data linit/.true./
c
	lend=.false.
	call no_error
c
	if(linit) then
	  do k=1,ST_MAXTYPE
	    st_corr(k,k) = 1.0
	  enddo
	  linit = .false.
	endif
c
	do while (.not. lend)
	  prom=prompt//'/stack'
	  call get_command (line,length,befehl,lbef,zeile,lp,prom)
	  if(ier_num.eq.0) then
	  if(line.ne.' ' .and. line(1:1).ne.'#') then
c
c------	----search for "="
c
	    indxg=index(line,'=')
	    if(indxg.ne.0 
     &	              .and. .not.(str_comp(befehl,'echo',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'syst',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'help',2,lbef,4) .or.
     &	                          str_comp(befehl,'?   ',2,lbef,4)))then
c
c------	------evaluate an expression and assign the value to a variable
c
	      call do_math(line,indxg,length)
	    else
c
c------ ----execute a macro file
c
            if(befehl(1:1).eq.'@') then
	      if(length.ge.2) then
	        call file_kdo(line(2:length),length-1)
	      else
	        ier_num = -13
	        ier_typ = ER_MAC
	      endif
c
c------	----Determine if average translation is calculated or set 'aver'
c
	    elseif(str_comp(befehl,'aver',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.3) then
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            do i=1,3
	              st_t_aver(i) = werte(i)
	            enddo
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----Read a single collumn of the correlation matrix 'ccolumn'
c
	    elseif(str_comp(befehl,'ccol',2,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(st_ntypes.lt.ianz .and. ianz.le.ST_MAXTYPE+1) then
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            i            = nint(werte(1))
	            if(0.lt.i  .and. i.le.ST_MAXTYPE ) then
	              do j= 1,ianz-1
	                st_corr(j,i) = werte(j+1)
	              enddo
	            else
	              ier_num = -13
	              ier_typ = ER_APPL
	            endif
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----Read a single element of the correlation matrix 'celement'
c
	    elseif(str_comp(befehl,'cele',2,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.3) then
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            i            = nint(werte(1))
	            j            = nint(werte(2))
	            if( 0.lt.i .and. i.le.ST_MAXTYPE  .and.
     &	                0.lt.j .and. j.le.ST_MAXTYPE       ) then
	              st_corr(i,j) = werte(3)
	            else
	              ier_num = -13
	              ier_typ = ER_APPL
	            endif
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----continues a macro 'continue'
c
	    elseif(str_comp(befehl,'continue',3,lbef,8)) then
	      call macro_continue(zeile,lp)
c
c------	----create list of origins 'create'
c
	    elseif(str_comp(befehl,'crea',3,lbef,4)) then
 	      call do_stack_create
c
c------	----Read a single row of the correlation matrix 'crow'
c
	    elseif(str_comp(befehl,'crow',3,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(st_ntypes.lt.ianz .and. ianz.le.ST_MAXTYPE+1) then
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            j            = nint(werte(1))
	            if(0.lt.j .and. j.le.ST_MAXTYPE) then
	            do i=1,ianz-1
	              st_corr(j,i) = werte(i+1)
	            enddo
	            else
	              ier_num = -13
	              ier_typ = ER_APPL
	            endif
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----Define distribution type 
c
	    elseif(str_comp(befehl,'dist',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ianz.ge.1) then
	        if(str_comp(cpara(1),'matrix',1,lpara(1),6)) then
	          st_distr = ST_DIST_MATRIX
	        elseif(str_comp(cpara(1),'file',1,lpara(1),4)) then
	          if(ianz.gt.1) then
	            call do_build_name(ianz,cpara,lpara,werte,maxw,2)
	            if(ier_num.eq.0) then
	              st_distr    = ST_DIST_FILE
	              st_infile   = cpara(2)
	              st_infile_l = lpara(2)
	            endif
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ ----Echo a string, just for interactive check in a macro 'echo'
c
	    elseif(str_comp(befehl,'echo',2,lbef,4)) then
	      call echo(zeile,lp)
c
c------	 ---Evaluate an expression, just for interactive check 'eval'
c
	    elseif(str_comp(befehl,'eval',2,lbef,4)) then
	      call do_eval(zeile,lp)
c
c------	----exit 'exit'
c
	    elseif(str_comp(befehl,'exit',2,lbef,4)) then
	      lend=.true.
c
c------	 ---Calculate the Fourier transform of the decorated s.f. 'fourier'
c
	    elseif(str_comp(befehl,'four',1,lbef,4)) then
	      four_log = .true.
	      call st_fourier
c
c------	----help 'help','?'
c
	    elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	           str_comp(befehl,'?   ',1,lbef,4)     ) then
	      if(str_comp(zeile,'errors',2,lp,6) ) then
	        lp = lp + 7
	        call do_hel('discus '//zeile,lp)
	      else
	        lp = lp + 12
	        call do_hel('discus stack '//zeile,lp)
	      endif
c
c------	----read the name of a new layer type                'layer'
c
	    elseif(str_comp(befehl,'laye',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.1) then
	          if(st_ntypes.lt.ST_MAXTYPE) then
	            st_ntypes = st_ntypes + 1
	            st_layer (st_ntypes) = cpara(1)
	            st_llayer(st_ntypes) = lpara(1)
	            do i=1,st_nchem
	              if(cpara(1).eq.st_layer_c(i)) then
	                st_chem(st_ntypes) = i
	                goto 5000
	              endif
	            enddo
	            st_nchem             = st_nchem + 1
	            st_chem(st_ntypes)   = st_nchem
	            st_layer_c(st_nchem) = cpara(1)
5000	            continue
	          else
	            ier_num = -53
	            ier_typ = ER_APPL
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----read the modulus for the translation             'modulus'
c
	    elseif(str_comp(befehl,'modu',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.6) then
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            do i=1,3
	              st_mod(i,1) = werte(i  )
	              st_mod(i,2) = werte(i+3)
	            enddo
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----read the number of layers to be created in the crystal 'number'
c
	    elseif(str_comp(befehl,'numb',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.1) then
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            i = nint(werte(1))
	            if(i.lt.ST_MAXLAYER) then
	              st_nlayer = i
	            else
	              ier_num = -54
	              ier_typ = ER_APPL
	            endif
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----reset stacking faults 'rese'
c
	    elseif(str_comp(befehl,'rese',2,lbef,4)) then
 	      call do_stack_rese
c
c------	----Select values for random stacking faults 'random'
c
	    elseif(str_comp(befehl,'random',2,lbef,6)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(str_comp(cpara(1),'prob',1,lpara(1),4)) then
c
c------	----------Random stacking fault probability		
c
	          if(ianz.eq.2) then
	            cpara(1) = '0'
	            lpara(1) = 1
	            call ber_params(ianz,cpara,lpara,werte,maxw)
	            if(ier_num.eq.0) then
	              st_prob = werte(2)
	            endif
	          endif
	        elseif(str_comp(cpara(1),'offset',1,lpara(1),6)) then
c
c------	----------Random stacking fault offset
c
	          if(ianz.eq.4) then
	            cpara(1) = '0'
	            lpara(1) = 1
	            call ber_params(ianz,cpara,lpara,werte,maxw)
	            if(ier_num.eq.0) then
	              do i=1,3
	                st_off(i) = werte(i+1)
	              enddo
	            endif
	          endif
	        elseif(str_comp(cpara(1),'sigma',1,lpara(1),5)) then
c
c------	----------Random stacking fault sigma for offset
c
	          if(ianz.eq.4) then
	            cpara(1) = '0'
	            lpara(1) = 1
	            call ber_params(ianz,cpara,lpara,werte,maxw)
	            if(ier_num.eq.0) then
	              do i=1,3
	                st_sigma_off(i) = werte(i+1)
	              enddo
	            endif
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Select values for rotational disorder    'rotation'
c
	    elseif(str_comp(befehl,'rotation',2,lbef,8)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(str_comp(cpara(1),'mode',1,lpara(1),4)) then
c
c------	----------Mode of rotations "all" or only in case of "stacking fault"
c
	          if(ianz.eq.2) then
	            if(str_comp(cpara(2),'all',1,lpara(2),3)) then
		      st_rot_mode = .true.
	            elseif(str_comp(cpara(2),'fault',1,lpara(2),5)) then
		      st_rot_mode = .false.
		    else
	              ier_num = -6
	              ier_typ = ER_COMM
		    endif
		  else
	            ier_num = -6
	            ier_typ = ER_COMM
		  endif
	        elseif(str_comp(cpara(1),'axis',1,lpara(1),4)) then
	          cpara(1) = '0'
	          lpara(1) = 1
c
c------	----------Direction of in-plane vector 1
c
	          if(str_comp(cpara(2),'mod1',4,lpara(2),4)) then
	            cpara(2) = '0'
	            lpara(2) = 1
c
c------	----------Direction of in-plane vector 1
c
	            if(ianz.eq.5 .or. ianz.eq.6) then
		      if(ianz.eq.5) then
		        cpara(6) = 'd'
		        lpara(6) = 1
	              endif
		      ianz = 5
	              call ber_params(ianz,cpara,lpara,werte,maxw)
	              if(ier_num.eq.0) then
	                st_rot_m1(1) = werte(3)
	                st_rot_m1(2) = werte(4)
	                st_rot_m1(3) = werte(5)
	              endif
	              if(str_comp(cpara(6),'d',1,lpara(6),1)) then
		        st_rot_m1_lspace = .true.
	              elseif(str_comp(cpara(6),'r',1,lpara(6),1)) then
		        st_rot_m1_lspace = .false.
		      else
	                ier_num = -6
	                ier_typ = ER_COMM
	  	      endif
		    else
	              ier_num = -6
	              ier_typ = ER_COMM
	            endif
	          elseif(str_comp(cpara(2),'mod2',4,lpara(2),4)) then
c
c------	----------Direction of in-plane vector 2
c
	            cpara(2) = '0'
	            lpara(2) = 1
	            if(ianz.eq.5 .or. ianz.eq.6) then
		      if(ianz.eq.5) then
		        cpara(6) = 'd'
		        lpara(6) = 1
	              endif
		      ianz = 5
	              call ber_params(ianz,cpara,lpara,werte,maxw)
	              if(ier_num.eq.0) then
	                st_rot_m2(1) = werte(3)
	                st_rot_m2(2) = werte(4)
	                st_rot_m2(3) = werte(5)
	              endif
	              if(str_comp(cpara(6),'d',1,lpara(6),1)) then
		        st_rot_m2_lspace = .true.
	              elseif(str_comp(cpara(6),'r',1,lpara(6),1)) then
		        st_rot_m2_lspace = .false.
		      else
	                ier_num = -6
	                ier_typ = ER_COMM
		      endif
		    else
	              ier_num = -6
	              ier_typ = ER_COMM
	            endif
	          elseif(str_comp(cpara(2),'normal',1,lpara(2),6)) then
c
c------	----------Direction of in-plane vector 1
c
	            cpara(2) = '0'
	            lpara(2) = 1
	            if(ianz.eq.5 .or. ianz.eq.6) then
		      if(ianz.eq.5) then
		        cpara(6) = 'd'
		        lpara(6) = 1
	              endif
		      ianz = 5
	              call ber_params(ianz,cpara,lpara,werte,maxw)
	              if(ier_num.eq.0) then
	                st_rot_no(1) = werte(3)
	                st_rot_no(2) = werte(4)
	                st_rot_no(3) = werte(5)
	              endif
	              if(str_comp(cpara(6),'d',1,lpara(6),1)) then
		        st_rot_no_lspace = .true.
	              elseif(str_comp(cpara(6),'r',1,lpara(6),1)) then
		        st_rot_no_lspace = .false.
		      else
	                ier_num = -6
	                ier_typ = ER_COMM
		      endif
		    else
	              ier_num = -6
	              ier_typ = ER_COMM
	            endif
		  else
	            ier_num = -6
	            ier_typ = ER_COMM
		  endif
	        elseif(str_comp(cpara(1),'sigma',1,lpara(1),5)) then
c
c------	----------Sigmas of oscillation around the three axes
c
	          if(ianz.eq.3) then
	            cpara(1) = '0'
	            lpara(1) = 1
	            if(str_comp(cpara(2),'normal',1,lpara(2),5)) then
		      cpara(2) = '0'
		      lpara(2) = 1
	              call ber_params(ianz,cpara,lpara,werte,maxw)
	              if(ier_num.eq.0) then
	                st_rot_si_no = werte(3)
	              endif
	            elseif(str_comp(cpara(2),'mod1',4,lpara(2),4)) then
		      cpara(2) = '0'
		      lpara(2) = 1
	              call ber_params(ianz,cpara,lpara,werte,maxw)
	              if(ier_num.eq.0) then
	                st_rot_si_m1 = werte(3)
	              endif
	            elseif(str_comp(cpara(2),'mod2',4,lpara(2),4)) then
		      cpara(2) = '0'
		      lpara(2) = 1
	              call ber_params(ianz,cpara,lpara,werte,maxw)
	              if(ier_num.eq.0) then
	                st_rot_si_m2 = werte(3)
	              endif
                    else
	              ier_num = -6
	              ier_typ = ER_COMM
	            endif
		  else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        elseif(str_comp(cpara(1),'status',2,lpara(1),6)) then
c
c------	----------Switch status of rotational disorder "on" or "off"
c
	          if(ianz.eq.2) then
	            if(str_comp(cpara(2),'on',2,lpara(2),2)) then
		      st_rot_status = .true.
	            elseif(str_comp(cpara(2),'off',2,lpara(2),3)) then
		      st_rot_status = .false.
		    else
	              ier_num = -6
	              ier_typ = ER_COMM
		    endif
		  else
	            ier_num = -6
	            ier_typ = ER_COMM
		  endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----run stacking faults 'run'
c
	    elseif(str_comp(befehl,'run ',2,lbef,4)) then
 	      call do_stack_fill
c
c------	----Set parameters                    'set'
c
	    elseif(str_comp(befehl,'set',2,lbef,3)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(str_comp(cpara(1),'aver',1,lpara(1),4)) then
	          if(ianz.eq.2) then
	            call del_params (1,ianz,cpara,lpara,maxw)
	            ianz = 1
	            call ber_params (ianz,cpara,lpara,werte,maxw)
	            if(ier_num.eq.0) then
	              st_aver = werte(1)
	            endif
	          elseif(ianz.eq.1) then
	            st_aver = 0.0
	          else
	            ier_num = -6
                    ier_typ = ER_COMM
	          endif
	        elseif(str_comp(cpara(1),'modu',1,lpara(1),4)) then
	          if(ianz.eq.2) then
	            if(str_comp(cpara(2),'off',2,lpara(2),3)) then
	              st_mod_sta = .false.
	            elseif(str_comp(cpara(2),'on',2,lpara(2),2)) then
	              st_mod_sta = .true.
	            else
	              ier_num = -6
                      ier_typ = ER_COMM
	            endif
	          else
	            ier_num = -6
                    ier_typ = ER_COMM
	          endif
	        elseif(str_comp(cpara(1),'tran',1,lpara(1),4)) then
	          if(ianz.eq.2) then
	            if(str_comp(cpara(2),'aver',1,lpara(2),4)) then
	              st_tra_aver = .true.
	            elseif(str_comp(cpara(2),'fixed',1,lpara(2),5)) then
	              st_tra_aver = .false.
	            else
	              ier_num = -6
                      ier_typ = ER_COMM
	            endif
	          else
	            ier_num = -6
                    ier_typ = ER_COMM
	          endif
	        else
	          ier_num = -6
                  ier_typ = ER_COMM
	        endif
	      endif
c
c------	----show current parameters 'show'
c
	    elseif(str_comp(befehl,'show',2,lbef,4)) then
	      write (output_io,3000)
	      if(st_aver.eq.0.0) then
	        write (output_io,3005)
	      else
	        write (output_io,3006)
	      endif
	      if(st_distr .eq. ST_DIST_MATRIX ) then
	        write (output_io,3007)
	      elseif(st_distr .eq. ST_DIST_FILE ) then
	        write (output_io,3008) st_infile(1:st_infile_l)
	      endif
	      write (output_io,3009) st_ntypes
	      write (output_io,3010)
	      do i=1,st_ntypes
	        write (output_io,3020) i,st_layer(i)(1:st_llayer(i))
	      enddo
	      write (output_io,3030)
	      do i=1,st_ntypes
	        do j=1,st_ntypes
	          write (output_io,3040) i,j,(st_trans(i,j,k),k=1,3),
     &	                            (st_sigma(i,j,k),k=1,3)
	        enddo
	        write (output_io,*)
	      enddo
	      if(st_tra_aver) then
	        write (output_io,3041)
	      else
	        write (output_io,3042) (st_t_aver(i),i=1,3)
	      endif
	      if(st_mod_sta) then
	        write (output_io,3043)
	      else
	        write (output_io,3044)
	      endif
	      write (output_io,3045) ((st_mod(i,j),i=1,3),j=1,2)
	      write (output_io,3050)
	      do i=1,st_ntypes
	        write (output_io,3060) (st_corr(i,j),j=1,st_ntypes)
	      enddo
	      write (output_io,3070) st_nlayer
	      write (output_io,3080) st_prob
	      write (output_io,3090) st_off,st_sigma_off
	      if(st_rot_status) then
	        write (output_io,3100) 
	      else
	        write (output_io,3101) 
	      endif
	      if(st_rot_mode) then
	       	write (output_io,3110)
	      else
	        write (output_io,3120) 
	      endif
	      if(st_rot_no_lspace) then
	        write (output_io,3140) st_rot_no,'d',st_rot_si_no
	      else
	        write (output_io,3140) st_rot_no,'r',st_rot_si_no
	      endif
	      if(st_rot_m1_lspace) then
	        write (output_io,3140) st_rot_m1,'d',st_rot_si_m1
	      else
	        write (output_io,3140) st_rot_m1,'r',st_rot_si_m1
	      endif
	      if(st_rot_m2_lspace) then
	        write (output_io,3140) st_rot_m2,'d',st_rot_si_m2
	      else
	        write (output_io,3140) st_rot_m2,'r',st_rot_si_m2
	      endif
c
c------	----Select sigmas of translational vector 'sigma'
c
	    elseif(str_comp(befehl,'sigma',2,lbef,5)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.5) then
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            i = nint(werte(1))
	            j = nint(werte(2))
	            if(0.lt.i .and. i.le.ST_MAXTYPE  .and.
     &	               0.lt.j .and. j.le.ST_MAXTYPE        ) then
	              do k=1,3
	                st_sigma(i,j,k) = werte(k+2)
	              enddo
	            else
	              ier_num = - 54
	              ier_typ = ER_APPL
	            endif
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Select translational vector 'trans'
c
	    elseif(str_comp(befehl,'trans',1,lbef,5)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.5) then
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            i = nint(werte(1))
	            j = nint(werte(2))
	            if(0.lt.i .and. i.le.ST_MAXTYPE  .and.
     &	               0.lt.j .and. j.le.ST_MAXTYPE        ) then
	              do k=1,3
	                st_trans(i,j,k) = werte(k+2)
	              enddo
	            else
	              ier_num = -54
	              ier_typ = ER_APPL
	            endif
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------- -Operating System Kommandos 'syst'
c
	  elseif(str_comp(befehl,'syst',2,lbef,4)) then
	    if(zeile.ne. ' ') then
	      call do_operating(zeile(1:lp),lp)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c
c------  -----waiting for user input
c
	    elseif(str_comp(befehl,'wait',3,lbef,4)) then
	      call do_input(zeile,lp)
c
c------	----Unknown command
c
	    else
	      ier_num = -8
	      ier_typ = ER_COMM
	    endif
	    endif
	  endif
	  endif
	  if(ier_num.ne.0) then
	    call errlist
	    if(lmakro) then
	      call macro_close
	      prompt_status = PROMPT_ON
	    endif
	    if(lblock) then
	      ier_num = -11
	      ier_typ = ER_COMM
	      return
	    endif
	    call no_error
	  endif
	enddo
c
9999	continue
c
3000	format(/30x,' Generalized Stacking Faults'/
     &	        30x,' ==========================='/)
3005	format(' Fourier Mode               : ','turbo Fourier')
3006	format(' Fourier Mode               : ','turbo Fourier - <F>')
3007	format(' Distribution of layer types: ','correlation matrix')
3008	format(' Distribution of layer types: ','file',/,
     &	       '                 input file : ',a)
3009	format(' Number of different Layers : ',  2x,i4   )
3010	format(' Names of Layers            : '           )
3020	format('                            : ',i4,1x,a   )
3030	format(' Translations between layers:    Pairs  ',12x,
     &	       'Vectors /  Sigma')
3040	format('                            : ',
     &	        i4,2x,i4,1x,3(2x,f9.4)/41x,3(2x,f9.4))
3050	format(' Correlation Matrix         : '           )
3060	format('                            : ',8(2x,f9.4))
3041	format(' Average translation        : calculated')
3042	format(' Average translation        : ',3(2x,f9.4))
3043	format(' Apply modulo function      : YES')
3044	format(' Apply modulo function      : NO')
3045	format(' Modulus of translation     : ',3(2x,f9.4)/
     &	       '                              ',3(2x,f9.4) )
3070	format(/' Number of layers in crystal:',  2x,i4   )
3080	format(/' Prob.  of random faults    : ',  2x,f9.4 )
3090	format(' Offset of random faults    : ',3(2x,f9.4)/
     &	       ' Sigma  of offset, random   : ',3(2x,f9.4) )
3100	format(/' Rotational disorder        : on')
3101	format(/' Rotational disorder        : off')
3110	format('     affects                : ',
     &	       '  all layers individually')
3120	format('     affects                :  only stacking faults ')
3130	format('     normal         ,sigma  : ',3(2x,f9.4),4x,f9.4 )
3140	format('     axis in-plane 1,sigma  : ',3(2x,f9.4),2x,a1,2x,
     &	       f9.4 )
3150	format('     axis in-plane 2,sigma  : ',3(2x,f9.4),4x,f9.4 )
c
	end
c*****7*****************************************************************
	subroutine do_stack_create
c-
c	Creates the list of origins for the crystal with stacking faults
c+
	implicit      none
c
	include       'config.inc'
	include       'prompt.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'errlist.inc'
	include       'param.inc'
	include       'random.inc'
	include       'stack.inc'
	include       'stack_cr.inc'
c
	integer       i,j,k
	logical       lprev
	real          prob  (ST_MAXTYPE)
	real          prob_n(ST_MAXTYPE)
	real          ptot_n
	real          u(3),v(3)
	real          r1,r2
	real          st_trans_cur(3)
c
	real          gasdev
	real          ran1
c
	call no_error
c
c------	reset counter for number of each layer type
c
	do i=1,ST_MAXTYPE
	  st_number(i) = 0
	enddo
c
c------	Read layer types from file or create from probability matrix
c
	if(st_distr.eq.ST_DIST_MATRIX) then
c
c------	  Set up initial probabilities
c
	  call st_init_prob(ptot_n,prob_n)
	  if(ptot_n.eq.0.0) then
	    ier_num = -39
	    ier_typ = ER_APPL
	    return
	  endif
c
c------	  The first layer is determined by random weighted choice
c
	  lprev = .false.
	  i     = 1
	  call stack_prob(ptot_n,prob,prob_n,lprev,i)
	  call stack_type(prob,i)
	  st_origin(1,1) = 0.0
	  st_origin(2,1) = 0.0
	  st_origin(3,1) = 0.0
	  st_number(st_type(1)) = 1
	elseif(st_distr.eq.ST_DIST_FILE) then
c
c------	--Stacking fault origins are read from file
c
	  call stack_dist_file(cr_spcgr,cr_a0,cr_win,cr_dim,
     &	            st_name,st_spcgr,
     &	            st_a0,st_win,st_natoms,st_nscat,
     &	            st_dw,st_at_lis,st_pos,st_iscat,
     &	            st_dim,
     &               sa_natoms,sa_at_lis,sa_dw,sa_pos,sa_iscat)
	  st_type(1) = st_iscat(1)
	  st_nlayer  = st_natoms
CDBG
CDBG	write (output_io,*) 'st_natoms ', st_natoms
	endif
	write (output_io,2000) ' Origins',st_type(1)
     &	              ,st_origin(1,1),st_origin(2,1),
     &	                      st_origin(3,1)
c
c------	Determine average translation
c
	if(st_tra_aver) then
	  do i=1,3
	    st_mod(i,3) = 0.0
	  enddo
	  do i=1,st_ntypes
	    do j=1,st_ntypes
	      do k=1,3
	        st_mod(k,3) = st_mod(k,3) + 
     &	                      st_corr(i,j)*st_trans(i,j,k)
	      enddo
	    enddo
	  enddo
	  do i=1,3
	    st_mod(i,3) = st_mod(i,3) / ptot_n
	  enddo
	  if(st_mod(1,3).eq.0.0 .and. st_mod(2,3).eq.0.0 .and.
     &	     st_mod(3,3).eq.0.0 ) then
	    ier_num = -57
	    ier_typ = ER_APPL
	    return
	  endif
	else
	  do i=1,3
	    st_mod(i,3) = st_t_aver(i)
	  enddo
	endif
c
c------	Calculate inverse modulus matrix
c
	do i=1,3
	  do j=1,3
	    st_inv(i,j) = st_mod(i,j)
	  enddo
	enddo
	call invmat(st_inv,st_mod)
	if(ier_num.eq.-1) then
	  call no_error
	  ier_num = -56
	  ier_typ = ER_APPL
	  return
	endif
c
c------	--Initialise rotation disorder
c
	i = 1
	if(st_rot_status) then
	  st_rot_ang_no(i) = gasdev(st_rot_si_no)
	  st_rot_ang_m1(i) = gasdev(st_rot_si_m1)
	  st_rot_ang_m2(i) = gasdev(st_rot_si_m2)
	endif
c
c------	Loop over all layers
c
CDBG
	write (output_io,*) ' Start Loop'
	do i=2,st_nlayer
c
c------	--Determine whether random or regular stacking fault
c
	  if(st_distr.eq.ST_DIST_MATRIX) then
	    if(ran1(idum).lt.st_prob) then
c
c------	----Determine layer type from probabilities disregarding previous layer
c
	      lprev = .false.
	      call stack_prob(ptot_n,prob,prob_n,.false.,i)
	      call stack_type(prob,i)
	    else
c
c------	----Determine layer type from probabilities using last layer
c
	      lprev = .true.
	      call stack_prob(ptot_n,prob,prob_n,lprev,i-1)
	      call stack_type(prob,i)
	    endif
	  elseif(st_distr.eq.ST_DIST_FILE) then
c
c------	--Stacking fault types are read from file
c
	    lprev = .true.
	    st_type(i) = st_iscat(i)
	  endif
c
c------	--Determine current translation vector
c
	  st_trans_cur(1) = st_trans(st_type(i-1),st_type(i),1) +
     &	             gasdev(st_sigma(st_type(i-1),st_type(i),1))
	  st_trans_cur(2) = st_trans(st_type(i-1),st_type(i),2) +
     &	             gasdev(st_sigma(st_type(i-1),st_type(i),2))
	  st_trans_cur(3) = st_trans(st_type(i-1),st_type(i),3) +
     &	             gasdev(st_sigma(st_type(i-1),st_type(i),3))
CDBG
CDBG	if(i.eq.2) then
CDBG	write (output_io,*) ' Translation vector',i,st_type(i)
CDBG     &	              ,st_trans_cur(1),st_trans_cur(2),
CDBG     &	                      st_trans_cur(3)
CDBG	endif
c
c------	--Initialise rotation disorder
c
	  if(st_rot_status) then
CDBG
	if(i.eq.2) then
	write (output_io,*) ' im rotation mode'
	endif
c
c------	----Set new rotation angles for all layers or
c	    only if the last layer was different than the current
c
	    if(st_rot_mode) then
	      st_rot_ang_no(i) = gasdev(st_rot_si_no)
	      st_rot_ang_m1(i) = gasdev(st_rot_si_m1)
	      st_rot_ang_m2(i) = gasdev(st_rot_si_m2)
	    else
	      if(st_type(i).ne.st_type(i-1)) then
	        st_rot_ang_no(i) = gasdev(st_rot_si_no)
	        st_rot_ang_m1(i) = gasdev(st_rot_si_m1)
	        st_rot_ang_m2(i) = gasdev(st_rot_si_m2)
	      else
	        st_rot_ang_no(i) = st_rot_ang_no(i-1)
		st_rot_ang_m1(i) = st_rot_ang_m1(i-1)
		st_rot_ang_m2(i) = st_rot_ang_m2(i-1)
	      endif
	    endif
c
c------	----Rotate translation vector around normal
c
	    if(st_rot_si_no.gt.0.0) then
	      call stack_rot_setup('normal',6,1,i-1,.false.)
	      call symm_setup
	      call symm_ca_single(st_trans_cur,.true.)
	      do j=1,3
	        st_trans_cur(j) = res_para(j)
	      enddo
	    endif
c
c------	----Rotate translation vector around mod1
c
	    if(st_rot_si_m1.gt.0.0) then
	      call stack_rot_setup('mod1',4,1,i-1,.false.)
	      call symm_setup
	      call symm_ca_single(st_trans_cur,.true.)
	      do j=1,3
	        st_trans_cur(j) = res_para(j)
	      enddo
	    endif
c
c------	----Rotate translation vector around mod2
c
	    if(st_rot_si_m2.gt.0.0) then
	      call stack_rot_setup('mod2',4,1,i-1,.false.)
	      call symm_setup
	      call symm_ca_single(st_trans_cur,.true.)
	      do j=1,3
	        st_trans_cur(j) = res_para(j)
	      enddo
	    endif
	  endif
c
c------	--Add translation vector to last origin
c
	  st_origin(1,i) = st_origin(1,i-1) + st_trans_cur(1)
	  st_origin(2,i) = st_origin(2,i-1) + st_trans_cur(2)
	  st_origin(3,i) = st_origin(3,i-1) + st_trans_cur(3)
	  if(.not.lprev) then
CDBG
	if(i.eq.2) then
	write (output_io,*) ' im random mode'
	endif
c
c------	----This is a random stacking fault, add random position
c
	    r1=ran1(idum)
	    r2=ran1(idum)
	    do j=1,3
	      st_origin(j,i) = st_origin(j,i)  + 
     &	                       r1 *st_mod(j,1) +
     &	                       r2 *st_mod(j,2) +
     &	                           st_off(j)   +
     &	                       gasdev(st_sigma_off(j))
	    enddo
	  endif
c
c------	--If necessary apply modulo function
c
	  if(st_mod_sta ) then
	    do j=1,3
	      v(j) = st_origin(j,i) - st_origin(j,1)
	    enddo
	    call trans(v,st_inv,u,3)
	    do j=1,3
	      st_origin(j,i) = st_origin(j,i) - 
     &	                       float(int(u(1)))*st_mod(j,1) -
     &	                       float(int(u(2)))*st_mod(j,2)
	    enddo
	  endif
c
c------	--Increment number of layers of this type
C
	  st_number(st_type(i)) = st_number(st_type(i)) + 1
	write (output_io,2000) ' Origins',st_type(i)
     &	              ,st_origin(1,i),st_origin(2,i),
     &	                      st_origin(3,i)
	enddo
c
c	do i=1,st_ntypes
c	  write (output_io,2020) i,st_number(i)
c	enddo
2000	format(a,i4,3f9.4)
2020	format(i4,2x,i8)
	end
c*****7*****************************************************************
	subroutine st_init_prob(ptot_n,prob_n)
c-
c	Determines the probabilities from the correlation matrix
c+
	implicit       none
c
	include       'config.inc'
	include       'stack.inc'
c
	integer        i,j
	real           prob_n(ST_MAXTYPE)
	real           ptot_n
c
	ptot_n    = 0.0
	do i = 1,st_ntypes
	  prob_n(i) = 0.0
	  do j = 1,st_ntypes
	    prob_n(i) = prob_n(i) + st_corr(j,i)
	    ptot_n    = ptot_n    + st_corr(j,i)
	  enddo
	enddo
c
	end
c*****7*****************************************************************
	subroutine stack_prob(ptot_n,prob,prob_n,lprev,l)
c-
c      	Set up the cummulative probabilities. 
c	if a previous layer exists, add probabilities
c	according to the correlation matrix, else 
c	an average probality for the
c	specific layer type i.e. sum corr(i,m) /st_type
c	is added.
c+
	implicit       none
c
	include       'config.inc'
	include       'stack.inc'
c
	integer        m,l
	logical        lprev
	real           prob  (ST_MAXTYPE),ptot_n
	real           prob_n(ST_MAXTYPE)
c
	if(lprev) then
	  do m=1,st_ntypes
	    prob(m) = st_corr(st_type(l),m)
	  enddo
	else
	  do m=1,st_ntypes
	    prob(m) = prob_n(m)/ptot_n
	  enddo
	endif
c
	end
C*****7*****************************************************************
	subroutine stack_type(prob,i)
c-
c	Determine type of layer from weighted probabilities
c+
	implicit       none
c
	include       'config.inc'
	include       'stack.inc'
	include       'random.inc'
	include       'errlist.inc'
c
	real           prob(ST_MAXTYPE)
c
	integer        i,m
	real           ad,s,ptot
	real           ran1
c
	ptot = 0.0
	do m=1,st_ntypes
	  ptot = ptot + prob(m)
	enddo
	ad = ran1(idum)*ptot
	s  = prob(1)
	m  = 1
c
	do while( s.lt.ad .and. m.lt.st_ntypes)
	  m = m + 1
	  s = s + prob(m)
	enddo
	st_type(i) = m
c	write (output_io,*) ' st Type(i) ',i,st_type(i)
c
	end
C*****7*****************************************************************
	subroutine do_stack_fill
c-
c	Creates the crystal with stacking faults
c+
	implicit      none
c
        integer       ist
        parameter    (ist=7)
c
	include       'config.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'errlist.inc'
	include       'gen_add.inc'
	include       'sym_add.inc'
	include       'save.inc'
	include       'stack.inc'
c
	integer       i,j,k
	integer       iatom
	logical       lread,lout
	logical		lcell
c
	lcell = .false.
c
c------	If there are any layers in the crystal read each layer
c
	if(st_nlayer.ge.1) then
c
c------	--The first layer is read by the full readstru routine to
c	   ensure correct lattice parameters
c
	  i    = 1
	  lout = .false.
c
c------	----read corresponding layer
c
	  call rese_cr
	  call readstru(NMAX,MAXSCAT,
     &	                    st_layer(st_type(i)),cr_name,cr_spcgr,
     &	                    cr_a0,cr_win,cr_natoms,cr_nscat,
     &	                    cr_dw,cr_at_lis,cr_pos,cr_iscat,
     &	                    cr_dim,as_natoms,as_at_lis,as_dw,
     &	                    as_pos,as_iscat,
     &	                    sav_ncell,sav_r_ncell,sav_ncatoms)
	  if(ier_num.ne.0) then
	    return
	  endif
c
	  call lattice(cr_a0,cr_ar,cr_eps,cr_gten,
     &	  cr_reps,cr_rten,cr_win,cr_wrez,cr_v,
     &	  cr_vr,lout)
c
	  iatom = 1
c
c------	--Add origin of layer
c
	  do j=iatom,cr_natoms
	    do k=1,3
	      cr_pos(k,j) = cr_pos(k,j) + st_origin(k,i)
	    enddo
	  enddo
c
c------	--Initialise rotation disorder
c
	  if(st_rot_status) then
c
c------	----Rotate layer around normal
c
	    if(st_rot_si_no.gt.0.0) then
	      call stack_rot_setup('normal',6,iatom,i,.true.)
	      call symm_setup
	      call symm_op_single
	    endif
c
c------	----Rotate layer around mod1
c
	    if(st_rot_si_m1.gt.0.0) then
	      call stack_rot_setup('mod1',4,iatom,i,.true.)
	      call symm_setup
	      call symm_op_single
	    endif
c
c------	----Rotate layer around mod2
c
	    if(st_rot_si_m2.gt.0.0) then
	      call stack_rot_setup('mod2',4,iatom,i,.true.)
	      call symm_setup
	      call symm_op_single
	    endif
	  endif
c
c------	--Loop over all layers in crystal
c
	  do i=2,st_nlayer
	    iatom = cr_natoms + 1
	    lread = .true.
c
c------	--Open file, read header
c
	    call oeffne(ist,st_layer(st_type(i)),'old',lread)
	    if(ier_num.eq.0) then
c
c------	------Read header of structure file
c
	      gen_add_n = 0
	      sym_add_n = 0
	      call stru_readheader(ist,
     &	           NMAX,MAXSCAT,lcell,
     &	           cr_name,cr_spcgr,cr_at_lis,cr_nscat,cr_dw,
     &	           cr_a0,cr_win,
     &	           sav_ncell,sav_r_ncell,sav_ncatoms)
c
	      if(ier_num.ne.0) then
	        return
	      endif
c
c------	------Now only the atoms are read
c
	      ier_num = 0
	      ier_typ = ER_NONE
c
	      call struc_read_atoms(NMAX,MAXSCAT,
     &	        cr_natoms,cr_nscat,
     &	        cr_dw,cr_at_lis,cr_pos,cr_iscat,
     &	        cr_dim,as_natoms,as_at_lis,as_dw,
     &	        as_pos,as_iscat)
	      close(ist)
	      if(ier_num.ne.0) then
	        return
	      endif
c
c------	------Add origin of layer
c
	      do j=iatom,cr_natoms
	        do k=1,3
	          cr_pos(k,j) = cr_pos(k,j) + st_origin(k,i)
	        enddo
	      enddo
c
c------	------Initialise rotation disorder
c
	      if(st_rot_status) then
c
c------	--------Rotate layer around normal
c
	        if(st_rot_si_no.gt.0.0) then
	          call stack_rot_setup('normal',6,iatom,i,.true.)
	          call symm_setup
	          call symm_op_single
	        endif
c
c------	--------Rotate layer around mod1
c
	        if(st_rot_si_m1.gt.0.0) then
	          call stack_rot_setup('mod1',4,iatom,i,.true.)
	          call symm_setup
	          call symm_op_single
	        endif
c
c------	--------Rotate layer around mod2
c
	        if(st_rot_si_m2.gt.0.0) then
	          call stack_rot_setup('mod2',4,iatom,i,.true.)
	          call symm_setup
	          call symm_op_single
	        endif
	      endif
	    else
	      return
	    endif
	  enddo
	endif
c
999	continue
	close(ist)
c
c------	Update Crystal dimension
c
	call update_cr_dim
c
2010	format(a)
	end
c*****7*****************************************************************
	subroutine stack_rot_setup(line,lbef,iatom,i,lorigin)
c-
c	performs the setup for the rotations around the different axes
c+
	implicit      none
c
	include       'config.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'stack.inc'
	include       'symm.inc'
c
	character*6    line
	integer        lbef
	integer        iatom
	integer        i,j
	logical        lorigin
	logical        str_comp
c
	include       'microsta.inc'
c
	sym_md_nr      = 0
	sym_md_s       = MD_S_EVE
	sym_power      = 1
	do j=1,cr_nscat
	  sym_latom(j) = .true.
	enddo
	sym_mode       = .false.
	sym_power_mult = .false.
	sym_type       = .true.
	sym_trans(1)   = 0.0
	sym_trans(2)   = 0.0
	sym_trans(3)   = 0.0
c
	sym_start      = iatom
	sym_end        = cr_natoms
	if(lorigin) then
	  sym_orig(1)    = st_origin(1,i)
	  sym_orig(2)    = st_origin(2,i)
	  sym_orig(3)    = st_origin(3,i)
	else
	  sym_orig(1)    = 0.0
	  sym_orig(2)    = 0.0
	  sym_orig(3)    = 0.0
	endif
c
	if(str_comp(line,'normal',1,lbef,6)) then
	  sym_angle = st_rot_ang_no(i)
	  if(st_rot_no_lspace) then
	    sym_uvw(1) = st_rot_no(1)
	    sym_uvw(2) = st_rot_no(2)
	    sym_uvw(3) = st_rot_no(3)
	    call trans(sym_uvw,cr_gten,sym_hkl,3)
	  else
	    sym_hkl(1) = st_rot_no(1)
	    sym_hkl(2) = st_rot_no(2)
	    sym_hkl(3) = st_rot_no(3)
	    call trans(sym_hkl,cr_rten,sym_uvw,3)
	  endif
	elseif(str_comp(line,'mod1',4,lbef,4)) then
	  sym_angle = st_rot_ang_m1(i)
	  if(st_rot_m1_lspace) then
	    sym_uvw(1) = st_rot_m1(1)
	    sym_uvw(2) = st_rot_m1(2)
	    sym_uvw(3) = st_rot_m1(3)
	    call trans(sym_uvw,cr_gten,sym_hkl,3)
	  else
	    sym_hkl(1) = st_rot_m1(1)
	    sym_hkl(2) = st_rot_m1(2)
	    sym_hkl(3) = st_rot_m1(3)
	    call trans(sym_hkl,cr_rten,sym_uvw,3)
	  endif
	elseif(str_comp(line,'mod2',4,lbef,4)) then
	  sym_angle = st_rot_ang_m2(i)
	  if(st_rot_m2_lspace) then
	    sym_uvw(1) = st_rot_m2(1)
	    sym_uvw(2) = st_rot_m2(2)
	    sym_uvw(3) = st_rot_m2(3)
	    call trans(sym_uvw,cr_gten,sym_hkl,3)
	  else
	    sym_hkl(1) = st_rot_m2(1)
	    sym_hkl(2) = st_rot_m2(2)
	    sym_hkl(3) = st_rot_m2(3)
	    call trans(sym_hkl,cr_rten,sym_uvw,3)
	  endif
	endif
c
	end
c*****7*****************************************************************
	subroutine st_fourier
c-
c	Calculates the Fourier transform of the stacking fault decorated
c	by the respective layers.
c+
	implicit      none
c
	include       'config.inc'
	include       'prompt.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'stack.inc'
	include       'diffuse.inc'
	include       'errlist.inc'
	include       'save.inc'
c
	integer       i,j,l
	integer       iscat
	integer       lbeg(3),csize(3)
	integer       ncell
	logical       lout
c
	real          ss
	real          seknds
c
c------ preset some values
c
	ilots = LOT_OFF
	ncell = 0
	lout  = .false.
	ss    = seknds(0.0)
	call four_layer
c
c------	Now start calculation if sufficient space
c
	if(num(1)*num(2).le.ST_MAXQXY) then
c
c------ --zero some arrays
c
	  do i=1,num(1)*num(2)
c	    st_csf(i) = cmplx(0.0d0,0.0d0)
	       csf(i) = cmplx(0.0d0,0.0d0)
c	      acsf(i) = cmplx(0.0d0,0.0d0)
	  enddo
c
c------	--read first layer to ensure that the metric tensors are set
c
	  call rese_cr
	  call readstru(NMAX,MAXSCAT,
     &	                st_layer(1),cr_name,cr_spcgr,
     &	                cr_a0,cr_win,cr_natoms,cr_nscat,
     &	                cr_dw,cr_at_lis,cr_pos,cr_iscat,
     &	                cr_dim,as_natoms,as_at_lis,as_dw,
     &	                as_pos,as_iscat,
     &	                sav_ncell,sav_r_ncell,sav_ncatoms)
	  call lattice(cr_a0,cr_ar,cr_eps,cr_gten,
     &	  cr_reps,cr_rten,cr_win,cr_wrez,cr_v,
     &	  cr_vr,lout)
c
c------ --preset some tables, calculate average structure
c
	  call four_cexpt
	  call four_stltab
	  if (ier_num.ne.0) return
c
c------	--Loop over all layer chemistries
c
	  do l=1,st_nchem
	    nxat = 0
c
c------	----loop over all layers
c
	    do j=1,st_nlayer
c
c------	------insert stacking fault distribution as electrons into crystal
c
	      if(st_chem(st_type(j)).eq.l) then
	        nxat        = nxat + 1
	        xat(nxat,1) = st_origin(1,j)
	        xat(nxat,2) = st_origin(2,j)
	        xat(nxat,3) = st_origin(3,j)
	      endif
	    enddo
	    if(nxat.gt.0) then
c
c------	------calculate structure factor of distribution
c
	      call four_strucf(0,.false.)
c
c------	------copy structure factor to temporary place
c
	      do i=1,num(1)*num(2)
                acsf(i) = tcsf(i)
	      enddo
c
c------	----read corresponding layer
c
	      call rese_cr
	      call readstru(NMAX,MAXSCAT,
     &	                    st_layer_c(l),cr_name,cr_spcgr,
     &	                    cr_a0,cr_win,cr_natoms,cr_nscat,
     &	                    cr_dw,cr_at_lis,cr_pos,cr_iscat,
     &	                    cr_dim,as_natoms,as_at_lis,as_dw,
     &	                    as_pos,as_iscat,
     &	                sav_ncell,sav_r_ncell,sav_ncatoms)
	      call lattice(cr_a0,cr_ar,cr_eps,cr_gten,
     &	      cr_reps,cr_rten,cr_win,cr_wrez,cr_v,
     &	      cr_vr,lout)
	      ier_num = 0
	      ier_typ = ER_NONE
	      call dlink(lxray,ano,lambda,rlambda)
	      if(ier_num.ne.0) then
	        return
	      endif
c
c------ ------Load form factor tables
c
	      call four_formtab
c
c------ ------zero some arrays
c
	      do i=1,num(1)*num(2)
	         st_csf(i) = cmplx(0.0d0,0.0d0)
	      enddo
c
c------ ------loop over all different atom types
c
	      do iscat=1,cr_nscat
	        call four_getatm (iscat,ilots,lbeg,csize,ncell)
	        call four_strucf (iscat,.true.)
c
c------ --------Add this part of the structur factor to the total
c
	        do i=1,num(1)*num(2)
	          st_csf(i) = st_csf(i) + tcsf(i)
	        enddo
	        if(four_log) then
	          write (output_io,3000) cr_at_lis(iscat),nxat
	        endif
	      enddo
c
c------	------Add product of acsf und st_csf to csf
c
	      do i=1,num(1)*num(2)
	        csf(i) = csf(i) + st_csf(i) * acsf(i)
	      enddo
	    endif
	  enddo
c
c------	--Calculate average scattering and subtract
c
	  call st_fourier_aver
	  do i=1,num(1)*num(2)
	    csf(i) = csf(i) - acsf(i)
	  enddo
	else
	  ier_num = -8
	  ier_typ = ER_APPL
	endif
c
c------	Compute intensity
c
	do i=1,num(1)*num(2)
	  dsi(i) = real(csf(i)*conjg(csf(i)))
	enddo
c
	if(four_log) then
	  call four_qinfo
	  ss = seknds(ss)
	  write (output_io,4000) ss
	endif
c
3000	format (  '                   Atom typ = ',A4,7X,'(# ',I9,' )') 
4000	format  (/,' Elapsed time    : ',G12.6,' sec')
c
	end
c*****7*****************************************************************
	subroutine st_fourier_aver
c-
c	Calculates the Fourier transform of the average lattice.
c+
	implicit      none
c
	include       'config.inc'
	include       'prompt.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'errlist.inc'
	include       'stack.inc'
	include       'save.inc'
	include       'diffuse.inc'
c
	integer       i,j,l
	integer       iscat
	integer       lbeg(3),csize(3)
	integer       ncell
	logical       lout
	real          u(3)
c
c------ preset some values
c
	ilots = LOT_OFF
	ncell = 0
	lout  = .false.
c
c------	Now start calculation if sufficient space
c
	if(num(1)*num(2).le.MAXQXY) then
c
c------ --zero some arrays
c
	  do i=1,num(1)*num(2)
c	    st_csf(i) = cmplx(0.0d0,0.0d0)
	      acsf(i) = cmplx(0.0d0,0.0d0)
	  enddo
c
c------	--Calculation is only performed if average is needed
c
	  if(st_aver.ne.0.0) then
c
c------	----read first layer to ensure that the metric tensors are set
c
	    call rese_cr
	    call readstru(NMAX,MAXSCAT,
     &	                  st_layer(1),cr_name,cr_spcgr,
     &	                  cr_a0,cr_win,cr_natoms,cr_nscat,
     &	                  cr_dw,cr_at_lis,cr_pos,cr_iscat,
     &	                  cr_dim,as_natoms,as_at_lis,as_dw,
     &	                  as_pos,as_iscat,
     &	                  sav_ncell,sav_r_ncell,sav_ncatoms)
	    call lattice(cr_a0,cr_ar,cr_eps,cr_gten,
     &	    cr_reps,cr_rten,cr_win,cr_wrez,cr_v,
     &	    cr_vr,lout)
c
	    if (ier_num.ne.0) return
c
c------	----Calculate average translation
c
	    u(1) = (st_origin(1,st_nlayer)-st_origin(1,1))/(st_nlayer-1)
	    u(2) = (st_origin(2,st_nlayer)-st_origin(2,1))/(st_nlayer-1)
	    u(3) = (st_origin(3,st_nlayer)-st_origin(3,1))/(st_nlayer-1)
c
c	    write (output_io,*) ' <t> : ', u
c
c------	----Determine average displacement of each layer type off the
c	    average translation direction
c
	    do l=1,st_ntypes
	      st_disp(1,l) = 0.0
	      st_disp(2,l) = 0.0
	      st_disp(3,l) = 0.0
	      st_ndisp( l) = 0
	    enddo
c
c------	----loop over all layers, compile displacements
c
	    do j=1,st_nlayer
	      do i=1,3
	        st_disp(i,st_type(j)) = st_disp(i,st_type(j)) +
     &	                                st_origin(i,j) -
     &	                                st_origin(i,1) -
     &	                                (j-1) * u(i)
	      enddo
	      st_ndisp(   st_type(j)) = st_ndisp(st_type(j)) + 1
	    enddo
c
c------	----calculate average displacement
c
	    do l=1,st_ntypes
	      if(st_ndisp(l).gt.0) then
	        do i=1,3
	          st_disp(i,l) = st_disp(i,l) / float(st_ndisp(l))
	        enddo
c	        write (output_io,5000) (st_disp(i,l),i=1,3)
	      endif
	    enddo
c
c------	----loop over all layers
c
	    nxat = 0
	    do j=1,st_nlayer
c
c------	------insert average stacking fault distribution as electrons into crystal
c
	      nxat        = nxat + 1
	      xat(nxat,1) = st_origin(1,1) + (j-1) * u(1)
	      xat(nxat,2) = st_origin(2,1) + (j-1) * u(2)
	      xat(nxat,3) = st_origin(3,1) + (j-1) * u(3)
	    enddo
c
c------	----calculate structure factor of distribution
c
	      call four_strucf(0,.false.)
c
c------	----copy structure factor to temporary place
c
	    do i=1,num(1)*num(2)
              acsf(i) = tcsf(i)
	    enddo
c
c------ ----zero some arrays
c
	    do i=1,num(1)*num(2)
	       st_csf(i) = cmplx(0.0d0,0.0d0)
	    enddo
c
c------	----Loop over all layer types
c
	    do l=1,st_ntypes
c
c------	------read corresponding layer
c
	      call rese_cr
	      call readstru(NMAX,MAXSCAT,
     &	                    st_layer(l),cr_name,cr_spcgr,
     &	                    cr_a0,cr_win,cr_natoms,cr_nscat,
     &	                    cr_dw,cr_at_lis,cr_pos,cr_iscat,
     &	                    cr_dim,as_natoms,as_at_lis,as_dw,
     &	                    as_pos,as_iscat,
     &	                    sav_ncell,sav_r_ncell,sav_ncatoms)
	      call lattice(cr_a0,cr_ar,cr_eps,cr_gten,
     &	      cr_reps,cr_rten,cr_win,cr_wrez,cr_v,
     &	      cr_vr,lout)
c
c------	------Add average displacement to each atom
c
	      do i=1,cr_natoms
	        do j=1,3
	          cr_pos(j,i) = cr_pos(j,i) + st_disp(j,l)
	        enddo
	      enddo
c
	      ier_num = 0
	      ier_typ = ER_NONE
	      call dlink(lxray,ano,lambda,rlambda)
	      if(ier_num.ne.0) then
	        return
	      endif
c
c------ ------Load form factor tables
c
	      call four_formtab
c
c------ ------loop over all different atom types
c
	      do iscat=1,cr_nscat
	        call four_getatm (iscat,ilots,lbeg,csize,ncell)
	        call four_strucf (iscat,.true.)
c
c------ --------Add this part of the structur factor to the total
c	        Wheighted by the relative amount of layers of this type
c
	        do i=1,num(1)*num(2)
	          st_csf(i) = st_csf(i) + tcsf(i)*float(st_number(l))/
     &	                                    float(st_nlayer)
	        enddo
	        write (output_io,3000) cr_at_lis(iscat),nxat
	      enddo
	    enddo
c
c------	----Save product of acsf und st_csf to acsf
c
	    do i=1,num(1)*num(2)
	      acsf(i) = st_csf(i) * acsf(i)
	    enddo
	  endif
	else
	  ier_num = -8
	  ier_typ = ER_APPL
	endif
c
c
3000	format ( '                   Atom typ = ',A4,7X,'(# ',I9,' )') 
5000	format ( ' displacement vector : ',3(2x,f8.3))
c
	end
c*****7*****************************************************************
	subroutine do_stack_rese
c-
c	Resets the stacking fault setup
c+
	implicit      none
c
	include       'config.inc'
	include       'stack.inc'
c
	st_nlayer = 0
	st_ntypes = 0
	st_nchem  = 0
c
	end
C*****7****************************************************************2********
	subroutine stack_dist_file(cr_spcgr,cr_a0,cr_win,cr_dim,
     &	            st_name,st_spcgr,
     &	            st_a0,st_win,st_natoms,st_nscat,
     &	            st_dw,st_at_lis,st_pos,st_iscat,
     &	            st_dim,
     &               sa_natoms,sa_at_lis,sa_dw,sa_pos,sa_iscat)
c-
c	A 'crystal' file is read and the atom types are interpreted as 
c	layer types. 
c	Later on the origins will be interpreted as well as
c	origins of the stacking faults.
c+
	implicit       none
c
	include       'config.inc'
	include       'prompt.inc'
	include       'stack.inc'
	include       'stack_cr.inc'
	include       'errlist.inc'
c
	integer		sav_ncell(3)
	integer		sav_ncatoms
	logical		sav_r_ncell
c
	integer        i
c
	character*16   cr_spcgr
	real           cr_a0(3),cr_win(3)
	real           cr_dim(3,2)
c
c------	Initialize counters for Atom numbers
c
	st_natoms = 0
	st_nscat  = 0
	sa_natoms = 0
	st_at_lis(0) = 'VOID'
	st_dw(0)     = 0.0
	do i = 1,ST_MAX_SCAT
	  st_at_lis(i) = ' '
	enddo
c
c------	Now read the pseudo microdomain structure
c
	call readstru(ST_MMAX,ST_MAX_SCAT,
     &	            st_infile      ,st_name,st_spcgr,
     &	            st_a0,st_win,st_natoms,st_nscat,
     &	            st_dw,st_at_lis,st_pos,st_iscat,
     &	            st_dim,
     &               sa_natoms,sa_at_lis,sa_dw,sa_pos,sa_iscat,
     &	                    sav_ncell,sav_r_ncell,sav_ncatoms)
	if(ier_num.ne.0) then
	  ier_msg(1) = 'Error occured while reading'
	  ier_msg(2) = st_infile
	  return
	endif
c
	if(st_natoms.gt.ST_MAXLAYER) then
	  ier_num = -5
	  ier_typ = ER_APPL
	  return
	endif
CDBG
	write (output_io,*) 'st_natoms after read', st_natoms
	write (output_io,*) 'st_nscat after read', st_nscat
c
	end
c*****7*****************************************************************
