c+
c	These routines create a new structure. The different options
c	are (or will be soon) :
c
c	  - comletely new structure
c	  - freestyle edited
c	  - generated from plane,space or non-crystallographic group
c	  - read-in structure
c	  - user written file
c	  - system catalog of standard structures
c
c	Version : 2.3
c	Date    : 23 April 1999
c
c	Author  : R.B. Neder  (neder@yoda.kri.physik.uni-muenchen.de)
c
c*****7*****************************************************************
	subroutine read_struc
c-
c	Main menu for read command.
c+
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'doact.inc'
	include 	'errlist.inc'
	include 	'learn.inc'
	include 	'macro.inc'
	include 	'molecule.inc'
	include 	'prompt.inc'
	include 	'save.inc'
c
	integer       	maxw
	parameter    	(maxw=11)
c
	character*200 	line,zeile,cpara(maxw)
	character*40  	strucfile
	character*11  	prom
	character*4	befehl
	integer       	lpara(maxw),lp,length
	integer       	ce_natoms,lstr,i,j,k,iatom
	integer       	ianz,l,n,lbef
	logical       	lout
	real          	hkl(3),u(3),xc(3),yc(3),zc(3),dist
	real          	werte(maxw)
c
	logical         str_comp
c
	call no_error
c
	blank = ' '
	lout  = .true.
c
	lstr      = 40
	cr_icc(1) =  1
	cr_icc(2) =  1
	cr_icc(3) =  1
c
	prom  = prompt//'/read'
	call get_command (line,length,befehl,lbef,zeile,lp,prom)
c
	if(ier_num.ne.0) return
	if(line(1:1).eq.' ' .or. line(1:1).eq.'#') goto 9999
c
c------ execute a macro file
c
        if(line(1:1).eq.'@') then
	  if(length.ge.2) then
	    call file_kdo(line(2:length),length-1)
	  else
	    ier_num = -13
	    ier_typ = ER_MAC
	  endif
c
c------ Echo a string, just for interactive check in a macro 'echo'
c
	elseif(str_comp(befehl,'echo',2,lbef,4)) then
          call echo(zeile,lp)
c
c------	execute command
c------	help
c
	elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	       str_comp(befehl,'?   ',1,lbef,4)     ) then
	  if(zeile.eq.' ') then
	    zeile='commands'
	    lp   = lp + 8
	  endif
	  if(str_comp(zeile,'errors',2,lp,6) ) then
	    lp = lp + 7
	    call do_hel('discus '//zeile,lp)
	  else
	    lp = lp + 12
	    call do_hel('discus read '//zeile,lp)
	  endif
c
c------  -----waiting for user input
c
	elseif(str_comp(befehl,'wait',3,lbef,4)) then
	  call do_input(zeile,lp)
c
	else
c
c------	--all other commands
c
c------	--get command parameters
c
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	  if(ianz.ge.1) then
c
c------	--Build file name
c
	    call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	    if(ier_num.ne.0) then
	      return
	    endif
	  endif
c
c------	--reset epsilon tensors
c
      	  do i=1,3
      	    do j=1,3
      	      do k=1,3
      	        cr_eps(i,j,k) =0.0
     	        cr_reps(i,j,k)=0.0
	      enddo
	    enddo
	  enddo
c
c------	read in old cell, use space group symbol to generate cell
c------	content 'cell'
c 
	  if   (str_comp(befehl,'cell' ,1,lbef,4) .or.
     &          str_comp(befehl,'lcell',1,lbef,4)     ) then
	    if(ianz.ge.1) then
	      cr_newtype = str_comp(befehl,'cell',1,lbef,4)
	      call rese_cr
	      strucfile=cpara(1)
	      if(ier_num.eq.0) then
c
c------	--------if necessary get crystal size
c
	        if(ianz.gt.1) then
	          cpara(1)='0.0'
	          lpara(1)=3
                  call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            do i=1,ianz-1
	              cr_icc(i) = nint(werte(i+1))
	            enddo
	          endif
	        endif
	        if(ier_num.eq.0) then
	          call readcell(strucfile)
	          if(ier_num.eq.0) then
c
c------	----------check whether total number of atoms fits into available
c------	----------space
c
	          iatom = cr_icc(1)*cr_icc(2)*cr_icc(3)*cr_natoms
	          if(iatom.gt.nmax) then
	            ier_num = -10
	            ier_typ = ER_APPL
	            write(ier_msg(1),3000) cr_icc(1),cr_icc(2),cr_icc(3)
	            write(ier_msg(2),3100) cr_natoms
	            write(ier_msg(3),3200) iatom,nmax
3000	            format('Unit cells   : ',3(i4,2x))
3100	            format('Atoms / cell : ',i10)
3200	            format('Total / max  : ',i10,'/',i10)
	            return
	          endif
	          ce_natoms =cr_natoms
	          cr_ncatoms=cr_natoms
	          cr_natoms =0
	          do k=1,cr_icc(3)
	            do j=1,cr_icc(2)
	              do i=1,cr_icc(1)
	                do n=1,ce_natoms
	                  cr_natoms=cr_natoms+1
                          cr_iscat(cr_natoms)=cr_iscat(n)
	                  cr_pos(1,cr_natoms)=cr_pos(1,n)+float(i-1)
	                  cr_pos(2,cr_natoms)=cr_pos(2,n)+float(j-1)
	                  cr_pos(3,cr_natoms)=cr_pos(3,n)+float(k-1)
	                enddo
	              enddo
	            enddo
	          enddo
c
c------	----------Update crystal dimensions
c
	          call update_cr_dim
c
c------	----------If molecules were read
c
	          if(mole_num_mole.gt.0) then
	            if(mole_num_mole*cr_icc(1)*cr_icc(2)*cr_icc(3).le.
     &	               MOLE_MAX_MOLE                         ) then
	              mole_num_atom = mole_off(mole_num_mole) +
     &	                              mole_len(mole_num_mole)
	              l             = mole_num_mole
	              mole_num_unit = mole_num_mole
	              do i=2,cr_icc(1)*cr_icc(2)*cr_icc(3)
	                do j=1,mole_num_mole
	                  l           = l + 1
	                  mole_len (l) = mole_len(j)
	                  mole_off (l) = mole_off(l-mole_num_mole) + 
     &	     	                         mole_num_atom
	                  mole_type(l) = mole_type(j)
	                  do k = 1,mole_len(j)
	                    mole_cont(mole_off(l)+k) = 
     &	                    mole_cont(mole_off(j)+k) + (i-1)*ce_natoms
	                  enddo
	                enddo
	              enddo
	              mole_num_mole = l
	            else
	              ier_num = -65
	              ier_typ = ER_APPL
	              return
	            endif
	          endif
c
c------	----------Define initial crystal size in fractional coordinates
c
	          do l=1,3
	            cr_dim0(l,1) = float(nint(cr_dim(l,1)))
	            cr_dim0(l,2) = float(nint(cr_dim(l,2)))
	          enddo
	          endif
	        endif
	      endif
	    endif
	    if(ier_num.eq.0) then
c
c------	------reset microdomain status
c
	      call micro_reset
	      call do_stack_rese
	    endif
c
c------	Free style editing of a structure 'free'
c
	  elseif(str_comp(befehl,'free',1,lbef,4)) then
	    call rese_cr
	    cr_name='freely created structure'
	    cr_spcgr(1:1)='P'
	    cr_spcgr(2:2)='1'
	    cr_spcgr(3:16)='              '
	    cr_spcgrno    = 1
	    if(ianz.eq.0) then
	      do i=1,3
	        cr_a0(i)=1.0
	        cr_win(i)=90.0
	      enddo
	    elseif(ianz.eq.6) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
	      do i=1,3
	        cr_a0(i)  = werte(i  )
	        cr_win(i) = werte(i+3)
	      enddo
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	      return
	    endif
	    cr_icc(1) = 1
	    cr_icc(2) = 1
	    cr_icc(3) = 1
	    cr_natoms = 0
	    cr_nscat  = 0
	    as_natoms = 0
c
c------	----reset microdomain status
c
	    call micro_reset
	    call do_stack_rese
c
c------	read an old structure 'stru'
c
	  elseif(str_comp(befehl,'stru',1,lbef,4)) then
	    if(ianz.eq.1) then
	      call rese_cr
	      sav_r_ncell = .false.
	      strucfile=cpara(1)
	      call readstru(NMAX,MAXSCAT,
     &	                    strucfile,cr_name,cr_spcgr,
     &	                    cr_a0,cr_win,cr_natoms,cr_nscat,
     &	                    cr_dw,cr_at_lis,cr_pos,cr_iscat,
     &	                    cr_dim,
     &	                    as_natoms,as_at_lis,as_dw,as_pos,as_iscat,
     &	                    sav_ncell,sav_r_ncell,sav_ncatoms)
c
c------	------Define initial crystal size in fractional coordinates
c
	      do l=1,3
	        cr_dim0(l,1) = float(nint(cr_dim(l,1)))
	        cr_dim0(l,2) = float(nint(cr_dim(l,2)))
	      enddo
c
c------	------The crystal size was read from the structure file
c
	      if(sav_r_ncell) then
	        do i=1,3
	          cr_icc(i) = sav_ncell(i)
	        enddo
	        cr_ncatoms = sav_ncatoms
	      else
c
c------	------Define initial crystal size in number of unit cells
c
	        do i=1,3
                  cr_icc(i) = max(1,int(cr_dim0(i,2)-cr_dim0(i,1)))
	        enddo
c
c------	------Define (average) number of atoms per unit cell
c
	        cr_ncatoms = cr_natoms/(cr_icc(1)*cr_icc(2)*cr_icc(3))
	      endif
c
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	    if(ier_num.eq.0) then
c
c------	------reset microdomain status
c
	      call micro_reset
	      call do_stack_rese
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	    goto 9999
	  endif  
	  if(ier_num.eq.0) then
	    write (output_io,1000) cr_spcgr,cr_spcgrno
c.......calculate metric and reciprocal metric tensor,reciprocal lattice
c       constants and permutation tensors
            call lattice(cr_a0,cr_ar,cr_eps,cr_gten,
     &	    cr_reps,cr_rten,cr_win,cr_wrez,cr_v,
     &	    cr_vr,lout)
C
	    do i=1,3
	      hkl(i)=0.0
	      u  (i)=0.0
	    enddo
	    hkl(3)=1.0
	    call trafo(hkl,u,xc,yc,zc,cr_gmat,cr_fmat,dist,cr_eps,
     &	               cr_gten,cr_reps,cr_rten)
	      call recip_symm
	  else
	    call errlist
	    if(lmakro) then
	      call macro_close
	      prompt_status = PROMPT_ON
	    endif
	    if(lblock) then
	      ier_num = -11
	      ier_typ = ER_COMM
	      return
	    endif
	    call no_error
	  endif
	endif
c
9999	continue
c
1000	format(1x,a16,i5)
	end
c**********************************************************************
      	subroutine readcell(strucfile)
c-
c     	This subroutine reads a unit cell.
c+
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
	include 	'molecule.inc'
	include 	'save.inc'
c
	integer       	ist,maxw
	parameter	(ist=7,maxw=4)
c
	character*10  	befehl
	character*40  	strucfile
	character*200 	line,zeile
	integer       	i,j,ibl,lbef
	logical       	lread,lcell
	real          	werte(maxw),dw1
c
	logical         str_comp
c
	cr_natoms = 0
	lread     = .true.
	lcell     = .true.
	call oeffne(ist,strucfile,'old',lread)
	if(ier_num.eq.0) then
	  do i=1,3
	    cr_dim(i,1) =  1.e10
	    cr_dim(i,2) = -1.e10
	  enddo
c
c------	--Read header of structure file
c
	  call stru_readheader(ist,
     &	    NMAX,MAXSCAT,lcell,
     &	    cr_name,cr_spcgr,cr_at_lis,cr_nscat,cr_dw,
     &	    cr_a0,cr_win,
     &	    sav_ncell,sav_r_ncell,sav_ncatoms)
c
	  if(ier_num.eq.0) then
	    do while(cr_natoms .lt. nmax)
	      ier_num = -49
	      ier_typ = ER_APPL
	      line=' '
	      read(ist,2000,end=2,err=999) line
c23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
	      if(line .ne. ' ' .and. line(1:1) .ne. '#') then
	        lbef   = 10
	        befehl = ' '
	        ibl    = index(line,' ')
	        lbef   = min(ibl  -1,lbef)
	        befehl = line(1:lbef)
	        if(str_comp(befehl,'molecule',4,lbef,8)) then
c
c------	----------Start/End of a molecule
c
	          call no_error
	          i = 200 - ibl
	          zeile = line(ibl+1:200)
	          call struc_mole_header(zeile,i,.true.)
	          if(ier_num.ne.0) return
	        else
	          read(line(ibl:80),*,end=999,err=999) (werte(j),j=1,4)
	          call no_error
	          cr_natoms = cr_natoms + 1
	          i         = cr_natoms
	          if(.not. mole_l_on) then
c
c------	------------Transform atom into first unit cell,
c	            if it is not inside a molecule
c
	            call firstcell(werte,maxw)
	          endif
c
	          do j=1,3
	            cr_pos(j,i)=werte(j)
	          enddo
	          dw1=werte(4)
c
	          if(line(1:4).ne.'    ') then
	            ibl = ibl - 1
	            call do_cap(line(1:ibl))
c
c------ ----------- New option determines whether all atoms in
c------ ----------- asymmetric unit are considered different atom
c------ ----------- types ..
c
	            if (.not. cr_newtype) then
                      do j=0,cr_nscat
                        if(line(1:ibl).eq.cr_at_lis(j) .and.
     &                     dw1        .eq.cr_dw(j)          ) then
                          cr_iscat(i)=j
	                  call symmetry
                          goto 22
                        endif
                      enddo
	            endif
c
c------ ----------- end new code
c
	            if(cr_nscat.lt.maxscat) then
	              cr_nscat            = cr_nscat+1
	              cr_iscat(i)         = cr_nscat
	              cr_at_lis(cr_nscat) = line(1:ibl)
	              cr_dw(cr_nscat)     = dw1
c
	              as_natoms             = as_natoms + 1
                      as_at_lis(cr_nscat)   = cr_at_lis(cr_nscat)
                      as_iscat(as_natoms)   = cr_iscat(i)
	              as_dw(as_natoms)      = cr_dw(cr_nscat)
	              do j=1,3
	                as_pos(j,as_natoms) = cr_pos(j,i)
	              enddo
	              call symmetry
	            else
	              ier_num = -26
	              ier_typ = ER_APPL
	              goto 2
	            endif
22	            continue
	          endif
	        endif
	      endif
	    enddo
	  endif
c
2	  continue
	  if(ier_num.eq.-49) then
	    call no_error
c
c------	  move first unit cell into lower left corner of crystal
c
	    do i=1,cr_natoms
	      do j=1,3
	        cr_pos(j,i)=cr_pos(j,i) - int((cr_icc(j)    )/2)
c	        cr_pos(j,i)=cr_pos(j,i) - int((cr_icc(j)-0.1)/2)
                cr_dim(j,1)=amin1(cr_dim(j,1),cr_pos(j,i))
                cr_dim(j,2)=amax1(cr_dim(j,2),cr_pos(j,i))
	      enddo
	    enddo
	  endif
c
	endif
c
999	continue
	close(ist)
	if(ier_num.eq.-49 ) then
	  write(ier_msg(1),3000) as_natoms+1
3000	  format('At atom number = ',i8)
	endif
c
2000	format(a)
2010	format(a16)
	end
c**********************************************************************
	subroutine struc_mole_header(zeile,lp,lcell)
c-
c	interprets the 'molecule' lines of a structure file
c+

	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
	include 	'molecule.inc'
c
	integer       	maxw
	parameter	(maxw=21)
c
	character*200 	zeile,cpara(maxw)
	integer       	j,ianz
	integer       	lpara(maxw),lp
	real          	werte(maxw)
	logical		lcell
c
	logical       	str_comp
c
        call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if(ier_num.eq.0) then
	  if(ianz.eq.0) then
c
c------	--No parameters, start a new Molekule
c
	    if(mole_num_mole.lt.MOLE_MAX_MOLE) then
	      if(mole_num_type.lt.MOLE_MAX_TYPE) then
	        mole_l_on                = .true.
	        mole_num_atom = mole_off(mole_num_mole) +
     &	                        mole_len(mole_num_mole)
	        mole_num_mole            = mole_num_mole + 1
	        mole_num_curr            = mole_num_mole
	        mole_num_type            = mole_num_type + 1
	        mole_off(mole_num_mole)  = mole_num_atom
	        mole_type(mole_num_mole) = mole_num_type
	        mole_gene_n              = 0
	        mole_symm_n              = 0
	      else
	        ier_num = -66
	        ier_typ = ER_APPL
	        return
	      endif
	    else
	      ier_num = -65
	      ier_typ = ER_APPL
	      return
	    endif
	  else
c
c------	--Parameters, interpret parameters
c
	    if(str_comp(cpara(1),'end',3,lpara(1),3)) then
c
c------	----Turn off molecule
c
	      if (lcell) call mole_firstcell
	      mole_l_on = .false.
c
	    elseif(str_comp(cpara(1),'generator',3,lpara(1),8)) then
c
c------	------Define which generators create atoms within the
c	      same molecule
c
	      cpara(1) = '0'
	      lpara(1) = 1
              call ber_params(ianz,cpara,lpara,werte,maxw)
	      if(ier_num.eq.0) then
	        if(ianz.eq.13 .or. ianz.eq.14) then
	          mole_gene_n = mole_gene_n + 1
	          do j=1,4
	            mole_gene(1,j,mole_gene_n) = werte(j+1)
	            mole_gene(2,j,mole_gene_n) = werte(j+5)
	            mole_gene(3,j,mole_gene_n) = werte(j+9)
	          enddo
	          mole_gene_power(mole_gene_n) = 1
	          if(ianz.eq.14) then
	            mole_gene_power(mole_gene_n) = nint(werte(ianz))
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        return
	      endif
c
	    elseif(str_comp(cpara(1),'symmetry',4,lpara(1),8)) then
c
c------	------Define which symmetries  create atoms within the
c	      same molecule
c
	      cpara(1) = '0'
	      lpara(1) = 1
              call ber_params(ianz,cpara,lpara,werte,maxw)
	      if(ier_num.eq.0) then
	        if(ianz.eq.13) then
	          mole_symm_n = mole_symm_n + 1
	          do j=1,4
	            mole_symm(1,j,mole_symm_n) = werte(j+1)
	            mole_symm(2,j,mole_symm_n) = werte(j+5)
	            mole_symm(3,j,mole_symm_n) = werte(j+9)
	          enddo
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        return
	      endif
	    elseif(str_comp(cpara(1),'content',4,lpara(1),7)) then
c
c------	------start reading a molecule content
c
	      cpara(1) = '0'
	      lpara(1) = 1
              call ber_params(ianz,cpara,lpara,werte,maxw)
	      if(ier_num.eq.0) then
	        if(ianz.eq.2 .or. ianz.eq.3) then
	          if(mole_num_mole.lt.MOLE_MAX_MOLE) then
	            if(werte(2).lt.MOLE_MAX_TYPE) then
	              mole_l_on                = .true.
	              mole_num_atom = mole_off(mole_num_mole) +
     &	                              mole_len(mole_num_mole)
	              mole_num_mole            = mole_num_mole + 1
	              mole_num_curr            = mole_num_mole
	              mole_type(mole_num_mole) = int(werte(2))
	              mole_off (mole_num_mole) = mole_num_atom
	              mole_len (mole_num_mole) = 0
	              mole_num_type = max(mole_num_type,int(werte(2)))
	              mole_gene_n              = 0
	              mole_symm_n              = 0
	            else
	              ier_num = -64
	              ier_typ = ER_APPL
	              ier_msg(1) = 'First characters of wrong line'
	              ier_msg(2) = zeile( 1:40)
	              ier_msg(3) = zeile(41:80)
	            endif
	          else
	            ier_num = -65
	            ier_typ = ER_APPL
	            ier_msg(1) = 'First characters of wrong line'
	            ier_msg(2) = zeile( 1:40)
	            ier_msg(3) = zeile(41:80)
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	          ier_msg(1) = 'First characters of wrong line'
	          ier_msg(2) = zeile( 1:40)
	          ier_msg(3) = zeile(41:80)
	        endif
	      else
	        ier_msg(1) = 'First characters of wrong line'
	        ier_msg(2) = zeile( 1:40)
	        ier_msg(3) = zeile(41:80)
	      endif
	    elseif(str_comp(cpara(1),'atoms',4,lpara(1),5)) then
c
c------	------read a molecule content
c
	      if(mole_l_on) then
	        cpara(1) = '0'
	        lpara(1) = 1
                call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	           do j=2,ianz
	             mole_len(mole_num_mole) =
     &	             mole_len(mole_num_mole) + 1
	             mole_cont(mole_off(mole_num_mole)+
     &	                                mole_len(mole_num_mole)) =
     &	             int(werte(j))
	          enddo
	        else
	          ier_msg(1) = 'First characters of wrong line'
	          ier_msg(2) = zeile( 1:40)
	          ier_msg(3) = zeile(41:80)
	        endif
	      else
	        ier_num = -65
	        ier_typ = ER_APPL
	      endif
	    else
	      write (*,*) 'Error reading molecule parameters '
	      ier_num = -6
	      ier_typ = ER_COMM
	      ier_msg(1) = 'First characters of wrong line'
	      ier_msg(2) = zeile( 1:40)
	      ier_msg(3) = zeile(41:80)
	    endif
	  endif
	endif
c
	end
c**********************************************************************
      	subroutine readstru(NMAX,MAXSCAT,
     &	                    strucfile,cr_name,cr_spcgr,cr_a0,
     &	                    cr_win,cr_natoms,cr_nscat,cr_dw,
     &	                    cr_at_lis,cr_pos,cr_iscat,cr_dim,
     &	                    as_natoms,as_at_lis,as_dw,as_pos,
     &	                    as_iscat,
     &	                    sav_ncell,sav_r_ncell,sav_ncatoms)
c-
c     	this subroutine reads an old structur.
c+
	implicit      	none
c
	integer          NMAX
	integer          MAXSCAT
c
	include 	'crystal2.inc'
	include 	'crystal3.inc'
	include 	'errlist.inc'
c
	integer		sav_ncell(3)
	integer		sav_ncatoms
	logical		sav_r_ncell
	logical		lcell
c
	integer       	ist
	parameter	(ist=7)
c
	character*40  	strucfile
	integer       	i
	logical       	lread
c
	cr_natoms = 0
	lread     = .true.
	lcell     = .false.
	call oeffne(ist,strucfile,'old',lread)
	if(ier_num.eq.0) then
	  do i=1,3
	    cr_dim(i,1) =  1.e10
	    cr_dim(i,2) = -1.e10
	  enddo
c
c------	--Read header of structure file
c
	  call stru_readheader(ist,
     &	    NMAX,MAXSCAT,lcell,
     &	    cr_name,cr_spcgr,cr_at_lis,cr_nscat,cr_dw,
     &	    cr_a0,cr_win,
     &	    sav_ncell,sav_r_ncell,sav_ncatoms)
c
	  if(ier_num.eq.0) then
	    call struc_read_atoms(NMAX,MAXSCAT,
     &	      cr_natoms,cr_nscat,
     &	      cr_dw,cr_at_lis,cr_pos,cr_iscat,
     &	      cr_dim,as_natoms,as_at_lis,as_dw,
     &	      as_pos,as_iscat)
	  endif
	endif
c
999	continue
	close(ist)
	if(ier_num.eq.-49 ) then
	  write(ier_msg(1),3000) cr_natoms+1
3000	  format('At atom number = ',i8)
	endif
c
2000	format(a)
2010	format(a16)
	end
c**********************************************************************
	subroutine stru_readheader(ist,
     &	    NMAX,MAXSCAT,lcell,
     &	    cr_name,cr_spcgr,cr_at_lis,cr_nscat,cr_dw,
     &	    cr_a0,cr_win,
     &	    sav_ncell,sav_r_ncell,sav_ncatoms)
c-
c	This subroutine reads the header of a structure file
c+
	implicit      	none
c
	integer		NMAX
	integer		MAXSCAT
c
	include 	'crystal2.inc'
	include 	'errlist.inc'
	include 	'gen_add.inc'
	include 	'sym_add.inc'
c
	integer        	 maxw
	parameter	(maxw=13)
c
	character*200 	line,cpara(maxw)
	character*200   zeile
	character*6     befehl
	integer         ist,i,ll,j
	integer       	ianz
	integer       	spcgr_ianz
	integer       	lpara(maxw),lp
	integer         lbef,indxb
	integer         xx_nscat,xx_nadp
	integer		sav_ncell(3)
	integer		sav_ncatoms
	logical		sav_r_ncell
	logical		lcell
	real            spcgr_para
	real          	werte(maxw)
c
	integer       	len_str
	logical         str_comp
c
	xx_nscat = 0
	xx_nadp  = 0
c
	ier_num = -46
	ier_typ = ER_APPL
	read(ist,2000,end=999,err=999)  cr_name
c
c------	This construction is needed as long a the old cell file format
c	must be supported.
c
c
c------	The maximum number of significant characters depends on the length of
c------	the character constant befehl.
c
	lbef   = len(befehl)
	befehl = '    '
	indxb  = index(cr_name,' ')
	lbef   = min(indxb-1,lbef)
	befehl = cr_name(1:lbef)
	if    (str_comp(befehl,'title',1,lbef,5)) then
c
c------	Read new header
c
c
c------	--remove title string from cr_name
c
	  ll               = len(cr_name)
	  ll               = len_str(cr_name)
	  line             = ' '
	  line(1:ll-indxb) = cr_name(indxb+1:ll)
	  cr_name          = line
c
	  call no_error
	  do while( .not. str_comp(befehl,'atoms',1,lbef,5) )
	    read(ist,2000,end=999,err=999)  line
	    ll     = 200
	    ll     = len_str(line)
c
c------	----The maximum number of significant characters depends on the 
c------	----length of the character constant befehl.
c
	    lbef   = len(befehl)
	    befehl = '    '
	    indxb  = index(line,' ')
	    lbef   = min(indxb-1,lbef)
	    befehl = line(1:lbef)
c
c------	----command parameters start at the first character following 
c------ ----the blank
c
	    zeile = ' '
	    lp    = 0
	    if(indxb+1 .le. ll) then
	      zeile = line(indxb+1:ll)
	      lp    = ll - indxb
	    endif
c
c------	----Commentary
c

	    if(line.eq.' ' .or. line(1:1).eq.'#') then
	      continue
c
c------	----Space group symbol
c
	    elseif(str_comp(befehl,'spcgr',1,lbef,5) ) then
              call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      cr_spcgr   = cpara(1)
	      spcgr_ianz = ianz -1
	      ianz       = ianz -1
	      if(ianz.eq.1) then
	        cpara(1) = cpara(2)
	        lpara(1) = lpara(2)
                call ber_params(ianz,cpara,lpara,werte,maxw)
		spcgr_para = werte(1)
	      endif
	      if(ier_num.ne.0) then
	        ier_num = -47
	        ier_typ = ER_APPL
		return
	      endif
c
c------	----Cell constants
c
	    elseif(str_comp(befehl,'cell',1,lbef,4) ) then
              call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.6) then
c------	--------New style, kommata included
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            do i=1,3
	              cr_a0 (i) = werte(i  )
	              cr_win(i) = werte(i+3)
	            enddo
	          else
	            ier_msg(1) = 'Error reading unit cell parameters'
	            return
	          endif
	        else
c------	--------Old style, no kommata included
	          ier_num = -48
	          ier_typ = ER_APPL
	          read(zeile,*,end=999,err=999) 
     &	              (cr_a0(i),i=1,3),(cr_win(i),i=1,3)
	          call no_error
	        endif
	      else
	        ier_msg(1) = 'Error reading unit cell parameters'
	        return
	      endif
c
c------	----Additional symmetry generators 'generator'
c
	    elseif(str_comp(befehl,'gene',1,lbef,4) ) then
	      if(lcell) then
	      if(gen_add_n.lt.GEN_ADD_MAX) then
                call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	        if(ier_num.eq.0) then
	          if(ianz.eq.12 .or. ianz.eq.13) then
                    call ber_params(ianz,cpara,lpara,werte,maxw)
	            if(ier_num.eq.0) then
	              gen_add_n = gen_add_n + 1
	              do j=1,4
	                gen_add(1,j,gen_add_n) = werte(j  )
	                gen_add(2,j,gen_add_n) = werte(j+4)
	                gen_add(3,j,gen_add_n) = werte(j+8)
	              enddo
	              if(ianz.eq.13) then
	                gen_add_power(gen_add_n) = nint(werte(13))
	              else
	                gen_add_power(gen_add_n) = 1
	              endif
	            endif
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        endif
	      else
	        ier_num = -61
	        ier_typ = ER_APPL
	        return
	      endif
	      endif
c
c------	----Names of atoms to setup specific sequence of scattering curves
c	                                                          'scat'
c
	    elseif(str_comp(befehl,'scat',2,lbef,4) ) then
              call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(xx_nscat+ianz.le.MAXSCAT) then
	          do i=1,ianz
	            call do_cap(cpara(i)(1:lpara(i)))
	            cr_at_lis(xx_nscat+i) = cpara(i)
	          enddo
	          xx_nscat = xx_nscat + ianz
	          cr_nscat = max(cr_nscat,xx_nscat)
	        else
	          ier_num = -26
	          ier_typ = ER_APPL
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Displacement parameters to setup specific sequence of 
c	                               scattering curves 'adp'
c
	    elseif(str_comp(befehl,'adp',2,lbef,3) ) then
              call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
                call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          if(xx_nadp+ianz.le.MAXSCAT) then
	            do i=1,ianz
	              cr_dw(xx_nadp+i) = werte(i)
	            enddo
	            xx_nadp  = xx_nadp + ianz
	            cr_nscat = max(cr_nscat,xx_nadp)
	          else
	            ier_num = -26
	            ier_typ = ER_APPL
	          endif
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Crystal dimensions and number of atoms per unit cell 'ncell'
c
	    elseif(str_comp(befehl,'ncell',1,lbef,5) ) then
              call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.4) then
                  call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            do j=1,3
	              sav_ncell(j) = werte(j)
	            enddo
	            sav_ncatoms = werte(4)
	            sav_r_ncell = .true.
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----Additional symmetry operations 'symmetry'
c
	    elseif(str_comp(befehl,'symm',2,lbef,4) ) then
	      if(lcell) then
	      if(sym_add_n.lt.SYM_ADD_MAX) then
                call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	        if(ier_num.eq.0) then
	          if(ianz.eq.12.or.ianz.eq.13) then
                    call ber_params(ianz,cpara,lpara,werte,maxw)
	            if(ier_num.eq.0) then
	              sym_add_n = sym_add_n + 1
	              do j=1,4
	                sym_add(1,j,sym_add_n) = werte(j  )
	                sym_add(2,j,sym_add_n) = werte(j+4)
	                sym_add(3,j,sym_add_n) = werte(j+8)
	              enddo
	              if(ianz.eq.13) then
	                sym_add_power(sym_add_n) = nint(werte(13))
	              else
	                sym_add_power(sym_add_n) = 1
	              endif
	            endif
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        endif
	      else
	        ier_num = -62
	        ier_typ = ER_APPL
	        return
	      endif
	      endif
c
	    elseif(str_comp(befehl,'atoms',2,lbef,5) ) then
	      continue
	    else
	      ier_num = -8
	      ier_typ = ER_COMM
	    endif
	    if(ier_num.ne.0) then
	      return
	    endif
	  enddo
c
	  call no_error
c
c------	--Determine space group number
c
	  werte(1) = spcgr_para
	  call spcgr_no(spcgr_ianz,maxw,werte)
	else
c
c------	Read old header
c
	  ier_num = -47
	  ier_typ = ER_APPL
	  read(ist,2010,end=999,err=999)  line
	  lp = len_str(line)
          call get_params(line,ianz,cpara,lpara,maxw,lp)
	  cr_spcgr = cpara(1)
	  ianz = ianz -1
	  if(ianz.eq.1) then
	    cpara(1) = cpara(2)
	    lpara(1) = lpara(2)
            call ber_params(ianz,cpara,lpara,werte,maxw)
	  endif
	  if(ier_num.eq.0) then
	    ier_num = -48
	    ier_typ = ER_APPL
	    read(ist,*,end=999,err=999) 
     &	        (cr_a0(i),i=1,3),(cr_win(i),i=1,3)
	    call no_error
	    call spcgr_no(ianz,maxw,werte)
	  endif
	endif
c
999	continue
c
2000	format(a)
2010	format(a16)
	end
c**********************************************************************
	subroutine struc_read_atoms(NMAX,MAXSCAT,
     &	                            cr_natoms,cr_nscat,cr_dw,
     &	                            cr_at_lis,cr_pos,cr_iscat,
     &	                            cr_dim,as_natoms,as_at_lis,
     &	                            as_dw,as_pos,as_iscat)
c-
c     	This subroutine reads the list of atoms into the crystal array
c+
	implicit      	none
c
	integer          NMAX
	integer          MAXSCAT
c
	include 	'crystal2.inc'
	include 	'crystal3.inc'
	include 	'errlist.inc'
	include 	'molecule.inc'
c
	integer       	ist,maxw
	parameter    	(ist=7,maxw=4)
c
	character*10    befehl
	character*200 	line,zeile
	integer       	i,j,ibl,lbef
	real          	werte(maxw),dw1
c
	logical         str_comp
c
1000	continue
	  ier_num = -49
	  ier_typ = ER_APPL
	  line=' '
	  read(ist,2000,end=2,err=999) line
	  if(line .ne. ' ' .and. line(1:1) .ne. '#') then
	    ibl= index(line,' ' )+1
	    lbef   = 10
	    befehl = ' '
	    ibl    = index(line,' ')
	    lbef   = min(ibl  -1,lbef)
	    befehl = line(1:lbef)
	    if(str_comp(befehl,'molecule',4,lbef,8)) then
c
c------	------Start/End of a molecule
c
	      call no_error
	      zeile = line(ibl:200)
	      i     = 200 - ibl
	      call struc_mole_header(zeile,i,.false.)
	      if(ier_num.ne.0) return
	    else
	      read(line(ibl:80),*,end=999,err=999) (werte(j),j=1,4)
	      if(cr_natoms.eq.nmax) then
c
c------	--------Too many atoms in the structure file
c
	        ier_num = -10
	        ier_typ = ER_APPL
	        return
	      endif
	      cr_natoms = cr_natoms + 1
	      i         = cr_natoms
	      do j=1,3
	        cr_pos(j,i)=werte(j)
                cr_dim(j,1)=amin1(cr_dim(j,1),cr_pos(j,i))
                cr_dim(j,2)=amax1(cr_dim(j,2),cr_pos(j,i))
	      enddo
	      dw1=werte(4)
	      if(line(1:4).ne.'    ') then
	        ibl = ibl - 1
	        call do_cap(line(1:ibl))
	        do j=0,cr_nscat
                  if(line(1:ibl).eq.cr_at_lis(j) .and.
     &	             dw1        .eq.cr_dw(j)          ) then
                  cr_iscat(i)=j
                    goto 11
                  endif
	        enddo
	        if(cr_nscat.eq.MAXSCAT) then
c
c------	--------  Too many atom types in the structure file
c
	          ier_num = -72
	          ier_typ = ER_APPL
	          return
	        endif
                cr_nscat            = cr_nscat+1
                cr_iscat(i)         = cr_nscat
                cr_at_lis(cr_nscat) = line(1:ibl)
                cr_dw(cr_nscat)=dw1
c
	        if(0.0 .le. cr_pos(1,i) .and. cr_pos(1,i).lt.1 .and.
     &	           0.0 .le. cr_pos(2,i) .and. cr_pos(2,i).lt.1 .and.
     &	           0.0 .le. cr_pos(3,i) .and. cr_pos(3,i).lt.1) then
	          as_natoms             = as_natoms + 1
                  as_at_lis(cr_nscat)   = cr_at_lis(cr_nscat)
                  as_iscat(as_natoms)   = cr_iscat(i)
	          as_dw(as_natoms)      = cr_dw(cr_nscat)
	          do j=1,3
	            as_pos(j,as_natoms) = cr_pos(j,i)
	          enddo
	        endif
11              continue
c
c------	--------If we are reading a molecule insert atom into current
c
	        if(mole_l_on) then
	          call mole_insert_current(cr_natoms,mole_num_curr)
	        endif
	      endif
	    endif
	  endif
	goto 1000
c
2	continue
	if(ier_num.eq.-49) then
	  call no_error
	endif
c
999	continue
	close(ist)
c
2000	format(a)
	end
c**********************************************************************
c**********************************************************************
	subroutine spcgr_no(ianz,maxw,werte)
c-
c	Interprets the space group symbol. Returns the space group no.
c+
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
	include 	'spcgr.inc'
c
	integer       	ianz,maxw,ii,i
	real          	werte(maxw)
c
	call no_error
	ii = 1
	if(ianz.eq.1) then
	  ii = nint(werte(1))
	endif
c
c------	Distinguish between trigonal and rhombohedral settings
c
	if(cr_spcgr(1:1).eq.'R') then
	  if(cr_a0(1).eq.cr_a0(2) .and. cr_win(1).eq.90. .and.
     &	     cr_win(2).eq.90.0    .and. cr_win(3).eq.120.0 ) then
	    ii = 1
	  elseif(cr_a0(1).eq.cr_a0(2) .and. cr_a0(1).eq.cr_a0(3) .and.
     &	    cr_win(1).eq.cr_win(2) .and. cr_win(1).eq.cr_win(3)) then
	    ii = 2
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	endif
c
	if(ii.lt.1  .or.  2.lt.ii) then
	  ier_num = -7
	  ier_typ = ER_APPL
	  return
	endif
c
	cr_spcgrno = 0
	cr_syst    = 0
	ier_num    =  -7
	ier_typ    = ER_APPL
c
	do i=1,SPCGR_MAX
	  if(cr_spcgr.eq.spcgr_name(i)) then
	    cr_spcgrno = spcgr_num(i,ii)
	    cr_syst    = spcgr_syst(cr_spcgrno)
	    call no_error
	    goto 10
	  endif
	enddo
c
10	continue
c
	if(ier_num.eq.0) then
	    ier_num = -14
	    ier_typ = ER_APPL
	  if    (cr_syst.eq.1) then
	      call no_error
	  elseif(cr_syst.eq.2) then
	    if(cr_win(1).eq.90.0     .and. cr_win(3).eq.90.0) then
	      call no_error
	    endif
	  elseif(cr_syst.eq.3) then
	    if(cr_win(1).eq.90.0     .and. cr_win(2).eq.90.0) then
	      call no_error
	    endif
	  elseif(cr_syst.eq.4) then
	    if(cr_win(1).eq.90.0     .and. cr_win(2).eq.90.0 .and.
     &	       cr_win(3).eq.90.0                            ) then
	      call no_error
	    endif
	  elseif(cr_syst.eq.5) then
	    if(cr_a0 (1).eq.cr_a0(2) .and.
     &	       cr_win(1).eq.90.0     .and. cr_win(2).eq.90.0 .and.
     &	       cr_win(3).eq.90.0                            ) then
	      call no_error
	    endif
	  elseif(cr_syst.eq.6 .or. cr_syst.eq.8) then
	    if(cr_a0 (1).eq.cr_a0(2) .and.
     &	       cr_win(1).eq.90.0     .and. cr_win(2).eq.90.0 .and.
     &	       cr_win(3).eq.120.0                           ) then
	      call no_error
	    endif
	  elseif(cr_syst.eq.7) then
	    if(cr_a0 (1).eq.cr_a0(2) .and. cr_a0 (1).eq.cr_a0(3) .and.
     &	       cr_win(1).eq.cr_win(2).and. cr_win(2).eq.cr_win(3)) then
	      call no_error
	    endif
	  elseif(cr_syst.eq.9) then
	    if(cr_a0 (1).eq.cr_a0(2) .and. cr_a0 (1).eq.cr_a0(3) .and.
     &	       cr_win(1).eq.90.0     .and. cr_win(2).eq.90.0 .and.
     &	       cr_win(3).eq.90.0                            ) then
	      call no_error
	    endif
	  endif
	endif
	end
c**********************************************************************
c**********************************************************************
	subroutine symmetry
c-
c	Performs the space group symmetry on the current atom.
c	cr_natoms             the current atom number 
c	cr_iscat(cr_natoms)   its scattering type
c	                      and thus number of chemically identical
c	                      yet symmetrically different atoms
c
c+
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
	include 	'gen_add.inc'
	include 	'molecule.inc'
	include 	'sym_add.inc'
c
	real           	eps
	integer       	i,j,ii,iii,igs,igg
	integer         iiii
	integer         mole_i,mole_st
c
	include 	'generate.inc'
c
	data           eps/0.00001/
c
c------	If we're reading a molecule, insert current atom at the end of 
c	current molecule
c
	if(mole_l_on) then
	  call mole_insert_current(cr_natoms,mole_num_curr)
	  mole_num_act       = mole_num_curr
	  mole_i             = 1
	  mole_st            = mole_len(mole_num_curr)
	endif
c
c------	ii is the number of the atom the symmetry is to work on
c
	ii = cr_natoms
c
c------	Loop over all generators for spacegroup cr_spcgrno
c
	do igs = 1,generspcgr(0,cr_spcgrno)
	  igg = generspcgr(igs,cr_spcgrno)
c
c------	--iii is the number of the last atom generated by the previous
c------	--generator
c
	  iii = cr_natoms
c
	  call symmetry_gener(NMAX,
     &	           cr_natoms,cr_pos,cr_iscat,
     &	           ii,iii,iii,igg,NG,
     &	           generators,generpower)
c
	  if(ier_num.ne.0) then
	    return
	  endif
	enddo
c
c------	Loop over all additional generators
c
	do igs = 1,gen_add_n
c
c------	--iii is the number of the last atom generated by the previous
c------	--generator
c
	  iii = cr_natoms
c
	  call symmetry_gener(NMAX,
     &	           cr_natoms,cr_pos,cr_iscat,
     &	           ii,iii,iii,igs,NG,
     &	           gen_add,gen_add_power)
c
	  if(ier_num.ne.0) then
	    return
	  endif
	enddo
c
c------	Loop over all additional symmetry operations that are not generators
c
c
c------	--iiii is the number of the last atom generated by the last
c------	--generator
c
	iiii = cr_natoms
c
	do igs = 1,sym_add_n
c
c------	--iii is the number of the last atom generated by the previous
c------	--symmetry operation
c
	  iii = cr_natoms
c
	  call symmetry_gener(NMAX,
     &	           cr_natoms,cr_pos,cr_iscat,
     &	           ii,iii,iiii,igs,NG,
     &	           sym_add,sym_add_power)
c
	  if(ier_num.ne.0) then
	    return
	  endif
	enddo
c
c------	Sort Atoms into molecules
c
	if(mole_l_on) then
	  call mole_insert(ii)
c
c------	Make sure molecules have not been separated by integer unit cell 
c
	  call first_mole(mole_st)
	endif
c
	end
c**********************************************************************
	subroutine symmetry_gener(NMAX,
     &	           cr_natoms,cr_pos,cr_iscat,
     &	           ii,iii,iiii,igg,NG,
     &	           generators,generpower)
c-
c	Applies the generator to the current atom
c+
	implicit      none
c
	integer        NMAX
	include       'crystal3.inc'
	include       'errlist.inc'
	include       'molecule.inc'
c
	integer      NG
	integer      ii,iii,iiii
	integer      igg
	integer      generpower(NG)
c
	real         generators(4,4,0:NG)
c
	integer      ia,iaa,ipg
	integer      i,j,k
	real         x(4),y(4),z(4),w(4)
	real         wmat(4,4)
	real         xmat(4,4)
	real         eps
c
	data           eps/0.00001/
c
c
c------	For convenience create Identity operator
c
	do i = 1,4
	  do j = 1,4
	    xmat(i,j)=0.0
	  enddo
	  xmat(i,i)=1.0
	enddo
c
c------	Loop over all powers of generator igg
c
	do ipg = 1,generpower(igg)
c
c------	--raise power of generator, xmat is a dummy matrix, equal to
c------	--the previous power of the generator
c
	  do i = 1,4
	    do j = 1,4
	      wmat(i,j)=0.0
	      do k = 1,4
	        wmat(i,j)=wmat(i,j)+generators(i,k,igg)*xmat(k,j)
	      enddo
	    enddo
	  enddo
c
c------	--Multiply first point with current generator
c
	  do i=1,3
	    x(i)=cr_pos(i,ii)
	  enddo
	  x(4)=1.0
	  call trans(x,wmat,y,4)
	  if(.not. mole_l_on) then
c
c------	----Transform atom into first unit cell,
c	    if it is not inside a molecule
c
	    call firstcell(y,4)
c
c------	----check for existence with all previously created atoms
c 
	    do ia=ii,iii
c------	------if atom exists, skip generator
	      if( abs(y(1)-cr_pos(1,ia)).lt. eps .and. 
     &	          abs(y(2)-cr_pos(2,ia)).lt. eps .and. 
     &	          abs(y(3)-cr_pos(3,ia)).lt. eps       ) goto 10
	    enddo
	  else
c
c------	----Atom is inside a molecule, do not convert into first
c	    unit cell. Compare, however, a converted copy with original
c	    atom in order to decide whether generator must be skipped
c	    or not.
c
	    do ia=1,4
	      z(ia) = y(ia)
	    enddo
	    call firstcell(z,4)
c
c------	----check for existence with all previously created atoms
c	    The previously created atoms must be converted into first
c	    unit cell as well !
c 
	    do ia=ii,iii
	      do j=1,3
	        w(j) = cr_pos(j,ia)
	      enddo
	      w(4) = 1.0
	      call firstcell(w,4)
c------	------if atom exists, skip generator
	      if( abs(z(1)-w(1)).lt. eps .and. 
     &	          abs(z(2)-w(2)).lt. eps .and. 
     &	          abs(z(3)-w(3)).lt. eps       ) goto 10
	    enddo
	  endif
c
c------	--insert atom into crystal
c
	  if(cr_natoms.lt.nmax) then
	    cr_natoms = cr_natoms+1
	    cr_pos(1,cr_natoms) = y(1)
	    cr_pos(2,cr_natoms) = y(2)
	    cr_pos(3,cr_natoms) = y(3)
	    cr_iscat(cr_natoms) = cr_iscat(ii)
	  else
	    ier_num = -10
	    ier_typ = ER_APPL
	    write (ier_msg(1),8888) nmax
8888	    format('Maximum allowed atom number =',i10) 
	    return
	  endif
c
c------	--Multiply all other points with current generator
c
	  do iaa = ii+1,iiii
	    do i=1,3
	      x(i)=cr_pos(i,iaa)
	    enddo
	    x(4)=1.0
	    call trans(x,wmat,y,4)
	    if(.not. mole_l_on) then
c
c------	------Transform atom into first unit cell,
c	      if it is not inside a molecule
c
	      call firstcell(y,4)
	    endif
c
c------	------insert atom into crystal
c
	    if(cr_natoms.lt.nmax) then
	      cr_natoms = cr_natoms+1
	      cr_pos(1,cr_natoms) = y(1)
	      cr_pos(2,cr_natoms) = y(2)
	      cr_pos(3,cr_natoms) = y(3)
	      cr_iscat(cr_natoms) = cr_iscat(ii)
	    else
	      ier_num = 10
	      ier_typ = ER_APPL
	      return
	    endif
	  enddo
c
c------	set xmat to current power of generator
c
	  do i = 1,4
	    do j = 1,4
	      xmat(i,j)=wmat(i,j)
	    enddo
	  enddo
c------	--End of loop over all powers
	enddo
10	continue
c
	end
c**********************************************************************
	subroutine mole_insert(ii)
c-
c	Sorts the newly created atoms into the correct molecules.
c+
	implicit      none
c
	include       'config.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'errlist.inc'
	include       'molecule.inc'
c
	integer       ii
c
	integer       i,j,k,i1,iii,igs,l
	integer       mole_natoms
	integer       mole_iscat(MOLE_MAX_ATOM)
	integer       mole_temp (MOLE_MAX_ATOM)
CDBG	integer q
c
	logical       lsame
c
	real          mole_pos(3,MOLE_MAX_ATOM)
	real          w(3),z(3)
	real          eps
c
	data          eps/0.00001/
c
	mole_temp(1)       = mole_num_curr
	do i=2,MOLE_MAX_ATOM
	  mole_temp(i) = 0
	enddo
CDBG
CDBG	write (output_io,*) ' Molekuelliste: '
CDBG	write (output_io,5556) (mole_temp(q),q=1,8)
c
c------	Loop over all new atoms
c
	do i=ii,cr_natoms
c
c------	--If atom is not yet inside a molecule, create new molecule and
c	  insert
c
	  if(mole_temp(i-ii+1).eq.0) then
	    mole_num_act = mole_num_act+1
	    call mole_insert_current(i,mole_num_act)
	    mole_temp(i-ii+1) = mole_num_act
	  endif
c
c------	--Copy current atom into temporary array
c
	  mole_pos(1,1) = cr_pos(1,i)
	  mole_pos(2,1) = cr_pos(2,i)
	  mole_pos(3,1) = cr_pos(3,i)
	  mole_natoms   = 1
	  i1            = 1
c
c------	--Loop over all molecule generators
c
	  do igs=1,mole_gene_n
	    iii = mole_natoms
c
	    call symmetry_gener(MOLE_MAX_ATOM,
     &	             mole_natoms,mole_pos,mole_iscat,
     &	             i1,iii,iii,igs,MOLE_MAX_GENE,
     &	             mole_gene,mole_gene_power)
c
	    if(ier_num.ne.0) then
	      return
	    endif
	  enddo
c
c------	--Loop over all molecule symmetries
c
	  do igs=1,mole_symm_n
	    iii = mole_natoms
c
	    call symmetry_gener(MOLE_MAX_ATOM,
     &	             mole_natoms,mole_pos,mole_iscat,
     &	             i1,iii,iii,igs,MOLE_MAX_GENE,
     &	             mole_symm,mole_symm_power)
c
	    if(ier_num.ne.0) then
	      return
	    endif
	  enddo
CDBG
CDBG	write (output_io,*) ' Erzeugte Atome im Molekuel'
CDBG5555	format(3f10.4)
CDBG	do q=1,mole_natoms
CDBG	  write (output_io,5555) mole_pos(1,q),mole_pos(2,q),mole_pos(3,q)
CDBG	enddo
c
c------	--Loop over all new atoms
c
	  do j=ii,cr_natoms
CDBG
CDBG	write (output_io,*   )
c
c------	----If atom is not yet assigned to an atom
c
	    if(mole_temp(j-ii+1).eq.0) then
c
c------	------Create copy in first unit cell
c
	      do l=1,3
	        z(l) = cr_pos(l,j)
	      enddo
	      call firstcell(z,3)
c
c------	------Loop over all copies
c
	      do k=2,mole_natoms
c
c------	--------Compare positions
c
c
c------	--------Create copy in first unit cell
c
	        do l=1,3
	          w(l) = mole_pos(l,k)
	        enddo
	        call firstcell(w,3)
	        lsame = abs(z(1)-w(1)).lt.eps.and.
     &	                abs(z(2)-w(2)).lt.eps.and.
     &	                abs(z(3)-w(3)).lt.eps
CDBG
CDBG	write (output_io,5557) z,w,lsame
CDBG5557	format(3f10.4,4x,3f10.4,4x,l1)
	        if(lsame) then
	          call mole_insert_current(j,mole_temp(i-ii+1))
	          mole_temp(j-ii+1) = mole_temp(i-ii+1)
	        endif
	      enddo
	    endif
	  enddo
CDBG
CDBG	write (output_io,*) ' Molekuelliste: '
CDBG	write (output_io,5556) (mole_temp(q),q=1,8)
CDBG5556	format(8i4)
	enddo
c
	end
c**********************************************************************
	subroutine mole_insert_current(iatom,imole)
c-
c	Inserts the last atom into the molecule list as last atom of
c	the specified molecule.
c+
	implicit      none
c
	include       'molecule.inc'
c
	integer       iatom
	integer       imole
c
	integer       i
c
c------	Move the content of all molecules after "imole" one down the list
c	mole_num_atom : total number of atoms in molecules
c	mole_num_acur : number of atoms in molecules including "imole"
c
	mole_num_atom = mole_off(mole_num_mole) +
     &	                mole_len(mole_num_mole)
c
c------	If necessary, create new molecule
c
	if(imole.gt.mole_num_mole) then
	  mole_num_mole    = mole_num_mole + 1
	  mole_len(imole)  = 0
	  mole_off(imole)  = mole_num_atom
	  mole_type(imole) = mole_num_type
	endif
c
	mole_num_acur = mole_off(imole) +
     &	                mole_len(imole)
c
	do i=mole_num_atom,mole_num_acur+1,-1
	  mole_cont(i+1) = mole_cont(i)
	enddo
c
c------	move the offset of all molecules after "imole" one down
c
	do i=imole+1,mole_num_mole
	  mole_off(i) = mole_off(i) + 1
	enddo
c
c------	insert atom "iatom" at the end of molecule "imole"
c
	mole_cont(mole_num_acur+1) = iatom
	mole_len(imole)            = mole_len(imole) + 1
	mole_num_acur              = mole_num_acur + 1
c
	end
c**********************************************************************
	subroutine first_mole(mole_st)
c-
c	Moves atoms by +- one unit cell to keep molecules concatenated
c	The algorithm of this subroutine is based on the assumption,
c	that the first atom is on the highest point of symmetry of the
c	molecule, i.e. is not copied by any of the symmetry operations
c	or generators that make up the molecule symmetry. This has the
c	desired effect that the bond distance of all symmetry 
c	equivalent atoms to this first atom is constant and can be taken
c	as a reference. If a symmetry operation of the space group
c	moves an atom out of the current unit cell, one can move this
c	atom back by integer unit cell vectors until the bond distance
c	is correct again.
c	If the molecule does not include an atom on the highest point
c	of the molecule symmetry, you must insert a "void" on this site.
c+
	implicit   none
c
	include   'config.inc'
	include   'crystal.inc'
	include   'crystal.cmm'
	include   'molecule.inc'
	include   'prompt.inc'
c
	logical    lspace
	parameter (lspace=.true.)
c
	integer    mole_st
	integer    i,j,k1,k2,k3
	integer    k1u,k1o,k2u,k2o,k3u,k3o
	real       d,dd
	real       u(3),v(3)
	real       x,y,z
c
	real       do_blen
c
c.......calculate metric and reciprocal metric tensor,reciprocal lattice
c       constants and permutation tensors
            call lattice(cr_a0,cr_ar,cr_eps,cr_gten,
     &	    cr_reps,cr_rten,cr_win,cr_wrez,cr_v,
     &	    cr_vr,.false.)
c
c------	Only one atom in the current molecule, return immediately
c
CDBG
CDBG	write (output_io,*) 'mole_len(mole_num_curr)', mole_len(mole_num_curr)
CDBG	write (output_io,*) 'mole_st                ',mole_st

	if(mole_len(mole_num_curr).eq.1) return
	if(mole_st.eq.1) mole_st = 2
	if(mole_len(mole_num_curr).lt.mole_st) return
c
	u(1) = cr_pos(1,mole_cont(mole_off(mole_num_curr)+1))
	u(2) = cr_pos(2,mole_cont(mole_off(mole_num_curr)+1))
	u(3) = cr_pos(3,mole_cont(mole_off(mole_num_curr)+1))
c
	v(1) = cr_pos(1,mole_cont(mole_off(mole_num_curr)+mole_st))
	v(2) = cr_pos(2,mole_cont(mole_off(mole_num_curr)+mole_st))
	v(3) = cr_pos(3,mole_cont(mole_off(mole_num_curr)+mole_st))
c
	d = do_blen(lspace,u,v)
CDBG
CDBG	write (output_io,5555) u,v,d
CDBG5555	format(3f10.4,2x,3f10.4,2x,f12.4/)
c
c------	Loop over all molecules from current to last
c
	do i=mole_num_curr,mole_num_mole
CDBG
CDBG	write (output_io,*) ' Molecule : ',i
	    u(1) = cr_pos(1,mole_cont(mole_off(i)+1))
	    u(2) = cr_pos(2,mole_cont(mole_off(i)+1))
	    u(3) = cr_pos(3,mole_cont(mole_off(i)+1))
c
c------	Loop over all atoms on places mole_st and higher
c
	  do j=mole_st,mole_len(i)
c
c------	----Determine proper limits for the loop over neighboring unit cells
c
	    x = cr_pos(1,mole_cont(mole_off(i)+j))
	    if(-1.0.lt.x .and. x.lt.0 .or. x.ge.1.0) then
	      k1u = -int(x)
	      k1o = k1u + 1
	    else
	      k1u = -int(x) - 1
	      k1o = k1u + 1
	    endif
	    y = cr_pos(2,mole_cont(mole_off(i)+j))
	    if(-1.0.lt.y .and. y.lt.0 .or. y.ge.1.0) then
	      k2u = -int(y)
	      k2o = k2u + 1
	    else
	      k2u = -int(y) - 1
	      k2o = k2u + 1
	    endif
	    z = cr_pos(3,mole_cont(mole_off(i)+j))
	    if(-1.0.lt.z .and. z.lt.0 .or. z.ge.1.0) then
	      k3u = -int(z)
	      k3o = k3u + 1
	    else
	      k3u = -int(z) - 1
	      k3o = k3u + 1
	    endif
CDBG
CDBG	write (output_io,*) ' x,y,z    ',x,y,z
CDBG	write (output_io,*) 'loop over ',k1u,k1o,k2u,k2o,k3u,k3o
c
c------	----perform loop over next unit cells
c
	    do k1=k1o,k1u,-1
	    do k2=k2o,k2u,-1
	    do k3=k3o,k3u,-1
	    v(1) = cr_pos(1,mole_cont(mole_off(i)+j))+float(k1)
	    v(2) = cr_pos(2,mole_cont(mole_off(i)+j))+float(k2)
	    v(3) = cr_pos(3,mole_cont(mole_off(i)+j))+float(k3)
	    dd   = do_blen(lspace,u,v)
CDBG
CDBG	write (output_io,5556) u,j,mole_off(i)+j,v,dd
CDBG5556	format(3f10.4,2(2x,i2),2x,3f10.4,2x,f12.4)
	    if(abs(d-dd).lt.0.01) then
	      goto 10
	    endif
	    enddo
	    enddo
	    enddo
c
	write (*,*) ' No correct distance found'
	return
c
10	    continue
	    cr_pos(1,mole_cont(mole_off(i)+j)) = v(1)
	    cr_pos(2,mole_cont(mole_off(i)+j)) = v(2)
	    cr_pos(3,mole_cont(mole_off(i)+j)) = v(3)
CDBG
CDBG	write (output_io,5557) k1,k2,k3
CDBG5557	format('loesung fuer ',3i3)
c
	  enddo
	enddo
c
	end
c**********************************************************************
	subroutine mole_firstcell
c-
c	Moves molecules whose first atom is outside the unit cell into
c	the first unit cell.
c+
	implicit      none
c
	include   'config.inc'
	include   'crystal.inc'
	include   'crystal.cmm'
	include   'molecule.inc'
c
	real          eps
	parameter    (eps=1.e-5)
c
	integer       i,j,k
	real          x,x1
c
c------	Loop over all molecules from current to last
c
	do j=mole_num_curr,mole_num_mole
	  do i=1,3
	    x  = cr_pos(i,mole_cont(mole_off(j)+1))
	    x1 = float(int(x))
	    if(x-x1.lt.-eps) x1=x1-1
	    if(abs(x1).gt.eps) then
c
c------	------Loop over all atoms in molecule j
c
	      do k=1,mole_len(j)
	        cr_pos(i,mole_cont(mole_off(j)+k)) =
     &	        cr_pos(i,mole_cont(mole_off(j)+k)) - x1
	      enddo
	    endif
	  enddo
	enddo
	end
c**********************************************************************
	subroutine firstcell(y,idim)
c-
c	truncates atomic position to fractal position of 
c	0.0 <= x < 1
c+
	implicit      none
c
	integer       idim,i
	real          y(idim)
c
	do i = 1,3
	  y(i) = y(i) - float(int(y(i)))
	  if(y(i) .lt. 0.0) y(i) = y(i)+1
	  if(y(i) .eq. 1.0) y(i) = 0.0
	enddo
	end
c**********************************************************************
	subroutine rese_cr
c
c	resets the crystal structure to empty
c
	implicit 	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'gen_add.inc'
	include 	'molecule.inc'
	include 	'save.inc'
	include 	'sym_add.inc'
c
	integer 	i
c
	cr_natoms  = 0
	as_natoms  = 0
	cr_ncatoms = 0
	cr_nscat   = 0
	do i=1,maxscat
	  cr_at_lis(i) = ' '
	enddo
	do i=1,3
	  cr_dim(i,1) = 0.0
	  cr_dim(i,2) = 0.0
	enddo
c
	do i=0,mole_num_mole
	  mole_len(i) = 0
	  mole_off(i) = 0
	enddo
	mole_l_on = .false.
	mole_num_mole = 0
	mole_num_curr = 0
	mole_num_act  = 0
	mole_num_type = 0
	mole_gene_n   = 0
	mole_symm_n   = 0
c
	sym_add_n = 0
	gen_add_n = 0
c
	sav_r_ncell = .false.
c
	end
c**********************************************************************
	subroutine recip_symm
c-
c	Creates the symmetry matrices in reciprocal space
c+
	implicit   none
c
	include    'config.inc'
	include    'crystal.inc'
	include    'crystal.cmm'
	include    'recipro.inc'
c
	integer    i,j,k
	logical    lfriedel_remove
	logical    lacentric
	real       a(3,3)
	real       b(3,3)
	real       h(4,rec_max_sym)
c
c------	Set up a general reflection
c
	h(1,1) = 0.1
	h(2,1) = 0.2
	h(3,1) = 0.3
	h(4,1) = 0.0
	do i=1,4
	  do j=1,4
	    rec_sym(i,j,1) = 0.0
	  enddo
	  rec_sym(i,i,1) = 1.0
	enddo
c
c------	Create all symmetry operations in real space that create
c	a different vector, ignoring the translational part. The
c	translational part of each first new matrix is saved, since
c	this is needed for proper phase assignment.
c	lfriedel_remove  Logical variable that signals to remove
c	                 symmetry operations -1
c	cr_acentric      logical variable that describes whether the
c	                 space group is acentric or not
c
	lfriedel_remove = .false.
	call rmc_symmetry (rec_n_sym,h,rec_sym,rec_max_sym,
     &	                   lfriedel_remove,lacentric)
	cr_acentric = lacentric
c
c------	Transform all symmetry operations into reciprocal space
c
	do k=1,rec_n_sym
	  do i=1,3
	    do j=1,3
	      a(i,j) = rec_sym(i,j,k)
	    enddo
	  enddo
c
c------	--do transformation q = gSg*
c
	  call matmulx (b,a,cr_rten)
	  call matmulx (a,cr_gten,b)
	  do i=1,3
	    do j=1,3
	      rec_sym(i,j,k) = a(i,j)
	    enddo
	  enddo
c
cdbg	write( *,1000) k
cdbg	do i=1,4
cdbg	  write (output_io,1010) (rec_sym(i,j,k),j=1,4)
cdbg	enddo
cdbg1000	format('**********************'/' Matrix Number ', i4)
cdbg1010	format(3(f4.1,2x),f7.4)
	enddo
c
	end
c*****7****************************************************************
	subroutine update_cr_dim
c-
c	Updates the crystal dimensions to the current values
c+
	implicit   none
c
	include    'config.inc'
	include    'crystal.inc'
	include    'crystal.cmm'
c
	integer    i,j
c
c------	Set initial values
c
	if(cr_natoms.gt.0) then
	  do j=1,3
	    cr_dim(j,1) = cr_pos(j,1)
	    cr_dim(j,2) = cr_pos(j,1)
	  enddo
	else
	  do j=1,3
	    cr_dim(j,1) =  1.e10
	    cr_dim(j,1) = -1.e10
	  enddo
	endif
c
c------	Update values from all atoms in crystal
c
	do i=1,cr_natoms
	  do j=1,3
            cr_dim(j,1)=amin1(cr_dim(j,1),cr_pos(j,i))
            cr_dim(j,2)=amax1(cr_dim(j,2),cr_pos(j,i))
	  enddo
	enddo
c
	end
c*****7****************************************************************
