c+
c	Generalized symmetry operations:
c
c	Rotations around a general axis by a general angle
c	Mirror operations with free choice of normal and glide 
c	component.
c
c	Version : 2.01
c	Date    : 21 October 1997
c
c	Author  : R.B. Neder  (reinhard.neder@mail.uni-wuerzburg.de)
c	          Th. Proffen (tproffen@lanl.gov)
c
c*****7*****************************************************************
	subroutine symm
c-
c	Main menu for generalized symmetry operations
c+
	implicit      none
c
	include       'config.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'doact.inc'
	include       'errlist.inc'
	include       'learn.inc'
	include       'macro.inc'
	include       'molecule.inc'
	include       'prompt.inc'
	include       'symm.inc'
c
	integer        maxw
	logical        lnew,lold
c
	parameter     (maxw=MAXSCAT)
	parameter     (lnew=.true.,lold=.false.)
c
	character*5    befehl
	character*11   prom
	character*200  line,zeile,cpara(maxw)
	integer        lpara(maxw),lp,length,lbef
	integer        repl(0:MAXSCAT)
	integer        indxg,ianz,i
	logical        lend,lspace
	real           hkl(3)
	real           werte(maxw)
c
	logical        str_comp
c
	include 'microsta.inc'
c
	lend=.false.
	call no_error
c
	do while (.not. lend)
	  prom=prompt//'/symm'
	  call get_command (line,length,befehl,lbef,zeile,lp,prom)
	  if(ier_num.eq.0) then
	  if(line.ne.' ' .and. line(1:1).ne.'#') then
c
c------	----search for "="
c
	    indxg=index(line,'=')
	    if(indxg.ne.0 
     &	              .and. .not.(str_comp(befehl,'echo',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'syst',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'help',2,lbef,4) .or.
     &	                          str_comp(befehl,'?   ',2,lbef,4)) )then
c
c------	------evaluatean expression and assign the value to a variabble
c
	      call do_math(line,indxg,length)
	    else
c
c------ ----execute a macro file
c
            if(befehl(1:1).eq.'@') then
	      if(length.ge.2) then
	        call file_kdo(line(2:length),length-1)
	      else
	        ier_num = -13
	        ier_typ = ER_MAC
	      endif
c
c------	----angle of rotation 'angle'
c
	    elseif(str_comp(befehl,'angle',2,lbef,5)) then
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.1) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          sym_angle = werte(1)
	        endif
	      endif
c
c------	----list asymmetric unit 'asym'
c
	    elseif(str_comp(befehl,'asym',2,lbef,4)) then
	      call show_asym
c
c------	----calculate a single symmetry operation
c
	    elseif(str_comp(befehl,'calc',2,lbef,4)) then
	      call symm_setup
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.3) then
		  cpara(4) = 'd'
		  lpara(4) = 1
		endif
		ianz = 3
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            hkl(i) = werte(i)
	          enddo
	          if(str_comp(cpara(4),'d',1,lpara(4),1)) then
		    lspace = .true.
	          elseif(str_comp(cpara(4),'r',1,lpara(4),1)) then
		    lspace = .false.
		  else
	            ier_num = -6
	            ier_typ = ER_COMM
		  endif
		  if(ier_num.eq.0) then
	            if(sym_power_mult ) then
	              call symm_ca_mult(hkl,lspace)
	            else
	              call symm_ca_single(hkl,lspace)
	            endif
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----continues a macro 'continue'
c
	    elseif(str_comp(befehl,'continue',2,lbef,8)) then
	      call macro_continue(zeile,lp)
c
c------	----list atoms present in the crystal 'chem'
c
	    elseif(str_comp(befehl,'chem',2,lbef,4)) then
	      call show_chem
c
c------ ----Echo a string, just for interactive check in a macro 'echo'
c
	    elseif(str_comp(befehl,'echo',2,lbef,4)) then
	      call echo(zeile,lp)
             
c
c------	 ---Evaluate an expression, just for interactive check 'eval'
c
	    elseif(str_comp(befehl,'eval',2,lbef,4)) then
	      call do_eval(zeile,lp)
c
c------	----exit 'exit'
c
	    elseif(str_comp(befehl,'exit',2,lbef,4)) then
	      lend=.true.
c
c------	----help 'help','?'
c
	    elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	           str_comp(befehl,'?   ',1,lbef,4)     ) then
	      if(str_comp(zeile,'errors',2,lp,6) ) then
	        lp = lp + 7
	        call do_hel('discus '//zeile,lp)
	      else
	        lp = lp + 12
	        call do_hel('discus symm '//zeile,lp)
	      endif
c
c------	----Select the reciprocal space direction of the symmetry axis 'hkl'
c
	    elseif(str_comp(befehl,'hkl ',2,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            sym_hkl(i) = werte(i)
	          enddo
	          call trans(sym_hkl,cr_rten,sym_uvw,3)
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Select range of atoms within crystal to be included 'incl'
c
	    elseif(str_comp(befehl,'incl',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.2) then
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            sym_sel_atom = .true.
	            sym_start = nint(werte(1))
	            sym_end   = nint(werte(2))
	            sym_incl  = 'list'
	          endif
	        elseif(ianz.eq.1) then
	          if(str_comp(cpara(1),'all',1,lpara(1),3)) then
	            sym_sel_atom = .true.
	            sym_start =  1
	            sym_end   = -1
	            sym_incl  = 'all '
	          elseif(str_comp(cpara(1),'env',1,lpara(1),3)) then
	            sym_sel_atom = .true.
	            sym_start =  1
	            sym_end   = -1
	            sym_incl  = 'env '
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----Select range of molecules within crystal to be included 'mincl'
c
	    elseif(str_comp(befehl,'mincl',1,lbef,5)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.2) then
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            sym_sel_atom = .false.
	            sym_start = nint(werte(1))
	            sym_end   = nint(werte(2))
	          endif
	        elseif(ianz.eq.1) then
	          if(str_comp(cpara(1),'all',1,lpara(1),3)) then
	            sym_sel_atom = .false.
	            sym_start =  1
	            sym_end   = -1
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----Select the mode of symmetry operation 'mode'
c
	    elseif(str_comp(befehl,'mode',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.1 .or. ianz.eq.2) then
	          if(str_comp(cpara(1),'copy',1,lpara(1),4)) then
	            sym_mode = .true.
	          elseif(str_comp(cpara(1),'repl',1,lpara(1),4)) then
	            sym_mode = .false.
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        endif
c
	        if(ier_num.eq.0 .and. ianz.eq.2) then
	          if(str_comp(cpara(2),'new',1,lpara(2),3)) then
	            sym_new = .true.
	          elseif(str_comp(cpara(1),'old',1,lpara(1),3)) then
	            sym_new = .false.
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        endif
	      endif
c
c------	----Select/deselect molecules
c
	    elseif(str_comp(befehl,'msel',2,lbef,4) .or.
     &	           str_comp(befehl,'mdes',2,lbef,4)     ) then
c
	      call mole_select(zeile,lp,sym_latom,repl,0,0,maxscat,
     &	                       sym_sel_atom,sym_md_s,sym_md_nr,lold,
     &	                       str_comp(befehl,'msel',2,lbef,4))
c
c------	----Select the origin of the symmetry operation  'origin'
c
	    elseif(str_comp(befehl,'origin',1,lbef,6)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. (ianz.eq.3 .or. ianz.eq.4)) then
	        if (ianz.eq.4) then
	          sym_orig_mol = str_comp(cpara(4),'mol',1,lpara(4),3)
	          ianz = 3
	        endif
c
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            sym_orig(i) = werte(i)
	          enddo
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Set the power of the symmetry operation  'power'
c
	    elseif(str_comp(befehl,'power',1,lbef,6)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.1 .or. ianz.eq.2) then
	          if(ianz.eq.2) then
	            if(str_comp(cpara(2),'mult',1,lpara(2),4)) then
	              sym_power_mult = .true.
	            elseif(str_comp(cpara(2),'sing',1,lpara(2),4)) then
	              sym_power_mult = .false.
	            else
	              ier_num = -6
	              ier_typ = ER_COMM
	            endif
	          endif
	          ianz = 1
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	              sym_power = nint(werte(1))
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----run symmetry 'run'
c
	    elseif(str_comp(befehl,'run ',1,lbef,4)) then
	      call symm_setup
	      if(sym_sel_atom) then
c
c-----	--------Apply symmetry operation to atoms
c
	        if(sym_power_mult ) then
	          call symm_op_mult
	        else
	          call symm_op_single
	        endif
	      else
c
c-----	--------Apply symmetry operation to molecules
c
	        if(sym_power_mult ) then
	          call symm_mole_mult
	        else
	          call symm_mole_single
	        endif
	      endif
	      call update_cr_dim
c
c------	----Select which atoms are copied to their image 'sele'
c
	    elseif(str_comp(befehl,'sele',2,lbef,4) .or.
     &	           str_comp(befehl,'dese',2,lbef,4)     ) then
c
	      call atom_select(zeile,lp,sym_latom,repl,0,0,maxscat,
     &	                       sym_sel_atom,sym_md_s,sym_md_nr,lold,
     &	                       str_comp(befehl,'sele',2,lbef,4))
c
c------	----show current parameters 'show'
c
	    elseif(str_comp(befehl,'show',2,lbef,4)) then
	      call symm_setup
	      call symm_show
c
c------	----Select translational part of the symmetry operation 'trans'
c
	    elseif(str_comp(befehl,'trans',2,lbef,5)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            sym_trans(i) = werte(i)
	          enddo
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Select the type of symmetry operation                  'type'
c
	    elseif(str_comp(befehl,'type',2,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.1) then
	          if(str_comp(cpara(1),'proper',1,lpara(1),6)) then
	            sym_type = .true.
	          elseif(str_comp(cpara(1),'improper',1,lpara(1),8)) then
	            sym_type = .false.
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        endif
	      endif
c
c------	----Select the direct space direction of the symmetry axis 'uvw'
c
	    elseif(str_comp(befehl,'uvw ',1,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            sym_uvw(i) = werte(i)
	          enddo
	          call trans(sym_uvw,cr_gten,sym_hkl,3)
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------- -Operating System Kommandos 'syst'
c
	  elseif(str_comp(befehl,'syst',2,lbef,4)) then
	    if(zeile.ne. ' ') then
	      call do_operating(zeile(1:lp),lp)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------  -----waiting for user input
c
	    elseif(str_comp(befehl,'wait',3,lbef,4)) then
	      call do_input(zeile,lp)
	    else
	      ier_num = -8
	      ier_typ = ER_COMM
	    endif
	    endif
	  endif
	  endif
	  if(ier_num.ne.0) then
	    call errlist
	    if(lmakro) then
	      call macro_close
	      prompt_status = PROMPT_ON
	    endif
	    if(lblock) then
	      ier_num = -11
	      ier_typ = ER_COMM
	      return
	    endif
	    call no_error
	  endif
	enddo
c
9999	continue
c
	end
c*****7*****************************************************************
	subroutine symm_show
c-
c	Shows current symm settings
c+
	implicit     none
c
	include      'config.inc'
	include      'prompt.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'molecule.inc'
	include      'microsta.inc'
	include      'symm.inc'
c
	character*9  at_lis(maxscat),at_name
	integer	     mol_lis(maxscat)
	integer	     i,j,k
c
	write (output_io,3000) sym_uvw
	write (output_io,3010) sym_hkl
	if(sym_orig_mol) then
	  write (output_io,3020) sym_orig,' rel.to molecule'
	else
	  write (output_io,3020) sym_orig,' rel. to crystal'
	endif
	write (output_io,3030) sym_angle
	write (output_io,3040) sym_trans
	write (output_io,3045) sym_or_tr
	write (output_io,3050) ((sym_mat (i,j),j=1,4),i=1,3)
	write (output_io,3060) ((sym_rmat(i,j),j=1,3),i=1,3)
	write (output_io,3070) sym_power
c
	if(sym_power_mult) then
	  write (output_io,3080) 'Multiple copy of original'
	else
	  write (output_io,3080) 'Single copy of original'
	endif
c
	if(sym_type) then
	  write (output_io,3090) 'Proper rotation'
	else
	  write (output_io,3090) 'Improper rotation'
	endif
c
	if(sym_mode) then
	  write (output_io,3100) 'Copy atom/molecule to new position'
	else
	  write (output_io,3100) 'Move atom/molecule to new position'
	endif
c
	if(sym_new .and. .not. sym_sel_atom) then
	  write (output_io,3110) 'Create new molecule type'
	else
	  write (output_io,3110) 'Keep molecule type'
	endif
c
	write (output_io,3120) cmic_s(sym_md_s)
c
c------ Working with atoms ...
c
	if(sym_sel_atom) then
	  if(sym_md_s.eq.MD_S_IND) then
	    write (output_io,3200) sym_md_nr
	  endif
c
	  j=0
	  do i=0,cr_nscat
	    if (sym_latom(i)) then
	      j=j+1
	      at_lis(j)=at_name(i)
	    endif
	  enddo
	  write (output_io,3210) (at_lis(i),i=1,j)
c
	  if(sym_incl.eq.'all ') then
	    write (output_io,3220) 
	  elseif(sym_incl.eq.'env ') then
	    write (output_io,3225) 
	  else
	    write (output_io,3230) sym_start,sym_end
	  endif
c
c------ Working with molecules
c
	else
	  if(sym_md_s.eq.MD_S_IND) then
	    write (output_io,3200) sym_md_nr
	  endif
c
	  if (sym_orig_mol) then
	    write (output_io,3250) 'Molecule'
	  else
	    write (output_io,3250) 'Crystal'
	  endif
c
	  j=0
	  do i=0,mole_num_type
	    if (sym_latom(i)) then
	      j=j+1
	      mol_lis(j)=i
	    endif
	  enddo
	  write (output_io,3300) (mol_lis(k),k=1,j)
c
	  if(sym_end.eq.-1) then
	    write (output_io,3310) 
	  else
	    write (output_io,3320) sym_start,sym_end
	  endif
	endif
c
3000	format( ' Generalized Symmetry Operation'/
     &	        '   Axis in direct space      : ',3(2x,f9.4))
3010	format( '   Axis in reciprocal space  : ',3(2x,f9.4))
3020	format( '   Origin of symmetry element: ',3(2x,f9.4),a)
3030	format( '   Rotation angle            : ',  2x,f9.4 )
3040	format( '   Translation part(true)    : ',3(2x,f9.4))
3045	format( '   Translation part(origin)  : ',3(2x,f9.4)/)
3050	format( '   Real space matrix         : ',4(2x,f9.4)/
     &	     2( '                             : ',4(2x,f9.4)/))
3060	format( '   Reciprocal space matrix   : ',3(2x,f9.4)/
     &	     2( '                             : ',3(2x,f9.4)/))
3070	format( '   Power of symmetry element : ', (2x,i4  ))
3080	format( '   Mode of power level       : ',2x,a)
3090	format( '   Type of symmetry element  : ',2x,a)
3100	format( '   Mode of symmetry operation: ',2x,a)
3110	format( '   Molecule status           : ',2x,a)
3120	format(/'   Select status             : ',2x,a)
3200	format( '   Seleced microdomain type  : ',2x,i4)
3210	format( '   Selected atom types       : ',2x,50(a9,1x))
3220	format( '   Range of selected atoms   :   All atoms included')
3225	format( '   Range of selected atoms   :   Current environment')
3230	format( '   Range of selected atoms   : ',i9,' to ',i9)
3250	format( '   Given origin relative to  : ',2x,a)
3300	format( '   Selected molecule types   : ',2x,50(i4,1x))
3310	format( '   Range of sel. molecules   :   All molecules included')
3320	format( '   Range of sel. molecules   : ',i9,' to ',i9)
c
	end
c*****7*****************************************************************
	subroutine  symm_setup
c-
c	Performs the generalized symmetry operation
c	See Sands, D.E. Vectors and Tensors in Crystallography Chapt. 4.7
c+
	implicit     none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'errlist.inc'
	include      'microdis.inc'
	include      'microsta.inc'
	include      'symm.inc'
c
	integer      i,j,k,l
	real         length
c
	real         uij
	real         ctheta,stheta
	real         sym_d(3),sym_r(3)
	real         usym(4),ures(4)
	real         kron(3,3)
	real         a(3,3)
	real         b(3,3)
c
	real         cosd,sind
	real         skalpro
c
c
	data kron    /1.0,0.0,0.0,   0.0,1.0,0.0,   0.0,0.0,1.0/
c
c------	initialize matrix and angle
c
	do i=1,4
	  do j=1,4
	    sym_mat (i,j)= 0.0
	    sym_rmat(i,j)= 0.0
	  enddo
	enddo
	sym_mat (4,4)= 1.0
	sym_rmat(4,4)= 0.0
	if(sym_power_mult) then
	  ctheta = cosd(sym_angle)
	  stheta = sind(sym_angle)
	else
	  ctheta = cosd(sym_angle*sym_power)
	  stheta = sind(sym_angle*sym_power)
	endif
c
c------	Create vectors of unit length in direct and reciprocal space
c
	length = sqrt(skalpro(sym_uvw,sym_uvw,cr_gten))
	if(length.eq.0.0) then
	  ier_num = -32
	  ier_typ =ER_APPL
	  return
	endif
	do j=1,3
	  sym_d(j) = sym_uvw(j)/length
	enddo
	length = sqrt(skalpro(sym_hkl,sym_hkl,cr_rten))
	if(length.eq.0.0) then
	  ier_num = -32
	  ier_typ =ER_APPL
	  return
	endif
	do j=1,3
	  sym_r(j) = sym_hkl(j)/length
	enddo
c	write (output_io,2001) sym_d,sym_r
c2001	format('direct axis     :',3(2x,f10.6)/
c    &	       'reciprocal axis :',3(2x,f10.6))
c
c------	calculate symmetry operation
c
	do i=1,3
	  do j=1,3
	  sym_mat(i,j) = 0.0
	    do k=1,3
	      do l=1,3
	        sym_mat(i,j) = sym_mat(i,j) + 
     &	                       cr_rten(i,k)*cr_eps(k,l,j)*sym_d(l)
	      enddo
	    enddo
	    uij          = sym_d(i)*sym_r(j)
	    sym_mat(i,j) = sym_mat(i,j)*stheta +
     &	                   uij + (kron(i,j)-uij)*ctheta
	  enddo
	  if(sym_power_mult) then
	    sym_mat(i,4) = sym_trans(i)
	  else
	    sym_mat(i,4) = sym_trans(i)*sym_power
	  endif
	enddo
c
c------	In case of improper rotation, multiply by -1
c
	if(.not.sym_type .and.
     &	   (sym_power_mult .or.
     &	    .not.sym_power_mult .and.mod(sym_power,2).ne.0) ) then
	  do i=1,3
	    do j=1,3
	      sym_mat(i,j) = -sym_mat(i,j)
	    enddo
	  enddo
	endif
c	write (output_io,2000) ((sym_mat(i,j),j=1,3),i=1,3)
c2000	format(3(3(2x,f10.6)/))
c
c
c
c------	Transform symmetry operation into reciprocal space
c
	do i=1,3
	  do j=1,3
	    a(i,j) = sym_mat(i,j)
	  enddo
	enddo
c
c------	do transformation q = gSg*
c
	call matmulx (b,a,cr_rten)
	call matmulx (a,cr_gten,b)
	do i=1,3
	  do j=1,3
	    sym_rmat(i,j) = a(i,j)
	  enddo
	enddo
c
c------	----Calculate translational component due to origin
c
c
c------	----Apply rotational part of symmetry operation to -1*origin
c
	    do j=1,3
	      usym(j) = - sym_orig(j)
	    enddo
c
c-----	----Apply symmetry operation
c
	    usym(4)=0.0
	    call trans(usym,sym_mat,ures,4)
c
c------	----Add origin to result to obtain total translational part
c
	    do j=1,3
	      sym_or_tr(j) = ures(j) + sym_orig(j)
	    enddo
c	write (output_io,2000) ((sym_rmat(i,j),j=1,3),i=1,3)
c2000	format(3(3(2x,f10.6)/))
c
	end
c*****7*****************************************************************
	subroutine symm_op_mult
c-
c	Performs the actual symmetry operation, multiple copy version
c+
	implicit     none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'atom_env.inc'
	include      'errlist.inc'
	include      'microdis.inc'
	include      'symm.inc'
	include      'microsta.inc'
c
	character*4  name
c
	integer      i,j,k,l
	integer      i_start,i_end
c
	real         usym(4),ures(4)
	real         werte(5)
c
	data usym    /0.0,0.0,0.0,1.0/
	data werte   /0.0,0.0,0.0,0.0,0.0/
c
c------	Set the appropriate starting end ending number for the atoms
c
	i_start = sym_start
	i_end   = sym_end
	if(sym_incl.eq.'all ') then
	  i_end = cr_natoms
	elseif(sym_incl.eq.'env ') then
	  i_end = atom_env(0)
	endif
c
c------	Apply symmetry operation to all atoms within selected range
c
	do l=i_start,i_end
	  i=l
	  if(sym_incl.eq.'env ') i=atom_env(l)
c
c------	--Select atom if:
c	  type has been selected and
c	       all atoms are selected                            or
c	       all microdomains have been selected               or
c	       a specific microdomain type has been selected     or
c	       microdomains are deselected and atom is outside
c
	  if(sym_latom(cr_iscat(i)) .and. 
     &	     ( sym_md_s.eq.MD_S_EVE                               .or.
     &	       sym_md_s.eq.MD_S_ALL .and. cr_md_next(i).lt.0      .or.
     &	       sym_md_s.eq.MD_S_IND .and. cr_md_next(i).lt.0 .and.
     &                     mc_type(-cr_md_next(i)).eq.sym_md_nr   .or.
     &	       sym_md_s.eq.MD_S_NON .and. sym_md_nr.eq.0      .and.
     &	                            cr_md_next(i).ge.0      )  ) then
c
c------	----Subtract origin 
c
	    do j=1,3
	      usym(j) = cr_pos(j,i) - sym_orig(j)
	    enddo
c
c-----	----Apply symmetry operation
c
	    usym(4)=1.0
	    do k=1,sym_power
	    call trans(usym,sym_mat,ures,4)
c
c------	----Add origin 
c
	    do j=1,3
	      werte(j+1) = ures(j) + sym_orig(j)
	    enddo
c
c------	----Insert copy of atom or replace original atom by its image
c
	    if(sym_mode) then
	      name     = cr_at_lis(cr_iscat(i))
	      werte(5) = cr_dw(cr_iscat(i))
	      call do_ins_atom(name,werte,5)
	      if(ier_num.ne.0) then
	        return
	      endif
	    else
	      do j=1,3
	        cr_pos(j,i) = werte(j+1)
	      enddo
	    endif
	    do j=1,3
	      usym(j) = ures(j)
	    enddo
	    enddo
	  endif
	enddo
c
	end
c*****7*****************************************************************
	subroutine symm_op_single
c-
c	Performs the actual symmetry operation, single result version
c+
	implicit     none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'atom_env.inc'
	include      'errlist.inc'
	include      'microdis.inc'
	include      'microsta.inc'
	include      'symm.inc'
c
	character*4  name
	integer      i,j,l
	integer      i_start,i_end
	real         usym(4),ures(4)
	real         werte(5)
c
	data usym    /0.0,0.0,0.0,1.0/
	data werte   /0.0,0.0,0.0,0.0,0.0/
c
c------	Set the appropriate starting end ending number for the atoms
c
	i_start = sym_start
	i_end   = sym_end
	if(sym_incl.eq.'all ') then
	  i_end = cr_natoms
	elseif(sym_incl.eq.'env ') then
	  i_end = atom_env(0)
	endif
c
c------	Apply symmetry operation to all atoms within selected range
c
	do l=i_start,i_end
	  i=l
	  if(sym_incl.eq.'env ') i=atom_env(l)
c
c------	--Select atom if:
c	  type has been selected and
c	       all atoms are selected                            or
c	       all microdomains have been selected               or
c	       a specific microdomain type has been selected     or
c	       microdomains are deselected and atom is outside
c
	  if(sym_latom(cr_iscat(i)) .and. 
     &	     ( sym_md_s.eq.MD_S_EVE                               .or.
     &	       sym_md_s.eq.MD_S_ALL .and. cr_md_next(i).lt.0      .or.
     &	       sym_md_s.eq.MD_S_IND .and. cr_md_next(i).lt.0 .and.
     &                     mc_type(-cr_md_next(i)).eq.sym_md_nr   .or.
     &	       sym_md_s.eq.MD_S_NON .and. sym_md_nr.eq.0      .and.
     &	                            cr_md_next(i).ge.0      )  ) then
c
c------	----Subtract origin 
c
	    do j=1,3
	      usym(j) = cr_pos(j,i) - sym_orig(j)
	    enddo
c
c-----	----Apply symmetry operation
c
	    usym(4)=1.0
	    call trans(usym,sym_mat,ures,4)
c
c------	----Add origin 
c
	    do j=1,3
	      werte(j+1) = ures(j) + sym_orig(j)
	    enddo
c
c------	----Insert copy of atom or replace original atom by its image
c
	    if(sym_mode) then
	      name     = cr_at_lis(cr_iscat(i))
	      werte(5) = cr_dw(cr_iscat(i))
	      call do_ins_atom(name,werte,5)
	      if(ier_num.ne.0) then
	        return
	      endif
	    else
	      do j=1,3
	        cr_pos(j,i) = werte(j+1)
	      enddo
	    endif
	  endif
	enddo
c
	end
c*****7*****************************************************************
	subroutine symm_mole_mult
c-
c	Performs the actual symmetry operation, multiple copy version
c	Operates on molecules
c+
	implicit     none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'errlist.inc'
	include      'microdis.inc'
	include      'symm.inc'
	include      'microsta.inc'
	include      'molecule.inc'
c
	character*4  name
c
	integer      i,j,k,l,ii
	integer      i_start,i_end
	integer      imole,imole_s,imole_t
c
	real         usym(4),ures(4),use_orig(3)
	real         werte(5)
c
	data usym    /0.0,0.0,0.0,1.0/
	data werte   /0.0,0.0,0.0,0.0,0.0/
c
c------	Set the appropriate starting end ending number for the atoms
c
	i_start = sym_start
	i_end   = sym_end
	if(sym_end.eq.-1) i_end = cr_natoms
	imole_s = mole_num_mole
c
	if (sym_new) then
	  imole_t = mole_num_type
	  if(mole_num_type.lt.MOLE_MAX_TYPE) then
	    mole_num_type = mole_num_type + sym_power
	  else
	    ier_num = -66
	    ier_typ = ER_APPL
	    return
	  endif
	endif
c
c------	Apply symmetry operation to all molecules within selected range
c
	do l=i_start,i_end
c
c------ - Determine origin for symmetry operation
c
	  if (sym_orig_mol) then
	    do i=1,3
	      ii = mole_cont(mole_off(l)+1)
	      use_orig(i) = sym_orig(i) + cr_pos(i,ii)
	    enddo
	  else
	    do i=1,3
	      use_orig(i) = sym_orig(i)
	    enddo
	  endif
c
c------	--Select atom if:
c	  type has been selected and
c	       all atoms are selected                            or
c	       all microdomains have been selected               or
c	       a specific microdomain type has been selected     or
c	       microdomains are deselected and atom is outside
c
	  if(sym_latom(mole_type(l)) .and. 
     &	     ( sym_md_s.eq.MD_S_EVE                               .or.
     &	       sym_md_s.eq.MD_S_ALL .and.
     &	       cr_md_next(mole_cont(mole_off(l)+1)).lt.0      .or.
     &	       sym_md_s.eq.MD_S_IND .and.
     &	       cr_md_next(mole_cont(mole_off(l)+1)).lt.0 .and.
     &         mc_type(-cr_md_next(mole_cont(mole_off(l)+1)))
     &	       .eq.sym_md_nr   .or.
     &	       sym_md_s.eq.MD_S_NON .and. sym_md_nr.eq.0      .and.
     &	       cr_md_next(mole_cont(mole_off(l)+1)).ge.0      )  ) then
c
c------	----Loop over all atoms in the molecule
c
	    do ii=1,mole_len(l)
	      i = mole_cont(mole_off(l)+ii)
c
c------	----- Subtract origin 
c
	      do j=1,3
	        usym(j) = cr_pos(j,i) - use_orig(j)
	      enddo
c
c-----	----- Apply symmetry operation
c
	      usym(4)=1.0
	      do k=1,sym_power
	        call trans(usym,sym_mat,ures,4)
c
c------	------- Add origin 
c
	        do j=1,3
	          werte(j+1) = ures(j) + use_orig(j)
	        enddo
c
c------	------- Insert copy of atom or replace original atom by its image
c
	        if(sym_mode) then
	          name     = cr_at_lis(cr_iscat(i))
	          werte(5) = cr_dw(cr_iscat(i))
	          call do_ins_atom(name,werte,5)
	          if(ier_num.ne.0) then
	            return
	          endif
c
c------	--------- Insert atom into proper new molecule
c
	          imole = imole_s + (l - i_start)*sym_power + (k-1) + 1
	          call mole_insert_current(cr_natoms,imole)
	          if(ier_num.ne.0) then
	            return
	          endif
	        else
	          do j=1,3
	            cr_pos(j,i) = werte(j+1)
	          enddo
	        endif
	        do j=1,3
	          usym(j) = ures(j)
	        enddo
	      enddo
	    enddo
c
c----- ---- Set new molecule type if requested
c
	    if (sym_new) then
	      do k=1,sym_power
	        if (sym_mode) then
	          mole_type(mole_num_mole-sym_power+k) = imole_t+k
	        else
	          mole_type(l) = imole_t+1
	        endif
	      enddo
	    endif 
	  endif
	enddo
c
	end
c*****7*****************************************************************
	subroutine symm_mole_single
c-
c	Performs the actual symmetry operation, single result version
c	Operates on molecules
c+
	implicit     none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'errlist.inc'
	include      'microdis.inc'
	include      'microsta.inc'
	include      'molecule.inc'
	include      'symm.inc'
c
	character*4  name
	integer      i,j,ii,l
	integer      i_start,i_end
	integer      imole,imole_s,imole_t
	real         usym(4),ures(4)
	real         werte(5),use_orig(3)
c
	data usym    /0.0,0.0,0.0,1.0/
	data werte   /0.0,0.0,0.0,0.0,0.0/
c
c------	Set the appropriate starting end ending number for the molecules
c
	i_start = sym_start
	i_end   = sym_end
	if(sym_end.eq.-1) i_end = cr_natoms
	imole_s = mole_num_mole
c
	if (sym_new) then
	  if(mole_num_type.lt.MOLE_MAX_TYPE) then
	    mole_num_type = mole_num_type + 1
	  else
	    ier_num = -66
	    ier_typ = ER_APPL
	    return
	  endif
	  imole_t = mole_num_type
	endif
c
c------	Apply symmetry operation to all molecules within selected range
c
	do l=i_start,i_end
c
c------ - Determine origin for symmetry operation
c
	  if (sym_orig_mol) then
	    do i=1,3
	      ii = mole_cont(mole_off(l)+1)
	      use_orig(i) = sym_orig(i) + cr_pos(i,ii)
	    enddo
	  else
	    do i=1,3
	      use_orig(i) = sym_orig(i)
	    enddo
	  endif
c
c------	--Select atom if:
c	  type has been selected and
c	       all atoms are selected                            or
c	       all microdomains have been selected               or
c	       a specific microdomain type has been selected     or
c	       microdomains are deselected and atom is outside
c
	  if(sym_latom(mole_type(l)) .and. 
     &	     ( sym_md_s.eq.MD_S_EVE                               .or.
     &	       sym_md_s.eq.MD_S_ALL .and.
     &	       cr_md_next(mole_cont(mole_off(l)+1)).lt.0      .or.
     &	       sym_md_s.eq.MD_S_IND .and.
     &	       cr_md_next(mole_cont(mole_off(l)+1)).lt.0 .and.
     &         mc_type(-cr_md_next(mole_cont(mole_off(l)+1)))
     &	       .eq.sym_md_nr   .or.
     &	       sym_md_s.eq.MD_S_NON .and. sym_md_nr.eq.0      .and.
     &	       cr_md_next(mole_cont(mole_off(l)+1)).ge.0      )  ) then
c
c------	----Loop over all atoms in the molecule
c
	    do ii=1,mole_len(l)
	      i = mole_cont(mole_off(l)+ii)
c
c------	----- Subtract origin 
c
	      do j=1,3
	        usym(j) = cr_pos(j,i) - use_orig(j)
	      enddo
c
c-----	----- Apply symmetry operation
c
	      usym(4)=1.0
	      call trans(usym,sym_mat,ures,4)
c
c------	----- Add origin 
c
	      do j=1,3
	        werte(j+1) = ures(j) + use_orig(j)
	      enddo
c
c------	----- Insert copy of atom or replace original atom by its image
c
	      if(sym_mode) then
	        name     = cr_at_lis(cr_iscat(i))
	        werte(5) = cr_dw(cr_iscat(i))
	        call do_ins_atom(name,werte,5)
	        if(ier_num.ne.0) then
	          return
	        endif
c
c------	------- Insert atom into proper new molecule
c
	        imole = imole_s + l -i_start + 1
	        call mole_insert_current(cr_natoms,imole)
	        if(ier_num.ne.0) then
	          return
	        endif
	      else
	        do j=1,3
	          cr_pos(j,i) = werte(j+1)
	        enddo
	      endif
	    enddo
c
c----- ---- Set new molecule type if requested
c
	    if (sym_new) then
	      if (sym_mode) then
	        mole_type(mole_num_mole) = imole_t
	      else
	        mole_type(l) = imole_t
	      endif
	    endif 
	  endif
	enddo
c
	end
c*****7*****************************************************************
	subroutine symm_ca_mult(uvw,lspace)
c-
c	Performs the actual symmetry operation, multiple copy version
c	Only the input vector uvw is used in direct or reciprocal space
c+
	implicit     none
c
	include      'config.inc'
	include      'prompt.inc'
	include      'errlist.inc'
	include      'param.inc'
	include      'symm.inc'
c
	integer      j,k
	logical      lspace
c
	real         uvw(3)
	real         usym(4),ures(4)
	real         werte(5)
c
	data usym    /0.0,0.0,0.0,1.0/
	data werte   /0.0,0.0,0.0,0.0,0.0/
c
c------	real space part
c
	if(lspace) then
c
c------	----Subtract origin, if in real space 
c
	  do j=1,3
	    usym(j) = uvw(j) - sym_orig(j)
	  enddo
c
c-----	--Apply symmetry operation
c
	  usym(4)=1.0
	  do k=1,sym_power
	    call trans(usym,sym_mat,ures,4)
c
c------	----Add origin and store result
c
	    do j=1,3
	      res_para((k-1)*3+j) = ures(j) + sym_orig(j)
	    enddo
	    write (output_io,3000) (res_para((k-1)*3+j),j=1,3)
c
c------	----Replace current vector by its image
c
	    do j=1,3
	      usym(j) = ures(j)
	    enddo
	  enddo
	else
c
c------	----Reciprocal space part 
c
	  do j=1,3
	    usym(j) = uvw(j)
	  enddo
c
c-----	--Apply symmetry operation
c
	  usym(4)=0.0
	  do k=1,sym_power
	    call trans(usym,sym_rmat,ures,4)
c
c------	----Store result
c
	    do j=1,3
	      res_para((k-1)*3+j) = ures(j)
	    enddo
	    write (output_io,3000) (res_para((k-1)*3+j),j=1,3)
c
c------	----Replace current vector by its image
c
	    do j=1,3
	      usym(j) = ures(j)
	    enddo
	  enddo
	endif
c
	res_para(0) = sym_power*3
c
3000	format(' Result    : ',3(2x,f9.4))
	end
c*****7*****************************************************************
	subroutine symm_ca_single(uvw,lspace)
c-
c	Performs the actual symmetry operation, multiple copy version
c	Only the input vector uvw is used in direct or reciprocal space
c+
	implicit     none
c
	include      'config.inc'
	include      'prompt.inc'
	include      'errlist.inc'
	include      'param.inc'
	include      'symm.inc'
c
	integer      j
	logical      lspace
c
	real         uvw(3)
	real         usym(4),ures(4)
	real         werte(5)
c
	data usym    /0.0,0.0,0.0,1.0/
	data werte   /0.0,0.0,0.0,0.0,0.0/
c
c------	real space part
c
	if(lspace) then
c
c------	----Subtract origin, if in real space 
c
	  do j=1,3
	    usym(j) = uvw(j) - sym_orig(j)
	  enddo
c
c-----	--Apply symmetry operation
c
	  usym(4)=1.0
	    call trans(usym,sym_mat,ures,4)
c
c------	----Add origin and store result
c
	    do j=1,3
	      res_para(j) = ures(j) + sym_orig(j)
	    enddo
c
c------	----Replace current vector by its image
c
	    do j=1,3
	      usym(j) = ures(j)
	    enddo
	else
c
c------	----Subtract origin, if in real space 
c
	  do j=1,3
	    usym(j) = uvw(j)
	  enddo
c
c-----	--Apply symmetry operation
c
	  usym(4) = 0.0
	    call trans(usym,sym_rmat,ures,4)
c
c------	----Add origin and store result
c
	    do j=1,3
	      res_para(j) = ures(j)
	    enddo
c
c------	----Replace current vector by its image
c
	    do j=1,3
	      usym(j) = ures(j)
	    enddo
	endif
c
	res_para(0) = 3
	write (output_io,3000) (res_para(j),j=1,3)
c
3000	format(' Result    : ',3(2x,f9.4))
	end
