c*****7*****************************************************************
	subroutine trafo(hkl,u,xc,yc,zc,gmat,fmat,dist,eps,
     &	                 gten,reps,rten)
c+
c	Calculates the transformation matrix : crystal <> plotsection
c	from lattice comstant and hkl of viewing vector. Also 
c	calculates the distance of the plotting section from the origin
c	of the crystal.
c-
	implicit	none
c
	integer		inull2(2),i,j,k,l,m,inull
	real 		eps(3,3,3),fmat(3,3),gmat(3,3),gten(3,3)
	real 		rten(3,3),u(3),xc(3),yc(3),zc(3),dist
	real  		reps(3,3,3),hkl(3),zcc,xcc,quad
c
c------	Determine achses for transformation
c------	Transform reciprocal vector HKL to real space vector ZC
c
	do i=1,3
	  zc(i)=0.0
	  do j=1,3
	    zc(i)=zc(i)+rten(i,j)*hkl(j)
	  enddo
	enddo
c
	zcc=sqrt(quad(zc,zc,gten))
	if(zcc.eq.0.0) return
	inull=0
	inull2(1)=0
	inull2(2)=0
	do i=1,3
	  zc(i)=zc(i)/zcc
	  if(hkl(i).eq.0.0) then
	    inull=inull+1
	    inull2(inull)=i
	  endif
	  xc(i)=0.0
	  yc(i)=0.0
	enddo
c
c------	Determine a direction as fundamental as possible for XC
c
	if(inull.eq.2  .or.  inull.eq.1) then
	  xc(inull2(1))=1.0
	else
	  if(hkl(1).eq.hkl(2)) then
	    xc(1)= hkl(1)
	    xc(2)=-hkl(2)
	  else if(hkl(1).eq.hkl(3)) then
	    xc(1)= hkl(1)
	    xc(3)=-hkl(3)
	  else if(hkl(2).eq.hkl(3)) then
	    xc(2)= hkl(2)
	    xc(3)=-hkl(3)
	  else
	    xc(1)= hkl(2)
	    xc(2)=-hkl(1)
	  endif
	endif
	xcc=sqrt(quad(xc,xc,gten))
c
c------	normalize XC
c
	do i=1,3
	  xc(i)=xc(i)/xcc
	enddo
c
c------ calculate yc as the vector product of zc and xc
c
	do m=1,3
	  yc(m)=0.0
	  do j=1,3
	    do k=1,3
	      do l=1,3
	        yc(m)=yc(m) + eps(j,k,l)*zc(k)*xc(l)*rten(j,m)
	      enddo
	    enddo
	  enddo
	enddo
c
c------	calculate indices of gmat
c
	do i=1,3
	  gmat(i,1)=xc(i)
	  gmat(i,2)=yc(i)
	  gmat(i,3)=zc(i)
	enddo
c
c------	calculate distance to origin
c
	call invmat(fmat,gmat)
	dist=fmat(3,1)*u(1) + fmat(3,2)*u(2) + fmat(3,3)*u(3) 
c
	end
C*****7*****************************************************************
	subroutine trans(uc,gmat,up,idim)
c+
c	Transforms a point in the crystal space into plot space 
c	and vice versa
c-
	implicit	none
c
	integer	 i,j,idim
	real gmat(idim,idim),uc(idim),up(idim)
c
	do i=1,idim
	  up(i)=0.0
	  do j=1,idim
	    up(i)=up(i)+gmat(i,j)*uc(j)
	  enddo
	enddo
c
	end
C*****7*****************************************************************
