c+
c	Generalized unit cell transformation operations:
c	The user provides the transformation matrix between new and
c	old coordinate system and the program transforms the old
c	atom coordinates into the new ones.
c	Individual direct and reciprocal space transformation can be
c	calculated as well.
c
c	Version : 3.0
c	Date    : 25 Jun 97
c
c	Author  : R.B. Neder  (reinhard.neder@mail.uni-wuerzburg.de)
c
C*****7*****************************************************************
	subroutine transform
c-
c	Main menu for generalized transformation operations
c+
	implicit      none
c
	include       'config.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'doact.inc'
	include       'errlist.inc'
	include       'learn.inc'
	include       'macro.inc'
	include       'prompt.inc'
	include       'transfrm.inc'
c
	integer        maxw
	parameter     (maxw=MAXSCAT)
	logical        lnew,lold
	parameter     (lnew=.true.,lold=.false.)
c
	character*5    befehl
	character*11   prom
	character*200  line,zeile,cpara(maxw)
	character*200  tran_hfile
	integer        lpara(maxw),lp,length,lbef
	integer        tran_hlen
	integer        indxg,ianz,i,j
	logical        lend,lchange,lscreen
	real           hkl(4)
	real           werte(maxw)
c
	logical        str_comp
c
	include 'microsta.inc'
c
	data lchange /.true./
	data lscreen /.true./
c
	lend=.false.
	call no_error
c
	do while (.not. lend)
	  prom=prompt//'/tran'
	  call get_command (line,length,befehl,lbef,zeile,lp,prom)
	  if(ier_num.eq.0) then
	  if(line.ne.' ' .and. line(1:1).ne.'#') then
c
c------	----search for "="
c
	    indxg=index(line,'=')
	    if(indxg.ne.0 
     &	              .and. .not.(str_comp(befehl,'echo',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'syst',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'help',2,lbef,4) .or.
     &	                          str_comp(befehl,'?   ',2,lbef,4)) )then
c
c------	------evaluatean expression and assign the value to a variabble
c
	      call do_math(line,indxg,length)
	    else
c
c------ ----execute a macro file
c
            if(befehl(1:1).eq.'@') then
	      if(length.ge.2) then
	        call file_kdo(line(2:length),length-1)
	      else
	        ier_num = -13
	        ier_typ = ER_MAC
	      endif
c
c------	----a(new) in terms of old axes
c
	    elseif(str_comp(befehl,'anew',2,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do j=1,3
	            tran_g (1,j) = werte(j)
	          enddo
	          tran_inp =TRAN_INP_G
	          lchange  = .true.
	        endif
	      endif
c
c------	----a(old) in terms of new axes
c
	    elseif(str_comp(befehl,'aold',2,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do j=1,3
	            tran_gi(1,j) = werte(j)
	          enddo
	          tran_inp =TRAN_INP_GI
	          lchange  = .true.
	        endif
	      endif
c
c------	----list asymmetric unit 'asym'
c
	    elseif(str_comp(befehl,'asym',2,lbef,4)) then
	      call show_asym
c
c------	----b(new) in terms of old axes
c
	    elseif(str_comp(befehl,'bnew',2,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do j=1,3
	            tran_g (2,j) = werte(j)
	          enddo
	          tran_inp =TRAN_INP_G
	          lchange  = .true.
	        endif
	      endif
c
c------	----b(old) in terms of new axes
c
	    elseif(str_comp(befehl,'bold',2,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do j=1,3
	            tran_gi(2,j) = werte(j)
	          enddo
	          tran_inp =TRAN_INP_GI
	          lchange  = .true.
	        endif
	      endif
c
c------	----calculate a single transformation operation 'c2new'
c
	    elseif(str_comp(befehl,'c2new',2,lbef,5)) then
	      if(lchange) then
	        call tran_setup
	      endif
	      lchange = .false.
	      ier_num = -6
	      ier_typ = ER_COMM
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.3) then
		  cpara(4) = 'd'
		  lpara(4) = 1
		endif
		ianz = 3
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            hkl(i) = werte(i)
	          enddo
	          if(str_comp(cpara(4),'d',1,lpara(4),1)) then
	            hkl(4) = 1.0
	            call tran_ca(hkl,tran_f ,lscreen)
	          elseif(str_comp(cpara(4),'r',1,lpara(4),1)) then
	            hkl(4) = 0.0
	            call tran_ca(hkl,tran_g ,lscreen)
		  else
	            ier_num = -6
	            ier_typ = ER_COMM
		  endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----calculate a single transformation operation 'c2old'
c
	    elseif(str_comp(befehl,'c2old',2,lbef,5)) then
	      if(lchange) then
	        call tran_setup
	      endif
	      lchange = .false.
	      ier_num = -6
	      ier_typ = ER_COMM
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.3) then
		  cpara(4) = 'd'
		  lpara(4) = 1
		endif
		ianz = 3
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            hkl(i) = werte(i)
	          enddo
	          if(str_comp(cpara(4),'d',1,lpara(4),1)) then
	            hkl(4) = 1.0
	            call tran_ca(hkl,tran_fi,lscreen)
	          elseif(str_comp(cpara(4),'r',1,lpara(4),1)) then
	            hkl(4) = 0.0
	            call tran_ca(hkl,tran_gi,lscreen)
		  else
	            ier_num = -6
	            ier_typ = ER_COMM
		  endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----c(new) in terms of old axes
c
	    elseif(str_comp(befehl,'cnew',2,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do j=1,3
	            tran_g (3,j) = werte(j)
	          enddo
	          tran_inp =TRAN_INP_G
	          lchange  = .true.
	        endif
	      endif
c
c------	----c(old) in terms of new axes
c
	    elseif(str_comp(befehl,'cold',2,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do j=1,3
	            tran_gi(3,j) = werte(j)
	          enddo
	          tran_inp =TRAN_INP_GI
	          lchange  = .true.
	        endif
	      endif
c
c------	----continues a macro 'continue'
c
	    elseif(str_comp(befehl,'continue',2,lbef,8)) then
	      call macro_continue(zeile,lp)
c
c------	----list atoms present in the crystal 'chem'
c
	    elseif(str_comp(befehl,'chem',2,lbef,4)) then
	      call show_chem
c
c------	----Deselect which atoms are included in the wave 'dese'
c
	    elseif(str_comp(befehl,'dese',1,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 ) then
	        if(cpara(1)(1:3).eq.'mic') then
	          tran_md_s  = MD_S_EVE
	          tran_md_nr = 0
	        else
	          call get_iscat(ianz,cpara,lpara,werte,maxw,lold)
	          if(ier_num.eq.0) then
	            if(werte(1).eq.-1) then
	              do i=0,cr_nscat
	                tran_latom(i) = .false.
	              enddo
	            else
	              do i=1,ianz
	                tran_latom(nint(werte(i))) = .false.
	              enddo
	            endif
	          endif
	        endif
	      endif
c
c------ ----Echo a string, just for interactive check in a macro 'echo'
c
	    elseif(str_comp(befehl,'echo',2,lbef,4)) then
	      call echo(zeile,lp)
c
c------	 ---Evaluate an expression, just for interactive check 'eval'
c
	    elseif(str_comp(befehl,'eval',2,lbef,4)) then
	      call do_eval(zeile,lp)
c
c------	----exit 'exit'
c
	    elseif(str_comp(befehl,'exit',2,lbef,4)) then
	      lend=.true.
c
c------	----help 'help','?'
c
	    elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	           str_comp(befehl,'?   ',1,lbef,4)     ) then
	      if(str_comp(zeile,'errors',2,lp,6) ) then
	        lp = lp + 7
	        call do_hel('discus '//zeile,lp)
	      else
	        lp = lp + 12
	        call do_hel('discus tran '//zeile,lp)
	      endif
c
c------	----transforme a list of reflections to new base 'h2new'
c
	    elseif(str_comp(befehl,'h2new',2,lbef,5)) then
	      if(lchange) then
	        call tran_setup
	      endif
	      lchange = .false.
	      ier_num = -6
	      ier_typ = ER_COMM
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.ge.1) then
	          call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	          if(ier_num.eq.0) then
	            tran_hfile = cpara(1)
	            tran_hlen  = lpara(1)
	            call tran_hkl(tran_hfile,tran_hlen,tran_g )
		  endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----transforme a list of reflections to old base 'h2old'
c
	    elseif(str_comp(befehl,'h2old',2,lbef,5)) then
	      if(lchange) then
	        call tran_setup
	      endif
	      lchange = .false.
	      ier_num = -6
	      ier_typ = ER_COMM
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.1) then
	          call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	          if(ier_num.eq.0) then
	            tran_hfile = cpara(1)
	            tran_hlen  = lpara(1)
	            call tran_hkl(tran_hfile,tran_hlen,tran_gi)
		  endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Select range of atoms within crystal to be included 'incl'
c
	    elseif(str_comp(befehl,'incl',1,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.2) then
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            tran_start = nint(werte(1))
	            tran_end   = nint(werte(2))
	          endif
	        elseif(ianz.eq.1) then
	          if(str_comp(cpara(1),'all',1,lpara(1),3)) then
	            tran_start =  1
	            tran_end   = -1
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----Select the location of the new origin in old coordinates 'onew'
c
	    elseif(str_comp(befehl,'onew',2,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.3) then
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
		    tran_oold = .true.
	            do i=1,3
	              tran_orig(i) = werte(i)
	            enddo
	            lchange  = .true.
		  endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Select the location of the old origin in new coordinates 'oold'
c
	    elseif(str_comp(befehl,'oold',2,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.3) then
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
		    tran_oold = .false.
	            do i=1,3
	              tran_orig(i) = werte(i)
	            enddo
	            lchange  = .true.
		  endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----run transformation 'run'
c
	    elseif(str_comp(befehl,'run ',1,lbef,4)) then
	      if(lchange) then
	        call tran_setup
	      endif
	      lchange = .false.
	      call tran_op
c
c------	----Select which atoms are copied to their image 'sele'
c
	    elseif(str_comp(befehl,'sele',3,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(cpara(1)(1:3).eq.'mic' .and. ianz.eq.2) then
	          if(cpara(2)(1:3).eq.'all') then
	            tran_md_s  = MD_S_ALL
	            tran_md_nr = 0
	          elseif(cpara(2)(1:3).eq.'non') then
	            tran_md_s  = MD_S_NON
	            tran_md_nr = 0
	          elseif(cpara(2)(1:3).eq.'eve') then
	            tran_md_s  = MD_S_EVE
	            tran_md_nr = 0
	          else
	            cpara(1) = '0.0'
	            lpara(1) = 3
	            call ber_params(ianz,cpara,lpara,werte,maxw)
	            tran_md_nr = nint(werte(2))
	            tran_md_s  = MD_S_IND
	          endif
	        else
	          call get_iscat(ianz,cpara,lpara,werte,maxw,lold)
	          if(ier_num.eq.0) then
	            if(werte(1).eq.-1) then
	              do i=0,cr_nscat
	                tran_latom(i) = .true.
	              enddo
	            else
	              do i=1,ianz
	                tran_latom(nint(werte(i))) = .true.
	              enddo
	            endif
	          endif
	        endif
	      endif
c
c------	----Set parameters for various commands 'set'
c
	    elseif(str_comp(befehl,'set',3,lbef,3)) then
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.gt.0) then
	          if(str_comp(cpara(1),'deltahkl',1,lbef,8)) then
	            cpara(1) = '0.0'
	            lpara(1) = 3
	            call ber_params(ianz,cpara,lpara,werte,maxw)
	            if(ier_num.eq.0) then
	              tran_deltahkl = werte(2)
	            endif
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----show current parameters 'show'
c
	    elseif(str_comp(befehl,'show',2,lbef,4)) then
	      if(lchange) then
	        call tran_setup
	      endif
	      lchange = .false.
	      write (output_io,3000)
	      write (output_io,3010) ((tran_g (i,j),j=1,3),i=1,3)
	      write (output_io,3020) ((tran_gi(i,j),j=1,3),i=1,3)
	      write (output_io,3030) ((tran_f (i,j),j=1,4),i=1,3)
	      write (output_io,3040) ((tran_fi(i,j),j=1,4),i=1,3)
	      write (output_io,3050) ((tran_f (i,j),j=1,3),i=1,3)
	      write (output_io,3060) ((tran_fi(i,j),j=1,3),i=1,3)
	      write (output_io,3061) ((tran_g (i,j),j=1,3),i=1,3)
	      write (output_io,3062) ((tran_gi(i,j),j=1,3),i=1,3)
c
	      if(tran_det.ne.0) then
	        write (output_io,3100) tran_det,1./tran_det
	      else
	        write (output_io,3200)
	      endif
c
	      write (output_io,3070) cmic_s(tran_md_s)
	      if(tran_md_s.eq.MD_S_IND) then
	        write (output_io,3075) tran_md_nr
	      endif
	      write (output_io,3090)
	      write (output_io,3091)
	      do i=0,cr_nscat
	        if(tran_latom(i)) then
	          write (output_io,3092) i,cr_at_lis(i)
	        endif
	      enddo
	      if(tran_end.eq.-1) then
	        write (output_io,3080) 
	      else
	        write (output_io,3081) tran_start,tran_end
	      endif
c
c------- -Operating System Kommandos 'syst'
c
	  elseif(str_comp(befehl,'syst',2,lbef,4)) then
	    if(zeile.ne. ' ') then
	      call do_operating(zeile(1:lp),lp)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------  -----waiting for user input
c
	    elseif(str_comp(befehl,'wait',3,lbef,4)) then
	      call do_input(zeile,lp)
c
c------	----x(new) in terms of old axes
c
	    elseif(str_comp(befehl,'xnew',2,lbef,4) .or. 
     &	           str_comp(befehl,'asnew',3,lbef,5)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do j=1,3
	            tran_f (1,j) = werte(j)
	          enddo
	          tran_inp =TRAN_INP_F
	          lchange  = .true.
	        endif
	      endif
c
c------	----x(old) in terms of new axes
c
	    elseif(str_comp(befehl,'xold',2,lbef,4) .or. 
     &	           str_comp(befehl,'asold',3,lbef,5)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do j=1,3
	            tran_fi(1,j) = werte(j)
	          enddo
	          tran_inp =TRAN_INP_FI
	          lchange  = .true.
	        endif
	      endif
c
c------	----y(new) in terms of old axes
c
	    elseif(str_comp(befehl,'ynew',2,lbef,4) .or. 
     &	           str_comp(befehl,'bsnew',3,lbef,5)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do j=1,3
	            tran_f (2,j) = werte(j)
	          enddo
	          tran_inp =TRAN_INP_F
	          lchange  = .true.
	        endif
	      endif
c
c------	----y(old) in terms of new axes
c
	    elseif(str_comp(befehl,'yold',2,lbef,4) .or. 
     &	           str_comp(befehl,'bsold',3,lbef,5)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do j=1,3
	            tran_fi(2,j) = werte(j)
	          enddo
	          tran_inp =TRAN_INP_FI
	          lchange  = .true.
	        endif
	      endif
c
c------	----z(new) in terms of old axes
c
	    elseif(str_comp(befehl,'znew',2,lbef,4) .or. 
     &	           str_comp(befehl,'csnew',3,lbef,5)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do j=1,3
	            tran_f (3,j) = werte(j)
	          enddo
	          tran_inp =TRAN_INP_F
	          lchange  = .true.
	        endif
	      endif
c
c------	----z(old) in terms of new axes
c
	    elseif(str_comp(befehl,'zold',2,lbef,4) .or. 
     &	           str_comp(befehl,'csold',3,lbef,5)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do j=1,3
	            tran_fi(3,j) = werte(j)
	          enddo
	          tran_inp =TRAN_INP_FI
	          lchange  = .true.
	        endif
	      endif
	    else
	      ier_num = -8
	      ier_typ = ER_COMM
	    endif
	    endif
	  endif
	  endif
	  if(ier_num.ne.0) then
	    call errlist
	    if(lmakro) then
	      call macro_close
	      prompt_status = PROMPT_ON
	    endif
	    if(lblock) then
	      ier_num = -11
	      ier_typ = ER_COMM
	      return
	    endif
	    call no_error
	  endif
	enddo
c
9999	continue
c
3000	format(20x,'    Unit cell transformations '/
     &	       20x,' ==============================='//)
3010	format(
     &	' ( a(new) ) = ( ',2(F9.5,','),f9.5,' )   ( a(old) )'/
     &	' ( b(new) ) = ( ',2(F9.5,','),f9.5,' ) * ( b(old) )'/
     &	' ( c(new) ) = ( ',2(F9.5,','),f9.5,' )   ( c(old) )'/)
3020	format(
     &	' ( a(old) ) = ( ',2(F9.5,','),f9.5,' )   ( a(new) )'/
     &	' ( b(old) ) = ( ',2(F9.5,','),f9.5,' ) * ( b(new) )'/
     &	' ( c(old) ) = ( ',2(F9.5,','),f9.5,' )   ( c(new) )'/)
3030	format(
     &	' ( x(new) ) = ( ',2(F9.5,','),f9.5,' )   ( x(old) )',
     &	'   (',f9.5,')'/
     &	' ( y(new) ) = ( ',2(F9.5,','),f9.5,' ) * ( y(old) )',
     &	' + (',f9.5,')'/
     &	' ( z(new) ) = ( ',2(F9.5,','),f9.5,' )   ( z(old) )',
     &	'   (',f9.5,')'/)
3040	format(
     &	' ( x(old) ) = ( ',2(F9.5,','),f9.5,' )   ( x(new) )',
     &	'   (',f9.5,')'/
     &	' ( y(old) ) = ( ',2(F9.5,','),f9.5,' ) * ( y(new) )',
     &	' + (',f9.5,')'/
     &	' ( z(old) ) = ( ',2(F9.5,','),f9.5,' )   ( z(new) )',
     &	'   (',f9.5,')'/)
3050	format(
     &	' ( a*(new)) = ( ',2(F9.5,','),f9.5,' )   ( a*(old))'/
     &	' ( b*(new)) = ( ',2(F9.5,','),f9.5,' ) * ( b*(old))'/
     &	' ( c*(new)) = ( ',2(F9.5,','),f9.5,' )   ( c*(old))'/)
3060	format(
     &	' ( a*(old)) = ( ',2(F9.5,','),f9.5,' )   ( a*(new))'/
     &	' ( b*(old)) = ( ',2(F9.5,','),f9.5,' ) * ( b*(new))'/
     &	' ( c*(old)) = ( ',2(F9.5,','),f9.5,' )   ( c*(new))'/)
3061	format(
     &	' ( h(new) ) = ( ',2(F9.5,','),f9.5,' )   ( h(old) )'/
     &	' ( k(new) ) = ( ',2(F9.5,','),f9.5,' ) * ( k(old) )'/
     &	' ( l(new) ) = ( ',2(F9.5,','),f9.5,' )   ( l(old) )'/)
3062	format(
     &	' ( h(old) ) = ( ',2(F9.5,','),f9.5,' )   ( h(new) )'/
     &	' ( k(old) ) = ( ',2(F9.5,','),f9.5,' ) * ( k(new) )'/
     &	' ( l(old) ) = ( ',2(F9.5,','),f9.5,' )   ( l(new) )'/)
3100	format(
     &	'   V(new)   = ',F9.5,' * V(old)'/
     &	'   V(old)   = ',F9.5,' * V(new)'/)
3200	format(
     &	'   Determinant of transformation is zero'/)
3070	format(/' select status           : ',a)
3075	format(22x,i4)
3080	format(' Range of atoms from to    : All atoms included')
3081	format(' Range of atoms from to    : ',2(2x,i9))
3090	format(' selected atoms    :')
3091	format('                      type name')
3092	format(20x,2(4x,i2,1x,a4))
c
	end
c*****7*****************************************************************
	subroutine  tran_setup
c-
c	Performs the generalized symmetry operation
c	See Sands, D.E. Vectors and Tensors in Crystallography Chapt. 4.7
c+
	implicit     none
c
	include      'config.inc'
	include      'errlist.inc'
	include      'transfrm.inc'
c
	integer      i,j
	real         a(3,3)
c
c------	initialize fourth columns and rows
c
	do i=1,4
	  tran_g (i,4) = 0.0
	  tran_g (4,i) = 0.0
	  tran_gi(i,4) = 0.0
	  tran_gi(4,i) = 0.0
	  tran_f (i,4) = 0.0
	  tran_f (4,i) = 0.0
	  tran_fi(i,4) = 0.0
	  tran_fi(4,i) = 0.0
	enddo
	tran_f (4,4) = 1.0
	tran_fi(4,4) = 1.0
c
c------	Matrix g was defined
c
	if(tran_inp .eq. TRAN_INP_G) then
	  do i=1,4
	    do j=1,4
	      tran_gi(i,j) = tran_g (i,j)
	    enddo
	  enddo
	  call invmat4(tran_gi)
	  do i=1,3
	    do j=1,3
	      tran_f (j,i) = tran_gi(i,j)
	      tran_fi(j,i) = tran_g (i,j)
	    enddo
	  enddo
c
c------	Matrix gi was defined
c
	elseif(tran_inp .eq. TRAN_INP_GI) then
	  do i=1,4
	    do j=1,4
	      tran_g (i,j) = tran_gi(i,j)
	    enddo
	  enddo
	  call invmat4(tran_g )
	  do i=1,3
	    do j=1,3
	      tran_f (j,i) = tran_gi(i,j)
	      tran_fi(j,i) = tran_g (i,j)
	    enddo
	  enddo
c
c------	Matrix f was defined
c
	elseif(tran_inp .eq. TRAN_INP_F) then
	  do i=1,4
	    do j=1,4
	      tran_fi(i,j) = tran_f (i,j)
	    enddo
	  enddo
	  call invmat4(tran_fi)
	  do i=1,3
	    do j=1,3
	      tran_g (j,i) = tran_fi(i,j)
	      tran_gi(j,i) = tran_f (i,j)
	    enddo
	  enddo
c
c------	Matrix fi was defined
c
	elseif(tran_inp .eq. TRAN_INP_FI) then
	  do i=1,4
	    do j=1,4
	      tran_f (i,j) = tran_fi(i,j)
	    enddo
	  enddo
	  call invmat4(tran_f )
	  do i=1,3
	    do j=1,3
	      tran_g (j,i) = tran_fi(i,j)
	      tran_gi(j,i) = tran_f (i,j)
	    enddo
	  enddo
	endif
c
c------	Origin was defined in terms of the old coordinates
c
	if(tran_oold) then
	  j=4
	  do i=1,3
	    tran_fi(i,4) = tran_orig(i)
	  enddo
	  do i=1,3
	    do j=1,3
	      tran_f(i,4) = tran_f(i,4) - tran_f(i,j)*tran_fi(j,4)
	    enddo
	  enddo
	else
	  j=4
	  do i=1,3
	    tran_f (i,4) = tran_orig(i)
	  enddo
	  do i=1,3
	    do j=1,3
	      tran_fi(i,4) = tran_fi(i,4) - tran_fi(i,j)*tran_f(j,4)
	    enddo
	  enddo
	endif
c
	do i=1,3
	  do j=1,3
	    a(i,j) = tran_g(i,j)
	  enddo
	enddo
	tran_det = a(1,1)*(a(2,2)*a(3,3) - a(2,3)*a(3,2)) +
     &             a(2,1)*(a(3,2)*a(1,3) - a(1,2)*a(3,3)) +
     &             a(3,1)*(a(1,2)*a(2,3) - a(1,3)*a(2,2))
c
	end
c*****7*****************************************************************
	subroutine tran_op
c-
c	Performs the actual transformation operation.
c	All atoms of the structure, all symmetry elements are transformed
c	into the new cell.
c+
	implicit     none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'errlist.inc'
	include      'microdis.inc'
	include      'microsta.inc'
	include      'transfrm.inc'
c
	integer      i,j
	integer      i1,i2,i3
	integer      i_start,i_end
	logical      lspace
	logical      lout
	real         usym(4),ures(4)
	real         werte(5)
	real         u(3),v(3),w(3)
c
	real         do_bang
	real         skalpro
c
	data usym    /0.0,0.0,0.0,1.0/
	data werte   /0.0,0.0,0.0,0.0,0.0/
c
c------	Set the appropriate starting end ending number for the atoms
c
	i_start = tran_start
	i_end   = tran_end
	if(tran_end.eq.-1) i_end = cr_natoms
c
c------	Apply transformation operation to all atoms within selected range
c
	do i=i_start,i_end
c
c------	--Select atom if:
c	  type has been selected and
c	       all atoms are selected                            or
c	       all microdomains have been selected               or
c	       a specific microdomain type has been selected     or
c	       microdomains are deselected and atom is outside
c
	  if(tran_latom(cr_iscat(i)) .and. 
     &	     ( tran_md_s.eq.MD_S_EVE                               .or.
     &	       tran_md_s.eq.MD_S_ALL .and. cr_md_next(i).lt.0      .or.
     &	       tran_md_s.eq.MD_S_IND .and. cr_md_next(i).lt.0 .and.
     &                     mc_type(-cr_md_next(i)).eq.tran_md_nr   .or.
     &	       tran_md_s.eq.MD_S_NON .and. tran_md_nr.eq.0      .and.
     &	                            cr_md_next(i).ge.0      )  ) then
c
c------	----Copy atom to temporary place
c
	    do j=1,3
	      usym(j) = cr_pos(j,i)
	    enddo
c
c-----	----Apply symmetry operation
c
	    usym(4)=1.0
	    call trans(usym,tran_f ,ures,4)
c
c------	----Replace original atom by its image
c
	    do j=1,3
	      cr_pos(j,i) = ures(j)
	    enddo
	  endif
	enddo
c
c------	If all atoms of the crystal have been selected, calculate new 
c	lattice constants and symmetry operations
c
	if(i_start.eq.1 .and. i_end.eq.cr_natoms ) then
	  v(1)   = 0.0
	  v(2)   = 0.0
	  v(3)   = 0.0
	  lspace = .true.
	  do i=1,3
	    do j=1,3
	      usym(j) = tran_g (i,j)
	    enddo
	    cr_a0(i) = sqrt( skalpro(usym,usym,cr_gten))
c
	    i1 = mod(i-1,3)+1
	    i2 = mod(i  ,3)+1
	    i3 = mod(i+1,3)+1
	    do j=1,3
	      u(j) = tran_g (i1,j)
	      w(j) = tran_g (i2,j)
	    enddo
	    cr_win(i3) = do_bang(lspace,u,v,w)
	  enddo
	  call tran_sym
	  cr_spcgr   = 'P1'
	  cr_spcgrno = 1
	  lout = .true.
	  call lattice(cr_a0,cr_ar,cr_eps,cr_gten,
     &	  cr_reps,cr_rten,cr_win,cr_wrez,cr_v,
     &	  cr_vr,lout)
	  call update_cr_dim
	endif
c
	end
c*****7*****************************************************************
	subroutine tran_ca(usym,matrix,lscreen)
c-
c	Performs the transformation symmetry operation for a single
C	atom or reciprocal vector.
c+
	implicit     none
c
	include      'config.inc'
	include      'prompt.inc'
	include      'errlist.inc'
	include      'param.inc'
c
	integer      j
c
	logical      lscreen
c
	real         usym(4),ures(4)
	real         matrix(4,4)
c
c-----	Apply symmetry operation
c
	call trans(usym,matrix,ures,4)
c
c------	Replace original vector and store result
c
	do j=1,3
	  res_para(j) = ures(j)
	  usym(j) = ures(j)
	enddo
c
	res_para(0) = 3
	if(lscreen) then
	  write (output_io,3000) (res_para(j),j=1,3)
	endif
c
3000	format(' Result    : ',3(2x,f9.4))
	end
c*****7*****************************************************************
	subroutine tran_sym
c-
c	Transforms the symmetry operations
c+
	implicit     none
c
	include      'config.inc'
	include      'prompt.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'errlist.inc'
	include      'gen_add.inc'
	include      'sym_add.inc'
	include      'transfrm.inc'
c
	integer       i,j,k,n,nn,jp,l
	logical       lequal
c
	real          mat(4,4),arr(4,4)
	real          eps
C
	include      'generate.inc'
c
	data          eps/0.001/
c
c------	The original symmetry elements are going to be stored as additional
c	generators. The original additional generators are shifted up.
c
	if(gen_add_n+generspcgr(0,cr_spcgrno).gt.gen_add_MAX) then
	  ier_typ = ER_APPL
	  ier_num = -73
	  return
	endif
c
c------	Shift original additional generators by generspcgr(0,cr_spcgrno) entries
c
	k = generspcgr(0,cr_spcgrno)
	do n=gen_add_n,1,-1
	  nn = n+k
	  do i=1,4
	    do j=1,4
	      gen_add(i,j,nn) = gen_add(i,j,n)
	    enddo
	  enddo
	  gen_add_power(nn) = gen_add_power(n)
	enddo
c
c------	copy space group generators into additional generators
c
	do n=1,generspcgr(0,cr_spcgrno)
	  nn = generspcgr(n,cr_spcgrno)
	  do i=1,4
	    do j=1,4
	      gen_add(i,j,n)  = generators(i,j,nn)
	    enddo
	  enddo
	  gen_add_power(n) = generpower(nn)
	enddo
	gen_add_n = gen_add_n+generspcgr(0,cr_spcgrno)
c
c------	transform the additional generators
c
	do n=1,gen_add_n
	  do i=1,4
	    do j=1,4
	      mat(i,j) = gen_add(i,j,n)
	    enddo
	  enddo
	  call matmul4(arr,tran_f,mat    )
	  call matmul4(mat,arr,   tran_fi)
	  do i=1,4
	    do j=1,4
	      gen_add(i,j,n) = mat(i,j)
	    enddo
	  enddo
	enddo
c
c------	transform the additional symmetry elements
c
	do n=1,sym_add_n
	  do i=1,4
	    do j=1,4
	      mat(i,j) = sym_add(i,j,n)
	    enddo
	  enddo
	  call matmul4(arr,tran_f,mat    )
	  call matmul4(mat,arr,   tran_fi)
	  do i=1,4
	    do j=1,4
	      sym_add(i,j,n) = mat(i,j)
	    enddo
	  enddo
	enddo
c
c------	Check transformation of primitive translations, if it results in
c	non-integer translation, add as additional generator.
c
	k = gen_add_n
	do n=1,3
	  do i=1,4
	    do j=1,4
	      mat(i,j) = 0.0
	    enddo
	    mat(i,i) = 1.0
	  enddo
	  mat(n,4) = 1.0
	  call matmul4(arr,tran_f,mat    )
	  call matmul4(mat,arr,   tran_fi)
	  if(abs(amod(mat(1,4),1.)).gt.eps .or.
     &       abs(amod(mat(2,4),1.)).gt.eps .or.
     &       abs(amod(mat(3,4),1.)).gt.eps      ) then
	    if(gen_add_n+1.gt.gen_add_MAX) then
	      ier_typ = ER_APPL
	      ier_num = -73
	      return
	    endif
c
c------	----Determine power of generator
c
c
c------	----After this loop j holds the power,which transforms the generator
c	    into a primitive translation
c
c
c------	----This loop transforms the translation into 0<=t<1
c
	    do i=1,3
	      mat(i,4) = amod(mat(i,4),1.0)
	      if(mat(i,4).lt.0.0) mat(i,4)=mat(i,4)+1.0
	    enddo
	    jp = 1
	    do while(abs(jp*mat(1,4)-nint(jp*mat(1,4))).gt.eps  .or. 
     &	             abs(jp*mat(2,4)-nint(jp*mat(2,4))).gt.eps  .or. 
     &	             abs(jp*mat(3,4)-nint(jp*mat(3,4))).gt.eps       )
     &	           
	      jp = jp+1
	    enddo
c
c------	----Compare to previous generators originating from primitive
c	    translations. If identical, skip this one.
c
	    lequal = .true.
	    do i=k+1,gen_add_n
	      do j=1,3
	        lequal=lequal.and.(abs(gen_add(j,4,i)-mat(j,4)).lt.eps)
	      enddo
	    enddo
	    if(.not. lequal .or. k.eq.gen_add_n) then
	      gen_add_n = gen_add_n + 1
	      gen_add_power(gen_add_n) = 1
	      if(jp.gt.1) jp=jp-1
	      gen_add_power(gen_add_n) = jp
	      do i=1,4
	        do j=1,4
	          gen_add(i,j,gen_add_n) = mat(i,j)
	        enddo
	      enddo
	    endif
	  endif
	enddo
c
c------	Shift the generators resulting from the primitive translations
c	up front
c
	n = gen_add_n - k
	do i=1,n
	  do j=1,4
	    do k=1,4
	      mat(j,k) = gen_add(j,k,gen_add_n)
	    enddo
	  enddo
	  jp = gen_add_power(gen_add_n)
	  do l = gen_add_n,2,-1
	    do j=1,4
	      do k=1,4
	        gen_add(j,k,l) = gen_add(j,k,l-1)
	      enddo
	    enddo
	    gen_add_power(l) = gen_add_power(l-1)
	  enddo
	  do j=1,4
	    do k=1,4
	      gen_add(j,k,1) = mat(j,k)
	    enddo
	  enddo
	  gen_add_power(1) = jp
	enddo
c
	end
c*****7*****************************************************************
	subroutine tran_hkl(infile,infile_l,matrix)
c-
c	Transforms a list of reflections, read from file.
c+
	implicit     none
c
	include      'config.inc'
	include      'prompt.inc'
	include      'errlist.inc'
	include      'param.inc'
	include      'transfrm.inc'
c
	integer      ird,iwr,irs
	integer      i,j
	logical      lread,ltest
c
	character*20 inten
	character*40 infile
	character*48 outfile
	character*48 restfile
	character*200 line
	integer      infile_l,outfile_l
	integer      hkl(3)
	real         usym(4),ures(4),utest(3)
	real         matrix(4,4)
c
	data ird,iwr,irs / 7,8,9/
c
c	Open input file, and the two output files
c
	lread = .true.
	call oeffne(ird,infile,'unknown',lread)
	if(ier_num.ne.0) then
	  close(ird)
	  return
	endif
	lread = .false.
	outfile = infile(1:infile_l)//'.trans'
	call oeffne(iwr,outfile,'unknown',lread)
	if(ier_num.ne.0) then
	  close(ird)
	  close(iwr)
	  return
	endif
	lread = .false.
	restfile = infile(1:infile_l)//'.rest'
	call oeffne(irs,restfile,'unknown',lread)
	if(ier_num.ne.0) then
	  close(ird)
	  close(iwr)
	  close(irs)
	  return
	endif
c
c-----	Loop over all reflections in input file
c
1000	continue
	  read(ird,2000,end=999) hkl,inten
	  do i=1,3
	    usym(i) = float(hkl(i))
	  enddo
	  usym(4) = 0.0
c
c-----	-- Apply transformation operation
c
	  call trans(usym,matrix,ures,4)
c
c------	-- Write new integer reflections to output file, non-integer
c	   reflections to restfile
c
	  ltest = .true.
	  do i=1,3
	    utest(i) = abs(float(nint(ures(i)))-ures(i))
	    ltest    = ltest .and. (utest(i).lt.tran_deltahkl)
	  enddo
	  if(ltest) then
	    write(iwr,2000) (nint(ures(j)),j=1,3),inten
	  else
	    write(irs,3000) (ures(j),j=1,3),inten,(nint(usym(j)),j=1,3)
	  endif
	goto 1000
999	continue
	close(ird)
	close(iwr)
	close(irs)
c
c
2000	format(3i4,a20)
3000	format(3f8.3,1x,a20,1x,3i4)
	end
