	subroutine ersetz_para(ikl,iklz,string,ll,ww,maxw,ianz)
c-
c       replaces a substring in an expression by the value of the
c       appropriate Parameter.
c	This is needed if the parameter is read.
c
c       Version : 1.0
c       Date    : 11 Aug 92
c
c       Author  : R.B. Neder  (reinhard.neder@mail.uni-wuerzburg.de)
c+
	implicit      none
c
        include       'config.inc'
        include       'crystal.inc'
        include       'crystal.cmm'
        include       'atom_env.inc'
        include       'mole_env.inc'
        include       'errlist.inc'
        include       'microdis.inc'
        include       'molecule.inc'
        include       'param.inc'
c
	character*(*) string
	character*200 zeile
c
	integer       ianz
	integer       laenge,ltyp,kpara,kpara2,ikl,ll,iklz,maxw
	integer       lcomm
	integer       length_com
	real          ww(maxw)
c
	laenge=ll
	ltyp  =1
	zeile =' '
	kpara =nint(ww(1))
	if(maxw.ge.2) then
	  kpara2=nint(ww(2))
	endif
c
	lcomm = length_com(string,laenge,ikl)
c
	if(lcomm.eq.1) then
c
	  if(ikl.gt.2) zeile(1:ikl-1)=string(1:ikl-2)
	  if(string(ikl-1:ikl-1).eq.'i') then
	    if(ianz.eq.1) then
	      if(0.le.kpara .and. kpara.le.MAXPAR) then
	        write(zeile(ikl-1:ikl+13),'(i15)'  ) inpara(kpara)
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
	  elseif(string(ikl-1:ikl-1).eq.'r') then
	    if(ianz.eq.1) then
	      if(0.le.kpara .and. kpara.le.MAXPAR) then
	        write(zeile(ikl-1:ikl+13),'(e15.8e2)') rpara(kpara)
	        zeile(ikl+10:ikl+10) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
	  elseif(string(ikl-1:ikl-1).eq.'x') then
	    if(ianz.eq.1) then
	      if(1.le.kpara .and. kpara.le.NMAX  .and.
     &	                          kpara.le.cr_natoms   ) then
	        write(zeile(ikl-1:ikl+13),'(e15.8e2)') cr_pos(1,kpara)
	        zeile(ikl+10:ikl+10) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
	  elseif(string(ikl-1:ikl-1).eq.'y') then
	    if(ianz.eq.1) then
	      if(1.le.kpara .and. kpara.le.NMAX  .and.
     &	                          kpara.le.cr_natoms   ) then
	        write(zeile(ikl-1:ikl+13),'(e15.8e2)') cr_pos(2,kpara)
	        zeile(ikl+10:ikl+10) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
	  elseif(string(ikl-1:ikl-1).eq.'z') then
	    if(ianz.eq.1) then
	      if(1.le.kpara .and. kpara.le.NMAX  .and.
     &	                          kpara.le.cr_natoms   ) then
	        write(zeile(ikl-1:ikl+13),'(e15.8e2)') cr_pos(3,kpara)
	        zeile(ikl+10:ikl+10) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
	  elseif(string(ikl-1:ikl-1).eq.'m') then
	    if(ianz.eq.1) then
	      if(1.le.kpara .and. kpara.le.NMAX  .and.
     &	                          kpara.le.cr_natoms   ) then
	        write(zeile(ikl-1:ikl+13),'(i15)'  ) cr_iscat(kpara)
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
	  elseif(string(ikl-1:ikl-1).eq.'b') then
	    if(ianz.eq.1) then
	      if(1.le.kpara .and. kpara.le.cr_nscat) then
	        write(zeile(ikl-1:ikl+13),'(e15.8e2)') cr_dw(kpara)
	        zeile(ikl+10:ikl+10) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
	  elseif(string(ikl-1:ikl-1).eq.'n') then
	    if(ianz.eq.1) then
	      if    (kpara.eq.1) then
	        write(zeile(ikl-1:ikl+13),'(i15)'  ) cr_natoms
	      elseif(kpara.eq.2) then
	        write(zeile(ikl-1:ikl+13),'(i15)'  ) cr_nscat
	      elseif(kpara.eq.3) then
	        write(zeile(ikl-1:ikl+13),'(i15)'  ) cr_ncatoms
	      elseif(kpara.eq.4) then
	        write(zeile(ikl-1:ikl+13),'(i15)'  ) mole_num_mole
	      elseif(kpara.eq.5) then
	        write(zeile(ikl-1:ikl+13),'(i15)'  ) mole_num_type
	      elseif(kpara.eq.6) then
	        write(zeile(ikl-1:ikl+13),'(i15)'  ) mole_num_unit
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
	  else
	    ier_num = -2
	    ier_typ = ER_FORT
	  endif
c
	elseif(lcomm.eq.8) then
c
	  if    (string(ikl-8:ikl-1).eq.'mol_cont') then
	    if(ianz.eq.2) then
	      if(ikl.gt.6) zeile(1:ikl-7)=string(1:ikl-6)
	      if(0.lt.kpara .and. kpara.le.mole_num_mole) then
	        if(0.eq.kpara2) then
	          write(zeile(ikl-8:ikl+13),'(i15)') 
     &	                 mole_len(kpara)
	        elseif(0.le.kpara2.and. kpara2.le.mole_len(kpara)) then
	          write(zeile(ikl-8:ikl+13),'(i15)') 
     &	                 mole_cont(mole_off(kpara)+kpara2)
	        else
	          ier_num = -74
	          ier_typ = ER_APPL
	          return
	        endif
	      else
	        ier_num = -63
	        ier_typ = ER_APPL
	        return
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
	  else
	    ier_num = -2
	    ier_typ = ER_FORT
	  endif
c
	elseif(lcomm.eq.7) then
c
	  if    (string(ikl-7:ikl-1).eq.'mol_len') then
	    if(ianz.eq.1) then
	      if(ikl.gt.6) zeile(1:ikl-7)=string(1:ikl-6)
	      if(0.lt.kpara .and. kpara.le.mole_num_mole) then
	        write(zeile(ikl-8:ikl+13),'(i15)') 
     &	               mole_len(kpara)
	      else
	        ier_num = -63
	        ier_typ = ER_APPL
	        return
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
c
	  elseif    (string(ikl-7:ikl-1).eq.'mc_orig') then
	    if(ianz.eq.2) then
	      if(ikl.gt.6) zeile(1:ikl-7)=string(1:ikl-6)
	        if(1.le.kpara .and. kpara.le.3            .and.
     &	           0.le.kpara2.and.kpara2.le.MC_MAX_MICRO  ) then
	          write(zeile(ikl-7:ikl+13),'(e15.8e2)'  )
     &                             mc_orig(kpara,kpara2)
	          zeile(ikl+4:ikl+4) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
c
	  elseif(string(ikl-7:ikl-1).eq.'mc_type') then
	    if(ianz.eq.1) then
	      if(ikl.gt.6) zeile(1:ikl-7)=string(1:ikl-6)
	        if(0.le.kpara .and. kpara.le.MC_MAX_MICRO) then
	          write(zeile(ikl-7:ikl+13),'(i15    )') mc_type(kpara)
	        else
	          ier_num = -8
	          ier_typ = ER_FORT
	        endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
c
	  elseif(string(ikl-7:ikl-1).eq.'md_dist') then
	    if(ianz.eq.1) then
	      if(ikl.gt.6) zeile(1:ikl-7)=string(1:ikl-6)
	      if(1.le.kpara .and. kpara.le.NMAX) then
	        write(zeile(ikl-7:ikl+13),'(e15.8e2)') cr_md_dist(kpara)
	        zeile(ikl+4:ikl+4) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
c
	  elseif(string(ikl-7:ikl-1).eq.'md_next') then
	    if(ianz.eq.1) then
	      if(ikl.gt.6) zeile(1:ikl-7)=string(1:ikl-6)
	      if(1.le.kpara .and. kpara.le.NMAX) then
	        write(zeile(ikl-7:ikl+13),'(i15    )') cr_md_next(kpara)
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
	  else
	    ier_num = -2
	    ier_typ = ER_FORT
	  endif
	elseif(lcomm.eq.6) then
c
	  if(string(ikl-6:ikl-1).eq.'mc_num') then
	    if(ianz.eq.1) then
	      if(ikl.gt.5) zeile(1:ikl-6)=string(1:ikl-5)
	      write(zeile(ikl-6:ikl+13),'(i15    )'  ) mc_num
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
c
	  elseif(string(ikl-6:ikl-1).eq.'mc_rad') then
	    if(ianz.eq.1) then
	      if(ikl.gt.5) zeile(1:ikl-6)=string(1:ikl-5)
	      if(0.le.kpara .and. kpara.le.MC_MAX_MICRO) then
	        write(zeile(ikl-6:ikl+13),'(e15.8e2)') mc_rad(kpara)
	        zeile(ikl+5:ikl+5) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
c
	  elseif(string(ikl-6:ikl-1).eq.'mc_run') then
	    if(ianz.eq.1) then
	      if(ikl.gt.5) zeile(1:ikl-6)=string(1:ikl-5)
	      write(zeile(ikl-6:ikl+13),'(i15    )'  ) mc_num_run
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
c
	  elseif(string(ikl-6:ikl-1).eq.'md_cre') then
	    if(ianz.eq.1) then
	      if(ikl.gt.5) zeile(1:ikl-6)=string(1:ikl-5)
	      write(zeile(ikl-6:ikl+13),'(i15    )'  ) md_num_cre
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
c
	  elseif(string(ikl-6:ikl-1).eq.'md_num') then
	    if(ianz.eq.1) then
	      if(ikl.gt.5) zeile(1:ikl-6)=string(1:ikl-5)
	      write(zeile(ikl-6:ikl+13),'(i15    )'  ) md_num
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
c
	  elseif(string(ikl-6:ikl-1).eq.'md_rad') then
	    if(ianz.eq.2) then
	      if(ikl.gt.5) zeile(1:ikl-6)=string(1:ikl-5)
	      if(0.le.kpara .and. kpara.le.MAX_MD_HKL   .and.
     &	         0.le.kpara2.and.kpara2.le.MAX_MD_TY     ) then
	        write(zeile(ikl-6:ikl+13),'(e15.8e2)'  ) 
     &                   md_rad(kpara,kpara2)
	        zeile(ikl+5:ikl+5) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
c
	  elseif(string(ikl-6:ikl-1).eq.'md_run') then
	    if(ianz.eq.1) then
	      if(ikl.gt.5) zeile(1:ikl-6)=string(1:ikl-5)
	      write(zeile(ikl-6:ikl+13),'(i15    )'  ) md_num_run
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
	  else
	    ier_num = -2
	    ier_typ = ER_FORT
	  endif
	elseif(lcomm.eq.4) then
c
	  if(string(ikl-4:ikl-1).eq.'cdim') then
	    if(ianz.eq.2) then
	      if(ikl.gt.5) zeile(1:ikl-4)=string(1:ikl-5)
	      if(1.le.kpara .and. kpara.le.3            .and.
     &	         1.le.kpara2.and.kpara2.le.2             ) then
	        write(zeile(ikl-4:ikl+13),'(e15.8e2)'  ) 
     &                      cr_dim(kpara,kpara2)
	        zeile(ikl+7:ikl+7) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
	  elseif(string(ikl-4:ikl-1).eq.'menv') then
	    if(ianz.eq.1) then
	      if(ikl.gt.5) zeile(1:ikl-4)=string(1:ikl-5)
	      if(0.le.kpara .and. kpara.le.MAXPAR_RES   ) then
	        write(zeile(ikl-4:ikl+13),'(i15    )'  ) 
     &                      mole_env(kpara)
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
	  else
	    ier_num = -2
	    ier_typ = ER_FORT
	  endif
	elseif(lcomm.eq.3) then
c
	  if(string(ikl-3:ikl-1).eq.'res') then
	    if(ianz.eq.1) then
	      if(ikl.gt.4) zeile(1:ikl-3)=string(1:ikl-4)
	      if(0.le.kpara .and. kpara.le.MAXPAR_RES   ) then
	        write(zeile(ikl-3:ikl+13),'(e15.8e2)'  ) 
     &                      res_para(kpara)
	        zeile(ikl+8:ikl+8) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
	  elseif(string(ikl-3:ikl-1).eq.'env') then
	    if(ianz.eq.1) then
	      if(ikl.gt.4) zeile(1:ikl-3)=string(1:ikl-4)
	      if(0.le.kpara .and. kpara.le.MAXPAR_RES   ) then
	        write(zeile(ikl-3:ikl+13),'(i15    )'  ) 
     &                      atom_env(kpara)
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	      return
	    endif
	  else
	    ier_num = -2
	    ier_typ = ER_FORT
	  endif
	else
	  ier_num = -2
	  ier_typ = ER_FORT
	endif
	if(ier_num .eq. 0) then
	  ll    =laenge+15-ltyp-(iklz-ikl+1)
	  if(iklz+1.le.laenge) zeile(ikl+14:ll)=string(iklz+1:laenge)
	  string=zeile
	else
	  write (*,*) string
	endif
	call rem_bl(string,ll)
	end
c*****7*****************************************************************
	subroutine upd_para(ctype,ww,maxw,wert,ianz)
c-
c       updates the parameter spezified by ctype, index ww  to the
c       new value of wert
c+
	implicit      none
c
        include       'config.inc'
        include       'crystal.inc'
        include       'crystal.cmm'
        include       'atom_env.inc'
        include       'errlist.inc'
        include       'param.inc'
c
	integer       maxw,ianz
	character*(*) ctype
	integer       ww(maxw),l
	real          wert
c
        if    (ctype.eq.'x') then
	  if(ianz.eq.1) then
	    if(0.lt.ww(1) .and. ww(1).le.NMAX  .and.
     &	                        ww(1).le.cr_natoms   ) then
              cr_pos(1,ww(1))=wert
	      l=1
              cr_dim(l,1)=amin1(cr_dim(l,1),cr_pos(l,ww(1)))
              cr_dim(l,2)=amax1(cr_dim(l,2),cr_pos(l,ww(1)))
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	    return
	  endif
        elseif(ctype.eq.'y') then
	  if(ianz.eq.1) then
	    if(0.lt.ww(1) .and. ww(1).le.NMAX  .and.
     &	                        ww(1).le.cr_natoms   ) then
              cr_pos(2,ww(1))=wert
	      l=2
              cr_dim(l,1)=amin1(cr_dim(l,1),cr_pos(l,ww(1)))
              cr_dim(l,2)=amax1(cr_dim(l,2),cr_pos(l,ww(1)))
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	    return
	  endif
        elseif(ctype.eq.'z') then
	  if(ianz.eq.1) then
	    if(0.lt.ww(1) .and. ww(1).le.NMAX  .and.
     &	                        ww(1).le.cr_natoms   ) then
              cr_pos(3,ww(1))=wert
	      l=3
              cr_dim(l,1)=amin1(cr_dim(l,1),cr_pos(l,ww(1)))
              cr_dim(l,2)=amax1(cr_dim(l,2),cr_pos(l,ww(1)))
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	    return
	  endif
        elseif(ctype.eq.'m') then
	  if(ianz.eq.1) then
	    if(0.lt.ww(1) .and. ww(1).le.NMAX  .and.
     &	                        ww(1).le.cr_natoms   ) then
              cr_iscat(ww(1))=int(wert)
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	    return
	  endif
        elseif(ctype.eq.'b') then
	  if(ianz.eq.1) then
	    if(0.lt.ww(1) .and. ww(1).le.cr_nscat) then
              cr_dw(ww(1))=wert
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	    return
	  endif
        elseif(ctype.eq.'i') then
	  if(ianz.eq.1) then
	    if(0.le.ww(1) .and. ww(1).le.MAXPAR) then
              inpara(ww(1))=int(wert)
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	    return
	  endif
        elseif(ctype.eq.'r') then
	  if(ianz.eq.1) then
	    if(0.le.ww(1) .and. ww(1).le.MAXPAR) then
              rpara(ww(1))=wert
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	    return
	  endif
        elseif(ctype.eq.'res') then
	  if(ianz.eq.1) then
	    if(0.le.ww(1) .and. ww(1).le.MAXPAR_RES) then
              res_para(ww(1))=wert
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	    return
	  endif
        elseif(ctype.eq.'env') then
	  if(ianz.eq.1) then
	    if(0.le.ww(1) .and. ww(1).le.MAXPAR_RES) then
              atom_env(ww(1))=int(wert)
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	    return
	  endif
        else
          ier_num = -2
	  ier_typ = ER_FORT
	  write (*,*) ctype
        endif
2000    format(' Integer Parameter: ',I1,' : ',i15)
2010    format(' Real    Parameter: ',I1,' : ',e15.8e2)
	end
c*****7***************************************************************
	subroutine calc_intr_spec(string,line,ikl,iklz,ww,laenge,lp)
c-
c	These are special intrinsic function for the DISCUS. Any
c	intrinsic function that references crystallographic values
c	is found in this subroutine.
c+
	implicit      none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'errlist.inc'
	include      'microdis.inc'
	include      'molecule.inc'
	include      'param.inc'
c
	integer       maxw
	parameter    (maxw=9)
c
	character*(*) string,line
	character*200 cpara(maxw)
	integer       lpara(maxw),lp
	integer       ikl,iklz,i,j,k,ianz,lcomm,laenge,l
	logical       lspace,lins
	real          werte(maxw),ww,u(3),v(3),w(3)
c
	integer       length_com
	logical       str_comp
	real          do_blen,do_bang
	real          do_read_number
c
	lcomm   = length_com(string,laenge,ikl)
	ier_num = -1
	ier_typ = ER_FORT
	do i=1,maxw
	  werte(i) = 0.0
	enddo
c
	if(lcomm.eq.9) then
c
c------	Calculate average density of a fractional coordinate
c
	  if(string(ikl-9:ikl-1).eq.'aver_dens') then
	    call get_params(line,ianz,cpara,lpara,6,lp)
	    if(ier_num.eq.0) then
	      do i=1,maxw
	        werte(i) = 0.00001
	      enddo
	      if(ianz.eq.3 .or. ianz.eq.4 ) then
	         do i=1,ianz
	           call eval(cpara(i),lpara(i))
	           if(ier_num.ne.0) then
	             goto 999
	           endif
	           werte(i) = do_read_number(cpara(i),lpara(i))
	           if(ier_num.ne.0) then
	             goto 999
	           endif
	         enddo
cthp	         ww = inter_aver_dens(werte,maxw)
	         call ersetz2(string,ikl,iklz,ww,9,laenge)
	       else
	         ier_num = -6
	         ier_typ = ER_COMM
	       endif
	    endif
	  else
	    ier_num = -3
	    ier_typ = ER_FORT
	  endif
c
	elseif(lcomm.eq.8) then
c
	  if(string(ikl-8:ikl-1).eq.'mol_test') then
	    call get_params(line,ianz,cpara,lpara,6,lp)
	    if(ier_num.eq.0) then
	      if(ianz.eq.1 ) then
	        call eval(cpara(1),lpara(1))
	        if(ier_num.ne.0) then
	          goto 999
	        endif
	        l = nint ( do_read_number(cpara(1),lpara(1)))
	        if(ier_num.ne.0) then
	          goto 999
	        endif
	        res_para(0)=0
	        res_para(1)=0
	        res_para(2)=0
	        do i=1,mole_num_mole
	          do j=1,mole_len(i)
	            if(mole_cont(mole_off(i)+j).eq.l) then
	              res_para(0)=2
	              res_para(1)=i
	              res_para(2)=j
	              ww         =float(i)
	              goto 8000
	            endif
	          enddo
	        enddo
8000	        continue
	        call ersetz2(string,ikl,iklz,ww,8,laenge)
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    endif
	  else
	    ier_num = -3
	    ier_typ = ER_FORT
	  endif
	elseif(lcomm.eq.7) then
c
c------	Calculate whether a given coordinate is inside any microdomain
c
	  if(string(ikl-7:ikl-1).eq.'md_test') then
	    call get_params(line,ianz,cpara,lpara,6,lp)
	    if(ier_num.eq.0) then
	      if(ianz.eq.3 ) then
	         do i=1,ianz
	           call eval(cpara(i),lpara(i))
	           if(ier_num.ne.0) then
	             goto 999
	           endif
	           werte(i) = do_read_number(cpara(i),lpara(i))
	           if(ier_num.ne.0) then
	             goto 999
	           endif
	         enddo
	         do i =1,3
	           u(i) = werte(i  )
	         enddo
	         lins          = .false.
	         i             = cr_natoms + 1
	         cr_md_next(i) = 0
	         cr_md_dist(i) = 1.0e9
	         j             = 1
CDBGG	         call micro_check_all(u,i,j,lins)
	         ww = float(j)
	         call ersetz2(string,ikl,iklz,ww,7,laenge)
	       else
	         ier_num = -6
	         ier_typ = ER_COMM
	       endif
	    endif
	  else
	    ier_num = -3
	    ier_typ = ER_FORT
	  endif
	elseif(lcomm.eq.5) then
c
c------	Calculate reciprocal length or d-star value, respectivly
c
	  if(string(ikl-5:ikl-1).eq.'dstar') then
	    call get_params(line,ianz,cpara,lpara,6,lp)
	    if(ier_num.eq.0) then
	      if(ianz.eq.3 .or. ianz.eq.6) then
	         do i=1,ianz
	           call eval(cpara(i),lpara(i))
	           if(ier_num.ne.0) then
	             goto 999
	           endif
	           werte(i) = do_read_number(cpara(i),lpara(i))
	           if(ier_num.ne.0) then
	             goto 999
	           endif
	         enddo
	         if(ianz.eq.3) then
	           do i =4,6
	             werte(i) = 0.0
	           enddo
	         endif
	         do i =1,3
	           u(i) = werte(i  )
	           v(i) = werte(i+3)
	         enddo
	         lspace = .false.
	         ww     = do_blen(lspace,u,v)
	         call ersetz2(string,ikl,iklz,ww,5,laenge)
	       else
	         ier_num = -6
	         ier_typ = ER_COMM
	       endif
	    endif
	  else
	    ier_num = -3
	    ier_typ = ER_FORT
	  endif
	elseif(lcomm.eq.4) then
c
c------	Calculate a bond angle
c
	  if(string(ikl-4:ikl-1).eq.'bang') then
	    call get_params(line,ianz,cpara,lpara,9,lp)
	    if(ier_num.eq.0) then
	      if(ianz.eq.3 .or. ianz.eq.4 .or. 
     &	         ianz.eq.6 .or. ianz.eq.9) then
c------	--------Input are atom numbers
	        if(str_comp(cpara(1),'atom',1,lpara(1),4)) then
	          do i=2,ianz
	            call eval(cpara(i),lpara(i))
	            if(ier_num.ne.0) then
	              goto 999
	            endif
	            werte(i) = do_read_number(cpara(i),lpara(i))
	            if(ier_num.ne.0) then
	              goto 999
	            endif
	          enddo
	          i = nint(werte(2))
	          j = nint(werte(3))
	          if(ianz.eq.3) then
	            if(i.lt.1 .or. cr_natoms.lt.i  .or.
     &                 j.lt.1 .or. cr_natoms.lt.j      ) then
	              ier_typ = ER_APPL
	              ier_num = -19
	              return
	            else
	              u(1) = cr_pos(1,i)
	              u(2) = cr_pos(2,i)
	              u(3) = cr_pos(3,i)
	              v(1) = 0.0
	              v(2) = 0.0
	              v(3) = 0.0
	              w(1) = cr_pos(1,j)
	              w(2) = cr_pos(2,j)
	              w(3) = cr_pos(3,j)
	            endif
	          else
	            k = nint(werte(4))
	            if(i.lt.1 .or. cr_natoms.lt.i  .or.
     &                 j.lt.1 .or. cr_natoms.lt.j  .or.
     &                 k.lt.1 .or. cr_natoms.lt.k      ) then
	              ier_typ = ER_APPL
	              ier_num = -19
	              return
	            else
	              u(1) = cr_pos(1,i)
	              u(2) = cr_pos(2,i)
	              u(3) = cr_pos(3,i)
	              v(1) = cr_pos(1,j)
	              v(2) = cr_pos(2,j)
	              v(3) = cr_pos(3,j)
	              w(1) = cr_pos(1,k)
	              w(2) = cr_pos(2,k)
	              w(3) = cr_pos(3,k)
	            endif
	          endif
	        else
c------	--------Input are real space coordinates
	         do i=1,ianz
	           call eval(cpara(i),lpara(i))
	           if(ier_num.ne.0) then
	             goto 999
	           endif
	           werte(i) = do_read_number(cpara(i),lpara(i))
	           if(ier_num.ne.0) then
	             goto 999
	           endif
	         enddo
	         if(ianz.eq.6) then
	           do i =4,6
	             werte(i+3) = werte(i)
	             werte(i  ) = 0.0
	           enddo
	         endif
	         do i =1,3
	           u(i) = werte(i  )
	           v(i) = werte(i+3)
	           w(i) = werte(i+6)
	         enddo
	        endif
	         lspace = .true.
	         ww     = do_bang(lspace,u,v,w)
	         call ersetz2(string,ikl,iklz,ww,4,laenge)
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    endif
c
c------	Calculate a bond length
c
	  elseif(string(ikl-4:ikl-1).eq.'blen') then
	    call get_params(line,ianz,cpara,lpara,6,lp)
	    if(ier_num.eq.0) then
	      if(ianz.eq.3 .or. ianz.eq.6) then
c------	--------Input are atom numbers
	        if(str_comp(cpara(1),'atom',1,lpara(1),4)) then
	          do i=2,ianz
	            call eval(cpara(i),lpara(i))
	            if(ier_num.ne.0) then
	              goto 999
	            endif
	            werte(i) = do_read_number(cpara(i),lpara(i))
	            if(ier_num.ne.0) then
	              goto 999
	            endif
	          enddo
	          i = nint(werte(2))
	          j = nint(werte(3))
	          if(i.lt.1 .or. cr_natoms.lt.i  .or.
     &               j.lt.1 .or. cr_natoms.lt.j      ) then
	            ier_typ = ER_APPL
	            ier_num = -19
	            return
	          else
	            u(1) = cr_pos(1,i)
	            u(2) = cr_pos(2,i)
	            u(3) = cr_pos(3,i)
	            v(1) = cr_pos(1,j)
	            v(2) = cr_pos(2,j)
	            v(3) = cr_pos(3,j)
	          endif
	        else
c------	--------Input are real space coordinates
	          do i=1,ianz
	            call eval(cpara(i),lpara(i))
	            if(ier_num.ne.0) then
	              goto 999
	            endif
	            werte(i) = do_read_number(cpara(i),lpara(i))
	            if(ier_num.ne.0) then
	              goto 999
	            endif
	          enddo
	          if(ianz.eq.3) then
	            do i =4,6
	              werte(i) = 0.0
	            enddo
	          endif
	          do i =1,3
	            u(i) = werte(i  )
	            v(i) = werte(i+3)
	          enddo
	         endif
	          lspace = .true.
	          ww     = do_blen(lspace,u,v)
	          call ersetz2(string,ikl,iklz,ww,4,laenge)
	       else
	         ier_num = -6
	         ier_typ = ER_COMM
	       endif
	    endif
c
c------	Calculate angle in reciprocal space
c
	  elseif(string(ikl-4:ikl-1).eq.'rang') then
	    call get_params(line,ianz,cpara,lpara,9,lp)
	    if(ier_num.eq.0) then
	      if(ianz.eq.6 .or. ianz.eq.9) then
	        do i=1,ianz
	           call eval(cpara(i),lpara(i))
	           if(ier_num.ne.0) then
	             goto 999
	           endif
	           werte(i) = do_read_number(cpara(i),lpara(i))
	           if(ier_num.ne.0) then
	             goto 999
	           endif
	        enddo
	        if(ianz.eq.6) then
	          do i =4,6
	            werte(i+3) = werte(i)
	            werte(i  ) = 0.0
	          enddo
	        endif
	        do i =1,3
	          u(i) = werte(i  )
	          v(i) = werte(i+3)
	          w(i) = werte(i+6)
	        enddo
	        lspace = .false.
	        ww     = do_bang(lspace,u,v,w)
	        call ersetz2(string,ikl,iklz,ww,4,laenge)
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    endif
	  else
	    ier_num = -3
	    ier_typ = ER_FORT
	  endif
	elseif(lcomm.eq.0) then
 	  call ersetz2(string,ikl,iklz,ww,0,laenge)
	else
	  ier_num = -3
	  ier_typ = ER_FORT
	endif
c
999	continue
c
	if(ier_num .ne.0) then
	  write (*,*) string
	  write (*,*) line
	endif
c
	end
c*****7****************************************************************
