c*****7*****************************************************************
	subroutine initarrays
c+
c	This is the initialisation routine called at startup time
c	of KUPLOT. In the first section there are a few definitions
c	that might need adjustment.
c
c	Version : 4.0
c	Date    : 06. March 1999
c
c	Author  : Th. Proffen (tproffen@lanl.gov )
c+
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'envir.inc'
	include		'errlist.inc'
	include		'learn.inc'
c
	integer		i,j,k,iw
	integer		stift(0:14)
c
	data	stift	/6,3,1,2,4,5,7,8,9,10,11,12,13,14,6/
c
c------ Device definitions for PGPLOT
c
	call init_devices
c
	do iw=1,maxwin
	  dev_width(iw)   = 10.0
	  dev_height(iw)  =  7.5
c
	  dev_sf(iw,x11)  = 0.7
	  dev_id(iw,x11)  = -1
	  dev_sf(iw,ps)   = 1.0
	  dev_id(iw,ps)   = -1
	  dev_sf(iw,vps)  = 1.0
	  dev_id(iw,vps)  = -1
	  dev_sf(iw,pic)  = 0.7
	  dev_id(iw,pic)  = -1
	  dev_sf(iw,vpic) = 0.7
	  dev_id(iw,vpic) = -1
	enddo
c
c------ common /errors/
c
	ier_num = 0
	ier_typ = ER_NONE
	ier_sta = ER_S_CONT
c
	do i=1,3
	  ier_msg(i) = ' '
	enddo
c
c------ setting default color map for bitmaps
c
	do iwin=1,maxwin
	  call cmap_gray (.false.)
	enddo
c
c------ setting default line colours
c------ Background
c
	do iw=1,maxwin
	  colour(iw, 0,1) = 1.0
	  colour(iw, 0,2) = 1.0
	  colour(iw, 0,3) = 1.0
c
c------ - Colours set to PGPLOT defaults
c
	  colour(iw, 1,1) = 1.0
	  colour(iw, 1,2) = 0.0
	  colour(iw, 1,3) = 0.0
c
	  colour(iw, 2,1) = 0.0
	  colour(iw, 2,2) = 1.0
	  colour(iw, 2,3) = 0.0
c
	  colour(iw, 3,1) = 0.0
	  colour(iw, 3,2) = 0.0
	  colour(iw, 3,3) = 1.0
c
	  colour(iw, 4,1) = 1.0
	  colour(iw, 4,2) = 0.0
	  colour(iw, 4,3) = 1.0
c
	  colour(iw, 5,1) = 1.0
	  colour(iw, 5,2) = 1.0
	  colour(iw, 5,3) = 0.0
c
	  colour(iw, 6,1) = 0.0
	  colour(iw, 6,2) = 0.0
	  colour(iw, 6,3) = 0.0
c
	  colour(iw, 7,1) = 0.6
	  colour(iw, 7,2) = 0.0
	  colour(iw, 7,3) = 0.0
c
	  colour(iw, 8,1) = 0.0
	  colour(iw, 8,2) = 0.6
	  colour(iw, 8,3) = 0.0
c
	  colour(iw, 9,1) = 0.0
	  colour(iw, 9,2) = 0.0
	  colour(iw, 9,3) = 0.6
c
	  colour(iw,10,1) = 0.6
	  colour(iw,10,2) = 0.0
	  colour(iw,10,3) = 0.6
c
	  colour(iw,11,1) = 0.6
	  colour(iw,11,2) = 0.6
	  colour(iw,11,3) = 0.0
c
	  colour(iw,12,1) = 0.5
	  colour(iw,12,2) = 0.5
	  colour(iw,12,3) = 0.5
c
	  colour(iw,13,1) = 0.0
	  colour(iw,13,2) = 1.0
	  colour(iw,13,3) = 1.0
c
	  colour(iw,14,1) = 0.0
	  colour(iw,14,2) = 0.6
	  colour(iw,14,3) = 0.6
c
	  colour(iw,15,1) = 0.0
	  colour(iw,15,2) = 0.0
	  colour(iw,15,3) = 0.0
c
	enddo
c                                            
c------ here start all the defaults for the variables
c
	ftyp        = 'NONE'
	fstart      = .true.
	wtyp        = 'INV'
	urf         = 0.1
	ncycle      = 30
	npara       = 2
	np1         = 2
	np2         = 0
	np3         = 0
	fit_ifen    = 5
	exclude9999 = 0
	ifen        = 9
c
	offxy(0)    = 0
	offz (0)    = 0
c
	do i=1,maxpara
	  p(i)    = 0.0
	  pinc(i) = 1.0
	enddo
c
	do i=1,maxkurvtot
	  lni(i)      = .false.
	  ikfirst(i)  = .true.
	enddo
c
	iz          = 1
	iframe      = 1
	iwin        = 1
c
	do iw=1,maxwin
	  ipara(iw)       = 2
	  fpara(iw)       = 'kupl.par'
	  orient(iw)      = .true.
	  tot_frame(iw)   = .false.
	  iaf(iw)         = 1  
	  icol_old(iw)    = -1
c
	  lgui(iw)        = .false.
	  iden(iw)        = .false.
c
	  do i=1,maxframe
	    ax_d(iw,i,1)      = 1.5
	    ax_d(iw,i,2)      = 1.5
	    lab_angle(iw,i,1) = 0.0
	    lab_angle(iw,i,2) = 0.0
	    lab_d(iw,i,1)     = 0.3
	    lab_d(iw,i,2)     = 0.3
	    tick_ma_h(iw,i,1) = 0.5
	    tick_ma_h(iw,i,2) = 0.5
	    tick_mi_h(iw,i,1) = 0.5
	    tick_mi_h(iw,i,2) = 0.5
	    tick_nsub(iw,i,1) = 2
	    tick_nsub(iw,i,2) = 2
c
	    ibuf(iw,i,1) = 0.1
	    ibuf(iw,i,2) = 0.1
	    ibuf(iw,i,3) = 0.1
	    ibuf(iw,i,4) = 0.1
	    linewid(iw,i,0)  = 0.3
	    ilinecol(iw,i,0) = 6
	    iho(iw,i)        = 1
c
	    info_orig(iw,i,1) = -9999.
	    info_orig(iw,i,2) = -9999.
c
	    do k=1,maxbond
	      bond_rad(iw,i,k)  = 0.0
	      bond_sig(iw,i,k)  = 0.2
	      bond_lwid(iw,i,k) = 0.5
	      bond_lcol(iw,i,k) = stift(mod(k,15))
	      bond_ltyp(iw,i,k) = 1
	    enddo
c
	    do j=1,maxkurvtot
	      do k=1,maxhl
	        hlinecol(iw,i,j,k) = stift(mod(j,15))
	        hlinetyp(iw,i,j,k) = 1
	      enddo
	      do k=1,4
	        fillrange(iw,i,j,k) = -9999.0
	      enddo
	      hlabel(iw,i,j)   = 0
	      linewid(iw,i,j)  = 0.2
	      ilegend(iw,i,j)  = 0
	      ilinecol(iw,i,j) = stift(mod(j,15))
	      ifillcol(iw,i,j) = stift(mod(j,15))
	      imarkcol(iw,i,j) = stift(mod(j,15))
	      ierrcol (iw,i,j) = stift(mod(j,15))
	      ierr(iw,i,j)     = 0
	      ilinetyp(iw,i,j) = 1
	      ifilltyp(iw,i,j) = 0
	      imarktyp(iw,i,j) = 0
	      imarkmax(iw,i,j) = 0
	      ilineart(iw,i,j) = 1
	      hlineart(iw,i,j) = 1
	      sizemark(iw,i,j) = 0.2
	      infra(iw,i,j) = j
	    enddo

	    do j=1,maxan
	      antext(iw,i,j)  = 'OFF'
	      anx(iw,i,j)     = 0.0
	      any(iw,i,j)     = 0.0
	      antx(iw,i,j)    = 0.0
	      anty(iw,i,j)    = 0.0
	      anjust(iw,i,j)  = if_left
	      anangle(iw,i,j) = 0.0
	    enddo
c
	    do j=1,maxhl
	      z_min(iw,i,j) = 50.0
	      z_inc(iw,i,j) = 50.0
	      nz(iw,i,j) = 10
	    enddo
c
	    frjust(iw,i)     = if_left
	    frback(iw,i,1)   = colour(iw,0,1)
	    frback(iw,i,2)   = colour(iw,0,2)
	    frback(iw,i,3)   = colour(iw,0,3)
c
	    fonscal(iw,i)    = 1.0
c
	    fonsize(iw,i,1)  = 160.0
	    fonsize(iw,i,2)  = 140.0
	    fonsize(iw,i,3)  = 120.0
	    fonsize(iw,i,4)  = 120.0
	    fonsize(iw,i,5)  = 120.0
	    fonsize(iw,i,6)  = 120.0
c
	    fon_id(iw,i,1)   = 2
	    fon_id(iw,i,2)   = 2
	    fon_id(iw,i,3)   = 2
	    fon_id(iw,i,4)   = 2
	    fon_id(iw,i,5)   = 1
	    fon_id(iw,i,6)   = 2
c
	    foncol(iw,i,1)   = 6
	    foncol(iw,i,2)   = 6
	    foncol(iw,i,3)   = 6
	    foncol(iw,i,4)   = 6
	    foncol(iw,i,5)   = 6
	    foncol(iw,i,6)   = 6
c
	    ifname(iw,i)  = .true. 
	    igrid(iw,i)   = .false.
	    ibox(iw,i)    = 3
	    ftext(iw,i)   = 'kupl.par'
	    ex(iw,i,1)    = -9999.
	    ex(iw,i,2)    = -9999.
	    ey(iw,i,1)    = -9999.
	    ey(iw,i,2)    = -9999.
	    t(iw,i,1)     = -9999.
	    t(iw,i,2)     = -9999.
	    yskal_u(iw,i) = -9999.
	    lyskal(iw,i)  = .false.
c
	    titel(iw,i,1) = ' '
	    titel(iw,i,2) = ' '
	    achse(iw,i,1) = ' x '
	    achse(iw,i,2) = ' y '
	    achse(iw,i,3) = 'OFF'
	    lachse(iw,i,1)= .false.
	    lachse(iw,i,2)= .false.
	    lachse(iw,i,3)= .false.
	    shear(iw,i)   = 90.0
	    sfl(iw,i)     = .true.
	    frame(iw,i,1) = 0.0
	    frame(iw,i,2) = 0.0
	    frame(iw,i,3) = 1.0
	    frame(iw,i,4) = 1.0
	  enddo
	enddo
c
	end
c*****7*****************************************************************
	subroutine do_read_def (zeile,lp)
c+
c	Reading defaults
c-
	implicit	none
c
	include		'prompt.inc'
	include		'errlist.inc'
c
	integer		maxw,idef
	parameter	(maxw=5)
	parameter	(idef=9)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	character*80	cdummy
	integer		lp,ianz
	integer		lpara(maxw)
	real		werte(maxw)
c
	integer		len_str
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
	if(ianz.eq.0) then
	  cdummy='kuplot.def'
	else
	  call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	  if (ier_num.ne.0) return
	  cdummy=cpara(1)
	endif
c
	call oeffne(idef,cdummy,'old',.false.)
	if (ier_num.eq.0) then
	  call read_def(idef)
	  write (output_io,1000) cdummy(1:len_str(cdummy))
	  close(idef)
	endif
c
1000	format (' ------ > Reading defaults from file ',a,' ..')
	end
c*****7*****************************************************************
	subroutine do_write_def (zeile,lp)
c+
c	Writing defaults
c-
	implicit	none
c
	include		'prompt.inc'
	include		'errlist.inc'
c
	integer		maxw,idef
	parameter	(maxw=5)
	parameter	(idef=9)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	character*80	cdummy
	integer		lpara(maxw)
	integer		lp,ianz
	real		werte(maxw)
c
	integer		len_str
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
	if(ianz.eq.0) then
	  cdummy='kuplot.def'
	else
	  call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	  if (ier_num.ne.0) return
	  cdummy=cpara(1)
	endif
c
	call oeffne(idef,cdummy,'unknown',.false.)
	if (ier_num.eq.0) then
	  call write_def(idef)
	  write (output_io,1000) cdummy(1:len_str(cdummy))
	  close(idef)
	endif
c
1000	format (' ------ > Writing defaults to file ',a,' ..')
	end
c*****7*****************************************************************
	subroutine write_def (idef)
c+
c 	This routine saves the current settings to a file
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	character*1	q
	integer		idef,i,j,k
c
	integer		len_str
c
	q = char(39)
c
	write (idef,1000) 
	write (idef,9998) 'MAXKURVTOT,MAXFRAME,MAXBOND,MAXHL,MAXWIN'
	write (idef,1100) MAXKURVTOT,MAXFRAME,MAXBOND,MAXHL,MAXWIN
	write (idef,9998) 'Title line 1 and 2 for each frame'
	write (idef,9997) (((q,titel(k,i,j)(1:len_str(titel(k,i,j))),q,
     &	                  k=1,MAXWIN),i=1,MAXFRAME),j=1,2)
	write (idef,9998) 'Axes lables x,y and z for each frame'
	write (idef,9997) (((q,achse(k,i,j)(1:len_str(achse(k,i,j))),q,
     &	                  k=1,MAXWIN),i=1,MAXFRAME),j=1,3)
	write (idef,9998) 'Buffer space for each frame (l,r,b,t)'
	write (idef,1600) ibuf
	write (idef,9998) 'Code for box around plot (-> buf)'
	write (idef,1800) ibox
	write (idef,9998) 'Code (T/F) for grid plotting (-> grid)'
	write (idef,1900) igrid
	write (idef,9998) 'Code (T/F) for paper orientation (-> orient)'
	write (idef,1900) orient
	write (idef,9998) 'Marker size for each data set and each frame'
	write (idef,1600) sizemark
	write (idef,9998) 'Line width ...'
	write (idef,1600) linewid
	write (idef,9998) 'Line colour ...'
	write (idef,1800) ilinecol
	write (idef,9998) 'Marker colour ...'
	write (idef,1800) imarkcol
	write (idef,9998) 'Line type ...'
	write (idef,1800) ilinetyp
	write (idef,9998) 'Marker type ...'
	write (idef,1800) imarktyp
	write (idef,9998) 'Line style ...'
	write (idef,1800) ilineart
	write (idef,9998) 'Maximum marker type ... '
	write (idef,1800) imarkmax
	write (idef,9998) 'Error bar type ... '
	write (idef,1800) ierr
	write (idef,9998) 'Frame corners for each frame'
	write (idef,1500) frame
	write (idef,9998) 'Frame background colour for each frame'
	write (idef,1600) frback
	write (idef,9998) 'Font sizes ...'
	write (idef,1700) fonsize
	write (idef,9998) 'Font overall scaling ...'
	write (idef,1700) fonscal
	write (idef,9998) 'Font ids ...'
	write (idef,1800) fon_id
	write (idef,9998) 'Font colour ...'
	write (idef,1800) foncol
	write (idef,9998) 'Code text justification ...'
	write (idef,1800) frjust
	write (idef,9998) 'Code filename plotting ...'
	write (idef,1900) ifname
	write (idef,9998) 'Code border around frames ...'
	write (idef,1900) tot_frame
	write (idef,9998) 'Number of contour sets'
	write (idef,1800) iho
	write (idef,9998) 'Lowest contour per set per frame'
	write (idef,1400) z_min
	write (idef,9998) 'Contour increment ...'
	write (idef,1400) z_inc
	write (idef,9998) 'Contour line colour ...'
	write (idef,1800) hlinecol
	write (idef,9998) 'Contour line type ...'
	write (idef,1800) hlinetyp
	write (idef,9998) 'Contour line style ...'
	write (idef,1800) hlineart
	write (idef,9998) 'Contour line labelling ...'
	write (idef,1800) hlabel
	write (idef,9998) 'Process -9999. ...'
	write (idef,1800) exclude9999
	write (idef,9998) 'Bond length ...'
	write (idef,1400) bond_rad
	write (idef,9998) 'Bond length sigma ...'
	write (idef,1400) bond_sig
	write (idef,9998) 'Bond line width ...'
	write (idef,1600) bond_lwid
	write (idef,9998) 'Bond line colour ...'
	write (idef,1800) bond_lcol
	write (idef,9998) 'Bond line type ...'
	write (idef,1800) bond_ltyp
	write (idef,9998) 'Line colours ...'
	write (idef,1600) colour
	write (idef,9998) 'Scale factors of graphics devices ...'
	write (idef,1600) dev_sf
	write (idef,9998) 'Colours for error bars'
	write (idef,1800) ierrcol
	write (idef,9998) 'Angle for text annotations'
	write (idef,1800) anangle
	write (idef,9998) 'Colour for filling'
	write (idef,1800) ifillcol
	write (idef,9998) 'Style for filling'
	write (idef,1800) ifilltyp
	write (idef,9998) 'Range for filling'
	write (idef,1400) fillrange
	write (idef,9998) 'Angle of axes labels'
	write (idef,1600) lab_angle
	write (idef,9998) 'Distance numbers from axes'
	write (idef,1600) lab_d
	write (idef,9998) 'Distance labels from axes'
	write (idef,1600) ax_d
	write (idef,9998) 'Height major tick marks'
	write (idef,1500) tick_ma_h
	write (idef,9998) 'Height minor tick marks'
	write (idef,1500) tick_mi_h
	write (idef,9998) 'Number of ticks between major labels'
	write (idef,1800) tick_nsub
	write (idef,9998) 'Plot date/time/username under plot'
	write (idef,1900) iden
	write (idef,9998) 'Log. axes flag'
	write (idef,1900) lachse
c
1000	format(32('#'),' KUPLOT Defaults ',31('#'))
1100	format(5(i8,1x))
1400	format(6(g11.5,1x))
1500	format(10(f7.4,1x))
1600	format(10(f7.2,1x))
1700	format(10(f7.0,1x))
1800	format(20(i3,1x))
1900	format(40(l1,1x))
9997	format(10(a1,a,a1,2x))
9998	format('# ',a)
9999	format(a)
	end
c*****7*****************************************************************
	subroutine read_def (idef)
c+
c 	This routine reads defaults from a file
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*80	cdummy
	integer		idef,i1,i2,i3,i4,i5
c
	read (idef,1,err=98,end=99) cdummy
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) i1,i2,i3,i4,i5
c
c------ Check is file has correct array sizes
c
	if (i1.ne.MAXKURVTOT .or. i2.ne.MAXFRAME .or.
     &	    i3.ne.MAXBOND    .or. i4.ne.MAXHL    .or.
     &	    i5.ne.MAXWIN                             ) then
	  ier_num = -36
	  ier_typ = ER_APPL
	  return
	endif
c
c------ All seems ok, so we read the defaults
c
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) titel
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) achse
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) ibuf
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) ibox
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) igrid
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) orient
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) sizemark
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) linewid
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) ilinecol
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) imarkcol
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) ilinetyp
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) imarktyp
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) ilineart
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) imarkmax
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) ierr
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) frame
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) frback
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) fonsize
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) fonscal
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) fon_id
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) foncol
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) frjust
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) ifname
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) tot_frame
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) iho
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) z_min
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) z_inc
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) hlinecol
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) hlinetyp
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) hlineart
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) hlabel
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) exclude9999
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) bond_rad
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) bond_sig
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) bond_lwid
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) bond_lcol
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) bond_ltyp
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) colour
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) dev_sf
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) ierrcol
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) anangle
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) ifillcol
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) ifilltyp
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) fillrange
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) lab_angle
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) lab_d
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) ax_d
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) tick_ma_h
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) tick_mi_h
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) tick_nsub
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) iden
	read (idef,1,err=98,end=99) cdummy
	read (idef,*,err=98,end=99) lachse
c
	return
c
98	continue
	ier_num = -3
	ier_typ = ER_IO
	return
c
99	continue
	ier_num = -6
	ier_typ = ER_IO
	return
c
1	format (a)
	end
c*****7*****************************************************************
	subroutine auto_def
c+
c	If the default setup file is there load it ..
c-
	implicit	none
c
	integer		idef
c
	include		'prompt.inc'
	include		'envir.inc'
	include		'errlist.inc'
c
	idef    = 33
	ier_num = 0
	ier_typ = ER_NONE
c
	call open_def(idef)
	if(ier_num.eq.0) then
	  write (output_io,1000) deffile
	  call read_def (idef)
	else
	  write (output_io,*)
	  ier_num = 0
	  ier_typ = ER_NONE
	endif
	close (idef)
c
1000    format (1x,'Reading defaults : ',a)
	end
