 	subroutine do_calc (zeile,lp)
c*****7*****************************************************************
c
c	These routines perform data manipulation - which is much
c	faster than using the build in interpreter - but less
c	flexible ..
c
c	Version : 4.1
c	Date    : 04. August 2000
c
c	Author  : Th. Proffen  (tproffen@lanl.gov )
c
c*****7*****************************************************************
c
	implicit	none
c
	integer		maxw
	parameter	(maxw=4)
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	character*3	oper
	character*2	unt
	real		werte(maxw)
	integer		lpara(maxw),lp
	integer		ianz,ilen,ik
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.lt.3 .or. ianz.gt.4) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	oper = cpara(1)(1:3)
	unt  = cpara(2)(1:2)
	call do_cap(oper)
	call do_cap(unt)
c
	call del_params(2,ianz,cpara,lpara,maxw)
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ier_num.ne.0) return
c
	ik=nint(werte(1))
	if (ik.gt.0 .and. ik.lt.iz) then
	  ilen=len(ik)
	  if     (unt.eq.'WX') then
     	    if (lni(ik)) ilen=nx(ik)
	    call calc_xy ( x,ilen,ik,oper,werte,maxw,ianz)
	    if (ier_num.ne.0) return
	    call get_extrema_xy (x,ik,ilen,xmin,xmax)
	    call show_data (ik)
	  elseif (unt.eq.'WY') then
     	    if (lni(ik)) ilen=ny(ik)
	    call calc_xy ( y,ilen,ik,oper,werte,maxw,ianz)
	    if (ier_num.ne.0) return
	    call get_extrema_xy (y,ik,ilen,ymin,ymax)
	    call show_data (ik)
	  elseif (unt.eq.'DX') then
	    call calc_xy (dx,len(ik),ik,oper,werte,maxw,ianz)
	  elseif (unt.eq.'DY') then
	    call calc_xy (dy,len(ik),ik,oper,werte,maxw,ianz)
	  elseif (unt.eq.'WZ') then
	    if (lni(ik)) then
	      call calc_z  (z,nx(ik),ny(ik),ik,oper,werte,maxw,ianz)
	      if (ier_num.ne.0) return
	      call get_extrema_z (z,ik,nx(ik),ny(ik),zmin,zmax)
	      call show_data (ik)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -4
	  ier_typ = ER_APPL
	endif		  
c
	end
c*****7*****************************************************************
	subroutine calc_xy (a,ilen,ik,op,werte,maxw,ianz)
c+
c	berechnungen fuer x und y feld
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	op
	integer		ilen,ik,ianz,maxw,i
	real	   	werte(maxw),a(maxarray)
	real		summand,faktor
c
	if     (op.eq.'INV') then
	  do i=1,ilen
	    if (a(offxy(ik-1)+i).ne.0.0) then
	      a(offxy(ik-1)+i) = 1.0/a(offxy(ik-1)+i)
	    else
	      a(offxy(ik-1)+i) = 0.0
	    endif
	  enddo	
	elseif (op.eq.'LOG') then
	  do i=1,ilen
	    if (a(offxy(ik-1)+i).gt.0.0) then
	      a(offxy(ik-1)+i) = log(a(offxy(ik-1)+i))
	    else
	      a(offxy(ik-1)+i) = 0.0
	    endif
	  enddo	
	elseif (op.eq.'EXP') then
	  do i=1,ilen
	    a(offxy(ik-1)+i) = exp(a(offxy(ik-1)+i))
	  enddo	
	elseif (op.eq.'SQU') then
	  do i=1,ilen
	    a(offxy(ik-1)+i) = a(offxy(ik-1)+i)*a(offxy(ik-1)+i)
	  enddo	
	elseif (op.eq.'SQR') then
	  do i=1,ilen
	    if (a(offxy(ik-1)+i).ge.0.0) then
	      a(offxy(ik-1)+i) = sqrt (a(offxy(ik-1)+i))
	    else
	      a(offxy(ik-1)+i) = 0.0
	    endif
	  enddo	
	elseif (op.eq.'ADD') then
	  summand=0.0
	  if (ianz.eq.2) summand=werte(2)
	  do i=1,ilen
	    a(offxy(ik-1)+i) = a(offxy(ik-1)+i)+summand
	  enddo	
	elseif (op.eq.'MUL') then
	  faktor=1.0
	  if (ianz.eq.2) faktor=werte(2)
	  do i=1,ilen
	    a(offxy(ik-1)+i) = a(offxy(ik-1)+i)*faktor
	  enddo	
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine calc_z (a,nxx,nyy,ik,op,werte,maxw,ianz)
c+
c	berechnungen fuer z feld
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	op
	integer		nxx,nyy,ik,maxw,ianz,i,j,ikk
	real	   	werte(maxw),a(maxarray)
	real		faktor,summand
c
	if     (op.eq.'INV') then
	  do i=1,nxx
	  do j=1,nyy
	    ikk=offz(ik-1)+(i-1)*ny(ik)+j
	    if (a(ikk).ne.0.0 .and. a(ikk).ne.-9999.0) then
	      a(ikk) = 1.0/a(ikk) 
	    endif
	  enddo	
	  enddo	
	elseif (op.eq.'LOG') then
	  do i=1,nxx
	  do j=1,nyy
	    ikk=offz(ik-1)+(i-1)*ny(ik)+j
	    if (a(ikk).ne.0.0 .and. a(ikk).ne.-9999.0) then
	      a(ikk) = log(a(ikk) )
	    endif
	  enddo	
	  enddo	
	elseif (op.eq.'EXP') then
	  do i=1,nxx
	  do j=1,nyy
	    ikk=offz(ik-1)+(i-1)*ny(ik)+j
	    if (a(ikk).ne.-9999.0) then
	      a(ikk) = exp(a(ikk))
	    endif
	  enddo	
	  enddo	
	elseif (op.eq.'SQU') then
	  do i=1,nxx
	  do j=1,nyy
	    ikk=offz(ik-1)+(i-1)*ny(ik)+j
	    if (a(ikk).ne.-9999.0) then
	      a(ikk) = a(ikk)**2 
	    endif
	  enddo	
	  enddo	
	elseif (op.eq.'SQR') then
	  do i=1,nxx
	  do j=1,nyy
	    ikk=offz(ik-1)+(i-1)*ny(ik)+j
	    if (a(ikk).ge.0.0 .and. a(ikk).ne.-9999.0) then
	      a(ikk) = sqrt(a(ikk))
	    endif
	  enddo	
	  enddo	
	elseif (op.eq.'ADD') then
	  summand=0.0
	  if (ianz.eq.2) summand=werte(2)
	  do i=1,nxx
	  do j=1,nyy
	    ikk=offz(ik-1)+(i-1)*ny(ik)+j
	    if (a(ikk).ne.-9999.0) then
	      a(ikk) = a(ikk)+summand 
	    endif
	  enddo	
	  enddo	
	elseif (op.eq.'MUL') then
	  faktor=1.0
	  if (ianz.eq.2) faktor=werte(2)
	  do i=1,nxx
	  do j=1,nyy
	    ikk=offz(ik-1)+(i-1)*ny(ik)+j
	    if (a(ikk).ne.-9999.0) then
	      a(ikk) = a(ikk)*faktor 
	    endif
	  enddo	
	  enddo	
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
 	subroutine do_exclude (zeile,lp)
c+
c	This routine allows the user to exclude data regions
c	and replace by linear interpolation of end points.
c-
	implicit	none
c
	integer		maxw
	parameter	(maxw=3)
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	real		werte(maxw)
	real		a,b,x1,x2,y1,y2,xleft,xright
	integer		lpara(maxw),lp
	integer		i,ipkt,ianz,ik,ileft,iright
c
	integer		closest_point
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.ne.3) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ier_num.ne.0) return
c
	ik     = nint(werte(1))
	xleft  = werte(2)
	xright = werte(3)
c
	if (ik.gt.0 .and. ik.lt.iz .and. .not.lni(ik)) then
	  ileft  = closest_point(ik,xleft)
	  iright = closest_point(ik,xright)
	  x1     = x(offxy(ik-1)+ileft)
	  y1     = y(offxy(ik-1)+ileft)
	  x2     = x(offxy(ik-1)+iright)
	  y2     = y(offxy(ik-1)+iright)
c
	  if (x2.le.x1) return
c
c-------- region is in the middle
c
	  if (xleft.gt.xmin(ik) .and. xright.lt.xmax(ik)) then
	    a = (y2-y1)/(x2-x1)
	    b = y1 - a*x1
	    do i=1,len(ik)
	      ipkt = offxy(ik-1)+i
	      if (x(ipkt).gt.xleft .and. x(ipkt).lt.xright) then
	        y(ipkt) = a*x(ipkt) + b
	      endif
	    enddo
c
c-------- left is outside
c
	  elseif (xleft.lt.xmin(ik) .and. xright.lt.xmax(ik)) then
	    do i=iright,len(ik)
	      ipkt = offxy(ik-1)+i
	       x(ipkt-iright+1) =  x(ipkt)
	      dx(ipkt-iright+1) = dx(ipkt)
	       y(ipkt-iright+1) =  y(ipkt)
	      dy(ipkt-iright+1) = dy(ipkt)
	    enddo
	    len(ik) = len(ik)-iright+1
	    call get_extrema_xy (x,ik,len,xmin,xmax)
c
c-------- right is outside
c
	  elseif (xleft.gt.xmin(ik) .and. xright.gt.xmax(ik)) then
	    len(ik) = ileft
	    call get_extrema_xy (x,ik,len,xmin,xmax)
c
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -4
	  ier_typ = ER_APPL
	endif		  
c
	end
c*****7*******************************************************************
	integer function closest_point(ik,xvalue)
c+
c	Find the point closest to xvalue;
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	integer		i,ik,ipkt,iclose
	real		xdist_old,xdist_new
	real		xvalue,xdist
c
	xdist_old = abs(xvalue-x(offxy(ik-1)+1))
	iclose    = 1
	do i=2,len(ik)
	  ipkt=offxy(ik-1)+i
	  xdist_new = abs(xvalue-x(offxy(ik-1)+i))
	  if (xdist_new.lt.xdist_old) then
	    iclose    = i
	    xdist_old = xdist_new
	  endif
	enddo
c
	closest_point = iclose
c
	end
c*****7*******************************************************************
	subroutine do_kmath (zeile,lp)
c+
c	Arithmetic between complete data sets
c-
	implicit	none
c
	integer		maxw
	parameter	(maxw=4)
	integer         EXCL,NEUT,IGNO
	parameter       (EXCL=0,NEUT=1,IGNO=2)
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	character*3	oper
	real		werte(maxw)
	integer		lpara(maxw),lp,imin
	integer		ianz,ik1,ik2,ikk1,ikk2,ikk3,ix,iy,i,ii
	logical         str_comp
c
c
c------ space left for new data set ??
c
	if (iz.gt.maxkurvtot) then
	  ier_num = -1
	  ier_typ = ER_APPL
	  return
	endif
c
c------ get parameters
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
c------ check arguments
c
	if (ianz.eq.4) then
	  if(str_comp(cpara(4),'excl',2,lpara(4),4)) then
	    exclude9999 = EXCL
	  elseif(str_comp(cpara(4),'neut',2,lpara(4),4)) then
	    exclude9999 = NEUT
	  elseif(str_comp(cpara(4),'igno',2,lpara(4),4)) then
	    exclude9999 = IGNO
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	    return
	  endif
	  ianz = 3
	elseif (ianz.eq.3) then
	  exclude9999 = EXCL
	endif
c
	if (ianz.ne.3) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	oper = cpara(1)(1:3)
	call do_cap(oper)
	if (oper.ne.'ADD' .and. oper.ne.'MUL' .and.
     &	    oper.ne.'SUB' .and. oper.ne.'DIV'      ) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	call del_params(1,ianz,cpara,lpara,maxw)
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ier_num.ne.0) return
c
	ik1=nint(werte(1))
	ik2=nint(werte(2))
c
	if (ik1.lt.1 .or. ik1.gt.(iz-1) .or.
     &	    ik2.lt.1 .or. ik2.gt.(iz-1)    ) then
	  ier_num = -4
	  ier_typ = ER_APPL
	  return
	endif
c
c------ if we have a 3d data set
c
	if    (lni(ik1)             .and. 
     &	       lni(ik2)             .and. 
     &	       (nx(ik1).eq.nx(ik2)) .and.
     &	       (ny(ik1).eq.ny(ik2)))     then
	  do ix=1,nx(ik1)
	    do iy=1,ny(ik1)
	      ikk1=offz(ik1-1)+(ix-1)*ny(ik1)+iy
	      ikk2=offz(ik2-1)+(ix-1)*ny(ik1)+iy
	      ikk3=offz(iz -1)+(ix-1)*ny(ik1)+iy
	      if(exclude9999.eq.EXCL ) then
	        if (z(ikk1).eq.-9999. .or. z(ikk2).eq.-9999.) then
	          z(ikk3)=-9999.0
	        else
	          if (oper.eq.'MUL') z(ikk3)=z(ikk1)*z(ikk2)
	          if (oper.eq.'SUB') z(ikk3)=z(ikk1)-z(ikk2)
	          if (oper.eq.'ADD') z(ikk3)=z(ikk1)+z(ikk2)
	          if (oper.eq.'DIV') then
	            if (z(ikk3).ne.0.0) then
	              z(ikk3)=z(ikk1)/z(ikk2)
	            else
	              z(ikk3) = 0.0
	            endif
	          endif
	        endif
	      elseif(exclude9999.eq.NEUT) then
	        if (z(ikk1).eq.-9999. .and. z(ikk2).eq.-9999.) then
	          z(ikk3)=-9999.0
	        elseif(z(ikk1).eq.-9999. ) then
	          z(ikk3)=z(ikk2)
	        elseif(z(ikk2).eq.-9999. ) then
	          z(ikk3)=z(ikk1)
	        else
	          if (oper.eq.'MUL') z(ikk3)=z(ikk1)*z(ikk2)
	          if (oper.eq.'SUB') z(ikk3)=z(ikk1)-z(ikk2)
	          if (oper.eq.'ADD') z(ikk3)=z(ikk1)+z(ikk2)
	          if (oper.eq.'DIV') then
	            if (z(ikk3).ne.0.0) then
	              z(ikk3)=z(ikk1)/z(ikk2)
	            else
	              z(ikk3) = 0.0
	            endif
	          endif
	        endif
	      elseif(exclude9999.eq.IGNO) then
	        if (oper.eq.'MUL') z(ikk3)=z(ikk1)*z(ikk2)
	        if (oper.eq.'SUB') z(ikk3)=z(ikk1)-z(ikk2)
	        if (oper.eq.'ADD') z(ikk3)=z(ikk1)+z(ikk2)
	        if (oper.eq.'DIV') then
	          if (z(ikk3).ne.0.0) then
	            z(ikk3)=z(ikk1)/z(ikk2)
	          else
	            z(ikk3) = 0.0
	          endif
	        endif
	      endif
	    enddo
	  enddo
	  do i=1,nx(ik1)
	    x(offxy(iz-1)+i)=x(offxy(ik1-1)+i)
	  enddo
	  do i=1,ny(ik1)
	    y(offxy(iz-1)+i)=y(offxy(ik1-1)+i)
	  enddo
	  nx(iz)    = nx(ik1)
	  ny(iz)    = ny(ik1)
	  len(iz)   = len(ik1)
	  lni(iz)   = .true.
	  fname(iz) = 'result.dat'
	  fform(iz) = fform(ik1)
	  offxy(iz) = offxy(iz-1) + len(iz)
	  offz(iz)  = offz(iz-1) + nx(ik1)*ny(ik1)
	  iz        = iz+1
	  call get_extrema_xy (x,iz-1,nx(iz),xmin,xmax)
	  call get_extrema_xy (y,iz-1,ny(iz),ymin,ymax)
	  call get_extrema_z  (z,iz-1,nx(iz),ny(iz),zmin,zmax)
	  call show_data (iz-1)
c
c------ here for a 2d data set
c
	elseif (.not.lni(ik1) .and. .not.lni(ik2)) then
          imin = min(len(ik1),len(ik2))
	  do ii=1,imin
	    ikk1=offxy(ik1-1)+ii
	    ikk2=offxy(ik2-1)+ii
	    ikk3=offxy(iz -1)+ii
	    x(ikk3)=x(ikk1)
	    if(oper.eq.'MUL') then
	       y(ikk3)= y(ikk1)*y(ikk2)
	      dy(ikk3)=sqrt((y(ikk1)*dy(ikk2))**2 + 
     &	                    (y(ikk2)*dy(ikk1))**2)
	    elseif(oper.eq.'ADD') then
	       y(ikk3)=y(ikk1)+y(ikk2)
	      dy(ikk3)=sqrt(dy(ikk1)**2 + dy(ikk2)**2)
	    elseif(oper.eq.'SUB') then
	       y(ikk3)=y(ikk1)-y(ikk2)
	      dy(ikk3)=sqrt(dy(ikk1)**2 + dy(ikk2)**2)
	    elseif(oper.eq.'DIV') then
	      if (y(ikk2).ne.0.0) then
	         y(ikk3)=y(ikk1)/y(ikk2)
	        dy(ikk3)=sqrt((dy(ikk1)/y(ikk2))**2        + 
     &	                      (dy(ikk2)*y(ikk1)/y(ikk2)**2)**2)
	      else
	        y(ikk3) = 0.0
	      endif
	    endif
	  enddo
	  len(iz)   = imin
	  fform(iz) = fform(ik1)
	  fname(iz) = 'result.dat'
	  offxy(iz) = offxy(iz-1) + len(iz)
	  iz        = iz+1
	  call get_extrema_xy (x,iz-1,len(iz),xmin,xmax)
	  call get_extrema_xy (y,iz-1,len(iz),ymin,ymax)
	  call show_data (iz-1)
c
c------ incompatible data sets
c
	else
	  ier_num = -23
	  ier_typ = ER_APPL
	endif
c
	end	  
c*****7*******************************************************************
	subroutine do_merge (zeile,lp)
c+
c	Merge different data sets
c-
	implicit	none
c
	integer		maxw
	parameter	(maxw=25)
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	real		werte(maxw)
	real		mdelta,mmin,mmax
	integer		lpara(maxw),lp
	integer		ianz,ik,ibin,i,ip,ntot,maxpp
	logical		lvalid,ladd
c
	logical         str_comp
c
c------ space left for new data set ??
c
	if (iz.gt.maxkurvtot) then
	  ier_num = -1
	  ier_typ = ER_APPL
	  return
	endif
c
c------ get parameters
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
c------ check arguments
c
	if (ianz.lt.2) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	ladd = str_comp(cpara(ianz),'add',1,lpara(ianz),3)
	if (ladd) ianz=ianz-1
c
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ier_num.ne.0) return
c
	lvalid = .true.
	do i=1,ianz
	  ik = nint(werte(i))
	  lvalid = lvalid .and. ik.ge.1 .and. ik.lt.iz 
     &	                  .and. .not.lni(ik)
	enddo
	if (.not. lvalid) then
	  ier_num = -4
	  ier_typ = ER_APPL
	  return
	endif
c
c------ First we get extend of new data set (first one defines DELTA)
c
	ik = nint(werte(1))
	mdelta = x(offxy(ik-1)+len(ik)) - x(offxy(ik-1)+1)
	mdelta = mdelta / float(len(ik)-1)
	mmin   = xmin(nint(werte(1)))
	mmax   = xmax(nint(werte(1)))
	do i=2,ianz
	  ik   = nint(werte(i))
	  mmax = max(mmax,xmax(ik))
	  mmin = min(mmin,xmin(ik))
	enddo
c
	maxpp = maxarray-offxy(iz-1)
	ntot  = nint((mmax-mmin)/mdelta)+1
c
	if (ntot.gt.maxpp) then
	  ier_num = -6
	  ier_typ = ER_APPL
	  return
	endif
c
c------ Now we merge the data one by one ...
c
	do i=1,ntot
	  ibin = offxy(iz-1)+i
	   x(ibin) = 0.0
	   y(ibin) = 0.0
	  dx(ibin) = 0.0
	  dy(ibin) = 0.0
	enddo
c
	do i=1,ianz
	  ik = nint(werte(i))
	  do ip=1,len(ik)
	    ibin = offxy(iz-1) + 
     &	           nint((x(offxy(ik-1)+ip)-mmin)/mdelta)+1
	     y(ibin) =  y(ibin) +  y(offxy(ik-1)+ip)
	    dy(ibin) = dy(ibin) + dy(offxy(ik-1)+ip)**2
	    dx(ibin) = dx(ibin) + 1.0
	  enddo
	enddo 
c
	do i=1,ntot
	  ibin = offxy(iz-1)+i
	  if (.not.ladd .and. dx(ibin).gt.0.0) then
      	     y(ibin) = y(ibin)/dx(ibin)
      	    dy(ibin) = sqrt(dy(ibin))/dx(ibin)
	  endif
	  x (ibin) = mmin + (i-1)*mdelta
	  dx(ibin) = 0.0
	enddo
c
	len(iz)   = ntot
	fform(iz) = fform(nint(werte(1)))
	fname(iz) = 'merge.dat'
	offxy(iz) = offxy(iz-1) + len(iz)
	iz        = iz+1
	call get_extrema_xy (x,iz-1,len(iz),xmin,xmax)
	call get_extrema_xy (y,iz-1,len(iz),ymin,ymax)
	call show_data (iz-1)
c
	end
c*****7*******************************************************************
	subroutine do_rebin (zeile,lp)
c+
c	Rebin data to given grid (only 2D - otherwise save/read GNU)
c-
	implicit	none
c
	integer		maxw
	parameter	(maxw=25)
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	real		werte(maxw),bdelta,fraction
	integer		lpara(maxw),lp,maxpp,ntot
	integer		ianz,ik,ibin,jbin,ip,i,j,k,iupper,iubin
c
c------ space left for new data set ??
c
	if (iz.gt.maxkurvtot) then
	  ier_num = -1
	  ier_typ = ER_APPL
	  return
	endif
c
c------ get parameters
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
c------ check arguments
c
	if (ianz.ne.2) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ier_num.ne.0) return
c
	ik     = nint(werte(1))
	bdelta = werte(2)
c
	if (ik.lt.1 .or. ik.gt.iz .or. lni(ik)) then
	  ier_num = -4
	  ier_typ = ER_APPL
	  return
	endif
c
	maxpp = maxarray-offxy(iz-1)
	ntot  = nint((xmax(ik)-xmin(ik))/bdelta)+1
c
	if (ntot.gt.maxpp) then
	  ier_num = -6
	  ier_typ = ER_APPL
	  return
	endif
c
c------ Now we rebin the data
c
	do i=1,ntot
	  ibin = offxy(iz-1)+i
	   x(ibin) = 0.0
	   y(ibin) = 0.0
	  dx(ibin) = 0.0
	  dy(ibin) = 0.0
	enddo
c
c------ Find closest bin and add data point to it
c
	do ip=1,len(ik)
	  ibin = offxy(iz-1) + 
     &	         nint((x(offxy(ik-1)+ip)-xmin(ik))/bdelta)+1
	   y(ibin) =  y(ibin) +  y(offxy(ik-1)+ip)
	  dy(ibin) = dy(ibin) + dy(offxy(ik-1)+ip)**2
	  dx(ibin) = dx(ibin) + 1.0
	enddo 
c
c------ Normalize new data points
c
	do i=1,ntot
	  ibin = offxy(iz-1)+i
	  if (dx(ibin).gt.0.0) then
      	     y(ibin) = y(ibin)/dx(ibin)
      	    dy(ibin) = sqrt(dy(ibin))/dx(ibin)
	  endif
	enddo
c
c------ Set x arrays
c
	do i=1,ntot
	  ibin    = offxy(iz-1)+i
	  x(ibin) = xmin(ik) + (i-1)*bdelta
	enddo
c
c------ Find empty bins and assign average value from neighbours
c------ needs to be done
c
	do i=2,ntot-1
	  ibin = offxy(iz-1)+i
	  if (dx(ibin).eq.0.0) then
	    iupper = 0
	    do k=i+1,ntot
	      jbin = offxy(iz-1)+k
	      if (dx(jbin).gt.0.0) then
	         iupper = k
	         goto 71
	      endif
	    enddo
71	    continue
	    iubin = offxy(iz-1)+iupper
	    fraction = (y(iubin)-y(ibin-1)) / (x(iubin)-x(ibin-1))
	    do j=i, iupper-1
	      jbin = offxy(iz-1)+j
	      y(jbin)  = y(ibin-1)+fraction*(x(jbin)-x(ibin-1))
	      dy(jbin) = dy(ibin-1)
	      dx(jbin) = 1.0
	    enddo
	  endif
	enddo
c
c------ Set dx arrays
c
	do i=1,ntot
	  ibin     = offxy(iz-1)+i
	  dx(ibin) = 0.0
	enddo
c
	len(iz)   = ntot
	fform(iz) = fform(ik)
	fname(iz) = 'rebin.dat'
	offxy(iz) = offxy(iz-1) + len(iz)
	iz        = iz+1
	call get_extrema_xy (x,iz-1,len(iz),xmin,xmax)
	call get_extrema_xy (y,iz-1,len(iz),ymin,ymax)
	call show_data (iz-1)
c
	end
c*****7*******************************************************************
	subroutine do_interpolate (zeile,lp)
c+
c	Interpolate data set <ik> on grid of <ig> using spline
c-
	implicit	none
c
	integer		maxw
	parameter	(maxw=2)
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	real		werte(maxw),yyy
	real		xpl(maxarray),ypl(maxarray)
	real		y2a(maxarray)
	integer		lpara(maxw),lp,maxpp,ntot
	integer		ianz,ibin,igg,ik,ig,i
c
c------ space left for new data set ??
c
	if (iz.gt.maxkurvtot) then
	  ier_num = -1
	  ier_typ = ER_APPL
	  return
	endif
c
c------ get parameters
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
c------ check arguments
c
	if (ianz.ne.2) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ier_num.ne.0) return
c
	ik     = nint(werte(1))
	ig     = nint(werte(2))
c
	if (ik.lt.1 .or. ik.gt.iz .or. lni(ik) .or.
     &	    ig.lt.1 .or. ig.gt.iz .or. lni(ig) .or. ik.eq.ig) then
	  ier_num = -4
	  ier_typ = ER_APPL
	  return
	endif
c
	maxpp = maxarray-offxy(iz-1)
	ntot  = len(ig)
c
	if (ntot.gt.maxpp) then
	  ier_num = -6
	  ier_typ = ER_APPL
	  return
	endif
c
c------ Now we interpolate the data
c
	do i=1,len(ik)
	  xpl(i)=x(offxy(ik-1)+i)
	  ypl(i)=y(offxy(ik-1)+i)
	enddo
c
	call spline (xpl,ypl,len(ik),1e30,1e30,y2a)
c
	do i=1,ntot
	  ibin = offxy(iz-1)+i
	  igg  = offxy(ig-1)+i
          call splint (xpl,ypl,y2a,len(ik),x(igg),yyy)
c
	   x(ibin) = x(igg)
	   y(ibin) = yyy
	  dx(ibin) = 0.0
	  dy(ibin) = 0.0
	enddo
c
	len(iz)   = ntot
	fform(iz) = fform(ig)
	fname(iz) = 'interpolate.dat'
	offxy(iz) = offxy(iz-1) + len(iz)
	iz        = iz+1
	call get_extrema_xy (x,iz-1,len(iz),xmin,xmax)
	call get_extrema_xy (y,iz-1,len(iz),ymin,ymax)
	call show_data (iz-1)
c
	end
c*****7*******************************************************************
	subroutine do_convolute (zeile,lp)
c+
c	Convoluting two data sets
c-
	implicit	none
c
	integer		maxw
	parameter	(maxw=2)
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	real		werte(maxw)
	real		dr1,dr2,ysum,start,eps
	integer		lpara(maxw),lp,maxpp
	integer		ianz,ik1,ik2,ii,i,j
c
c------ space left for new data set ??
c
	if (iz.gt.maxkurvtot) then
	  ier_num = -1
	  ier_typ = ER_APPL
	  return
	endif
c
c------ get parameters
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
c------ check arguments
c
	if (ianz.ne.2) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ier_num.ne.0) return
c
	ik1 = nint(werte(1))
	ik2 = nint(werte(2))
c
	if (ik1.lt.1 .or. ik1.gt.iz .or. lni(ik1) .or.
     &	    ik2.lt.1 .or. ik2.gt.iz .or. lni(ik2) .or.
     &      ik1.eq.ik2                                ) then
	  ier_num = -4
	  ier_typ = ER_APPL
	  return
	endif
c
	dr1 = (xmax(ik1)-xmin(ik1))/float(len(ik1)-1)
	dr2 = (xmax(ik2)-xmin(ik2))/float(len(ik2)-1)
c
	if (abs(dr1-dr2).gt.1e-8) then
	  ier_num = -45
	  ier_typ = ER_APPL
	endif
c
	maxpp = maxarray-offxy(iz-1)
	if (len(ik1).gt.maxpp) then
	  ier_num = -6
	  ier_typ = ER_APPL
	endif
	if (ier_num.ne.0) return
c
c------ Now do convolution
c
	start = x(offxy(ik2-1)+1)
c
	do i=1,len(ik1)
	  ysum = 0.0
	  do j=1,len(ik1)
	    ii = (i-j) - nint(start/dr1) + 1
	    if (ii.ge.1 .and. ii.le.len(ik2)) then
	      ysum = ysum + y(offxy(ik1-1)+j)*y(offxy(ik2-1)+ii)
	    endif
	  enddo
c
	  x(offxy(iz-1)+i) = x(offxy(ik1-1)+i)
	  y(offxy(iz-1)+i) = ysum * dr1
c
	  dx(offxy(iz-1)+i) = 0.0
	  dy(offxy(iz-1)+i) = 0.0
	enddo
c
c------ Do other settings
c
	len(iz)   = len(ik1)
	fform(iz) = fform(ik1)
	fname(iz) = 'convolute.dat'
	offxy(iz) = offxy(iz-1) + len(iz)
	iz        = iz+1
	call get_extrema_xy (x,iz-1,len(iz),xmin,xmax)
	call get_extrema_xy (y,iz-1,len(iz),ymin,ymax)
	call show_data (iz-1)
c
	end
c*****7*******************************************************************
	subroutine do_derivative (zeile,lp)
c+
c	Calculate n-th derivative of given data set.
c-
	implicit	none
c
	integer		maxw,maxsm
c
	parameter	(maxw=2)
	parameter	(maxsm=51)
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	real		werte(maxw)
	real		cc(maxsm)
	real		deltax,fnorm
	integer		lpara(maxw),lp
	integer		ianz,i,ik,id,ip,im,inew,iold,maxpp
c
c------ space left for new data set ??
c
	if (iz.gt.maxkurvtot) then
	  ier_num = -1
	  ier_typ = ER_APPL
	  return
	endif
c
c------ get parameters
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
c------ check arguments
c
	if (ianz.ne.1 .and. ianz.ne.2) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ier_num.ne.0) return
c
	id = 1
	ik = nint(werte(1))
	if (ianz.eq.2) id = nint(werte(2))
c
	if (id.lt.1 .or. id.gt.4) then
	  ier_num = -40
	  ier_typ = ER_APPL
	  return
	endif
c
	if (ik.lt.1 .or. ik.gt.iz .or. lni(ik)) then
	  ier_num = -4
	  ier_typ = ER_APPL
	  return
	endif
c
	maxpp = maxarray-offxy(iz-1)
	if (len(ik).gt.maxpp) then
	  ier_num = -6
	  ier_typ = ER_APPL
	  return
	endif
c
	write (*,1000) id,ik
1000	format (1x,'------ > Calculating derivative ',i2,
     &	           ' for data set ',i3,' ...')
c
c------ Some setup
c
	im=6
	ip=2*im + 1
c
c------ First we copy the data to new data set
c
	len(iz)   = len(ik)
	fform(iz) = fform(ik)
	fname(iz) = 'deriv.dat'
c
	do i=1,len(ik)
	  inew = offxy(iz-1)+i
	  iold = offxy(ik-1)+i
	   x(inew) =  x(iold)
	   y(inew) =  y(iold)
	  dx(inew) = dx(iold)
	  dy(inew) = dy(iold)
	enddo
c
c------ Set up smoothing to return derivative
c
	call SAVGOL(cc,ip,ip/2,ip/2,id,im)
	if (ier_num.ne.0) return
	call do_glatt_y (iz,ip,len(iz),cc,maxsm,.true.)
	if (ier_num.ne.0) return
c
c------ Divide by the step size
c
	call get_extrema_xy (x,iz,len(iz),xmin,xmax)
	deltax = (xmax(iz)-xmin(iz))/float(len(iz)-1)
c
	fnorm  = 1.0
	do i=2,id
	  fnorm = fnorm*float(i)
	enddo
c
	fnorm  = deltax**id / fnorm
c
	do i=1+im,len(iz)-im
	  inew = offxy(iz-1)+i-im
	  iold = offxy(iz-1)+i
	   x(inew) =  x(iold)
	   y(inew) =  y(iold) / fnorm
	  dx(inew) = dx(iold)
	  dy(inew) = dy(iold)
	enddo
c
	len(iz)   = len(iz) - 2*im
	offxy(iz) = offxy(iz-1) + len(iz)
c
c------ Finish off
c
	iz = iz+1
c
	call get_extrema_xy (y,iz-1,len(iz-1),ymin,ymax)
	call show_data (iz-1)
c
	end
c*****7*******************************************************************
	subroutine do_match (zeile,lp)
c+
c	Calculates scaling and offset to give best match between
c	two data sets.
c-
	implicit	none
c
	integer		maxw
	parameter	(maxw=25)
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	real		werte(maxw)
	real		sk,ba,wtot,ee,cc,ce,c,e,wi
	integer		lpara(maxw),lp
	integer		ianz,iko,ikc,ikko,ikkc,ip
	logical		lback,lskal,lmix
c
	logical		str_comp
c
c------ get parameters
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
c------ check arguments
c
	if (ianz.lt.3) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
c------ Getting arguments
c
	lskal = str_comp(cpara(1),'scal',  1,lpara(1),4) .or.
     &	        str_comp(cpara(1),'all',   1,lpara(1),3)
	lback = str_comp(cpara(1),'offset',1,lpara(1),6) .or.
     &	        str_comp(cpara(1),'all',   1,lpara(1),3)
	lmix  = str_comp(cpara(1),'mix'   ,1,lpara(1),3)
c
	if (lmix) then 
	  call do_match_mix(ianz,cpara,lpara,maxw)
	  return
	endif
c	
	call del_params(1,ianz,cpara,lpara,maxw)
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ier_num.ne.0) return
c
	iko = nint(werte(1))
	ikc = nint(werte(2))
c
	if (iko.lt.1 .or. iko.gt.iz .or. lni(iko) .or.
     &	    ikc.lt.1 .or. ikc.gt.iz .or. lni(ikc) .or.
     &	    iko.eq.ikc                                ) then
	  ier_num = -4
	  ier_typ = ER_APPL
	  return
	endif
c
c------ Now we calculate scale and offset
c
	wtot = 0.0
	e    = 0.0
	c    = 0.0
	ee   = 0.0
	cc   = 0.0
	ce   = 0.0
c
	wi   = 1.0
c
	do ip=1,len(ikc)
	  ikko = offxy(iko-1)+ip
	  ikkc = offxy(ikc-1)+ip
	  wtot = wtot+wi
	  e    = e +wi*y(ikko)
	  ee   = ee+wi*y(ikko)**2
       	  c    = c +wi*y(ikkc)
	  cc   = cc+wi*y(ikkc)**2
       	  ce   = ce+wi*y(ikkc)*y(ikko)
	enddo 
c
	if (lskal .and. lback) then
	  sk = (wtot*ce - e*c) / (wtot*cc - c*c)
	  ba = (e-sk*c) / wtot
       	elseif (lskal .and. .not. lback) then
	  sk = ce / cc
	  ba = 0.0
	elseif (.not. lskal .and. lback) then
	  sk = 1.0
	  ba = (e-c) / wtot
	else
	  sk = 1.0
	  ba = 0.0
	endif                         
c
	write (output_io,1000) sk,ba
c
c------ Modifying data set ikc
c
	do ip=1,len(ikc)
	  ikkc = offxy(ikc-1)+ip
	  y(ikkc) = sk*y(ikkc)+ba
	enddo
c
	call get_extrema_xy (x,ikc,len(ikc),xmin,xmax)
	call get_extrema_xy (y,ikc,len(ikc),ymin,ymax)
	call show_data (ikc)
c
1000	format (' ------ > Scale = ',g12.5,' Offset = ',g12.5,/)
c
	end
c*****7*******************************************************************
	subroutine do_match_mix(ianz,cpara,lpara,maxw)
c+
c	Calculates fraction to match x*data_1 + (1-x)*data_2
c	to given data set.
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
c
	character*(*)	cpara(maxw)
	real		werte(maxw)
	integer		lpara(maxw),ianz
c
	real		a,b,aa,bb,ab,ao,bo,fra
	integer		ip,iko,ik1,ik2,iik,ii1,ii2,iio
c
	integer		len_str
c	
c------ space left for new data set ??
c
	if (iz.gt.maxkurvtot) then
	  ier_num = -1
	  ier_typ = ER_APPL
	  return
	endif
c
	call del_params(1,ianz,cpara,lpara,maxw)
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ier_num.ne.0) return
c
	if (ianz.ne.3) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	iko = nint(werte(1))
	ik1 = nint(werte(2))
	ik2 = nint(werte(3))
c
	if (iko.lt.1 .or. iko.gt.iz .or. lni(iko) .or.
     &	    ik1.lt.1 .or. ik1.gt.iz .or. lni(ik1) .or.
     &	    ik2.lt.1 .or. ik2.gt.iz .or. lni(ik2) .or.
     &	    iko.eq.ik1 .or. iko.eq.ik2 .or. ik1.eq.ik2) then
	  ier_num = -4
	  ier_typ = ER_APPL
	  return
	endif
c
	if (len(iko).ne.len(ik1)   .or. 
     &	    len(iko).ne.len(ik2)   .or. 
     &	    len(ik1).ne.len(ik2)   .or. 
     &      xmin(ik1).ne.xmin(iko) .or. 
     &	    xmin(ik2).ne.xmin(iko) .or.
     &	    xmin(ik1).ne.xmin(ik2) .or.
     &      xmax(ik1).ne.xmax(iko) .or. 
     &	    xmax(ik2).ne.xmax(iko) .or.
     &	    xmax(ik1).ne.xmax(ik2)     ) then
	  ier_num = -44
	  ier_typ = ER_APPL
	  return
	endif
c
c------ Now we calculate mixing fraction
c
	a  = 0.0
	b  = 0.0
	ao = 0.0
	bo = 0.0
	ab = 0.0
c
	do ip=1,len(iko)
	  iik = offxy(iz-1)+ip
	  ii1 = offxy(ik1-1)+ip
	  ii2 = offxy(ik2-1)+ip
	  iio = offxy(iko-1)+ip
c
	  a  = a  + y(ii1)
	  b  = b  + y(ii2)
	  aa = aa + y(ii1)**2
	  bb = bb + y(ii2)**2
	  ao = ao + y(ii1)*y(iio)
	  bo = bo + y(ii2)*y(iio)
	  ab = ab + y(ii1)*y(ii2)
	enddo
c
	fra = (bb + ao - ab - bo) / (aa - 2.0*ab + bb)
c
	write (output_io,1000) fra,fname(ik1)(1:len_str(fname(ik1))),
     &	                 (1.0-fra),fname(ik2)(1:len_str(fname(ik2)))
c
c------ Create new data set
c
	do ip=1,len(iko)
	  iik = offxy(iz-1)+ip
	  ii1 = offxy(ik1-1)+ip
	  ii2 = offxy(ik2-1)+ip
	  iio = offxy(iko-1)+ip
	  x(iik) = x(iio)
	  y(iik) = fra*y(ii1) + (1.0-fra)*y(ii2)
	enddo
c
	len(iz)   = len(iko)
	fform(iz) = fform(iko)
	fname(iz) = 'mix.dat'
	offxy(iz) = offxy(iz-1) + len(iz)
	iz        = iz+1
	call get_extrema_xy (x,iz-1,len(iz),xmin,xmax)
	call get_extrema_xy (y,iz-1,len(iz),ymin,ymax)
	call show_data (iz-1)
c
1000	format (' ------ > Mix = ',f12.5,' * ',a,' + ',
     &	                   f12.5,' * ',a/)
c
	end
