c******7****************************************************************
c
c	Here are menu and mouse related commands
c
c	Version : 1.2
c	Date    : 21 April 2000
c
c	Author  : Th. Proffen  (tproffen@lanl.gov )
c
c******7****************************************************************
	subroutine do_mouse(zeile,lp)
c+
c	Mouse command ..
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=4)
c
	character*(*)	zeile
	integer		lp
c
	character*200	cpara(maxw)
	integer		lpara(maxw),ianz
	real		werte(maxw)
c
	logical		str_comp
c
	call get_params(zeile,ianz,cpara,lpara,maxw,-lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  lgui(iwin) = .true.
	  call do_menu
	  lgui(iwin) = .false.
	else
	  if (str_comp(cpara(1),'point',1,lpara(1),5)) then
	    call do_koor_nogui
	  elseif (str_comp(cpara(1),'line',1,lpara(1),4)) then
	    call do_region_nogui(1)
	  elseif (str_comp(cpara(1),'rect',1,lpara(1),4)) then
	    call do_region_nogui(2)
	  elseif (str_comp(cpara(1),'yrange',1,lpara(1),6)) then
	    call do_region_nogui(3)
	  elseif (str_comp(cpara(1),'xrange',1,lpara(1),6)) then
	    call do_region_nogui(4)
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	endif
c
	end
c******7****************************************************************
	subroutine do_menu
c
c	Activate KUPLOT menu
c
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'learn.inc'
	include		'errlist.inc'
c
	character*1	ch
	real		xb,xt,yt,mx,my
	integer		ini
	logical		lw,lend
c
	logical		hit_button,n_in_f
c
	lw = .true.
c
	call do_plot (.true.)
	if (ier_num.ne.0) return
	if (iaf(iwin).gt.1) call border_frame(iframe,1,0.02)
c
	write (output_io,1000)
c
c------ Here is the menu input loop
c
10	continue
	  call frame_menu
	  call PGCURS (mx,my,ch)
	  if (ch.eq.butt_l) then
c
c------ --- Exit selected
c
	    if (hit_button(1,mx,my)) then
	      call do_plot (.false.)
	      if (llearn) then
	        write (33,2000) ex(iwin,iframe,1),ex(iwin,iframe,2),
     &	                        ey(iwin,iframe,1),ey(iwin,iframe,2)
	      endif
	      return
c
c------ --- Coordinate command
c
	    elseif (hit_button(2,mx,my)) then
	      call draw_button (2,.false.,.true.)
	      call do_koor
	      call draw_button (2,.false.,.false.)
c
c------ --- Select region command
c
	    elseif (hit_button(3,mx,my)) then
	      call draw_button (3,.false.,.true.)
	      call do_region
	      call draw_button (3,.false.,.false.)
c
c------ --- Zoom
c
	    elseif (hit_button(4,mx,my)) then
	      call draw_button (4,.false.,.true.)
	      call do_zoom (.true.)
	      call draw_button (4,.false.,.false.)
c
c------ --- Move
c
	    elseif (hit_button(5,mx,my)) then
	      call draw_button (5,.false.,.true.)
	      call do_zoom (.false.)
	      call draw_button (5,.false.,.false.)
c
c------ --- Reset region
c
	    elseif (hit_button(6,mx,my)) then
	      call draw_button (6,.false.,.true.)
	      ex(iwin,iframe,1) = -9999.
	      t (iwin,iframe,1) = -9999.
	      call draw_frame (iframe,lw)
	      call frame_menu
	      call draw_tframe (' ',' ','Region reset ...')
	      call draw_button (6,.false.,.false.)
c
c------ --- Select frame command
c
	    elseif (hit_button(7,mx,my) .and. iaf(iwin).gt.1) then
	      call draw_button (7,.false.,.true.)
	      call do_fselect
	      call draw_button (7,.false.,.false.)
c
c------ --- Select distance command
c
	    elseif (hit_button(8,mx,my)) then
	      call draw_button (8,.false.,.true.)
	      call do_distance
	      call draw_button (8,.false.,.false.)
c
c------ --- Select ZMIN
c
	    elseif (hit_button(9,mx,my) .and.n_in_f(ini)) then
	      call draw_button (9,.false.,.true.)
	      call do_zscale(.true.)
	      call draw_button (9,.false.,.false.)
c
c------ --- Select ZMAX
c
	    elseif (hit_button(10,mx,my) .and.n_in_f(ini)) then
	      call draw_button (10,.false.,.true.)
	      call do_zscale(.false.)
	      call draw_button (10,.false.,.false.)
c
c------ --- Enter KUPLOT command
c
	    elseif (hit_button(11,mx,my)) then
	      call draw_button (11,.false.,.true.)
	      call do_enter_command (lend)
	      if (lend) return
	      call draw_button (11,.false.,.false.)
	    endif
	  endif
	  if (iaf(iwin).gt.1) call border_frame (iframe,1,0.02)
	goto 10
c
c------ Finish off
c
9999	continue

c
1000	format(' ------ > Click on EXIT MENU to return to ',
     &	                 'command mode ...')
2000	format ('skal ',3(G12.6,','),G12.6)
	end
c******7****************************************************************
	subroutine frame_menu
c
c	This sets the menu viewport and draws borders ...
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	real		xpl(2),ypl(2)
c
	call PGSVP  (0.0,0.999,0.0,0.999)
	call PGSWIN (0.0,1.0,0.0,1.0)
c
	call PGSFS  (2)
	call PGSCI  (6)
	call PGRECT (0.0,1.0,0.0,1.0)
c
	end
c******7****************************************************************
	subroutine draw_menu
c
c	Draw the different menu parts
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'prompt.inc'
	include		'errlist.inc'
c
	character*40	text
	real		xh,yh,xt,yt
	integer		ini
c
	integer		len_str
	logical		n_in_f
c
c------ Draw borders and filling of menu region
c
	call PGSVP  (0.0,0.999,0.0,0.999)
	call PGSWIN (0.0,1.0,0.0,1.0)
	call PGSCI  (6)
	call PGSFS  (1)
	call PGRECT (1.0-dev_draw(iwin,1),1.0,0.0,1.0)
	call PGRECT (0.0,1.0-dev_draw(iwin,1),0.0,dev_draw(iwin,2))
c
c------ Plot KUPLOT logo
c
	call PGSCF (1)
	call PGSCH (1.0)
	call PGSCI (1)
	xt = 1.0 - 0.50*dev_draw(iwin,1)
	yt = 0.0 + 0.60*dev_draw(iwin,2)
	call PGQCS  (4,xh,yh)
	call PGPTXT (xt,yt,0.0,0.5,'KUPLOT')
	yt = yt - 1.05*yh
	text = 'Version '//version(1:len_str(version))
	call PGPTXT (xt,yt,0.0,0.5,text)
c
c------ Add menu buttons
c
	xt = 1.0 - 0.50*dev_draw(iwin,1)
	yt = dev_draw(iwin,1)*0.9
c
	call def_button ( 2,'Coordinates'  ,xt,0.95,yt,0.04)
	call def_button ( 8,'Distances'    ,xt,0.90,yt,0.04)
	call def_button ( 3,'Select region',xt,0.80,yt,0.04)
	call def_button ( 4,'Zoom'         ,xt,0.75,yt,0.04)
	call def_button ( 5,'Move'         ,xt,0.70,yt,0.04)
	call def_button ( 6,'Reset region' ,xt,0.65,yt,0.04)
	call def_button ( 9,'Select zmin'  ,xt,0.55,yt,0.04)
	call def_button (10,'Select zmax'  ,xt,0.50,yt,0.04)
	call def_button ( 7,'Select frame' ,xt,0.40,yt,0.04)
	call def_button (11,'Enter command',xt,0.25,yt,0.04)
	call def_button ( 1,'Exit menu'    ,xt,0.20,yt,0.04)
c
	call draw_button( 1,.false.,.false.)
	call draw_button( 2,.false.,.false.)
	call draw_button( 3,.false.,.false.)
	call draw_button( 4,.false.,.false.)
	call draw_button( 5,.false.,.false.)
	call draw_button( 6,.false.,.false.)
	call draw_button( 7,(iaf(iwin).eq.1),.false.)
	call draw_button( 8,.false.,.false.)
	call draw_button( 9,.not.n_in_f(ini),.false.)
	call draw_button(10,.not.n_in_f(ini),.false.)
	call draw_button(11,.false.,.false.)
c
	call draw_tframe (' ',' ',
     &	     'Use the EXIT button to return to command mode ...')
c
	end
c******7****************************************************************
	subroutine draw_tframe (tt1,tt2,tt3)
c
c	This routine writes the strings tt1-tt3 below plot
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	character*(*)	tt1,tt2,tt3
	character*80	t1,t2,t3
	real		xt,yt,xh,yh
	integer		ltext
c
	integer		len_str
c
	t1 = tt1
	t2 = tt2
	t3 = tt3
c
c------ Remove old text
c
	call PGSCI  (6)
	call PGSFS  (1)
	call PGRECT (0.0,1.0-dev_draw(iwin,1),0.0,dev_draw(iwin,2))
	call frame_menu
c
c------ Plot new text
c
	call PGSCF (1)
	call PGSCI (0)
	call PGSCH (1.25)
	call PGQCS (4,xh,yh)
	xt = 0.5 * (1.0-dev_draw(iwin,1))
	yt = dev_draw(iwin,2) - 1.5*yh
	ltext=len_str(t1)
	if (ltext.gt.0) call PGPTXT (xt,yt,0.0,0.5,t1(1:ltext))
	yt = yt - 1.1*yh
	ltext=len_str(t2)
	if (ltext.gt.0) call PGPTXT (xt,yt,0.0,0.5,t2(1:ltext))
	call PGSCH (1.0)
	call PGQCS (4,xh,yh)
	yt = yt - 1.5*yh
	ltext=len_str(t3)
	if (ltext.gt.0) call PGPTXT (xt,yt,0.0,0.5,t3(1:ltext))
c
	end
c******7****************************************************************
	subroutine draw_command (cmd,befehl,ic,ib) 
c
c	Get command from GUI area ..
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	character*(*)	cmd,befehl
	integer		ic,ib
	real		xt,yt,xh,yh,x1,x2,y1,y2
c
	ic = 0
	cmd = ' '
c
	call PGSCI  (6)
	call PGSFS  (1)
	call PGRECT (0.0,1.0-dev_draw(iwin,1),0.0,dev_draw(iwin,2))
c
	call frame_menu
c
c------ Plot prompt
c
	call PGSCF (1)
	call PGSCH (1.0)
	call PGQCS (4,xh,yh)
	call PGSCI (1)
c
	x1 = 0.0+0.2*xh
	x2 = 1.0-dev_draw(iwin,1)
	y1 = 1.80*yh
	y2 = 0.20*yh
	xt = x1+0.50*xh
	yt = y2+0.40*yh
c
	call PGPTXT (xt,yt,0.0,0.0,'kuplot >')
        call PGRSTR (xt+5.0*xh,yt,0.0,0.0,cmd,ic,6)
	call extr_befehl(cmd,befehl,ic,ib)
c
	end
c******7****************************************************************
	subroutine extr_befehl(cmd,befehl,ic,ib)
c
c	Extract 'befehl' string
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	character*(*)	cmd,befehl
	integer		ic,ib,il,ir,len_str
c
	ic = len_str(cmd)
	il = 1
	do while (cmd(il:il).eq.' ' .and. il.lt.ic)
	  il = il+1
	enddo
	ir = index(cmd(il:ic),' ') - 1
	if (ir.lt.0) ir=ic
c
	befehl = cmd(il:ir)
	ib     = len_str(befehl)
c
	end
c******7****************************************************************
	logical function hit_button (ib,mx,my)
c
c	Checks if button was pressed
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	real		mx,my,w2,h2
	integer		ib
c
	w2 = 0.5*bw(ib)
	h2 = 0.5*bh(ib)
c
	hit_button = mx.ge.(bx(ib)-w2) .and. mx.le.(bx(ib)+w2) .and.
     &	             my.ge.(by(ib)-h2) .and. my.le.(by(ib)+h2)
c
	end
c******7****************************************************************
	logical function n_in_f(ini)
c
c	Checks for 2D files in current frame
c
	implicit 	none
c
	include 	'config.inc'
	include 	'kuplot.inc'
c
	integer		i,ini
	logical		k_in_f
c
	n_in_f = .false.
	do i=1,iz-1
	  n_in_f = n_in_f .or. (k_in_f(i) .and. lni(i))
	  if (n_in_f) ini = i
	enddo
c
	end
c******7****************************************************************
	subroutine def_button (ib,text,xb,yb,wb,hb)
c
c	Defines a button for the menu
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	character*(*)	text
	real		xb,yb,wb,hb
	integer		ib
c
	btext(ib) = text
	bx(ib)    = xb
	by(ib)    = yb
	bw(ib)    = wb
	bh(ib)    = hb
c
	end
c******7****************************************************************
	subroutine draw_button (i,ldisabled,lactive)
c
c	This routine draws a button on menu panel
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	real		xh,yh,w2,h2
	integer		i,ib,it
	logical		lactive,ldisabled
c
	if (ldisabled) then
	  ib = 6
	  it = 6
	else
	  if (lactive) then
	    ib = 6
	    it = 0
	  else
	    ib = 0
	    it = 6
	  endif
	endif
c
	w2 = 0.5*bw(i)
	h2 = 0.5*bh(i)
c
	call PGSCI  (ib)
	call PGSFS  (1)
	call PGRECT (bx(i)-w2,bx(i)+w2,by(i)-h2,by(i)+h2)
	call PGSFS  (2)
	call PGSCI  (it)
	call PGQCS  (4,xh,yh)
	call PGPTXT (bx(i),by(i)-yh*0.3,0.0,0.5,btext(i))
c	
	end
c******7****************************************************************
	subroutine do_enter_command (lend)
c
c	Allows the user to enter KUPLOT command
c
	implicit 	none
c
	include 	'config.inc'
	include 	'kuplot.inc'
	include 	'doact.inc'
	include 	'macro.inc'
	include 	'errlist.inc'
c
	character*200	command,befehl
	integer		ic,ib,mac_level_old
	logical		lend,lreg
c
	logical		str_comp
c
	lend = .false.
c
c------ Now enter, check and execute command
c
	mac_level_old = mac_level
	call draw_command (command,befehl,ic,ib)
	if (ic.gt.0) then
c
c------ - Check for disabled commands
c
	  if(str_comp(befehl,'help',2,ib,4)   .or.
     &	     str_comp(befehl,'do'  ,2,ib,2)   .or.
     &	     str_comp(befehl,'if'  ,2,ib,2)       ) then
	    goto 10
	  else
	    call mache_kdo (command,lend,ic)
	    if (ier_num.ne.0) goto 10
c
c------ --- Macro entered ?
c
	    do while (mac_level.gt.mac_level_old) 
	      if(lblock) then
	        call do_execute(lreg,command,ic)
	        if(ier_num.ne.0 .or. .not. lreg) goto 10
	      else
	        call macro_read (command,ic)
	        call extr_befehl (command,befehl,ic,ib)
	        if(str_comp(befehl,'do',2,ib,4)   .or.
     &	           str_comp(befehl,'if',2,ib,2)       ) then
	          call do_loop (command,lend,ic)
	        else
	          call mache_kdo (command,lend,ic)
	        endif
	        if (ier_num.ne.0) goto 10
	      endif
	    enddo
	  endif
	endif
c
c------ Redraw and return
c
10	continue
c
	call do_plot (.not. lend)
	if (ier_num.ne.0) then
	  call errlist
	  if (.not. lend) call draw_tframe('Last command',
     &	                                   command,ier_out)
	endif
c
	end
c******7****************************************************************
	subroutine do_zscale(lmin)
c
c	Set zmin,zmax via mouse
c	LEFT : up by 5% / MIDDLE : down by 5% / RIGHT : back to menu
c
	implicit 	none
c
	include 	'config.inc'
	include 	'kuplot.inc'
	include 	'errlist.inc'
c
	character*80	zeile
	character*1  	key
	real		wx,wy,hub
	integer		ini
	logical		lw,lmin,l2d,n_in_f
c
	lw  = .true.
	l2d = n_in_f(ini)
c
	call draw_tframe (' ',
     &	                  'LEFT button: up 5% / MIDDLE button: down 5%',
     &	                  'RIGHT botton: back')
c
c------ First point
c
10	continue
	  call open_viewport
	  call PGSCI  (ilinecol(iwin,iframe,0))
	  call PGBAND (0,0,0.0,0.0,wx,wy,key)
	  hub = nz(iwin,iframe,1)*z_inc(iwin,iframe,1)
	  if (key.eq.butt_r) then
	    goto 9999
	  elseif (key.eq.butt_l) then
	    if (lmin) then
	      z_min(iwin,iframe,1) = z_min(iwin,iframe,1)+0.05*hub
	    else
	      z_inc(iwin,iframe,1) = 
     &	           (1.00+0.05)*hub/float(nz(iwin,iframe,1))
	    endif
	  elseif (key.eq.butt_m) then
	    if (lmin) then
	      z_min(iwin,iframe,1) = z_min(iwin,iframe,1)-0.05*hub
	    else
	      z_inc(iwin,iframe,1) = 
     &	           (1.00-0.05)*hub/float(nz(iwin,iframe,1))
	    endif
	  endif
	  call draw_frame (iframe,lw)
	goto 10
c
9999	continue
c
	call draw_frame (iframe,lw)
	call frame_menu
	write (zeile,1000) z_min(iwin,iframe,1),
     &	                   nz(iwin,iframe,1)*z_inc(iwin,iframe,1)
c
	call draw_tframe (zeile,' ',' ')
c
1000	format ('New range Z: ',G12.6,' to ',G12.6)
c
	end
c******7****************************************************************
	subroutine do_fselect
c
c	Select active frame via mouse
c	LEFT : select frame
c
	implicit 	none
c
	include 	'config.inc'
	include 	'kuplot.inc'
	include 	'errlist.inc'
c
	character*80	zeile
	character*1  	key
	real		wx,wy,fx,fy
	integer		i,ifn
	logical		lw
c
	lw = .true.
c
	call draw_tframe (' ',' ','LEFT button: select active frame')
c
c------ Get point
c
	call PGSCI  (ilinecol(iwin,iframe,0))
	call PGBAND (0,0,0.0,0.0,wx,wy,key)
	if (key.ne.butt_l) return
c
c------ Determine frame
c
        fx = wx / (1.0-dev_draw(iwin,1))
        fy = wy / (1.0-dev_draw(iwin,2)) - dev_draw(iwin,2)
c
	ier_num = -35
	ier_typ = ER_APPL
c
	do i=1,iaf(iwin)
	  if (frame(iwin,i,1).le.fx .and. 
     &	      frame(iwin,i,3).ge.fx .and.
     &	      frame(iwin,i,2).le.fy .and. 
     &	      frame(iwin,i,4).ge.fy)     then
	    ifn     = i
	    ier_num = 0
	    ier_typ = ER_NONE
	  endif
	enddo
c
	if (ier_num.eq.0) then
	  call draw_frame (iframe,lw)
	  call draw_frame (ifn,lw)
	  call border_frame (ifn,1,0.02)
	  iframe = ifn
	endif
c
	write(zeile,1000) iframe
	call frame_menu
	call draw_tframe (zeile,' ',' ')
c
1000	format ('Selected active frame :',i3)
c
	end
c******7****************************************************************
	subroutine do_region 
c
c	Set plotting region via mouse
c	LEFT : select region / RIGHT : back to showing ALL data
c
	implicit 	none
c
	include 	'config.inc'
	include 	'kuplot.inc'
	include 	'errlist.inc'
c
	character*80	zeile(2)
	character*1  	key
	real		px(2),py(2)
	real		wx1,wy1,wx2,wy2
	logical		lw
c
	lw = .true.
c
	call draw_tframe (' ',' ',
     &	     'LEFT button: mark corners / RIGHT botton: reset')
c
c------ First point
c
	call open_viewport
	call PGSCI  (ilinecol(iwin,iframe,0))
	call PGBAND (0,0,0.0,0.0,wx1,wy1,key)
	if (key.eq.butt_r) then
	  ex(iwin,iframe,1)    = -9999.0
	  t(iwin,iframe,1)     = -9999.0
	  t(iwin,iframe,2)     = -9999.0
	endif
	if (key.ne.butt_l) goto 9999
c
c------ Draw cross at first point
c
	call PGSLS(4)
	call trans_koor(wx1,wy1)
c
	px(1)=ex(iwin,iframe,1)
	py(1)=wy1
	px(2)=ex(iwin,iframe,2)
	py(2)=wy1
	call PGLINE(2,px,py)
c
	px(1)=wx1
	py(1)=ey(iwin,iframe,1)
	px(2)=wx1
	py(2)=ey(iwin,iframe,2)
	call PGLINE(2,px,py)
c
c------ Second point
c
	call PGBAND (2,0,wx1,wy1,wx2,wy2,key)
	if (key.ne.butt_l) goto 9999
c
c------ Set new scale
c
	call trans_koor(wx2,wy2)
c
	ex(iwin,iframe,1) = min(wx1,wx2)
	ex(iwin,iframe,2) = max(wx1,wx2)
	ey(iwin,iframe,1) = min(wy1,wy2)
	ey(iwin,iframe,2) = max(wy1,wy2)
c
	t(iwin,iframe,1)  = -9999.0
	t(iwin,iframe,2)  = -9999.0
c
9999	continue
c
	call draw_frame (iframe,lw)
	call frame_menu
	write (zeile(1),1000) ex(iwin,iframe,1),ex(iwin,iframe,2)
	write (zeile(2),1010) ey(iwin,iframe,1),ey(iwin,iframe,2)
c
	call draw_tframe (zeile(1),zeile(2),' ')
c
1000	format ('New range X: ',G12.6,' to ',G12.6)
1010	format ('New range Y: ',G12.6,' to ',G12.6)
c
	end
c******7****************************************************************
	subroutine do_zoom (lzoom)
c
c	Zoom in/out of picture
c
	implicit 	none
c
	include 	'config.inc'
	include 	'kuplot.inc'
	include		'learn.inc'
	include 	'errlist.inc'
c
	character*80	zeile(2),thelp
	character*1  	key
	real		wx,wy,w2,h2
	logical		lzoom,lw
c
	lw = .true.
c
	if (lzoom) then
	  thelp = 'LEFT button: zoom in / MIDDLE button: zoom out'//
     &	          ' / RIGHT botton: exit'
	else
	  thelp = 'LEFT button: new center / RIGHT botton: exit'
	endif
	call draw_tframe (' ',' ',thelp)
c
c------ Check mouse
c
10	continue
	  call open_viewport
	  call PGSCI  (ilinecol(iwin,iframe,0))
	  call PGBAND (0,0,0.0,0.0,wx,wy,key)
	  if (key.eq.butt_r) goto 20
c
c------ - Compute new boundaries
c
	  call trans_koor(wx,wy)
c
	  w2 = 0.5 * (ex(iwin,iframe,2) - ex(iwin,iframe,1))
	  h2 = 0.5 * (ey(iwin,iframe,2) - ey(iwin,iframe,1))
c
	  if (key.eq.butt_l .and. lzoom) then
	    w2 = 0.9 * w2
	    h2 = 0.9 * h2
	  endif
	  if (key.eq.butt_m .and. lzoom) then
	    w2 = 1.1 * w2
	    h2 = 1.1 * h2
	  endif
c
	  ex(iwin,iframe,1) = wx - w2
	  ex(iwin,iframe,2) = wx + w2
	  ey(iwin,iframe,1) = wy - h2
	  ey(iwin,iframe,2) = wy + h2
	  t(iwin,iframe,1)  = -9999.0
	  t(iwin,iframe,2)  = -9999.0
c
c------ - Redraw frame
c
	  call draw_frame (iframe,lw)
c
	  call frame_menu
	  write (zeile(1),1000) ex(iwin,iframe,1),ex(iwin,iframe,2)
	  write (zeile(2),1010) ey(iwin,iframe,1),ey(iwin,iframe,2)
	  call draw_tframe (zeile(1),zeile(2),thelp)
	goto 10
20	continue
c
	call frame_menu
	write (zeile(1),1000) ex(iwin,iframe,1),ex(iwin,iframe,2)
	write (zeile(2),1010) ey(iwin,iframe,1),ey(iwin,iframe,2)
	call draw_tframe (zeile(1),zeile(2),' ')
c
1000	format ('New range X: ',G12.6,' to ',G12.6)
1010	format ('New range Y: ',G12.6,' to ',G12.6)
c
	end
c******7****************************************************************
	subroutine do_distance 
c
c	Shows distance between two points ..
c
	implicit 	none
c
	include 	'config.inc'
	include 	'kuplot.inc'
	include 	'param.inc'
	include 	'errlist.inc'
c
	character*80	zeile
	character*1  	key
	real		x1,y1,x2,y2,dist
c
	zeile = ' '
c
	res_para(0)=0
10	continue
	  call frame_menu
	  call draw_tframe (zeile,' ',
     &	       'LEFT button: select points / RIGHT button: exit')
	  call open_viewport
	  call PGSCI  (ilinecol(iwin,iframe,0))
c
	  call PGBAND (7,0,0.0,0.0,x1,y1,key)
	  if (key.eq.butt_r) goto 20
	  call PGBAND (1,0,x1,y1,x2,y2,key)
	  if (key.eq.butt_r) goto 20
c
	  y1=yskal(iwin,iframe)*y1
	  y2=yskal(iwin,iframe)*y2
	  dist=sqrt((x2-x1)**2 + (y2-y1)**2)
c
	  write(zeile,2200) dist
	  if(res_para(0)-1.le.maxpar_res) then
	    res_para(0)=res_para(0)+1
	    res_para(res_para(0)-1)=dist
	  endif
	goto 10
c
20	continue
c
	call frame_menu
c
2200	format('Distance = ',g12.6)
c
	end
c******7****************************************************************
	subroutine do_koor 
c
c	Show coordinates of mouse pointer position
c
	implicit 	none
c
	include 	'config.inc'
	include 	'kuplot.inc'
	include 	'param.inc'
	include 	'errlist.inc'
c
	character*80	zeile
	character*1  	key
	real		wx,wy,wz,dxx,dyy
	integer		i,ini,nxx,nyy
	logical		l2d,k_in_f
c
	zeile = ' '
c
	l2d = .false.
	do i=1,iz-1
	  l2d = l2d .or. (k_in_f(i) .and. lni(i))
	  if (l2d) ini = i
	enddo
c
	res_para(0)=0
10	continue
	  call frame_menu
	  call draw_tframe (zeile,' ',
     &	       'LEFT button: select point / RIGHT button: exit')
	  call open_viewport
	  call PGSCI  (ilinecol(iwin,iframe,0))
	  call PGBAND (7,0,0.0,0.0,wx,wy,key)
	  if (key.eq.butt_r) goto 20
c
	  call trans_koor(wx,wy)
c
	  if (.not.l2d) then
	    write(zeile,2200) wx,wy
	    if(res_para(0)-2.le.maxpar_res) then
	      res_para(0)=res_para(0)+2
	      res_para(res_para(0)-1)=wx
	      res_para(res_para(0)  )=wy
	    endif
c
	  else
            dxx = (xmax(ini)-xmin(ini))/float(nx(ini)-1)
            dyy = (ymax(ini)-ymin(ini))/float(ny(ini)-1)
	    nxx = nint (((wx - xmin(ini))/dxx))+1
	    nyy = nint (((wy - ymin(ini))/dyy))+1
	    wz  = z(offz(ini-1)+(nxx-1)*ny(ini)+nyy)
	    write(zeile,2210) wx,wy,wz
	    if(res_para(0)-3.le.maxpar_res) then
	      res_para(0)=res_para(0)+3
	      res_para(res_para(0)-2)=wx
	      res_para(res_para(0)-1)=wy
	      res_para(res_para(0)  )=wz
	    endif
	  endif
	goto 10
c
20	continue
c
	call frame_menu
	call draw_tframe (' ',' ',' ')
c
1200	format(1x,2(g12.6,1x))
1210	format(1x,3(g12.6,1x))
2200	format('(x,y) = ',2(g12.6,1x))
2210	format('(x,y,z) = ',3(g12.6,1x))
c
	end
c******7****************************************************************
	subroutine do_koor_nogui 
c
c	Get coordinates of mouse pointer position outside GUI window
c
	implicit 	none
c
	include 	'config.inc'
	include 	'kuplot.inc'
	include 	'prompt.inc'
	include 	'param.inc'
	include 	'errlist.inc'
c
	character*1  	key
	real		wx,wy,wz
	real		dxx,dyy
	integer		i,ini,ikey
	integer		nxx,nyy
	logical		l2d,k_in_f
c
	call do_plot (lgui(iwin))
	if (ier_num.ne.0) return
c
	write (output_io,1000)
c
	l2d = .false.
	do i=1,iz-1
	  l2d = l2d .or. (k_in_f(i) .and. lni(i))
	  if (l2d) ini = i
	enddo
c
	res_para(0)=0
	call open_viewport
	call PGSCI  (ilinecol(iwin,iframe,0))
	call PGBAND (7,0,0.0,0.0,wx,wy,key)
	if (key.eq.butt_l) ikey=1
	if (key.eq.butt_m) ikey=2
	if (key.eq.butt_r) ikey=3
c
	call trans_koor(wx,wy)
c
	if (.not.l2d) then
	  res_para(0) = 3
	  res_para(1) = wx
	  res_para(2) = wy
	  res_para(3) = float(ikey)
	else
          dxx = (xmax(ini)-xmin(ini))/float(nx(ini)-1)
          dyy = (ymax(ini)-ymin(ini))/float(ny(ini)-1)
	  nxx = nint (((wx - xmin(ini))/dxx))+1
	  nyy = nint (((wy - ymin(ini))/dyy))+1
	  wz  = z(offz(ini-1)+(nxx-1)*ny(ini)+nyy)
	  res_para(0) = 4
	  res_para(1) = wx
	  res_para(2) = wy
	  res_para(3) = wz
	  res_para(4) = float(ikey)
	endif
c
1000	format (' ------ > Select desired point using the mouse ...')
	end
c******7****************************************************************
	subroutine do_region_nogui(imode) 
c
c	Set region via mouse - without menu
c
	implicit 	none
c
	include 	'config.inc'
	include 	'prompt.inc'
	include 	'kuplot.inc'
	include 	'param.inc'
	include 	'errlist.inc'
c
	character*80	zeile(2)
	character*1  	key
	real		wx1,wy1,wx2,wy2
	integer		ikey,imode
c
	call do_plot (lgui(iwin))
	if (ier_num.ne.0) return
c
	write (output_io,1000)
	ikey = -1
c
c------ First point
c
	call open_viewport
	call PGSCI  (ilinecol(iwin,iframe,0))
	call PGBAND (0,0,0.0,0.0,wx1,wy1,key)
	if (key.ne.butt_l) goto 9999
c
c------ Second point
c
	call PGBAND (imode,0,wx1,wy1,wx2,wy2,key)
	if (key.eq.butt_l) ikey=1
	if (key.eq.butt_m) ikey=2
	if (key.eq.butt_r) ikey=3
c
c------ Set new scale
c
	call trans_koor(wx1,wy1)
	call trans_koor(wx2,wy2)
c
	res_para(0) = 5
	res_para(1) = wx1
	res_para(2) = wy1
	res_para(3) = wx2
	res_para(4) = wy2
	res_para(5) = float(ikey)
c
9999	continue
c
1000	format (' ------ > Select desired points using the mouse ...')
	end
c******7****************************************************************
	subroutine trans_koor (wx,wy)
c
c	Convert screen coordinates to world coordinates for ANGL not 90.
c	and for log. axis ..
c
	implicit 	none
c
	include 	'config.inc'
	include 	'kuplot.inc'
	include 	'wink.inc'
c
	real		wx,wy
c
	if (shear(iwin,iframe).ne.90.0) then
	  wx=wx-(wy-ey(iwin,iframe,1))*
     &	         yskal(iwin,iframe)/tan(rad*shear(iwin,iframe))
	endif
c
	if (lachse(iwin,iframe,1)) wx=exp(wx*log(10.0))
	if (lachse(iwin,iframe,2)) wy=exp(wy*log(10.0))
c
	end
c******7****************************************************************
      SUBROUTINE PGRSTR(X, Y, ANGLE, FJUST, TEXT, LSTR, BCI)
      REAL X, Y, ANGLE, FJUST
      CHARACTER*(*) TEXT
      INTEGER LSTR, BCI
C-----------------------------------------------------------------------
      CHARACTER CH
      INTEGER CI
      REAL XCUR, YCUR, XBOX(4), YBOX(4)
C
      CALL PGQCI(CI)
C
 10   CONTINUE
C     -- Draw current string
          IF (LSTR.GT.0) THEN
             CALL PGPTXT(X, Y, ANGLE, FJUST, TEXT(1:LSTR))
             CALL PGQTXT(X, Y, ANGLE, FJUST, TEXT(1:LSTR), XBOX, YBOX)
             XCUR = XBOX(4)
             YCUR = YBOX(4)
          ELSE
             XCUR = X
             YCUR = Y
          END IF
C         -- Read a character
          CALL PGBAND(0, 1, XCUR, YCUR, XCUR, YCUR, CH)
C         -- Erase old string
          CALL PGSCI(BCI)
          IF (LSTR.GT.0) 
     :         CALL PGPTXT(X, Y, ANGLE, FJUST, TEXT(1:LSTR))
          CALL PGSCI(CI)
C         -- Avoid problem with PGPLOT escape character
          IF (CH.EQ.CHAR(92)) CH = '*'
C         -- Backspace (ctrl H) or delete removes last character
          IF (ICHAR(CH).EQ.8 .OR. ICHAR(CH).EQ.127) THEN
             IF (LSTR.GT.0) TEXT(LSTR:LSTR) = ' '
             IF (LSTR.GT.0) LSTR = LSTR-1
C         -- Ctrl U removes entire string
          ELSE IF (ICHAR(CH).EQ.21) THEN
             TEXT(1:LSTR) = ' '
             LSTR = 0
C         -- Any other non-printing character terminates input
          ELSE IF (ICHAR(CH).LT.32) THEN
             IF (LSTR.GT.0)
     :            CALL PGPTXT(X, Y, ANGLE, FJUST, TEXT(1:LSTR))
             GOTO 20
C         -- Otherwise, add character to string if there is room
          ELSE IF (LSTR.LT.LEN(TEXT)) THEN
             LSTR = LSTR+1
             TEXT(LSTR:LSTR) = CH
          END IF
      GOTO 10
C
 20   RETURN
      END
