c*****7*****************************************************************
c-
c	This sublevel includes all commands and functions for the
c	least square fits in KUPLOT. 
c
c	Version  : 4.0
c	Date     : 06. March 1999
c
c	Author   : Th. Proffen (tproffen@lanl.gov )
c*****7*****************************************************************
	subroutine do_fit(zei,lp)
c
c	Main fitting menu
c
	implicit	none
c
	integer		maxw
	parameter	(maxw = 1)
c
	include 	'config.inc'
	include 	'kuplot.inc'
	include 	'doact.inc'
	include 	'macro.inc'
	include 	'errlist.inc'
	include 	'learn.inc'
	include 	'prompt.inc'
c
	character*(*)	zei
	character*200	cpara(maxw)
	character*200  	line,zeile
	character*10   	prom
	character*40   	cdummy
	character*4    	befehl
	integer		lpara(maxw)
	integer        	ll,lp
	integer        	ianz,indxg,lbef
	integer         maxpkt,maxzz
	real		werte(maxw)
	logical		flag(3),sel_func
c
	logical         str_comp
c
	call no_error
	sel_func = ftyp(1:4).ne.'NONE'
c
c------ check data set number and free space
c
	call get_params(zei,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.1) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  ikfit=nint(werte(1))
	  if (ikfit.lt.1 .or. ikfit.gt.(iz-1)) then
	    ier_num = -4
	    ier_typ = ER_APPL
	    return
	  endif
	  if ((iz+1).gt.maxkurvtot) then
	    ier_num = -1
	    ier_typ = ER_APPL
	    return
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	if (ikfirst(ikfit)) then
c
c----- -- Check if there is enough space left
c
	  maxpkt = maxarray - offxy(iz-1)
	  maxzz  = maxarray - offz (iz-1)
c
	  if (lni(ikfit)) then
	    if ((2.0*nx(iz-1)*ny(iz-1)  .gt. maxzz) .or.
     &	        (max(nx(iz-1),ny(iz-1)) .gt. maxpkt))    then
	      ier_num = -6
	      ier_typ = ER_APPL
	      return
	    endif
c
	    ikcal=iz
	    ikdif=iz+1
	    offxy(ikcal) = offxy(iz-1 ) + max(nx(iz-1),ny(iz-1))
	    offxy(ikdif) = offxy(ikcal) + max(nx(iz-1),ny(iz-1))
	    offz (ikcal) = offz (iz-1 ) + nx(iz-1)*ny(iz-1)
	    offz (ikdif) = offz (ikcal) + nx(iz-1)*ny(iz-1)
	    iz=iz+2
	  else
	    if (2.0*len(iz-1) .gt. maxpkt) then
	      ier_num = -6
	      ier_typ = ER_APPL
	      return
	    endif
c
	    ikcal=iz
	    ikdif=iz+1
	    offxy(ikcal) = offxy(iz-1 ) + len(iz-1)
	    offxy(ikdif) = offxy(ikcal) + len(iz-1)
	    offz (ikcal) = offz (iz-1 )
	    offz (ikdif) = offz (ikcal)
	    iz=iz+2
	  endif
c
c----- -- Everything ok so far ..
c
	  ikfirst(ikfit)   = .false.
	  fit_ikcal(ikfit) = ikcal
	  fit_ikdif(ikfit) = ikdif
c
c----- -- Restore previous fit setting
c
	else
	  ikcal = fit_ikcal(ikfit)
	  ikdif = fit_ikdif(ikfit)
	endif
c
c------ here starts sublevel fit
c
10	continue
c
	prom=prompt//'/fit'
	call get_command (line,ll,befehl,lbef,zeile,lp,prom)
	if(ier_num.eq.0) then
	if(line.eq.' '.or.line(1:1).eq.'#') goto 10
c
c------ search for "="
c
	indxg=index(line,'=')
	if(indxg.ne.0.and..not.(str_comp(befehl,'echo',2,lbef,4))
     &	             .and..not.(str_comp(befehl,'help',2,lbef,4) .or.
     &	                        str_comp(befehl,'?   ',2,lbef,4)) ) then
          call do_math(line,indxg,ll)
c
c------ execute a macro file
c
        elseif(befehl(1:1).eq.'@') then
          call file_kdo(line(2:ll),ll-1)
c
c------	continues a macro 'continue'
c
	elseif(str_comp(befehl,'continue',3,lbef,8)) then
	  call macro_continue(zeile,lp)
c
c-------Set number of cycles 'cyc'
c
	elseif(str_comp(befehl,'cycle',2,lbef,5)) then
	  call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	  if (ier_num.eq.0) then
	    if (ianz.eq.1) then
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if (ier_num.eq.0) then
	        ncycle=nint(werte(1))
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------ Echo a string, just for interactive check in a macro 'echo'
c
	elseif(str_comp(befehl,'echo',2,lbef,4)) then
          call echo (zeile,lp)
c
c------ Evaluate an expression
c
	elseif(str_comp(befehl,'eval',2,lbef,4)) then
	  call do_eval(zeile,lp)
c
c------	exit 'exit'
c
	elseif(str_comp(befehl,'exit',3,lbef,4)) then
	  goto 9999
c
c------	Define fit function 'func'
c
	elseif(str_comp(befehl,'func',3,lbef,4)) then
	  call do_fit_fkt(zeile,lp)
	  if (ier_num.eq.0) sel_func = .true.
c
c------	help 'help','?'
c
	elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	       str_comp(befehl,'?   ',1,lbef,4)     ) then
	  if(str_comp(zeile,'errors',2,lp,6) ) then
	    lp = lp + 7
	    call do_hel('kuplot '//zeile,lp)
	  else
	    lp = lp + 12
	    call do_hel('kuplot fit '//zeile,lp)
	  endif
c
c-------Save current parameters to a macro file
c
	elseif(str_comp(befehl,'macro',2,lbef,5)) then
	  call do_fit_macro (zeile,lp)
c
c-------Set parameter 'ifen' for determination of maxima
c
	elseif(str_comp(befehl,'mfen',2,lbef,4)) then
	  call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	  if (ier_num.eq.0) then
	    if (ianz.eq.1) then
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if (ier_num.eq.0) then
	        fit_ifen=nint(werte(1))
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------ Echo a string, just for interactive check in a macro 'echo'
c
c-------Toogle fit screen output 'output'
c
	elseif(str_comp(befehl,'output',2,lbef,6)) then
	  call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	  if (ianz.eq.1) then
	    fstart=str_comp(cpara(1),'on',2,lpara(1),2)
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c-------Set parameters
c
	elseif(str_comp(befehl,'par',2,lbef,3)) then
	  call do_fit_par (zeile,lp)
c
c-------Plot result
c
	elseif(str_comp(befehl,'plot',2,lbef,4)) then
	  call do_plot (.false.)
c
c-------Run fit
c
	elseif(str_comp(befehl,'run',2,lbef,3)) then
	  if (.not.sel_func) then
	    ier_num = -25
	    ier_typ = ER_APPL
	  else
	    if(lni(ikfit)) then
	      call do_fit_z
	    else
	      call do_fit_y
	    endif
	  endif
c
c-------Save fit results
c
	elseif(str_comp(befehl,'save',2,lbef,4)) then
	  call do_fit_save
c
c-------Show settings
c
	elseif(str_comp(befehl,'show',2,lbef,4)) then
	  call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	  if (ier_num.eq.0) then
	    if (ianz.eq.0) then
	      call do_fit_info(output_io,.true.,.true.,.true.)
	    elseif (ianz.eq.1) then
	      call do_cap(cpara(1))
	      flag(1)=cpara(1)(1:2).eq.'GE'
	      flag(2)=cpara(1)(1:2).eq.'FI'
	      flag(3)=cpara(1)(1:2).eq.'PA'
	      if (flag(1).or.flag(2).or.flag(3)) then
	        call do_fit_info(output_io,flag(1),flag(2),flag(3))
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c-------Operating System Kommandos 'syst'
c
	elseif(str_comp(befehl,'syst',2,lbef,4)) then
	  cdummy=' '
	  if(zeile.ne. ' ') then
	    cdummy(1:lp)=zeile(1:lp)
	    call do_operating(cdummy,lp)
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c-------Set URF 'urf'
c
	elseif(str_comp(befehl,'urf',2,lbef,3)) then
	  call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	  if (ier_num.eq.0) then
	    if (ianz.eq.1) then
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if (ier_num.eq.0) then
	        urf=werte(1)
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	Waiting for user input
c
	elseif(str_comp(befehl,'wait',3,lbef,4)) then
	  call do_input(zeile,lp)
c
c------	Set weighting scheme
c
	elseif(str_comp(befehl,'wic',3,lbef,3)) then
	  call do_fit_wichtung(zeile,lp)
c
c------ no command found
c
	else
	  ier_num = -8
	  ier_typ = ER_COMM
	endif
	endif
c
c------ any errors ?
c
	if(ier_num.ne.0) then
	  call errlist
	  if(lmakro) then
	    call macro_close
	    prompt_status = PROMPT_ON
	  endif
	  if(lblock) then
	    ier_num = -11
	    ier_typ = ER_COMM
	    return
	  endif
	  call no_error
	endif
	goto 10
c
9999	continue
c
2000	format (a)
	end
c*****7*******************************************************************
	subroutine do_fit_fkt (zeile,lp)
c+
c	Set theory function 
c-
	implicit	none
c
	integer		maxw
	parameter	(maxw=3)
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	real		werte(maxw)
	integer		lpara(maxw),lp
	integer		ianz
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if(ier_num.ne.0) return
c
	if(ianz.ge.1) then
	  ftyp=cpara(1)(1:4)
	  call do_cap(ftyp)
	  if (ianz.gt.1) then
	    call del_params(1,ianz,cpara,lpara,maxw)
	    call ber_params(1,cpara,lpara,werte,maxw)
	  else
	    ianz = 0
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	if (ier_num.ne.0) return
c
c------ Polynom (only 2D)
c
	if     (ftyp(1:2).eq.'PO') then
	  if (.not.lni(ikfit)) then
	    call setup_poly (ianz,werte,maxw)
	  else
	    ier_num = -25
	    ier_typ = ER_APPL
	  endif
c
c------ Gaussian (xy and xyz data sets)
c
	elseif (ftyp(1:2).eq.'GA') then
	  if (.not.lni(ikfit)) then
	    call setup_gauss (ianz,werte,maxw)
	  else
	    call setup_gauss_2d (ianz,werte,maxw)
	  endif
c
c------ Lorenzian (only 2D)
c
	elseif (ftyp(1:2).eq.'LO' ) then
	  if (.not.lni(ikfit)) then
	    call setup_lor (ianz,werte,maxw)
	  else
	    ier_num = -25
	    ier_typ = ER_APPL
	  endif
c
c------ User defined function (xy and xyz data sets)
c
	elseif (ftyp(1:2).eq.'FX') then
	  call setup_user (ianz,werte,maxw,cpara,lpara)
c
	else
	  ier_num = -25
	  ier_typ = ER_APPL
	endif
c
	end
c*****7*******************************************************************
	subroutine do_fit_macro (zeile,lp)
c+
c	fitparameter und einstellungen als macro speichern
c-
	implicit	none
c
	integer		maxw
	parameter	(maxw=10)
c
	include 	'config.inc'
	include 	'prompt.inc'
	include 	'kuplot.inc'
	include 	'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	real		werte(maxw)
	integer		lpara(maxw),lp
	integer		ianz,i
c
	integer		len_str
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
	call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	if (ier_num.ne.0) return
c
	call oeffne (77,cpara(1),'unknown',.false.)
	if (ier_num.ne.0) return
c
	write (output_io,3000) cpara(1)(1:len_str(cpara(1)))
	do i=1,npara
	  write (77,1000) i
	  write (77,2000) i,pinc(i),p(i)
	enddo
	close (77)
c
1000	format ('# parameter number ',i3)
2000	format ('par ',i3,',',g12.6,',',f2.0)
3000	format (' ---------- > Saving current parameters to macro file ',
     &	        a,' ..')
	end	
c*****7*******************************************************************
	subroutine do_fit_pmerk
c+
c	speichern der fitparameter
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	integer		i
c
	do i=1,npara
	  p_merk(i)    = p(i)
	  pinc_merk(i) = pinc(i)
	enddo
	end
c*****7*******************************************************************
	subroutine do_fit_prueck
c+
c	speichern der fitparameter
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	integer		i
c
	do i=1,npara
	  p(i)    = p_merk(i)
	  pinc(i) = pinc_merk(i)
	  dp(i)   = 0.0
	enddo
	end
c*****7*******************************************************************
	subroutine do_fit_save
c+
c	speichern der fitergebnisse
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=4)
c
	character*80	filname
	character*2     cdummy
	real		werte(maxw)
	integer         ianz
	integer		len_str
c
	filname=fname(ikfit)
	filname=filname(1:len_str(filname))//'.erg'
c
	call oeffne(77,filname,'unknown',.false.)
	if(ier_num.ne.0) return
c
	call do_fit_info (77,.true.,.true.,.true.)
	write (output_io,1000) filname(1:len_str(filname))
	close (77)
c
	write (output_io,2000) fname(ikcal)(1:len_str(fname(ikcal)))
	cdummy = fform(ikcal)
	ianz   = 0
	call check_form (cdummy,ianz,werte,maxw)
	call do_save (ikcal,fname(ikcal),fform(ikcal),
     &	                     ianz,werte,maxw,.false.)
c
	write (output_io,3000) fname(ikdif)(1:len_str(fname(ikdif)))
	cdummy = fform(ikdif)
	ianz   = 0
	call check_form (cdummy,ianz,werte,maxw)
	call do_save (ikdif,fname(ikdif),fform(ikdif),
     &	                     ianz,werte,maxw,.false.)
c
1000	format (' ---------- > Saving results in file ',a,' ..')
2000	format (' ---------- > Saving calculated data in file ',a,' ..')
3000	format (' ---------- > Saving difference data in file ',a,' ..')
	end
c*****7*******************************************************************
	subroutine do_fit_wichtung (zeile,lp)
c+
c	aendern der wichtung
c-
	implicit	none
c
	integer		maxw
	parameter	(maxw=2)
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz
	real            werte(maxw)
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.1) then
	  call do_cap (cpara(1))
	  if (cpara(1)(1:3).ne.'LOG'.and.cpara(1)(1:3).ne.'SQR'.and.
     &	      cpara(1)(1:3).ne.'ONE'.and.cpara(1)(1:3).ne.'LIN'.and.
     &	      cpara(1)(1:3).ne.'SQA'.and.cpara(1)(1:3).ne.'INV'.and.
     &	      cpara(1)(1:3).ne.'BCK'.and.
     &	      cpara(1)(1:3).ne.'ISQ'.and.cpara(1)(1:3).ne.'DAT'    ) then
	    ier_num = -27
	    ier_typ = ER_APPL
	  else
	    wtyp=cpara(1)(1:3)
	    wval=0.01
	  endif
	elseif (ianz.eq.2) then
	  call do_cap (cpara(1))
	  if (cpara(1)(1:3).eq.'BCK') then
            wtyp=cpara(1)(1:3)
	    cpara(1)='(0)'
	    lpara(1)=3
	    call ber_params(ianz,cpara,lpara,werte,maxw)
	    if(ier_num.eq.0) then
	      wval = werte(2)
	    endif
	  else
	    ier_num = -27
	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*******************************************************************
	subroutine do_fit_par (zeile,lp)
c+
c	aendern der fit-parameter
c-
	implicit	none
c
	integer		maxw
	parameter	(maxw=3)
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	real		werte(maxw)
	integer		lpara(maxw),lp
	integer		ianz,ip
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  call do_fit_info (output_io,.false.,.false.,.true.)
c
	elseif (ianz.eq.1) then
	  call do_cap(cpara(1))
	  if (cpara(1)(1:2).eq.'SA') then
	    call do_fit_pmerk
	  elseif (cpara(1)(1:2).eq.'LO') then
	    call do_fit_prueck
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
	elseif (ianz.eq.2 .or. ianz.eq.3) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  ip=nint(werte(1))
	  if (ip.gt.0 .and. ip.le.MAXPARA) then
	    pinc(ip)=werte(2)
	    if (ianz.eq.3) p(ip)=werte(3)
	    write (output_io,1000) ip,p(ip),pinc(ip)
	  else
	    ier_num = -26
	    ier_typ = ER_APPL
	  endif
c
	else
	  ier_num = -6
	  ier_typ = ER_COMM  
	endif
c
1000	format (' ---------- > Setting parameter p(',i2,') = ',g12.6,
     &	        '  pinc = ',f4.1) 
	end
c*****7*******************************************************************
	subroutine show_fit_para (idout)
c+
c	anzeigen der fit-parameter
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	character*30	fitfkt,wictyp
	integer		idout,lt1,lt2,lf,lfn,lw,ipkt
c
	integer		len_str
c
	if     (ftyp(1:2).eq.'PO') then
	  fitfkt = 'Polynom'
	elseif (ftyp(1:2).eq.'FX') then
	  fitfkt = 'f = '//fit_func(1:fit_lfunc)
	elseif (ftyp(1:2).eq.'LO') then
	  fitfkt = 'Lorenzian'
	elseif (ftyp(1:2).eq.'GA') then
	  if(lni(ikfit)) then
	    fitfkt = 'Gaussian (2D)'
	  else
	    fitfkt = 'Gaussian (1D)'
	  endif
	else
	  fitfkt = 'not defined'
	endif
c
	if     (wtyp(1:3).eq.'LOG') then
	  wictyp = 'w(i) = log(i)'
	elseif (wtyp(1:3).eq.'SQR') then
	  wictyp = 'w(i) = sqrt(i)'
	elseif (wtyp(1:3).eq.'ONE') then
	  wictyp = 'w(i) = 1.0'
	elseif (wtyp(1:3).eq.'LIN') then
	  wictyp = 'w(i) = i'
	elseif (wtyp(1:3).eq.'SQA') then
	  wictyp = 'w(i) = i**2'
	elseif (wtyp(1:3).eq.'INV') then
	  wictyp = 'w(i) = 1.0/i'
	elseif (wtyp(1:3).eq.'ISQ') then
	  wictyp = 'w(i) = 1.0/sqrt(i)'
	elseif (wtyp(1:3).eq.'DAT' .and. .not. lni(ikfit)) then
	  wictyp = 'w(i) = 1/dy(i) from data set'
	elseif (wtyp(1:3).eq.'BCK') then
	  wictyp = 'w(i) = exp(-WVAL*(Fobs-Fcalc))'
	else
	  wictyp = 'unknown'
	endif
c
	lt1 = max(1,len_str(titel(iwin,iframe,1)))
	lt2 = max(1,len_str(titel(iwin,iframe,2)))
	lf  = len_str(fitfkt)
	lfn = len_str(fname(ikfit))
	lw  = len_str(wictyp)
c
	if (lni(ikfit)) then
	  ipkt = nx(ikfit)*ny(ikfit)
	else
	  ipkt = len(ikfit)
	endif
c
	write (idout,1000) titel(iwin,iframe,1)(1:lt1),
     &	                   titel(iwin,iframe,2)(1:lt2),
     &	                   fitfkt(1:lf),fname(ikfit)(1:lfn),ipkt,
     &	                   npara,urf,ncycle,fit_ifen,wictyp(1:lw)
c
1000	format (1x,'General fit parameter settings : ',/,
     &	        3x,'Title            : ',a,/11x,a,/,
     &	        3x,'Fit function     : ',a,/
     &	        3x,'Data file name   : ',a,/
     &	        3x,'# of data pts.   : ',i6,/
     &	        3x,'# of parameters  : ',i6,/
     &	        3x,'Urf              : ',f9.4,/
     &	        3x,'Max. cycle       : ',i6,/
     &	        3x,'MFEN for maxima  : ',i6,/
     &	        3x,'Weighting scheme : ',a,/)
	end
c*****7*******************************************************************
	subroutine show_fit_erg (idout)
c+
c	anzeigen der fit-ergebnisse
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	integer		idout,i,j
	logical		kor
c
	write (idout,1040) zalt,zwert,zdif,fend,r4,re
	write (idout,1050)
	kor=.false.
	do i=2,npara
	  do j=1,i-1
	    if(abs(cl(i,j)).gt.0.8) then
	      write (idout,1070) i,j,cl(i,j)
	      kor=.true.
	    endif
	  enddo
	enddo    
	if (.not.kor) write (idout,1060)
	write (idout,*) ' '
c
1040	format (' Information about the fit : '/
     &		3x,'Sum n-1    : ',g12.6,12x,' Sum n   : ',g12.6/
     &          3x,'Difference : ',g12.6,/
     &          3x,'Urf final  : ',g12.6,/
     &	        3x,'R4 value   : ',g12.6,12x,' R exp   : ',g12.6/)
1050	format (' Correlations larger than 0.8 :')
1060	format (3x,'** none **')
1070	format (3x,'Between p(',i2,') - p(',i2,') : ',f6.3)
c
	end
c*****7*******************************************************************
	subroutine write_fit
c+
c	kupl.fit schreiben fuer textframe
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		i,j
	logical		kor
c
	call oeffne (22,'kupl.fit','unknown',.false.)
	if (ier_num.ne.0) return
c
	write (22,1000) ftyp,r4*100.,re*100.
        kor=.false.
        do i=2,npara
          do j=1,i-1
            if(abs(cl(i,j)).gt.0.8) then
              write (22,1070) i,j,cl(i,j)
              kor=.true.
            endif
          enddo
        enddo
        if (.not.kor) write (22,1060)
	write (22,1100)
	do i=1,npara
	  if (pinc(i).ne.1) then
	    write (22,1200) i,p(i)
	  else
	    write (22,1210) i,p(i),dp(i)
	  endif
	enddo
	close (22)
c
1000	format (/1x,'F i t  -  r e s u l t s',/,
     &	         1x,'--------------------------------------',/,
     &           1x,'Fit function : ',a4,/,
     &           1x,'R value      : ',f5.1,' %',/
     &           1x,'Rexp value   : ',f5.1,' %',/
     &	         1x,'--------------------------------------',/,
     &	         1x,'Correlations > 0.8 : ',/)
1060    format ( 1x,'** none **')
1070    format ( 1x,'betw. p(',i2,') - p(',i2,') : ',f6.3)
1100	format ( 1x,'--------------------------------------',/,
     &	         1x,'Resulting parameters: ',/)
1200	format ( 1x,'p(',i2,') = ',g12.6,' fixed')
1210	format ( 1x,'p(',i2,') = ',g12.6,' +- ',g12.6)
c
	close (22)
c
	end
c*****7*******************************************************************
	subroutine do_fit_info (idout,f_se,f_er,f_pa)
c+
c	ausgabe von fitinformationen
c-
	implicit	none
c
	include 	'config.inc'
	include 	'kuplot.inc'
c
	integer		idout
	logical		f_se,f_er,f_pa
c
	if (f_se) call show_fit_para (idout)
	if (f_er) call show_fit_erg  (idout)
c
	if (f_pa) then
	  if     (ftyp(1:2).eq.'PO') then
	    call show_poly (idout)
	  elseif (ftyp(1:2).eq.'GA') then
	    if (.not. lni(ikfit)) then
	      call show_gauss (idout)
	    else
	      call show_gauss_2d (idout)
	    endif
	  elseif (ftyp(1:2).eq.'LO') then
	    call show_lor   (idout)
	  elseif (ftyp(1:2).eq.'FX') then
	    call show_user (idout)
	  endif
	endif
c
	end
c*****7*******************************************************************
	subroutine do_fit_y
c+
c	der eigentliche fit fuer xy-files
c-
	implicit	none
c
	include 	'config.inc'
	include 	'prompt.inc'
	include 	'kuplot.inc'
c
	character*60	filname
	real		xx,f,df(maxpara)
	integer		i,ii,jj,kk
	integer		len_str
c
	call wichtung (y)
	call fit_kupl (y)
c
	ii = offxy(ikfit-1)
	jj = offxy(ikcal-1)
	kk = offxy(ikdif-1)
c
	do i=1,len(ikfit)
	  xx = x(ii+i)
	  call kupl_theory (xx,f,df,-i)
           x(jj+i) = xx
	   y(jj+i) = f
          dx(jj+i) = 0.0
	  dy(jj+i) = 0.0
           x(kk+i) = xx
	   y(kk+i) = y(ii+i)-f
          dx(kk+i) = 0.0
	  dy(kk+i) = 0.0
	enddo
c
	len(ikcal)   = len(ikfit)
	len(ikdif)   = len(ikfit)
	fform(ikcal) = fform(ikfit)
	fform(ikdif) = fform(ikfit)
	filname      = fname(ikfit)
	fname(ikcal) = filname(1:len_str(filname))//'.fit'
	fname(ikdif) = filname(1:len_str(filname))//'.dif'
	call get_extrema
c
	call do_fit_info (output_io,.false.,.false.,.true.)
	end
c*****7*******************************************************************
	subroutine do_fit_z
c+
c	der eigentliche fit fuer xyz-files
c-
	implicit	none
c
	include 	'config.inc'
	include 	'prompt.inc'
	include 	'kuplot.inc'
c
	character*60	filname
	real		xx,f,df(maxpara)
	integer		i,iii
	integer		len_str
c
	call wichtung (z)
	call fit_kupl (z)
c
	do i=1,nx(ikfit)*ny(ikfit)
	  xx =float(i)
	  call kupl_theory (xx,f,df,-i)
	  z(offz(ikcal-1)+i)=f
	  if(z(offz(ikfit-1)+i).ne.-9999) then
	    z(offz(ikdif-1)+i)=z(offz(ikfit-1)+i)-f
	  else
	    z(offz(ikdif-1)+i)=-9999.0
	  endif
	enddo
	do iii=1,nx(ikfit)
          x(offxy(ikcal-1)+iii)=x(offxy(ikfit-1)+iii)
          x(offxy(ikdif-1)+iii)=x(offxy(ikfit-1)+iii)
	enddo
	do iii=1,ny(ikfit)
          y(offxy(ikcal-1)+iii)=y(offxy(ikfit-1)+iii)
          y(offxy(ikdif-1)+iii)=y(offxy(ikfit-1)+iii)
	enddo
c
	lni(ikcal)=.true.
	lni(ikdif)=.true.
	len(ikcal)=len(ikfit)
	len(ikdif)=len(ikfit)
	nx(ikcal) =nx(ikfit)
	ny(ikcal) =ny(ikfit)
	nx(ikdif) =nx(ikfit)
	ny(ikdif) =ny(ikfit)
	fform(ikcal)=fform(ikfit)
	fform(ikdif)=fform(ikfit)
c
	filname=fname(ikfit)
	fname(ikcal)=filname(1:len_str(filname))//'.fit'
	fname(ikdif)=filname(1:len_str(filname))//'.dif'
	call get_extrema
c	
	call do_fit_info (output_io,.false.,.false.,.true.)
	end
c*****7*******************************************************************
	subroutine wichtung (a)
c+
c	berechung der wichtungsfaktoren
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	real		a(maxarray),aaa
	integer		i,ii,m
c
	if (lni(ikfit)) then
	  ii=offz (ikfit-1)
	  m =nx(ikfit)*ny(ikfit)
	else
	  ii=offxy(ikfit-1)
	  m =len(ikfit)
	endif
c
	do i=1,m
	  w(ii+i) = 0.0
	  aaa  = abs(a(ii+i))
	  if (a(ii+i).ne.-9999.0) then 
	    if     (wtyp(1:3).eq.'LOG') then
	      if (aaa.gt.0.0) w(ii+i) = log (aaa)
	    elseif (wtyp(1:3).eq.'SQR') then
	      if (aaa.ge.0.0) w(ii+i) = sqrt(aaa)
	    elseif (wtyp(1:3).eq.'ONE') then
	      w(ii+i) = 1.0
	    elseif (wtyp(1:3).eq.'LIN') then
	      w(ii+i) = aaa
	    elseif (wtyp(1:3).eq.'SQA') then
	      w(ii+i) = aaa**2
	    elseif (wtyp(1:3).eq.'INV') then
	      if (aaa.ne.0.0) w(ii+i) = 1.0/aaa
	    elseif (wtyp(1:3).eq.'ISQ') then
	      if (aaa.gt.0.0) w(ii+i) = 1.0/sqrt(aaa)
	    elseif (wtyp(1:3).eq.'DAT' .and. .not. lni(ikfit)) then
	      w(ii+i) = 1.0/dy(ii+i)
	    endif
	  endif
	enddo
c
	end
c*****7*******************************************************************
	subroutine kupl_theory (xx,f,df,iwert)
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	real		xx,f,df(maxpara)
	integer		iwert
c
	if     (ftyp(1:2).eq.'PO') then
	  call theory_poly (xx,f,df,iwert)
	elseif (ftyp(1:2).eq.'LO') then
	  call theory_lor  (xx,f,df,iwert)
	elseif (ftyp(1:2).eq.'FX') then
	  call theory_user (xx,f,df,iwert)
	elseif (ftyp(1:2).eq.'GA') then
	  if(.not. lni(ikfit)) then
	    call theory_gauss (xx,f,df,iwert)
	  else
	    call theory_gauss_2d (xx,f,df,iwert)
	  endif 
	endif
c
	end
c*****7*******************************************************************
c 	User defined fit function
c*****7*******************************************************************
	subroutine setup_user (ianz,werte,maxw,cpara,lpara)
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
c
	character*200	cpara(maxw),cdummy
	real		dummy,werte(maxw)
	integer		lpara(maxw)
	integer		ianz,ip
c
	real		berechne
c
	if (ianz.eq.2) then
	  ip = nint(werte(1))
	  if (ip.lt.1 .or. ip.gt.maxpara) then
	    ier_num = -31
	    ier_typ = ER_APPL
	    return
	  endif
c
	  npara     = ip
	  fit_func  = cpara(2)(1:lpara(2))
	  fit_lfunc = lpara(2)
	  cdummy    = '('//fit_func(1:fit_lfunc)//')'
	  dummy     = berechne(cdummy,fit_lfunc+2)
c
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*******************************************************************
	subroutine show_user (idout)
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	integer		idout,i
c
	write (idout,1000) fit_func(1:fit_lfunc)
	do i=1,npara
	  write (idout,1100) i,p(i),dp(i),pinc(i)
	enddo
	write (idout,*) ' '
c
1000	format (1x,'Fit function : F = ',a,/)
1100	format (3x,'p(',i2,') : ',g12.6,' +- ',g12.6,4x,'pinc : ',f2.0) 
c
	end
c***********************************************************************
	subroutine theory_user (xx,f,df,i) 
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'param.inc'
c
	character*200	cdummy
	real  		xx,f,df(maxpara)
	real		pb,h,err
	integer		i,ix,iy,ind
c
	real		berechne,dfridr
c
	do ind=1,maxpara
	  df(ind)=0.0
	enddo
c
c-------x und y bestimmen
c
	if (lni(ikfit)) then
	  ix       = (abs(i)-1)/ny(ikfit)+1
	  iy       = abs(i)-(ix-1)*ny(ikfit)
	  rpara(0) = x(offxy(ikfit-1)+ix)
	  rpara(1) = y(offxy(ikfit-1)+iy)
	else
	  rpara(0) = xx
	endif
c
	cdummy = '('//fit_func(1:fit_lfunc)//')'
	f = berechne(cdummy,fit_lfunc+2)
c
c-------ableitungen
c
	if (i.gt.0) then
	  do ind=1,npara
	    if(pinc(ind).ne.0) then
	      h   = 0.1*abs(p(ind))
	      if (h.eq.0) h=0.5
	      pb  = p(ind)
	      np1 = ind
              df(ind) = dfridr(p(ind),h,err)
	      p(ind)  = pb
	    endif
	  enddo
	endif
c
	end
c*****7*******************************************************************
	real function func(xx)
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'param.inc'
c
	character*200	cdummy
	real		xx,berechne
c
	p(np1) = xx
	cdummy = '('//fit_func(1:fit_lfunc)//')'
	func   = berechne(cdummy,fit_lfunc+2)
c
	end
c*****7*******************************************************************
c 	Lorenzian
c*****7*******************************************************************
	subroutine show_lor (idout)
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'wink.inc'
c
	integer		idout,i,iii
	real		zz,sint,ds0,ds2,ds3,dsint
c
	write (idout,1000) np1
	write (idout,1100) 1,p(1),dp(1),pinc(1)
	write (idout,1200) 2,p(2),dp(2),pinc(2)
	do i=1,np1
	  write (idout,1300) i
  	  iii=2+(i-1)*4
	  write (idout,1400) iii+1,p(iii+1),dp(iii+1),pinc(iii+1)
	  write (idout,1500) iii+2,p(iii+2),dp(iii+2),pinc(iii+2)
	  write (idout,1600) iii+3,p(iii+3),dp(iii+3),pinc(iii+3)
	  write (idout,1700) iii+4,p(iii+4),dp(iii+4),pinc(iii+4)
c---------integral berechnen
	  zz    = p(iii+3)/p(iii+4) + p(iii+3)*p(iii+4)
	  sint  = p(iii+1)*zpi*zz 
	  ds0   = zpi*zz
	  ds2   = p(iii+1)*zpi*(1.0/p(iii+4) + p(iii+4))
	  ds3   = p(iii+1)*zpi*(-p(iii+3)/p(iii+4)**2 + p(iii+3))
	  dsint = dp(iii+1)*ds0 + dp(iii+3)*ds2 + dp(iii+4)*ds3 
	  write (idout,1800) sint,dsint
	enddo
	write (idout,*) ' '
c
1000	format (1x,'Fitted',i3,' Lorenzian(s) : '/)
1100	format (3x,'p(',i2,') : backgr. 1 : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0) 
1200	format (3x,'p(',i2,') : backgr. 2 : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1300	format (/,1x,'Lorenzian : ',i3,/)
1400	format (3x,'p(',i2,') : peak      : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1500	format (3x,'p(',i2,') : position  : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1600	format (3x,'p(',i2,') : fwhm      : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1700	format (3x,'p(',i2,') : asymmetry : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1800	format (3x,'        integral  : ',g12.6,' +- ',g12.6)
c
	end
c*****7*******************************************************************
	subroutine setup_lor (ianz,werte,maxw)
c
	implicit	none
c
	integer		maxmax
	parameter	(maxmax=50)
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	real		werte(maxw)
	real		wmax(maxmax)
	integer		ixm(maxmax)
	integer		ianz,ii,jj,ima,i
c
	if     (ianz.eq.0) then
          npara=6
	  np1=1
	elseif (ianz.eq.1) then
	  ii = nint(werte(1))
	  if (ii.gt.0 .and. (2+4*ii).le.maxpara) then
	    np1  =ii
	    npara=2+4*np1
	  else
	    ier_num = -31
	    ier_typ = ER_APPL
	    return
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	ii=offxy(ikfit-1)+1
	jj=offxy(ikfit-1)+len(ikfit)
c
	p(1)   = y(ii)
	pinc(1)=1.0
	p(2)   =(y(jj)-y(ii))/(x(jj)-x(ii))
	pinc(2)=1.0
c
	ifen = fit_ifen
	call do_fmax_xy (ikfit,wmax,ixm,maxmax,ima)
	if (ima.lt.np1) then
	  ier_num = -30
	  ier_typ = ER_APPL
	  call errlist
	  call no_error
	  do i=ima+1,np1
	    wmax(i)=wmax(ima)
	    ixm(i) = ixm(ima)
	  enddo
	endif
c
	if (ier_num.eq.0) then
	  do i=1,np1
	   p   (2+(i-1)*4+1) = wmax(i)
	   pinc(2+(i-1)*4+1) = 1.0
	   p   (2+(i-1)*4+2) = x(ii+ixm(i)-1)
	   pinc(2+(i-1)*4+2) = 1.0
	   p   (2+(i-1)*4+3) = 0.2*abs(x(jj)-x(ii))
	   pinc(2+(i-1)*4+3) = 1.0
	   p   (2+(i-1)*4+4) = 1.0
	   pinc(2+(i-1)*4+4) = 0.0
	  enddo
c
	  do i=1,npara
	    dp(i) = 0.0
	  enddo
	endif
c
	end
c***********************************************************************
	subroutine theory_lor (xx,f,df,i) 
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	real  		xx,f,df(maxpara)
	real		o1,fwf,fw,xw,rn
	integer		i,ind,na,nu,np,nl,nlauf
c
	do ind=1,maxpara
	  df(ind)=0.0
	enddo
c
	o1 = 2.0*atan(1.0)
	nu = 2 
	np = 4 
	nl = np1   
c-------untergrund
	f=p(1)+p(2)*xx
	do nlauf=1,nl
	  na=nu+(nlauf-1)*np+1       
c---------halbwertsbreiten
	  if(xx.le.p(na+1)) then
	    fwf=1.0/p(na+3)
	  else
	    fwf=1.0*p(na+3)
	  endif     
	  fw=p(na+2)*fwf
          xw=xx-p(na+1)
	  rn=(fw*fw + 4.0*xw*xw)
c---------funktionswert berechnen	 
	  f=f+p(na)*fw*fw/rn
c---------ableitungen berechnen
	  if(i.gt.0) then            
	    if(pinc(na).ne.0) 
     &	      df(na)  =fw*fw/rn
	    if(pinc(na+1).ne.0)
     &	      df(na+1)=8.0*p(na)*fw*fw*xw/(rn**2)
	    if(pinc(na+2).ne.0)                  
     &	      df(na+2)=2*p(na)*fw/rn - 2*p(na)*fw*fw*fw/(rn**2)
     	    if(pinc(na+3).ne.0) then
	      if(xx.le.p(na+1)) then 
	        df(na+3)=-df(na+2)*(2.0*(xx-p(na+1))**2*o1/(fw**3))*
     &			  p(na+2)/(p(na+3)**2)
	      else
	        df(na+3)= df(na+2)*(2.0*(xx-p(na+1))**2*o1/(fw**3))*
     &			  p(na+3)
	      endif
	    endif       
	  endif
	enddo
c-------untergrundsableitungen
	if (i.gt.0) then
	  if(pinc(1).ne.0) df(1) = 1.0    
	  if(pinc(2).ne.0) df(2) = xx
	endif
c
	end
c*****7*******************************************************************
c	Gaussian (1D)
c*****7*******************************************************************
	subroutine show_gauss (idout)
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'wink.inc'
c
	real		o,sqpio,zz,sint,ds0,ds2,ds3,dsint
	integer		idout,i,iii
c
	o     = sqrt(4.0*alog(2.0))
	sqpio = sqrt(pi)/o*0.5
c
	write (idout,1000) np1
	write (idout,1100) 1,p(1),dp(1),pinc(1)
	write (idout,1200) 2,p(2),dp(2),pinc(2)
	do i=1,np1
	  write (idout,1300) i
  	  iii=2+(i-1)*4
	  write (idout,1400) iii+1,p(iii+1),dp(iii+1),pinc(iii+1)
	  write (idout,1500) iii+2,p(iii+2),dp(iii+2),pinc(iii+2)
	  write (idout,1600) iii+3,p(iii+3),dp(iii+3),pinc(iii+3)
	  write (idout,1700) iii+4,p(iii+4),dp(iii+4),pinc(iii+4)
c---------integral berechnen
	  zz    = p(iii+3)/p(iii+4) + p(iii+3)*p(iii+4)
	  sint  = p(iii+1)*sqpio*zz 
	  ds0   = sqpio*zz
	  ds2   = p(iii+1)*sqpio*(1.0/p(iii+4) + p(iii+4))
	  ds3   = p(iii+1)*sqpio*(-p(iii+3)/p(iii+4)**2 + p(iii+3))
	  dsint = dp(iii+1)*ds0 + dp(iii+3)*ds2 + dp(iii+4)*ds3 
	  write (idout,1800) sint,dsint
	enddo
	write (idout,*) ' '
c
1000	format (1x,'Fitted',i3,' Gaussian(s) : '/)
1100	format (3x,'p(',i2,') : backgr. 1 : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0) 
1200	format (3x,'p(',i2,') : backgr. 2 : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1300	format (/,1x,'Gaussian : ',i3,/)
1400	format (3x,'p(',i2,') : peak      : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1500	format (3x,'p(',i2,') : position  : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1600	format (3x,'p(',i2,') : fwhm      : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1700	format (3x,'p(',i2,') : asymmetry : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1800	format (3x,'        integral  : ',g12.6,' +- ',g12.6)
c
	end
c*****7*******************************************************************
	subroutine setup_gauss (ianz,werte,maxw)
c
	implicit	none
c
	integer		maxmax
	parameter	(maxmax=50)
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	real		werte(maxw)
	real		wmax(maxmax)
	integer		ixm(maxmax)
	integer		ianz,ii,jj,ima,i
c
	if     (ianz.eq.0) then
          npara=6
	  np1=1
	elseif (ianz.eq.1) then
	  ii = nint(werte(1))
	  if (ii.gt.0 .and. (2+4*ii).le.maxpara) then
	    np1  =ii
	    npara=2+4*np1
	  else
	    ier_num = -31
	    ier_typ = ER_APPL
	    return
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	ii=offxy(ikfit-1)+1
	jj=offxy(ikfit-1)+len(ikfit)
c
	p(1)   = y(ii)
	pinc(1)=1.0
	p(2)   =(y(jj)-y(ii))/(x(jj)-x(ii))
	pinc(2)=1.0
c
	ifen = fit_ifen
	call do_fmax_xy (ikfit,wmax,ixm,maxmax,ima)
	if (ima.lt.np1) then
	  ier_num = -30
	  ier_typ = ER_APPL
	  call errlist
	  call no_error
	  do i=ima+1,np1
	    wmax(i)=wmax(ima)
	    ixm(i) = ixm(ima)
	  enddo
	endif
c
	if (ier_num.eq.0) then
	  do i=1,np1
	   p   (2+(i-1)*4+1) = wmax(i)
	   pinc(2+(i-1)*4+1) = 1.0
	   p   (2+(i-1)*4+2) = x(ii+ixm(i)-1)
	   pinc(2+(i-1)*4+2) = 1.0
	   p   (2+(i-1)*4+3) = 0.2*abs(x(jj)-x(ii))
	   pinc(2+(i-1)*4+3) = 1.0
	   p   (2+(i-1)*4+4) = 1.0
	   pinc(2+(i-1)*4+4) = 0.0
	  enddo
c
	  do i=1,npara
	    dp(i) = 0.0
	  enddo
	endif
c
	end
c***********************************************************************
	subroutine theory_gauss (xx,f,df,iwert) 
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	real  		xx,f,df(maxpara)
	real		o1,fw,fwf,exx
	integer		iwert,ind,nunt,npar
	integer		nlauf,na
c
	o1  =4.0*alog(2.0)
	nunt=2
	npar=4
c
	do ind=1,npara
	  df(ind)=0.0
	enddo
c-------untergrund
	f=p(1)+p(2)*xx
	do nlauf=1,np1
	  na=nunt+(nlauf-1)*npar+1       
c---------halbwertsbreiten
	  if(xx.le.p(na+1)) then
	    fwf=1.0/p(na+3)
	  else
	    fwf=1.0*p(na+3)
	  endif     
	  fw=p(na+2)*fwf
c---------funktionswert berechnen	 
	  exx=exp(-(xx-p(na+1))**2*o1/(fw**2))
	  f=f+p(na)*exx                         
c---------ableitungen berechnen
	  if(iwert.gt.0) then            
	    if(pinc(na).ne.0) df(na)=exx
	    if(pinc(na+1).ne.0)
     &	      df(na+1)=p(na)*exx*(2.0*o1*(xx-p(na+1))/fw**2)
	    if(pinc(na+2).ne.0)                  
     &	      df(na+2)=p(na)*exx*(2.0*(xx-p(na+1))**2*o1*fwf/(fw**3))
     	    if(pinc(na+3).ne.0) then
	      if(xx.le.p(na+1)) then 
	        df(na+3)=-p(na)*exx*(2.0*(xx-p(na+1))**2*o1/(fw**3))*
     &			  p(na+2)/(p(na+3)**2)
	      else
	        df(na+3)= p(na)*exx*(2.0*(xx-p(na+1))**2*o1/(fw**3))*
     &			  p(na+3)
	      endif
	    endif       
	  endif
	enddo
c-------untergrundsableitungen
	if (iwert.gt.0) then
	  if(pinc(1).ne.0) df(1) = 1.0    
	  if(pinc(2).ne.0) df(2) = xx
	endif
c
	end
c*****7*******************************************************************
c	Gaussian (2D)
c*****7*******************************************************************
	subroutine show_gauss_2d (idout)
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'wink.inc'
c
	real		o,sqpio,sqpio2
	real		zz_x,zz_y,sint,ds0,ds3,ds4,ds6,ds7,dsint
	integer		idout,i,iii
c
	o      = sqrt(4.0*alog(2.0))
	sqpio  = sqrt(pi)/o*0.5
	sqpio2 = sqpio*sqpio
c
	write (idout,1000) np1
	write (idout,1100) 1,p(1),dp(1),pinc(1)
	do i=1,np1
	  write (idout,1300) i
  	  iii=1+(i-1)*8
	  write (idout,1400) iii+1,p(iii+1),dp(iii+1),pinc(iii+1)
	  write (idout,1410) iii+2,p(iii+2),dp(iii+2),pinc(iii+2)
	  write (idout,1420) iii+3,p(iii+3),dp(iii+3),pinc(iii+3)
	  write (idout,1430) iii+4,p(iii+4),dp(iii+4),pinc(iii+4)
	  write (idout,1440) iii+5,p(iii+5),dp(iii+5),pinc(iii+5)
	  write (idout,1450) iii+6,p(iii+6),dp(iii+6),pinc(iii+6)
	  write (idout,1460) iii+7,p(iii+7),dp(iii+7),pinc(iii+7)
	  write (idout,1470) iii+8,p(iii+8),dp(iii+8),pinc(iii+8)
	  zz_x   = p(iii+4)/p(iii+7) + p(iii+4)*p(iii+7)
	  zz_y   = p(iii+5)/p(iii+8) + p(iii+5)*p(iii+8)
	  sint   = p(iii+1)*sqpio2*zz_x*zz_y
	  ds0    = sqpio2*zz_x*zz_y
	  ds3    = p(iii+1)*sqpio2*zz_y*(1.0/p(iii+7) + p(iii+7))
	  ds4    = p(iii+1)*sqpio2*zz_x*(1.0/p(iii+8) + p(iii+8))
	  ds6    = p(iii+1)*sqpio2*zz_y*
     &	       	   (-p(iii+4)/p(iii+7)**2 + p(iii+4))
	  ds7    = p(iii+1)*sqpio2*zz_x*
     &		   (-p(iii+5)/p(iii+8)**2 + p(iii+5))
	  dsint  = dp(iii+1)*ds0 + dp(iii+4)*ds3 + dp(iii+5)*ds4 +
     &	                           dp(iii+7)*ds6 + dp(iii+8)*ds7
	  write (idout,1800) sint,dsint
	enddo
	write (idout,*) ' '
c
1000	format (1x,'Fitted',i3,' Gaussian(s) : '/)
1100	format (3x,'p(',i2,') : backgr. 1 : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0) 
1300	format (/,1x,'Gaussian : ',i3,/)
1400	format (3x,'p(',i2,') : peak      : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1410	format (3x,'p(',i2,') : position x: ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1420	format (3x,'p(',i2,') : position y: ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1430	format (3x,'p(',i2,') : fwhm a    : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1440	format (3x,'p(',i2,') : fwhm b    : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1450	format (3x,'p(',i2,') : angle a,x : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1460	format (3x,'p(',i2,') : asym. a   : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1470	format (3x,'p(',i2,') : asym. b   : ',g12.6,' +- ',g12.6,
     &	        4x,'pinc : ',f2.0)
1800	format (3x,'        integral  : ',g12.6,' +- ',g12.6)
c
	end
c*****7*******************************************************************
	subroutine setup_gauss_2d (ianz,werte,maxw)
c
	implicit	none
c
	integer		maxmax
	parameter	(maxmax=20)
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	real		werte(maxw)
	real		wmax(maxmax)
	integer		ixm(maxmax),iym(maxmax)
	integer		ianz,ima,ii,jj,i
c
	if     (ianz.eq.0) then
          npara=1+8
	  np1=1
	elseif (ianz.eq.1) then
	  ii = nint(werte(1))
	  if (ii.gt.0 .and. (1+8*ii).le.maxpara) then
	    np1  =ii
	    npara=1+8*np1
	  else
	    ier_num = -31
	    ier_typ = ER_APPL
	    return
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	ii=offxy(ikfit-1)
	jj=offz (ikfit-1)
c
c-------untergrund = wert li unten
c
	p(1)   = z(jj+1)
	pinc(1)= 1.0
c
c-------nach lokalen maxima suchen
c
	ifen = fit_ifen
	call do_fmax_z (ikfit,wmax,ixm,iym,maxmax,ima)
	if (ima.lt.np1) then
	  ier_num = -30
	  ier_typ = ER_APPL
	  call errlist
	  call no_error
	  do i=ima+1,np1
	    wmax(i)=wmax(ima)
	    ixm(i) = ixm(ima)
	    iym(i) = iym(ima)
	  enddo
	endif
c
c-------parameter setzen
c	
	if (ier_num.eq.0) then
	  do i=1,np1
	    p   (1+(i-1)*8+1) = wmax(i)
	    pinc(1+(i-1)*8+1) = 1.0
	    p   (1+(i-1)*8+2) = x(ii+ixm(i))
	    pinc(1+(i-1)*8+2) = 1.0
	    p   (1+(i-1)*8+3) = y(ii+iym(i))
	    pinc(1+(i-1)*8+3) = 1.0
	    p   (1+(i-1)*8+4) = 0.2*abs(x(ii+nx(ikfit))-x(ii+1))
	    pinc(1+(i-1)*8+4) = 1.0
	    p   (1+(i-1)*8+5) = 0.2*abs(y(ii+ny(ikfit))-y(ii+1))
	    pinc(1+(i-1)*8+5) = 1.0
	    p   (1+(i-1)*8+6) = 0.0
	    pinc(1+(i-1)*8+6) = 0.0
	    p   (1+(i-1)*8+7) = 1.0
	    pinc(1+(i-1)*8+7) = 0.0
	    p   (1+(i-1)*8+8) = 1.0
	    pinc(1+(i-1)*8+8) = 0.0
	  enddo
c
	  do i=1,npara
	    dp(i) = 0.0
	  enddo
	endif
c
	end
c***********************************************************************
	subroutine theory_gauss_2d (xx,f,df,i) 
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'wink.inc'
c
	real  		xx,f,o1,df(maxpara)
	real		rx,ry,rxs,rys,fwfx,fwx,fwfy,fwy,cosp,sinp
	real		exx,eyy,dfxs,dfys
	integer		i,ind,nlauf,na,nu,np,ng,ix,iy
c
	do ind=1,maxpara
	  df(ind)=0.0
	enddo
c
	o1 = 4.0*alog(2.0)
	nu = 1 
	np = 8 
	ng = np1   
c-------x und y bestimmen
	ix=(abs(i)-1)/ny(ikfit)+1
	iy=abs(i)-(ix-1)*ny(ikfit)
	rx=x(offxy(ikfit-1)+ix)
	ry=y(offxy(ikfit-1)+iy)
c-------untergrund
	f=p(1)
	do nlauf=1,ng
	  na=nu+(nlauf-1)*np+1       
c---------sinus und cosinus berechnen
	  cosp=cos(rad*p(na+5))
	  sinp=sin(rad*p(na+5))
c---------transformation in hautachsensystem
	  rxs= cosp*(rx-p(na+1)) + sinp*(ry-p(na+2))
	  rys=-sinp*(rx-p(na+1)) + cosp*(ry-p(na+2))
c---------halbwertsbreiten
	  if(rxs.le.0.0) then
	    fwfx=1.0/p(na+6)
	  else
	    fwfx=1.0*p(na+6)
	  endif     
	  fwx=p(na+3)*fwfx
	  if(rys.le.0.0) then
	    fwfy=1.0/p(na+7)
	  else
	    fwfy=1.0*p(na+7)
	  endif     
	  fwy=p(na+4)*fwfy
c---------funktionswert berechnen	 
	  exx=exp(-rxs**2*o1/(fwx**2))
	  eyy=exp(-rys**2*o1/(fwy**2))
	  f=f+p(na)*exx*eyy                         
c---------ableitungen berechnen
	  if(i.gt.0) then            
	    if(pinc(na).ne.0) df(na)=exx*eyy
     	    dfxs=p(na)*eyy*exx*(-2*rxs*o1/(fwx**2))
     	    dfys=p(na)*eyy*exx*(-2*rys*o1/(fwy**2)) 
	    if(pinc(na+1).ne.0)
     &	      df(na+1)=-cosp*dfxs + sinp*dfys
	    if(pinc(na+2).ne.0)                  
     &	      df(na+2)=-sinp*dfxs - cosp*dfys
	    if(pinc(na+3).ne.0)                  
     &	      df(na+3)=p(na)*eyy*exx*(2*rxs**2*o1*fwfx/(fwx**3))
  	    if(pinc(na+4).ne.0)                  
     &	      df(na+4)=p(na)*eyy*exx*(2*rys**2*o1*fwfy/(fwy**3))
	    if(pinc(na+5).ne.0)
     &	     df(na+5)=(-(rx-p(na+1))*sinp+(ry-p(na+2))*cosp)*dfxs*rad+
     &	              (-(rx-p(na+1))*cosp-(ry-p(na+2))*sinp)*dfys*rad
     	    if(pinc(na+6).ne.0) then
	      if(rxs.le.0.0) then 
	        df(na+6)=-p(na)*eyy*exx*(2*rxs**2*o1/(fwx**3))*
     &			  p(na+3)/(p(na+6)**2)
	      else
	        df(na+6)=p(na)*eyy*exx*(2*rxs**2*o1/(fwx**3))*p(na+3)
	      endif
	    endif       
     	    if(pinc(na+7).ne.0) then
	      if(rys.le.0.0) then 
	        df(na+7)=-p(na)*eyy*exx*(2*rys**2*o1/(fwy**3))*
     &			  p(na+4)/(p(na+7)**2)
	      else
	        df(na+7)=p(na)*eyy*exx*(2*rys**2*o1/(fwy**3))*p(na+4)
	      endif       
	    endif 
	  endif
	enddo
c-------untergrundsableitungen
	if (i.gt.0) then
	  if(pinc(1).ne.0) df(1) =1.0     
	endif
c
	end
c*****7*******************************************************************
c	Polynom
c*****7*******************************************************************
	subroutine show_poly (idout)
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	integer		idout,i
c
	write (idout,1000) np1
	do i=0,np1
	  write (idout,1100) i+1,i,p(i+1),dp(i+1),pinc(i+1)
	enddo
	write (idout,*) ' '
c
1000	format (1x,'Fitted polynom of order ',i2,' : '/)
1100	format (3x,'p(',i2,') : coeff. for x**',i2,' : ',g12.6,
     &	        ' +- ',g12.6,4x,'pinc : ',f2.0) 
c
	end
c*****7*******************************************************************
	subroutine setup_poly (ianz,werte,maxw)
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	real		werte(maxw)
	integer		ianz,ii,jj,i
c
	if     (ianz.eq.0) then
	  npara=1
	  np1=1
	elseif (ianz.eq.1) then
	  ii = nint(werte(1))
	  if (ii.ge.0 .and. (1+ii).le.maxpara) then
	    np1  =ii
	    npara=ii+1
	  else
	    ier_num = -31
	    ier_typ = ER_APPL
	    return
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	ii=offxy(ikfit-1)+1
	jj=offxy(ikfit-1)+len(ikfit)
c
	p(1)   = y(ii)
	pinc(1)=1.0
	p(2)   =(y(jj)-y(ii))/(x(jj)-x(ii))
	pinc(2)=1.0
	do i=3,npara
	  p(i)   =0.0
	  pinc(i)=1.0
	enddo
c
	do i=1,npara
	  dp(i) = 0.0
	enddo
c
	end
c*****7*******************************************************************
	subroutine theory_poly (xx,f,df,iwert)
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	real		xx,f,df(maxpara)
	integer		iwert,ind
c
	do ind=1,npara
	  df(ind)=0.0
	enddo
c
	f=p(1)
	do ind=1,np1
	  if (xx.ne.0) f=f + p(ind+1)*(xx**ind)
	enddo
c-------ableitungen
	if (iwert.gt.0) then
	  do ind=0,np1
	    if(pinc(ind+1).ne.0) then
              df(ind+1)=(xx**ind)
	    endif
	  enddo
	endif
c
	end
c*****7*******************************************************************
c	Altered subroutine FITTE for KUPLOT use
c*****7*******************************************************************
	subroutine fit_kupl (ww)
c+
c	eigentliche fit-routine speziell fuer kupl ..
c-
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
c
	real		ww(maxarray)
	real		df(maxpara),dl(maxpara),dz(maxpara),pl(maxpara)
	real		pinc_old(maxpara)
c
	if (lni(ikfit)) then
	  iiw = offz (ikfit-1)
	  iix = offxy(ikfit-1)
	  m   = nx(ikfit)*ny(ikfit)
	else
	  iiw = offxy(ikfit-1)
	  iix = offxy(ikfit-1)
	  m   = len(ikfit)
	endif
c
	do i=1,npara
	  pinc_old(i)=pinc(i)
	enddo
c
  	if (fstart) write(output_io,5000)
	n = npara
      	j = 0
10    	continue
	zwert= 0.0
      	do k = 1,n
          dz(k) = 0.0
          do l = k,n
            cl(l,k) = 0.0
	  enddo
	enddo
      	do i = 1,m
      	  xx = x(iix+i)
          call kupl_theory (xx,f,df,i)
          s = ww(iiw+i) - f
	  if(wtyp.eq.'BCK') then
	    if(ww(iiw+i).ne.-9999.) then
	      w(iiw+i) = exp(-wval*s)
	    else
	      w(iiw+i) = 0.0
	    endif
	  endif
          zwert= zwert+ w(iiw+i) * s*s
          do k = 1,n
      	    if(abs(df(k)).lt.0.0000001)df(k)=0.0
            ttt = w(iiw+i) * df(k)
            dz(k) = dz(k) - s * ttt
            do l = k,n
              cl(l,k) = cl(l,k) + ttt * df(l)
	    enddo
	  enddo
	enddo
      	f = 1.0
      	if (urf) 60,60,40
40    	continue
	h = 0.0
      	do k = 1,n
     	  if (dz(k).ne.0.0) h=h+(dz(k)*dz(k))/(zwert*cl(k,k))
	enddo
      	f = 1.000001 + urf * h
60    	continue
  	if (fstart) write (output_io,5010) j,zwert,f
      	zalt=zl
      	zdif=zwert-zl
      	fend=f
      	if (j)    80,80,70
70    	continue
	if (zwert-zl) 80,300,300
80    	continue
	zl=zwert    
      	do k = 1,n
          pl(k) =p(k)
	enddo
      	do k =1,n
          do l = 1,k
            l1=l-1
            s=cl(k,l)
            if (l-k) 100,140,100
100         if (l1)  130,130,110
110         do i = 1,l1
              s=s - cl(i,l)*cl(i,k)
	    enddo
130         cl(l,k) = s
	  enddo
140       if (s)  145,142,145
142   	  dl(k)=0.0
      	  goto 190
145       s = s*f
          if (l1)   170,170,150
150       do i=1,l1
            ttt = cl(i,k)
            cl(i,k) = ttt*dl(i)
            s = s - ttt*cl(i,k)  
	  enddo
170       if (s)    190,190,180
180       dl(k)=1.0/s
190       continue 
	enddo
      	if (j-ncycle)  200,200,300
200   	j=j+1
      	if (n-1)  230,230,210
210   	do l=2,n
          l1=l-1
          do k=1,l1
            dz(l)=dz(l)-cl(k,l)*dz(k)
	  enddo
	enddo
230   	dz(n)=dz(n)*dl(n)
      	if (n-1)   260,260,240
240   	do nl=2,n
          l=n-nl+1
          l1=l+1
          dz(l)=dz(l)*dl(l)
          do k=l1,n
            dz(l)=dz(l) - cl(l,k)*dz(k)
	  enddo
	enddo
260   	do k=1,n
          pinc(k)=0.01*dz(k)
          p(k)=p(k)-dz(k)
	enddo
c
      	goto 10
c
300   	g=1.0
      	h=float(m-n)
      	if (h*zl.gt.0.0)  g=zl/h
      	do k=1,n
          dl(k)=dl(k)*g
          cl(k,k)=1.0 
	enddo
      	if (n-1)   350,350,320
320   	do l=2,n
          l1=l-1
          do k=1,l1
            s=0.0
            do i=k,l1
              s=s-cl(i,l)*cl(i,k)
	    enddo
            cl(l,k)=s 
    	  enddo
	enddo
350   	do k=1,n
      	  do l=k,n
            s=0.0
            if (l-k)   380,360,380
360         do i=l,n
              ttt=cl(i,k)
              cl(i,k)=ttt*dl(i)
              s=s+ttt*cl(i,k)
	    enddo
            goto 400
380         do i=l,n
              s=s+cl(i,l)*cl(i,k) 
	    enddo
400	    continue
            cl(l,k)=s
	  enddo
	enddo
      	do l=1,n
          if (dl(l)) 502,501,502
501    	  dp(l)=1.0
          dp(l)=0.0      
          goto 570
502       f=sqrt(cl(l,l))
          dp(l)=f
          do k= 1,l
            dz(k)=cl(l,k)/f
	  enddo
          do k=l,n
            dz(k)=cl(k,l)/f 
	  enddo
          do k=1,l
            if(dp(k).eq.0.0) then
              cl(l,k)=dz(k)
            else
              cl(l,k)=dz(k)/dp(k)
            endif      
	  enddo
570       continue   
	enddo  
c
      	do k=1,n
          p(k)= pl(k)
	enddo
      	sqsum=0.0
      	syi  =0.0
      	sum3 =0.0
      	sum4 =0.0
      	nf=n
      	do i=1,n
     	  if(df(i).eq.0.) nf=nf-1 
	enddo
      	do i= 1,m
      	  xx=x(iix+i)
          call kupl_theory (xx,f,df,-i)
          h=ww(iiw+i) - f
	  if(wtyp.eq.'BCK') then
	    if(ww(iiw+i).ne.-9999.) then
	      w(iiw+i) = exp(-wval*s)
	    else
	      w(iiw+i) = 0.0
	    endif
	  endif
          sum3  = sum3 + w(iiw+i) * h*h
          sum4  = sum4 + w(iiw+i) * ww(iiw+i)*ww(iiw+i)
	enddo
      	r4   = sqrt(sum3 / sum4)
      	re   = sqrt((m-nf)/sum4)
c
	do i=1,npara
	  pinc(i)=pinc_old(i)
	enddo
  	if (fstart) write(output_io,*)
c
5000	format (' Starting least square fit ... ',/)
5010	format (3x,'cycle:',i4,3x,'sum: ',g12.6,3x,' urf: ',g12.6)
c
      	end
c*****7*******************************************************************
c	Routine zur Berechnung der Ableitung aus RECIPES
c*****7*******************************************************************
	function dfridr(x,h,err)
	integer ntab
	real dfridr,err,h,x,func,con,con2,big,safe
	parameter (con=1.4,con2=con*con,big=1.e30,ntab=10,safe=2.)
	integer i,j
	real errt,fac,hh,a(ntab,ntab)
c
	if(h.eq.0.) pause 'h must be nonzero in dfridr'
	hh=h
	a(1,1)=(func(x+hh)-func(x-hh))/(2.0*hh)
	err=big
	do i=2,ntab 
	  hh=hh/con
	  a(1,i)=(func(x+hh)-func(x-hh))/(2.0*hh) 
	  fac=con2
	  do j=2,i
	    a(j,i)=(a(j-1,i)*fac-a(j-1,i-1))/(fac-1.)
	    fac=con2*fac
    	    errt=max(abs(a(j,i)-a(j-1,i)),abs(a(j,i)-a(j-1,i-1)))
	    if (errt.le.err) then
	      err=errt
	      dfridr=a(j,i)
	    endif
	  enddo
	  if(abs(a(i,i)-a(i-1,i-1)).ge.SAFE*err)return
	enddo
	return
	end
