c*****7*****************************************************************
c+
c	This routine interprets the commands and executes the 
c	corresponding function.
c
c	Version : 4.0
c	Date    : 10 Oct 96
c
c	Author  : Th. Proffen  (tproffen@lanl.gov )
c*****7*****************************************************************
	subroutine mache_kdo(line,lend,length)
c
c	Main menu for KUPLOT
c
	implicit     none
c
	include      'config.inc'
	include      'kuplot.inc'
	include      'learn.inc'
	include      'prompt.inc'
	include      'errlist.inc'
c
	integer       maxw
	parameter    (maxw=1)
c
	character*200 line,zei,command,cpara(maxw)
	character*4   bef
	real          dummy
	integer       lpara(maxw)
	integer       lc,lbef,length
	integer       ianz,indxg,indxb
	logical       lend,ldummy
c
	logical       str_comp
c
	save          command
c
	call no_error
c
c------ If a commentary return immediately
c
	if(line(1:1).eq.' ' .or. line(1:1).eq.'#' .or. 
     &	   line(1:1).eq.'!' .or. length.eq.0           ) return
c
c------	Only the first 4 characters are significant. The command consists
c	of the four nonblank characters 
c
	bef = '    '
	indxb  = index(line,' ')
	lbef   = min(indxb-1,4)
	bef = line(1:lbef )
c
c------	command parameters start at the first character following the blank
c
	zei = ' '
	lc = 0
	if(indxb+1.le.length) then
	  zei = line(indxb+1:length)
	  lc = length - indxb
	endif
c
c-------Suche nach einem "="
c
	indxg=index(line,'=')
        if(indxg.ne.0.and..not.(str_comp(bef,'echo',2,lbef,4))
     &               .and..not.(str_comp(bef,'syst',2,lbef,4))
     &               .and..not.(str_comp(bef,'achx',2,lbef,4))
     &               .and..not.(str_comp(bef,'achy',2,lbef,4))
     &               .and..not.(str_comp(bef,'tit1',2,lbef,4))
     &               .and..not.(str_comp(bef,'tit2',2,lbef,4))
     &               .and..not.(str_comp(bef,'sleg',2,lbef,4))
     &               .and..not.(str_comp(bef,'sann',2,lbef,4))
     &               .and..not.(str_comp(bef,'fput',2,lbef,4))
     &               .and..not.(str_comp(bef,'help',2,lbef,4) .or.
     &	                        str_comp(bef,'?   ',2,lbef,4)) )then
c
c-------Zuweisung eines Funktionswertes
c
	  call do_math(line,indxg,length)
	else
c
c------	--execute a macro file
c
	  if(bef(1:1).eq.'@') then
	    if(length.ge.2) then
	      call file_kdo(line(2:length),length-1)
	    else
	      ier_num = -13
	      ier_typ = ER_MAC
	    endif
c
c------ Terminate KUPLOT 'exit'
c
	  elseif(str_comp(bef,'exit',2,lbef,4)) then
	    lend=.true.
c
c-------  Start of KUPLOT specific commands
c-------  Allocate memory for new dataset 
c
	  elseif(str_comp(bef,'allocate',2,lbef,8)) then
	    call do_allocate(zei,lc)
c
c-------  Set bond drawing options
c
	  elseif(str_comp(bef,'bond',2,lbef,4)) then
	    call set_bond(zei,lc)
c
c-------  Perform calculations, merge and rebin
c
	  elseif(str_comp(bef,'ccal',3,lbef,4)) then
	    call do_calc(zei,lc)
	  elseif(str_comp(bef,'conv',3,lbef,4)) then
	    call do_convolute(zei,lc)
	  elseif(str_comp(bef,'exclude',3,lbef,7)) then
	    call do_exclude(zei,lc)
	  elseif(str_comp(bef,'kcal',3,lbef,4)) then
	    call do_kmath(zei,lc)
	  elseif(str_comp(bef,'merge',3,lbef,5)) then
	    call do_merge(zei,lc)
	  elseif(str_comp(bef,'rebin',3,lbef,5)) then
	    call do_rebin(zei,lc)
c
c-------  Set colours
c
	  elseif(str_comp(bef,'color',3,lbef,4)) then
	    call set_color(zei,lc)
c
c-------  Set bitmap colormap
c
	  elseif(str_comp(bef,'cmap',3,lbef,4)) then
	    call set_cmap(zei,lc)
c
c-------  Calculate derivative
c
	  elseif(str_comp(bef,'derivative',3,lbef,10)) then
	    call do_derivative(zei,lc)
c
c-------  Set fill parameters
c
	  elseif(str_comp(bef,'fill',3,lbef,4)) then
	    call set_fill(zei,lc)
c
c-------  Enter fit sublevel
c
	  elseif(str_comp(bef,'fit',3,lbef,3)) then
	    call do_fit(zei,lc)
c
c-------  Plot filenames on plot
c
	  elseif(str_comp(bef,'fnam',3,lbef,4)) then
	    call get_params(zei,ianz,cpara,lpara,maxw,lc)
	    if (ier_num.ne.0) return
	    ifname(iwin,iframe)=str_comp(cpara(1),'on',2,lpara(1),2)
c
c-------  Set typ of box & axis
c
	  elseif(str_comp(bef,'fset',3,lbef,4)) then
	    call set_ibox(zei,lc)
c
c-------  Set font size, type and color
c
	  elseif(str_comp(bef,'font',3,lbef,4)) then
	    call set_font(zei,lc)
c
c-------  Plot frame around plot/frames
c
	  elseif(str_comp(bef,'fram',3,lbef,4)) then
	    call get_params(zei,ianz,cpara,lpara,maxw,lc)
	    if (ier_num.ne.0) return
	    tot_frame(iwin)=str_comp(cpara(1),'on',2,lpara(1),2)
c
c-------  Calculate Fourier Transform from data set
c
	  elseif(str_comp(bef,'four',2,lbef,4)) then
	    call do_four(zei,lc)
c
c-------  Create data set from function
c
	  elseif(str_comp(bef,'func',2,lbef,4)) then
	    call do_func(zei,lc)
c
c-------  smooth data 'glat' and 'smooth'
c
	  elseif(str_comp(bef,'glat',2,lbef,4)) then
	    call do_glat(zei,lc,.false.)
	  elseif(str_comp(bef,'smooth',3,lbef,6)) then
	    call do_glat(zei,lc,.true.)
c
c-------  grid on/off
c
	  elseif(str_comp(bef,'grid',3,lbef,4)) then
	    call get_params(zei,ianz,cpara,lpara,maxw,lc)
	    if (ier_num.ne.0) return
	    igrid(iwin,iframe)=str_comp(cpara(1),'on',2,lpara(1),2)
c
c-------  ident on/off
c
	  elseif(str_comp(bef,'ident',3,lbef,5)) then
	    call get_params(zei,ianz,cpara,lpara,maxw,lc)
	    if (ier_num.ne.0) return
	    iden(iwin)=str_comp(cpara(1),'on',2,lpara(1),2)
c
c-------  set contour line parameters
c
	  elseif(str_comp(bef,'hlin',3,lbef,4)) then
	    call set_hlin(zei,lc)
	  elseif(str_comp(bef,'hcol',3,lbef,4)) then
	    call para_setii(zei,lc,hlinecol,maxkurvtot,maxhl,bef,1,15)
	  elseif(str_comp(bef,'htyp',3,lbef,4)) then
	    call para_setii(zei,lc,hlinetyp,maxkurvtot,maxhl,bef,0,5)
	  elseif(str_comp(bef,'hpak',3,lbef,4)) then
	    call set_hpak(zei,lc)
c
c-------  calculate integral
c
	  elseif(str_comp(bef,'inte',2,lbef,4)) then
	    call do_inte(zei,lc)
c
c-------  Interpolate function on grid of other function
c
	  elseif(str_comp(bef,'spline',3,lbef,6)) then
	    call do_interpolate(zei,lc)
c
c-------  save data set
c
	  elseif(str_comp(bef,'ksav',2,lbef,4)) then
	    call do_ksav(zei,lc)
c
c-------  Load files 'load'
c
	  elseif(str_comp(bef,'load',2,lbef,4)) then
	    call do_load(zei,lc)
c
c-------  Set line width
c
	  elseif(str_comp(bef,'lwid',2,lbef,4)) then
	    call set_linewidth(zei,lc)
c
c-------  Set tick marks
c
	  elseif(str_comp(bef,'mark',3,lbef,4)) then
	    call set_mark(zei,lc)
c
c-------  Match data sets
c
	  elseif(str_comp(bef,'match',3,lbef,4)) then
	    call do_match(zei,lc)
c
c-------  Activate mouse menu
c
	  elseif(str_comp(bef,'mouse',3,lbef,5)) then
	    call do_mouse(zei,lc)
c
c-------  Calculate averages, ..
c
	  elseif(str_comp(bef,'mean',3,lbef,4)) then
	    call do_mean(zei,lc,.true.)
c
c-------  Set marker size
c
	  elseif(str_comp(bef,'msize',2,lbef,5)) then
	    call set_sizemark(zei,lc)
c
c-------  set landscape / portrait orientation
c
	  elseif(str_comp(bef,'orient',3,lbef,6)) then
	    call get_params(zei,ianz,cpara,lpara,maxw,lc)
	    if (ier_num.ne.0) return
	    ldummy=str_comp(cpara(1),'landscape',1,lpara(1),9)
	    if (ldummy.neqv.orient(iwin)) then
	      orient(iwin)     = ldummy
	      dummy            = dev_width(iwin)
	      dev_width(iwin)  = dev_height(iwin)
	      dev_height(iwin) = dummy
	    endif
c
c-------  Setting plotting window
c
	  elseif(str_comp(bef,'window',2,lbef,6)) then
	    call set_window(zei,lc)
c
c-------  Here are all frame related commands: nfra,afra,kfra,...
c
	  elseif(str_comp(bef,'nfra',2,lbef,4)) then
	    call set_nfra(zei,lc)
	  elseif(str_comp(bef,'kfra',2,lbef,4)) then
	    call set_kfra(zei,lc)
	  elseif(str_comp(bef,'sfra',2,lbef,4)) then
	    call set_sfra(zei,lc)
	  elseif(str_comp(bef,'afra',2,lbef,4)) then
	    call set_afra(zei,lc)
	  elseif(str_comp(bef,'cfra',2,lbef,4)) then
	    call set_cfra(zei,lc)
	  elseif(str_comp(bef,'bfra',2,lbef,4)) then
	    call set_bfra(zei,lc)
	  elseif(str_comp(bef,'mass',3,lbef,4)) then
	    write (output_io,2000)
c
c-------  Plot graphic
c
	  elseif(str_comp(bef,'plot',2,lbef,4)) then
	    call do_plot (.false.)
c
c-------  Save or print graphic
c
	  elseif(str_comp(bef,'save',2,lbef,4) .or.
     &	         str_comp(bef,'prin',2,lbef,4)     ) then
	    call do_hardcopy (bef,zei,lbef,lc)
c
c-------  Commands 'achx','achy','tit1' and 'tit2'
c
	  elseif(str_comp(bef,'achx',4,lbef,4)) then
	    call para_set_achse(zei,lc,achse(iwin,iframe,1),
     &	                        lachse(iwin,iframe,1))
	  elseif(str_comp(bef,'achy',4,lbef,4)) then
	    call para_set_achse(zei,lc,achse(iwin,iframe,2),
     &	                        lachse(iwin,iframe,2))
	  elseif(str_comp(bef,'achz',4,lbef,4)) then
	    call para_set_achse(zei,lc,achse(iwin,iframe,3),
     &	                        lachse(iwin,iframe,3))
c
	  elseif(str_comp(bef,'tit1',4,lbef,4)) then
	    call para_set_title(zei,lc,titel(iwin,iframe,1))
	  elseif(str_comp(bef,'tit2',4,lbef,4)) then
	    call para_set_title(zei,lc,titel(iwin,iframe,2))
c
c-------  Commands 'mass','aver',...
c
	  elseif(str_comp(bef,'aver',3,lbef,4)) then
	    call para_setr(zei,lc,yskal_u(iwin,iframe),bef,-9999.)
	    lyskal(iwin,iframe) = (yskal_u(iwin,iframe).ne.-9999.)
	  elseif(str_comp(bef,'angle',3,lbef,5)) then
	    call para_setr(zei,lc,shear(iwin,iframe),bef,90.0)
c
c-------  Commands 'ltyp','lcol','mtyp','mcol',...
c
	  elseif(str_comp(bef,'ltyp',3,lbef,4)) then
	    call para_seti(zei,lc,ilinetyp,1,maxkurvtot,
     &	                   bef,0, 5,.false.)
	  elseif(str_comp(bef,'mtyp',3,lbef,4)) then
	    call para_seti(zei,lc,imarktyp,1,maxkurvtot,
     &	                   bef,0,131,.false.)
	  elseif(str_comp(bef,'lcol',3,lbef,4)) then
	    call para_seti(zei,lc,ilinecol,0,maxkurvtot,
     &	                   bef,1,15,.true.)
	  elseif(str_comp(bef,'mcol',3,lbef,4)) then
	    call para_seti(zei,lc,imarkcol,1,maxkurvtot,
     &	                   bef,1,15,.false.)
	  elseif(str_comp(bef,'ecol',3,lbef,4)) then
	    call para_seti(zei,lc,ierrcol ,1,maxkurvtot,
     &	                   bef,1,15,.false.)
	  elseif(str_comp(bef,'lart',3,lbef,4)) then
	    call para_seti(zei,lc,ilineart,1,maxkurvtot,
     &	                   bef,1, 3,.false.)
	  elseif(str_comp(bef,'hart',3,lbef,4)) then
	    call para_seti(zei,lc,hlineart,1,maxkurvtot,
     &	                   bef,1, 4,.false.)
	  elseif(str_comp(bef,'hlab',3,lbef,4)) then
	    call para_seti(zei,lc,hlabel  ,1,maxkurvtot,
     &	                   bef,0,99,.false.)
	  elseif(str_comp(bef,'ptyp',3,lbef,4)) then
	    call para_seti(zei,lc,imarkmax,1,maxkurvtot,
     &	                   bef,0,131,.false.)
	  elseif(str_comp(bef,'etyp',3,lbef,4)) then
	    call para_seti(zei,lc,ierr    ,1,maxkurvtot,
     &	                   bef,0, 3,.false.)
c
c-------  Reset
c
	  elseif(str_comp(bef,'rese',3,lbef,4)) then
	    call do_rese
c
c-------  Set annotations
c
	  elseif(str_comp(bef,'sann',3,lbef,4)) then
	    call set_annotation(zei,lc)
c
c-------  Read/Write defaults
c
	  elseif(str_comp(bef,'sdef',3,lbef,4)) then
	    call do_write_def(zei,lc)
	  elseif(str_comp(bef,'rdef',3,lbef,4)) then
	    call do_read_def(zei,lc)
c
c-------  Show parameters 'show'
c
	  elseif(str_comp(bef,'show',3,lbef,4)) then
	    call do_show(zei,lc)
c
c-------  Set data set caption
c
	  elseif(str_comp(bef,'sleg',3,lbef,4)) then
	    call set_legend(zei,lc)
c
c-------  Set buffer around plotting window
c
	  elseif(str_comp(bef,'buff',3,lbef,4)) then
	    call set_buff(zei,lc)
c
c-------  Set plotting window
c
	  elseif(str_comp(bef,'skal',3,lbef,4)) then
	    call set_skal(zei,lc)
c
c-------  Sort data set (up in x)
c
	  elseif(str_comp(bef,'sort',3,lbef,4)) then
	    call do_sort(zei,lc)
c
c-------  Search maxima/minima
c
	  elseif(str_comp(bef,'smax',3,lbef,4)) then
	    call do_smax(zei,lc)
c
c-------  Check for generic command
c
	  else
	    call kdo_all(bef,lbef,zei,lc)
	  endif
	endif
c
2000	format (' ****WARN**** Redundant command, do not use',
     &          13x,'**** -99 ****')
	end
