	program kuplot
c
	implicit	none
	character*10	aktuell
	parameter	(aktuell='4.1       ')
c
c*****7*****************************************************************
c
c       This is the universal plot program KUPLOT. It sets up most
c	variables and calls the loop interpreting the commands.
c
c       Authors : Th. Proffen (tproffen@lanl.gov )
c                 R.B. Neder  (reinhard.neder@mail.uni-wuerzburg.de)
c
c*****7*****************************************************************
c
	include		'errlist.inc'
	include		'doact.inc'
	include		'learn.inc'
	include		'prompt.inc'
	include		'macro.inc'
c
	character*200	line,zeile
	character*4	befehl
	logical		lend
	integer		lbef,lp,ll
c
	version           = aktuell
	pname             = 'kuplot'
	pname_cap         = 'KUPLOT'
	prompt            = pname
	lend              = .false.
	blank             = ' '
	prompt_status     = PROMPT_ON
	prompt_status_old = PROMPT_ON
c
	call setup
	call no_error
c
	do while (.not. lend)
10	  continue
	  call get_command (line,ll,befehl,lbef,zeile,lp,prompt)
	  if(ier_num.eq.0 .and. ll.gt.0) then
  	    if(line.eq.' '.or.line(1:1).eq.'#') goto 10
c
c------ --- Execute command
c
	    if(befehl(1:3).eq.'do ' .or. befehl(1:2).eq.'if') then
	      call do_loop   (line,lend,ll)
	    else
	      call mache_kdo (line,lend,ll)
	    endif
	  endif
c
c------	- Handle error message
c
	  if(ier_num.ne.0) then
	    call errlist
	    if(lmakro) then
	      call macro_close
	      prompt_status = PROMPT_ON
	    endif
	    lblock  = .false.
	    call no_error
	  endif
	enddo
c                             
c------ END of PROGRAM
c
9999	continue
	call do_exit
c                                 
2000	format(a)
c                                       
	end
c*****7*****************************************************************
	subroutine setup
c
c	This routine makes inital setup of KUPLOT
c
	implicit      	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include 	'wink.inc'
	include 	'prompt.inc'
	include		'date.inc'
c
	 pi=4.00*atan(1.00)
	zpi=8.00*atan(1.00)
	rad=zpi/360.00
c
	call ini_ran(0)
c
c------ Write starting screen
c
	write(*,1000) version,cdate
c
c------	Call initialization routines
c
	call initarrays
	call init_sysarrays
	call appl_env
	call auto_def
	call cmdline_args
c
1000	format (/,10x,59('*'),/,10x,'*',15x,
     &	          'K U P L O T   Version ',
     &	          a10,10x,'*',/,10x,'*',57x,'*',/
     &	          10x,'*         Created : ',a35,3x,'*',/,10x,'*',
     &	          57('-'),'*',/,10x,'* (c) Th. Proffen ',
     &	          '(tproffen@lanl.gov)                     *',/,
     &	          10x,'*     R.B. Neder  ',
     &            '(reinhard.neder@mail.uni-wuerzburg.de)  *',/,
     &	          10x,59('*'),/)
	end
