c*****7**************************************************************
c
c	Here are all the 'math' routines for KUPLOT.
c
c	Version : 4.1
c	Date    : 19. April 2000
c
c	Author  : Th. Proffen  (tproffen@lanl.gov )
c
c*****7**************************************************************
	subroutine do_sort (zeile,lp)
c+
c	sort xy file after increasing x values
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw = 1)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz,ik,ir,l,i,j
	real		xxx,yyy,dxx,dyy
	real		werte (maxw)
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ier_num.ne.0) return
c
        if (ianz.ne.1) then
          ier_num = -6
	  ier_typ = ER_COMM
        else
          ik=nint(werte(1))
          if(ik.lt.iz .and. ik.gt.0) then
	    write (output_io,1000) ik
	    l =len(ik)/2+1
	    ir=len(ik)    
10	    continue
	    if (l.gt.1) then
	      l=l-1
	      xxx= x(offxy(ik-1)+l)
	      yyy= y(offxy(ik-1)+l)
	      dxx=dx(offxy(ik-1)+l)
	      dyy=dy(offxy(ik-1)+l)
	    else
	      xxx= x(offxy(ik-1)+ir)
              yyy= y(offxy(ik-1)+ir)
              dxx=dx(offxy(ik-1)+ir)
              dyy=dy(offxy(ik-1)+ir)
	       x(offxy(ik-1)+ir)= x(offxy(ik-1)+1)
	       y(offxy(ik-1)+ir)= y(offxy(ik-1)+1)
	      dx(offxy(ik-1)+ir)=dx(offxy(ik-1)+1)
	      dy(offxy(ik-1)+ir)=dy(offxy(ik-1)+1)
	      ir=ir-1
	      if (ir.eq.1) then
	         x(offxy(ik-1)+1)=xxx
	         y(offxy(ik-1)+1)=yyy
	        dx(offxy(ik-1)+1)=dxx
	        dy(offxy(ik-1)+1)=dyy
	        return
	      endif
	    endif
	    i=l
	    j=l+l
20	    continue
	    if (j.le.ir) then
	      if (j.lt.ir) then
	        if (x(offxy(ik-1)+j).lt.x(offxy(ik-1)+j+1)) j=j+1
	      endif
	      if (xxx.lt.x(offxy(ik-1)+j)) then
                 x(offxy(ik-1)+i)= x(offxy(ik-1)+j)
                 y(offxy(ik-1)+i)= y(offxy(ik-1)+j)
                dx(offxy(ik-1)+i)=dx(offxy(ik-1)+j)
                dy(offxy(ik-1)+i)=dy(offxy(ik-1)+j)
	        i=j
	        j=j+j
	      else
	        j=ir+1
	      endif
	      goto 20
	    endif
             x(offxy(ik-1)+i)=xxx
             y(offxy(ik-1)+i)=yyy
            dx(offxy(ik-1)+i)=dxx
            dy(offxy(ik-1)+i)=dyy
            goto 10
          else
	    ier_num = -4
	    ier_typ = ER_APPL
          endif
	endif
c
1000	format (' ------ > Sorting data set ',i3,' ..')
	end
c*****7**************************************************************
	subroutine do_four (zeile,lp)
c+
c	Calculates simple discrete Fourier Transform from 
c	given data set. Range in Fourier space is determined
c	by sample width in real space. And it is done with 2PI 
c	in the exponential !!!
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=3)
c
	character*(*)	zeile
	integer		lp
c
	character*200	cpara(maxw)
	integer		lpara(maxw)
	integer		ianz,ik
	real		werte(maxw)
	logical		fo(4)
c
c------ get parameters
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c	
	if (ianz.eq.1 .or. ianz.eq.2) then
	  if (ianz.eq.2) then
	    ianz = ianz - 1
	    call do_cap(cpara(2))
	    fo(1) = (index(cpara(2)(1:lpara(2)),'R').ne.0)
	    fo(2) = (index(cpara(2)(1:lpara(2)),'I').ne.0)
	    fo(3) = (index(cpara(2)(1:lpara(2)),'A').ne.0)
	    fo(4) = (index(cpara(2)(1:lpara(2)),'P').ne.0)
	  else
	    fo(1) = .true.
	    fo(2) = .true.
	    fo(3) = .false.
	    fo(4) = .false.
	  endif
c
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  ik=nint(werte(1))
	  if(ik.lt.iz .and. ik.gt.0) then
	    if(lni(ik)) then
	      call do_four_z (ik,fo)
	    else
	      call do_four_y (ik,fo)
	    endif
	  else
	    ier_num = -4
	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7****************************************************************
	subroutine do_four_y (ik,fo)
c
c	This routine perfoms the Fourier Transform for 2D data
c
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
	include		'wink.inc'
c
	character*10	oname(4)
	integer		i,j,ipkt,inew,ik,k,kk
	integer		maxpkt
	integer		ift(0:4)
	real		dxx,h,f(4)
	logical		fo(4)
c
	data oname	/'real.xy','imag.xy','ampl.xy','phase.xy'/
c
c------ Enough space for new data sets
c
	inew   = 0
	ift(0) = ik
	do i=1,4
	  if (fo(i)) then
	    inew = inew+1
	    ift(i) = iz-1+inew
	  endif
	enddo
c
	if (inew.eq.0) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	if ((iz+inew-1).gt.maxkurvtot) then
	  ier_num = -1
	  ier_typ = ER_APPL
	  return
	endif
c
	maxpkt = maxarray - offxy(iz-1)
	ipkt   = 2*(len(ik)/2) + 1
	if (inew*ipkt.gt.maxpkt) then
	  ier_num = -6
	  ier_typ = ER_APPL
	  return
	endif
c
c------ Setting properties of newly created data sets
c
	do i=1,4
	  if (fo(i)) then
	    fname(ift(i)) = oname(i)
	    fform(ift(i)) = 'XY'
	    lni(ift(i))   = .false.
	    len(ift(i))   = ipkt
	    offxy(ift(i)) = offxy(ift(i)-1) + len(ift(i))
	    offz(ift(i))  = offz (ift(i)-1)
	    iz = iz+1
	  endif
	enddo
c
c------ Calculating the Fourier Transform
c
	write(output_io,1000) ik
c
	kk  = 0
	dxx = x(offxy(ik-1)+2)-x(offxy(ik-1)+1)
	do k=-len(ik)/2,len(ik)/2
	  h    = k/(len(ik)*dxx)
	  f(1) = 0.0
	  f(2) = 0.0
	  do j=1,len(ik)
	    f(1) = f(1) + y(offxy(ik-1)+j)*cos(zpi*h*x(offxy(ik-1)+j))
	    f(2) = f(2) + y(offxy(ik-1)+j)*sin(zpi*h*x(offxy(ik-1)+j))
	  enddo
	  f(1) = dxx*f(1)
	  f(2) = dxx*f(2)
	  f(3) = sqrt(f(1)**2 + f(2)**2)
	  f(4) = atan(f(2)/f(1))/rad
	  kk   = kk+1
c
	  do i=1,4
	    if(fo(i)) then
	       x(offxy(ift(i)-1)+kk) = h
	       y(offxy(ift(i)-1)+kk) = f(i)
	      dx(offxy(ift(i)-1)+kk) = 0.0
	      dy(offxy(ift(i)-1)+kk) = 0.0
	    endif
	  enddo
	enddo
c
	call get_extrema
c
1000	format (' ------ > Calulating Fourier Transform of data set ',
     &	                   I2,' ...')
	end
c*****7****************************************************************
	subroutine do_four_z (ik,fo)
c
c	This routine perfoms the Fourier Transform for 3D data
c
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
	include		'wink.inc'
c
	character*12	oname(4)
	integer		i,jx,jy,ipkt,jpkt,inew,ik,kkx,kky
	integer		kx,ky,maxpkt,maxzz
	integer		ift(0:4)
	real		dxx,dyy,hx,hy,f(4)
	logical		fo(4)
c
	data oname	/'real.nipl','imag.nipl',
     &	                 'ampl.nipl','phase.nipl'/
c
c------ Enough space for new data sets
c
	inew   = 0
	ift(0) = ik
	do i=1,4
	  if (fo(i)) then
	    inew = inew+1
	    ift(i) = iz-1+inew
	  endif
	enddo
c
	if (inew.eq.0) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	if ((iz+inew-1).gt.maxkurvtot) then
	  ier_num = -1
	  ier_typ = ER_APPL
	  return
	endif
c
	maxpkt = maxarray - offxy(iz-1)
	maxzz  = maxarray - offz (iz-1)
c
	ipkt   = 2*(nx(ik)/2) + 1
	jpkt   = 2*(ny(ik)/2) + 1
	if(nx(ik).le.0 .or. ny(ik).le.0      .or.
     &	   inew*nx(ik)*ny(ik)     .gt.maxzz  .or.
     &	   inew*max(nx(ik),ny(ik)).gt.maxpkt        ) then
	  ier_num = -6
	  ier_typ = ER_APPL
	  return
	endif
c
c------ Setting properties of newly created data sets
c
	do i=1,4
	  if (fo(i)) then
	    fname(ift(i)) = oname(i)
	    fform(ift(i)) = 'NI'
	    lni(ift(i))   = .true.
	    nx(ift(i))    = ipkt
	    ny(ift(i))    = jpkt
	    len(ift(i))   = max(ipkt,jpkt)
	    offxy(ift(i)) = offxy(ift(i)-1) + len(ift(i))
	    offz(ift(i))  = offz (ift(i)-1) + nx(ift(i))*ny(ift(i))
	    iz = iz+1
	  endif
	enddo
c
c------ Calculating the Fourier Transform
c
	write(output_io,1000) ik
c
	kkx = 0
	dxx = x(offxy(ik-1)+2)-x(offxy(ik-1)+1)
	dyy = y(offxy(ik-1)+2)-y(offxy(ik-1)+1)
	do kx=-nx(ik)/2,nx(ik)/2
	  kkx  = kkx+1
	  kky  = 0
	  hx   = kx/(nx(ik)*dxx)
	  do ky=-ny(ik)/2,ny(ik)/2
	    kky  = kky+1
	    hy   = ky/(ny(ik)*dyy)
	    f(1) = 0.0
	    f(2) = 0.0
	    do jx=1,nx(ik)
	    do jy=1,ny(ik)
	      f(1) = f(1) + z(offz(ik-1)+(jx-1)*ny(ik)+jy)*
     &	                     cos(zpi*(hx*x(offxy(ik-1)+jx)+
     &	                              hy*y(offxy(ik-1)+jy))  )
	      f(2) = f(2) + z(offz(ik-1)+(jx-1)*ny(ik)+jy)*
     &	                     sin(zpi*(hx*x(offxy(ik-1)+jx)+
     &	                              hy*y(offxy(ik-1)+jy))  )
	    enddo
	    enddo
	    f(1) = dxx*dyy*f(1)
	    f(2) = dxx*dyy*f(2)
	    f(3) = sqrt(f(1)**2 + f(2)**2)
	    f(4) = atan(f(2)/f(1))/rad
c
  	    do i=1,4
	      if(fo(i)) then
	         z(offz (ift(i)-1)+(kkx-1)*ny(ift(i))+kky) = f(i)
	         x(offxy(ift(i)-1)+kkx) = hx
	         y(offxy(ift(i)-1)+kky) = hy
	        dx(offxy(ift(i)-1)+kkx) = 0.0
	        dy(offxy(ift(i)-1)+kky) = 0.0
	      endif
	    enddo
	  enddo
	enddo
c
	call get_extrema
c
1000	format (' ------ > Calulating Fourier Transform of data set ',
     &	                   I2,' ...')
	end
c*****7****************************************************************
	subroutine do_glat (zeile,lp,lsmooth)
c+
c	Smooth data set
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw,maxsm
	parameter	(maxw  = 4)
	parameter	(maxsm = 501)
c
	character*(*)	zeile
	integer		lp
	logical		lsmooth
c
	character*200	cpara(maxw)
	character*2	dir
	integer		lpara(maxw)
	integer		ianz,ik,ip,im,il
	real		werte(maxw)
	real		cc(maxsm)
	logical		gx,gy
c
	if (lsmooth) then
	  do ip=1,maxsm
	    cc(ip) = 0.0
	  enddo
	else
	  do ip=1,maxsm
	    cc(ip) = 1.0
	  enddo
	endif
c
c------ get parameters
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c	
	if (ianz.eq.2 .or. ianz.eq.3 .or. ianz.eq.4) then
	  if (ianz.eq.4) then
	    call do_cap(cpara(4))
	    gx = (cpara(4)(1:1).eq.'X')
	    gy = (cpara(4)(1:1).eq.'Y')
	    cpara(4) = '0.0'
	  else
	    gx = .true.
	    gy = .true.
	  endif
c
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  ik=nint(werte(1))
	  ip=nint(werte(2))
	  if(ik.lt.iz .and. ik.gt.0) then
c
	    if (gx) dir = ' x'
	    if (gy) dir = ' y'
	    if (gx .and. gy) dir = 'xy'
c
	    if (lsmooth) then
	      il=0
	      im=2
	      if (ianz.gt.2) im=nint(werte(3))
	      call SAVGOL(cc,ip,ip/2,ip/2,il,im)
	      if (ier_num.ne.0) return
	    endif
c
	    if(lni(ik)) then
	      if (lsmooth) then
	        write (output_io,2000) ik,ip,im
	      else
	        write (output_io,2010) ik,ip
	      endif
	      write (output_io,2100) dir
	      call do_glatt_z (ik,ip,nx(ik),ny(ik),gx,gy,
     &	                                cc,maxsm,lsmooth)
	    else
	      if (lsmooth) then
	        write (output_io,2000) ik,ip,im
	      else
	        write (output_io,2010) ik,ip
	      endif
	      call do_glatt_y (ik,ip,len(ik),cc,maxsm,lsmooth)
	    endif
	  else
	    ier_num = -4
	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
2000	format (' Smoothing data set ',i3,' via Savitzky-Golay :',/,
     &	        '   Number of points           : ',i3,/,
     &	        '   Order of smoothing polynom : ',i3)
2010	format (' Smoothing data set ',i3,' via sliding average :',/,
     &	        '   Number of points           : ',i3)
2100	format ('   Direction                  : ',1x,a2)
	end
c*****7*******************************************************************
	subroutine do_inte (zeile,lp)
c+
c	Compute integral for 2d/3d data sets
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'param.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw = 5)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz,ipkt,ip,ik,ix,iy
	real		rint,drint,rdx,rdy,xa,ya,xs
	real		wx1,wx2,wy1,wy2
	real		werte(maxw)
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ianz.lt.1) then
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	if (ier_num.ne.0) return
	call skalieren
	ik     = nint (werte(1))
	wx1    = ex(iwin,iframe,1)
	wx2    = ex(iwin,iframe,2)
	wy1    = ey(iwin,iframe,1)
	wy2    = ey(iwin,iframe,2)
c
	if(ik.gt.0 .and. ik.lt.iz) then
	  if    (ianz.eq.1) then	
	    continue
	  elseif (ianz.eq.3) then
	    wx1    = werte(2)
	    wx2    = werte(3)
	  elseif (ianz.eq.5 .and. lni(ik)) then
	    wx1    = werte(2)
	    wx2    = werte(3)
	    wy1    = werte(4)
	    wy2    = werte(5)
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -4
	  ier_typ = ER_APPL
	endif
c
	if (ier_num.ne.0) return
c
	rint  = 0.0
	drint = 0.0
	ipkt  = 0
c
c------ 2D integration
c
	if (lni(ik)) then
	  do ix = 1,nx(ik)
	    do iy = 1,ny(ik)
	      if (x(offxy(ik-1)+ix).ge.wx1 .and. 
     &	          y(offxy(ik-1)+iy).ge.wy1 .and. 	
     &	          x(offxy(ik-1)+ix).le.wx2 .and. 
     &	          y(offxy(ik-1)+iy).le.wy2      ) then
	            zwert = z(offz(ik-1)+(ix-1)*ny(ik)+iy)
	            if (zwert.ne.-9999.0) then
     	              rint  = rint + zwert 
	              ipkt  = ipkt + 1
	            endif
	      endif
	    enddo
	  enddo
	  rdx = (xmax(ik)-xmin(ik))/float(nx(ik))
	  rdy = (ymax(ik)-ymin(ik))/float(ny(ik))
          write (output_io,2000) ik,wx1,wx2,wy1,wy2,rint*rdx*rdy,
     &	                         drint,ipkt
	  if (maxpar_res.lt.7) then
	    ier_num = -24
	    ier_typ = ER_APPL
	    return
	  endif
	  res_para(0)=7
	  res_para(1)=rint*rdx*rdy
	  res_para(2)=drint
	  res_para(3)=float(ipkt)
	  res_para(4)=wx1
	  res_para(5)=wx2
	  res_para(6)=wy1
	  res_para(7)=wy2
c
c------ 1D integration
c
 	else
	  do ix = 2,len(ik)
	    ip = offxy(ik-1)+ix
	    xa = (x(ip)+x(ip-1))/2.0
	    ya = (y(ip)+y(ip-1))/2.0
	    xs = abs(x(ip)-x(ip-1))
c
	    if (xa.ge.wx1 .and. xa.le.wx2) then
     	      rint  =  rint + xs*ya
	      drint = drint + xs**2*(dy(ip)**2+dy(ip-1)**2)/4.0
	      ipkt  = ipkt  + 1
	    endif
	  enddo
          write (output_io,2100) ik,wx1,wx2,rint,sqrt(drint),ipkt
	  if (maxpar_res.lt.5) then
	    ier_num = -24
	    ier_typ = ER_APPL
	    return
	  endif
	  res_para(0)=5
	  res_para(1)=rint
	  res_para(2)=sqrt(drint)
	  res_para(3)=float(ipkt)
	  res_para(4)=wx1
	  res_para(5)=wx2
	endif
	write(output_io,*)
c
2000	format(' Integration result for data set ',i3,' :',/
     &	       3x,'x-range    : ',g12.4,' to ',g12.4,/
     &	       3x,'y-range    : ',g12.4,' to ',g12.4,/
     &         3x,'Integral   : ',g12.4,' +- ',g12.4,'  (',i7,' pkt)')
2100	format(' Integration result for data set ',i3,' :',/
     &	       3x,'x-range    : ',g12.4,' to ',g12.4,/
     &         3x,'Integral   : ',g12.4,' +- ',g12.4,'  (',i7,' pkt)')
5000	format(a)
c
	end
c*****7*******************************************************************
	subroutine do_mean (zeile,lp,lout)
c+
c	calculates mean and standard deviation 
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'param.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw = 5)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz,ik,ix,iy,i
	real		werte(maxw)
	real		wx1,wx2,wy1,wy2
	real		sum(3),sum2(3),wert(3),ave(3),sig(3),n
	logical		lout
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ianz.lt.1) then
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	if(ier_num.ne.0) return
c
	ik  = nint (werte(1))
	if (ik.ge.iz .or. len(ik).eq.0) then
	  ier_num = -4
	  ier_typ = ER_APPL
	  return
	endif
c
	call skalieren
	if    (ianz.eq.1) then	
	  wx1 = ex(iwin,iframe,1)
	  wx2 = ex(iwin,iframe,2)
	  wy1 = ey(iwin,iframe,1)
	  wy2 = ey(iwin,iframe,2)
	elseif (ianz.eq.3) then
	  wx1 = werte (2)
	  wx2 = werte (3)
	  wy1 = ey(iwin,iframe,1)
	  wy2 = ey(iwin,iframe,2)
	elseif (ianz.eq.5 .and. lni(ik)) then
	  wx1 = werte (2)
	  wx2 = werte (3)
	  wy1 = werte (4)
	  wy2 = werte (5)
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	do i=1,3
	  sum (i) = 0.0
	  sum2(i) = 0.0
	enddo
	n = 0
c
	if (lni(ik)) then
	  do ix = 1,nx(ik)
	    do iy = 1,ny(ik)
	      if (x(offxy(ik-1)+ix).ge.wx1 .and. 
     &	          y(offxy(ik-1)+iy).ge.wy1 .and. 	
     &	          x(offxy(ik-1)+ix).le.wx2 .and. 
     &	          y(offxy(ik-1)+iy).le.wy2      ) then
	            wert(1) = x(offxy(ik-1)+ix)
	            wert(2) = y(offxy(ik-1)+iy)
	            wert(3) = z(offz(ik-1)+(ix-1)*ny(ik)+iy)
	            if (werte(3).ne.-9999.0) then
	              do i=1,3
     	                sum (i)  = sum (i) + wert(i)
     	                sum2(i)  = sum2(i) + wert(i)**2
	              enddo
	              n = n + 1
	            endif
	      endif
	    enddo
	  enddo
	  if (n.gt.0) then
	    do i=1,3
	      ave(i)=sum(i)/n
	      sig(i)=sqrt(sum2(i)/n-(sum(i)/n)**2)
	    enddo
            if (lout) write(output_io,2000) ik,wx1,wx2,wy1,wy2,int(n),
     &	                                    (ave(i),sig(i),i=1,3)
	    if (maxpar_res.lt.11) then
	      ier_num = -24
	      ier_typ = ER_APPL
	      return
	    endif
	    res_para( 0)=11
	    res_para( 1)=ave(1)
	    res_para( 2)=ave(2)
	    res_para( 3)=ave(3)
	    res_para( 4)=sig(1)
	    res_para( 5)=sig(2)
	    res_para( 6)=sig(3)
	    res_para( 7)=int(n)
	    res_para( 8)=wx1
	    res_para( 9)=wx2
	    res_para(10)=wy1
	    res_para(11)=wy2
	  else
	    ier_num = -20
	    ier_typ = ER_APPL
	  endif
 	else
	  do ix = 1,len(ik)
	    if (x(offxy(ik-1)+ix).ge.wx1 .and. 
     &	        x(offxy(ik-1)+ix).le.wx2      ) then
	          wert(1) = x(offxy(ik-1)+ix)
	          wert(2) = y(offxy(ik-1)+ix)
	          do i=1,2
     	            sum (i)  = sum (i) + wert(i)
     	            sum2(i)  = sum2(i) + wert(i)**2
	          enddo
	          n = n + 1
	    endif
	  enddo
	  if (n.gt.0) then
	    do i=1,2
	      ave(i)=sum(i)/n
	      sig(i)=sqrt(sum2(i)/n-(sum(i)/n)**2)
	    enddo
            if (lout) write(output_io,2100) ik,wx1,wx2,int(n),
     &	                                    (ave(i),sig(i),i=1,2)
	    if (maxpar_res.lt.7) then
	      ier_num = -24
	      ier_typ = ER_APPL
	      return
	    endif
	    res_para( 0)=7
	    res_para( 1)=ave(1)
	    res_para( 2)=ave(2)
	    res_para( 3)=sig(1)
	    res_para( 4)=sig(2)
	    res_para( 5)=int(n)
	    res_para( 6)=wx1
	    res_para( 7)=wx2
	  else
	    ier_num = -20
	    ier_typ = ER_APPL
	  endif
	endif
	if (lout) write(output_io,*)
c
2000	format(' Average and standard deviation data set ',i3,' :',/
     &	       3x,'x-range   : ',g12.4,' to ',g12.4,/
     &	       3x,'y-range   : ',g12.4,' to ',g12.4,/
     &	       3x,'# points  : ',i7//
     &         3x,'Average x : ',g12.4,' sigma :  ',g12.4,/
     &         3x,'Average y : ',g12.4,' sigma :  ',g12.4,/
     &         3x,'Average z : ',g12.4,' sigma :  ',g12.4)
2100	format(' Average and standard deviation data set ',i3,' :',/
     &	       3x,'x-range   : ',g12.4,' to ',g12.4,/
     &	       3x,'# points  : ',i7//
     &         3x,'Average x : ',g12.4,' sigma :  ',g12.4,/
     &         3x,'Average y : ',g12.4,' sigma :  ',g12.4)
5000	format(a)
c
	end
c*****7*******************************************************************
	subroutine do_smax (zeile,lp)
c+
c	Search for maxima in data set
c-
	implicit	none
c
	integer		maxmax,maxw
	parameter	(maxmax=50)
	parameter	(maxw  =10)
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'param.inc'
	include		'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	character*80	cdummy
	character*6	cout
	real		werte(maxw)
	real		wmax(maxmax)
	integer		lpara(maxw),lp
	integer		ixm(maxmax),iym(maxmax)
	integer		ianz,ifil,im,ima,ik
c
	integer		len_str
c
	cout = 'maxima'
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.ge.2) then
	  call ber_params(2,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  ik  =nint(werte(1))
	  ifen=nint(werte(2))
	  if(ik.gt.0 .and. ik.lt.iz) then
	    if(ianz.gt.2) then
	      call del_params(2,ianz,cpara,lpara,maxw)
	      call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	      if(ier_num.ne.0) return
	      ifil=66
	      cdummy=cpara(1)
	      call oeffne(ifil,cdummy,'unknown',.false.)
	      if(ier_num.ne.0) return
	      write(output_io,900) cdummy(1:len_str(cdummy))
	    else
	      ifil=output_io
	    endif
c
c------ --- 3D data set
c
	    if(lni(ik)) then
	      call do_fmax_z (ik,wmax,ixm,iym,maxmax,ima)
	      if (ier_num.eq.0) then
	        write (ifil,1000) cout,ik,ifen
	        if (maxpar_res.lt.2*ima) then
	          ier_num = -24
	          ier_typ = ER_APPL
	          return
	        endif
	        res_para(0)=2.0*ima
	        do im=1,ima
	          write (ifil,1100) im,x(offxy(ik-1)+ixm(im)),
     &	                            y(offxy(ik-1)+iym(im)),wmax(im)
	          res_para(2*im-1)=float(ixm(im))
	          res_para(2*im  )=float(iym(im))
	        enddo
	      endif
c
c------ --- 2D data set
c
	    else
	      call do_fmax_xy (ik,wmax,ixm,maxmax,ima)
	      if (ier_num.eq.0) then
	        write (ifil,2000) cout,ik,ifen
	        if (maxpar_res.lt.ima) then
	          ier_num = -24
	          ier_typ = ER_APPL
	          return
	        endif
	        res_para(0)=ima
	        do im=1,ima
	          write (ifil,2100) im,x(offxy(ik-1)+ixm(im)),wmax(im)
	          res_para(im)=float(ixm(im))
	        enddo
	      endif
    	    endif
	    if(ifil.ne.6) close (ifil)
	  else
	    ier_num = -4
	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
 900	format (' ------ > Saving results to file ',a,' ..')
1000	format (' Found ',a,' data set ',i3,' (ifen = ',i3,') :',//,
     &	        3x,'No.        pos. x       pos. y         value'/
     &	        3x,'--------------------------------------------------')
1100	format (3x,i3,2x,f11.3,2x,f11.3,2x,f18.3)
2000	format (' Found ',a,' data set ',i3,' (ifen = ',i3,') :',//,
     &	        3x,'No.        pos. x         value'/
     &	        3x,'-------------------------------------')
2100	format (3x,i3,2x,f11.3,2x,f18.3)
	end	
c*****7*****************************************************************
c	SUPPORT ROUTINES
c*****7*****************************************************************
      	subroutine do_glatt_z (ik,np,nxx,nyy,gx,gy,cc,mc,lsm)
c+
c	glaetten des nipl-2d-arrays
c-
	implicit 	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	integer		mc
c
	real 		a(maxarray),cc(mc)
	real		xnw,s
	integer		ik,np,nxx,nyy
	integer		nd,na,ne,ip,jp,im,jm,i,j,k
	logical		gx,gy,lsm
c
      	nd=(np-1)/2
      	na=nd+1
c
c------ glaettung in x-richtung
c
	if (.not. gx) goto 222
      	ne=nxx-nd
      	do j=1,nyy
          do i=na,ne
            xnw=np
            im=i-nd
            ip=i+nd
            s=0.0
            do k=im,ip
              if (z(offz(ik-1)+(k-1)*ny(ik)+j).ne.-9999.0 .and. 
     &	          z(offz(ik-1)+(k-1)*ny(ik)+j).ne.0.0) then
	        s=s+cc(abs(i-k)+1)*z(offz(ik-1)+(k-1)*ny(ik)+j)
	      else 
	        xnw=xnw-1
	      endif
	    enddo
            if (xnw.gt.0) then
  	      if (lsm) then
	        a(i)=s
	      else
	        a(i)=s/xnw
	      endif
	    else 
	      a(i)=-9999.0
	    endif
	  enddo
          do i=na,ne
            z(offz(ik-1)+(i-1)*ny(ik)+j)=a(i)
	  enddo
	enddo
c
c------ glaettung in y-richtung
c
222	continue
	if (.not.gy) goto 333
      	ne=nyy-nd
      	do i=1,nxx
          do j=na,ne
            xnw=np
            jm=j-nd
            jp=j+nd
            s=0.0
            do k=jm,jp
              if (z(offz(ik-1)+(i-1)*ny(ik)+k).ne.-9999.0 .and. 
     &	          z(offz(ik-1)+(i-1)*ny(ik)+k).ne.0.0) then
	        s=s+cc(abs(j-k)+1)*z(offz(ik-1)+(i-1)*ny(ik)+k)
	      else 
	        xnw=xnw-1
	      endif
	    enddo
            if (xnw.gt.0) then
  	      if (lsm) then
	        a(j)=s
	      else
	        a(j)=s/xnw
	      endif
	    else 
	      a(j)=-9999.0
	    endif
	  enddo
          do j=na,ne               
            z(offz(ik-1)+(i-1)*ny(ik)+j)=a(j)
	  enddo
	enddo
c
333	continue
      	end
c*****7*****************************************************************
      	subroutine do_glatt_y (ik,ip,llen,cc,mc,lsm)
c+
c	glaetten der kurve ik ueber ip punkte
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	integer		mc
c
	real	   	ay(maxarray),ady(maxarray),cc(mc)
	real		s,ds,xnw
	integer		ik,ip,llen
	integer		na,ne,nd,ic,i,k,kk
	logical		lsm
c            
        nd = (ip-1)/2
     	na = nd+1
      	ne = llen-nd
c
        do i=na,ne
          xnw = ip
          s   = 0.0
	  ds  = 0.0
c
          do k=-nd,0
	    kk =  k+i
	    ic =  1-k
	     s =  s+cc(ic)    *  y(offxy(ik-1)+kk)
	    ds = ds+cc(ic)**2 * dy(offxy(ik-1)+kk)**2
	  enddo
c
          do k=1,nd
	    kk =  k+i
	    ic =  2*nd+2 - k 
	     s =  s+cc(ic)    *  y(offxy(ik-1)+kk)
	    ds = ds+cc(ic)**2 * dy(offxy(ik-1)+kk)**2
	  enddo
c
  	  if (lsm) then
	    ay(i)  = s
	    ady(i) = sqrt(ds)
	  else
	    ay(i)  = s/float(ip)
	    ady(i) = sqrt(ds/float(ip))
	  endif
	enddo     
c
	do i=na,ne
	   y(offxy(ik-1)+i) =  ay(i)
	  dy(offxy(ik-1)+i) = ady(i)
	enddo 
c
	end
c*****7*****************************************************************
 	subroutine get_extrema_xy (a,ik,ilen,amin,amax)
c+
c	extrema der kurve ik bestimmen
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	real	   	a(maxarray)
	real		amax(maxkurvtot), amin(maxkurvtot)
	integer		ik,ip,ilen
c
	amax(ik)=a(offxy(ik-1)+1)
	amin(ik)=a(offxy(ik-1)+1)
	do ip=2,ilen
	  amax(ik)=max(amax(ik),a(offxy(ik-1)+ip))
	  amin(ik)=min(amin(ik),a(offxy(ik-1)+ip))
	enddo
c
	end
c*****7*****************************************************************
 	subroutine get_extrema_z (a,ik,nxx,nyy,amin,amax)
c+
c	extrema der kurve ik bestimmen
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	real	   	a(maxarray)
	real		amax(maxkurvtot), amin(maxkurvtot)
	integer		ik,nxx,nyy,ikk,i,j
c
	amax(ik)=a(offz(ik-1)+1)
	amin(ik)=a(offz(ik-1)+1)
	if(amin(ik).eq.-9999.) amin(ik)=1e+30
	do i=1,nxx
	  do j=2,nyy
	    ikk=offz(ik-1)+(i-1)*ny(ik)+j
	    amax(ik)=max(amax(ik),a(ikk))
	    if (a(ikk).ne.-9999.) amin(ik)=min(amin(ik),a(ikk))
	  enddo
	enddo
c
	end
c*****7*******************************************************************
	subroutine do_fmax_xy (ik,wmax,ixm,maxmax,ima)
c+
c	maxima bestimmen fuer xy-files
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include         'errlist.inc'
c
	integer		maxmax
	real		wmax(maxmax)
	integer		ixm(maxmax),ik,ima
	integer		ix,jf
	logical		max_da
c
	ima =1
	do ix=1+ifen,len(ik)-ifen
	  if (x(offxy(ik-1)+ix).ge.ex(iwin,iframe,1) .and.
     &	      x(offxy(ik-1)+ix).le.ex(iwin,iframe,2)      ) then
	    max_da=.true.
	    do jf=-ifen,-1
	      max_da = max_da .and. 
     &	               (y(offxy(ik-1)+ix).ge.y(offxy(ik-1)+ix+jf))	
	    enddo
	    do jf=1,ifen
	      max_da = max_da .and. 
     &	               (y(offxy(ik-1)+ix).ge.y(offxy(ik-1)+ix+jf))	
	    enddo
c
	    if (max_da) then
	      wmax(ima)=y(offxy(ik-1)+ix)
	      ixm(ima)=ix
	      ima=ima+1
	      if (ima.gt.maxmax) then
	        ier_num=-21
	        ier_typ=ER_APPL
	        ima=maxmax
	        return
	      endif
	    endif
	  endif
	enddo
	ima=ima-1
c
	if (ima.eq.0) then 
	  ier_num = -22
	  ier_typ = ER_APPL
	endif
c
	end
c*****7*******************************************************************
	subroutine do_fmax_z (ik,wmax,ixm,iym,maxmax,ima)
c+
c	maxima bestimmen aus xyz files
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include         'errlist.inc'
c
	integer		maxmax
	real		wmax(maxmax)
	integer		ik,ima,ixm(maxmax),iym(maxmax)
	integer		ikk,iix,ix,iy,jf,kf
	logical		max_da
c
	ima =1
	ikk =offz(ik-1)
	do ix=1+ifen,nx(ik)-ifen
	  do iy=1+ifen,ny(ik)-ifen
	    iix=ix-1
	    if(z(ikk+iix*ny(ik)+iy).eq.-9999.0) goto 20
	    max_da=.true.
	    do jf=-ifen,ifen
	      do kf=-ifen,ifen
	        if (jf.ne.0 .or. kf.ne.0) then
	          max_da = max_da .and.
     &	          (z(ikk+iix*ny(ik)+iy)).ge.z(ikk+(iix+jf)*ny(ik)+iy+kf)
	          if (.not. max_da) goto 20
	        endif
	      enddo           
	    enddo
	    if (max_da) then
	      wmax(ima)=z(ikk+iix*ny(ik)+iy)
	      ixm(ima)=ix
	      iym(ima)=iy
	      ima=ima+1
	      if (ima.gt.maxmax) then
	        ier_num=-21
	        ier_typ=ER_APPL
	        ima=maxmax
	        return
	      endif
	    endif
20	    continue
	  enddo
	enddo
	ima=ima-1
c
	if (ima.eq.0) then 
	  ier_num = -22
	  ier_typ = ER_APPL
	endif
c
	end
c*****7*******************************************************************
	subroutine extract_subarray (xf,yf,zf,xmit,ymit,nsize,ik,ie)
c+
c	schneiden eines subarrays fuer interpolationsroutinen
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	integer		nsize
	real		xf(nsize),yf(nsize),zf(nsize,nsize)
	real		xmit,ymit
	integer		ik,ie,ip,ii,jj,ixx,iyy
c
	ie =0
	ip =nsize/2+1
	ixx=nint((xmit-xmin(ik))/(xmax(ik)-xmin(ik))*float(nx(ik)-1))+1  
	iyy=nint((ymit-ymin(ik))/(ymax(ik)-ymin(ik))*float(ny(ik)-1))+1
	if(ixx.lt.ip .or. (ixx+ip).gt.nx(ik) .or.
     &	   iyy.lt.ip .or. (iyy+ip).gt.ny(ik))     then
	  ie=-1
	  return
	endif
	do ii=1,nsize
	  do jj=1,nsize
	    xf(ii)=x(offxy(ik-1)+ii-ip+ixx)
	    yf(jj)=y(offxy(ik-1)+jj-ip+iyy)
	    zf(ii,jj)=z(offz(ik-1)+(ii-ip+ixx)*ny(ik)+jj-ip+iyy)
	    if (zf(ii,jj).eq.-9999.) then
	      ie=-1
	      return
	    endif
	  enddo
	enddo 
c
	end
c***********************************************************************
      subroutine polin2(x1a,x2a,ya,m,n,x1,x2,y,dy)
      parameter (nmax=50,mmax=50)
      dimension x1a(m),x2a(n),ya(m,n),yntmp(nmax),ymtmp(mmax)
      do 12 j=1,m
        do 11 k=1,n
          yntmp(k)=ya(j,k)
11      continue
        call polint(x2a,yntmp,n,x2,ymtmp(j),dy)
12    continue
      call polint(x1a,ymtmp,m,x1,y,dy)
      return
      end
c
      subroutine polint(xa,ya,n,x,y,dy)
      parameter (nmax=50) 
      dimension xa(n),ya(n),c(nmax),d(nmax)
      ns=1
      dif=abs(x-xa(1))
      do 11 i=1,n 
        dift=abs(x-xa(i))
        if (dift.lt.dif) then
          ns=i
          dif=dift
        endif
        c(i)=ya(i)
        d(i)=ya(i)
11    continue
      y=ya(ns)
      ns=ns-1
      do 13 m=1,n-1
        do 12 i=1,n-m
          ho=xa(i)-x
          hp=xa(i+m)-x
          w=c(i+1)-d(i)
          den=ho-hp
          if(den.eq.0.)pause
          den=w/den
          d(i)=hp*den
          c(i)=ho*den
12      continue
        if (2*ns.lt.n-m)then
          dy=c(ns+1)
        else
          dy=d(ns)
          ns=ns-1
        endif
        y=y+dy
13    continue
      return
      end
c
      subroutine spline(x,y,n,yp1,ypn,y2)
      include 'config.inc'
      parameter (nmax=maxarray)
      dimension x(n),y(n),y2(n),u(nmax)
      if (yp1.gt..99e30) then
        y2(1)=0.
        u(1)=0.
      else
        y2(1)=-0.5
        u(1)=(3./(x(2)-x(1)))*((y(2)-y(1))/(x(2)-x(1))-yp1)
      endif
      do 11 i=2,n-1
        sig=(x(i)-x(i-1))/(x(i+1)-x(i-1))
        p=sig*y2(i-1)+2.
        y2(i)=(sig-1.)/p
        u(i)=(6.*((y(i+1)-y(i))/(x(i+1)-x(i))-(y(i)-y(i-1))
     *      /(x(i)-x(i-1)))/(x(i+1)-x(i-1))-sig*u(i-1))/p
11    continue
      if (ypn.gt..99e30) then
        qn=0.
        un=0.
      else
        qn=0.5
        un=(3./(x(n)-x(n-1)))*(ypn-(y(n)-y(n-1))/(x(n)-x(n-1)))
      endif
      y2(n)=(un-qn*u(n-1))/(qn*y2(n-1)+1.)
      do 12 k=n-1,1,-1
        y2(k)=y2(k)*y2(k+1)+u(k)
12    continue
      return
      end
c
      subroutine splint(xa,ya,y2a,n,x,y)
      dimension xa(n),ya(n),y2a(n)
      klo=1
      khi=n
1     if (khi-klo.gt.1) then
        k=(khi+klo)/2
        if(xa(k).gt.x)then
          khi=k
        else
          klo=k
        endif
      goto 1
      endif
      h=xa(khi)-xa(klo)
      if (h.eq.0.) pause 'bad xa input.'
      a=(xa(khi)-x)/h
      b=(x-xa(klo))/h
      y=a*ya(klo)+b*ya(khi)+
     *      ((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**2)/6.
      return
      end

	SUBROUTINE SAVGOL(c,np,nl,nr,ld,m)
	include 'errlist.inc'
	INTEGER ld,m,nl,np,nr,MMAX
	REAL c(np)
	PARAMETER (MMAX=6)
	INTEGER imj,ipj,j,k,kk,mm,indx(MMAX+1)
	REAL d,fac,sum,a(MMAX+1,MMAX+1),b(MMAX+1)
c
	if(np.lt.nl+nr+1.or.nl.lt.0.or.nr.lt.0.or.ld.gt.m.or.m.gt.MMAX
     * .or.nl+nr.lt.m.or.np.le.3) then 
	  ier_num = -39
	  ier_typ = ER_APPL
	  return
	endif
	do ipj=0,2*m
	sum=0.
	if(ipj.eq.0)sum=1.
	do k=1,nr
	sum=sum+float(k)**ipj
	enddo
	do k=1,nl
	sum=sum+float(-k)**ipj
	enddo
	mm=min(ipj,2*m-ipj)
	do imj=-mm,mm,2
	a(1+(ipj+imj)/2,1+(ipj-imj)/2)=sum
	enddo
	enddo
	call ludcmp(a,m+1,MMAX+1,indx,d)
	do j=1,m+1
	b(j)=0.
	enddo
	b(ld+1)=1.
	call lubksb(a,m+1,MMAX+1,indx,b)
	do kk=1,np
	c(kk)=0.
	enddo
	do k=-nl,nr
	sum=b(1)
	fac=1.
	do mm=1,m
	fac=fac*k
	sum=sum+b(mm+1)*fac
	enddo
	kk=mod(np-k,np)+1
	c(kk)=sum
	enddo
	return
	END

      SUBROUTINE LUBKSB(A,N,NP,INDX,B)
      DIMENSION A(NP,NP),INDX(N),B(N)
      II=0
      DO 12 I=1,N
        LL=INDX(I)
        SUM=B(LL)
        B(LL)=B(I)
        IF (II.NE.0)THEN
          DO 11 J=II,I-1
            SUM=SUM-A(I,J)*B(J)
11        CONTINUE
        ELSE IF (SUM.NE.0.) THEN
          II=I
        ENDIF
        B(I)=SUM
12    CONTINUE
      DO 14 I=N,1,-1
        SUM=B(I)
        IF(I.LT.N)THEN
          DO 13 J=I+1,N
            SUM=SUM-A(I,J)*B(J)
13        CONTINUE
        ENDIF
        B(I)=SUM/A(I,I)
14    CONTINUE
      RETURN
      END
      SUBROUTINE LUDCMP(A,N,NP,INDX,D)
      PARAMETER (NMAX=100,TINY=1.0E-20)
      DIMENSION A(NP,NP),INDX(N),VV(NMAX)
      D=1.
      DO 12 I=1,N
        AAMAX=0.
        DO 11 J=1,N
          IF (ABS(A(I,J)).GT.AAMAX) AAMAX=ABS(A(I,J))
11      CONTINUE
        IF (AAMAX.EQ.0.) PAUSE 'Singular matrix.'
        VV(I)=1./AAMAX
12    CONTINUE
      DO 19 J=1,N
        IF (J.GT.1) THEN
          DO 14 I=1,J-1
            SUM=A(I,J)
            IF (I.GT.1)THEN
              DO 13 K=1,I-1
                SUM=SUM-A(I,K)*A(K,J)
13            CONTINUE
              A(I,J)=SUM
            ENDIF
14        CONTINUE
        ENDIF
        AAMAX=0.
        DO 16 I=J,N
          SUM=A(I,J)
          IF (J.GT.1)THEN
            DO 15 K=1,J-1
              SUM=SUM-A(I,K)*A(K,J)
15          CONTINUE
            A(I,J)=SUM
          ENDIF
          DUM=VV(I)*ABS(SUM)
          IF (DUM.GE.AAMAX) THEN
            IMAX=I
            AAMAX=DUM
          ENDIF
16      CONTINUE
        IF (J.NE.IMAX)THEN
          DO 17 K=1,N
            DUM=A(IMAX,K)
            A(IMAX,K)=A(J,K)
            A(J,K)=DUM
17        CONTINUE
          D=-D
          VV(IMAX)=VV(J)
        ENDIF
        INDX(J)=IMAX
        IF(J.NE.N)THEN
          IF(A(J,J).EQ.0.)A(J,J)=TINY
          DUM=1./A(J,J)
          DO 18 I=J+1,N
            A(I,J)=A(I,J)*DUM
18        CONTINUE
        ENDIF
19    CONTINUE
      IF(A(N,N).EQ.0.)A(N,N)=TINY
      RETURN
      END
