c*****7**************************************************************
c
c       Here are all the parameter setting routines ..
c
c       Version : 4.0
c       Date    : 06. March 1999
c
c       Author  : Th. Proffen  (tproffen@lanl.gov )
c
c*****7*****************************************************************
	subroutine para_seti(zeile,lp,iarray,nia,nie,bef,imi,ima,lnull)
c+
c	Sets option value in integer arrays(nia:nie)
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=3)
c
	character*(*)	zeile,bef
	character*200	cpara(maxw)
	character*20	cdummy
	real		werte(maxw)
	integer		nia,nie
	integer		iarray(maxwin,maxframe,nia:nie)
	integer		ianz,imi,ima,ik,iw
	integer		lpara(maxw),lp
	logical		lnull
c
	integer		len_str
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  cdummy = 'kuplot '//bef
	  call do_hel(cdummy,-len_str(cdummy))
	elseif (ianz.eq.2) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  ik=nint(werte(1))
	  iw=nint(werte(2))
	  if ((ik.le.(iz-1) .and. ik.ge.1) .or.
     &	      (ik.eq.0 .and. lnull)             ) then
	    if (iw.ge.imi .and. iw.le.ima) then
	      iarray(iwin,iframe,ik)=iw
	    else
	      ier_num = -7
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -4
 	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine para_setii(zeile,lp,iarray,nia,nib,befehl,imi,ima)
c+
c	Sets option value in integer arrays(nia,nib)
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=4)
c
	character*(*)	zeile,befehl
	character*200	cpara(maxw)
	character*20	cdummy
	integer		nia,nib
	integer		iarray(maxwin,maxframe,nia,nib),imi,ima
	integer		lpara(maxw),lp
	integer		ianz,ik,iw,ip
	real		werte(maxw)
c
	integer		len_str
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  cdummy = 'kuplot '//befehl
	  call do_hel(cdummy,-len_str(cdummy))
	elseif (ianz.eq.3) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  ik=nint(werte(1))
	  ip=nint(werte(2))
	  iw=nint(werte(3))
	  if (ik.le.(iz-1) .and. ik.ge.1) then
	    if (ip.ge.1 .and. ip.le.maxhl) then
	      if (iw.ge.imi .and. iw.le.ima) then
	        iarray(iwin,iframe,ik,ip)=iw
	      else
	        ier_num = -7
	        ier_typ = ER_APPL
	      endif
	    else
	      ier_num = -14
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -4
 	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine para_setr(zeile,lp,array,befehl,awert)
c+
c	Sets option value in integer arrays
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=2)
c
	character*(*)	zeile,befehl
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz
	real		werte(maxw),array,awert
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  array = awert
	elseif (ianz.eq.1) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  array=werte(1)
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7**************************************************************
	subroutine para_set_title(zeile,lp,string)
c+
c	Sets strings for title
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=10)
c
	character*(*)	zeile,string
	integer		lp
c
	character*200	cpara(maxw)
	integer		lpara(maxw),ianz
	real		werte(maxw)
c
	call get_params(zeile,ianz,cpara,lpara,maxw,-lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  string = ' '
	else
	  call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	  if (ier_num.ne.0) return
	  string = cpara(1)
	endif
c
	end
c*****7**************************************************************
	subroutine para_set_achse(zeile,lp,string,lflag)
c+
c	Sets strings for axes
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=10)
c
	character*(*)	zeile,string
	integer		lp
c
	character*200	cpara(maxw)
	integer		lpara(maxw),ianz
	real		werte(maxw)
	logical		lflag,str_comp
c
	call get_params(zeile,ianz,cpara,lpara,maxw,-lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  string = ' '
	else
	  call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	  if (ier_num.ne.0) return
	  string = cpara(1)
c
	  if (ianz.eq.2) then
	    lflag = str_comp(cpara(2),'log',2,lpara(2),3)
	  endif
	endif
c
	end
c*****7*****************************************************************
	subroutine set_fill(zeile,lp)
c+
c	Sets options for filling
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=7)
c
	character*(*)	zeile
	character*200	cpara(maxw),cdummy
	integer		lpara(maxw),lp
	integer		ianz,ik,ic,it
	real		werte(maxw)
c
	integer		len_str
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  cdummy = 'kuplot fill'
	  call do_hel(cdummy,-len_str(cdummy))
c
	elseif (ianz.eq.3 .or. ianz.eq.5 .or. ianz.eq.7) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  ik=nint(werte(1))
	  ic=nint(werte(2))
	  it=nint(werte(3))
c
	  if (ik.gt.(iz-1) .or. ik.lt.1) then
	    ier_num = -4
 	    ier_typ = ER_APPL
	    return
	  endif
c
	  if (ic.gt.15 .or. ic.lt.1 .or. 
     &	      it.gt. 8 .or. it.lt.1     ) then
	    ier_num = -7
 	    ier_typ = ER_APPL
	    return
	  endif
c
	  ifillcol(iwin,iframe,ik)    = ic
	  ifilltyp(iwin,iframe,ik)    = it
	  fillrange(iwin,iframe,ik,1) = -9999.
	  fillrange(iwin,iframe,ik,2) = -9999.
	  fillrange(iwin,iframe,ik,3) = -9999.
	  fillrange(iwin,iframe,ik,4) = -9999.
c
	  if (ianz.eq.5) then
	    fillrange(iwin,iframe,ik,1) = werte(4)
	    fillrange(iwin,iframe,ik,2) = werte(5)
	  endif
	  if (ianz.eq.7) then
	    fillrange(iwin,iframe,ik,1) = werte(4)
	    fillrange(iwin,iframe,ik,2) = werte(5)
	    fillrange(iwin,iframe,ik,3) = werte(6)
	    fillrange(iwin,iframe,ik,4) = werte(7)
	  endif
c
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine set_bond(zeile,lp)
c+
c	Sets options for bond drawings
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=6)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ib,ianz
	real		werte(maxw)
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  write (output_io,1000) iframe
	  do ib=1,maxbond
	    if (bond_rad(iwin,iframe,ib).gt.0.0) then
	      write(output_io,1100) 
     &	         ib,bond_rad(iwin,iframe,ib),bond_sig(iwin,iframe,ib),
     &	         bond_lcol(iwin,iframe,ib),bond_ltyp(iwin,iframe,ib),
     &	         bond_lwid(iwin,iframe,ib)
	    endif
	  enddo
	elseif (ianz.ge.2) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  ib = nint(werte(1))
	  if (ib.ge.1 .and. ib.le.maxbond) then
	    if (ianz.eq.2) then
	      bond_rad(iwin,iframe,ib) = werte(2)
	    elseif (ianz.eq.3) then
	      bond_rad(iwin,iframe,ib) = werte(2)
	      bond_sig(iwin,iframe,ib) = werte(3)
	    elseif (ianz.eq.6) then
	      bond_rad(iwin,iframe,ib) = werte(2)
	      bond_sig(iwin,iframe,ib) = werte(3)
	      bond_ltyp(iwin,iframe,ib) = nint(werte(4))
	      bond_lcol(iwin,iframe,ib) = nint(werte(5))
	      bond_lwid(iwin,iframe,ib) = werte(6)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  else
	    ier_num = -33
	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
1000	format (' Bond drawing settings for frame ',I3,' ...',//,
     &	        '    #   distance  sigma  col typ width ',/,
     &	        '   ----------------------------------- ')
1100	format (3X,I3,2X,F8.4,2X,F5.3,3X,I1,2X,I1,3X,F4.2)
	end
c*****7*****************************************************************
	subroutine set_linewidth(zeile,lp)
c+
c	Sets linewidth for given data set
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=3)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	character*20	cdummy
	integer		lpara(maxw),lp
	integer		ianz,ik
	real		werte(maxw)
c
	integer		len_str
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  cdummy = 'kuplot lwid'
	  call do_hel(cdummy,-len_str(cdummy))
	elseif (ianz.eq.2) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  ik=nint(werte(1))
	  if (ik.le.(iz-1) .and. ik.ge.0) then
	    linewid(iwin,iframe,ik)=werte(2)
	  else
	    ier_num = -4
 	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine set_ibox(zeile,lp)
c+
c	Sets type of box & axis for active frame
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=2)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	character*20	cdummy
	integer		lpara(maxw),lp
	integer		ianz,it
	real		werte(maxw)
c
	integer		len_str
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  cdummy = 'kuplot fset'
	  call do_hel(cdummy,-len_str(cdummy))
	elseif (ianz.eq.1) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  it=nint(werte(1))
	  if (abs(it).ge.0 .and. abs(it).le.3) then
	    ibox(iwin,iframe)=it
	  else
	    ier_num = -6
 	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine set_sizemark(zeile,lp)
c+
c	Sets size of markers
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=3)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz,ik
	real		werte(maxw)
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.2) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  ik=nint(werte(1))
	  if (ik.le.(iz-1) .and. ik.ge.0) then
	    sizemark(iwin,iframe,ik)=werte(2)
	  else
	    ier_num = -4
 	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine set_legend(zeile,lp)
c+
c	Sets possible caption for given data set
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=10)
c
	character*(*)	zeile
c
	character*200	cpara(maxw)
	character*20	cdummy
	integer		lpara(maxw),lp
	integer		ianz,ik
	real		werte(maxw)
c
	logical		str_comp
	integer		len_str
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  cdummy = 'kuplot sleg'
	  call do_hel(cdummy,-len_str(cdummy))
	elseif (ianz.ge.2) then
	  call ber_params(1,cpara,lpara,werte,maxw)
	  if(ier_num.ne.0) return
	  ik=nint(werte(1))
	  if (ik.gt.0 .and. ik.le.(iz-1)) then
	    if (str_comp(cpara(2),'off',3,lpara(2),3)) then
	      ilegend(iwin,iframe,ik)=0
	      info_orig(iwin,iframe,1)=-9999.
	    else
	      call get_params(zeile,ianz,cpara,lpara,maxw,-lp)
	      call del_params(1,ianz,cpara,lpara,maxw)
	      call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	      if (ier_num.ne.0) return
	      ilegend(iwin,iframe,ik)=1
	      clegend(iwin,iframe,ik)=cpara(1)
	      if (ianz.eq.3) then
	        call del_params(1,ianz,cpara,lpara,maxw)
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        info_orig(iwin,iframe,1)=werte(1)
	        info_orig(iwin,iframe,2)=werte(2)
	      else
	        info_orig(iwin,iframe,1)=-9999.
	      endif
	    endif
	  else
	    ier_num = -4
 	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine set_annotation(zeile,lp)
c+
c	Sets possible annotations
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=10)
c
	character*(*)	zeile
c
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz,ik
	real		werte(maxw)
c
	logical		str_comp
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  call show_annotation
	elseif (ianz.ge.2) then
	  call ber_params(1,cpara,lpara,werte,maxw)
	  if(ier_num.ne.0) return
	  ik=nint(werte(1))
	  if (ik.gt.0 .and. ik.le.maxan) then
	    if (str_comp(cpara(2),'OFF',3,lpara(2),3)) then
	      antext(iwin,iframe,ik)='OFF'
	    else
	      call get_params(zeile,ianz,cpara,lpara,maxw,-lp)
	      call del_params(1,ianz,cpara,lpara,maxw)
	      call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	      if (ier_num.ne.0) return
	      antext(iwin,iframe,ik)=cpara(1)
	      call del_params(1,ianz,cpara,lpara,maxw)
	      if (ianz.eq.2 .or. ianz.eq.3 .or. 
     &	          ianz.eq.4 .or. ianz.eq.6     ) then
	        call ber_params(2,cpara,lpara,werte,maxw)
	        antx(iwin,iframe,ik)=werte(1) 
	        anty(iwin,iframe,ik)=werte(2) 
c
	        if (ianz.ge.3) then
	          if (str_comp(cpara(3),'left',1,lpara(3),4)) then
	            anjust(iwin,iframe,ik)=if_left
	          elseif (str_comp(cpara(3),'righ',1,lpara(3),4)) then
	            anjust(iwin,iframe,ik)=if_right
	          elseif (str_comp(cpara(3),'cent',1,lpara(3),4)) then
	            anjust(iwin,iframe,ik)=if_centre
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        else
	          anjust(iwin,iframe,ik)=if_left
	        endif
c
	        if (ianz.ge.4) then
	          cpara(3) = '0.0'
	          lpara(3) = 3
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          anangle(iwin,iframe,ik)=werte(4)
	        else
	          anangle(iwin,iframe,ik)=0.0
	        endif
c
	        if (ianz.eq.6) then
	          anx(iwin,iframe,ik)=werte(5) 
	          any(iwin,iframe,ik)=werte(6) 
	        else
	          anx(iwin,iframe,ik)=antx(iwin,iframe,ik)
	          any(iwin,iframe,ik)=anty(iwin,iframe,ik)
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    endif
	  else
	    ier_num = -28
 	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine set_buff (zeile,lp)
c+
c	Command buff ..
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=5)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz
	real		werte(maxw)
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.1) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  ibuf(iwin,iframe,1) = werte(1)
	  ibuf(iwin,iframe,2) = werte(1)
	  ibuf(iwin,iframe,3) = werte(1)
	  ibuf(iwin,iframe,4) = werte(1)
	elseif (ianz.eq.4) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  ibuf(iwin,iframe,1) = werte(1)
	  ibuf(iwin,iframe,2) = werte(2)
	  ibuf(iwin,iframe,3) = werte(3)
	  ibuf(iwin,iframe,4) = werte(4)
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine set_skal (zeile,lp)
c+
c	Command skal ..
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=5)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz
	real		werte(maxw)
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  ex(iwin,iframe,1) = -9999.0
	  t(iwin,iframe,1)  = -9999.0
	elseif (ianz.eq.2 .or. ianz.eq.4) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  call skalieren
	  call no_error
	  if (werte(1).lt.werte(2)) then
	    ex(iwin,iframe,1) = werte(1)
	    ex(iwin,iframe,2) = werte(2)
	    if (ianz.eq.4) then
	      if (werte(3).lt.werte(4)) then
	        ey(iwin,iframe,1) = werte(3)
	        ey(iwin,iframe,2) = werte(4)
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    endif
	    call skalieren
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine set_mark (zeile,lp)
c+
c	Command mark ..
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=5)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz
	real		werte(maxw)
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  t(iwin,iframe,1)   = -9999.0
	elseif (ianz.eq.1 .or. ianz.eq.2) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  call skalieren
	  call no_error
	  if (werte(1).gt.0.0) then
	    t(iwin,iframe,1) = werte(1)
	    if (ianz.eq.2) then
	      if (werte(2).gt.0.0) then
	        t(iwin,iframe,2) = werte(2)
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine set_hpak (zeile,lp)
c+
c	Setting of contour line intervalls
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=2)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz,ii
	real		werte(maxw)
c
c------ get parameters
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
c------ no parameters : show actual settings
c
	if     (ianz.eq.0) then
	  call show_hlin
c
c------ set number of contour line sets
c
	elseif (ianz.eq.1) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  ii=nint(werte(1))
	  if (ii.gt.0 .and. ii.lt.maxhl) then
	    iho(iwin,iframe)=ii
	  else
	    ier_num = -14
	    ier_typ = ER_APPL
	  endif
c
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine set_hlin (zeile,lp)
c+
c	Setting of contour line intervalls
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=6)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz,ihl,i
	real		werte(maxw)
	real		zzmin,zzmax,zhub
	logical		proz,k_in_f
c
c------ get parameters
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
c------ no parameters : show actual settings
c
	if     (ianz.eq.0) then
	  call show_hlin
c
c------ set contour line base, intervall, number and optinally mode
c
	elseif (ianz.eq.4 .or. ianz.eq.5) then
	  proz = .false.
	  if (ianz.eq.5) then
	    proz = (cpara(5)(1:1).eq.'%')
	    ianz = ianz-1
	  endif
c
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
c
	  ihl=nint(werte(1))
	  if (ihl.ge.1 .and. ihl.le.maxhl) then
	    iho(iwin,iframe)       = max(iho(iwin,iframe),ihl)
	    nz(iwin,iframe,ihl)    = nint(werte(4))
c
	    if (proz) then
	      call get_extrema
	      zzmax=-1e19
	      zzmin= 1e19
	      do i=1,iz-1
	        if (k_in_f(i)) then
	          zzmax=max(zzmax,zmax(i))
	          zzmin=min(zzmin,zmin(i))
	        endif
	      enddo
c
	      zhub = zzmax-zzmin
	      if (zhub.eq.0) zhub=100.0
	      z_min(iwin,iframe,ihl) = zzmin + 0.01*zhub*werte(2)
	      z_inc(iwin,iframe,ihl) =         0.01*zhub*werte(3)
	    else
	      z_min(iwin,iframe,ihl) = werte(2)
	      z_inc(iwin,iframe,ihl) = werte(3)
	    endif
	  else
	    ier_num = -14
	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine set_font (zeile,lp)
c+
c	Setting of font size, type and color
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=4)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz,icol,ifon,ifid
	real		werte(maxw)
	real		fsiz
	logical		str_comp
c
c------ get parameters
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
c------ no parameters : show actual settings
c
	if     (ianz.eq.0) then
	  call show_font
	elseif (ianz.ge.2) then
c
c------ - set font size
c
	  if (str_comp(cpara(1),'size',2,lpara(1),4)) then
	    call del_params(1,ianz,cpara,lpara,maxw)
	    call ber_params(ianz,cpara,lpara,werte,maxw)
	    if (ier_num.ne.0) return
	    if (ianz.eq.2) then
	      ifon = nint(werte(1))
	      fsiz = werte(2)
	      if (ifon.gt.0   .and. ifon.le.nfon  .and.
     &	          fsiz.ge.4.0 .and. fsiz.le.128.0      ) then
	        fonsize(iwin,iframe,ifon)=10.0*fsiz
	      else
	        ier_num = -7
	        ier_typ = ER_APPL
	      endif
	    elseif (ianz.eq.1) then
	      fonscal(iwin,iframe)=werte(1)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------ - set font color
c
	  elseif (str_comp(cpara(1),'color',2,lpara(1),5)) then
	    call del_params(1,ianz,cpara,lpara,maxw)
	    call ber_params(ianz,cpara,lpara,werte,maxw)
	    if (ier_num.ne.0) return
	    if (ianz.eq.2) then
	      ifon = nint(werte(1))
	      icol = nint(werte(2))
	      if (ifon.gt.0 .and. ifon.le.nfon .and.
     &	          icol.gt.0 .and. icol.le.15        ) then
	        foncol(iwin,iframe,ifon)=icol
	      else
	        ier_num = -7
	        ier_typ = ER_APPL
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------ - set font typ
c
	  elseif (str_comp(cpara(1),'typ',2,lpara(1),3)) then
	    call del_params(1,ianz,cpara,lpara,maxw)
	    call ber_params(ianz,cpara,lpara,werte,maxw)
	    if (ier_num.ne.0) return
	    if (ianz.eq.2) then
	      ifon = nint(werte(1))
	      ifid = nint(werte(2))
	      if (ifon.gt.0 .and. ifon.le.nfon  .and.
     &	          ifid.gt.0 .and. ifid.le.4          ) then
	        fon_id(iwin,iframe,ifon)=ifid
	      else
	        ier_num = -7
	        ier_typ = ER_APPL
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------ - set text justification for title / textframes
c
	  elseif (str_comp(cpara(1),'just',2,lpara(1),4)) then
	    if (ier_num.ne.0) return
	    if (ianz.eq.2) then
	      if (str_comp(cpara(2),'cen',1,lpara(2),3)) then
	        frjust(iwin,iframe)=if_centre
	      elseif (str_comp(cpara(2),'left',1,lpara(2),4)) then
	        frjust(iwin,iframe)=if_left
	      else
	        ier_num = -7
	        ier_typ = ER_APPL
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end    
c****7******************************************************************
	subroutine do_rese
c+
c	Reset KUPLOT
c-
	implicit	none
c
	include 	'config.inc'
	include 	'kuplot.inc'
c
	integer		iw,i,j
c
	iz=1
	iframe=1
c
	do i=1,maxkurvtot
	  lni(i)     = .false.
	  ikfirst(i) = .true.
	enddo
c
	do iw=1,maxwin
	  iaf(iw)=1
	  frame(iw,1,1)=0.0
	  frame(iw,1,2)=0.0
	  frame(iw,1,3)=1.0
	  frame(iw,1,4)=1.0
c
	  do i=1,maxframe
	    ex(iw,i,1)     = -9999.
	    lyskal(iw,i)   = .false.
	    t(iw,i,1)      = -9999.0
	    frback(iw,i,1) = 1.0
	    frback(iw,i,2) = 1.0
	    frback(iw,i,3) = 1.0
	    fonscal(iw,i)  = 1.0
	    shear(iw,i)    = 90.0
c
	    do j=1,maxkurvtot
	      infra(iw,i,j)=j
	    enddo
  	  enddo
  	enddo
c
	end
c****7******************************************************************
	subroutine skalieren
c+
c 	setting up plotting window
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*8	ct
	integer		i
	real		dummy_x(2),dummy_y(2)
	logical		k_in_f
c
c------ get data set extrema
c
	call get_extrema
c
c------ set plotting window
c
	if(ex(iwin,iframe,1).eq.-9999.) then
	  ex(iwin,iframe,1)= 1.0e19
	  ex(iwin,iframe,2)=-1.0e19
	  ey(iwin,iframe,1)= 1.0e19
	  ey(iwin,iframe,2)=-1.0e19
	  do i=1,iz-1
	    if (k_in_f(i)) then
	      ex(iwin,iframe,1)=min(ex(iwin,iframe,1),xmin(i))
	      ex(iwin,iframe,2)=max(ex(iwin,iframe,2),xmax(i))
	      ey(iwin,iframe,1)=min(ey(iwin,iframe,1),ymin(i))
	      ey(iwin,iframe,2)=max(ey(iwin,iframe,2),ymax(i))
	    endif
	  enddo
c
	  if (ey(iwin,iframe,2).eq.ey(iwin,iframe,1)) then
	    ey(iwin,iframe,1) = ey(iwin,iframe,1)-0.2*ey(iwin,iframe,1)
	    ey(iwin,iframe,2) = ey(iwin,iframe,2)+0.2*ey(iwin,iframe,2)
	  endif
	endif	             
c
c------ set tick marks
c
	if(t(iwin,iframe,1).eq.-9999.) then
	  t(iwin,iframe,1)=(ex(iwin,iframe,2)-ex(iwin,iframe,1))*0.125
	  t(iwin,iframe,2)=(ey(iwin,iframe,2)-ey(iwin,iframe,1))*0.125
	  write (ct,'(g8.1)') t(iwin,iframe,1)
	  read  (ct,*) t(iwin,iframe,1)
	  write (ct,'(g8.1)') t(iwin,iframe,2)
	  read  (ct,*) t(iwin,iframe,2)
        endif
c
c------ Now extract the values for plotting 
c
	dummy_x(1) = ex(iwin,iframe,1)
	dummy_x(2) = ex(iwin,iframe,2)
	dummy_y(1) = ey(iwin,iframe,1)
	dummy_y(2) = ey(iwin,iframe,2)
c
	if (lachse(iwin,iframe,1) .and. dummy_x(1).le.0.0) then
	  ier_num = -43
	  ier_typ = ER_APPL
	  dummy_x(1) = 1.0
	endif
c
	if (lachse(iwin,iframe,2) .and. dummy_y(1).le.0.0) then
	  ier_num = -43
	  ier_typ = ER_APPL
	  dummy_y(1) = 1.0
	endif
c
	call koor_log(2,dummy_x,dummy_y)
c
	pex(iwin,iframe,1) = dummy_x(1)
	pex(iwin,iframe,2) = dummy_x(2)
	pey(iwin,iframe,1) = dummy_y(1)
	pey(iwin,iframe,2) = dummy_y(2)
c
	dummy_x(1) = t(iwin,iframe,1)
	dummy_y(1) = t(iwin,iframe,2)
c
	call koor_log(1,dummy_x,dummy_y)
c
	if (lachse(iwin,iframe,1)) dummy_x(1)=float(nint(dummy_x(1)))
	if (lachse(iwin,iframe,2)) dummy_y(1)=float(nint(dummy_y(1)))
	pt(iwin,iframe,1) = dummy_x(1)
	pt(iwin,iframe,2) = dummy_y(1)
c
	end
c****7******************************************************************
	subroutine write_para
c+                                                       
c 	write parameter file 'kupl.par'
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c                           
	integer		ifil
	parameter	(ifil = 21)
c
	integer		ifr,ik,i
	logical		lho
c
	lho=.false.
	call oeffne (ifil,'kupl.par','unknown',.false.)
	if (ier_num.ne.0) return
c
	write (ifil,1000)
	write (ifil,1002) yskal_u(iwin,iframe),shear(iwin,iframe)
	do ik=1,iz-1
	  if(lni(ik)) then
	    write(ifil,1005) fname(ik),xmin(ik),xmax(ik),
     &	                   ymin(ik),ymax(ik),zmin(ik),zmax(ik)
	    lho=.true.
	  else
	    write(ifil,1010) fname(ik),xmin(ik),xmax(ik),
     & 	                   ymin(ik),ymax(ik)
	  endif
	enddo
c
	if (lho) then
	  do ifr=1,iaf(iwin)
	    write (ifil,1020) ifr
	    do i=1,iho(iwin,ifr)
	      write (ifil,1030) z_min(iwin,ifr,i),z_inc(iwin,ifr,i),
     &	                        nz(iwin,ifr,i)
	    enddo
	  enddo
	endif
	close (ifil)
c
1000	format ( ' Plot - parameter : '/)
1002	format ( ' Ratio y/x-axis   : ',g9.4e1,/
     &	         ' Angle x/y axis   : ',g9.4e1,/)
1005	format ( ' File : ',a40,/
     &           '    x : ',g9.4e1,' to ',g9.4e1/  
     &           '    y : ',g9.4e1,' to ',g9.4e1/  
     &           '    z : ',g9.4e1,' to ',g9.4e1)
1010	format ( ' File : ',a40,/
     &           '    x : ',g9.4e1,' to ',g9.4e1/  
     &           '    y : ',g9.4e1,' to ',g9.4e1)
1020   	format (/' Contours     [frame ',i2,'] : '/
     &           ' minimum     step        #')
1030	format ( 1x,g10.4,1x,g10.4,2x,i2)
c
	end
c****7******************************************************************
