c*********************************************************************
c
c	These are the main plot routines for 2D and 3D data. 3D data
c	can be plotted as contour plots or bitmaps or both. All
c	settings are defined in 'kuplot.inc'.
c
c	Version : 4.2
c	Date    : 21. June 2000
c
c	Author  : Th. Proffen  (tproffen@lanl.gov )
c
c*********************************************************************
 	subroutine do_plot (lmenu)
c
c	Main plotting routine
c
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	real		x1,x2,y1,y2,width,ratio
	integer		ii,ik,idev,irtn
	logical		k_in_f,tfr,lmenu
c
	integer		PGOPEN
c
c------ see if there are data at all
c
	tfr = .false.
	do ii=1,iaf(iwin)
	  tfr = tfr .or. (infra(iwin,ii,1).eq.-1)
	enddo
c
	if (iz.le.1 .and. .not.tfr) then
	  ier_num = -12
	  ier_typ = ER_APPL
	  return
	endif
c
c------ Open screen graphics device
c
	if (lmenu) then
	  dev_draw(iwin,1) = 0.20
	  dev_draw(iwin,2) = 0.15
	else
	  dev_draw(iwin,1) = 0.00
	  dev_draw(iwin,2) = 0.00
	endif
c
	if (dev_id(iwin,x11).eq.-1) then
	  dev_id(iwin,x11) = PGOPEN (dev_name(x11))
	  if (dev_id(iwin,x11).le.0) stop
	  width = dev_sf(iwin,x11)*dev_width(iwin)
	else
	  call PGSLCT (dev_id(iwin,x11))
	  if (dev_name(x11)(2:3).ne. 'GW') then
	    call PGCLOS
	    dev_id(iwin,x11) = PGOPEN (dev_name(x11))
	    call PGQVSZ (1,x1,x2,y1,y2)
	    width = x2-x1
	  else
	    width = dev_sf(iwin,x11)*dev_width(iwin)
	  endif
	endif
c
c------ Getting ready to plot
c------ Colour_setup is done twice due to some strange
c------ difference between the GW and X11 drivers ????
c
	call colour_setup
	ratio = dev_height(iwin)/dev_width(iwin)
	call PGPAP (width,ratio)
	call PGASK (.false.)
	call PGPAGE
	call colour_setup
c
c------ here starts the plotting
c
	do ii=1,iaf(iwin)
	  call draw_frame (ii,lmenu)
	enddo 
c
c------ draw menu parts
c
	if (lmenu) call draw_menu
c
c------ draw identification 
c
	if (iden(iwin)) then
	  call PGSCI (foncol(iwin,iframe,3))
	  call PGIDEN
	endif
c
	end
c*********************************************************************
 	subroutine do_hardcopy (befehl,zeile,lbef,lp)
c+
c	This is the plotting routine for hardcopies
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=10)
c
	character*(*)	befehl,zeile
	character*200	cpara(maxw),prnbef
	character*80	filname,uname
	real		werte(maxw)
	real		x1,x2,y1,y2,width,ratio
	integer		lpara(maxw)
	integer		ianz,ii,ik,idev,lbef,lp
	logical		k_in_f,tfr,lrena,lmenu
c
	integer		len_str
	integer		PGOPEN
c
	lmenu = .false.
c
c------ see if there are data at all
c
	tfr = .false.
	do ii=1,iaf(iwin)
	  tfr = tfr .or. (infra(iwin,ii,1).eq.-1)
	enddo
c
	if (iz.le.1 .and. .not.tfr) then
	  ier_num = -12
	  ier_typ = ER_APPL
	  return
	endif
c
	call do_cap(befehl)
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
c------ Command save or print
c
	if (befehl(1:2).eq.'SA') then
	  if (ianz.ge.1) then
	    lrena = .false.
	    call do_cap(cpara(1))
	    if     (cpara(1)(1:2).eq.'PS') then
	      filname = 'kuplot.ps'
	      if (orient(iwin)) then
	        idev = ps
	      else
	        idev = vps
	      endif
	    elseif (cpara(1)(1:2).eq.'PI') then
	      filname = 'kuplot.pic'
	      if (orient(iwin)) then
	        idev = pic
	      else
	        idev = vpic
	      endif
	    else
	      ier_num = -11
	      ier_typ = ER_APPL
	      return
	    endif
	    if (ianz.ge.2) then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	      uname = cpara(1)
	      lrena = .true.
	    else
	      uname = filname
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	    return
	  endif
c
	  ii=len_str(uname)
	  write (output_io,1000) iwin,uname(1:ii)
c
c------ Command prin
c
	elseif (befehl(1:2).eq.'PR') then
	  filname = 'kuplot.plt'
	  if (orient(iwin)) then
	    idev = ps
	  else
	    idev = vps
	  endif
	  lrena   = .false.
c
	  if (ianz.ge.1) then
	    call do_cap(cpara(1))
	    if (cpara(1)(1:2).ne.'PS') then
	      ier_num = -11
	      ier_typ = ER_APPL
	      return
	    endif
	  endif
c
	  if (ianz.gt.1) then
	    call get_params(zeile,ianz,cpara,lpara,maxw,-lp)
	    call del_params (1,ianz,cpara,lpara,maxw)
	    call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	    prnbef = cpara(1)
	  else
	    prnbef = dev_prn(idev)
	  endif
	endif  
	if (ier_num.ne.0) return
c
c------ Opening device
c
	dev_draw(iwin,1) = 0.00
	dev_draw(iwin,2) = 0.00
c
	dev_id(iwin,idev) = PGOPEN (filname//dev_name(idev))
	if (dev_id(iwin,idev).le.0) stop
c
	width = dev_sf(iwin,idev)*dev_width(iwin)
	ratio = dev_height(iwin)/dev_width(iwin)
c
	call PGPAP (width,ratio)
	call colour_setup
c
c------ here starts the plotting
c
	do ii=1,iaf(iwin)
	  call draw_frame (ii,lmenu)
	enddo 
c
c------ draw identification 
c
	if (iden(iwin)) then
	  call PGSCI (foncol(iwin,iframe,3))
	  call PGIDEN
	endif
c
	call PGCLOS
c
c------ check if we need to rename ouputfile
c
	if (lrena) call do_rename_file(filname,uname)
c
c------ if the command was prin we'll print
c
	if (befehl(1:2).eq.'PR') then
	  ii=len_str(prnbef)
	  prnbef = prnbef(1:ii)//' '//filname
	  ii=len_str(prnbef)
	  write (output_io,2000) iwin,prnbef(1:ii)
	  call do_operating (prnbef(1:ii),ii)
	  call do_del_file (filname)
	endif
c
1000	format (' ------ > Saving window ',i3,' to file : ',a,' ..')
2000	format (' ------ > Printing window ',i3,' using : ',a,' ..')
	end
c*****7*****************************************************************
	subroutine colour_setup
c+
c	This sets the default KUPLOT colours ...
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	integer		ic
c
	do ic=0,15
	  call PGSCR (ic,colour(iwin,ic,1),colour(iwin,ic,2),
     &	                                   colour(iwin,ic,3))
	enddo
c
	end
c*****7*****************************************************************
	subroutine open_frame (ii,lwhite)
c+
c	This routine sets background and border for frame ii
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	real		x1,x2,y1,y2
	integer		ic,ii
	logical		lwhite
c
c------ Plot border and background colour if required
c
	x1 = frame(iwin,ii,1) * (1.0-dev_draw(iwin,1))
	x2 = frame(iwin,ii,3) * (1.0-dev_draw(iwin,1))
	y1 = frame(iwin,ii,2) * (1.0-dev_draw(iwin,2))+dev_draw(iwin,2)
	y2 = frame(iwin,ii,4) * (1.0-dev_draw(iwin,2))+dev_draw(iwin,2)
c
	if (y2.ge.1.0) y2=y2-0.001
	if (x2.ge.1.0) x2=x2-0.001
c
	call PGSVP  (x1,x2,y1,y2)
	call PGSWIN (0.0,1.0,0.0,1.0)
c
	if (frback(iwin,ii,1).ne.1.0 .or.
     &	    frback(iwin,ii,2).ne.1.0 .or.
     &	    frback(iwin,ii,3).ne.1.0 .or. lwhite) then
	  ic = ii + 15
	  call PGSCR  (ic,frback(iwin,ii,1),frback(iwin,ii,2),
     &	                                    frback(iwin,ii,3))
	  if (lwhite) then 
	    call PGSCI (0) 
	  else 
	    call PGSCI (ic)
	  endif
	  call PGSFS  (1)
	  call PGRECT (0.0,1.0,0.0,1.0)
	endif
c
        if (tot_frame(iwin)) call border_frame (ii,1,0.0)
c
	end
c*****7*****************************************************************
	subroutine border_frame (ii,icol,delta)
c+
c	This routine draws border around frame ii
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	real		x1,x2,y1,y2,delta,deltay
	integer		ii,icol
c
c------ Plot border and background colour if required
c
	x1 = frame(iwin,ii,1) * (1.0-dev_draw(iwin,1))
	x2 = frame(iwin,ii,3) * (1.0-dev_draw(iwin,1))
	y1 = frame(iwin,ii,2) * (1.0-dev_draw(iwin,2))+dev_draw(iwin,2)
	y2 = frame(iwin,ii,4) * (1.0-dev_draw(iwin,2))+dev_draw(iwin,2)
c
	if (y2.ge.1.0) y2=y2-0.001
	if (x2.ge.1.0) x2=x2-0.001
c
	deltay = (y2-y1)/(x2-x1)
	deltay = delta / deltay
c
	call PGSVP  (x1,x2,y1,y2)
	call PGSWIN (0.0,1.0,0.0,1.0)
c
	call PGSCI  (icol)
	call PGSFS  (2)
	call PGRECT (0.0+delta,1.0-delta,0.0+deltay,1.0-deltay)
c
	end
c*****7*****************************************************************
	subroutine open_viewport
c+
c	This routine sets the viewport and window for the current
c	frame (-> iframe)
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'wink.inc'
c
	real		wxmi,wxma,wymi,wyma
	real		xx,yy,x1,x2,y1,y2,vl,vr,vb,vt,yf,off
c
c------ Set viewport for current frame
c
	vl = min(1.0,(frame(iwin,iframe,1) + ibuf(iwin,iframe,1)))
	vr = max(0.0,(frame(iwin,iframe,3) - ibuf(iwin,iframe,2)))
	vb = min(1.0,(frame(iwin,iframe,2) + ibuf(iwin,iframe,3)))
	vt = max(0.0,(frame(iwin,iframe,4) - ibuf(iwin,iframe,4)))
c
	vl = vl * (1.0-dev_draw(iwin,1))
	vr = vr * (1.0-dev_draw(iwin,1))
	vb = vb * (1.0-dev_draw(iwin,2)) + dev_draw(iwin,2)
	vt = vt * (1.0-dev_draw(iwin,2)) + dev_draw(iwin,2)
c
	call PGSVP  (vl,vr,vb,vt)
c
c------ Force user defined aspect ratio if required
c
	if (.not.lyskal(iwin,iframe) .and. 
     &	    shear(iwin,iframe).ne.90.0     ) then
	  lyskal(iwin,iframe)  = .true.
	  yskal_u(iwin,iframe) = 1.0
	endif
c
	yf = sin(rad*shear(iwin,iframe))
	if (lyskal(iwin,iframe)) then
	  yskal(iwin,iframe) = yskal_u(iwin,iframe)*yf
	  xx = pex(iwin,iframe,2)-pex(iwin,iframe,1)
	  yy = pey(iwin,iframe,2)-pey(iwin,iframe,1)
	  x1 = pex(iwin,iframe,2)
	  y1 = pey(iwin,iframe,2)
	  call koor_shear (1,x1,y1)
	  off = x1 - pex(iwin,iframe,2)
	  call PGWNAD (0.0,1.0,0.0,
     &	              (yy/(xx+abs(off)))*yskal(iwin,iframe))
	else
	  call PGQVP (2,x1,x2,y1,y2)
	  yskal(iwin,iframe)   = (y2-y1)/(x2-x1)
	  yskal_u(iwin,iframe) = yskal(iwin,iframe)/yf
	endif
c
c------ Set coordinates for current frame
c
	x1 = pex(iwin,iframe,2)
	y1 = pey(iwin,iframe,2)
	call koor_shear (1,x1,y1)
	off = x1 - pex(iwin,iframe,2)
c
	if (shear(iwin,iframe).le.90.0) then
	  call PGSWIN (pex(iwin,iframe,1),pex(iwin,iframe,2)+off,
     &	               pey(iwin,iframe,1),pey(iwin,iframe,2))
	else
	  call PGSWIN (pex(iwin,iframe,1)+off,pex(iwin,iframe,2),
     &	               pey(iwin,iframe,1),pey(iwin,iframe,2))
	endif
c
	end
c*********************************************************************
 	subroutine draw_frame (ii,lmenu)
c+
c	Here we actually do the plotting ...
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=10)
c
	integer		ik,ii,iframe_old
	logical		k_in_f,lmenu
c
	call PGBBUF
c
	iframe_old = iframe
	iframe = ii
c
	call open_frame (iframe,lmenu)
	if (infra(iwin,iframe,1).eq.-1) then
	  call draw_text_frame
	else
	  call skalieren
	  call open_viewport
	  do ik=1,iz-1
	    if ((hlineart(iwin,iframe,ik).eq.2 .or. 
     &	         hlineart(iwin,iframe,ik).eq.3     ) .and. 
     &	         k_in_f(ik) .and. lni(ik)) call draw_bitmap (ik)
	  enddo
	  call draw_werte
	  call draw_rahmen
	endif
c
	iframe = iframe_old
c
	call PGEBUF
c
	end
c****7******************************************************************
	subroutine draw_text_frame
c+                                                       
c 	plot text frame
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'wink.inc'
	include		'errlist.inc'
c
	character*80	zeile,filname
	real		xh,yh,xt,yt
	integer		i
c
	integer		len_str
c
	filname=ftext(iwin,iframe)
	call do_cap (filname)
c
	if (filname.eq.'PARA' .or. filname.eq.'KUPL.PAR') then
	  call write_para
	  filname = 'kupl.par'
	elseif (filname.eq.'FIT' .or. filname.eq.'KUPL.FIT') then
	  call write_fit
	  filname = 'kupl.fit'
	else
	  filname = ftext(iwin,iframe)
	endif
c                   
	call oeffne (21,filname,'unknown',.true.)
	if (ier_num.ne.0) return
c
	call PGSCI (foncol (iwin,iframe,5))
	call PGSLW (nint(linewid(iwin,iframe,0)/0.13))
	call PGSCF (fon_id (iwin,iframe,5))
	call PGSCH (fonscal(iwin,iframe)*fonsize(iwin,iframe,5)/120.0)
	call PGQCS (4,xh,yh)
c
	i=0
10	continue
	  read (21,'(a)',end=20) zeile
	  if (frjust(iwin,iframe).eq.if_left) then
	    xt=0.0
	  else
	    xt=0.5
	  endif
	  yt=1.0-(i+1)*1.05*yh
	  if(len_str(zeile).gt.0 ) then
	    call PGPTXT (xt,yt,0.0,xt,zeile(1:len_str(zeile)))
	  endif
	  i=i+1
	goto 10
20	continue
	close (21)
c
	end                           
c*****7*****************************************************************
	subroutine draw_rahmen
c+
c	This routine draws the labeled frame around the plot.
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	character*2	cal,car,cax
	character*1	clx,cly
	real		ax1,ay1,ax2,ay2,off,off0,adis
	real		rj,xt,yt,ltx,lty
	real		xpl(2),ypl(2)
	real		xh(5),yh(5)
c
	ax1 = pex(iwin,iframe,2)
	ay1 = pey(iwin,iframe,2)
	call koor_shear (1,ax1,ay1)
	off = ax1 - pex(iwin,iframe,2)
c
	call PGSLS (1)
	call PGSLW (nint(linewid(iwin,iframe,0)/0.13))
	call PGSCI (6)
c
c------ IBOX = 0 : nothing 
c
	if (ibox(iwin,iframe).eq.0) return
c
c------ IBOX = 1 : just a box
c
	if (abs(ibox(iwin,iframe)).eq.1) then
	  xh(1) = pex(iwin,iframe,1)
	  yh(1) = pey(iwin,iframe,1)
	  xh(2) = pex(iwin,iframe,2)
	  yh(2) = pey(iwin,iframe,1)
	  xh(3) = pex(iwin,iframe,2)
	  yh(3) = pey(iwin,iframe,2)
	  xh(4) = pex(iwin,iframe,1)
	  yh(4) = pey(iwin,iframe,2)
	  xh(5) = pex(iwin,iframe,1)
	  yh(5) = pey(iwin,iframe,1)
	  call koor_shear (5,xh,yh)
	  call PGLINE (5,xh,yh)
c
c------ IBOX >= 2 : tickmarks, numbers, ..
c
	else
c
c------ - Grid lines
c
	  if (igrid(iwin,iframe)) then
	    call PGSCI (ilinecol(iwin,iframe,0))
	    call PGSLS (4)
c
	    if (pex(iwin,iframe,1).lt.0.0) then
	      do xt=0.0,pex(iwin,iframe,1),-pt(iwin,iframe,1)
	        if (xt.lt.pex(iwin,iframe,2)) then
	          xpl(1) = xt
	          ypl(1) = pey(iwin,iframe,1)
	          xpl(2) = xt
	          ypl(2) = pey(iwin,iframe,2)
	          call koor_shear (2,xpl,ypl)
	          call PGLINE (2,xpl,ypl)
	        endif
	      enddo
	    endif
	    if (pex(iwin,iframe,2).gt.0.0) then
	      do xt=0.0,pex(iwin,iframe,2),pt(iwin,iframe,1)
	        if (xt.gt.pex(iwin,iframe,1)) then
	          xpl(1) = xt
	          ypl(1) = pey(iwin,iframe,1)
	          xpl(2) = xt
	          ypl(2) = pey(iwin,iframe,2)
	          call koor_shear (2,xpl,ypl)
	          call PGLINE (2,xpl,ypl)
	        endif
	      enddo
	    endif
c
	    if (pey(iwin,iframe,1).lt.0.0) then
	      do yt=0.0,pey(iwin,iframe,1),-pt(iwin,iframe,2)
	        xpl(1) = pex(iwin,iframe,1)
	        ypl(1) = yt
	        xpl(2) = pex(iwin,iframe,2)
	        ypl(2) = yt
	        call koor_shear (2,xpl,ypl)
	        call PGLINE (2,xpl,ypl)
	      enddo
	    endif
	    if (pey(iwin,iframe,2).gt.0.0) then
	      do yt=0.0,pey(iwin,iframe,2),pt(iwin,iframe,2)
	        xpl(1) = pex(iwin,iframe,1)
	        ypl(1) = yt
	        xpl(2) = pex(iwin,iframe,2)
	        ypl(2) = yt
	        call koor_shear (2,xpl,ypl)
	        call PGLINE (2,xpl,ypl)
	      enddo
	    endif
	    call PGSCI (6)
	  endif
c
c------ - Axes
c
	  clx = ' '
	  cly = ' '
	  if (lachse(iwin,iframe,1)) clx='L'
	  if (lachse(iwin,iframe,2)) cly='L'
c
	  xpl(1) = pex(iwin,iframe,1)
	  xpl(2) = pex(iwin,iframe,2)
	  ypl(1) = pey(iwin,iframe,1)
	  ypl(2) = pey(iwin,iframe,2)
c
	  ltx    = pt(iwin,iframe,1)
	  lty    = pt(iwin,iframe,2)
c
	  if (ibox(iwin,iframe).gt.1) then
	    cal  = cly//'N'
	    car  = cly//' '
	    adis = -lab_d(iwin,iframe,2)
	  else
	    cal  = cly//' '
	    car  = cly//'N'
	    adis = lab_d(iwin,iframe,2)
	  endif
c
	  cax = clx//'N'
	  if (achse(iwin,iframe,1)(1:3).eq.'OFF') cax = '  '
	  if (achse(iwin,iframe,2)(1:3).eq.'OFF') cal = '  '
	  if (achse(iwin,iframe,2)(1:3).eq.'OFF') car = '  '
c
	  call PGSLS  (1)
	  call PGSLW  (nint(linewid(iwin,iframe,0)/0.13))
	  call PGSCI  (foncol(iwin,iframe,4))
	  call PGSCF  (fon_id(iwin,iframe,4))
	  call PGSCH  (fonscal(iwin,iframe)*
     &	               fonsize(iwin,iframe,4)/120.0)
	  call PGQCS  (4,xh(4),yh(4))
	  call PGAXIS (cax,xpl(1),ypl(1),xpl(2),ypl(1),
     &	                   xpl(1),xpl(2),ltx,tick_nsub(iwin,iframe,1),
     &	                   tick_ma_h(iwin,iframe,1),0.0,
     &	                   tick_mi_h(iwin,iframe,1),
     &	                   lab_d(iwin,iframe,1),
     &	                   lab_angle(iwin,iframe,1))
	  call PGAXIS (clx,xpl(1)+off,ypl(2),xpl(2)+off,ypl(2),
     &	                   xpl(1),xpl(2),ltx,tick_nsub(iwin,iframe,1),
     &	                   0.0,tick_ma_h(iwin,iframe,1),
     &	                   tick_mi_h(iwin,iframe,1),
     &	                   lab_d(iwin,iframe,1),
     &	                   lab_angle(iwin,iframe,1))
c
	  call PGAXIS (cal,xpl(1),ypl(1),xpl(1)+off,ypl(2),
     &	                   ypl(1),ypl(2),lty,tick_nsub(iwin,iframe,2),
     &	                   0.0,tick_ma_h(iwin,iframe,2),
     &	                   tick_mi_h(iwin,iframe,2),adis,
     &	                   lab_angle(iwin,iframe,2))
  	  call PGAXIS (car,xpl(2),ypl(1),xpl(2)+off,ypl(2),
     &	                   ypl(1),ypl(2),lty,tick_nsub(iwin,iframe,2),
     &	                   tick_ma_h(iwin,iframe,2),0.0,
     &	                   tick_mi_h(iwin,iframe,2),adis,
     &	                   lab_angle(iwin,iframe,2))
c
c------ - Axis at x=0.0
c
	  if (abs(ibox(iwin,iframe)).ge.3 .and.
     &	      pex(iwin,iframe,1).lt.0.0    .and. 
     &	      pex(iwin,iframe,2).gt.0.0         ) then
	    ax1  = 0.0
	    ay1  = pey(iwin,iframe,2)
	    call koor_shear (1,ax1,ay1)
	    off0 = ax1 
	    call PGAXIS (cly,0.0 ,ypl(1),off0,ypl(2),ypl(1),ypl(2),
     &	                     lty,tick_nsub(iwin,iframe,1),
     &	                     tick_ma_h(iwin,iframe,2),
     &	                     tick_ma_h(iwin,iframe,2),
     &	                     tick_mi_h(iwin,iframe,2),0.0,0.0)
	  endif
c
c------ - Axis at y=0.0
c
	  if (abs(ibox(iwin,iframe)).ge.3 .and.
     &	      ey(iwin,iframe,1).lt.0.0    .and. 
     &	      ey(iwin,iframe,2).gt.0.0         ) then
	    ax1  = pex(iwin,iframe,2)
	    ay1  = 0.0
	    call koor_shear (1,ax1,ay1)
	    off0 = ax1 - pex(iwin,iframe,2)
	    call PGAXIS (clx,xpl(1)+off0,0.0,xpl(2)+off0,0.0,xpl(1),xpl(2),
     &	                     ltx,tick_nsub(iwin,iframe,2),
     &	                     tick_ma_h(iwin,iframe,1),
     &	                     tick_ma_h(iwin,iframe,1),
     &	                     tick_mi_h(iwin,iframe,1),0.0,0.0)
	  endif
c
c------ - Axes labels
c
	  call PGSCI  (foncol(iwin,iframe,3))
	  call PGSCF  (fon_id(iwin,iframe,3))
	  call PGSCH  (fonscal(iwin,iframe)*
     &	               fonsize(iwin,iframe,3)/120.0)
	  call PGQCS  (4,xh(3),yh(3))
c
	  if (achse(iwin,iframe,1)(1:3).ne.'OFF') then
	    xt = pex(iwin,iframe,1)+
     &	         0.5*(pex(iwin,iframe,2)-pex(iwin,iframe,1))
	    yt = pey(iwin,iframe,1)-ax_d(iwin,iframe,1)*yh(4)-1.2*yh(3)
	    call PGPTXT (xt,yt,0.0,0.5,achse(iwin,iframe,1))
	  endif
c
	  if (achse(iwin,iframe,2)(1:3).ne.'OFF') then
	    if (ibox(iwin,iframe).gt.1) then
	      yt  = pey(iwin,iframe,1)+
     &	            0.5*(pey(iwin,iframe,2)-pey(iwin,iframe,1))
	      xt  = pex(iwin,iframe,1)-ax_d(iwin,iframe,2)*xh(4)-0.2*xh(3)
	      call koor_shear (1,xt,yt)
	      call PGPTXT (xt,yt,shear(iwin,iframe),
     &	                   0.5,achse(iwin,iframe,2))
	    else
	      yt  = pey(iwin,iframe,1)+
     &	            0.5*(pey(iwin,iframe,2)-pey(iwin,iframe,1))
	      xt  = pex(iwin,iframe,2)+
     &	              (ax_d(iwin,iframe,2)+1)*xh(4)+0.2*xh(3)
	      call koor_shear (1,xt,yt)
	      call PGPTXT (xt,yt,shear(iwin,iframe),
     &	                   0.5,achse(iwin,iframe,2))
	    endif
	  endif
	    
	endif
c
c------ Title 
c
	ax1 = pex(iwin,iframe,1)
	ay1 = pey(iwin,iframe,2)
	call koor_shear (1,ax1,ay1)
	off = ax1 - pex(iwin,iframe,1)
c
	if (frjust(iwin,iframe).eq.if_left) then
	  xt = pex(iwin,iframe,1) + off
	  yt = pey(iwin,iframe,2)
	  rj = 0.0
	else
	  xt = pex(iwin,iframe,1) + 
     &         0.5*(pex(iwin,iframe,2)-pex(iwin,iframe,1)) + off
	  yt = pey(iwin,iframe,2)
	  rj = 0.5
	endif
c
	call PGSCI  (foncol(iwin,iframe,2))
	call PGSCF  (fon_id(iwin,iframe,2))
	call PGSCH  (fonscal(iwin,iframe)*fonsize(iwin,iframe,2)/120.0)
	call PGQCS  (4,xh(2),yh(2))
	yt = yt + 0.5*yh(2)
	call PGPTXT (xt,yt,0.0,rj,titel(iwin,iframe,2))
c
	call PGSCI  (foncol(iwin,iframe,1))
	call PGSCF  (fon_id(iwin,iframe,1))
	call PGSCH  (fonscal(iwin,iframe)*fonsize(iwin,iframe,1)/120.0)
	call PGQCS  (4,xh(1),yh(1))
	yt = yt + 1.1*yh(1)
	call PGPTXT (xt,yt,0.0,rj,titel(iwin,iframe,1))
c
	end
c*****7*****************************************************************
	subroutine draw_werte
c+
c	This routine plots the datasets ...
c-
	implicit	none
c
	integer         maxmax
	parameter       (maxmax=50)
c
	include		'config.inc'
	include		'kuplot.inc'
c
	character*80	text
	real		xpl(maxarray),ypl(maxarray)
	real		wmax(maxmax)
	real		eex(2),eey(2)
	real		xleg,yleg,xfehl(2),yfehl(2)
	real		rj,xh,yh,xp,yp,xt,yt,sx,sy,xma,yma,delx
	integer		ixm(maxmax),iym(maxmax)
	integer		ikurv,ipkt,npkt
	integer		il,ima,ikr,iityp,iicol
	logical		k_in_f
c
	integer		len_str
	logical		inrect
c
c------ Loop over all data sets
c
	ikr = 0
	do ikurv=1,iz-1
	  if (.not. k_in_f(ikurv)) goto 999
c
c-------- draw lines
c
	  if(lni(ikurv)) then
	    if (hlineart(iwin,iframe,ikurv).eq.1 .or.
     &	        hlineart(iwin,iframe,ikurv).eq.3     ) then
	      call draw_contour (ikurv)
	    endif
	  else
	    if(fform(ikurv).ne.'CR') then
	      do ipkt=2,len(ikurv)
	        xpl(ipkt-1) = x(offxy(ikurv-1)+(ipkt-1))
	        ypl(ipkt-1) = y(offxy(ikurv-1)+(ipkt-1))
	        xpl(ipkt)   = x(offxy(ikurv-1)+ipkt)
	        ypl(ipkt)   = y(offxy(ikurv-1)+ipkt)
	      enddo
	      npkt = len(ikurv)
	      if (npkt.gt.1) then
	        call draw_points(xpl,ypl,npkt,ikurv)
	      endif
	    endif
	  endif	
c
c-------- Markers
c
	  if(fform(ikurv).eq.'CR') then
	    call draw_bonds(ikurv)
	    do ipkt=1,len(ikurv)
	      delx  = dy(offxy(ikurv-1)+ipkt)*
     &	              sizemark(iwin,iframe,ikurv)
	      xma   = x(offxy(ikurv-1)+ipkt)
	      yma   = y(offxy(ikurv-1)+ipkt)
	      iicol = int(dx(offxy(ikurv-1)+ipkt)/1000)
	      iityp = int(dx(offxy(ikurv-1)+ipkt)-1000.0*iicol)
	      call draw_marker (xma,yma,iityp,iicol,delx)
	    enddo
	  else
	    if(imarktyp(iwin,iframe,ikurv).ne.0 .and. 
     &	       .not.lni(ikurv)                       ) then
	      call draw_bonds(ikurv)
	      do ipkt=1,len(ikurv)
	        xma=x(offxy(ikurv-1)+ipkt)
	        yma=y(offxy(ikurv-1)+ipkt)
	        call draw_marker (xma,yma,imarktyp(iwin,iframe,ikurv),
     &	                                  imarkcol(iwin,iframe,ikurv),  
     &	                                  sizemark(iwin,iframe,ikurv))  
	      enddo
	    endif  
	  endif
c
c-------- Marker for maxima
c
	  if(imarkmax(iwin,iframe,ikurv).ne.0) then
	    if (lni(ikurv)) then
	      call do_fmax_z  (ikurv,wmax,ixm,iym,maxmax,ima)
	    else
	      call do_fmax_xy (ikurv,wmax,ixm,maxmax,ima)
	    endif
	    do ipkt=1,ima
	      if (.not.lni(ikurv)) iym(ipkt)=ixm(ipkt)
	      xma=x(ixm(ipkt))
	      yma=y(iym(ipkt))
	      call draw_marker (xma,yma,imarkmax(iwin,iframe,ikurv), 
     &	                                imarkcol(iwin,iframe,ikurv),  
     &	                                sizemark(iwin,iframe,ikurv))  
	    enddo
	  endif  
c
c-------- Error bars
c
	  if(ierr(iwin,iframe,ikurv).ne.0 .and. .not.lni(ikurv)) then
	    call PGSLS (1)
	    call PGSLW (nint(linewid(iwin,iframe,ikurv)/0.13))
	    call PGSCI (ierrcol(iwin,iframe,ikurv))
	    do ipkt=1,len(ikurv)
c
	      if (ierr(iwin,iframe,ikurv).eq.1 .or. 
     &	          ierr(iwin,iframe,ikurv).eq.3     ) then
	        xfehl(1)=x(offxy(ikurv-1)+ipkt)-dx(offxy(ikurv-1)+ipkt)
	        yfehl(1)=y(offxy(ikurv-1)+ipkt)
	        xfehl(2)=x(offxy(ikurv-1)+ipkt)+dx(offxy(ikurv-1)+ipkt)
	        yfehl(2)=y(offxy(ikurv-1)+ipkt)
	        call koor_shear (2,xfehl,yfehl)
	        call koor_log (2,xfehl,yfehl)
	        call PGERRX (1,xfehl(1),xfehl(2),yfehl(1),1.0)
	      endif
c
	      if (ierr(iwin,iframe,ikurv).eq.2 .or. 
     &	          ierr(iwin,iframe,ikurv).eq.3     ) then
	        xfehl(1)=x(offxy(ikurv-1)+ipkt)
	        yfehl(1)=y(offxy(ikurv-1)+ipkt)-dy(offxy(ikurv-1)+ipkt)
	        xfehl(2)=x(offxy(ikurv-1)+ipkt)
	        yfehl(2)=y(offxy(ikurv-1)+ipkt)+dy(offxy(ikurv-1)+ipkt)
	        call koor_shear (2,xfehl,yfehl)
	        call koor_log (2,xfehl,yfehl)
	        call PGERRY (1,xfehl(1),yfehl(1),yfehl(2),1.0)
	      endif
	    enddo
	  endif
c
c-------- Filenames
c
	  if(ifname(iwin,iframe)) then
	    text = fname(ikurv)
	    il   = len_str(text)
	    if(il.gt.0) then
	      ikr = ikr + 1 
	      call PGSCI (ilinecol(iwin,iframe,ikurv))
	      call PGSCF (fon_id(iwin,iframe,6))
	      call PGSLW (nint(linewid(iwin,iframe,0)/0.13))
	      call PGSCH (fonscal(iwin,iframe)*
     &	                  fonsize(iwin,iframe,6)/120.0)
	      call PGQCS (4,xh,yh)
	      if (info_orig(iwin,iframe,1).ne.-9999.) then
	        xt = info_orig(iwin,iframe,1)
	        yt = info_orig(iwin,iframe,2)
	      else
	        xt = pex(iwin,iframe,2)
	        yt = pey(iwin,iframe,2)
	      endif
	      xt = xt - xh
	      yt = yt - ikr*yh*1.2 - 0.3*yh
	      call koor_shear (1,xt,yt)
	      call PGPTXT (xt,yt,0.0,1.0,text(1:il))
	    endif
	  endif
c
c-------- Possible legend
c
	  if(ilegend(iwin,iframe,ikurv).eq.1) then
	    ikr = ikr + 1 
	    call PGSCF (fon_id(iwin,iframe,6))
	    call PGSCH (fonscal(iwin,iframe)*
     &	                fonsize(iwin,iframe,6)/120.0)
	    call PGQCS (4,xh,yh)
	    text = clegend(iwin,iframe,ikurv)
	    if (info_orig(iwin,iframe,1).ne.-9999.) then
	      xleg = info_orig(iwin,iframe,1)
	      yleg = info_orig(iwin,iframe,2)
	    else
	      xleg = pex(iwin,iframe,2)
	      yleg = ey(iwin,iframe,2)
	    endif
	    xleg = xleg - xh
	    yleg = yleg - ikr*yh*1.2
	    call koor_shear (1,xleg,yleg)
c
	    if(ilinetyp(iwin,iframe,ikurv).ne.0) then
	      call PGSCI (ilinecol(iwin,iframe,ikurv))
	      call PGSLS (ilinetyp(iwin,iframe,ikurv))
	      call PGSLW (nint(linewid(iwin,iframe,ikurv)/0.13))
	      call PGERRX (1,xleg,xleg-4.0*xh,yleg,1.0)
	    endif
c
	    call draw_marker (xleg-2.0*xh,yleg,
     &	                      imarktyp(iwin,iframe,ikurv),
     &	                      imarkcol(iwin,iframe,ikurv),  
     &	                      sizemark(iwin,iframe,ikurv))  
c
	    call PGSCI (foncol(iwin,iframe,6))
	    call PGSCF (fon_id(iwin,iframe,6))
	    call PGSLW (nint(linewid(iwin,iframe,0)/0.13))
	    call PGSCH (fonscal(iwin,iframe)*
     &	                fonsize(iwin,iframe,6)/120.0)
	    xt = xleg-5.0*xh
	    yt = yleg-0.3*yh
	    il=len_str(text)
	    if(il.gt.0) then
	      call PGPTXT (xt,yt,0.0,1.0,text(1:il))
	    endif                        
	  endif                        
c
999	  continue
	enddo
c
c------ plot possible annotations
c
	eex(1)=pex(iwin,iframe,1)
	eex(2)=pex(iwin,iframe,2)
	eey(1)=pey(iwin,iframe,1)
	eey(2)=pey(iwin,iframe,2)
c
	call PGSCI (foncol(iwin,iframe,6))
	call PGSLW (nint(linewid(iwin,iframe,0)/0.13))
	call PGSCF (fon_id(iwin,iframe,6))
	call PGSCH (fonscal(iwin,iframe)*fonsize(iwin,iframe,6)/120.0)
	call PGQCS (4,xh,yh)
        do ipkt=1,maxan
          if (antext(iwin,iframe,ipkt)(1:3).ne.'OFF') then
            il=len_str(antext(iwin,iframe,ipkt))
            xt=antx(iwin,iframe,ipkt)
            yt=anty(iwin,iframe,ipkt)
            xp=anx (iwin,iframe,ipkt)
            yp=any (iwin,iframe,ipkt)
	    call koor_shear(1,xp,yp)
	    call koor_shear(1,xt,yt)
	    call koor_log  (1,xp,yp)
	    call koor_log  (1,xt,yt)
	    sx = 0.05*(xt-xp)
	    sy = 0.05*(yt-yp)
	    if(xt.ne.xp .or. yt.ne.yp) call PGARRO (xt-sx,yt-sy,xp,yp)
            if(il.gt.0 .and. inrect(eex,eey,xt,yt)) then
	      if (anjust(iwin,iframe,ipkt).eq.IF_LEFT)   rj = 0.0
	      if (anjust(iwin,iframe,ipkt).eq.IF_RIGHT)  rj = 1.0
	      if (anjust(iwin,iframe,ipkt).eq.IF_CENTRE) rj = 0.5
	      call PGPTXT (xt,yt,anangle(iwin,iframe,ipkt),rj,
     &	                   antext(iwin,iframe,ipkt)(1:il))
            endif
          endif
	enddo
c
	end
c****7******************************************************************
	subroutine draw_line(xpl,ypl,npkt,ikurv)
c+
c	The drawing and filling itself
c-                                             
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
	include		'debug.inc'
c
	integer		npkt,ikurv
	real		xpl(npkt),ypl(npkt)
c
	real		xfill(maxarray),yfill(maxarray)
	real		x1,x2,y1,y2,yb
	integer		ip,np
c
	call koor_shear (npkt,xpl,ypl)
	call koor_log   (npkt,xpl,ypl)
c
c------ Fill area if required
c
	if (ifilltyp(iwin,iframe,ikurv).gt.0) then
	  if (fillrange(iwin,iframe,ikurv,1).eq.-9999.) then
	    x1 = pex(iwin,iframe,1)
	    x2 = pex(iwin,iframe,2)
	  else
	    x1 = fillrange(iwin,iframe,ikurv,1)
	    x2 = fillrange(iwin,iframe,ikurv,2)
	  endif
	  if (fillrange(iwin,iframe,ikurv,3).eq.-9999.) then
	    y1 = pey(iwin,iframe,1)
	    y2 = pey(iwin,iframe,2)
	    yb = max(0.0,ey(iwin,iframe,1))
	  else
	    y1 = fillrange(iwin,iframe,ikurv,3)
	    y2 = fillrange(iwin,iframe,ikurv,4)
	    yb = fillrange(iwin,iframe,ikurv,3)
	  endif
c
	  np = 1
	  xfill(np) = x1
	  yfill(np) = yb
c
	  do ip=1,npkt
	    if(xpl(ip).ge.x1 .and. xpl(ip).le.x2) then
	      np        = np+1
              xfill(np) = xpl(ip)
	      if(ypl(ip).ge.y1 .and. ypl(ip).le.y2) then
                yfill(np) = ypl(ip)
	      else
	        if(ypl(ip).lt.y1) yfill(np) = y1
	        if(ypl(ip).gt.y2) yfill(np) = y2
	      endif
	    endif
	  enddo
c
	  np = np+1
	  xfill(np) = x2
	  yfill(np) = yb
c
	  if(dbg) then
	    write(*,1000) 1,   xfill(1),   yfill(1)
	    write(*,1000) 2,   xfill(2),   yfill(2)
	    write(*,1000) np-1,xfill(np-1),yfill(np-1)
	    write(*,1000) np,  xfill(np),  yfill(np)
1000	    format (' debug  > Fill point ',i5,' at ',2(g12.4,1x))
	  endif
c
	  if     (ifilltyp(iwin,iframe,ikurv).eq.1 .or.
     &	          ifilltyp(iwin,iframe,ikurv).eq.5)      then
	    call PGSFS (1)
	    call PGSHS ( 45.0,1.0,0.0)
	  elseif (ifilltyp(iwin,iframe,ikurv).eq.2 .or.
     &	          ifilltyp(iwin,iframe,ikurv).eq.6)      then
	    call PGSFS (3)
	    call PGSHS ( 45.0,1.0,0.0)
	  elseif (ifilltyp(iwin,iframe,ikurv).eq.3 .or.
     &	          ifilltyp(iwin,iframe,ikurv).eq.7)      then
	    call PGSFS (3)
	    call PGSHS (-45.0,1.0,0.0)
	  elseif (ifilltyp(iwin,iframe,ikurv).eq.4 .or.
     &	          ifilltyp(iwin,iframe,ikurv).eq.8)      then
	    call PGSFS (4)
	    call PGSHS ( 45.0,1.0,0.0)
	  endif
c
	  call PGSCI  (ifillcol(iwin,iframe,ikurv))
	  call PGPOLY (np,xfill,yfill)
c
	  if (ifilltyp(iwin,iframe,ikurv).gt.4) then
	    call PGSCI  (6)
	    call PGSFS  (2)
	    call PGPOLY (np,xfill,yfill)
	  endif
	endif
c
c------ Draw the line
c
	if (ilinetyp(iwin,iframe,ikurv).gt.0) then
	  call PGSLS (ilinetyp(iwin,iframe,ikurv))
	  call PGSLW (nint(linewid(iwin,iframe,ikurv)/0.13))
	  call PGSCI (ilinecol(iwin,iframe,ikurv))
	  call PGLINE (npkt,xpl,ypl)
	endif
c
	end
c****7******************************************************************
	subroutine draw_points(xpl,ypl,nnpkt,ikurv)
c+
c	Draws line as simple line, step or spline
c-                                             
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		nnpkt,npkt,ikurv,is,ipkt
	real		xpl(nnpkt),ypl(nnpkt)
	real		eex(2),eey(2)
	real		y2a(maxarray),xhe(maxsp),yhe(maxsp)
	real		xxx,yyy,xst,xen,dxx
c
	eex(1) = pex(iwin,iframe,1)
	eex(2) = pex(iwin,iframe,2)
	eey(1) = pey(iwin,iframe,1)
	eey(2) = pey(iwin,iframe,2)
c
	npkt = nnpkt
c
c------ Normal line between points
c
	if     (ilineart(iwin,iframe,ikurv).eq.1) then
	  if (shear(iwin,iframe).ne.90.0) then
	    call clip_array(eex,eey,xpl,ypl,npkt)
	  endif
	  call draw_line (xpl,ypl,npkt,ikurv)
c
c------ Histogram style steps
c
	elseif (ilineart(iwin,iframe,ikurv).eq.2) then
	  if (4*npkt.gt.maxsp) then
            ier_num = -13
	    ier_typ = ER_APPL
	  else
	    is=0
	    do ipkt=1,npkt-1
	      xhe(is+1)=xpl(ipkt)
	      yhe(is+1)=ypl(ipkt)
	      xhe(is+2)=xpl(ipkt)+(xpl(ipkt+1)-xpl(ipkt))/2.0
	      yhe(is+2)=ypl(ipkt)
	      xhe(is+3)=xpl(ipkt)+(xpl(ipkt+1)-xpl(ipkt))/2.0
	      yhe(is+3)=ypl(ipkt+1)
	      xhe(is+4)=xpl(ipkt+1)
	      yhe(is+4)=ypl(ipkt+1)
	      is=is+4
	    enddo
	    if (shear(iwin,iframe).ne.90.0) then
	      call clip_array(eex,eey,xhe,yhe,npkt)
	    endif
	    call draw_line (xhe,yhe,is,ikurv)
	  endif
c
c------ Spline interpolation between points
c
	elseif (ilineart(iwin,iframe,ikurv).eq.3) then
	  if (npkt.gt.maxsp) then
            ier_num = -13
	    ier_typ = ER_APPL
	  else
	    call spline (xpl,ypl,npkt,1e30,1e30,y2a)
	    xst=max(xmin(ikurv),pex(iwin,iframe,1))
	    xen=min(xmax(ikurv),pex(iwin,iframe,2))
	    dxx=(xen-xst)/maxsp
	    is=1
	    do xxx=xst+dxx,xen-dxx,dxx
	      call splint (xpl,ypl,y2a,npkt,xxx,yyy)
	      xhe(is)=xxx
	      yhe(is)=yyy
	      is=is+1
	    enddo
	    if (shear(iwin,iframe).ne.90.0) then
	      call clip_array(eex,eey,xhe,yhe,is-1)
	    endif
	    call draw_line (xhe,yhe,is-1,ikurv)
	  endif
	endif
c
	end
c****7******************************************************************
	subroutine draw_marker (px,py,ityp,icol,size)
c+
c	Draws marker of typ ityp and color icol at px,py
c-                                                                
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	real		px,py,size
	real		eex(2),eey(2)
	integer		ityp,icol,iptyp
	logical		inrect
c
	eex(1)=pex(iwin,iframe,1)
	eex(2)=pex(iwin,iframe,2)
	eey(1)=pey(iwin,iframe,1)
	eey(2)=pey(iwin,iframe,2)
	if(ityp.eq.0 .or. .not.inrect(eex,eey,px,py)) return 
c
	call koor_shear(1,px,py)
	call koor_log  (1,px,py)
c
	call PGSLW (nint(linewid(iwin,iframe,0)/0.13))
	call PGSCI (icol)
c
c------ just a dot
c
	if (ityp.eq. 1) then
	  call PGPT (1,px,py,-1)
c
c------ empty/filled circle
c
	elseif (ityp.eq. 2) then                
	  call PGSCH (7.143*size)
	  call PGPT (1,px,py,21)
	elseif (ityp.eq. 3) then                
	  call PGSCH (8.333*size)
	  call PGPT (1,px,py,17)
c
c------ empty/filled square
c
	elseif (ityp.eq. 4) then                
	  call PGSCH (5.000*size)
	  call PGPT (1,px,py, 6)
	elseif (ityp.eq. 5) then                
	  call PGSCH (8.333*size)
	  call PGPT (1,px,py,16)
c
c------ emtyp triangle
c
	elseif (ityp.eq. 6) then                
	  call PGSCH (5.000*size)
	  call PGPT (1,px,py, 7)
c
c------ cross 'x'
c
	elseif (ityp.eq. 7) then                
	  call PGSCH (5.556*size)
	  call PGPT (1,px,py, 5)
c
c------ cross '+'
c
	elseif (ityp.eq. 8) then
	  call PGSCH (4.545*size)
	  call PGPT (1,px,py, 2)
c
c------ line '|'
c
	elseif (ityp.eq. 9) then		
	  call PGSCH (2.083*size)
	  call PGPT (1,px,py,ichar('|'))
c
c------ line '/'
c
	elseif (ityp.eq. 10) then		
	  call PGSCH (1.852*size)
	  call PGPT (1,px,py,ichar('/'))
c
c------ line '\'
c
	elseif (ityp.eq. 11) then		
	  call PGSCH (2.500*size)
	  call PGPT (1,px,py,ichar('\\'))
c
c------ line '-'
c
	elseif (ityp.eq. 12) then		
	  call PGSCH (3.571*size)
	  call PGPT (1,px,py,ichar('-'))
c
c------ line from y-axis
c
	elseif (ityp.eq.13) then		
	  call PGMOVE (px,ey(iwin,iframe,1))
	  call PGDRAW (px,py)
c
c------ marker types 100+PGPLOT marker number
c
	elseif (ityp.ge.92 .and. ityp.le.131) then
	  iptyp = ityp - 100
	  call PGSCH (5.000*size)
          call PGPT (1,px,py,iptyp)
	endif
c
	end          
c****7******************************************************************
	subroutine draw_bonds (ikurv)
c+
c	Draws bonds
c-                                             
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		ikurv
	integer 	ib,iii,jjj,ipkt,jpkt
	real		xpl(2),ypl(2),dist
	real		eex(2),eey(2)
	real		blow,bhigh
c
	logical		inrect
c
	eex(1)=pex(iwin,iframe,1)
	eex(2)=pex(iwin,iframe,2)
	eey(1)=pey(iwin,iframe,1)
	eey(2)=pey(iwin,iframe,2)
c
	do ib=1,maxbond
	  if(bond_rad(iwin,iframe,ib).gt.0.0) then
	    blow  = bond_rad(iwin,iframe,ib) * 
     &	            (1 - bond_sig(iwin,iframe,ib))
	    bhigh = bond_rad(iwin,iframe,ib) * 
     &	            (1 + bond_sig(iwin,iframe,ib))
	    call PGSLS (bond_ltyp(iwin,iframe,ib))
	    call PGSLW (nint(bond_lwid(iwin,iframe,ib)/0.13))
	    call PGSCI (bond_lcol(iwin,iframe,ib))
	    do ipkt=1,len(ikurv)
	      iii  =offxy(ikurv-1)+ipkt
	      if (inrect(eex,eey,x(iii),y(iii))) then
	        do jpkt=1,len(ikurv)
	          jjj  =offxy(ikurv-1)+jpkt
	          xpl(1)=x(iii)
	          ypl(1)=y(iii)
	          xpl(2)=x(jjj)
	          ypl(2)=y(jjj)
	          call koor_shear(2,xpl,ypl)
	          call koor_log  (2,xpl,ypl)
	          ypl(1)=yskal(iwin,iframe)*ypl(1)
	          ypl(2)=yskal(iwin,iframe)*ypl(2)
	          dist=sqrt((xpl(2)-xpl(1))**2 + (ypl(2)-ypl(1))**2)
	          if(dist.ge.blow .and. dist.le.bhigh) then
	            xpl(1)=x(iii)
	            ypl(1)=y(iii)
	            xpl(2)=x(jjj)
	            ypl(2)=y(jjj)
	            call koor_shear(2,xpl,ypl)
	            call koor_log  (2,xpl,ypl)
	            call PGLINE (2,xpl,ypl)
	          endif
	        enddo
	      endif
	    enddo
	  endif
	enddo
c
	end
c*****7*****************************************************************
	subroutine draw_bitmap(ik)
c+
c	This routine draws the bitmaps 
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'wink.inc'
	include		'debug.inc'
	include		'errlist.inc'
c
	real		zpl(maxz,maxz),tr(6)
	real		rc,rdx,rdy,yf
	real		zzmin,zzmax,x1,x2
	integer		i,ic,ik,ix,iy,ikk
	integer		nx_min,nx_max,ny_min,ny_max
c
        rdx=(xmax(ik)-xmin(ik))/float(nx(ik)-1)
        rdy=(ymax(ik)-ymin(ik))/float(ny(ik)-1)
        nx_min=max(1,     nint((pex(iwin,iframe,1)-xmin(ik))/rdx)+1)
        nx_max=min(nx(ik),nint((pex(iwin,iframe,2)-xmin(ik))/rdx)+1)
        ny_min=max(1,     nint((pey(iwin,iframe,1)-ymin(ik))/rdy)+1)
        ny_max=min(ny(ik),nint((pey(iwin,iframe,2)-ymin(ik))/rdy)+1)
c	
	if (nx_min.eq.nx_max .or. ny_min.eq.ny_max) return
c
	if (nx_max.gt.maxz .or. ny_max.gt.maxz) then
	  ier_num = -34
	  ier_typ = ER_APPL
	  return
	endif
c
c------ Copy array and call drawing routine
c
	zzmin=z_min(iwin,iframe,1)
	zzmax=nz(iwin,iframe,1)*z_inc(iwin,iframe,1)+
     &	                        z_min(iwin,iframe,1)
	do iy=ny_min,ny_max
	  do ix=nx_min,nx_max
	    ikk=offz(ik-1)+(ix-1)*ny(ik)+iy
	    zpl(ix,iy) = z(ikk)
	  enddo
	enddo
c
c------ Transformation matrix
c
	tr(1) = xmin(ik) - rdx
	tr(2) = rdx
	tr(3) = 0.0
	tr(4) = ymin(ik) - rdy
	tr(5) = 0.0
	tr(6) = rdy
c
	if (shear(iwin,iframe).ne.90.0) then
	  yf = yskal(iwin,iframe)/tan(rad*shear(iwin,iframe))
	  tr(1) = tr(1) + yf*(tr(4) - ey(iwin,iframe,1))
	  tr(3) = rdy*yf
c
c------ - Account for pixel overlap for ANGL not 90.
c
	  x1 = tr(1) + tr(2)*(float(nx_min)-0.5) + 
     &	               tr(3)*(float(ny_min)-0.5)
	  x2 = tr(1) + tr(2)*(float(nx_max)+0.5) + 
     &	               tr(3)*(float(ny_min)+0.5)
	  pex(iwin,iframe,1) = x1
	  pex(iwin,iframe,2) = x2
	endif
c
	if (dbg) then
	  write (output_io,8000) rdx,rdy
	  write (output_io,8010) nx_min,nx_max,ny_min,ny_max
	  write (output_io,8020) tr
8000	  format(' debug > dx,dy               = ',2(g12.6,2x))
8010	  format(' debug > nx(mi,ma),ny(mi,ma) = ',2i5,2x,2i5)
8020	  format(' debug > TR matrix           = ',3(g12.6,2x),/,
     &	         '                               ',3(g12.6,2x))
	endif
c
c------ Setting colours
c
	call PGQCIR (ix,iy)
	if (ix.lt.(iaf(iwin)+19)) ix = iaf(iwin)+19
	call PGSCIR (ix,iy)
	rc = 254.0 / float(iy-ix)
	do i=ix,iy
	  ic = int((i-ix)*rc) + 1
	  call PGSCR (i,col_map(iwin,ic,1),col_map(iwin,ic,2),
     &	                                   col_map(iwin,ic,3))
	enddo
c
	call PGSITF (0)
	call PGIMAG (zpl,maxz,maxz,nx_min,nx_max,ny_min,ny_max,
     &	             zzmin,zzmax,tr)
c
c------ Plot wedge next to plot if required
c
	if (achse(iwin,iframe,3)(1:3).ne.'OFF') then
	  call PGSCI  (foncol(iwin,iframe,4))
	  call PGSCF  (fon_id(iwin,iframe,4))
	  call PGSCH  (fonscal(iwin,iframe)*
     &	               fonsize(iwin,iframe,4)/120.0)
	  call PGWEDG ('RI',0.5,2.5,zzmin,zzmax,achse(iwin,iframe,3))
	endif
c
	end
c*****7*****************************************************************
	subroutine draw_contour(ik)
c+
c	This routine draws the contour lines
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'kuplot.inc'
	include		'wink.inc'
	include		'debug.inc'
	include		'errlist.inc'
c
	character*25	label
	real		zpl(maxz,maxz),tr(6)
	real		rdx,rdy,zm,zi,h,log10,yf
	integer		i,mm,pp,il,ic,ik,ix,iy,ikk,ihp,ihl,lmi,lin
	integer		nx_min,nx_max,ny_min,ny_max
c
        rdx=(xmax(ik)-xmin(ik))/float(nx(ik)-1)
        rdy=(ymax(ik)-ymin(ik))/float(ny(ik)-1)
        nx_min=max(1,     nint((pex(iwin,iframe,1)-xmin(ik))/rdx)+1)
        nx_max=min(nx(ik),nint((pex(iwin,iframe,2)-xmin(ik))/rdx)+1)
        ny_min=max(1,     nint((ey(iwin,iframe,1)-ymin(ik))/rdy)+1)
        ny_max=min(ny(ik),nint((ey(iwin,iframe,2)-ymin(ik))/rdy)+1)
c
	if (nx_min.eq.nx_max .or. ny_min.eq.ny_max) return
c
	lmi = nint(0.2*min((nx_max-nx_min),(ny_max-ny_min)))
	lin = 3*lmi
	ic  = iframe + 20
c
	log10 = log(10.0)
c	
	if (nx_max.gt.maxz .or. ny_max.gt.maxz) then
	  ier_num = -34
	  ier_typ = ER_APPL
	  return
	endif
c
c------ Copy array and call drawing routine
c
	do iy=ny_min,ny_max
	  do ix=nx_min,nx_max
	    ikk=offz(ik-1)+(ix-1)*ny(ik)+iy
	    zpl(ix,iy) = z(ikk)
	  enddo
	enddo
c
c------ Transformation matrix
c
	tr(1) = xmin(ik) - rdx
	tr(2) = rdx
	tr(3) = 0.0
	tr(4) = ymin(ik) - rdy
	tr(5) = 0.0
	tr(6) = rdy
c
	if (shear(iwin,iframe).ne.90.0) then
	  yf = yskal(iwin,iframe)/tan(rad*shear(iwin,iframe))
	  tr(1) = tr(1) + yf*(tr(4) - ey(iwin,iframe,1))
	  tr(3) = rdy*yf
	endif
c
	if (dbg) then
	  write (output_io,8000) rdx,rdy
	  write (output_io,8010) nx_min,nx_max,ny_min,ny_max
	  write (output_io,8020) tr
8000	  format(' debug > dx,dy               = ',2(g12.6,2x))
8010	  format(' debug > nx(mi,ma),ny(mi,ma) = ',2i5,2x,2i5)
8020	  format(' debug > TR matrix           = ',3(g12.6,2x),/,
     &	         '                               ',3(g12.6,2x))
	endif
c
c------ Drawing the contours
c
	do ihp = 1,iho(iwin,iframe)
	  call PGSLS (hlinetyp(iwin,iframe,ik,ihp))
	  call PGSLW (nint(linewid(iwin,iframe,ik)/0.13))
	  zm = z_min(iwin,iframe,ihp)
	  zi = z_inc(iwin,iframe,ihp)
	  if (hlinetyp(iwin,iframe,ik,ihp).ne.0) then
	    do ihl = 1,nz(iwin,iframe,ihp)
	      h = zm + (ihl-1)*zi
	      call PGSCI  (hlinecol(iwin,iframe,ik,ihp))
	      call PGCONT (zpl,maxz,maxz,nx_min,nx_max,
     &	                   ny_min,ny_max,h,-1,tr)
c
	      if (hlabel(iwin,iframe,ik).ne.0) then
	        if (mod(ihl,hlabel(iwin,iframe,ik)).eq.0) then
                  if (h.eq.0) then
                    pp = 1
                    mm = 0
                  else
                    pp = int(log(abs(h))/log(10.0))-4
	            if (pp.lt.0) then
                      mm = nint(h*10**(abs(pp)))
	            else
                      mm = nint(h/10**(abs(pp)))
                    endif
                  endif
c
	          call PGSLS  (1)
	          call PGSLW  (nint(linewid(iwin,iframe,0)/0.13))
	          call PGSCI  (foncol(iwin,iframe,4))
	          call PGSCF  (fon_id(iwin,iframe,4))
	          call PGSCH  (fonscal(iwin,iframe)*
     &	                       fonsize(iwin,iframe,4)/160.0)
	          call PGSTBG (ic)
	          call PGNUMB (mm,pp,0,label,il)
       	          call PGCONL (zpl,maxz,maxz,nx_min,nx_max,
     &	                       ny_min,ny_max,h,tr,label,
     &	                       lin,lmi)
	          call PGSTBG (-1)
	        endif
	      endif
	    enddo
	  endif
	enddo
c
	end	
c*****7*****************************************************************
	logical function k_in_f(ik)
c+
c	Check if data set ik should be plotted in actual frame
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
c
	integer		ik,i
c
	k_in_f = .false.
	do i=1,maxkurvtot
	  k_in_f = k_in_f .or. (infra(iwin,iframe,i).eq.ik)
	enddo
c
	end
c*****7*****************************************************************
	logical function inrect (ex,ey,x,y)
c-
c       Checks if point x,y is within rectangle ex(2),ey(2).
c+
	real    x,y,ex(2),ey(2)
c
	inrect = (x.ge.ex(1) .and. x.le.ex(2)) .and.
     &           (y.ge.ey(1) .and. y.le.ey(2))
	end
c***********************************************************************
	subroutine clip_array (ex,ey,ax,ay,npkt)
c 
	implicit	none
c
	integer		i,j,npkt
	logical 	inrect,in1,in2,in3,sf
	real		ex(2),ey(2),ax(npkt),ay(npkt)
	real		xs,ys,axp,ayp
c
	if (npkt.lt.2) return
c
	j = 1
c
c------ First point
c
	in2 = inrect (ex,ey,ax(1),ay(1))
	in3 = inrect (ex,ey,ax(2),ay(2))
	if (in2) then
	  ax(j) = ax(1)
	  ay(j) = ay(1)
	  j = j+1
	elseif (.not.in2 .and. in3) then
	  call schnitt (ex,ey,ax(1),ay(1),ax(2),ay(2),xs,ys,sf)
	  ax(j) = xs
	  ay(j) = ys
	  j = j+1
	endif
c
	axp = ax(1)
	ayp = ay(1)
c
c------ Check supsequent points
c
	do i = 2,npkt-1
	  in1 = inrect (ex,ey,axp,ayp)
	  in2 = inrect (ex,ey,ax(i),ay(i))
	  in3 = inrect (ex,ey,ax(i+1),ay(i+1))
          if (in2) then
	    axp = ax(i)
	    ayp = ay(i)
	    ax(j) = ax(i)
	    ay(j) = ay(i)
	    j = j+1
	  elseif (.not.in2 .and. in1) then
	    call schnitt (ex,ey,axp,ayp,ax(i),ay(i),xs,ys,sf)
	    axp = ax(i)
	    ayp = ay(i)
	    ax(j) = xs
	    ay(j) = ys
	    j = j+1
	  elseif (.not.in2 .and. in3) then
	    call schnitt (ex,ey,ax(i),ay(i),ax(i+1),ay(i+1),xs,ys,sf)
	    axp = ax(i)
	    ayp = ay(i)
	    ax(j) = xs
	    ay(j) = ys
	    j = j+1
	  else
	    axp = ax(i)
	    ayp = ay(i)
	    continue
	  endif
	enddo
c
c------ Last point
c
	in1 = inrect (ex,ey,axp,ayp)
	in2 = inrect (ex,ey,ax(npkt),ay(npkt))
	if (in2) then
	  ax(j) = ax(npkt)
	  ay(j) = ay(npkt)
	  j = j+1
	elseif (.not.in2 .and. in1) then
	  call schnitt (ex,ey,axp,ayp,ax(npkt),ay(npkt),xs,ys,sf)
	  ax(j) = xs
	  ay(j) = ys
	  j = j+1
	endif
c
	npkt = j-1
c
	end
c***********************************************************************
      	subroutine schnitt(ex,ey,x1,y1,x2,y2,xs,ys,sflag)
c-
c     	Calculates the intersection of the line from x1,y1 to x2,y2
c     	with rectangle given by ex(2),ey(2)
c+              
	implicit	none
c
	real		ex(2),ey(2)
	real		xs,ys,x1,y1,x2,y2
	real		lam,mue                     
	logical 	sflag
c                    
	sflag = .false.
        call cross(lam,mue,ex(1),ex(2),x1,x2,ey(1),ey(1),y1,y2,xs,ys)
        if (0. .le. lam .and. lam .le. 1.  .and.
     &      0. .le. mue .and. mue .le. 1.       ) then
          sflag = .true.
	  return
	endif
        call cross(lam,mue,ex(2),ex(2),x1,x2,ey(1),ey(2),y1,y2,xs,ys)
        if (0. .le. lam .and. lam .le. 1.  .and.
     &      0. .le. mue .and. mue .le. 1.       ) then
          sflag = .true.
	  return
	endif
        call cross(lam,mue,ex(2),ex(1),x1,x2,ey(2),ey(2),y1,y2,xs,ys)
        if (0. .le. lam .and. lam .le. 1.  .and.
     &      0. .le. mue .and. mue .le. 1.       ) then
          sflag = .true.
	  return
	endif
        call cross(lam,mue,ex(1),ex(1),x1,x2,ey(2),ey(1),y1,y2,xs,ys)
        if (0. .le. lam .and. lam .le. 1.  .and.
     &      0. .le. mue .and. mue .le. 1.       ) then
          sflag = .true.
	  return
	endif
      	end
c*********************************************************************
      	subroutine cross(lam,mue,x1,x2,x3,x4,y1,y2,y3,y4,xs,ys)
c-
c     	Calculates intersection of two vectors : 12 and 34
c     	if singulaer lam and mue are set to  -20.
c+
	implicit	none
c
	real		x1,x2,x3,x4,x21,x43,x13
	real		y1,y2,y3,y4,y21,y43,y13
	real		xs,ys,det
      	real 		lam,mue 
c
      	x21=x2-x1
      	x43=x4-x3
      	x13=x1-x3
      	y21=y2-y1
      	y43=y4-y3
      	y13=y1-y3
      	det=y43*x21-x43*y21
      	if(abs(det) .eq. 0.0) then
          lam=-20.
          mue=-20.
      	else
          lam=(x21*y13-x13*y21)/det
          mue=(x43*y13-x13*y43)/det
          xs=x3+lam*x43
          ys=y3+lam*y43
      	endif
      	end
c*********************************************************************** 
	subroutine koor_shear (npkt,xa,ya)
c+
c	transformation beim shearen
c-
	implicit	none
c
	integer		npkt,i
	real		xa(npkt),ya(npkt)
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'wink.inc'
c
	if (shear(iwin,iframe).ne.90.0 .and. sfl(iwin,iframe)) then 
	  do i=1,npkt
	    if (ya(i).gt.pey(iwin,iframe,1)) then
	      xa(i)=xa(i)+(ya(i)-pey(iwin,iframe,1))
     &	            *yskal(iwin,iframe)/tan(rad*shear(iwin,iframe))
	    else
	      xa(i)=xa(i)
	    endif
	    ya(i)=ya(i)
	  enddo
	endif
c
	end
c*********************************************************************** 
	subroutine koor_log (npkt,xa,ya)
c+
c	transformation for LOG axes
c-
	implicit	none
c
	integer		npkt,i
	real		xa(npkt),ya(npkt)
	real		log10
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'wink.inc'
c
	log10 = log(10.0)
c
	if (lachse(iwin,iframe,1)) then
	  do i=1,npkt
	    if (xa(i).ne.0.0) then
	      xa(i) = log(abs(xa(i)))/log10
	    else
	      xa(i) = -9999.
	    endif
	  enddo
	endif
c
	if (lachse(iwin,iframe,2)) then
	  do i=1,npkt
	    if (ya(i).ne.0.0) then
	      ya(i) = log(abs(ya(i)))/log10
	    else
	      ya(i) = -9999.
	    endif
	  enddo
	endif
c
	end
