c*****7************************************************************
c
c	Here are the routines necessary to save data sets in
c	various formats ..
c
c	Version : 2.0
c	Date    : 17 Oct 96
c
c	Author  : Th. Proffen  (tproffen@lanl.gov )    
c
c*****7************************************************************
	subroutine do_ksav(zei,lp)
c
c	Main save menu
c
	implicit	none
c
	integer		maxw
	parameter	(maxw=10)
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'prompt.inc'
	include		'macro.inc'
	include		'doact.inc'
	include		'errlist.inc'
	include		'param.inc'
	include		'learn.inc'
c
	character*(*)	zei
	character*200	zeile,line,cpara(maxw)
	character*40	filname
	character*11	prom
	character*4	befehl,czeile
	character*2	form,cdummy
	integer		lpara(maxw),lp,lbef
	integer		i,ianz,iianz,ik,length
	logical         l_m999
	real		werte(maxw),wwerte(maxw)
c
	logical		str_comp
c
	call no_error
	l_m999 = .false.
c
	call get_params(zei,ianz,cpara,lpara,maxw,lp)
	if(ier_num.ne.0) return
c
c------ get data set number
c
	if (ianz.eq.1) then
	  call ber_params(1,cpara,lpara,werte,maxw)
	  if(ier_num.ne.0) return
	  ik=nint(werte(1))
	  if(ik.ge.1 .and. ik.lt.iz) then
	    filname = 'kuplot.sav'
            form    = fform(ik)
	    if (form.eq.'Z1' .or. form.eq.'Z2' .or.
     &	        form.eq.'T1' .or. form.eq.'T2' .or.
     &	        form.eq.'C1' .or. form.eq.'C2' .or.
     &	        form.eq.'P1' .or. form.eq.'P2' .or.
     &	        form.eq.'O1' .or. form.eq.'O2' .or.
     &	        form.eq.'H1' .or. form.eq.'H2' .or.
     &	        form.eq.'K1' .or. form.eq.'K2' .or.
     &	        form.eq.'L1' .or. form.eq.'L2' .or.
     &	        form.eq.'DM' .or. form.eq.'TE' .or.
     &	        form.eq.'ST' .or. form.eq.'SC' .or.
     &	        form.eq.'XX' .or. form.eq.'MC' .or.
     &	        form.eq.'ZE' .or. form.eq.'YX'      ) form='XY'
	    if (form.eq.'ZZ' .or. form.eq.'DA' .or.
     &	        form.eq.'AS' .or. form.eq.'MP'      ) form='PG'
	    iianz   = 0
	    call check_form (form,iianz,wwerte,maxw)
	    pgmlow =zmin(ik)
	    pgmhigh=zmax(ik)
c
c------ --- here starts the sublevel loop
c
10	    continue
	    prom = pname//'/ksav'
	    call get_command (line,length,befehl,lbef,zeile,lp,prom)
	    if(ier_num.eq.0) then
	    if(line.eq.' '.or.line(1:1).eq.'#') goto 10
c
c------ --- subcommand 'run'
c
	    if(str_comp(befehl,'run',2,lbef,3)) then
	      call do_save (ik,filname,form,iianz,wwerte,maxw,l_m999)
	      goto 20
c
c------	--- help 'help','?'
c
	    elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	           str_comp(befehl,'?   ',1,lbef,4)     ) then
	      if(str_comp(zeile,'errors',2,lp,6) ) then
	        lp = lp + 7
	        call do_hel('kuplot '//zeile,lp)
	      else
	        lp = lp + 12
	        call do_hel('kuplot ksav '//zeile,lp)
	      endif
c
c------	--- continues a macro 'continue'
c
	    elseif(str_comp(befehl,'continue',3,lbef,8)) then
	      call macro_continue(zeile,lp)
c
c------ --- subcommand 'outfile'
c
	    elseif(str_comp(befehl,'outf',2,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ianz.ge.1) then
	        call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	        if (ier_num.eq.0) then
	          filname=cpara(1)
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------ --- subcommand 'form'
c
	    elseif(str_comp(befehl,'form',2,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      cdummy=cpara(1)
	      if(ianz.gt.1) then
	        call del_params(1,ianz,cpara,lpara,maxw)
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	      else
	        ianz=0
	      endif
	      call check_form (cdummy,ianz,werte,maxw)
	      if(ier_num.eq.0) then
	        form=cdummy
	        iianz=ianz
	        do i=1,iianz
	          wwerte(i)=werte(i)
	        enddo
	      endif
c
c------ --- subcommand 'm999'
c
	    elseif(str_comp(befehl,'m999',2,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ianz.eq.1) then
	        if(str_comp(cpara(1),'data',2,lpara(1),4)) then
	          l_m999=.true.
	        elseif(str_comp(cpara(1),'excl',2,lpara(1),4)) then
	          l_m999=.false.
	        endif
	      else
	        ier_num =-6
	      endif
c
c------ --- subcommand 'show'
c
	    elseif(str_comp(befehl,'show',2,lbef,4)) then
	      write(output_io,1000) ik,filname
	      write(output_io,1100) form
	      if (iianz.ne.0) 
     &	          write(output_io,1200)(wwerte(i),i=1,iianz)
	      if (form.eq.'PG') 
     &	          write (output_io,1300) pgmlow,pgmhigh
c
c------	--- Set threshold for PGM files (0..255)
c
	    elseif(str_comp(befehl,'thre',2,lbef,4)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.2) then
	          if(str_comp(cpara(1),'high',1,lpara(1),4)) then
	            call del_params (1,ianz,cpara,lpara,maxw)
	            call ber_params(ianz,cpara,lpara,werte,maxw)
	            if(ier_num.eq.0) then
	              pgmhigh=werte(1)*0.01*zmax(ik)
	            endif
	          elseif(str_comp(cpara(1),'low',1,lpara(1),3)) then
	            call del_params (1,ianz,cpara,lpara,maxw)
	            call ber_params(ianz,cpara,lpara,werte,maxw)
	            if(ier_num.eq.0) then
	              pgmlow =werte(1)*0.01*zmin(ik)
	            endif
	          elseif(str_comp(cpara(1),'sigma',1,lpara(1),5)) then
	            call del_params (1,ianz,cpara,lpara,maxw)
	            call ber_params(ianz,cpara,lpara,werte,maxw)
	            if (ier_num.eq.0) then
	              write (czeile,'(i4)') ik
	              call do_mean (czeile,4,.false.)
	              pgmhigh=min(zmax(ik),res_para(3)+
     &	                          werte(1)*res_para(6))
	              pgmlow =max(zmin(ik),res_para(3)-
     &	                          werte(1)*res_para(6))
	            endif
	          elseif(str_comp(cpara(1),'zmax',3,lpara(1),4)) then
	            call del_params (1,ianz,cpara,lpara,maxw)
	            call ber_params(ianz,cpara,lpara,werte,maxw)
	            if(ier_num.eq.0) then
	              pgmhigh=werte(1)
	            endif
	          elseif(str_comp(cpara(1),'zmin',3,lpara(1),4)) then
	            call del_params (1,ianz,cpara,lpara,maxw)
	            call ber_params(ianz,cpara,lpara,werte,maxw)
	            if(ier_num.eq.0) then
	              pgmlow =werte(1)
	            endif
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------ --- subcommand 'exit'
c
	    elseif(str_comp(befehl,'exit',2,lbef,4)) then
	      goto 20
c
c------ --- subcommand 'wait'
c
	    elseif(str_comp(befehl,'wait',2,lbef,4)) then
	      call do_input(zeile,lp)
c
c------ --- no command found
c
	    else
	      ier_num = -8
	      ier_typ = ER_COMM
	    endif
	    endif
c
	    if(ier_num.ne.0) then
	      call errlist
	      if(lmakro) then
	        call macro_close
	        prompt_status = PROMPT_ON
	      endif
	      if(lblock) then
	        ier_num = -11
	        ier_typ = ER_COMM
	        return
	      endif
	      call no_error
	    endif
	    goto 10
c
c------ --- here ends the sublevel loop
c
20	    continue
	  else
	    ier_num = -4
	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
1000	format(' Current KSAV settings (data set ',i3,') :',//,
     &	       3x,'Output filename   : ',a40)
1100	format(3x,'Format            : ',a2)
1200	format(3x,'Parameters        : ',5(g11.5,2x))
1300	format(3x,'Z range -> 0..255 : ',2(g11.5,2x))
2000	format(a)
	end  
c*****7************************************************************
	subroutine check_form (form,ianz,werte,maxw)
c+
c	This routine checks if file format and parameters
c	are valid.
c-
	implicit	none
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	form
	integer		ik,ianz,maxw
	real		werte(maxw)
c
	call do_cap(form)
	call skalieren
c
c------ xy files : parameters: xmin, xmax
c
	if (form.eq.'XY') then
	  if(ianz.eq.0) then
	    werte(1)=ex(iwin,iframe,1)
	    werte(2)=ex(iwin,iframe,2)
	    ianz    =2
	  elseif (ianz.eq.2) then
	    continue
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c------ gn,ni,pg files : parameters: xmin, xmax, ymin, ymax
c
	elseif (form.eq.'GN' .or. form.eq.'NI' .or. form.eq.'PG') then
	  if(ianz.eq.0) then
	    werte(1)=ex(iwin,iframe,1)
	    werte(2)=ex(iwin,iframe,2)
	    werte(3)=ey(iwin,iframe,1)
	    werte(4)=ey(iwin,iframe,2)
	    ianz    =4
	  elseif (ianz.eq.4) then
	    continue
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c------ sx, sy files : parameter: cutting at x/y
c
	elseif (form.eq.'SX' .or. form.eq.'SY') then
	  if(ianz.ne.1) then
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c------ mx, my files : parameter: cutting through max no. 
c
	elseif (form.eq.'MX' .or. form.eq.'MY') then
	  if(ianz.ne.1) then
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c------ sl files : parameter: cutting from x1,y1 to x2,y2, n points
c
	elseif (form.eq.'SL') then
	  if(ianz.ne.5) then
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c------ sk files : parameter: cut along xy of data set ik
c
	elseif (form.eq.'SK') then
	  if(ianz.eq.1) then
	    ik=nint(werte(1))
	    if(ik.lt.1 .or. ik.gt.(iz-1)) then
	      ier_num = -4
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
	else
	  ier_num = -7
	  ier_typ = ER_APPL
	endif
c
	end	
c*****7************************************************************
	subroutine do_save (ik,filname,form,ianz,werte,maxw,l_m999)
c+
c	Here is the main save routine
c-
	implicit	none
c
	integer		isa,maxw,maxmax,maxf
	parameter	(isa=66,maxmax=50,maxf=3)
c
	include		'config.inc'
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	filname,form
	real		xf(maxf),yf(maxf),zf(maxf,maxf)
	real		werte(maxw),wmax(maxmax)
	real		rdx,rdy
	real		xsteig,xabsch,xanf,xend,xdel
	real		xxx,yyy,zzz,dzzz
	real		wx_min,wx_max,wy_min,wy_max
	integer		ixm(maxmax),iym(maxmax)
	integer		ipg(maxarray)
	integer		ianz,ik,i,ix,iy,ie,k
	integer		ispk,ixxx,ikk,ima,nma
	integer		nx_min,nx_max,ny_min,ny_max,nx_s,ny_s
	logical         l_m999
c
	call oeffne(isa,filname,'unknown',.false.)
	if (ier_num.ne.0) return
c
c-------xy-kurve abspeichern
c
	if     (form(1:2).eq.'XY' .and. .not. lni(ik)) then
	  do i=1,len(ik)
	    if (x(offxy(ik-1)+i).ge.werte(1) .and. 
     &	        x(offxy(ik-1)+i).le.werte(2)) then
	      write (isa,4000) x(offxy(ik-1)+i), y(offxy(ik-1)+i),
     &	                       dx(offxy(ik-1)+i),dy(offxy(ik-1)+i)
	    endif
	  enddo 
c
c-------nipl-file fuer gnuplot abspeichern 
c
	elseif (form(1:2).eq.'GN' .and. lni(ik)) then
	  rdx   =(xmax(ik)-xmin(ik))/float(nx(ik)-1)
	  rdy   =(ymax(ik)-ymin(ik))/float(ny(ik)-1)
	  nx_min=max(1,nint(((werte(1)-xmin(ik))/rdx))+1)
	  nx_max=min(nx(ik),nint(((werte(2)-xmin(ik))/rdx))+1)
	  ny_min=max(1,nint(((werte(3)-ymin(ik))/rdy))+1)
	  ny_max=min(ny(ik),nint(((werte(4)-ymin(ik))/rdy))+1)
	  do ix=nx_min,nx_max
	    do iy=ny_min,ny_max
	      write (isa,4000) x(offxy(ik-1)+ix),
     &	                 y(offxy(ik-1)+iy),
     &	                 z(offz(ik-1)+(ix-1)*ny(ik)+iy)
	    enddo
	    write (isa,2000) ' '
	  enddo
c
c-------nipl-file-schnitt abspeichern (beliebige richtung) 
c
	elseif (form(1:2).eq.'SL' .and. lni(ik)) then
	  xsteig = (werte(4)-werte(2))/(werte(3)-werte(1))
	  xabsch = werte(2)-xsteig*werte(1)
	  xanf   = ex(iwin,iframe,1)
	  xend   = ex(iwin,iframe,2)
	  xdel   = (werte(3)-werte(1))/werte(5)
	  do xxx=xanf,xend,xdel
	    yyy=xsteig*xxx+xabsch
	    call extract_subarray (xf,yf,zf,xxx,yyy,maxf,ik,ie)
	    if (ie.eq.0) then
	      call polin2 (xf,yf,zf,maxf,maxf,xxx,yyy,zzz,dzzz)
	      write (isa,4000) xxx,zzz,0.0,abs(dzzz),yyy
	    endif
	  enddo
c
c-------nipl-file-schnitt abspeichern (spur aus kurve ik)
c
	elseif (form(1:2).eq.'SK' .and. lni(ik)) then
	  ispk   = nint(werte(1))
	  do ixxx=1,len(ispk)
	    xxx=x(offxy(ispk-1)+ixxx)
	    yyy=y(offxy(ispk-1)+ixxx)
	    call extract_subarray (xf,yf,zf,xxx,yyy,maxf,ik,ie)
	    if (ie.eq.0) then
	      call polin2 (xf,yf,zf,maxf,maxf,xxx,yyy,zzz,dzzz)
	      write (isa,4100) float(ixxx),zzz,0.0,abs(dzzz),xxx,yyy
	    endif
	  enddo
c
c-------nipl-file-schnitt abspeichern 
c
	elseif (form(1:2).eq.'SX' .and. lni(ik)) then
	  rdy =(ymax(ik)-ymin(ik))/float(ny(ik)-1)
	  ny_s=nint(((werte(1)-ymin(ik))/rdy))+1   
	  do i=1,nx(ik)
	    ikk=offz(ik-1)+(i-1)*ny(ik)+ny_s
	    if (z(ikk).ne.-9999.0  .or.       
     &	        z(ikk).eq.-9999.0 .and. l_m999) then
	      write (isa,4000) x(offxy(ik-1)+i),z(ikk)
	    endif
	  enddo 
c
c-------nipl-file-schnitt durch i-tes maximum abspeichern 
c
	elseif (form(1:2).eq.'MX' .and. lni(ik)) then
	  call do_fmax_z (ik,wmax,ixm,iym,maxmax,ima)
	  nma=nint(werte(1))
	  if(ianz.eq.0) nma=1
	  if(nma.gt.ima) then
	    ier_num = -19
	    ier_typ = ER_APPL
	    return
	  endif
	  rdy =(ymax(ik)-ymin(ik))/float(ny(ik)-1)
	  ny_s=nint(((y(iym(nma))-ymin(ik))/rdy))+1   
	  do i=1,nx(ik)
	    ikk=offz(ik-1)+(i-1)*ny(ik)+ny_s
	    if (z(ikk).ne.-9999.0  .or.       
     &	        z(ikk).eq.-9999.0 .and. l_m999) then
	      write (isa,4000) x(offxy(ik-1)+i),z(ikk)
	    endif
	  enddo 
c
c-------nipl-file-schnitt abspeichern 
c
	elseif (form(1:2).eq.'SY' .and. lni(ik)) then
	  rdx =(xmax(ik)-xmin(ik))/float(nx(ik)-1)
	  nx_s=nint(((werte(1)-xmin(ik))/rdx))+1   
	  do i=1,ny(ik)
	    ikk=offz(ik-1)+(nx_s-1)*ny(ik)+i
	    if (z(ikk).ne.-9999.0  .or.       
     &	        z(ikk).eq.-9999.0 .and. l_m999) then
	      write (isa,4000) y(offxy(ik-1)+i),z(ikk)
	    endif
	  enddo 
c
c-------nipl-file-schnitt abspeichern durch maximum
c
	elseif (form(1:2).eq.'MY' .and. lni(ik)) then
	  call do_fmax_z (ik,wmax,ixm,iym,maxmax,ima)
	  nma=nint(werte(1))
	  if(ianz.eq.0) nma=1
	  if(nma.gt.ima) then
	    ier_num = -19
	    ier_typ = ER_APPL
	    return
	  endif
	  rdx =(xmax(ik)-xmin(ik))/float(nx(ik)-1)
	  nx_s=nint(((x(ixm(nma))-xmin(ik))/rdx))+1   
	  do i=1,ny(ik)
	    ikk=offz(ik-1)+(nx_s-1)*ny(ik)+i
	    if (z(ikk).ne.-9999.0  .or.       
     &	        z(ikk).eq.-9999.0 .and. l_m999) then
	      write (isa,4000) y(offxy(ik-1)+i),z(ikk)
   	    endif
	  enddo 
c
c-------pgm-file abspeichern (aktueller ausschnitt)
c
	elseif (form(1:2).eq.'PG' .and. lni(ik)) then
	  rdx   =(xmax(ik)-xmin(ik))/float(nx(ik)-1)
	  rdy   =(ymax(ik)-ymin(ik))/float(ny(ik)-1)
	  nx_min=max(1,nint(((werte(1)-xmin(ik))/rdx))+1)
	  nx_max=min(nx(ik),nint(((werte(2)-xmin(ik))/rdx))+1)
	  ny_min=max(1,nint(((werte(3)-ymin(ik))/rdy))+1)
	  ny_max=min(ny(ik),nint(((werte(4)-ymin(ik))/rdy))+1)
	  write (isa,2000) 'P2'
	  write (isa,2000) '# PGM-file created by KUPLOT'
	  write (isa,*) nx_max-nx_min+1,ny_max-ny_min+1
	  write (isa,*) 255
	  do iy=ny_max,ny_min,-1
	    do ix=nx_min,nx_max
	      k=offz(ik-1)+(ix-1)*ny(ik)+iy
	      if (z(k).lt.pgmlow) then
	        ipg(ix-nx_min+1)=0
	      elseif (z(k).gt.pgmhigh) then
	        ipg(ix-nx_min+1)=255
	      elseif (z(k).eq.-9999.0) then
	        ipg(ix-nx_min+1)=0
	      else
	        ipg(ix-nx_min+1)=nint(255.*(z(k)-pgmlow)/
     &	                         (pgmhigh-pgmlow))
	      endif
	    enddo
	    write (isa,4500) (ipg(ix),ix=1,nx_max-nx_min+1)
	  enddo
c
c-------nipl-file abspeichern (aktueller ausschnitt)
c
	elseif (form(1:2).eq.'NI' .and. lni(ik)) then
	  rdx   =(xmax(ik)-xmin(ik))/float(nx(ik)-1)
	  rdy   =(ymax(ik)-ymin(ik))/float(ny(ik)-1)
	  nx_min=max(1,nint(((werte(1)-xmin(ik))/rdx))+1)
	  nx_max=min(nx(ik),nint(((werte(2)-xmin(ik))/rdx))+1)
	  ny_min=max(1,nint(((werte(3)-ymin(ik))/rdy))+1)
	  ny_max=min(ny(ik),nint(((werte(4)-ymin(ik))/rdy))+1)
	  wx_min=xmin(ik)+(nx_min-1)*rdx
	  wx_max=xmin(ik)+(nx_max-1)*rdx
	  wy_min=ymin(ik)+(ny_min-1)*rdy
	  wy_max=ymin(ik)+(ny_max-1)*rdy
	  write (isa,*) nx_max-nx_min+1,ny_max-ny_min+1
	  write (isa,4000) wx_min,wx_max,wy_min,wy_max
	  do iy=ny_min,ny_max
	    write (isa,4000) (z(offz(ik-1)+(ix-1)*ny(ik)+iy),
     &	                      ix=nx_min,nx_max)
	  enddo
	endif	  
	close (isa)
c
2000	format (a)
4000	format (5(g14.8,2x))
4100	format (6(g12.6,1x))
4500	format (20(i3,1x))
	end
