	subroutine ersetz_para(ikl,iklz,string,ll,ww,maxw,ianz)
c-
c       Replaces a substring in an expression by the value of the
c       appropriate parameter. Modified version for KUPLOT.
c
c	Version : 4.0
c	Date    : 14 May 1999
c
c	Authors : R.B. Neder  (reinhard.neder@mail.uni-wuerzburg.de)
c	          Th. Proffen (proffen@pa.msu.edu)
c
c+
	implicit	none
c
	integer		mmaxw,maxw
	parameter	(mmaxw=3)
c
        include		'config.inc'
        include		'kuplot.inc'
        include		'errlist.inc'
        include		'param.inc'
c
	character*(*)	string
	character*200	zeile
	integer		i,ianz,ikl,iklz,ll
	integer		lcomm,laenge,ltyp
	integer		idummy
	integer		kpara(mmaxw)
	real		ww(maxw)
c
	integer		length_com
c
	laenge = ll
	ltyp   = 1
	zeile  = ' '
	do i=1,maxw
	  kpara(i)=nint(ww(i))
	enddo
c
	lcomm = length_com(string,laenge,ikl)
c
	if(lcomm.eq.1) then
	  if(ikl.gt.2) zeile(1:ikl-1)=string(1:ikl-2)
c
c-------- general integer parameter i[n]
c
	  if(string(ikl-1:ikl-1).eq.'i') then
	    if (ianz.eq.1) then
	      if(0.le.kpara(1) .and. kpara(1).le.MAXPAR) then
	        write(zeile(ikl-1:ikl+13),'(i15)'  ) inpara(kpara(1))
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
c-------- program information n[n]
c
	  elseif(string(ikl-1:ikl-1).eq.'n') then
	    if (ianz.eq.1) then
	      if(1.le.kpara(1) .and. kpara(1).le.5) then
	        if     (kpara(1).eq.1) then
	          idummy=iz-1
	          write(zeile(ikl-1:ikl+13),'(i15)') idummy
	        elseif (kpara(1).eq.2) then
	          write(zeile(ikl-1:ikl+13),'(i15)') maxkurvtot
	        elseif (kpara(1).eq.3) then
	          write(zeile(ikl-1:ikl+13),'(i15)') maxframe
	        elseif (kpara(1).eq.4) then
	          write(zeile(ikl-1:ikl+13),'(i15)') maxan
	        elseif (kpara(1).eq.5) then
	          write(zeile(ikl-1:ikl+13),'(i15)') maxbond
	        endif
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
c-------- general real parameter r[n]
c
	  elseif(string(ikl-1:ikl-1).eq.'r') then
	    if (ianz.eq.1) then
	      if(0.le.kpara(1) .and. kpara(1).le.MAXPAR) then
	        write(zeile(ikl-1:ikl+13),'(e15.8e2)') rpara(kpara(1))
	        zeile(ikl+10:ikl+10) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
c-------- Fit parameter p[n]
c
	  elseif(string(ikl-1:ikl-1).eq.'p') then
	    if (ianz.eq.1) then
	      if(1.le.kpara(1) .and. kpara(1).le.MAXPARA) then
	        write(zeile(ikl-1:ikl+13),'(e15.8e2)') p(kpara(1))
	        zeile(ikl+10:ikl+10) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
c-------- data arrays x[n,m], y[n,m], z[n,mx,my]
c
	  elseif(string(ikl-1:ikl-1).eq.'x') then
	    if (ianz.eq.2) then
	      if(1.le.kpara(1) .and. kpara(1).le.(iz-1) .and.
     &	         1.le.kpara(2) .and. kpara(2).le.len(kpara(1)) ) then
	        write(zeile(ikl-1:ikl+13),'(e15.8e2)') 
     &	              x(offxy(kpara(1)-1) + kpara(2))
	        zeile(ikl+10:ikl+10) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
	  elseif(string(ikl-1:ikl-1).eq.'y') then
	    if (ianz.eq.2) then
	      if(1.le.kpara(1) .and. kpara(1).le.(iz-1) .and.
     &	         1.le.kpara(2) .and. kpara(2).le.len(kpara(1)) ) then
	        write(zeile(ikl-1:ikl+13),'(e15.8e2)') 
     &	              y(offxy(kpara(1)-1) + kpara(2))
	        zeile(ikl+10:ikl+10) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
	  elseif(string(ikl-1:ikl-1).eq.'z') then
	    if (ianz.eq.3) then
	      if(1.le.kpara(1) .and. kpara(1).le.(iz-1)       .and.
     &	         1.le.kpara(2) .and. kpara(2).le.nx(kpara(1)) .and.
     &	         1.le.kpara(3) .and. kpara(3).le.ny(kpara(1))      ) then
	        write(zeile(ikl-1:ikl+13),'(e15.8e2)') 
     &	              z(offz(kpara(1)-1) + 
     &	                (kpara(2)-1)*ny(kpara(1)) + kpara(3))
	        zeile(ikl+10:ikl+10) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
	  else
	    ier_num = -2
	    ier_typ = ER_FORT
	  endif
	elseif(lcomm.eq.2) then
	  if(ikl.gt.3) zeile(1:ikl-2)=string(1:ikl-3)
c
c-------- data arrays dx[n,m], dy[n,m]
c
	  if(string(ikl-2:ikl-1).eq.'dx') then
	    if (ianz.eq.2) then
	      if(1.le.kpara(1) .and. kpara(1).le.(iz-1) .and.
     &	         1.le.kpara(2) .and. kpara(2).le.len(kpara(1))  ) then
	        write(zeile(ikl-2:ikl+13),'(e15.8e2)') 
     &	              dx(offxy(kpara(1)-1) + kpara(2))
	        zeile(ikl+9:ikl+9) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
	  elseif(string(ikl-2:ikl-1).eq.'dy') then
	    if (ianz.eq.2) then
	      if(1.le.kpara(1) .and. kpara(1).le.(iz-1) .and.
     &	         1.le.kpara(2) .and. kpara(2).le.len(kpara(1))  ) then
	        write(zeile(ikl-2:ikl+13),'(e15.8e2)') 
     &	              dy(offxy(kpara(1)-1) + kpara(2))
	        zeile(ikl+9:ikl+9) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
c-------- data set dimensions nx[n], ny[n], np[n], ni[n]
c
	  elseif(string(ikl-2:ikl-1).eq.'nx') then
	    if (ianz.eq.1) then
	      if(1.le.kpara(1) .and. kpara(1).le.(iz-1)) then
	        write(zeile(ikl-2:ikl+13),'(i15)') nx(kpara(1))
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
	  elseif(string(ikl-2:ikl-1).eq.'ny') then
	    if (ianz.eq.1) then
	      if(1.le.kpara(1) .and. kpara(1).le.(iz-1)) then
	        write(zeile(ikl-2:ikl+13),'(i15)') ny(kpara(1))
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
	  elseif(string(ikl-2:ikl-1).eq.'np') then
	    if(ianz.eq.1) then
	      if(1.le.kpara(1) .and. kpara(1).le.(iz-1)) then
	        write(zeile(ikl-2:ikl+13),'(i15)') len(kpara(1))
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
	  elseif(string(ikl-2:ikl-1).eq.'ni') then
	    if(ianz.eq.1) then
	      if(1.le.kpara(1) .and. kpara(1).le.(iz-1)) then
	        if (lni(kpara(1))) then
	          write(zeile(ikl-2:ikl+13),'(i15)') 1
	        else
	          write(zeile(ikl-2:ikl+13),'(i15)') 0
	        endif
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -2
	    ier_typ = ER_FORT
	  endif
c
	elseif(lcomm.eq.3) then
	  if(ikl.gt.4) zeile(1:ikl-3)=string(1:ikl-4)
c
c-------- result array res[n]
c
	  if(string(ikl-3:ikl-1).eq.'res') then
	    if(ikl.gt.4) zeile(1:ikl-3)=string(1:ikl-4)
	    if(ianz.eq.1) then
	      if(0.le.kpara(1) .and. kpara(1).le.MAXPAR_RES   ) then
	        write(zeile(ikl-3:ikl+13),'(e15.8e2)'  ) 
     &                      res_para(kpara(1))
	        zeile(ikl+8:ikl+8) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -2
	    ier_typ = ER_FORT
	  endif
c
	elseif(lcomm.eq.4) then
	  if(ikl.gt.5) zeile(1:ikl-4)=string(1:ikl-5)
c
c-------- data set dimensions xmin[n], xmax[n], ..
c
	  if(string(ikl-4:ikl-1).eq.'xmin') then
	    if(ianz.eq.1) then
	      if(1.le.kpara(1) .and. kpara(1).le.(iz-1)   ) then
	        call get_extrema
	        write(zeile(ikl-4:ikl+13),'(e15.8e2)'  ) xmin(kpara(1))
	        zeile(ikl+7:ikl+7) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
	  elseif(string(ikl-4:ikl-1).eq.'xmax') then
	    if (ianz.eq.1) then
	      if(1.le.kpara(1) .and. kpara(1).le.(iz-1)   ) then
	        call get_extrema
	        write(zeile(ikl-4:ikl+13),'(e15.8e2)'  ) xmax(kpara(1))
	        zeile(ikl+7:ikl+7) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
	  elseif(string(ikl-4:ikl-1).eq.'ymin') then
	    if (ianz.eq.1) then
	      if(1.le.kpara(1) .and. kpara(1).le.(iz-1)   ) then
	        call get_extrema
	        write(zeile(ikl-4:ikl+13),'(e15.8e2)'  ) ymin(kpara(1))
	        zeile(ikl+7:ikl+7) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
	  elseif(string(ikl-4:ikl-1).eq.'ymax') then
	    if (ianz.eq.1) then
	      if(1.le.kpara(1) .and. kpara(1).le.(iz-1)   ) then
	        call get_extrema
	        write(zeile(ikl-4:ikl+13),'(e15.8e2)'  ) ymax(kpara(1))
	        zeile(ikl+7:ikl+7) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
	  elseif(string(ikl-4:ikl-1).eq.'zmin') then
	    if (ianz.eq.1) then
	      if(1.le.kpara(1) .and. kpara(1).le.(iz-1) .and.
     &	         lni(kpara(1))                                ) then
	        call get_extrema
	        write(zeile(ikl-4:ikl+13),'(e15.8e2)'  ) zmin(kpara(1))
	        zeile(ikl+7:ikl+7) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
	  elseif(string(ikl-4:ikl-1).eq.'zmax') then
	    if (ianz.eq.1) then
	      if(1.le.kpara(1) .and. kpara(1).le.(iz-1) .and.
     &	         lni(kpara(1))                                ) then
	        call get_extrema
	        write(zeile(ikl-4:ikl+13),'(e15.8e2)'  ) zmax(kpara(1))
	        zeile(ikl+7:ikl+7) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
c------ - Scale factors for graphic devices
c
	  elseif(string(ikl-4:ikl-1).eq.'size') then
	    if (ianz.eq.1) then
	      if(1.eq.kpara(1)) then
	        write(zeile(ikl-4:ikl+13),'(e15.8e2)'  ) 
     &	              dev_sf(iwin,x11)
	        zeile(ikl+7:ikl+7) = 'e'
	      elseif(2.eq.kpara(1)) then
	        write(zeile(ikl-4:ikl+13),'(e15.8e2)'  ) 
     &	              dev_sf(iwin,ps)
	        zeile(ikl+7:ikl+7) = 'e'
	      elseif(3.eq.kpara(1)) then
	        write(zeile(ikl-4:ikl+13),'(e15.8e2)'  ) 
     &	              dev_sf(iwin,pic)
	        zeile(ikl+7:ikl+7) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
c------ - color map variables cmap[n,m], cmax[n]
c
	  elseif(string(ikl-4:ikl-1).eq.'cmap') then
	    if (ianz.eq.2) then
	      if(1.le.kpara(1) .and. kpara(1).le.maxcol .and.
     &	         1.le.kpara(2) .and. kpara(2).le.3           ) then
	        write(zeile(ikl-4:ikl+13),'(e15.8e2)'  ) 
     &	              col_map(iwin,kpara(1),kpara(2))
	        zeile(ikl+7:ikl+7) = 'e'
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
	  elseif(string(ikl-4:ikl-1).eq.'cmax') then
	    if (ianz.eq.1) then
	      if(kpara(1).eq.1) then
	        write(zeile(ikl-4:ikl+13),'(i15)'  ) maxcol
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
c------ - Drawing of axes relates variables
c
	  elseif(string(ikl-4:ikl-1).eq.'axis') then
	    if (ianz.eq.2) then
	      if(1.le.kpara(1) .and. kpara(1).le.6 .and.
     &	         1.le.kpara(2) .and. kpara(2).le.2           ) then
c
	        if(kpara(1).eq.1) then
	          write(zeile(ikl-4:ikl+13),'(e15.8e2)'  ) 
     &	                lab_angle(iwin,iframe,kpara(2))
	          zeile(ikl+7:ikl+7) = 'e'
	        elseif(kpara(1).eq.2) then
	          write(zeile(ikl-4:ikl+13),'(e15.8e2)'  ) 
     &	                tick_ma_h(iwin,iframe,kpara(2))
	          zeile(ikl+7:ikl+7) = 'e'
	        elseif(kpara(1).eq.3) then
	          write(zeile(ikl-4:ikl+13),'(e15.8e2)'  ) 
     &	                tick_mi_h(iwin,iframe,kpara(2))
	          zeile(ikl+7:ikl+7) = 'e'
	        elseif(kpara(1).eq.4) then
	          write(zeile(ikl-4:ikl+13),'(i15)'  ) 
     &	                tick_nsub(iwin,iframe,kpara(2))
	        elseif(kpara(1).eq.5) then
	          write(zeile(ikl-4:ikl+13),'(e15.8e2)'  ) 
     &	                lab_d(iwin,iframe,kpara(2))
	          zeile(ikl+7:ikl+7) = 'e'
	        elseif(kpara(1).eq.6) then
	          write(zeile(ikl-4:ikl+13),'(e15.8e2)'  ) 
     &	                ax_d(iwin,iframe,kpara(2))
	          zeile(ikl+7:ikl+7) = 'e'
	        endif
	      else
	        ier_num = -8
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -13
	      ier_typ = ER_FORT
	    endif
c
	  else
	    ier_num = -2
	    ier_typ = ER_FORT
	  endif
 
c
	else
	  ier_num = -2
	  ier_typ = ER_FORT
	endif
	if(ier_num .eq. 0) then
	  ll    =laenge+15-ltyp-(iklz-ikl+1)
	  if(iklz+1.le.laenge) zeile(ikl+14:ll)=string(iklz+1:laenge)
	  string=zeile
	  call rem_bl(string,ll)
	endif
	end
c*****7*****************************************************************
	subroutine upd_para(ctype,ww,maxw,wert,ianz)
c-
c       updates the parameter spezified by ctype, index ww  to the
c       new value of wert
c+
	implicit	none
c
        include		'config.inc'
        include		'prompt.inc'
        include		'kuplot.inc'
        include		'errlist.inc'
        include		'param.inc'
c
	character*(*)	ctype
	integer		maxw
	integer		ianz,idummy
	integer		ww(maxw)
	real		wert
c
c------ integer parameter i[n]
c
        if(ctype.eq.'i') then
	  if(ianz.eq.1) then
	    if(0.le.ww(1) .and. ww(1).le.MAXPAR) then
              inpara(ww(1))=int(wert)
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	  endif
c
c------ real parameter r[n]
c
        elseif(ctype.eq.'r') then
	  if(ianz.eq.1) then
	    if(0.le.ww(1) .and. ww(1).le.MAXPAR) then
              rpara(ww(1))=wert
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	  endif
c
c------ fit parameter p[n]
c
        elseif(ctype.eq.'p') then
	  if(ianz.eq.1) then
	    if(1.le.ww(1) .and. ww(1).le.MAXPARA) then
              p(ww(1))=wert
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	  endif
c
c------ Number of loaded data sets n[1] - to clear some
c
        elseif(ctype.eq.'n') then
	  if(ianz.eq.1) then
	    if(ww(1).eq.1) then
              idummy=nint(wert)
	      if (idummy.gt.0 .and. idummy.le.(iz-1)) then
	        write (output_io,2000) iz-idummy-1
	        iz = idummy+1
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	  endif
c
c------ data arrays x[n,m], y[n,m], z[n,nx,ny], dx[n,m], dy[n,m]
c
	elseif(ctype.eq.'x') then
	  if(ianz.eq.2) then
	    if(1.le.ww(1) .and. ww(1).le.(iz-1) .and.
     &	       1.le.ww(2) .and. ww(2).le.len(ww(1))   ) then
	      x(offxy(ww(1)-1) + ww(2)) = wert	
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	  endif
c
	elseif(ctype.eq.'dx') then
	  if(ianz.eq.2) then
	    if(1.le.ww(1) .and. ww(1).le.(iz-1) .and.
     &	       1.le.ww(2) .and. ww(2).le.len(ww(1))   ) then
	      dx(offxy(ww(1)-1) + ww(2)) = wert	
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	  endif
c
	elseif(ctype.eq.'y') then
	  if(ianz.eq.2) then
	    if(1.le.ww(1) .and. ww(1).le.(iz-1) .and.
     &	       1.le.ww(2) .and. ww(2).le.len(ww(1))   ) then
	      y(offxy(ww(1)-1) + ww(2)) = wert	
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	  endif
c
	elseif(ctype.eq.'dy') then
	  if(ianz.eq.2) then
	    if(1.le.ww(1) .and. ww(1).le.(iz-1) .and.
     &	       1.le.ww(2) .and. ww(2).le.len(ww(1))   ) then
	      dy(offxy(ww(1)-1) + ww(2)) = wert	
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	  endif
c
	elseif(ctype.eq.'z') then
	  if(ianz.eq.3) then
	    if(1.le.ww(1) .and. ww(1).le.(iz-1) .and.
     &	       1.le.ww(2) .and. ww(2).le.nx(ww(1)) .and.
     &	       1.le.ww(3) .and. ww(3).le.ny(ww(1))        ) then
	      z(offz(ww(1)-1) + 
     &	          (ww(2)-1)*ny(ww(1)) + ww(3)) = wert	
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	  endif
c
c------ scale factors for graphic devices
c
	elseif(ctype.eq.'size') then
	  if(ianz.eq.1) then
	    if(1.eq.ww(1)) then
	      dev_sf(iwin,x11) = wert
	    elseif(2.eq.ww(1)) then
	      dev_sf(iwin,ps)  = wert
	      dev_sf(iwin,vps) = wert
	    elseif(3.eq.ww(1)) then
	      dev_sf(iwin,pic)  = wert
	      dev_sf(iwin,vpic) = wert
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	  endif
c
c------ color map values cmap[], cmax[]
c
	elseif(ctype.eq.'cmap') then
	  if(ianz.eq.2) then
	    if(1.le.ww(1) .and. ww(1).le.maxcol .and.
     &	       1.le.ww(2) .and. ww(2).le.3            ) then
	      if (wert.ge.0.0 .and. wert.le.1.0) then
	        col_map(iwin,ww(1),ww(2)) = wert
	      else
	        ier_num = -18
	        ier_typ = ER_APPL
	      endif
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	  endif
c
c------ axis drawing parameters
c
	elseif(ctype.eq.'axis') then
	  if(ianz.eq.2) then
	    if(1.le.ww(1) .and. ww(1).le.6 .and.
     &	       1.le.ww(2) .and. ww(2).le.2      ) then
	      if(ww(1).eq.1) then
	        lab_angle(iwin,iframe,ww(2)) = wert
	      elseif (ww(1).eq.2) then
	        tick_ma_h(iwin,iframe,ww(2)) = wert
	      elseif (ww(1).eq.3) then
	        tick_ma_h(iwin,iframe,ww(2)) = wert
	      elseif (ww(1).eq.4) then
	        tick_nsub(iwin,iframe,ww(2)) = nint(wert)
	      elseif (ww(1).eq.5) then
	        lab_d(iwin,iframe,ww(2)) = wert
	      elseif (ww(1).eq.6) then
	        ax_d(iwin,iframe,ww(2)) = wert
	      endif
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	  endif
c
c------ result array parameter res[n]
c
        elseif(ctype.eq.'res') then
	  if (ianz.eq.1) then
	    if(0.le.ww(1) .and. ww(1).le.MAXPAR_RES) then
              res_para(ww(1))=wert
	    else
	      ier_num = -8
	      ier_typ = ER_FORT
	    endif
	  else
	    ier_num = -13
	    ier_typ = ER_FORT
	  endif
        else
          ier_num = -2
	  ier_typ = ER_FORT
        endif
c
2000	format (' ------ > Last ',i3,' data set(s) deleted ...')
	end
c*****7***************************************************************
	subroutine calc_intr_spec(string,line,ikl,iklz,ww,laenge,lp)
c-
c	These are special intrinsic function for the KUPLOT. Any
c	intrinsic function that references KUPLOT specific values
c	is found in this subroutine.
c+
	implicit	none
c
	include		'errlist.inc'
c
	character*(*)	string,line
	integer		ikl,iklz,laenge,lp,il
	real		ww
c
	integer		len_str
c
c------ so far no special functions :-)
c------ so we should not end up here ...
c
	ier_num = -3
	ier_typ = ER_FORT
c
	il=max(len(ier_msg(1))-11,len_str(string))
	ier_msg(1) = 'Function : '//string(1:30)
c
	end
