c+
c	Handling of blockstructures and all math functions
c	and parameter updating and referencing is done by
c	routines in this file.
c
c       Version : 1.1
c       Date    : 14 Oct 96
c
c       Authors : R.B. Neder  (reinhard.neder@mail.uni-wuerzburg.de)
c	          Th. Proffen (proffen@pa.msu.edu)
c
c*****7*****************************************************************
	subroutine do_loop  (line,lend,length)
c+
c	All commands included in a block structure are read and stored in
c	character array. Executable commands are parsed to mach_kdo.
c	If an illegal nesting of block structures is detected, an 
c	error flag is returned and the block structure is not executed
c	at all.
c-
	implicit       none
c
	include        'doact.inc'
	include        'doloop.inc'
	include        'doexec.inc'
	include        'errlist.inc'
	include        'learn.inc'
	include        'macro.inc'
	include        'prompt.inc'
c
        integer         maxw
        parameter      (maxw=2)
c
	character*200   line
	character*200	zeile
	character*9     prom
	character*4	befehl
	character*3     cprom(0:3)
	integer         jlevel(0:maxlev)
	integer         i,length,lp,lbef
	logical         lend,lreg
c
	logical         str_comp
c
      data cprom/'/do','/if','/do','/do'/
c
c-----	read first block structure command
c
      if(line(1:2).eq.'do' .and. index(line,'=').ne.0 ) then
	jlevel(0)=0
	i      = length - 3
	call rem_bl(line(4:length),i)
	length = i+3
      elseif(line(1:2).eq.'do' .and. index(line,'while').ne.0 ) then
	jlevel(0)=2
	i      = length - 3
	call rem_bl(line(4:length),i)
	length = i+3
      elseif(line(1:2).eq.'do' .and. length.eq.2) then
	jlevel(0)=3
      elseif(line(1:2).eq.'if') then
	jlevel(0)=1
	call rem_bl(line,length)
      endif
      prom=prompt//cprom(jlevel(0))
      do i=0,maxlev
	nlevel(i)=-1
      enddo
      level=0
      nlevel(level)=0
      do_comm(0,0)=line
      do_leng(0,0)=length
c
c.....read all commands
c
      do while(level.gt.-1)
	lblock_read=.true.
	nlevel(level)=nlevel(level)+1
	if(nlevel(level).gt.maxcom) then
	  ier_num = -15
	  ier_typ = ER_FORT
	  goto 999
	endif
c
10	continue
c
	prom=prompt//cprom(jlevel(level))
	call get_command (line,length,befehl,lbef,zeile,lp,prom)
	if(line(1:2).eq.'do' .and. index(line,'=').ne.0 ) then
	  i      = length - 3
	  call rem_bl(line(4:length),i)
	  length = i+3
        elseif(line(1:2).eq.'do' .and. 
     &	       index(line,'while').ne.0 ) then
	  i      = length - 3
	  call rem_bl(line(4:length),i)
	  length = i+3
        elseif(line(1:2).eq.'if') then
	  call rem_bl(line,length)
	endif
c
c------ execute a macro file
c
        if(line(1:1).eq.'@') then
	  ier_num = 0
	  ier_typ = ER_NONE
	  if(length.ge.2) then
	     call file_kdo(line(2:length),length-1)
	   else
	     ier_num = -13
	     ier_typ = ER_MAC
	   endif
	  goto 10
	endif
c
	do_comm(nlevel(level),level)=line
	do_leng(nlevel(level),level)=length
	ldostart(level)=.true.
c
c------	sort commands into proper levels
c
	if(line(1:3).eq.'do ' .or. line(1:2).eq.'if') then
	  if(level.lt.maxlev) then
	    do_comm(nlevel(level),level)='&&'
	    do_leng(nlevel(level),level)=6
	    write(do_comm(nlevel(level),level)(3:6),'(i4)')
     &           nlevel(level+1)+1
	    level=level+1
	    nlevel(level)=nlevel(level)+1
	    do_comm(nlevel(level),level)=line
	    do_leng(nlevel(level),level)=length
            if(line(1:2).eq.'do' .and. index(line,'=').ne.0 ) then
      	      jlevel(level)=0
            elseif(line(1:2).eq.'do' .and. index(line,'while').ne.0)then
	      jlevel(level)=2
            elseif(line(1:2).eq.'do' .and. length.eq.2) then
	      jlevel(level)=3
	    elseif(line(1:2).eq.'if') then
	      jlevel(level)=1
	    endif
	  else
	    ier_num = -16
	    ier_typ = ER_FORT
	    goto 999
	  endif
	elseif(line(1:5).eq.'enddo') then
	  if(jlevel(level).eq.0 .and. length.eq.5) then
	    level=level-1
	  elseif(jlevel(level).eq.2 .and. length.eq.5) then
	    level=level-1
	  elseif(jlevel(level).eq.3 .and. index(line,'until').ne.0) then
	    level=level-1
	  else
	    ier_num = -19
	    ier_typ = ER_FORT
	    goto 999
	  endif
	elseif(line(1:5).eq.'endif') then
	  if(jlevel(level).eq.1) then
	    level=level-1
	  else
	    ier_num = -19
	    ier_typ = ER_FORT
	    goto 999
	  endif
	endif
      enddo
	lblock_read = .false.
      ier_num = 0
      ier_typ = ER_NONE
c
c-----	execute the block structure
c
      do i=0,maxlev
	ilevel(i)=-1
	ltest(i) =.false.
        ldostart(i) =.true.
      enddo
      level=0
	lblock = .true.
c
c-----	as long as there are commands and no error ...
c
      do while(level.gt.-1 .and. ier_num.eq.0)
c
c------	increment the command array, follow up with block commands
c
	call do_execute(lreg,line,length)
	if(ier_num.ne.0) goto 999
c
c------	Regular command, call mach_kdo or file_kdo
c
	if(lreg) then
	  if(.not.( level.eq.0 .and. ilevel(level).eq.0)) then
	    if(str_comp(line(1:4),'stop',4,length,4)) then
	      write (output_io,2000) char(7)
	      lblock_dbg = .true.
	      lblock     = .false.
	      line       = '#'
	      length     = 1
c
c------	----Continuous loop until debug mode is switched off
c
	      do while(lblock_dbg) 
	        call get_command (line,length,befehl,lbef,zeile,lp,prom)
	        if(line(1:1).eq.'@') then
	          call file_kdo(line(2:length),length-1)
	        else
	          call mache_kdo(line,lend,length)
	        endif
	        if(ier_num.ne.0) goto 999
	      enddo
	      if(.not.lblock) then
	        goto 999
	      endif
	      line       = '#'
	      length     = 1
	    endif
	    if(line(1:1).eq.'@') then
	      call file_kdo(line(2:length),length-1)
	    else
	      call mache_kdo(line,lend,length)
	    endif
	    if(ier_num.ne.0) goto 999
	  endif
	endif
      enddo
c
999   continue
	lblock = .false.
	if(ier_num.ne.0) then
	  write(ier_msg(1),3000)
	  write(ier_msg(2),3100) line(1:41)
	endif
c
c
1000	format(a)
2000	format(a1)
2001	format(' Macro > ',a)
3000	format('Erroneous line in block structure')
3100	format(a41)
	END
C*****7****************************************************************
	subroutine do_execute(lreg,line,laenge)
c-
c	This subroutine increments the commands in the block structure.
c	Block structure commands are executed in this subroutine, 
c	regular commands are returned to the calling subroutine.
c+
	implicit      none
c
	include        'doloop.inc'
	include        'doexec.inc'
	include        'errlist.inc'
c
        integer         maxw
        parameter      (maxw=2)
c
	character*(*) line
	character*200 string,cpara(maxw)
	integer       lpara(maxw)
	integer       i,ianz,laenge
	integer       ikl,ithen
	logical       lreg
        real          werte(maxw)
c
	logical         if_test
c
	lreg = .false.
c
	ilevel(level) = ilevel(level)+1
	line          = do_comm(ilevel(level),level)
	laenge        = do_leng(ilevel(level),level)
	if(line(1:2).eq.'&&') then
	  level=level+1
	  read(line(3:6),*) jump(level)
	  ilevel(level)=jump(level)
	  line=do_comm(ilevel(level),level)
	  laenge = do_leng(ilevel(level),level)
	endif
c
c------	if do-loop command, evaluate counter
c
	if(line(1:3).eq.'do ') then
          if(level.eq.0) then
            jump(level) = ilevel(level)
          endif
	  call do_do(line,level,laenge)
	  if(ier_num.ne.0) then
	    return
	  endif
	  if(ldostart(level)) then
c------	----do loop is done
	    level=level-1
	  endif
c
c------	enddo command, check for enddo until
c
	elseif(line(1:5) .eq. 'enddo') then
	  call do_end(line,level,laenge)
	  if(ier_num.ne.0) then
	    return
	  endif
	  if(ldostart(level)) then
	    ilevel(level)=ilevel(level)+1
	    level=level-1
	  else
	    do while(do_comm(ilevel(level),level)(1:3).ne.'do ')
	      ilevel(level)=ilevel(level)-1
	    enddo
	    ilevel(level)=jump(level)-1
	  endif
c
c------	if or elseif command
c
	elseif(line(1:2).eq.'if' .or. line(1:6).eq.'elseif') then
	  if(ltest(level)) then
c........... previous block of the current if-elseif had been true
	    ltest(level)=.false.
	    level=level-1
	  else
c...........This is the first if statement thats true
	    ikl    = index(line,'(')
	    ithen  = index(line,'then')-1
	    string=line(ikl:ithen)
	    ltest(level)=if_test(string,ithen-ikl+1)
	    if(ier_num.ne.0) then
	      return
	    endif
	    if(ier_num.ne.0) goto 999
	    if(.not.ltest(level)) then
c.............If statement is false, ignore the commands that follow
	      do while(do_comm(ilevel(level)+1,level)(1:4).ne.'else'
     &           .and. do_comm(ilevel(level)+1,level)(1:5).ne.'endif')
	        ilevel(level)=ilevel(level)+1
	      enddo
	    endif
	  endif
c
c------	else command
c
	elseif(line(1:5).eq.'else ') then
	  if(ltest(level)) then
c...........A previous block of the currrent if-elseif had been true
	    ltest(level)=.false.
	    level=level-1
	  endif
c
c------	elseif command
c
	elseif(line .eq. 'endif') then
	  ltest(level)=.false.
	  level=level-1
c
c------	break command
c
        elseif(line(1:5).eq.'break') then
          call get_params(line(6:laenge),ianz,cpara,lpara,maxw,laenge-5)
          if(ier_num.eq.0) then
            if(ianz.eq.1) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
                if(level.ge.nint(werte(1))-1) then
                  do i=level,level - nint(werte(1))+1,-1
                    ldostart(i) = .true.
                    ltest   (i) = .false.
                  enddo
                  level = level - nint(werte(1))
                else
                  ier_num = -28
	          ier_typ = ER_FORT
                endif
              endif
            else
              ier_num =  -6
	      ier_typ = ER_FORT
            endif
          endif
c
c------	regular command
c
	else
	  lreg = .true.
	endif
c
999	continue
c
	end
C*****7****************************************************************
      subroutine do_do(line,level,laenge)
c-
c	reads the 'do' command and evaluates the corresponding counter
c+
	implicit      none
c
	integer       maxw
	parameter    (maxw=3)
c
	include      'doloop.inc'
	include      'errlist.inc'
c
	character*(*) line
	character*200 zeile,cpara(maxw)
	integer       lpara(maxw)
	integer       ipos,ikp,ianz,level,laenge,lll
	integer       ianz_d,i
	logical       if_test
	real          werte(maxw),wert
c
	ier_num  = -6
	ier_typ = ER_FORT
c
c------	search for argument separator on the do-loop command line
c
	ipos=index(line,'=')
	ikp =index(line,'[')
c
c------	Do-loop of type: do counter = start,end[,increment]
c
      if(ikp.lt.ipos) then
	lll = ipos - ikp -2
	if(lll.gt.0) then
	  zeile=' '
	  zeile(1:lll) = line(ikp+1:ipos-2)
	  call get_params(zeile,ianz_d,cpara,lpara,maxw,lll)
	  if(ier_num.eq.0) then
	    call ber_params(ianz_d,cpara,lpara,werte,maxw)
	    if(ier_num.ne.0) then
	      return
	    endif
	    if(ianz_d.ge.1 .and. ianz_d.le.2) then
	      do i=1,ianz_d
	        do_kpara(i)=nint(werte(i))
	      enddo
	    else
	      ier_num = -17
	      ier_typ = ER_FORT
	      return
	    endif
	  else
	    return
	  endif
	else
	  ier_num = -14
	  ier_typ = ER_FORT
	  return
	endif
	ier_num = 0
	ier_typ = ER_NONE
	if(ldostart(level)) then
c.........Do loop needs to be started
	  if(ipos.ne.0) then
	    lll = laenge - (ipos+1) + 1
	    call get_params(line(ipos+1:laenge),ianz,cpara,lpara,maxw,lll)
	    if(ier_num.eq.0 .and. ianz.ge.2) then
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if(ier_num.ne.0) then
	        return
	      endif
	      glow(level) =werte(1)
	      ghigh(level)=werte(2)
	      if(ianz.eq.2) then
	        ginc(level)=1.0
	      else
	        ginc(level)=werte(3)
	      endif
	      nloop(level)=max(int((ghigh(level)-glow(level))/
     &                             ginc(level))+1,0)
	      iloop(level)=0
	      ldostart(level)=.false.
	      ier_num = 0
	      ier_typ = ER_NONE
	    else
	      ier_num = -6
	      ier_typ = ER_FORT
	      goto 999
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_FORT
	    goto 999
	  endif
	endif
	iloop(level)=iloop(level)+1
	if(iloop(level).le.nloop(level)) then
c.........Do loop is running
	  wert=glow(level) + (iloop(level)-1)*ginc(level)
	  call upd_para(line(4:ikp-1),do_kpara,1,wert,ianz_d)
	  if(ier_num.ne.0) then
	    return
	  endif
	else
c.........Do loop is done
	  ldostart(level)=.true.
	endif
c
c------	do...until loop
c
      elseif(line(4:4).eq.'    ') then
	ier_num = 0
	ier_typ = ER_NONE
	ldostart(level)=.false.
c
c------	DO WHILE loop
c
      elseif(laenge.gt.4 .and. index(line(4:laenge),'while').ne.0) then
	ier_num = 0
	ier_typ = ER_NONE
	ipos=index(line,'(')
	zeile=line(ipos:laenge)
	ldostart(level)=.not. if_test(zeile,laenge-ipos+1)
	if(ier_num.ne.0) then
	  return
	endif
c
c------	error, wrong parameter on the do loop command line
c
      else
	ier_num = -8
	ier_typ = ER_COMM
	ldostart(level)=.true.
      endif
c
999   continue
c
      end
C*****7****************************************************************
	subroutine do_end(line,level,laenge)
c-
c	reads the 'enddo'. If the 'until' is found, the expression is
c	evaluated
c+
	implicit      none
c
	include      'doloop.inc'
	include      'errlist.inc'
c
	character*(*) line
	character*200 zeile
	integer       laenge,ipos,level
	logical       if_test
c
	ipos  =index(line,'until')
	if(ipos.ne.0) then
	  zeile=line(ipos+5:laenge)
	  ldostart(level)=if_test(zeile,laenge-(ipos+5)+1)
	  if(ier_num.ne.0) then
	    return
	  endif
      endif
999   continue
      end
C*****7****************************************************************
	logical function if_test(string,laenge)
c-
c	Tests the logical condition given in 'string'
c+
	implicit       none
c
	include       'errlist.inc'
c
	character*(*)  string
	character*2    comp
	character*200  zeile,line,oldstr
	integer        suche_vor,suche_nach
	integer        laenge,icom,iz1,iz2
	integer        ikl,iklz,ikla,ikla1,ikla2
	integer        ll,i,lcom,inot,lll
	logical        lscr,lscr1
	real           w1,w2
	real           berechne
c
	ier_num = 0
	ier_typ = ER_NONE
	oldstr=string
	call rem_bl(string,laenge)
	if_test = .false.
	if(laenge.eq.0 .or. string.eq.' ' .or. ier_num.ne.0) then
	continue
	else
	icom=max(index(string,'.lt.'),index(string,'.le.'),
     &           index(string,'.gt.'),index(string,'.ge.'),
     &           index(string,'.eq.'),index(string,'.ne.') )
	do while (icom.ne.0)
c
c------	--Found an operator, search for numbers before and after
c
	  comp=string(icom+1:icom+2)
	  lll = icom - 1
	  iz1=suche_vor(string(1:icom-1),lll)
	  zeile='('//string(iz1:icom-1)//')'
	  ll   = icom-1 -iz1 + 3
	  w1=berechne(zeile,ll)
	  if(ier_num.ne.0) then
	    return
	  endif
	  lll = (laenge) - (icom+4) + 1
	  iz2=suche_nach(string(icom+4:laenge),lll)
	  zeile='('//string(icom+4:icom+4+iz2-1)//')'
	  ll   = icom+4+iz2-1 - (icom+4) + 3
	  w2=berechne(zeile,ll)
	  if(ier_num.ne.0) then
	    return
	  endif
	  if(comp.eq.'lt') then
	    lscr=w1.lt.w2
	  elseif(comp.eq.'le') then
	    lscr=w1.le.w2
	  elseif(comp.eq.'gt') then
	    lscr=w1.gt.w2
	  elseif(comp.eq.'ge') then
	    lscr=w1.ge.w2
	  elseif(comp.eq.'eq') then
	    lscr=w1.eq.w2
	  elseif(comp.eq.'ne') then
	    lscr=w1.NE.w2
	  endif
	  lcom=4
	  call ersetz_log(string,iz1,iz2,icom,laenge,lcom,lscr)
	  icom=max(index(string,'.lt.'),index(string,'.le.'),
     &             index(string,'.gt.'),index(string,'.ge.'),
     &             index(string,'.eq.'),index(string,'.ne.') )
	enddo
	ikla=index(string,'(')
	do while(ikla.ne.0)
	  iklz =index(string(ikla+1:laenge),')') + ikla
	  if(iklz.eq.ikla) then
	    ier_num = -9
	    ier_typ = ER_FORT
	    if_test = .false.
	    return
	  endif
	  ikla2=index(string(ikla+1:iklz),'(') + ikla
	  ikla1=ikla
	  do while(ikla2.lt.iklz .and. ikla2.gt.ikla1)
	    ikla1=ikla2
	    ikla2=index(string(ikla1+1:iklz),'(') + ikla1
	  enddo
	  ikl=max(ikla1,ikla2)
	  if(ikl.ne.0) then
	    line=string(ikl+1:iklz-1)
	    ll  =iklz-ikl-1
c
c------	----Found a set of corresponding brackets
c
c	    Evaluate any '.not.'
c
	    inot=index(line,'.not.')
	    do while(inot.ne.0)
	      read(line(inot+5:inot+5),'(l1)') lscr
	      lscr=.not.lscr
	      iz1 =inot-1
	      iz2 =1
	      lcom=5
	      call ersetz_log(line,iz1,iz2,inot,ll,lcom,lscr)
	      inot=index(line,'.not.')
	    enddo
c
c	    Evaluate any '.and.'
c
	    inot=index(line,'.and.')
	    do while(inot.ne.0)
	      read(line(inot-1:inot-1),'(l1)') lscr1
	      read(line(inot+5:inot+5),'(l1)') lscr
	      lscr=lscr1.and.lscr
	      iz1 =inot-1
	      iz2 =1
	      lcom=5
	      call ersetz_log(line,iz1,iz2,inot,ll,lcom,lscr)
	      inot=index(line,'.and.')
	    enddo
c
c	    Evaluate any '.xor.'
c
	    inot=index(line,'.xor.')
	    do while(inot.ne.0)
	      read(line(inot-1:inot-1),'(l1)') lscr1
	      read(line(inot+5:inot+5),'(l1)') lscr
	      lscr=(lscr1 .and. .not.lscr).or.(.not.lscr1 .and. lscr)
	      iz1 =inot-1
	      iz2 =1
	      lcom=5
	      call ersetz_log(line,iz1,iz2,inot,ll,lcom,lscr)
	      inot=index(line,'.and.')
	    enddo
c
c	    Evaluate any '.or.'
c
	    inot=index(line,'.or.')
	    do while(inot.ne.0)
	      read(line(inot-1:inot-1),'(l1)') lscr1
	      read(line(inot+4:inot+4),'(l1)') lscr
	      lscr=lscr1.or.lscr
	      iz1 =inot-1
	      iz2 =1
	      lcom=4
	      call ersetz_log(line,iz1,iz2,inot,ll,lcom,lscr)
	      inot=index(line,'.or.')
	    enddo
	    zeile=' '
	    if(ikl.gt.1) zeile(1:ikl-1)=string(1:ikl-1)
	    zeile(ikl:ikl+ll-1)=line(1:ll)
	    lll = ikl+ll-1
	    if(iklz+1.le.laenge) then
	      zeile(ikl+ll:ikl+ll+laenge-iklz)=
     &                           string(iklz+1:laenge)
	      lll = ikl+ll+laenge-iklz
	    endif
	    string=zeile
	    laenge=lll
	  endif
	  ikla=index(string,'(')
	enddo
	i=1
	do while(string(i:i).eq.' ')
	  i=i+1
	enddo
	zeile =string(i:laenge)
	string=zeile
	if    (string.eq.'T' .or. string.eq.'t') then
	  if_test = .true.
	elseif(string.eq.'F' .or. string.eq.'f') then
	  if_test = .false.
	else
	  ier_num = -18
	  ier_typ = ER_FORT
	  if_test = .false.
	endif
      endif
c
      end
C*****7****************************************************************
	subroutine ersetz_log(string,iz1,iz2,icom,laenge,lcom,lscr)
c-
c       Replaces the result of a logical operation within the
C       string
c
c       Version  : 0.0
c
c       Date     : September 1992
c
c       Author   : r.n.
c
c       modified : 
c
c+
	implicit      none
c
	character*(*) string
	character*200 zeile
	integer       iz1,iz2,icom,laenge,lcom,ll
	logical       lscr
c
	zeile=' '
	if(iz1.gt.1) zeile(1:iz1-1)=string(1:iz1-1)
	write(zeile(iz1:iz1),'(L1)') lscr
	ll=laenge-(lcom+iz2+icom-iz1)+1
	if(icom+lcom+iz2.le.laenge) then
	  zeile(iz1+1:ll)=string(icom+lcom+iz2:laenge)
	endif
	string=zeile
	laenge=ll
c
	end
C*****7****************************************************************
      integer function suche_vor(string,i)
c-
c     searches for the last '(' or '.') in the string
c+
	implicit    none
c
	character*(*) string
	integer       i,level
c
	level=0
	do while(i.gt.0 .and. level.ge.0)
	  if(    string(i:i).eq.')' .or. string(i:i).eq.']') then
	    level=level+1
	  elseif(string(i:i).eq.'(' .or. string(i:i).eq.'[') then
	    level=level-1
	  elseif(i.gt.3 .and.( string(i-3:i).eq.'.lt.' .or.
     &                         string(i-3:i).eq.'.le.' .or.
     &                         string(i-3:i).eq.'.gt.' .or.
     &                         string(i-3:i).eq.'.ge.' .or.
     &                         string(i-3:i).eq.'.eq.' .or.
     &                         string(i-3:i).eq.'.ne.' .or.
     &                         string(i-3:i).eq.'.or.')) then
	    level=-1
	  elseif(i.gt.4 .and.( string(i-4:i).eq.'.not.' .or.
     &                         string(i-4:i).eq.'.and.')) then
	    level=-1
	  elseif(level.eq.0 .and. string(i:i).eq.',') then
	    level=-1
	  endif
	  i=i-1
	enddo
	suche_vor=i+2
	end
C*****7****************************************************************
      integer function suche_nach(string,laenge)
c-
c     searches for the first '(' or '.') in the string
c+
	implicit      none
c
	character*(*) string
	integer       laenge,i,level
c
	i     =1
	level=0
	do while(i.le.laenge .and. level.ge.0)
	  if(    string(i:i).eq.')' .or. string(i:i).eq.']') then
	    level=level-1
	  elseif(string(i:i).eq.'(' .or. string(i:i).eq.'[') then
	    level=level+1
	  elseif(i.lt.laenge-3 .and.( string(i:i+3).eq.'.lt.' .or.
     &	                              string(i:i+3).eq.'.le.' .or.
     &	                              string(i:i+3).eq.'.gt.' .or.
     &	                              string(i:i+3).eq.'.ge.' .or.
     &	                              string(i:i+3).eq.'.eq.' .or.
     &	                              string(i:i+3).eq.'.ne.' .or.
     &	                              string(i:i+3).eq.'.or.')) then
	    level=-1
	  elseif(i.lt.laenge-4 .and.( string(i:i+4).eq.'.not.' .or.
     &	                              string(i:i+4).eq.'.and.')) then
	    level=-1
	  elseif(level.eq.0 .and. string(i:i).eq.',') then
	    level=-1
	  endif
	  i=i+1
	enddo
	suche_nach=i-2
	end
C*****7****************************************************************
	integer function suche_vor2(string,i)
c-
c     Searches for the last '(' or '*' or '+' or '-'
C     in the string
c+
	implicit	none
c
	character*(*) string
	integer	 i,j
c
	do while(i.gt.0       .and. string(i:i).ne.'(' .and.
     &	 string(i:i).ne.'*'   .and.
     &	 string(i:i).ne.'/'   .and.
     &	(string(i:i).ne.'-'   .or. (i.gt.1             .and.
     &	 string(i:i).eq.'-'   .and. 
     &	(string(i-1:i-1).eq.'E'  .or. string(i-1:i-1).eq.'e') ) .or.
     &	(string(i:i).eq.'-'   .and. i.eq.1)                 ) .and.
     &	(string(i:i).ne.'+'   .or. (i.gt.1             .and.
     &	 string(i:i).eq.'+'   .and. 
     &	(string(i-1:i-1).eq.'E' .or. string(i-1:i-1).eq.'e') ) .or.
     &	(string(i:i).eq.'+'   .and. i.eq.1                  ) ))
	  i=i-1
	enddo
      suche_vor2=i+1
      if(i.gt.1 .and. (string(i:i).eq.'-' .or. string(i:i).eq.'+')) then
	if(i.eq.1) then
	  suche_vor2=i
	else
	  j=i-1
	  do while(j.gt.1     .and. string(j:j).eq.' ')
	    j=j-1
	  enddo
	  if(string(j:j).eq.'*' .or. string(j:j).eq.'/' .or.
     &       string(j:j).eq.'+' .or. string(j:j).eq.'-' .or.
     &       string(j:j).eq.'(' ) then
	    suche_vor2=i
	  endif
	endif
      endif
      end
C*****7****************************************************************
      integer function suche_nach2(string,laenge)
c-
c     Searches for the first '(' or '*' or '/' or '+' or '-'
C     in the string
c       im string
c+
	implicit    none
c	
      character*(*) string
	integer     laenge
	integer     i
c
      i     =1
      do while(i.le.laenge  .and. string(i:i).eq.' ')
	i=i+1
      enddo
      if(string(i:i).eq.'-' .or. string(i:i).eq.'+') then
	i=i+1
      endif
      do while(i.le.laenge  .and. string(i:i).ne.')' .and.
     & string(i:i).ne.'*'   .and.
     & string(i:i).ne.'/'   .and.
     &(string(i:i).ne.'-'   .or. (i.gt.1             .and.
     & string(i:i).eq.'-'   .and. 
     &(string(i-1:i-1).eq.'E'  .or.  string(i-1:i-1).eq.'e')) ) .and.
     &(string(i:i).ne.'+'   .or. (i.gt.1             .and.
     & string(i:i).eq.'+'   .and. 
     &(string(i-1:i-1).eq.'E' .or. string(i-1:i-1).eq.'e')) ))
	i=i+1
      enddo
      suche_nach2=i-1
      end
C****7*****************************************************************
	subroutine do_math(line,indxg,length)
C-
C	Calculates the value of an expression and stores the result
c	in the proper variable
C
	implicit	none
c
	include        'errlist.inc'
c
	integer         maxw
	parameter      (maxw=10)
c
	character*(*)  line
	character*200  zeile,cpara(maxw)
c
	integer        lpara(maxw)
	integer        indxg,i,ikk,iii(maxw),ianz,lll
	integer        length
c
	real           berechne,wert,werte(maxw)
c
c------	Get the expression
c
	lll = length - (indxg+1) + 1
	call get_params(line(indxg+1:length),ianz,cpara,lpara,maxw,lll)
	if(ier_num.ne.0) then
	  return
	elseif(ianz.eq.0) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
	i     = lpara(1)
	zeile ='('//cpara(1)(1:i)//')'
	i     = i+2
c
c------	Calculate the expression
c
	wert = berechne(zeile,i)
	if( ier_num.eq.0) then
c
c-----evaluate the index of the variable 
c
	  lll = indxg-1
	  call get_params(line(1:indxg-1),ianz,cpara,lpara,maxw,lll)
	  if( ier_num.eq.0) then
	    line = cpara(1)
	    i    = lpara(1)
	    ikk  = index(line,'[')
	    if(ikk.lt.i) then
	      if(line(i:i).eq.']') then
	        if(i.gt.ikk+1) then
	          zeile=' '
	          zeile(1:i-ikk-1)    =line(ikk+1:i-1)
	          lll = i-ikk-1
                  call get_params(zeile,ianz,cpara,lpara,maxw,lll)
                  if(ier_num.eq.0) then
                    if(ianz.ge.1 .or. ianz.le.3) then
                      call ber_params(ianz,cpara,lpara,werte,maxw)
                      if(ier_num.eq.0) then
	                do i=1,ianz
	                  iii(i) = nint(werte(i))
	                enddo
c
c------	------------Store result in the variable
c
	                call upd_para(line(1:ikk-1),iii,ianz,wert,ianz)
	              endif
	            else
	              ier_num = -6
	              ier_typ = ER_FORT
	            endif
	          endif
	        else
	          ier_num = -10
	          ier_typ = ER_FORT
	        endif
	      else
	        ier_num = -9
	        ier_typ = ER_FORT
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_FORT
	    endif
	  endif
	endif
c
	end
C****7*****************************************************************
	subroutine do_eval(line,i)
C-
C	evaluates the expression stored in line
C
	implicit	none
c
	include        'errlist.inc'
	include        'prompt.inc'
c
	integer         maxw
	parameter      (maxw=10)
c
	character*200  line,zeile
	character*200  cpara(maxw)
	integer        lpara(maxw)
	integer        i,ianz
	real           berechne,wert
c
	integer        len_str
c
	if(line.eq.' ') then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	else
	  call get_params(line,ianz,cpara,lpara,maxw,i)
	  if(ier_num.eq.0) then
	    i     = lpara(1)
	    zeile = '('//cpara(1)(1:i)//')'
	    i     = i+2
c
c------	--Calculate the value of the expression
c
	    wert=berechne(zeile,i)
	  endif
	endif
	if(ier_num.eq.0) then
	  write (*,2222) line(1:len_str(line)),wert
	  if (output_status.eq.OUTPUT_FILE) then
	    write (output_io,2222) line(1:len_str(line)),wert
	  endif
	endif
c
2222	format(' Value of ',a,' = ',g11.5)
	end
C****7*****************************************************************
	real function berechne(string,laenge)
c-
c	Calculates the value of the expression stored in string
c+
	implicit	none
c
	include        'errlist.inc'
	include        'charact.inc'
c
	integer        maxw
	parameter     (maxw=3)
c
	character*(*)  string
	character*200  zeile,line,cpara(maxw)
	integer        lpara(maxw)
	integer        max
	integer        laenge,ikla,iklz,ikla1,ikla2,ikl,ll,lll,ie
	integer        ikpa,ikpa1,ikpa2,ikp,ikpz,lp,ianz,i,ikom
	real           werte(maxw)
c
	real           do_read_number
c
	ier_num      = 0
	ier_typ = ER_NONE
	berechne = 0
	if(laenge.eq.0 .or. string.eq.' ' .or. ier_num.ne.0) then
	  continue
	else
	ie = index(string,'E')
	do while(ie.ne.0)
	  string(ie:ie)='e'
	  ie = index(string,'E')
	enddo
	ikla=index(string,'(')
	do while(ikla.ne.0)
	  iklz =index(string(ikla+1:laenge),')') + ikla
	  if(iklz.gt.ikla+1) then
	    ikla2=index(string(ikla+1:iklz  ),'(') + ikla
	  else
	    ikla2 =ikla
	  endif
	  ikla1=ikla
	  do while(ikla2.lt.iklz .and. ikla2.gt.ikla1)
	    ikla1=ikla2
	    if(iklz.gt.ikla+1) then
	      ikla2=index(string(ikla1+1:iklz),'(') + ikla1
	    else
	      ikla2 =ikla1
	    endif
	  enddo
	  ikl=max(ikla1,ikla2)
	  if(ikl.ne.0) then
c
c------	----Print error messages if Parentheses are missing
c
	    if(iklz.eq.ikl) then
	      ier_num = -11
	      ier_typ = ER_FORT
	      return
	    elseif(iklz.eq.ikl+1) then
	      ier_num = -12
	      ier_typ = ER_FORT
	      return
	    endif
	    line=string(ikl+1:iklz-1)
	    ll  =iklz-ikl-1
c
c------	----Found a pair of parentheses, search for inner set 
c
	ikpa=index(line,'[')
	do while(ikpa.ne.0)
	  ikpz =index(line(ikpa+1:ll),']') + ikpa
	  if(ikpz.gt.ikpa+1) then
	    ikpa2=index(line(ikpa+1:ikpz  ),'[') + ikpa
	  else
	    ikpa2 = ikpa
	  endif
	  ikpa1=ikpa
	  do while(ikpa2.lt.ikpz .and. ikpa2.gt.ikpa1)
	    ikpa1=ikpa2
	    if(ikpz.gt.ikpa+1) then
	      ikpa2=index(line(ikpa1+1:ikpz),'[') + ikpa1
	    else
	      ikpa2 = ikpa1
	    endif
	  enddo
	  ikp=max(ikpa1,ikpa2)
	  if(ikp.ne.0) then
	    if(ikpz.gt.ikp+1) then
	      zeile=line  (ikp+1:ikpz-1)
	      lp  =ikpz-ikp-1
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        do i=1,ianz
	          call eval(cpara(i),lpara(i))
	          if(ier_num.ne.0) then
	            return
	          endif
	          werte(i) = do_read_number(cpara(i),lpara(i))
	          if(ier_num.ne.0) then
	            goto 999
	          endif
	        enddo
	          call ersetz_para(ikp,ikpz,line,ll,werte,maxw,ianz)
	            if(ier_num.ne.0) then
	            return
	        endif
	      else
	        return
	      endif
	    elseif(ikpz.eq.ikp+1) then
	      ier_num = -10
	      ier_typ = ER_FORT
	      return
	    else
	      ier_num = -9
	      ier_typ = ER_FORT
	      return
	    endif
	  endif
	  ikpa=index(line,'[')
	enddo
c
c
	ikom=index(line,',')
	if(ikom.eq.0) then
	  call eval(line,ll)
	  if(ier_num.ne.0) then
	    return
	  endif
	endif
	if(ikl.ge.3) then
	  call calc_intr(string,line,ikl,iklz,laenge,ll)
	  if(ier_num.ne.0) then
	    return
	  endif
	else
	  zeile=' '
	  if(ikl.gt.1) zeile(1:ikl-1)=string(1:ikl-1)
	  zeile(ikl:ikl+ll-1)=line(1:ll)
	  lll = ikl+ll-1
	  if(iklz+1.le.laenge) then
	    zeile(ikl+ll:ikl+ll+laenge-iklz-1)=
     &                         string(iklz+1:laenge)
	    lll = ikl+ll+laenge-iklz-1
	  endif
	  string = zeile
	  laenge = lll
	endif
	  endif
	  ikla  =index(string,'(')
	enddo
      endif
	berechne = do_read_number(string,laenge)
999	continue
c
      end
c*****7****************************************************************
	subroutine eval(line,ll)
c-
c       evaluates a line that has only the basic arithmetics
c+
	implicit       none
c
	include       'errlist.inc'
c
	character*200  line
	integer        ipot,iz1,iz2,ll,imal,idiv,iverk
	integer        iexpo,iplus,iminus,ipp
	logical        lreal
	real           w1,w2,ww
c
c...........Evaluate the exponentiation  '**'
	    ipot=index(line,'**')
	    do while(ipot.ne.0)
	      call get_w1_w2(w1,w2,line,ipot,iz1,iz2,ll,2,lreal)
	      if(ier_num.ne.0) then
	        return
	      endif
	      ww=w1**w2
	      call ersetz(line,iz1,iz2,ww,ipot,ll,2,lreal)
	      ipot=index(line,'**')
	    enddo
c...... Multiplication, division
	imal =index(line,'*')
	idiv =index(line,'/')
	if(    imal.gt.0 .and. idiv.gt.0) then
	  iverk=min(imal,idiv)
	elseif(imal.gt.0 .and. idiv.eq.0) then
	  iverk=imal
	elseif(imal.eq.0 .and. idiv.gt.0) then
	  iverk=idiv
	elseif(imal.eq.0 .and. idiv.eq.0) then
	  iverk=0
	endif
	do while(iverk.ne.0)
	  call get_w1_w2(w1,w2,line,iverk,iz1,iz2,ll,1,lreal)
	  if(ier_num.ne.0) then
	    return
	  endif
	  if(line(iverk:iverk).eq.'*') then
	    ww=w1*w2
	  elseif(line(iverk:iverk).eq.'/') then
	    if(w2.ne.0) then
	      if(lreal) then
	        ww=w1/w2
	      else
	        ww=float(int(w1)/int(w2))
	      endif
	    else
	      ier_num = -4
	      ier_typ = ER_FORT
	      return
	    endif
	  endif
	  call ersetz(line,iz1,iz2,ww,iverk,ll,1,lreal)
	  imal =index(line,'*')
	  idiv =index(line,'/')
	  if(    imal.gt.0 .and. idiv.gt.0) then
	    iverk=min(imal,idiv)
	  elseif(imal.gt.0 .and. idiv.eq.0) then
	    iverk=imal
	  elseif(imal.eq.0 .and. idiv.gt.0) then
	    iverk=idiv
	  elseif(imal.eq.0 .and. idiv.eq.0) then
	    iverk=0
	  endif
	enddo
c...... addition,subtraction
c...........search for all '+' that are not part of  xxxE+yyy
	if(line(1:1).eq.'+') then
	  iplus=index(line(2:ll),'+')
	  if(iplus.ne.0) iplus=iplus+1
	else
	  iplus=index(line      ,'+')
	endif
	if(iplus.gt.1) then
	  iexpo=index(line,'e')
	  do while(iplus.gt.1 .and. iexpo.gt.1 .and. 
     &	           iexpo+1.eq.iplus)
	    ipp=index(line(iplus+1:ll),'+')
	    if(ipp.eq.0) then
	      iplus=0
	    else
	      iplus=iplus+ipp
	      iexpo=iexpo+index(line(iexpo+1:ll),'e')
	    endif
	  enddo
	endif
	if(line(1:1).eq.'-') then
	  iminus=index(line(2:ll),'-')
	  if(iminus.ne.0) iminus=iminus+1
	else
	  iminus=index(line      ,'-')
	endif
	if(iminus.gt.1) then
	  iexpo=index(line,'e')
	  do while(iminus.gt.1 .and. iexpo.gt.1 .and. 
     &	           iexpo+1.eq.iminus)
	    ipp=index(line(iminus+1:ll),'-')
	    if(ipp.eq.0) then
	      iminus=0
	    else
	      iminus=iminus+ipp
	      iexpo=iexpo+index(line(iexpo+1:ll),'e')
	    endif
	  enddo
	endif
	if(    iplus .gt.0 .and. iminus.gt.0) then
	  iverk=min(iplus ,iminus)
	elseif(iplus .gt.0 .and. iminus.eq.0) then
	  iverk=iplus 
	elseif(iplus .eq.0 .and. iminus.gt.0) then
	  iverk=iminus
	elseif(iplus .eq.0 .and. iminus.eq.0) then
	  iverk=0
	endif
	do while(iverk.gt.1)
	  call get_w1_w2(w1,w2,line,iverk,iz1,iz2,ll,1,lreal)
	  if(ier_num.ne.0) then
	    return
	  endif
	  if(line(iverk:iverk).eq.'+') then
	    ww=w1+w2
	  else
	    ww=w1-w2
	  endif
	  call ersetz(line,iz1,iz2,ww,iverk,ll,1,lreal)
	  if(line(1:1).eq.'+') then
	    iplus=index(line(2:ll),'+')
	    if(iplus.ne.0) iplus=iplus+1
	  else
	    iplus=index(line      ,'+')
	  endif
	  if(iplus.gt.1) then
	    iexpo=index(line,'e')
	    do while(iplus.gt.1 .and. iexpo.gt.1 .and.
     &               iexpo+1.eq.iplus)
	      ipp=index(line(iplus+1:ll),'+')
	      if(ipp.eq.0) then
	        iplus=0
	      else
	        iplus=iplus+ipp
	        iexpo=iexpo+index(line(iexpo+1:ll),'e')
	      endif
	    enddo
	  endif
	  if(line(1:1).eq.'-') then
	    iminus=index(line(2:ll),'-')
	    if(iminus.ne.0) iminus=iminus+1
	  else
	    iminus=index(line      ,'-')
	  endif
	  if(iminus.gt.1) then
	    iexpo=index(line,'e')
	    do while(iminus.gt.1 .and. iexpo.gt.1 .and.
     &               iexpo+1.eq.iminus)
	      ipp=index(line(iminus+1:ll),'-')
	      if(ipp.eq.0) then
	        iminus=0
	      else
	        iminus=iminus+ipp
	        iexpo=iexpo+index(line(iexpo+1:ll),'e')
	      endif
	    enddo
	  endif
	  if(    iplus .gt.0 .and. iminus.gt.0) then
	    iverk=min(iplus ,iminus)
	  elseif(iplus .gt.0 .and. iminus.eq.0) then
	    iverk=iplus 
	  elseif(iplus .eq.0 .and. iminus.gt.0) then
	    iverk=iminus
	  elseif(iplus .eq.0 .and. iminus.eq.0) then
	    iverk=0
	  endif
	enddo
	end
c*****7****************************************************************
	subroutine calc_intr(string,line,ikl,iklz,lll,lp)
c
c	Evaluate all intrinsic functions
c
	implicit      none
c
	include        'errlist.inc'
	include        'random.inc'
	include        'wink.inc'
c
	integer       maxw
	parameter    (maxw=9)
c
	character*(*) string,line
	character*200 cpara(maxw)
	integer       lpara(maxw)
	integer       lp,lll,ikom,ikl,iklz,i,ianz
	integer       lcom
	real          fl1,fl2,fl3,gbox_k,gbox_w,gbox_x
	real          werte(maxw),ww,a
	real          sind,cosd,tand,asind,acosd,atand
c
	integer       length_com
	real          gasdev,ran1
	real          do_read_number
c
	ier_num = -1
	ier_typ = ER_FORT
	ikom=index(line,',')
	if(ikom.eq.0) then
	  ww = do_read_number(line,lp)
	  if(ier_num.ne.0) then
	    return
	  endif
	endif
	ier_num = 0
	ier_typ = ER_NONE
	lcom    = length_com(string,lll,ikl)
	if(lcom.eq.0) then
 	  call ersetz2(string,ikl,iklz,ww,0,lll)
	elseif(lcom.eq.5) then
	  if  (string(ikl-5:ikl-1).eq.'asind') then
	    if(abs(ww).le.1.0) then
	      ww=asind(ww)
	      call ersetz2(string,ikl,iklz,ww,5,lll)
	    else
	      ier_num = -7
	      ier_typ = ER_FORT
	    endif
	  elseif(string(ikl-5:ikl-1).eq.'acosd') then
	    if(abs(ww).le.1.0) then
	      ww=acosd(ww)
	      call ersetz2(string,ikl,iklz,ww,5,lll)
	    else
	      ier_num = -7
	      ier_typ = ER_FORT
	    endif
	  elseif(string(ikl-5:ikl-1).eq.'atand') then
	    ww=atand(ww)
	    call ersetz2(string,ikl,iklz,ww,5,lll)
	  else
	    call calc_intr_spec(string,line,ikl,iklz,ww,lll,lp)
	  endif
	elseif(lcom.eq.4) then
	  if    (string(ikl-4:ikl-1).eq.'asin') then
	    if(abs(ww).le.1.0) then
	      ww=asin(ww)
	      call ersetz2(string,ikl,iklz,ww,4,lll)
	    else
	      ier_num = -7
	      ier_typ = ER_FORT
	    endif
	  elseif(string(ikl-4:ikl-1).eq.'acos') then
	    if(abs(ww).le.1.0) then
	      ww=acos(ww)
	      call ersetz2(string,ikl,iklz,ww,4,lll)
	    else
	      ier_num = -7
	      ier_typ = ER_FORT
	    endif
	  elseif(string(ikl-4:ikl-1).eq.'atan') then
	    ww=atan(ww)
	    call ersetz2(string,ikl,iklz,ww,4,lll)
	  elseif(string(ikl-4:ikl-1).eq.'sind') then
	    ww=sind(ww)
	    call ersetz2(string,ikl,iklz,ww,4,lll)
	  elseif(string(ikl-4:ikl-1).eq.'cosd') then
	    ww=cosd(ww)
	    call ersetz2(string,ikl,iklz,ww,4,lll)
	  elseif(string(ikl-4:ikl-1).eq.'tand') then
	    ww=tand(ww)
	    call ersetz2(string,ikl,iklz,ww,4,lll)
	  elseif(string(ikl-4:ikl-1).eq.'tanh') then
	    ww=tanh(ww)
	    call ersetz2(string,ikl,iklz,ww,4,lll)
	  elseif(string(ikl-4:ikl-1).eq.'sinh') then
	    ww=sinh(ww)
	    call ersetz2(string,ikl,iklz,ww,4,lll)
	  elseif(string(ikl-4:ikl-1).eq.'cosh') then
	    ww=cosh(ww)
	    call ersetz2(string,ikl,iklz,ww,4,lll)
	  elseif(string(ikl-4:ikl-1).eq.'sqrt') then
	    if(ww.ge.0) then
	      ww=sqrt(ww)
	      call ersetz2(string,ikl,iklz,ww,4,lll)
	    else
	      ier_num = -5
	      ier_typ = ER_FORT
	    endif
	  elseif(string(ikl-4:ikl-1).eq.'nint') then
	    ww=float(nint(ww))
	    call ersetz2(string,ikl,iklz,ww,4,lll)
	  elseif(string(ikl-4:ikl-1).eq.'frac') then
	    ww=ww-float(int(ww))
	    call ersetz2(string,ikl,iklz,ww,4,lll)
	  elseif(string(ikl-4:ikl-1).eq.'gbox') then
	    call get_params(line,ianz,cpara,lpara,3,lp)
	    if(ianz.eq.3) then
	      do i=1,3
	        call eval(cpara(i),lpara(i))
	        if(ier_num.ne.0) then
	          return
	        endif
	        werte(i) = do_read_number(cpara(i),lpara(i))
	        if(ier_num.ne.0) then
	          return
	        endif
	        if(werte(i).lt.0.0) then
	          ier_num = -28
	          ier_typ = ER_APPL
	          return
	        endif
	      enddo	
c	      Determine relative size of exponentials and box
	      fl1 = 0.5*werte(1)*sqrt(zpi)
	      fl2 =     werte(2)
	      fl3 = 0.5*werte(3)*sqrt(zpi)
c	      Normalize to 1
	      gbox_k = 1./( fl1 + fl2 +fl3 )
	      gbox_w = 1. - (fl1 +fl3)*gbox_k
c	      Get random number 
	      gbox_x = ran1(idum)
c
	      if(gbox_x.lt. fl1*gbox_k      ) then
	        ww = -werte(2)*0.5 - abs(gasdev(werte(1)))
	      elseif( gbox_x.lt. (fl1+fl2)*gbox_k) then
	        ww = -werte(2)*0.5 + (gbox_x - fl1*gbox_k)*werte(2)/gbox_w
	      else
	        ww =  werte(2)*0.5 + abs(gasdev(werte(3)))
	      endif
	      call ersetz2(string,ikl,iklz,ww,4,lll)
	    else
	      ier_num = -6
	      ier_typ = ER_FORT
	      return
	    endif
	  elseif(string(ikl-4:ikl-1).eq.'gran') then
	    call get_params(line,ianz,cpara,lpara,2,lp)
	    if(ianz.ge.1) then
	      call eval(cpara(1),lpara(1))
	      if(ier_num.ne.0) then
	        return
	      endif
	      werte(1) = do_read_number(cpara(1),lpara(1))
	      if(ier_num.ne.0) then
	        return
	      endif
	      if(werte(1).lt.0.0) then
	        ier_num = -28
	        ier_typ = ER_APPL
	        return
	      endif
c
	      if(ianz.eq.1 .or. cpara(2).eq.'s') then
	        a = werte(1)
	      elseif(ianz.eq.2 .and. cpara(2).eq.'f') then
	        a = werte(1)/sqrt(8.*log(2.))
	      else
	        ier_num = -6
	        ier_typ = ER_FORT
	        return
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_FORT
	      return
	    endif
	    ww = gasdev(a)
	    call ersetz2(string,ikl,iklz,ww,4,lll)
	  else
	    call calc_intr_spec(string,line,ikl,iklz,ww,lll,lp)
	  endif
	elseif(lcom.eq.3) then
	  if    (string(ikl-3:ikl-1).eq.'sin') then
	    ww=sin(ww)
	    call ersetz2(string,ikl,iklz,ww,3,lll)
	  elseif(string(ikl-3:ikl-1).eq.'cos') then
	    ww=cos(ww)
	    call ersetz2(string,ikl,iklz,ww,3,lll)
	  elseif(string(ikl-3:ikl-1).eq.'tan') then
	    ww=tan(ww)
	    call ersetz2(string,ikl,iklz,ww,3,lll)
	  elseif(string(ikl-3:ikl-1).eq.'exp') then
	    ww=exp(ww)
	    call ersetz2(string,ikl,iklz,ww,3,lll)
	  elseif(string(ikl-3:ikl-1).eq.'abs') then
	    ww=abs(ww)
	    call ersetz2(string,ikl,iklz,ww,3,lll)
	  elseif(string(ikl-3:ikl-1).eq.'int') then
	    ww=float(int(ww))
	    call ersetz2(string,ikl,iklz,ww,3,lll)
	  elseif(string(ikl-3:ikl-1).eq.'max') then
	    call get_params(line,ianz,cpara,lpara,2,lp)
	    if(ianz.eq.2) then
	      do i=1,ianz
	        call eval(cpara(i),lpara(i))
	        if(ier_num.ne.0) then
	          return
	        endif
	        werte(i) = do_read_number(cpara(i),lpara(i))
	        if(ier_num.ne.0) then
	          return
	        endif
	      enddo
	      ww=max(werte(1),werte(2))
	      call ersetz2(string,ikl,iklz,ww,3,lll)
	    else
	      ier_num = -6
	      ier_typ = ER_FORT
	      return
	    endif
	  elseif(string(ikl-3:ikl-1).eq.'min') then
	    call get_params(line,ianz,cpara,lpara,2,lp)
	    if(ianz.eq.2) then
	      do i=1,ianz
	        call eval(cpara(i),lpara(i))
	        if(ier_num.ne.0) then
	          return
	        endif
	        werte(i) = do_read_number(cpara(i),lpara(i))
	        if(ier_num.ne.0) then
	          return
	        endif
	      enddo
	      ww=min(werte(1),werte(2))
	      call ersetz2(string,ikl,iklz,ww,3,lll)
	    else
	      ier_num = -6
	      ier_typ = ER_FORT
	      return
	    endif
	  elseif(string(ikl-3:ikl-1).eq.'mod') then
	    call get_params(line,ianz,cpara,lpara,2,lp)
	    if(ianz.eq.2) then
	      do i=1,ianz
	        call eval(cpara(i),lpara(i))
	        if(ier_num.ne.0) then
	          return
	        endif
	        werte(i) = do_read_number(cpara(i),lpara(i))
	        if(ier_num.ne.0) then
	          return
	        endif
	      enddo
	      ww=amod(werte(1),werte(2))
	      call ersetz2(string,ikl,iklz,ww,3,lll)
	    else
	      ier_num = -6
	      ier_typ = ER_FORT
	      return
	    endif
	  elseif(string(ikl-3:ikl-1).eq.'ran') then
	    ww=ran1(idum)
	    call ersetz2(string,ikl,iklz,ww,3,lll)
	  else
	    call calc_intr_spec(string,line,ikl,iklz,ww,lll,lp)
	  endif
	elseif (lcom.eq.2) then
	  if(string(ikl-2:ikl-1).eq.'ln') then
	    if(ww.gt.0.0) then
	      ww=log(ww)
	      call ersetz2(string,ikl,iklz,ww,2,lll)
	    else
	      ier_num = -20
	      ier_typ = ER_FORT
	    endif
	  else
	    call calc_intr_spec(string,line,ikl,iklz,ww,lll,lp)
	  endif
	else
	  call calc_intr_spec(string,line,ikl,iklz,ww,lll,lp)
	endif
c
999     continue
	end
c*****7****************************************************************
	subroutine get_w1_w2(w1,w2,line,iverk,iz1,iz2,ll,lverk,lreal)
c
c	Get the two numbers in front and after an operator
c
	implicit	none
c
	include        'errlist.inc'
c
	character*(*)   line
	character*200   zeile
	integer         suche_vor2,suche_nach2
	integer         iverk,iz1,iz2,ll,lverk,lll
	logical         lreal
	real            w1,w2
c
	real            do_read_number
c
	lll   = iverk - 1
	iz1   = suche_vor2(line(1:iverk-1),lll)
	zeile = line(iz1:iverk-1)
	w1    = do_read_number(zeile,iverk-iz1)
	if(ier_num.ne.0) then
	  return
	endif
	lreal = index(line(iz1:iverk-1),'.') .gt. 0
	lll   = ll - ( iverk+lverk ) + 1
	iz2   = suche_nach2(line(iverk+lverk:ll),lll)
	zeile = line(iverk+lverk:iverk+lverk+iz2-1)
	w2    = do_read_number(zeile,iz2)
	if(ier_num.ne.0) then
	  return
	endif
	lreal=lreal .or.
     &	  index(line(iverk+lverk:iverk+lverk+iz2-1),'.') .gt. 0
c
	end
c*****7****************************************************************
	subroutine ersetz(line,iz1,iz2,ww,iverk,ll,lverk,lreal)
c+
c	Replaces the corresponding part of line by the number ww
c	Different format is used for real and integer numbers
c
	implicit       none
c
	character*(*)  line
	character*5    form
	character*200  zeile
	integer        iz1,iz2,iverk,ll,lverk,lw
	logical        lreal
	real           ww
c
	zeile=' '
	if(iz1.gt.1) zeile(1:iz1-1)=line(1:iz1-1)
	if(lreal) then
	  lw = 15
	  write(zeile(iz1:iz1+lw-1),'(e15.8e2)') ww
	  zeile(iz1+11:iz1+11) = 'e'
	else
	  lw = int(alog(abs(ww)+1.))+2
	  write(form,1000) lw
	  write(zeile(iz1:iz1+lw-1),form       ) int(ww)
	endif
	if(iverk+lverk+iz2.le.ll) 
     &	  zeile(iz1+lw:200)=line(iverk+lverk+iz2:ll)
	line=zeile
	ll=ll+lw-(lverk+iz2+iverk-iz1-1)
	call rem_bl(line,ll)
c
1000	format('(i',i2,')')
	end
c*****7****************************************************************
	subroutine ersetz2(string,ikl,iklz,ww,lfunk,lll)
c
c	Replaces the intrinsic function and its argument by the
c	corresponding value ww
c
	implicit       none
c
	character*(*)  string
	character*200  zeile
	integer        ikl,iklz,laenge,lfunk,lll
	real           ww
c
	laenge=lll
	zeile =' '
	if(ikl.gt.1) zeile(1:ikl-1-lfunk)=string(1:ikl-1-lfunk)
	write(zeile(ikl-lfunk:ikl-lfunk+14),'(e15.8e2)') ww
	zeile(ikl-lfunk+11:ikl-lfunk+11) = 'e'
	lll = ikl-lfunk+14
	if(iklz+1.le.laenge) then
	  zeile(ikl-lfunk+15:200)= string(iklz+1:laenge)
	  lll = lll + laenge - ( iklz+1) + 1
	endif
	string=zeile
	call rem_bl(string,lll)
	end
c*****7****************************************************************
	integer function bindex(string,char)
c
c	Searches for 'char' in 'string' from the back
c
	implicit	none
c
	character*(*)	string
	character*1	char
c
	integer		il,ik
	integer		len_str
c
	ik = 0
	il = len_str(string)
c
	do while (il.ge.1 .and. ik.eq.0)
	  if (string(il:il).eq.char) then
	    ik = il
	  else
	    il = il-1
	  endif
	enddo
c
	bindex = ik
c
	end
c*****7****************************************************************
	subroutine rem_bl(line,ll)
c
c	Removes all blanks from a string
c
	implicit       none
c
	character*(*)  line
	character*200  zeile
	integer        ll,ibl
c
	ibl=index(line(1:ll),' ')
	do while(ibl.gt.0)
	  zeile=' '
	  if(ibl.gt.1) zeile(1:ibl-1)=line(1:ibl-1)
	  if(ibl.lt.ll) then
	    zeile(ibl:ll-1)=line(ibl+1:ll)
	  endif
	  ll=ll-1
	  line=zeile
	  ibl=index(line(1:ll),' ')
	enddo
	end
c*****7***************************************************************
	integer function len_str(string)
c-
c	 determines the position of the last non-blank character
c
c	 Version  : 0.0
c
c	 Date     : September 1992
c
c	 Author   : r.n.
c
c	 modified : 
c
c+
	implicit       none
c
	character*(*)  string
	integer        laenge,i
c
	laenge=len(string)
	i=laenge
	do while (i.gt.0 .and. string(i:i).eq.' ')
	  i=i-1
	enddo
	if (ichar(string(i:i)).eq.13) i=i-1
	len_str=i
	end
c*****7***************************************************************
	subroutine del_params(ndel,ianz,cpara,lpara,nwerte)
c-
c	Deletes the first <ndel> parameters from the list and 
c	moves the rest to the beginning of the arrays.
c+
	implicit       none
c
	include        'errlist.inc'
c
	integer        nwerte
	character*200  cpara(nwerte)
	integer        lpara(nwerte)
	integer        ndel,ianz,i
c
	if (ndel.lt.ianz) then
	  do i=ndel+1,ianz
	    cpara(i-ndel)=cpara(i)
	    lpara(i-ndel)=lpara(i)
	  enddo
	  ianz=ianz-ndel
	endif
c
	end
c*****7***************************************************************
	subroutine get_params(string,ianz,cpara,lpara,nwerte,laenge)
c-
c	Reads parameters that have to be separated by ",". Each
c       expression between "," is evaluated to give the value of
c       the parameter. If the routine is called with a negative
c	length, leading SPACE will NOT be removed !
c+
	implicit       none
c
	include        'errlist.inc'
c
	integer        nwerte
	character*(*)  string
	character*200  cpara(nwerte)
	integer        lpara(nwerte)
	integer        suche_nach,i,lll
	integer        laenge,ipos,ianz,iko,ikk
	logical        rmblk
c
	ipos=1
	ianz=0
	ier_num = 0
	ier_typ = ER_NONE
	if(laenge.eq.0) return
c
	if(laenge.lt.0) then
	  laenge = -laenge
	  rmblk  = .false.
	else
	  rmblk  = .true.
	endif
c
	iko=index(string(ipos:laenge),',')
	if(iko.ne.0) then
	  lll = laenge - ipos + 1
	  ikk=suche_nach(string(ipos:laenge),lll)+1
	  if(ikk.eq.laenge) then
	    ikk=ikk+1
	  endif
	  do while(ikk.gt.1 .and. ianz.lt.nwerte-1)
	    ianz       =ianz+1
	    cpara(ianz)=string(ipos:ipos+ikk-2)
	    lpara(ianz)= (ipos+ikk-2) - ipos + 1
	    ipos       =ipos+ikk
	    if(ipos.le.laenge) then
	      iko=index(string(ipos:laenge),',')
	      if(iko.ne.0) then
	        lll = laenge - ipos + 1
	        ikk=suche_nach(string(ipos:laenge),lll)+1
	        if(ikk+ipos.gt.laenge) goto 10
	      else
	        ikk=0
	      endif
	    else
	      goto 10
	    endif
	  enddo
	endif
10	continue
	if(ipos.le.laenge .and. string(ipos:laenge).ne. ' ') then
	  ianz       =ianz+1
	  cpara(ianz)=string(ipos:laenge)
	  lpara(ianz)=laenge - ipos + 1
	endif
	ier_num = 0
	ier_typ = ER_NONE
c
c------	remove leading blanks if length was given positive
c
	if (rmblk) then
	  do i=1,ianz
	    lll      = lpara(i)
	    call rem_bl(cpara(i),lll)
	    lpara(i) = lll
	  enddo
	endif
	end
c*****7***************************************************************
	subroutine ber_params(ianz,cpara,lpara,werte,maxpara)
c-
c	Calculated the value of all expressions stored in cpara
c+
	implicit       none
c
	include        'errlist.inc'
c
	integer         maxpara
	character*200   cpara(maxpara)
	integer         lpara(maxpara)
	character*200   line
	integer         ll,ianz,i
	real            werte(maxpara),wert
	real            berechne
c
	do i=1,ianz
	  ll=lpara(i)
	  line=' '
	  line='('//cpara(i)(1:ll)//')'
	  ll  = ll + 2
	  wert=berechne(line,ll)
	  if(ier_num.ne.0) then
	    goto 9999
	  endif
	  werte(i)=wert
	enddo
9999    continue
	end
c*****7***************************************************************
	integer function length_com(string,laenge,ikl)
c-
c	Determines the length of the variable or intrinsic function
c	by searching backwards from the bracket to the first non
c	character and non '_' character.
c+
	implicit      none
c
	include      'charact.inc'
c
	character*(*) string
c
	integer       laenge,ikl,i,c
	logical       lchar
c
	i     = ikl
	lchar = .true.
	dowhile( lchar .and. i.gt.1) 
	  i     = i-1
	  c     = ichar(string(i:i))
	  lchar = a.le. c .and. c.le.z .or. c.eq.u
	enddo
c
	if(i.eq.1 .and. lchar) then
	  length_com = ikl  -1
	else
	  length_com = ikl-i-1
	endif
c
	end
c*****7****************************************************************
	real function do_read_number(string,laenge)
c-
c	Reads a numerical value from the string. This is the VMS version.
c	In order to recognize erroneous nonmunerical data in the last
c	character of string, the format is one character longer than the
c	actual; length of the parameter. Otherwise unix does not 
c	recognize an integer like e.g. "3a" as an error.
c
c	The VMS version properly detects an error for the (more sensible)
c	length equal to the actual length of the parameter
c+
	implicit      none
c
	include       'charact.inc'
	include       'errlist.inc'
c
	character*(*)  string
	integer        laenge
c
	character*200  line
	integer        i
c
	ier_num = -1
	ier_typ = ER_FORT
	line    = string
c
	i       = ichar(string(laenge:laenge))
	if(zero.le.i .and. i.le.nine .or. i.eq.period) then
	  read(line,*   ,end=999,err=999) do_read_number
c
	  ier_num = 0
	  ier_typ = ER_NONE
	else
	  do_read_number = 0.
	endif
c
999	continue
c
	end
c*****7***************************************************************
	subroutine do_build_name(ianz,cpara,lpara,werte,MAXW,fpara)
c-
c	Creates a filename from several parameters. the first parameter
c	is interpreted as format.
c+
	implicit       none
c
	include       'errlist.inc'
c
	integer		FORM_INTEGER
	parameter	(FORM_INTEGER=1)
	integer		FORM_INT_ZEROS
	parameter	(FORM_INT_ZEROS=2)
	integer		FORM_REAL
	parameter	(FORM_REAL=3)
	integer		FORM_REAL_ZEROS
	parameter	(FORM_REAL_ZEROS=4)
	integer		NUM_FORM
	parameter	(NUM_FORM=4)
c
	integer        MAXW
c
	character*200  cpara(MAXW)
	character*200  string
	integer        ianz
	integer        fpara
	integer        lpara(MAXW)
	real           werte(MAXW)
c
	character*1	c_form(NUM_FORM)
	character*200	fstring
	character*200  line,number
	integer		ftyp
	integer        ind_ql,ind_qr
	integer        ind_d,ind_i,ind_f
	integer		ind_p,itot,idec
	integer        ii,lp
	integer        laenge
	integer        lwert
	integer        lsub
	integer        npara
	integer        pos
	integer        ll,i
	real           wert
	logical        lfloat
c
	real           berechne
	integer        len_str
c
	data c_form/'d','D','f','F'/
c
	string = ' '
	if(lpara(fpara).le.1) then
c
c------	--If first parameter is too short for a string, return
c
	  return
	endif
c
c------	Get position of left quotation mark into ind_ql
c
	ind_ql = index(cpara(fpara)(1:lpara(fpara)-1),'"')
	if(ind_ql.lt.1) then
c
c------	--No quotation mark found, return
c
	  return
	endif
c
c------	Get position of right quotation mark into ind_qr
c
	ind_qr = ind_ql + index(cpara(fpara)(ind_ql+1:lpara(fpara)),'"')
	if(ind_qr.lt.ind_ql+1) then
	  ier_num = -44
	  ier_typ = ER_APPL
	  return
	endif
c
c------	Find position of first format specifiers
c
	ind_d  = index(cpara(fpara)(ind_ql+1:ind_qr-1)  ,'%') + ind_ql
c
	laenge = 0
	pos    = ind_ql + 1
	npara  = fpara + 1
CDBG	lfloat = (cpara(fpara)(ind_d+1:ind_d+1).eq.'f')
c
c------	While there are any format specifiers left
c
	do while (ind_d.ge.pos)
c
c------	--If there is space left for a format specifier
c
	  if(ind_d+1.le.ind_qr-1) then
c
c------	----Find first 'd' or 'f'
c
	    ind_f = 9999
	    ftyp  = 0
	    do i=1,NUM_FORM
	      ind_i  = index(cpara(fpara)(ind_d+1:ind_qr-1),c_form(i))
	      if(ind_i.gt.0 .and. ind_i.lt.ind_f) then
	        ind_f = ind_i
	        ftyp  = i
	      endif
	    enddo
	    if(ftyp.eq.0) then
	      ier_num = -21
	      ier_typ = ER_FORT
	      return
	    endif
	    ind_i = ind_f
c
c------	--We have an integer format
c	  The string between '%' and 'd' or 'D' is evaluated and
c	  written into the format variable fstring. Allows error checking
c	  and flexible formats
c
	    if(ftyp.eq.FORM_INTEGER.or.ftyp.eq.FORM_INT_ZEROS) then
	      ll = ind_i-1
	      if(ll.gt.0) then
	        line = '('//cpara(fpara)(ind_d+1:ind_d+ind_i-1)//')'
	        ll = ll + 2
	        call rem_bl(line(1:ll),ll)
	        ier_num = 0
	        wert=berechne(line,ll)
	        if(ier_num.ne.0) then
	          ier_msg(1) = 'An error occurred while calculating'
	          ier_msg(2) = 'the value of a format specifier    '
	          return
	        endif
	        write(fstring,3000) int(wert)
	        ll = 15
	        call rem_bl(fstring(1:ll),ll)
	      else
	        fstring = '*'
	        ll      = 1
	      endif
c
c------	--We have a real format
c	  The string between '%' and 'f' or 'F' is evaluated and
c	  written into the format variable fstring. Allows error checking
c	  and flexible formats
c
	    elseif(ftyp.eq.FORM_REAL.or.ftyp.eq.FORM_REAL_ZEROS) then
	      ll = ind_f-1
	      if(ll.gt.0) then
	        line = '('//cpara(fpara)(ind_d+1:ind_d+ind_f-1)//')'
	        ll = ll + 2
	        call rem_bl(line(1:ll),ll)
	        ind_p = index(line(1:ll),'.')
	        if(ind_p.gt.0) then
	          number = line(1:ind_p-1)//')'
	          lp     = ind_p
	          itot = nint(berechne(number,lp))
	          if(ier_num.ne.0) then
	            ier_msg(1) = 'An error occurred while calculating'
	            ier_msg(2) = 'the value of a format specifier    '
	            return
	          endif
	          if(ind_p.lt.ll-1) then
	            number = '('//line(ind_p+1:ll)
	            lp     = ll-ind_p+1
	            idec = nint(berechne(number,lp))
	            if(ier_num.ne.0) then
	              ier_msg(1) = 'An error occurred while calculating'
	              ier_msg(2) = 'the value of a format specifier    '
	              return
	            endif
	          else
	            idec = 0
	          endif
	        else
	          itot = nint(berechne(line(1:ll),ll))
	          if(ier_num.ne.0) then
	            ier_msg(1) = 'An error occurred while calculating'
	            ier_msg(2) = 'the value of a format specifier    '
	            return
	          endif
	          idec = 0
	        endif
	        if(ier_num.ne.0) return
	        write(fstring,3100) itot,idec
	        ll = 24
	        call rem_bl(fstring(1:ll),ll)
	      else
	        fstring = '*'
	        ll      = 1
	      endif
	    endif
	  else
	    ier_num = -21
	    ier_typ = ER_FORT
	    return
	  endif
c
c------	--Copy strings left before the current format specifier.
c
	  if(ind_d.gt.pos) then
	    lsub    = ind_d - pos
	    string(laenge+1:laenge+lsub) = 
     &	             cpara(fpara)(pos:ind_d-1)
	    laenge  = laenge + lsub
	  endif
c
c------	--Write numerical value of parameter into string
c
	  if(ianz.ge.npara) then
c
c------	----Calculate value of current parameter
c
	    ll=lpara(npara)
	    line=' '
	    line='('//cpara(npara)(1:ll)//')'
	    ll  = ll + 2
	    call rem_bl(line(1:ll),ll)
	    wert=berechne(line,ll)
	    if(ier_num.ne.0) then
	      return
	    endif
	    werte(npara)=wert
c
	    if (ftyp.eq.FORM_REAL) then
	      pos    = ind_d + ind_f + 1
	      if(fstring.eq.'*') then
	        write(number,*) werte(npara)
	        ii = len_str(number)
	        call rem_bl(number,ii)
	      else
	        write(number,fstring) werte(npara)
	      endif
	      ii = len_str(number)
	    elseif (ftyp.eq.FORM_REAL_ZEROS) then
	      pos    = ind_d + ind_f + 1
	      if(fstring.eq.'*') then
	        write(number,*) werte(npara)
	        ii = len_str(number)
	        call rem_bl(number,ii)
	      else
	        write(number,fstring) werte(npara)
	      endif
	      ii = len_str(number)
	      do i=1,ii
	        if(number(i:i).eq.' ') then
	          number(i:i)='0'
	        endif
	      enddo
	      do i=1,ii
	        if(number(i:i).eq.'-') then
	          number(i:i)='0'
	          number(1:1)='-'
	        endif
	      enddo
	    elseif(ftyp.eq.FORM_INTEGER) then
	      pos    = ind_d + ind_i + 1
	      ii     = nint(werte(npara))
	      if(fstring.eq.'*') then
	        write(number,*) ii
	        ii = len_str(number)
	        call rem_bl(number,ii)
	      else
	        write(number,fstring) ii
	      endif
	      ii = len_str(number)
	    elseif(ftyp.eq.FORM_INT_ZEROS  ) then
	      pos    = ind_d + ind_i + 1
	      ii     = nint(werte(npara))
	      if(fstring.eq.'*') then
	        write(number,*) ii
	        ii = len_str(number)
	        call rem_bl(number,ii)
	      else
	        write(number,fstring) ii
	      endif
	      ii = len_str(number)
	      do i=1,ii
	        if(number(i:i).eq.' ') then
	          number(i:i)='0'
	        endif
	      enddo
	      do i=1,ii
	        if(number(i:i).eq.'-') then
	          number(i:i)='0'
	          number(1:1)='-'
	        endif
	      enddo
	    endif
	    lwert  = len_str(number)
	    string(laenge+1:laenge+lwert) = number(1:lwert)
	    laenge = laenge + lwert
c
c------	----Eliminate parameter from list
c
	    do i=npara,ianz-1
	      cpara(i) = cpara(i+1)
	      lpara(i) = lpara(i+1)
	    enddo
	    cpara(ianz) = ' '
	    lpara(ianz) = 0
	    ianz = ianz - 1
	  else
	    ier_num = -43
	    ier_typ = ER_APPL
	    return
	  endif
c
c------	--Any format specifiers left ?
c
	  if(pos.le.ind_qr-1) then
	    ind_d  = index(cpara(fpara)(pos:ind_qr-1)  ,'%') + pos - 1
	    lfloat = (cpara(fpara)(ind_d+1:ind_d+1).eq.'f')
	  else
	    ind_d = 0
	  endif
	enddo
c
c------	Append rest of format specifying string to filename
c
	if(ind_qr-1.ge.pos) then
	  string(laenge+1:laenge+ind_qr-pos) = 
     &	                cpara(fpara)(pos:ind_qr-1)
	  laenge = laenge + ind_qr - pos
	endif
c
	cpara(fpara) = string
	lpara(fpara) = laenge
c
3000	format('(i',i10,')')
3100	format('(f',i10,'.',i10,')')
	end
c*****7***************************************************************
	subroutine count_col (zeile,ianz)
c+
c	This subroutine counts the number of columns of string 'zeile'
c-
	implicit	none
c
	include		'prompt.inc'
c
	character*(*)	zeile
	integer		ianz,i
	logical		ein
c
	integer		len_str
c
	ianz=0
	ein =.false.
c
	do i=1,len_str(zeile)
	  if (zeile(i:i).ne.' ') then
	    ein  = .true.
	  elseif (zeile(i:i).eq.' ' .and. ein) then
	    ein  = .false.
	    ianz = ianz + 1
	  endif
	enddo
c
	if (ein) ianz=ianz+1
c
	if (ianz.ne.0) write (output_io,1000) ianz
1000	format(1x,'Reading ',i1,' columns ...')
c
	end
