c****7******************************************************************
	subroutine do_hel(ein,length)
c-
c	This sublevel emulates the HELP function under VMS and
c	controls the online help of DISCUS.
c
c	Version : 1.3
c	Date    : 25 Oct 96
c
c	Authors : R.B. Neder  (reinhard.neder@mail.uni-wuerzburg.de)
c	          Th. Proffen (proffen@pa.msu.edu)
c
c-
	implicit         none
c
	include		'prompt.inc'
	include         'envir.inc'
	include         'doact.inc'
	include         'macro.inc'
	include         'errlist.inc'
c
	integer          nviele    ,ihl   ,maxw
        parameter       (nviele=101,ihl=77,maxw=10)
c
        character*(*)    ein
	character*80     line,zeile,dummy
        character*12     bef(maxw)
	character*11	 prom
	character*4      befehl
	character*3      status
	integer          i,ibef,il(maxw)
	integer          length,ll,lbef,lp
        logical          lread,lende
	logical          found,fast,stay
c
	integer		 len_str
c
c------ set up some variables
c
	line = ein
	ier_num = 0
	ier_typ = ER_NONE
	status = 'old'
	lread  = .true.
	lende  = .false.
	fast   = .false.
c
c------ if length was given negative we don't want to enter help level
c
	if (length.lt.0) then
	  stay   = .false. 
	  length = -length
	else
	  stay   = .true.
	endif
c
c------ if we are in a loop or macro do nothing !!
c
	if (lmakro .or. lblock) return
10	continue
c
c------ - print help file entry 
c
	  if (stay) call do_status(1,bef,ibef,il,maxw)
          call oeffne(ihl,hlpfile,status,lread)
	  if(ier_num.ne.0) return
	  call do_cap(line)
          call do_trenn(line,bef,ibef,length,maxw)
	  call do_help_single(ihl,bef,ibef,maxw,found,fast)
	  close (ihl)
c
c------ - Entry found ?
c
	  if(ier_num.ne.0) return
c
c------ - if there are no subcommands get up one level
c
	  if (.not.found) then
	    if(ibef.gt.1) then
	      ibef = ibef-1
	      write (line,1000) (bef(i),i=1,ibef)
	      length = len_str(line)
	    endif
	  endif
c
c------ - Want to enter help level ?
c
	  if (.not.stay) return
c
c------	- Set reading mode back to normal
c
	  fast = .false.
c
c------ - prompt user for input in online help
c
15	  continue
	  call do_status(2,bef,ibef,il,maxw)
	  prom = prompt//'/help'
	  call get_command (zeile,ll,befehl,lbef,dummy,lp,prom)
c
c------ - we will go up one level '..'
c
	  if (zeile(1:2).eq.'..') then
	    if(ibef.gt.1) then
	      ibef = ibef-1
	      write (line,1000) (bef(i),i=1,ibef)
	      length = len_str(line)
	    endif
	    goto 15
c
c------ - leave help level ' '
c
	  elseif (ll.eq.0) then
	    lende = .true.
c
c------	- repeat list of sublevels availble from current level
c
	  elseif (zeile(1:1).eq.'?') then
	    fast = .true.
c
c------ - give help for this subcommand 'word'
c
	  else
	    write (line,1000) (bef(i),i=1,ibef),zeile
	    length = len_str(line)
	  endif
c
	if (.not. lende) goto 10
c
20	continue
c
1000	format(8(a12,1x))
2000	format(a)
	end
c****7******************************************************************
	subroutine do_status(iwhere,bef,ibef,il,maxw)
c-
c	Prints out status line in online help
c-
	implicit         none
c
	include		 'prompt.inc'
c
	integer		 iwhere,ibef,maxw
	integer		 il(maxw)
	character*(*)    bef(maxw)
c
	character*80     level
	character*6      prom
	integer	         i
c
	integer		 len_str
c
c------ Build status lines
c
	if     (iwhere.eq.1) then
	  prom = prompt
	  call do_cap(prom)
	  write (output_io,2000) prom,version
	elseif (iwhere.eq.2) then
	  do i=1,ibef
	    il(i) = len_str(bef(i))
	  enddo
	  write (level,1000) (bef(i)(1:il(i)),i=1,ibef)
	  write (output_io,3000) level
	endif
c
1000	format(8(a,1x))
2000	format(' ----------- > ',A6,' online help ',25x,
     &	       'Version : ',a5,/)
3000	format(' ----------- > current help level : ',a40)
	end
c****7******************************************************************
	subroutine do_help_single(ihl,bef,ibef,maxw,found,fast)
c-
c	This routine emulates the VMS help function itself
c-
	implicit         none
c
	include         'envir.inc'
	include         'prompt.inc'
	include         'errlist.inc'
c
	integer          nviele    
        parameter       (nviele=101)
c
	integer		 ihl,ibef,maxw
	character*(*)    bef(maxw)
c
        character*80     line
        character*12     viele(nviele)
	integer          lev,nl,nbef,ianz,laenge
        logical          found,fast
	real             werte
c
	integer          len_str
	logical	         str_comp
c
c------ Loop over all helpfile levels until entry is found
c
        do lev=1,ibef
5         continue
          found=.false.
          read(ihl,1000,end=10) line
c
	  if(line(1:1).eq.'!') then
	    line(1:1)=' '
	    line(2:2)=' '
	  endif
c
	  call do_cap(line)
          call hole_zahl(line(1:3),ianz,werte)
          if(ianz.eq.1) then
            nl=int(werte)
            if(nl.eq.lev) then
	      laenge = len_str(bef(lev))
	      found=str_comp(line(4:4+laenge-1),bef(lev),
     &	                     laenge,laenge,laenge)
              if (.not.found) goto 5
	    elseif(nl.gt.lev .or. nl.eq.0) then
	      goto 5
	    elseif(nl.lt.lev) then
              goto 10
            endif
          else
            goto 5
          endif
        enddo
c
c------ If entry is found, print text and get possible further
c------ subentries
c
10      continue
        nbef=0
        if(found) then
	  if(.not.fast) then
            call lese_text(ihl)
	  else
            read(ihl,1000,end=10) line
c
	    if(line(1:1).eq.'!') then
	      line(1:1)=' '
	      line(2:2)=' '
	    endif
c
	  endif
          call weitere(ihl,ibef+1,viele,nviele,nbef)
          call schreib_viele(viele,nviele,nbef)
	  write (output_io,*) ' '
        else
	  ier_typ = ER_IO
	  ier_num = -5
          ier_num = -5
	  call errlist
	  ier_num = 0
	  ier_typ = ER_NONE
        endif
c
c------	Mark whether subentries were found
c
	found = nbef.gt.0
c
1000    format(a)
        end
c*****7*****************************************************************
        subroutine hole_zahl(zeile,ianz,werte)
c+
c	Gets numbers from command line and number of values of input.
c-
	implicit	none
c
        character*(*) 	zeile
	integer       	ianz
	real          	werte
c
        werte=0.0
        ianz=0
        read(zeile,*,end=98,err=98) werte
        ianz=1
        return
98      continue
        ianz=0
        end
c*****7*****************************************************************
        subroutine do_trenn(ein,bef,ibef,length,maxw)
c+
c	Separates the character string into single words
c-
	implicit         none
c
	integer		 maxw,ibef
        character*(*)    ein,bef(maxw)
	integer          ib,i,ianf,iend,length
        logical          lchar
c
        ib=1
        do i=1,10
          lchar=.true.
          call locate(lchar,ein,ib,ianf,length)
          if(ianf.gt.length) goto 20
          lchar=.false.
          ib=ianf
          call locate(lchar,ein,ib,iend,length)
          bef(i)=ein(ianf:iend-1)
          ib=iend
        enddo
20      continue
        ibef=i-1
        end
c*****7*****************************************************************
        subroutine locate(lchar,ein,ib,ianf,length)
c
	implicit         none
c
        character*(*)    ein
	integer          ianf,length,i,ib
        logical          lchar
c
        ianf   = length + 1
C
        do i=ib,length
          if(lchar .and. ein(i:i).ne.' ' .and. ein(i:i).ne.',') then
            ianf=i
            goto 20
          elseif(.not.lchar .and. (ein(i:i).eq.' ' .OR.
     &	                           ein(i:i).eq.','      )) then
            ianf=i
            goto 20
          endif
        enddo
20      continue
        end
c*****7*****************************************************************
        subroutine lese_text(ihl)
C
	implicit         none
c
	include         'envir.inc'
	include         'prompt.inc'
c
        character*80    line
	character*1     cdummy
	integer         ihl,ilc
c
	integer		len_str
C
10	continue
	  do ilc=1,lines-2
            read(ihl,1000,end=9010) line
c
	    if(line(1:1).eq.'!') then
	      line(1:1)=' '
	      line(2:2)=' '
	    endif
c
            if(line(1:1).ne.' ') then
              goto 20
	    else
              write (output_io,1000) line(1:len_str(line))
            endif
	  enddo
	  write (output_io,2000)
	  if (output_io.eq.6) read (*,1000) cdummy
	goto 10
20      continue
C
9010    continue
1000    format(a)
2000	format(/,' ----------- > Press <RETURN> for next page ')
        end
c*****7*****************************************************************
        subroutine weitere(ihl,nl,viele,nviele,nbef)
c
	implicit         none
c
	integer        nviele
        character*(*)  viele(nviele)
        character*80   line
	integer        ihl,nl,nbef,ianz
	real           werte
C
        nbef=0
        backspace(ihl)
30      continue
	  read(ihl,1000,end=9010) line
	  do while(line(1:1).eq.' ') 
            read(ihl,1000,end=9010) line
	  enddo
          call hole_zahl(line,ianz,werte)
	  if(ianz.eq.1) then
            if(int(werte).eq.nl) then
              nbef=nbef+1
              viele(nbef)=line(4:15)
            elseif(int(werte).lt.nl) then
              return
            endif
          endif
          goto 30
9010    continue
1000    format(a)
        end
c*****7*****************************************************************
        subroutine schreib_viele(viele,nviele,nbef)
c
	implicit         none
c
	include		'prompt.inc'
c
	integer          nviele
        character*(*)    viele(nviele)
	integer          nbef,i
c
        write (output_io,1000) (viele(i),i=1,nbef)
c
1000    format(5(3x,a12))
        end
