c*****7****************************************************************
	subroutine file_kdo (line,i)
c-
c	Opens a new macro file. 
c+
	implicit        none
c
	include        'errlist.inc'
	include        'envir.inc'
	include        'macro.inc'
	include        'prompt.inc'
c
	integer         maxw
	parameter      (maxw=MAC_MAX_PARA+1)
c
	character*(*)	line
	character*200   filename,string,cpara(maxw)
c
	integer         lpara(maxw)
	integer         ip,ianz,i
	logical         fileda
	real            werte(maxw)
c
c------	If there is place for another macro
c
	if(mac_level .lt. MAC_MAX_LEVEL) then
c
c------	--Get filename from command line and string for parameters
c
	  string = line
	  ip     = index(string,' ')
	  string(ip:ip) = ','
	  call get_params(string,ianz,cpara,lpara,maxw,i)
c
c------	--Try to build filename
c
	  call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	  if(ier_num.eq.0) then
c
c------	  Try to open the macro file
c
	  if(ip.gt.1) then 
c
c-----      Try local directory with appended '.mac'
c
	    filename=cpara(1)(1:lpara(1))//'.mac'
	    inquire (file=filename,exist=fileda)
c
c-----      Try local directory 
c
	    if(.not.fileda) then
	      filename=cpara(1)(1:lpara(1))
	      inquire (file=filename,exist=fileda) 
	    endif
c
c-----      Try users system directory with appended '.mac'
c
	    if(.not.fileda) then
	      filename=umac_dir(1:umac_dir_l)//
     &                 cpara(1)(1:lpara(1))//'.mac'
	      inquire (file=filename,exist=fileda) 
	    endif
c
c-----      Try users system directory
c
	    if(.not.fileda) then
	      filename=umac_dir(1:umac_dir_l)//cpara(1)(1:lpara(1))
	      inquire (file=filename,exist=fileda) 
	    endif
c
c-----      Try system directory with appended '.mac'
c
	    if(.not.fileda) then
	      filename=mac_dir(1:mac_dir_l)//
     &                 cpara(1)(1:lpara(1))//'.mac'
	      inquire (file=filename,exist=fileda) 
	    endif
c
c-----      Try system directory
c
	    if(.not.fileda) then
	      filename=mac_dir(1:mac_dir_l)//cpara(1)(1:lpara(1))
	      inquire (file=filename,exist=fileda) 
	    endif
c
	    if (fileda) then
c
c------	  File could be opened., append to maco-file listing
c
	      mac_level           = mac_level + 1
	      mac_name(mac_level) = filename
	      mac_line(mac_level) = 0
c
c------	----Try to get parameters
c
	      if(ip+1.le.i) then
	        if(ianz.ge.2) then
	          if(ianz-1.le.MAC_MAX_PARA) then
c
c------	----------Copy parameters to macro parameter list.
c
	            do i=2,ianz
	              mac_para(i-1,mac_level) = cpara(i)
	              mac_leng(i-1,mac_level) = lpara(i)
	            enddo
	            mac_n_par(mac_level) = ianz - 1
	            write(mac_para (0,mac_level),1000) ianz-1
	            mac_leng (0,mac_level) = 4
	          else
	            ier_num = -1
	            ier_typ = ER_MAC
	          endif
	        endif
	      else
	        mac_n_par(mac_level)   = 0
	        mac_para (0,mac_level) = '0'
	        mac_leng (0,mac_level) = 1
	      endif
c
c------	  --if macro file is already active, or currently debugged,
c	    close current file
c
	      i = max(1,mac_level-1)
	      if(lmakro .or. lmacro_dbg(i)) then
	        close(19)
	      endif
c
	      lmakro=.true.
	      prompt='macro  '
	      open(unit=19,file=filename,status='old') 
	    else
C------	  MAKRO nicht gefunden
	      ier_num = -12
	      ier_typ = ER_MAC
	    ENDIF 
	  ELSE
C------	  ungueltiges MAKRO
	    ier_num = -13
	    ier_typ = ER_MAC
	  ENDIF
	  endif
	else
c------	Too many macro levels
	  ier_num = -35
	  ier_typ = ER_MAC
	endif
C
	IF(ier_num.NE.0) THEN
	  CALL ERRLIST
	  ier_num = -11
	  ier_typ = ER_COMM
	ENDIF
C
1000	format(i4)
c
	END
c*****7*****************************************************************
	subroutine macro_read(line,laenge)
c-
c	Reads a single line from the current macro file
c+
	implicit        none
c
	include        'charact.inc'
	include        'doact.inc'
	include        'errlist.inc'
	include        'macro.inc'
	include        'prompt.inc'
c
	character*(*)   line
c
	character*1     cdummy
	character*200   zeile
	integer         ndol
	integer         lpar
	integer         n_par
	integer         laenge
	integer         lx,nx,x,lll
	integer         i,il
	logical         lnum
c
	integer         len_str
	logical         str_comp
c
	ier_num               = 0
	ier_typ               = ER_NONE
	mac_line(mac_level)   = mac_line(mac_level) + 1
	read (19,1000,end=20)   line
	laenge                = len_str(line)
c
	if(line(1:1).ne.'#' .and. line(1:1).ne.'!' .and.
     &	   Laenge.ne.0                                   ) then
c
c------	If inside a macro, check for parameter substitution
c
	zeile = line
	ndol   = index(zeile(1:laenge),'$')
	if(ndol.gt.laenge) then
	  ndol = 0
	endif
c
c------	Replace all '$'-parameters
c
	dowhile(ndol.ne.0)
c
c------	--Determine length of the numerical parameter string i.e.: '1', '12' 
c
	  lx   = 0
	  nx   = ndol + lx +1
	  x    = ichar(zeile(nx:nx))
	  lnum = zero.le.x .and. x.le.nine
	  dowhile(lnum .and. nx.lt.laenge)
	    lx = lx + 1
	    nx = ndol + lx +1
	    x    = ichar(zeile(nx:nx))
	    lnum = zero.le.x .and. x.le.nine
	  enddo
	  if(nx.lt.laenge) then
	    nx = nx - 1
	  elseif(nx.eq.laenge .and. .not.lnum) then
	    nx = nx - 1
	  endif
c
c------	--Read parameter number and substitute rest of string
c
	  read(zeile(ndol+1:nx),*) n_par
	  if(n_par.le.mac_n_par(mac_level)) then
	    lpar = mac_leng(n_par,mac_level)
	    line = ' '
	    if(ndol.gt.1) then
	      line(1:ndol-1) = zeile(1:ndol-1)
	    endif
c
	    line(ndol:ndol+lpar-1) = 
     &	             mac_para(n_par,mac_level)(1:lpar)
	    lll  = ndol+lpar-1
	    if(nx.lt.laenge) then
	      line(ndol+lpar:ndol+lpar+laenge-nx) =
     &	        zeile(nx+1:laenge)
	      lll = lll + laenge - nx
	    endif
	    zeile = ' '
	    zeile = line
	    laenge   = lll
	    ndol     = index(zeile(1:laenge),'$')
	    if(ndol.gt.laenge) then
	      ndol = 0
	    endif
	  else
	    il = len_str(line)
	    write (output_io,1000) line(1:il)
	    ier_num = -41
	    ier_typ = ER_MAC
	    return
	  endif
	enddo
	endif
c
c------	line read, return to calling routine
c
	il = len_str(line)
	if(prompt_status.ne.PROMPT_OFF) then
	  if (il.gt.0) then
	    write (output_io,1000) line(1:il)
	  else
	    write (output_io,1000) ' '
	  endif
	endif
c
c------	Check for 'stop' command, unless we are reading a block structure
c
	if(str_comp(line,'stop',4,il,4) .and. .not.lblock_read) then
	  write (*,2000) char(7)
	  lmakro = .false.
	  lmacro_dbg(mac_level) = .true.
	  line   = '#'
	  il     = 1
	endif
	  
	return
c
c	End of macro file, if nested macro file go back to previous
c	else set lmakro to .false.
c
20	continue
	if(prompt_status.ne.PROMPT_OFF) then
	  write (output_io,1000) ' '
	endif
c
	close (19)
	mac_line(mac_level)   = 0
	mac_name(mac_level)   = ' '
	lmacro_dbg(mac_level) = .false.
	mac_level             = mac_level - 1
c
	if(mac_level.gt.0) then
	  OPEN(UNIT=19,FILE=mac_name(mac_level),STATUS='OLD') 
	  do i=1,mac_line(mac_level)
	    read(19,1000,end=30) cdummy
	  enddo
c
c------	--This level has been stopped
c
	  if(lmacro_dbg(mac_level)) then
	    lmakro = .false.
	    line   = '#'
	    il     = 1
	  endif
	else
c
c------	--This was the last macro, reset macro status and return 
c	  program prompt
c
	  call macro_close
	endif
c
	line   = '#'
	laenge = 1
c
	return
c
30	continue
c
c------	unexpected EOF in previous macro file
c
	line      = '#'
	laenge    = 1
	call macro_close
	ier_num   = -36
	ier_typ   = ER_MAC
c
c
1000	format (a)
2000	format (' ------ > Macro halted, continue with cont ...',a1) 
	end
c*****7*****************************************************************
	subroutine macro_close
c-
c	Closes the macro file, switches macro status off and sets the
c	macro level back to zero.
c+
	implicit        none
c
	include        'macro.inc'
	include        'prompt.inc'
c
	integer         i
c
	close(19)
	lmakro     = .false.
	prompt     = pname
	mac_level  = 0
	do i=1,MAC_MAX_LEVEL
	  mac_line(i)   = 0
	  mac_name(i)   = ' '
	  lmacro_dbg(i) = .false.
	enddo	
c
	end
c*****7*****************************************************************
	subroutine macro_continue(zeile,lcomm)
c-
c	Continues the macro file, that had been interupted for
c	debugging purposes
c+
	implicit        none
c
	include        'doact.inc'
	include        'errlist.inc'
	include        'macro.inc'
	include        'prompt.inc'
c
	integer         maxw
	parameter      (maxw=1)
	character*200   zeile
	character*200   cpara(maxw)
	integer         lpara(maxw)
	integer         ianz,lcomm
c
	logical         str_comp
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lcomm)
c
c------	--No parameter for macro or block structures
c
	if(ianz. eq. 0) then
c
c------	--Only active inside macro's stopped by a previous 'stop' command
c
	  if(mac_level.gt.0) then
	    lmakro    = .true.
	    prompt    = 'macro '
	    lmacro_dbg(mac_level) = .false.
	  endif
c
c------	Only active inside macro's stopped by a previous 'stop' command
c
	  if(lblock_dbg) then
	    lblock_dbg = .false.
	    lblock     = .true.
	  endif
c
c------	--One parameter and '<pname>' command
c
	elseif(ianz.eq.1) then
	  if(str_comp(cpara(1),pname,3,lpara(1),6)) then
	    call macro_close
	    lblock_dbg = .false.
	    lblock     = .false.
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
