c*****7*****************************************************************
c
c	This file contains several subroutines for command language
c	handling and other common support routines.
c
c	Version : 2.1
c	Date    : 18 April 2001
c
c	Authors : R.B. Neder  (reinhard.neder@mail.uni-wuerzburg.de)
c                 Th. Proffen (proffen@pa.msu.edu)
c
c*****7*****************************************************************
	subroutine cmdline_args
c
c	This routine checks for command line arguments and 
c	executes given macros ..
c
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'errlist.inc'
c
	integer		marg
	parameter	(marg=10)
c
	character*200	arg(marg)
	integer		iarg,i,ilen
	integer		len_str
c
	call do_getargs(iarg,arg,marg)
	if (iarg.gt.0) then
	  do i=1,iarg
	    ilen=len_str(arg(i))
	    write(*,1000) arg(i)(1:ilen)
	    call file_kdo(arg(i)(1:ilen),ilen)
	  enddo
	endif
c
1000	format (' ------ > Reading macro ',a)
	end
c*****7*****************************************************************
	subroutine kdo_all(bef,lbef,zei,lc)
c
c	This part contains all the program independent commands.
c
	implicit     none
c
	include      'config.inc'
	include      'learn.inc'
	include      'prompt.inc'
	include      'errlist.inc'
c
	character*(*) zei,bef
	character*200 command
	integer       lc,lbef
c
	logical       str_comp
c
c------	change working directory
c
	if(str_comp(bef,'cd',2,lbef,2)) then
	  call do_chdir(zei,lc)
c
c------	continues a macro 'continue'
c
	elseif(str_comp(bef,'continue',2,lbef,8)) then
	  call macro_continue(zei,lc)
c
c------ Echo a string, just for interactive check in a macro 'echo'
c
	elseif(str_comp(bef,'echo',2,lbef,4)) then
	  call echo (zei,lc)
c
c------	Evaluate an expression, just for interactive check 'eval'
c
	elseif(str_comp(bef,'eval',2,lbef,4)) then
	  call do_eval(zei,lc)
c
c------ IO commands
c
	elseif(str_comp(bef,'fopen',2,lbef,5)) then
	  call do_fopen(zei,lc)
	elseif(str_comp(bef,'fclose',2,lbef,6)) then
	  call do_fclose(zei,lc) 
	elseif(str_comp(bef,'fend',2,lbef,6)) then
	  call do_fend(zei,lc)
	elseif(str_comp(bef,'fexist',2,lbef,6)) then
	  call do_fexist(zei,lc) 
	elseif(str_comp(bef,'fget',2,lbef,4)) then
	  call do_fget(zei,lc)
	elseif(str_comp(bef,'fput',2,lbef,4)) then
	  call do_fput(zei,lc)
	elseif(str_comp(bef,'fsub',2,lbef,4)) then
	  call do_fgetsub(zei,lc)
	elseif(str_comp(bef,'fformat',2,lbef,7)) then
	  call do_fformat(zei,lc)
c
c------ Online help
c
	elseif(str_comp(bef,'help',2,lbef,4) .or.
     &	       str_comp(bef,'?   ',1,lbef,4)     ) then
	  lc = lc + 7
	  write(command,1000) pname,zei
1000	  format(a6,1x,a)
          call do_hel(command,lc)
c
c------ start learning a macro 'learn'
c
	elseif(str_comp(bef,'lear',3,lbef,4)) then
	  call start_learn(zei,lc)
c
c------ end learning a macro 'lend'
c
	elseif(str_comp(bef,'lend',3,lbef,4)) then
	  call ende_learn	  
c
c------ Various settings 'set'
c
	elseif(str_comp(bef,'set',3,lbef,3)) then
	  call do_set(zei,lc)
c
c------ Operating System Kommandos 'syst'
c
	elseif(str_comp(bef,'syst',2,lbef,4)) then
	  command=' '
	  if(zei.ne. ' ') then
	    command(1:lc)=zei(1:lc)
	    call do_operating(command,lc)
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c------ Wait for user input 'wait'
c
	elseif(str_comp(bef,'wait',3,lbef,4)) then
	  call do_input(zei,lc)
c
c------ Unknown command
c
	else
	  ier_num = -8
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine do_cap (str)
c+
c 	Converts string 'str' to upper letters
c-
	implicit      none
c
	character*(*) str
	integer       i
	integer       len
C
        do i=1,len(str)
	  if (ichar(str(i:i)).ge.ichar('a') .and. 
     &	      ichar(str(i:i)).le.ichar('z'))      then 
	    str(i:i) = char (ichar(str(i:i))-ichar('a')+ichar('A'))
	  endif
	enddo
	end		
C*****7***********************************************************
	subroutine ini_ran(iflag)
c
	implicit      none
c
	include      'random.inc'
c
	integer          iflag
	real             seknds
c
	if(iflag.ge.0) then
	  idum=  -seknds(0.0)
	else
	  idum = iflag
	endif
	iset = 0
	end
c*****7***********************************************************
	subroutine get_command (line,ll,befehl,lbef,zeile,lp,prom)
c+
c	This subroutine gets a command for processing. If it
c	is keyboard input and the program was compiled with
c	READLINE defined, you will have basic line editing
c	functions.
c-
	implicit	none
c
	include		'macro.inc'
	include		'doact.inc'
	include		'learn.inc'
	include		'errlist.inc'
	include		'prompt.inc'
c
	character*(*)	line,befehl,zeile,prom
	character*200	input
	character*30	bprom
	character*1	TAB
	integer		lbef,lpr,lp,ll,indxb
	integer         il,jl,lll
	logical		lreg
	logical         str_comp
c
	integer		len_str
c
	input  = ' '
	line   = ' '
	zeile  = ' '
	befehl = ' '
c
	ll   = 0
	lp   = 0
	lbef = 0
c
	TAB  = char(9)
c
	if(lblock) then
	  call do_execute(lreg,input,ll)
          if(ier_num.ne.0 .or. .not. lreg) return
	elseif(lmakro .and. .not.lblock_dbg) then
	  call do_prompt(prom)
	  call macro_read(input,ll)
          if(ier_num.ne.0) return
	else
c
c------	--Normal mode, if status is PROMPT_OFF or PROMPT_REDIRECT
c------ --we assume non interactive input and use 'normal' FORTRAN
c------ --READ to avoid EOF problems.
c
	  if(prompt_status.eq.PROMPT_ON .and. .not.first_input) then
	    lpr   = len_str(prom)
	    bprom = ' '//prom(1:lpr)//' > ' 
	    lpr   = len_str(bprom)+1
	    ll    = len(input)
c
c------	----call the c-routine that enables command history & line editing
c
	    call cread(bprom,lpr,input,ll)
	    if (ll.lt.0) then
	      call do_prompt(prom)
	      read(* ,2000,end=990,err=995) input
	    endif
c
c------ --otherwise use normal READ
c
	  else
	    call do_prompt(prom)
	    read(* ,2000,end=990,err=995) input
	    first_input = .FALSE.
	  endif
c
	  ll = len_str(input)
          if(prompt_status.eq.PROMPT_REDIRECT) then
            if(ll.gt.0) then
              write (output_io,2000) input(1:ll)
            else
              write (output_io,2000)
            endif
          endif
	endif
c
	if(ll.ne.0 .and. input(1:1).ne.'#') then
c
c------ - Remove leading blanks from 'line'
c
	  il    = 1
	  jl    = len_str(input)
	  do while ((input(il:il).eq.' ' .or.
     &	             input(il:il).eq.TAB).and. il.le.jl)
	    il = il+1
	  enddo
	  line = input(il:jl)
	  ll   = len_str(line)
c
c------	- The maximum number of significant characters depends on the 
c------	- length of the character constant befehl.
c
	  lbef   = len(befehl)
	  indxb  = index(line,' ')
	  lbef   = min(indxb-1,lbef)
	  befehl = line(1:lbef)
c
c------	- command parameters start at the first character following 
c------ - the blank
c
	  if(indxb+1 .le. ll) then
	    zeile = line(indxb+1:ll)
	    lp    = ll - indxb
	  endif
c
c------	- Learn command for learn sequence
c
	  if(llearn .and.
     &	     .not.str_comp(befehl,'lend' ,3,lbef,4) .and.
     &	     .not.str_comp(befehl,'mouse',3,lbef,5)      ) then
	    if(ll.gt. 0) then
	      write (33,2000) input(1:len_str(input))
	    else
	      write (33,2000)
	    endif
	  endif
	endif
c
c------	Normal return
c
	return
c
c------	EOF in input
c
990	continue
	line   = 'exit'
	ll     = 4
	befehl = 'exit'
	lbef   = 4
	zeile  = ' '
	lp     = 0
	return
c
c------	Error in input
c
995	continue
	ier_num = -9
	ier_typ = ER_IO
	return
c
2000	format (a)
	end
c*****7*****************************************************************
	subroutine do_operating(zeile,lp)
c-
c	writes an echo to the screen
c+
	implicit       none
c
	include        'prompt.inc'
	include        'errlist.inc'
c
	integer         maxp
	parameter      (maxp=12)
	character*200   zeile,string
	character*200   cpara(maxp)
        integer         lpara(maxp)
	integer         ianz
	integer         lp,i
	integer         iko,iqo,iqo2,lstring
	real            werte(maxp)
c
c------	Find any " which would mean that we need parameter substitution
c
	iqo = index(zeile(1:lp),'"')
	if(iqo.eq.0) then
c
c------	--None foud, harmless echo
c
	  call do_operating_comm(zeile(1:lp))
	else
c
c------	--Look for matching "
c
	  iqo2 = index(zeile(iqo+1:lp),'"')
	  if(iqo2.eq.0) then
	    ier_num = -44
	    ier_typ = ER_APPL
	    return
	  endif
c
c------	--save the string in quotation marks for later use as first parameter
c
	  iqo2 = iqo2 + iqo
	  iko  = index(zeile(iqo2+1:lp),',')
	  if(iko.ne.0) then
	    string = zeile(iqo2+iko+1:lp)
	    lstring = -( lp - iqo2 - iko )
	  else
	    string = ' '
	    lstring = 1
	  endif
c
c------	--get all other parameters
c
	  call get_params(string,ianz,cpara,lpara,maxp,lstring)
	  if(ier_num.eq.0) then
	    do i=ianz,1,-1
	      cpara(i+1) = cpara(i)
	      lpara(i+1) = lpara(i)
	    enddo
	    cpara(1) = zeile(1:iqo2)
	    lpara(1) = iqo2
	    ianz     = ianz + 1
	    call do_build_name(ianz,cpara,lpara,werte,maxp,1)
	    if(ier_num.eq.0) then
c
c------	------The first comma that follows the quotation marks must be
c	      omitted, all others retained as part of the echo
c
	      if(ianz.eq.1) then
	        string  = cpara(ianz)(1:lpara(ianz))
	        lstring = lpara(ianz)
	      elseif(ianz.eq.2) then
	        string  = cpara(1)(1:lpara(1))//
     &	                       cpara(ianz)(1:lpara(ianz))
	        lstring = lpara(1) + lpara(2)
	      else
	        string  = cpara(1)(1:lpara(1))
	        lstring = lpara(1)
	        do i=1,ianz
	          zeile   = string(1:lstring)//
     &	                    cpara(i)(1:lpara(i))
	          lstring = lstring + lpara(i)
	          string  = zeile
	        enddo
	      endif
	      call do_operating_comm(string)
	    endif
	  endif
	endif
c
2000	format(1x,21a)
2010	format(1x,  a)
c
	end
c*****7***********************************************************
	subroutine do_fopen(zeile,lp)
c
	implicit      none
c
	include      'errlist.inc'
	include      'prompt.inc'
	include      'macro.inc'
c
	integer       maxw
	parameter    (maxw=10)
c
	character*(*) zeile
	character*200 cpara(maxw)
	real          werte(maxw)
	integer       lpara(maxw),lp
	integer       ianz,ianzz
	integer		ii
	logical       lappend
	logical		one_open
c
	logical       str_comp
c
	ianzz = 1
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if ( ianz.ge.1) then
	  call ber_params(ianzz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  if(ianz.eq.1) then
	    ianz = 0
	  else
	    call del_params(1,ianz,cpara,lpara,maxw)
	  endif
	  if (ier_num.ne.0) return
	  ii = nint(werte(1))
	  if(ii.lt.0 .or. MAC_MAX_IO.lt.ii) then
	    ier_num = -13
	    ier_typ = ER_IO
	    return
	  endif
c
	  if (ianz.ge.1) then
	    if (io_open(ii)) then
	      ier_num = -10
	      ier_typ = ER_IO
	      return
	    endif
	    call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	    if (ianz.eq.2) then
	      lappend = str_comp(cpara(2),'append',1,lpara(2),6)
	    else
	      lappend = .false.
	    endif
	    if (lappend) then
	      open (unit=io_unit(ii),file=cpara(1),status='unknown',
     &	            access='append',err=999)
	      write (output_io,1000) cpara(1)(1:lpara(1))
	    else
	      open (unit=io_unit(ii),file=cpara(1),status='unknown',
     &	            err=999)    
	      write (output_io,1100) cpara(1)(1:lpara(1))
	    endif
	    io_open(ii) = .true.
	    io_file(ii) = cpara(1)(1:lpara(1))
	  else
	    if (io_open(ii)) then
	      write (output_io,2000) io_file(ii)
	    else
	      write (output_io,2010)
	    endif
	  endif
	else
	  one_open = .false.
	  do ii=1,MAC_MAX_IO
	    if (io_open(ii)) then
	      write (output_io,2000) ii,io_file(ii)
	      one_open = .true.
	    endif
	  enddo
	  if(.not.one_open) then
	    write (output_io,2010)
	  endif
	endif
	return
c
999	continue
	ier_num = -2
	ier_typ = ER_IO
c
1000	format (' ------ > File ',a,' opened (appending) ...')
1100	format (' ------ > File ',a,' opened (overwriting) ...')
2000	format (' ------ > IO stream Nr. ',i2,' open, file : ',a)
2010	format (' ------ > No IO stream open')
	end
c*****7***********************************************************
	subroutine do_fexist(zeile,lp)
c
	implicit      none
c
	include      'errlist.inc'
	include      'param.inc'
c
	integer       maxw
	parameter    (maxw=10)
c
	character*(*) zeile
	character*200 cpara(maxw)
	real          werte(maxw)
	integer       lpara(maxw),lp
	integer       ianz
	logical       lexist
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.ge.1) then
	  call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	  inquire(file=cpara(1)(1:lpara(1)),exist=lexist)
	  if (lexist) then
	    res_para(0) = 1
	    res_para(1) = 1
	    write(*,1000) cpara(1)(1:lpara(1))
	  else
	    res_para(0) = 1
	    res_para(1) = 0
	    write(*,1100) cpara(1)(1:lpara(1))
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
1000	format (' ------ > File ',a,' exists ...')
1100	format (' ------ > File ',a,' does NOT exist ...')
	end
c*****7***********************************************************
	subroutine do_fclose(zeile,lp)
c
	implicit      none
c
	include      'errlist.inc'
	include      'macro.inc'
c
	integer       maxw
	parameter    (maxw=25)
c
	character*(*) zeile
	character*200 cpara(maxw),line
	real          werte(maxw)
	integer       lpara(maxw),lp
	integer       ianz,ii
c
	logical		str_comp
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if(ianz.eq.1) then
	  if(str_comp(cpara(1),'all',2,lpara(1),3)) then
	    do ii=1,MAC_MAX_IO
	      if(io_open(ii) ) then
	        close(io_unit(ii))
	        io_open(ii) = .false.
	      endif
	    enddo
	  else
	    call ber_params(ianz,cpara,lpara,werte,maxw)
	    if (ier_num.ne.0) return
c
	    ii = nint(werte(1))
	    if(ii.lt.0 .or. MAC_MAX_IO.lt.ii) then
	      ier_num = -13
	      ier_typ = ER_IO
	      return
	    endif
	    if (io_open(ii)) then
	      close(io_unit(ii))
	      io_open(ii) = .false.
	    else
	      ier_num = -11
	      ier_typ = ER_IO
	    endif
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
	end
c*****7***********************************************************
	subroutine do_fend(zeile,lp)
c
	implicit      none
c
	include      'errlist.inc'
	include      'prompt.inc'
	include      'macro.inc'
c
	integer       maxw
	parameter    (maxw=10)
c
	character*(*) zeile
	character*200 cpara(maxw)
	real          werte(maxw)
	integer       lpara(maxw),lp
	integer       ianz,ianzz
	integer		ii
	logical       lappend
	logical		one_open
c
	logical       str_comp
c
	ianzz = 1
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if ( ianz.ge.1) then
	  call ber_params(ianzz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  if(ianz.eq.1) then
	    ianz = 0
	  else
	    call del_params(1,ianz,cpara,lpara,maxw)
	  endif
	  if (ier_num.ne.0) return
	  ii = nint(werte(1))
	  if(ii.lt.0 .or. MAC_MAX_IO.lt.ii) then
	    ier_num = -13
	    ier_typ = ER_IO
	    return
	  endif
c
	  if (ianz.ge.1) then
	    if(str_comp(cpara(1),'error',2,lpara(1),6)) then
	      io_eof(ii) = .false.
	    elseif(str_comp(cpara(1),'continue',2,lpara(1),8)) then
	      io_eof(ii) = .true.
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7***********************************************************
	subroutine do_fget(zeile,lp)
c
	implicit      none
c
	include      'errlist.inc'
	include      'macro.inc'
	include      'param.inc'
c
	integer       maxw
	parameter    (maxw=25)
c
	character*(*) zeile
	character*200 cpara(maxw),line,cstr,string
	real          werte(maxw)
	integer       lpara(maxw),lstr,lp
	integer       ianz,i,igl,ii,ianzz
	integer       ia,ie
c
	integer       len_str
c
	ianzz = 1
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	call ber_params(ianzz,cpara,lpara,werte,maxw)
	if (ier_num.ne.0) return
	if(ianz.eq.1) then
	  ianz = 0
	else
	  call del_params(1,ianz,cpara,lpara,maxw)
	endif
	ii = nint(werte(1))
	if(ii.lt.0 .or. MAC_MAX_IO.lt.ii) then
	  ier_num = -13
	  ier_typ = ER_IO
	  return
	endif
c
	if (.not. io_open(ii)) then
	  ier_num = -11
	  ier_typ = ER_IO
	  return
	endif
c
	if (ianz.gt.0) then
	  read(io_unit(ii),'(a)',err=998,end=999) string
	  lstr = len_str(string)
	  ia = max(1   ,io_get_sub(ii,1))
	  if(io_get_sub(ii,2).eq.-1) then
	    ie = lstr
	  else
	    ie = min(lstr,io_get_sub(ii,2))
	  endif
CDBG	write(*,*) ' ia,ie ',ia,ie
CDBG	write(*,'(a)') string(ia:ie)
CDBG	write(*,*) ' ianz ',ianz
	  read(string(ia:ie),*,err=998,end=999) (werte(i),i=1,ianz)
	  res_para(0) = 0
	  do i=1,ianz
	    write(cstr,*) werte(i)
	    lstr = len_str(cstr)
	    line = cpara(i)(1:lpara(i))//'='//cstr(1:lstr)
	    lp   = len_str(line)
	    igl  = index(line,'=')
	    call do_math(line,igl,lp)
CDBG
CDBG	write(*,*) ' ier_num ', ier_num
	    if (ier_num.ne.0) return
	  enddo
	else
	  read(io_unit(ii),*,err=998,end=999)
	  res_para(0) = 0
	endif
c
	return
c
998	continue
	ier_num = -3
	ier_typ = ER_IO
	return
c
999	continue
	if(io_eof(ii)) then
	  res_para(0) = -1
	else
	  ier_num = -6
	  ier_typ = ER_IO
	endif
	return
c
	end
c*****7***********************************************************
	subroutine do_fformat(zeile,lp)
c
	implicit      none
c
	include      'errlist.inc'
	include      'macro.inc'
	include      'debug.inc'
c
	integer       maxw
	parameter    (maxw=2)
c
	character*(*) zeile
	character*200 cpara(maxw)
	integer       lpara(maxw),lp
	integer       ii,iii,ianz
	real	      werte(maxw)
c
	integer       len_str
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  write (*,1000)
	  do ii = 1,MAC_MAX_FORM,6
	    write (*,1100) (ii+iii,iii=0,min(5,MAC_MAX_FORM-ii))
	    write (*,1200) (io_out_format(ii+iii)
     &	          (2:min(len_str(io_out_format(ii+iii))-1,8)),
     &	                           iii=0,min(5,MAC_MAX_FORM-ii))
	  enddo
	elseif (ianz.eq.2) then
	  call ber_params(1,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  ii = nint(werte(1))
	  if (ii.gt.0 .and. ii.le.MAC_MAX_FORM) then
	    io_out_format(ii)='('//cpara(2)(1:lpara(2))//')'
	  else
	    ier_num = -7
	    ier_typ = ER_APPL
	  endif 
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
1000	format (' Current format setting for file output :',/)
1100	format ('   Column : ',6(i8,2x))
1200	format ('   Format : ',6(a8,2x),/)
	end
c*****7***********************************************************
	subroutine do_fgetsub(zeile,lp)
c
	implicit      none
c
	include      'errlist.inc'
	include      'macro.inc'
	include      'debug.inc'
c
	integer       maxw
	parameter    (maxw=2)
c
	character*(*) zeile
	character*200 cpara(maxw)
	integer       lpara(maxw),lp
	integer       ii,iii,ianz
	real	      werte(maxw)
c
	integer       len_str
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
#
	if(ianz.eq.1) then
	  ianz = 0
	else
	  call del_params(1,ianz,cpara,lpara,maxw)
	endif
	ii = nint(werte(1))
	if(ii.lt.0 .or. MAC_MAX_IO.lt.ii) then
	  ier_num = -13
	  ier_typ = ER_IO
	  return
	endif
c
	if (ianz.eq.0) then
	  io_get_sub(ii,1)=1
	  io_get_sub(ii,2)=-1
	elseif (ianz.eq.2) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  io_get_sub(ii,1)=nint(werte(1))
	  io_get_sub(ii,2)=nint(werte(2))
	  if(io_get_sub(ii,2).ne.-1 .and. 
     &	     io_get_sub(ii,1).gt.io_get_sub(ii,2)) then
	    ier_num = -13
	    ier_typ = ER_IO
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
CDBG
CDBG	write(*,*) 'cpara      ',cpara
CDBG	write(*,*) 'werte      ',werte
CDBG	write(*,*) 'io_get_sub ',io_get_sub
c
	end
c*****7***********************************************************
	subroutine do_fput(zeile,lp)
c
	implicit      none
c
	include      'errlist.inc'
	include      'macro.inc'
	include      'debug.inc'
c
	integer       maxw
	parameter    (maxw=MAC_MAX_FORM)
c
	character*(*) zeile
	character*200 cpara(maxw),cstr,line
	character*1   quote
	real          wert
	integer       lpara(maxw),lp
	integer       ianz,lstr,i,ie,ianzz,ii
	real          werte(maxw)
c
	integer       len_str
	real          berechne
c
	quote=char(39)
	ianzz = 1
c
	call get_params(zeile,ianz,cpara,lpara,maxw,-lp)
	if (ier_num.ne.0) return
c
	call ber_params(ianzz,cpara,lpara,werte,maxw)
	if (ier_num.ne.0) return
	if(ianz.eq.1) then
	  ianz = 0
	else
	  call del_params(1,ianz,cpara,lpara,maxw)
	endif
	ii = nint(werte(1))
	if(ii.lt.0 .or. MAC_MAX_IO.lt.ii) then
	  ier_num = -13
	  ier_typ = ER_IO
	  return
	endif
c
	if (.not. io_open(ii)) then
	  ier_num = -11
	  ier_typ = ER_IO
	  return
	endif
c
	if (ianz.ge.1) then
	  ie = 0
	  do i=1,ianz
	    if (index(cpara(i)(1:lpara(i)),quote).ne.0) then
	      line(ie+1:ie+lpara(i)-2)=cpara(i)(2:lpara(i)-1)
	      ie = ie+lpara(i)-2
	    else
	      cstr = '('//cpara(i)(1:lpara(i))//')'
	      lstr = lpara(i)+2
	      wert = berechne(cstr,lstr)
	      if (ier_num.ne.0) return
	      if (io_out_format(i).eq.'(*)') then
	        write (cstr,*,err=999) wert
	      else
	        if (index(io_out_format(i),'i').ne.0 .or.
     &	            index(io_out_format(i),'I').ne.0     ) then
	          write (cstr,io_out_format(i),err=999) nint(wert)
	        else
	          write (cstr,io_out_format(i),err=999) wert
	        endif
	      endif
	      lstr = len_str(cstr)
	      line(ie+1:ie+lstr)=cstr(1:lstr)
	      ie = ie+lstr
	    endif
	  enddo
	  write(io_unit(ii),9999,err=999) line(1:ie)
	  if (dbg) write (*,1000) line(1:ie)
	else
	  write(io_unit(ii),*,err=999)
	endif
	return
c
999	ier_num = -12
	ier_typ = ER_IO
	return
c
1000	format( ' debug  > Written: ',a)
9999	format(a)
	end
c*****7***********************************************************
	subroutine do_input(zeile,lp)
c
	implicit      none
c
	include      'errlist.inc'
	include      'param.inc'
c
	integer       maxw
	parameter    (maxw=12)
c
	character*(*) zeile
	character*200 cpara(maxw)
	character*200 line
	character*1   cdummy
	real          werte(maxw)
	integer       i
	integer       lpara(maxw),lp
	integer       ianz
	integer       len_str
	logical       str_comp
c
	lp = -lp
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if(ier_num.ne.0) return
c
	if(ianz.eq.0) then
	  write (*,1000)
	  read  (*,5000,err=50,end=50) cdummy
	elseif(ianz.eq.1 .or. ianz.eq.2) then
	  if(str_comp(cpara(1),'return',1,lpara(1),6)) then
	    write (*,1000)
	    read  (*,5000,err=50,end=50) cdummy
	  elseif(str_comp(cpara(1),'input',1,lpara(1),5)) then
	    if(ianz.eq.1) then
	      write (*,1500)
	    elseif(ianz.eq.2) then
	      write (*,1600) cpara(2)(1:lpara(2))
	    endif
	    read  (*,5000,err=50,end=50) line
	    lp = len_str(line)
	    call get_params(line,ianz,cpara,lpara,maxw,lp)
	    if(ier_num.eq.0) then
	      if(ianz.le.maxw) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          res_para(0)=float(ianz)
	          do i=1,ianz
	            res_para(i)=werte(i)
	          enddo
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
	return
c
50	continue
	ier_num = -9
	ier_typ = ER_IO
c
1000	format (' ------ > Waiting for <RETURN> : ',$)
1500	format (' ------ > Waiting for input : ',$)
1600	format (a,' ',$)
5000	format (a)
	end
C*****7***********************************************************
	subroutine do_seed(zeile,lp)
c
	implicit      none
c
	include      'errlist.inc'
c
	integer       maxw
	parameter    (maxw=1)
c
	character*(*) zeile
	character*200 cpara(maxw)
	integer       lpara(maxw),lp
	integer       ianz,iflag
	real          werte(maxw)
c
	if(zeile.ne. ' ') then
	  call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	  if(ier_num.eq.0) then
	    if(ianz.eq.1) then
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if(ier_num.eq.0) then
	        iflag = -iabs(nint(werte(1)))
	        call ini_ran(iflag)
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
	else
	  call ini_ran(0)
	endif
	end
c*****7***********************************************************
	subroutine do_prompt(prom)
c*
c	This routine prints the prompt on the screen
c-
	implicit      none
c
	include      'prompt.inc'
c
	character*(*)   prom
c
	if(prompt_status.eq.PROMPT_ON       .or.
     &	   prompt_status.eq.PROMPT_REDIRECT      ) then
	  write (output_io,'(1X,A,'' > '',$)') prom
	endif
c
	end
C*****7***********************************************************
	logical function str_comp(a,b,j,la,lb)
c-
c	compares the first non blank characters of the two strings 
c	for equality. At least j characters must be identical.
c+
	implicit      none
c
	character*(*) a,b
	integer       i,j,la,lb,ia,ib
c
	ia = min(index(a,' '),la)
	ib = min(index(b,' '),lb)
	if(ia.eq.0) then
	  ia = la
	endif
	if(ib.eq.0) then
	  ib = lb
	endif
	i = min(ia,ib)
	i = max(i,j)
	str_comp = a(1:i).eq.b(1:i)
c
	end
C*****7***********************************************************
	subroutine do_set(zeile,lp)
c-
c	Sets the value of status variables
c+
	implicit      none
c
	include      'errlist.inc'
	include      'debug.inc'
	include      'envir.inc'
	include      'prompt.inc'
c
	integer       maxw
	parameter    (maxw=5)
c
	character*(*) zeile
	character*200 cpara(maxw)
	character*80  logfile
	real          werte(maxw)
	integer       lpara(maxw),lp
	integer       ianz
	logical       llog
c
	logical       str_comp
	integer       len_str
c
	if(zeile.ne. ' ') then
	  call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	  if(ier_num.eq.0) then
c
c----- ---- set error
c
	    if(str_comp(cpara(1),'error',1,lpara(1),5)) then
	      if(ianz.eq.2) then
	        if(str_comp(cpara(2),'cont',2,lpara(2),4)) then
	          ier_sta = ER_S_CONT
	        elseif(str_comp(cpara(2),'exit',2,lpara(2),4)) then
	          ier_sta = ER_S_EXIT
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c----- ---- set prompt
c
	    elseif(str_comp(cpara(1),'prompt',1,lpara(1),6)) then
	      if(ianz.ge.2) then
c
c------ ------- Third+1  optional parameter: save previous setting
c
	        if (ianz.eq.4) then
	          prompt_status_old = prompt_status
	          output_status_old = output_status
	        endif
c
c------ ------- First+1 parameter PROMPT
c
	        if(str_comp(cpara(2),'on',2,lpara(2),2)) then
	          prompt_status = PROMPT_ON
c
	        elseif(str_comp(cpara(2),'off',2,lpara(2),2)) then
	          prompt_status = PROMPT_OFF
c
	        elseif(str_comp(cpara(2),'redirect',1,lpara(2),8)) then
	          prompt_status = PROMPT_REDIRECT
c
	        elseif(str_comp(cpara(2),'old',1,lpara(2),3)) then
	          if (output_status.ne.OUTPUT_SCREEN) then
	            close(output_io)
	          endif
	          output_status = output_status_old
	          prompt_status = prompt_status_old
	          if (output_status.eq.OUTPUT_SCREEN) then
	            output_io = 6
	          elseif (output_status.eq.OUTPUT_NONE) then
	            output_io     = 37
	            open(unit=output_io,file=nullfile,status='unknown')
	          elseif (output_status.eq.OUTPUT_FILE) then
	            output_io     = 37
	            logfile       = pname(1:len_str(pname))//'.log'
	            inquire(file=logfile,exist=llog)
	            if (llog) then
	              open(unit=output_io,file=logfile,
     &	                   status='old',access='append')
	            else
	              open(unit=output_io,file=logfile,status='new')
	            endif 
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
c
c------ ------- Second+1 optional parameter general output
c
	        if (ianz.ge.3) then
	          if(str_comp(cpara(3),'on',2,lpara(3),2)) then
	            if (output_status.ne.OUTPUT_SCREEN) then
	              close(output_io)
	            endif
	            output_status = OUTPUT_SCREEN
	            output_io     = 6
c
	          elseif(str_comp(cpara(3),'off',2,lpara(3),3)) then
	            if (output_status.ne.OUTPUT_SCREEN) then
	              close(output_io)
	            endif
	            output_status = OUTPUT_NONE
	            output_io     = 37
	            open(unit=output_io,file=nullfile,status='unknown')
c
	          elseif(str_comp(cpara(3),'file',2,lpara(3),4)) then
	            if (output_status.ne.OUTPUT_SCREEN) then
	              close(output_io)
	            endif
	            output_status = OUTPUT_FILE
	            output_io     = 37
	            logfile       = pname(1:len_str(pname))//'.log'
	            inquire(file=logfile,exist=llog)
	            if (llog) then
	              open(unit=output_io,file=logfile,
     &	                   status='old',access='append')
	            else
	              open(unit=output_io,file=logfile,status='new')
	            endif
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        endif
	        write(output_io,*)
c
	        if (dbg) then
	          write(*,5000) prompt_status,prompt_status_old
	          write(*,5010) output_status,output_status_old
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c----- ---- set debug
c
	    elseif(str_comp(cpara(1),'debug',2,lpara(1),5)) then
	      if(ianz.eq.2) then
	        dbg = (cpara(2)(1:2).eq.'on')
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
2000	format(a)
5000	format(' debug  > Prompt (current, old) : ',2I3)
5010	format(' debug  > Output (current, old) : ',2I3)
c
	end
c*****7*****************************************************************
	subroutine echo(zeile,lp)
c-
c	writes an echo to the screen
c+
	implicit       none
c
	include        'prompt.inc'
	include        'errlist.inc'
c
	integer         maxp
	parameter      (maxp=12)
	character*200   zeile,string
	character*200   cpara(maxp)
        integer         lpara(maxp)
	integer         ianz
	integer         lp,i
	integer         iko,iqo,iqo2,lstring
	real            werte(maxp)
c
c------	Find any " which would mean that we need parameter substitution
c
	iqo = index(zeile(1:lp),'"')
	if(iqo.eq.0) then
c
c------	--None foud, harmless echo
c
	  write (*,2010) zeile(1:lp)
	  if (output_status.eq.OUTPUT_FILE) then
	    write(output_io,2010) zeile(1:lp)
	  endif
	else
c
c------	--Look for matching "
c
	  iqo2 = index(zeile(iqo+1:lp),'"')
	  if(iqo2.eq.0) then
	    ier_num = -44
	    ier_typ = ER_APPL
	    return
	  endif
c
c------	--save the string in quotation marks for later use as first parameter
c
	  iqo2 = iqo2 + iqo
	  iko  = index(zeile(iqo2+1:lp),',')
	  if(iko.ne.0) then
	    string = zeile(iqo2+iko+1:lp)
	    lstring = -( lp - iqo2 - iko )
	  else
	    string = ' '
	    lstring = 1
	  endif
c
c------	--get all other parameters
c
	  call get_params(string,ianz,cpara,lpara,maxp,lstring)
	  if(ier_num.eq.0) then
	    do i=ianz,1,-1
	      cpara(i+1) = cpara(i)
	      lpara(i+1) = lpara(i)
	    enddo
	    cpara(1) = zeile(1:iqo2)
	    lpara(1) = iqo2
	    ianz     = ianz + 1
	    call do_build_name(ianz,cpara,lpara,werte,maxp,1)
	    if(ier_num.eq.0) then
c
c------	------The first comma that follows the quotation marks must be
c	      omitted, all others retained as part of the echo
c
	      if(ianz.eq.1) then
	        write (*,2000) cpara(ianz)(1:lpara(ianz))
	        if (output_status.eq.OUTPUT_FILE) then
	          write (output_io,2000) cpara(ianz)(1:lpara(ianz))
	        endif
	      elseif(ianz.eq.2) then
	        write (*,2000) cpara(1)(1:lpara(1)),
     &	                       cpara(ianz)(1:lpara(ianz))
	        if (output_status.eq.OUTPUT_FILE) then
	          write (output_io,2000) cpara(1)(1:lpara(1)),
     &	                                 cpara(ianz)(1:lpara(ianz))
	        endif
	      else
	        write (*,2000) cpara(1)(1:lpara(1)),
     &	                     (cpara(i)(1:lpara(i)),',',i=2,ianz-1),
     &	                      cpara(ianz)(1:lpara(ianz))
	        if (output_status.eq.OUTPUT_FILE) then
	          write (output_io,2000) cpara(1)(1:lpara(1)),
     &	                     (cpara(i)(1:lpara(i)),',',i=2,ianz-1),
     &	                      cpara(ianz)(1:lpara(ianz))
	        endif
	      endif
	    endif
	  endif
	endif
c
2000	format(1x,21a)
2010	format(1x,  a)
c
	end
C*****7*****************************************************************
