c
c	This file contains subroutines for:
c	Compiler specific routines GNU f2c version
c
c*****7****************************************************************
       function sind(arg)
c
	include     'wink.inc'
c
       sind=sin(arg*rad)
       end
c*****7****************************************************************
       function cosd(arg)
c
	include     'wink.inc'
c
       cosd=cos(arg*rad)
       end
c*****7****************************************************************
       function tand(arg)
c
	include     'wink.inc'
c
       tand=tan(arg*rad)
       end
c*****7****************************************************************
       function asind(arg)
c
	include     'wink.inc'
c
       asind=asin(arg)/rad
       end
c*****7****************************************************************
       function acosd(arg)
c
	include     'wink.inc'
c
       acosd=acos(arg)/rad
       end
c*****7****************************************************************
       function atand(arg)
c
	include     'wink.inc'
c
       atand=atan(arg)/rad
       end
c*****7****************************************************************
       function atan2d(arg1,arg2)
c
	include     'wink.inc'
c
       atan2d=atan2(arg1,arg2)/rad
       end
c*****7*****************************************************************
	subroutine do_getargs(iarg,arg,narg)
c+         
c	Get command line parameters
c-
	implicit       none
c
	integer		narg,iarg,i
	character*(*)	arg(narg)
c
	iarg = iargc()
	iarg = min(iarg,narg)
c
	if (iarg.gt.0) then
	  do i=1,iarg
	    call getarg(i,arg(i))
	  enddo
	endif
c
	end
c*****7*****************************************************************
	subroutine do_operating_comm(command)
c+         
c	Executes operating system command
c-
	implicit       none
c
	include       'errlist.inc'
c
	character*(*)  command
c
	call system(command,ier_num)
	if(ier_num.eq.0) then
	  ier_typ = ER_NONE
	else
	  write(*,2000) ier_num
	  ier_num = -5
	  ier_typ = ER_COMM
	endif
c
2000	format(' ****SYST**** Operating System/Shell Error Number:',i5,
     &	       ' ****')
	end
c*****7*****************************************************************
	subroutine do_chdir(dir,ld)
c+         
c	Changes working directory ..
c-
	implicit       none
c
	include       'errlist.inc'
c
	character*(*)  dir
	character*200  cwd
	integer        ld,dummy
c
	integer        len_str
c
	if (dir.eq.' ') then
	  call getcwd(cwd,dummy)
	  write(*,1000) cwd(1:len_str(cwd))
	else
	  call chdir(dir(1:ld),ier_num)
	  if(ier_num.eq.0) then
	    ier_typ = ER_NONE
	    call getcwd(cwd,dummy)
	    write(*,1000) cwd(1:len_str(cwd))
	  else
	    write(*,2000) ier_num
	    ier_num = -5
	    ier_typ = ER_COMM
	  endif
	endif
c
1000	format(' ------ > Working directory : ',a)
2000	format(' ****SYST**** Unable to change directory - Error :',i5,
     &	       ' ****')
	end
C*****7******************************************************************
	subroutine do_del_file(name)
c+
c	Deletes a file
c-
	implicit       none
c
	include       'errlist.inc'
c
	character*(*)  name
	character*80   command
	integer        len_str,laenge
c
	laenge =len_str(name)
	call    rem_bl(name,laenge)
	command=' '
c
c------	sun,hp
c
	command(1:3)='rm '
	command(4:4+laenge)=name(1:laenge)
	call system(command)
	if(ier_num.eq.0) then
	  ier_typ = ER_NONE
	else
	  write(*,2000) ier_num
	  ier_num = -5
	  ier_typ = ER_COMM
	endif
c
2000	format(' ****SYST****Operating System/Shell Error Number:',i5,
     &	       '****')
	end
C*****7******************************************************************
	subroutine do_rename_file(nameold,namenew)
C+
C	Renames the file <nameold> to <namenew>
c-
	implicit       none
c
	include       'errlist.inc'
c
	character*(*)  nameold,namenew
	character*80   command
	integer        len_str,lo,ln
c
	lo =len_str(nameold)
	call    rem_bl(nameold,lo)
	ln =len_str(namenew)
	call    rem_bl(namenew,ln)
	command=' '
c
c------	sun,hp
c
	command(1   :3      ) = 'mv '
	command(4   :3+lo   ) = nameold(1:lo)
	command(4+lo:4+lo   ) = ' '
	command(5+lo:4+lo+ln) = namenew(1:ln)
c
	call system(command)
	if(ier_num.eq.0) then
	  ier_typ = ER_NONE
	else
	  write(*,2000) ier_num
	  ier_num = -5
	  ier_typ = ER_COMM
	endif
c
2000	format('****SYST****Operating System/Shell Error Number:',i5,
     &	       '****')
	end
C*****7*****************************************************************
	real function seknds(s)
c-
c	returns the elapsed system time since midnight (s=0) or since s
c	im seconds
c
	implicit       none
c	
	real s,secnds
c
	seknds=secnds(s)
	end
C*****7*****************************************************************
	subroutine open_def(idef)
c
	implicit      none
c
	include      'envir.inc'
	include       'errlist.inc'
c
	character*80  dffile
	integer       idef,l1,l2
	logical       lread
c
	data          dffile/' '/
c
c------	try in present directory
c
	dffile = deffile
	lread  = .true.
	call oeffne(idef,dffile,'old',lread)
	if(ier_num.ne.0) then
c
c------	not found, try in home directory
c
	  dffile(1:home_dir_l) = home_dir
	  l1=home_dir_l+1
	  l2=home_dir_l+1+deffile_l+1
	  dffile(l1:l2) = '/'//deffile
	  call oeffne(idef,dffile,'old',lread)
	  if(ier_num.ne.0) then
c
c------	not found, try in home/bin directory
c
	    dffile(1:home_dir_l) = home_dir
	    l1=home_dir_l+1
	    l2= l1+4
	    dffile(l1:l2) = '/bin/'
	    l1=l2+1
	    l2=l1+deffile_l
	    dffile(l1:l2) = deffile
	    call oeffne(idef,dffile,'old',lread)
	  endif
	endif
	end
c*****7***************************************************************
	subroutine oeffne(inum,datei,stat,lread)
c-
c	opens a file 'datei' with status 'stat' and unit 'inum'
c	if lread = .true. the file is opened readonly
c	The readonly parameter is VMS specific, not implemented
c	on SUN FORTRAN
c+
	implicit      none
c
	include       'errlist.inc'
c
	character*(*) datei,stat
	integer       inum,ios
	logical       lda,lread
c
	ier_num = -2
	ier_typ = ER_IO
	if(stat.eq.'unknown') then
	  open(inum,file=datei,status=stat,err=999,iostat=ios)
	  ier_num = 0
	  ier_typ =ER_NONE
	else
	  inquire(file=datei,exist=lda)
	  if(stat.eq.'old') then
	    if(lda) then
	      open(inum,file=datei,status=stat,err=999,iostat=ios)
	      ier_num = 0
	      ier_typ =ER_NONE
	    elseif(.not.lda) then
	      ier_num = -1
	      ier_typ = ER_IO
	    endif
	  elseif(stat.eq.'new') then
	    if(.not.lda) then
	      open(inum,file=datei,status=stat,err=999,iostat=ios)
	      ier_num = 0
	      ier_typ =ER_NONE
	    elseif(lda) then
	      ier_num = -4
	      ier_typ = ER_IO
	    endif
	  endif
	endif
999	continue
c
2000	format(' ****SYST****Operating System/Shell Error Number:',i5,
     &	       '****')
	end
c*****7***************************************************************
