c*****7*****************************************************************
	subroutine mache_kdo(line,lend,length)
c+
c	This routine interprets the commands and executes the 
c	corresponding function.
c
c	Version : 1.0
c	Date    : 17 Sep 98
c
c	Author  : Th. Proffen  (tproffen@lanl.gov)
c-
	implicit     none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'pdf.inc'
	include      'learn.inc'
	include      'errlist.inc'
c
	character*200 line,zei
	character*70  command
	character*4   bef
	integer       i,lc,lbef,length
	integer       ianz,indxg,indxb
	logical       lend
c
	logical       str_comp
c
	save          command
c
	call no_error
c
c------ If a commentary return immediately
c
	if(line(1:1).eq.' ' .or. line(1:1).eq.'#' .or. 
     &	   line(1:1).eq.'!' .or. length.eq.0           ) return
c
c------	Only the first 4 characters are significant. The command consists
c	of the four nonblank characters 
c
	bef = '    '
	indxb  = index(line,' ')
	lbef   = min(indxb-1,4)
	bef = line(1:lbef )
c
c------	command parameters start at the first character following the blank
c
	zei = ' '
	lc = 0
	if(indxb+1.le.length) then
	  zei = line(indxb+1:length)
	  lc = length - indxb
	endif
c
c-------Suche nach einem "="
c
	indxg=index(line,'=')
        if(indxg.ne.0.and..not.(str_comp(bef,'echo',2,lbef,4))
     &               .and..not.(str_comp(bef,'syst',2,lbef,4))
     &               .and..not.(str_comp(bef,'par' ,2,lbef,3))
     &               .and..not.(str_comp(bef,'help',2,lbef,4) .or.
     &	                        str_comp(bef,'?   ',1,lbef,4)) )then
c
c-------Zuweisung eines Funktionswertes
c
	  call do_math(line,indxg,length)
	  if (cr_la) call lattice(cr_ipha,.false.)
	else
c
c------	--execute a macro file
c
	  if(bef(1:1).eq.'@') then
	    if(length.ge.2) then
	      call file_kdo(line(2:length),length-1)
	    else
	      ier_num = -13
	      ier_typ = ER_MAC
	    endif
c
c------ Terminate PDFFIT 'exit'
c
	  elseif(str_comp(bef,'exit',2,lbef,4)) then
	    lend=.true.
c
c-------  ---------------------------------------------------------------
c-------  Here we have PDFFIT specific commands
c-------  ---------------------------------------------------------------
c
c-------  Allocating space for calculating PDF without data
c
	  elseif(str_comp(bef,'alloc',3,lbef,5)) then
	    call do_allocate(zei,lc)
	    call fit_update
c
c-------  Calculate bond angles
c
	  elseif(str_comp(bef,'bang',2,lbef,4)) then
	    call calc_bang(zei,lc)
c
c-------  Calculate bond lengths
c
	  elseif(str_comp(bef,'blen',2,lbef,4)) then
	    call calc_blen(zei,lc)
c
c-------  Calculating the PDF
c
	  elseif(str_comp(bef,'calc',2,lbef,4)) then
	    call fit_theory(.false.,.true.)
c
c-------  Setting number of iterations
c
	  elseif(str_comp(bef,'cycle',3,lbef,5)) then
	    call do_ncycle(zei,lc)
c
c-------  Setting occupancies
c
	  elseif(str_comp(bef,'occ',2,lbef,3)) then
	    call do_occ(zei,lc)
c
c-------  Setting parameter definitions
c
	  elseif(str_comp(bef,'par',3,lbef,3)) then
	    call do_par(zei,lc)
c
c-------  Setting current phase to 'n'
c
	  elseif(str_comp(bef,'phase',3,lbef,5)) then
	    call do_phase(zei,lc)
c
c-------  Selecting phases for specific data sets
c
	  elseif(str_comp(bef,'psele',3,lbef,5)) then
	    call pdf_pselect(zei,lc)
c
c-------  Specify R-range for fit
c
	  elseif(str_comp(bef,'range',3,lbef,5)) then
	    call pdf_range(zei,lc)
c
c-------  Reading structure, data and PDFFIT files
c
	  elseif(str_comp(bef,'read',3,lbef,4)) then
	    call do_read(zei,lc)
	    call fit_update
c
c-------  Run refinement
c
	  elseif(str_comp(bef,'run',2,lbef,3)) then
	    call do_fit
c
c-------  Reset PDFFIT
c
	  elseif(str_comp(bef,'reset',3,lbef,5)) then
	    call do_reset
	    call fit_reset
c
c-------  Save PDF, structure or complete result
c
	  elseif(str_comp(bef,'save',3,lbef,4)) then
	    call pdf_save(zei,lc)
c
c-------  Set user defined scattering lengths
c
	  elseif(str_comp(bef,'scat',3,lbef,4)) then
	    call do_scat (zei,lc)
c
c------   Select/deselect atoms used for PDF calculation
c
 	  elseif(str_comp(bef,'isele',3,lbef,5) .or.
     &	         str_comp(bef,'idese',3,lbef,5)     ) then
 	    call atom_select(zei,lc,pdf_allowed_i,
     & 	                     str_comp(bef,'isele',3,lbef,5))
 	  elseif(str_comp(bef,'jsele',3,lbef,5) .or.
     &	         str_comp(bef,'jdese',3,lbef,5)     ) then
 	    call atom_select(zei,lc,pdf_allowed_j,
     & 	                     str_comp(bef,'jsele',3,lbef,5))
c
c-------  Display various information
c
	  elseif(str_comp(bef,'show',2,lbef,4)) then
	    call do_show(zei,lc)
c
c-------  Setting anisotropic temperature factors
c
	  elseif(str_comp(bef,'temp',2,lbef,4)) then
	    call do_temp(zei,lc)
c
c-------  Setting URF
c
	  elseif(str_comp(bef,'urf',2,lbef,3)) then
	    call do_urf(zei,lc)
c
c-------  Setting Q for f(xray)
c
	  elseif(str_comp(bef,'xray',2,lbef,4)) then
	    call do_xray(zei,lc)
c
c-------  Check for general commands
c
	  else
	    call kdo_all(bef,lbef,zei,lc)
	  endif
	endif
c
	end
