c*****7*****************************************************************
c
c	This file contains all routines dealing with the
c	PDF anlysis.
c
c	Version  : 1.1
c	Date     : 01 June 1999
c	Author   : Th. Proffen (tproffen@lanl.gov)
c 
c*****7*****************************************************************
	subroutine do_read_data (ianz,cpara,lpara,werte,maxw,lref)
c+
c	Reads observed PDF as xy ASCII file. 
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'prompt.inc'
	include 	'crystal.inc'
	include 	'param.inc'
	include 	'errlist.inc'
	include 	'debug.inc'
	include 	'pdf.inc'
c
	integer		maxw
c
	character*200	cpara(maxw)
	character*200	pfile,rfile
	character*80	line
	integer		lpara(maxw)
	integer		lpfile,lrfile
	integer		ianz,iianz,i,ip,iset
	real		werte(maxw)
	real		ra,re,dr,da,de
	logical		lref,lwei
c
c------ Check if there is space for another data set
c
	if (pdf_nset.eq.MAXDSET) then
	  ier_num = -104
	  ier_typ = ER_APPL
	  return
	endif 
	iset = pdf_nset + 1
c
c------ Now analyse given parameters
c
	if ((.not.lref .and. ianz.ge.4) .or.
     &	    (     lref .and. ianz.ge.5)     ) then
c
c------ - get exp. method (neutron/x-ray)
c
	  call do_cap(cpara(1))
	  if (cpara(1)(1:1).eq.'N') then
	    pdf_lxray(iset)=.false.
	  elseif (cpara(1)(1:1).eq.'X') then
	    pdf_lxray(iset)=.true.
	  else
	    ier_num = -105
	    ier_typ = ER_APPL
	    return
	  endif
c
c------ - get QMAX and QSIG
c
	  iianz = 2
	  call del_params(1,ianz,cpara,lpara,maxw)
	  call ber_params(iianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  pdf_qmax(iset)   = werte(1)
	  pdf_sigmaq(iset) = werte(2)
c
c------ - get filename
c
	  call del_params(2,ianz,cpara,lpara,maxw)
	  call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	  pfile  = cpara(1)
	  lpfile = lpara(1)
c
c------ - read possible reference PDF filename
c
	  if (lref) then
	    pdf_lref(iset) = .true.
	    call del_params(1,ianz,cpara,lpara,maxw)
	    call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	    rfile  = cpara(1)
	    lrfile = lpara(1)
	  else
	    pdf_lref(iset) = .false.
	  endif
c
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
c------ Read observed PDF for given plane
c
	call oeffne (17,pfile,'old',.false.)
	if (lref) call oeffne (18,rfile,'old',.false.)
	if (ier_num.ne.0) return
c
c------ Has the file a prepended History ?
c------ Get information from history and store in res[i]
c
c------ res[1] = Temperature
c
	res_para(0) = 0
c
	read(17,1000) line
	if (line(1:7).eq.'History') then
	  write (output_io,3000)
22	  continue
	    read(17,1000,end=999) line
	    call extract_key(line,'temp=')
	    call extract_key(line,'Qmax=')
	    if (line(1:16) .eq. '##### start data') goto 33
	  goto 22
	else
	  backspace(17)
	endif
33	continue
c
c------ Any other header lines starting with # ?
c
44	continue
	  read(17,1000,end=999) line
	if (line(1:1).eq.'#') goto 44
	backspace(17)
c
c------ Finally we actually read the data
c
	read (17,1000,end=20,err=999) line
	call count_col (line,ianz)
	if (ianz.ne.2 .and. ianz.ne.3 .and. ianz.ne.4) goto 999
	backspace(17)
c
	ip=1
	lwei=.true.
c
10	continue
	  read (17,*,end=20,err=999) (werte(i),i=1,ianz)
	  re=werte(1)
	  pdf_obs(ip,iset)=werte(2)
	  if (ianz.gt.2 .and. werte(ianz).gt.0.0) then
	    pdf_wic(ip,iset) = 1.0 / werte(ianz)**2
	  else
	    pdf_wic(ip,iset) = 1.0
	    lwei = .false.
	  endif
	  if (lref) then
	    read (18,*,end=20,err=999) de,pdf_ref(ip,iset)
	    if (abs(re-de).gt.1e-5) goto 9999
	  endif
	  ip = ip+1
	  if (ip.gt.MAXDAT) goto 9998
	  goto 10
20	continue
	close (17)
c
	if (lref) close (18)
	if (ier_num.ne.0) return
c
	pdf_nset = iset
	pdf_iset = iset
c
	pdf_rmin(iset)   = ra
	pdf_rmax(iset)   = re
	pdf_bin(iset)    = ip-1
	pdf_deltar(iset) = (re-ra)/float(pdf_bin(iset)-1)
	pdf_name(iset)   = pfile(1:lpfile)
c
	if (lref) pdf_rname(iset)  = rfile(1:lrfile)
c
	if (lref) then
	  write (output_io,9000) iset,ra,re,pdf_bin(iset)
	else
	  write (output_io,9100) iset,ra,re,pdf_bin(iset)
	endif
c
	if (.not.lwei) write (output_io,9200)
	return
c
999	continue
	close (17)
	if (lref) close (18)
	ier_num = -3
	ier_typ = ER_IO
	return
c
9998	continue
	close (17)
	if (lref) close (18)
	ier_num = -111
	ier_typ = ER_APPL
	return
c
9999	continue
	close (17)
	if (lref) close (18)
	ier_num = -115
	ier_typ = ER_APPL
	return
c
1000	format (a)
3000	format (' History information found ...')
9000	format (' Read PDF difference data set ',I3,'  (r = ',F7.3,
     &	        ' to ',F7.3,' A, ',I5,' points) ...')
9100	format (' Read PDF data set ',I3,'  (r = ',F7.3,' to ',F7.3,
     &	        ' A, ',I5,' points) ...')
9200	format (' No sigmas for G(r) found, using unit weights ..')
	end
c*****7*****************************************************************
	subroutine extract_key (line,key)
c+
c	Gets numbers from history part of data file
c-
	implicit      	none
c
	include		'config.inc'
	include		'param.inc'
c
	character*(*)	line,key
	integer		is,ie,ll,lk
c
	integer		len_str
c
	ll = len_str(line)
	lk = len_str(key)
c
	is = index(line,key(1:lk))
	if (is.ne.0) then
	  is = is+lk
	  do while (line(is:is).eq.' ')
	    is = is+1
	  enddo
	  ie = index(line(is:ll),' ')
	  if (ie.eq.0) ie = ll
	  res_para(0) = res_para(0)+1
	  read(line(is:is+ie),*) res_para(res_para(0))
	endif
c
	end
c*****7*****************************************************************
	subroutine do_allocate (zeile,lp)
c+
c	Allocates space for calculated PDF
c-
	implicit      	none
c
	include 	'config.inc'
	include 	'prompt.inc'
	include 	'crystal.inc'
	include 	'errlist.inc'
	include 	'debug.inc'
	include 	'pdf.inc'
c
	integer		maxw
	parameter	(maxw = 6)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	real		werte(maxw)
	integer		lpara(maxw)
	integer		lp,ianz,iset,ip
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
c------ Check if there is space for another data set
c
	if (pdf_nset.eq.MAXDSET) then
	  ier_num = -104
	  ier_typ = ER_APPL
	  return
	endif 
	iset = pdf_nset + 1
c
c------ Now analyse given parameters
c
	if (ianz.eq.6) then
c
c------ - get exp. method (neutron/x-ray)
c
	  call do_cap(cpara(1))
	  if (cpara(1)(1:1).eq.'N') then
	    pdf_lxray(iset)=.false.
	  elseif (cpara(1)(1:1).eq.'X') then
	    pdf_lxray(iset)=.true.
	  else
	    ier_num = -105
	    ier_typ = ER_APPL
	    return
	  endif
c
c------ - get other parameters
c
	  call del_params(1,ianz,cpara,lpara,maxw)
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
c
	  if (nint(werte(5)).gt.MAXDAT) then
	    ier_num = -111
	    ier_typ = ER_APPL
	    return
	  endif
c
	  pdf_nset = iset
	  pdf_iset = iset
c
	  pdf_qmax(iset)   = werte(1)
	  pdf_sigmaq(iset) = werte(2)
	  pdf_rmin(iset)   = werte(3)
	  pdf_rmax(iset)   = werte(4)
	  pdf_bin(iset)    = nint(werte(5))
	  pdf_deltar(iset) = (pdf_rmax(iset)-pdf_rmin(iset))/
     &	                     float(pdf_bin(iset)-1)
	  pdf_name(iset)   = 'Dummy space'
c
	  do ip=1,pdf_bin(iset)
	    pdf_obs(ip,iset) = 0.0
	    pdf_wic(ip,iset) = 1.0
	  enddo
c
	  write (output_io,9000) iset,pdf_rmin(iset),pdf_rmax(iset),
     &	                         pdf_bin(iset)
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
9000	format (' Allocated PDF data set ',I3,
     &	        '  (r = ',F7.3,' to ',F7.3,' A, ',I5,' points) ...')
	end
c*****7*****************************************************************
	subroutine pdf_setup_bnd(np)
c+
c	Setup of periodic boundary array
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'pdf.inc'
c
	integer		np
	integer		i,j
c
	do j=1,3
	  do i=-MAXBND,MAXBND+MAXBND
	    pdf_bnd(j,i)=i
	    do while (pdf_bnd(j,i).le.0) 
	      pdf_bnd(j,i)=pdf_bnd(j,i)+cr_icc(j,np)
	    enddo
	    do while (pdf_bnd(j,i).gt.cr_icc(j,np)) 
	      pdf_bnd(j,i)=pdf_bnd(j,i)-cr_icc(j,np)
	    enddo
	  enddo
	enddo
c
	end
c*****7*****************************************************************
	subroutine pdf_setup (np,ns,lout)
c+
c	Setup for various arrays and functions for PDF calculation.
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'debug.inc'
	include		'errlist.inc'
	include		'pdf.inc'
c
	real		bave,hh,rtot,ract
	integer		i,j,ia,is,js,np,ns
	logical		lout
c
	real		form,quad
c
	if (lout) write (output_io,1000)
c
c------ Setting up array for periodic boundaries
c
	call pdf_setup_bnd(np)
c
c------ Setting up weighting (b(i)b(j)/<b**2>)
c
	call dlink(ns)
c
	bave = 0.0
	hh   = pdf_xq**2
c
	do ia=1,cr_natoms(np)
	  bave = bave+cr_occ(ia,np)*form(cr_iscat(ia,np),hh,ns,np)
	enddo
	bave = bave/cr_np(np)
c
	cr_bave(np,ns) = bave
c
	do is=0,cr_nscat(np)
	  do js=0,cr_nscat(np)
	    pdf_weight(is,js)=form(is,hh,ns,np)*
     &	                      form(js,hh,ns,np)/bave**2
	  enddo
	enddo
c
c------ Get the ratio total pairs/selected weight in structure
c
	rtot = 0.0
	ract = 0.0
c	
	do i=1,cr_natoms(np)
	  do j=1,cr_natoms(np)
	    is = cr_iscat(i,np)
	    js = cr_iscat(j,np)
	    rtot = rtot + pdf_weight(is,js)
	    if ((pdf_allowed_i(is,ns) .and. 
     &	         pdf_allowed_j(js,ns)      ).or.
     &	        (pdf_allowed_j(is,ns) .and.
     &	         pdf_allowed_i(js,ns))          ) 
     &	     ract = ract + pdf_weight(is,js)
	  enddo
	enddo
c
	pdf_dnorm(np) = ract/rtot
c
c------ Setting up SINC function for convolution with PDF
c
	call pdf_setup_sinc (ns,lout)
c
1000	format (' Setting up PDF segment ...')
	end
c*****7*****************************************************************
	subroutine pdf_setup_sinc (s,lout)
c+
c	Setup SINC function for dataset 's'
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'debug.inc'
	include		'errlist.inc'
	include		'pdf.inc'
c
	real		sincut,rcut
	integer		i,nn,nnn,s
	logical		lout
c
	if (pdf_rfmin(s).lt.0.0) then
	  pdf_rfmin(s) = pdf_rmin(s)
	  pdf_rfmax(s) = pdf_rmax(s)
	endif
c
	pdf_rcmin(s) = pdf_rfmin(s)
	pdf_rcmax(s) = pdf_rfmax(s)
c
c------ Setup of the SINC function 
c
	if (pdf_qmax(s).gt.0.0) then
	  sincut = 0.025
	  rcut   = 1.0 / (pdf_qmax(s)*sincut)
	  nn     = int(rcut/pdf_deltar(s)) + 100
	  nnn    = nint((pdf_rfmax(s)+rcut)/pdf_deltar(s))+1
c
	  if (nnn.le.MAXDAT) then
	    pdf_rcmin(s) = max(pdf_rmin(s),pdf_rfmin(s)-rcut)
	    pdf_rcmax(s) = pdf_rfmax(s) + rcut
	    if (lout) write (output_io,1100) pdf_rmin(s),pdf_rmax(s)
	  else
	    ier_num = -112
	    ier_typ = ER_APPL
	    call errlist_appl
	    call no_error
	  endif
c
	  do i=1,nn
	    pdf_sinc(i) = sin(i*pdf_deltar(s)*pdf_qmax(s))/
     &	                     (i*pdf_deltar(s))
	  enddo
	  do i=nn+1,2*MAXDAT
	    pdf_sinc(i) = 0.0
	  enddo
	endif
c
c------ Calculate boudary indices
c
	pdf_ncmin(s)=nint((pdf_rcmin(s)-pdf_rmin(s))/pdf_deltar(s))+1
	pdf_ncmax(s)=nint((pdf_rcmax(s)-pdf_rmin(s))/pdf_deltar(s))+1
	pdf_nfmin(s)=nint((pdf_rfmin(s)-pdf_rmin(s))/pdf_deltar(s))+1
	pdf_nfmax(s)=nint((pdf_rfmax(s)-pdf_rmin(s))/pdf_deltar(s))+1
c
1100	format (' Extending PDF search distance to ',F8.4,' -> ',
     &	          F8.4,' A ...')
	end
c*****7*****************************************************************
	subroutine pdf_determine (iset,ldiff,lout)
c+
c	Calculate PDF of current structure
c-
	implicit	none
c
	include		'config.inc'
	include		'prompt.inc'
	include		'crystal.inc'
	include		'errlist.inc'
	include		'pdf.inc'
	include		'wink.inc'
c
	integer		i,j,k,ii,jj,kk,is,js,ks,ia,ja,ip
	integer		ig,igaus,ib,ie
	integer		idummy,iset,iatom,ibin,nn
	integer       	istart(3),iend(3),iii(3),cell(3),ioff(3)
	real		dist,dist2,r,rg,d(3),dd(3)
	real		ampl,absd,sigma,sigmap,sigma02,gnorm
	real		rmax2,rmin2
	real		ppp(MAXDAT),gaus(MAXDAT)
	logical		lout,ldiff
c
	real		skalpro
c
	if (lout) write (output_io,500)
c
c------ Setup some common variables
c
	do ip=1,MAXDAT
	  pdf_tot(ip,iset) = 0.0
	enddo
c
c------ Loop over all phases
c
	do ip = 1,cr_npha
	  if (.not.pdf_psel(ip,iset)) goto 1111
	  idummy  = cr_ipha
	  cr_ipha = ip
c
c------ - Setup PDF variables
c
	  call pdf_setup(ip,iset,.false.)
	  rmax2 = pdf_rcmax(iset)**2
	  rmin2 = pdf_rcmin(iset)**2
c
	  do i=1,MAXDAT
	    ppp(i)   = 0.0
	  enddo
c
	  do ia=1,cr_natoms(ip)
            is = cr_iscat(ia,ip)
	    if (.not. pdf_allowed_i(is,iset) .and.
     &	        .not. pdf_allowed_j(is,iset)      ) goto 9999
	    call indextocell (ia,iii,ks,ip)
	    do i=1,3
 	      istart(i) = iii(i)-1-int(pdf_rcmax(iset)/cr_a0(i,ip))
	      iend(i)   = iii(i)+1+int(pdf_rcmax(iset)/cr_a0(i,ip))
	    enddo
c
	    do k=istart(3),iend(3)
	    do j=istart(2),iend(2)
	    do i=istart(1),iend(1)
	      cell(1) = i
	      cell(2) = j
	      cell(3) = k
c  	 
c------ ----- Here we apply periodic boundaries
c------ ----- Modified to allow more than a single cycle !
c
	      do ii=1,3
	        iii(ii)  = cell(ii)
	        cell(ii) = pdf_bnd(ii,cell(ii))
	        ioff(ii) = iii(ii)-cell(ii)
	      enddo
c
c------ ----- Now look for neighbours in surrounding unit cells only
c
	      do ja=1,cr_ncatoms(ip)
	        call celltoindex (cell,ja,iatom,ip)
                do jj=1,3
	          dd(jj)   = cr_pos(jj,ia,ip)    - 
     &	                     cr_pos(jj,iatom,ip) - float(ioff(jj))
	          d(jj)    = abs(dd(jj)) * cr_a0(jj,ip)
	        enddo   
	        dist2 = skalpro(dd,dd,cr_gten,ip)
	        if (dist2.ge.rmin2 .and. dist2.le.rmax2) then
                  js   = cr_iscat(iatom,ip)
c
	          if ((pdf_allowed_i(is,iset) .and. 
     &	               pdf_allowed_j(js,iset)      ).or.
     &	              (pdf_allowed_j(is,iset) .and.
     &	               pdf_allowed_i(js,iset))          ) then
c
c------ ----------- Setting up 'thermal' Gaussian
c
	            sigma02 = cr_u(1,ia   ,ip)*d(1)*d(1)     +
     &	                      cr_u(2,ia   ,ip)*d(2)*d(2)     +
     &	                      cr_u(3,ia   ,ip)*d(3)*d(3)     +
     &	                      cr_u(4,ia   ,ip)*d(1)*d(2)*2.0 +
     &	                      cr_u(5,ia   ,ip)*d(1)*d(3)*2.0 +
     &	                      cr_u(6,ia   ,ip)*d(2)*d(3)*2.0 +
     &	                      cr_u(1,iatom,ip)*d(1)*d(1)     +
     &	                      cr_u(2,iatom,ip)*d(2)*d(2)     +
     &	                      cr_u(3,iatom,ip)*d(3)*d(3)     +
     &	                      cr_u(4,iatom,ip)*d(1)*d(2)*2.0 +
     &	                      cr_u(5,iatom,ip)*d(1)*d(3)*2.0 +
     &	                      cr_u(6,iatom,ip)*d(2)*d(3)*2.0 
c
	            dist    = sqrt(dist2)
	            ibin    = nint((dist-pdf_rmin(iset))/
     &	                      pdf_deltar(iset))+1
	            sigmap  = sqrt(abs(sigma02)/dist2)
	            sigma   = sigmap - pdf_delta(ip)/dist2
	            if (dist.lt.pdf_rcut(ip)) then
	              sigma = sigma*abs(pdf_srat(ip))
	            endif
	            igaus   = 1 + nint(5.0*sigma/pdf_deltar(iset))
	            ib      = max(pdf_ncmin(iset),ibin-igaus+1)
	            ie      = min(pdf_ncmax(iset),ibin+igaus-1)
	            gnorm   = 1.0/(sqrt(zpi)*sigma)
	            ampl    = cr_occ(ia,ip)*cr_occ(iatom,ip)*
     &	                      pdf_weight(is,js)
c
	            do ig=1,igaus
	              rg       = (ig-1)*pdf_deltar(iset)
	              gaus(ig) = gnorm * exp(-0.5*(rg/sigma)**2)
	            enddo
c
	            do ig=ib,ie
	              kk        = abs(ibin-ig)+1
	              ppp(ig)   = ppp(ig) + ampl*gaus(kk)
	              if (ldiff) then
	                call pdf_derivative (ip,iset,ia,iatom,ig,
     &	                       kk,sigma,sigmap,dist,dd,ampl,gaus)
	              endif
	            enddo
	          endif
	        endif
              enddo
	    enddo
	    enddo
	    enddo
9999	    continue
	  enddo
c
c------ - Convert to proper G(r)
c
	  do i=pdf_ncmin(iset),pdf_ncmax(iset)
	    r = (i-1)*pdf_deltar(iset) + pdf_rmin(iset)
	    pdf_calc(i,iset,ip) = ppp(i)/cr_np(ip)/r - 
     &	                          fpi*r*cr_rho0(ip)*pdf_dnorm(ip)
c
	    if (pdf_sigmaq(iset).gt.0.0) then
	      pdf_calc(i,iset,ip) = pdf_calc(i,iset,ip) *
     &	                            exp(-(r*pdf_sigmaq(iset))**2/2.0)
	    endif
	  enddo
c
c------ - Convolute with SINC function
c
	  if (pdf_qmax(iset).gt.0.0) then
	    do i=pdf_ncmin(iset),pdf_ncmax(iset)
	      ppp(i) = pdf_calc(i,iset,ip)*
     &	               (pdf_qmax(iset)-pdf_sinc(2*i))
	      do k=pdf_ncmin(iset),i-1
	        ppp(i) = ppp(i) + pdf_calc(k,iset,ip)*
     &	                         (pdf_sinc(i-k)-pdf_sinc(i+k))
	      enddo
	      do k=i+1,pdf_ncmax(iset)
	        ppp(i) = ppp(i) + pdf_calc(k,iset,ip)*
     &	                         (pdf_sinc(k-i)-pdf_sinc(k+i))
	      enddo
	    enddo
c
	    do i=pdf_ncmin(iset),pdf_ncmax(iset)
	      pdf_calc(i,iset,ip) = ppp(i)*pdf_deltar(iset)/pi
	    enddo
	  endif
c
c------ - Add to total PDF 
c
	  do i=pdf_ncmin(iset),pdf_ncmax(iset)
  	    pdf_tot(i,iset) = pdf_tot(i,iset)+pdf_skal(iset)*
     &	                      cr_skal(ip)*pdf_calc(i,iset,ip)
	  enddo
1111	  continue
	enddo
c
c------ Subtract reference PDF if required
c
	if (pdf_lref(iset)) then
	  do i=pdf_ncmin(iset),pdf_ncmax(iset)
  	    pdf_tot(i,iset) = pdf_tot(i,iset)-pdf_ref(i,iset)
	  enddo
	endif
c
	cr_ipha = idummy
c
500	format (' Calculating PDF ...')
	end
c*****7*****************************************************************
	subroutine pdf_derivative (ip,iset,ia,ja,ig,kk,sigma,
     &	                           sigmap,dist,d,ampl,gaus)
c+
c	This routine calculates the sums over 'ij' needed for the
c	derivatives - this is faster than doing the complete loop
c	in 'pdf_determine' again ..
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'errlist.inc'
	include 	'pdf.inc'
	include 	'fit.inc'
c
	real		gaus(MAXDAT),d(3)
	real		ampl,dist,sigma,sigmap
	integer		ip,iset,ia,ja,ig,kk
c
	real		dphi,phi,drdx,dsdx,drda,dsda,dg,rd,rk
	real		s11,s22,s33,s12,s13,s23
	integer		i,n,ipar,jpar,mpar
c
c------ Some common calculations
c
	s11 = cr_u(1,ia,ip) + cr_u(1,ja,ip)
	s22 = cr_u(2,ia,ip) + cr_u(2,ja,ip)
	s33 = cr_u(3,ia,ip) + cr_u(3,ja,ip)
	s12 = cr_u(4,ia,ip) + cr_u(4,ja,ip)
	s13 = cr_u(5,ia,ip) + cr_u(5,ja,ip)
	s23 = cr_u(6,ia,ip) + cr_u(6,ja,ip)
c
	rk = (ig-1)*pdf_deltar(iset) + pdf_rmin(iset)
        rd = (rk - dist)/sigma
c
	if (dist.lt.pdf_rcut(ip)) then
	  phi  = pdf_srat(ip)
	  dphi = sigma/phi
	else
	  phi  = 1.0
	  dphi = 0.0
	endif
c
c------ ----------------------------------------------------------------
c------ Derivatives per atom : x,y,z,u,o
c------ ----------------------------------------------------------------
c
c ----- d/dx[ip,ia]
c
	ipar = cr_off(ip-1) + (ia-1)*n_at + 1
	jpar = cr_off(ip-1) + (ja-1)*n_at + 1
c
	mpar = fit_jd(ipar)
	if (fit_ndpp(mpar).ne.0) then
	  drdx = cr_a0(1,ip)*cr_a0(1,ip)*         d(1) +
     &	         cr_a0(1,ip)*cr_a0(2,ip)*cosg(ip)*d(2) +
     &	         cr_a0(1,ip)*cr_a0(3,ip)*cosb(ip)*d(3)
	  drdx = -drdx / dist
	  dsdx = cr_a0(1,ip)*cr_a0(1,ip)*d(1)*s11 +
     &	         cr_a0(1,ip)*cr_a0(2,ip)*d(2)*s12 +
     &	         cr_a0(1,ip)*cr_a0(3,ip)*d(3)*s13
	  dsdx = dsdx/dist/dist/sigmap - drdx*sigmap/dist
	  dsdx = dsdx + 2.0*pdf_delta(iset)*drdx/dist/dist/dist
	  dsdx = phi * dsdx
          dg   = ampl*gaus(kk)/sigma*((rd**2 - 1)*dsdx + rd*drdx)
	  fit_a(ig,iset,ipar) = fit_a(ig,iset,ipar) - dg
	endif
c
	mpar = fit_jd(jpar)
	if (fit_ndpp(mpar).ne.0) then
	  fit_a(ig,iset,jpar) = fit_a(ig,iset,jpar) + dg
	endif
c
c ----- d/dy[ip,ia]
c
	ipar = ipar + 1
	jpar = jpar + 1
c
	mpar = fit_jd(ipar)
	if (fit_ndpp(mpar).ne.0) then
	  drdx = cr_a0(2,ip)*cr_a0(2,ip)*         d(2) +
     &	         cr_a0(2,ip)*cr_a0(1,ip)*cosg(ip)*d(1) +
     &	         cr_a0(2,ip)*cr_a0(3,ip)*cosa(ip)*d(3)
	  drdx = -drdx / dist
	  dsdx = cr_a0(2,ip)*cr_a0(1,ip)*d(1)*s12 +
     &	         cr_a0(2,ip)*cr_a0(2,ip)*d(2)*s22 +
     &	         cr_a0(2,ip)*cr_a0(3,ip)*d(3)*s23
	  dsdx = dsdx/dist/dist/sigmap - drdx*sigmap/dist
	  dsdx = dsdx + 2.0*pdf_delta(iset)*drdx/dist/dist/dist
	  dsdx = phi * dsdx
          dg   = ampl*gaus(kk)/sigma*((rd**2 - 1)*dsdx + rd*drdx)
	  fit_a(ig,iset,ipar) = fit_a(ig,iset,ipar) - dg
	endif
c
	mpar = fit_jd(jpar)
	if (fit_ndpp(mpar).ne.0) then
	  fit_a(ig,iset,jpar) = fit_a(ig,iset,jpar) + dg
	endif
c
c ----- d/dz[ip,ia]
c
	ipar = ipar + 1
	jpar = jpar + 1
c
	mpar = fit_jd(ipar)
	if (fit_ndpp(mpar).ne.0) then
	  drdx = cr_a0(3,ip)*cr_a0(3,ip)*         d(3) +
     &	         cr_a0(3,ip)*cr_a0(1,ip)*cosb(ip)*d(1) +
     &	         cr_a0(3,ip)*cr_a0(2,ip)*cosa(ip)*d(2)
	  drdx = -drdx / dist
	  dsdx = cr_a0(3,ip)*cr_a0(1,ip)*d(1)*s13 +
     &	         cr_a0(3,ip)*cr_a0(2,ip)*d(2)*s23 +
     &	         cr_a0(3,ip)*cr_a0(3,ip)*d(3)*s33
	  dsdx = dsdx/dist/dist/sigmap - drdx*sigmap/dist
	  dsdx = dsdx + 2.0*pdf_delta(iset)*drdx/dist/dist/dist
	  dsdx = phi * dsdx
          dg   = ampl*gaus(kk)/sigma*((rd**2 - 1)*dsdx + rd*drdx)
	  fit_a(ig,iset,ipar) = fit_a(ig,iset,ipar) - dg
	endif
c
	mpar = fit_jd(jpar)
	if (fit_ndpp(mpar).ne.0) then
	  fit_a(ig,iset,jpar) = fit_a(ig,iset,jpar) + dg
	endif
c
c ----- d/du[j,ip,ia] (j=11,22,33,12,13,23)
c
	do i=1,3
	  dg = ampl*gaus(kk)*cr_a0(i,ip)*cr_a0(i,ip)*d(i)*d(i)/
     &	       dist/dist/sigma/sigmap * (rd**2 - 1)
	  dg = phi * dg
	  mpar = fit_jd(ipar+i)
	  if (fit_ndpp(mpar).ne.0) then
	    fit_a(ig,iset,ipar+i) = fit_a(ig,iset,ipar+i) + dg
	  endif
	  mpar = fit_jd(jpar+i)
	  if (fit_ndpp(mpar).ne.0) then
	    fit_a(ig,iset,jpar+i) = fit_a(ig,iset,jpar+i) + dg
	  endif
	enddo
c
	dg = ampl*gaus(kk)*cr_a0(1,ip)*cr_a0(2,ip)*d(1)*d(2)/
     &	     dist/dist/sigma/sigmap * (rd**2 - 1)
	dg = phi * dg
	mpar = fit_jd(ipar+4)
	if (fit_ndpp(mpar).ne.0) then
	  fit_a(ig,iset,ipar+4) = fit_a(ig,iset,ipar+4) + dg
	endif
	mpar = fit_jd(jpar+4)
	if (fit_ndpp(mpar).ne.0) then
	  fit_a(ig,iset,jpar+4) = fit_a(ig,iset,jpar+4) + dg
	endif
c
	dg = ampl*gaus(kk)*cr_a0(1,ip)*cr_a0(3,ip)*d(1)*d(3)/
     &	     dist/dist/sigma/sigmap * (rd**2 - 1)
	dg = phi * dg
	mpar = fit_jd(ipar+5)
	if (fit_ndpp(mpar).ne.0) then
	  fit_a(ig,iset,ipar+5) = fit_a(ig,iset,ipar+5) + dg
	endif
	mpar = fit_jd(jpar+5)
	if (fit_ndpp(mpar).ne.0) then
	  fit_a(ig,iset,jpar+5) = fit_a(ig,iset,jpar+5) + dg
	endif
c
	dg = ampl*gaus(kk)*cr_a0(2,ip)*cr_a0(3,ip)*d(2)*d(3)/
     &	     dist/dist/sigma/sigmap * (rd**2 - 1)
	dg = phi * dg
	mpar = fit_jd(ipar+6)
	if (fit_ndpp(mpar).ne.0) then
	  fit_a(ig,iset,ipar+6) = fit_a(ig,iset,ipar+6) + dg
	endif
	mpar = fit_jd(jpar+6)
	if (fit_ndpp(mpar).ne.0) then
	  fit_a(ig,iset,jpar+6) = fit_a(ig,iset,jpar+6) + dg
	endif
c
c ----- d/do[ip,ia]
c
	ipar = ipar + 7
	jpar = jpar + 7
c
	mpar = fit_jd(ipar)
	if (fit_ndpp(mpar).ne.0) then
	  n  = (mpar-10)/n_at - (ip-1)*NMAX + 1
	  dg = -1.0/cr_np(ip)
	  if (n.eq.ia) then
	    dg = dg + 1.0/cr_occ(ia,ip)
	  endif
	   fit_a(ig,iset,ipar) = fit_a(ig,iset,ipar) + ampl*gaus(kk)*dg
	endif
c
	mpar = fit_jd(jpar)
	if (fit_ndpp(mpar).ne.0) then
	  n  = (mpar-10)/n_at - (ip-1)*NMAX + 1
	  dg = -1.0/cr_np(ip)
	  if (n.eq.ja) then
	    dg = dg + 1.0/cr_occ(ja,ip)
	  endif
	   fit_a(ig,iset,jpar) = fit_a(ig,iset,jpar) + ampl*gaus(kk)*dg
	endif
c
c------ ----------------------------------------------------------------
c------ Derivatives per phase : lat,delta
c------ ----------------------------------------------------------------
c
c ----- d/d(lattice parameter a)
c
	ipar = cr_total*n_at + (ip-1)*n_st+1
	mpar = fit_jd(ipar)
	if (fit_ndpp(mpar).ne.0) then
	  drda = cr_a0(1,ip)*d(1)*d(1)+cr_a0(2,ip)*cosg(ip)*d(1)*d(2)
     &	                              +cr_a0(3,ip)*cosb(ip)*d(1)*d(3)
	  drda = drda / dist
	  dsda = cr_a0(1,ip)*d(1)*d(1)*s11 +
     &	         cr_a0(2,ip)*d(1)*d(2)*s12 +
     &	         cr_a0(3,ip)*d(1)*d(3)*s13
	  dsda = dsda/dist**2/sigmap - sigmap/dist * drda
	  dsda = dsda + 2*pdf_delta(ip)*drda/dist**3
	  dsda = phi * dsda
	  dg   = ampl*gaus(kk)/sigma*((rd**2 - 1)*dsda + rd*drda)
	  fit_a(ig,iset,ipar) = fit_a(ig,iset,ipar) + dg
	endif
c
c ----- d/d(lattice parameter b)
c
	ipar = ipar + 1
	mpar = fit_jd(ipar)
	if (fit_ndpp(mpar).ne.0) then
	  drda = cr_a0(2,ip)*d(2)*d(2)+cr_a0(1,ip)*cosg(ip)*d(1)*d(2)
     &	                              +cr_a0(3,ip)*cosa(ip)*d(2)*d(3)
	  drda = drda / dist
	  dsda = cr_a0(1,ip)*d(2)*d(1)*s12 +
     &	         cr_a0(2,ip)*d(2)*d(2)*s22 +
     &	         cr_a0(3,ip)*d(2)*d(3)*s23
	  dsda = dsda/dist**2/sigmap - sigmap/dist * drda
	  dsda = dsda + 2*pdf_delta(ip)*drda/dist**3
	  dsda = phi * dsda
	  dg   = ampl*gaus(kk)/sigma*((rd**2 - 1)*dsda + rd*drda)
	  fit_a(ig,iset,ipar) = fit_a(ig,iset,ipar) + dg
	endif
c
c ----- d/d(lattice parameter c)
c
	ipar = ipar + 1
	mpar = fit_jd(ipar)
	if (fit_ndpp(mpar).ne.0) then
	  drda = cr_a0(3,ip)*d(3)*d(3)+cr_a0(1,ip)*cosb(ip)*d(1)*d(3)
     &	                              +cr_a0(2,ip)*cosa(ip)*d(2)*d(3)
	  drda = drda / dist
	  dsda = cr_a0(1,ip)*d(3)*d(1)*s13 +
     &	         cr_a0(2,ip)*d(3)*d(2)*s23 +
     &	         cr_a0(3,ip)*d(3)*d(3)*s33
	  dsda = dsda/dist**2/sigmap - sigmap/dist * drda
	  dsda = dsda + 2*pdf_delta(ip)*drda/dist**3
	  dsda = phi * dsda
	  dg   = ampl*gaus(kk)/sigma*((rd**2 - 1)*dsda + rd*drda)
	  fit_a(ig,iset,ipar) = fit_a(ig,iset,ipar) + dg
	endif
c
c ----- d/d(lattice angle alpha)
c
	ipar = ipar + 1
	mpar = fit_jd(ipar)
	if (fit_ndpp(mpar).ne.0) then
	  drda = - cr_a0(2,ip)*cr_a0(3,ip)*sina(ip)*d(2)*d(3) / dist
	  dsda = - sigmap/dist * drda
	  dsda = dsda + 2*pdf_delta(ip)*drda/dist**3
	  dsda = phi * dsda
	  dg   = ampl*gaus(kk)/sigma*((rd**2 - 1)*dsda + rd*drda)
	  fit_a(ig,iset,ipar) = fit_a(ig,iset,ipar) + dg
	endif
c
c ----- d/d(lattice angle beta)
c
	ipar = ipar + 1
	mpar = fit_jd(ipar)
	if (fit_ndpp(mpar).ne.0) then
	  drda = - cr_a0(1,ip)*cr_a0(3,ip)*sina(ip)*d(1)*d(3) / dist
	  dsda = - sigmap/dist * drda
	  dsda = dsda + 2*pdf_delta(ip)*drda/dist**3
	  dsda = phi * dsda
	  dg   = ampl*gaus(kk)/sigma*((rd**2 - 1)*dsda + rd*drda)
	  fit_a(ig,iset,ipar) = fit_a(ig,iset,ipar) + dg
	endif
c
c ----- d/d(lattice angle gamma)
c
	ipar = ipar + 1
	mpar = fit_jd(ipar)
	if (fit_ndpp(mpar).ne.0) then
	  drda = - cr_a0(1,ip)*cr_a0(2,ip)*sina(ip)*d(1)*d(2) / dist
	  dsda = - sigmap/dist * drda
	  dsda = dsda + 2*pdf_delta(ip)*drda/dist**3
	  dsda = phi * dsda
	  dg   = ampl*gaus(kk)/sigma*((rd**2 - 1)*dsda + rd*drda)
	  fit_a(ig,iset,ipar) = fit_a(ig,iset,ipar) + dg
	endif
c
c ----- d/d(delta)
c
	ipar = ipar + 1
	mpar = fit_jd(ipar)
	if (fit_ndpp(mpar).ne.0) then
	  dg = ampl*gaus(kk)/sigma/dist/dist*(rd**2 - 1)
	  dg = phi * dg
	  fit_a(ig,iset,ipar) = fit_a(ig,iset,ipar) + dg
	endif
c
c ----- d/d(csca)
c
	ipar = ipar + 1
c
c ----- d/d(srat)
c
	ipar = ipar + 1
	mpar = fit_jd(ipar)
	if (fit_ndpp(mpar).ne.0) then
	  dg = dphi*ampl*gaus(kk)/sigma*(rd**2 - 1)
	  fit_a(ig,iset,ipar) = fit_a(ig,iset,ipar) + dg
	endif
c
	end
c*****7*****************************************************************
	subroutine pdf_range (zeile,lp)
c+
c	Sets R-range for fitting
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'errlist.inc'
	include 	'pdf.inc'
c
	integer		maxw
	parameter	(maxw=10)
c
	character*(*)	zeile
	integer		lp
c
	character*200	cpara(maxw),cdummy
	integer		ianz,lpara(maxw),is
	real		werte(maxw)
	logical		lall
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if(ianz.eq.3) then
	  cdummy = cpara(1)
	  call do_cap(cdummy)
	  if (cdummy(1:3).eq.'ALL') then
	    lall = .true.
	    call del_params (1,ianz,cpara,lpara,maxw)
	  else
	    lall = .false.
	  endif
c
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (lall) then
	    do is=1,pdf_nset
	      if (werte(1).ge.pdf_rmin(is) .and. 
     &	          werte(1).le.pdf_rmax(is) .and.
     &	          werte(2).le.pdf_rmax(is) .and.
     &	          werte(2).le.pdf_rmax(is) .and.
     &	          werte(2).gt.werte(1)          ) then
	        pdf_rfmin(is) = werte(1)
	        pdf_rfmax(is) = werte(2)
	      else
	        ier_num = -116
	        ier_typ = ER_APPL
	      endif
	    enddo
	  else
	    is = nint(werte(1))
	    if (is.ge.1 .and. is.le.pdf_nset) then
	      if (werte(2).ge.pdf_rmin(is) .and. 
     &	          werte(2).le.pdf_rmax(is) .and.
     &	          werte(3).le.pdf_rmax(is) .and.
     &	          werte(3).le.pdf_rmax(is) .and.
     &	          werte(3).gt.werte(2)          ) then
	        pdf_rfmin(is) = werte(2)
	        pdf_rfmax(is) = werte(3)
	      else
	        ier_num = -116
	        ier_typ = ER_APPL
	      endif
	    else
	      ier_num = -106
	      ier_typ = ER_APPL
	    endif  
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif  
c
	end
c*****7*****************************************************************
	subroutine pdf_pselect (zeile,lp)
c+
c	Sets phases used for data set
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'errlist.inc'
	include 	'pdf.inc'
c
	integer		maxw
	parameter	(maxw=20)
c
	character*(*)	zeile
	integer		lp
c
	character*200	cpara(maxw),cdummy
	integer		i,ianz,iianz,lpara(maxw),is,ip
	real		werte(maxw)
	logical		lall
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if(ianz.ge.2) then
	  iianz = 1
	  call ber_params(iianz,cpara,lpara,werte,maxw)
	  is = nint(werte(1))
	  if (is.ge.1 .and. is.le.pdf_nset) then
	    call del_params (1,ianz,cpara,lpara,maxw)
	    cdummy = cpara(1)
	    call do_cap(cdummy)
	    if (cdummy(1:3).eq.'ALL') then
	      do i=1,MAXPHA
	        pdf_psel(i,is) = .true.
	      enddo
	    else
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      do i=1,MAXPHA
	        pdf_psel(i,is) = .false.
	      enddo
	      do i=1,ianz
	        ip = nint(werte(i))
	        if (ip.ge.1 .and. ip.le.cr_npha) then
	          pdf_psel(ip,is) = .true.
	        else
	          ier_num = -102
	          ier_typ = ER_APPL
	        endif
	      enddo
	    endif
	  else
	    ier_num = -106
	    ier_typ = ER_APPL
	  endif  
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif  
c
	end
c*****7*****************************************************************
	subroutine pdf_save (zeile,lp)
c+
c	Save PDF or current structure
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'errlist.inc'
	include		'prompt.inc'
	include		'date.inc'
	include 	'pdf.inc'
c
	integer		maxw
	parameter	(maxw=10)
c
	character*(*)	zeile
	integer		i,il,lp
	real		r
c
	character*200	cdummy,cpara(maxw)
	integer		ianz,iianz,lpara(maxw),ip,is,ipha,iset
	real		werte(maxw)
	logical		ldiscus
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if(ianz.ge.2) then
	  call do_cap(cpara(1))
	  cdummy = cpara(1)
	  if (ier_num.ne.0) return
c
c------ - Save structure for given phase for plotting in ATOMS
c
	  if (cdummy(1:2).eq.'AT') then
	    call del_params (1,ianz,cpara,lpara,maxw)
	    iianz = 1
	    call ber_params(iianz,cpara,lpara,werte,maxw)
	    if (ier_num.ne.0) return
c
	    ipha = nint(werte(1))
	    if (ipha.ge.1 .and. ipha.le.cr_npha) then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call do_build_name (ianz,cpara,lpara,werte,maxw,1)
	      if (ier_num.ne.0) return
	      write (output_io,1510) ipha,cpara(1)(1:lpara(1))
	      call save_atoms(ipha,cpara(1),lpara(1))
	    else
	      ier_num = -101
	      ier_typ = ER_APPL
	    endif
c
c------ - Save structure for given phase
c
	  elseif (cdummy(1:2).eq.'ST' .or. cdummy(1:3).eq.'DIS') then
	    ldiscus = cdummy(1:3).eq.'DIS'
	    call del_params (1,ianz,cpara,lpara,maxw)
	    iianz = 1
	    call ber_params(iianz,cpara,lpara,werte,maxw)
	    if (ier_num.ne.0) return
c
	    ipha = nint(werte(1))
	    if (ipha.ge.1 .and. ipha.le.cr_npha) then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call do_build_name (ianz,cpara,lpara,werte,maxw,1)
	      if (ier_num.ne.0) return
	      if (ldiscus) then
	        write (output_io,1520) ipha,cpara(1)(1:lpara(1))
	      else
	        write (output_io,1530) ipha,cpara(1)(1:lpara(1))
	      endif
	      call save_struc(ipha,cpara(1),lpara(1),ldiscus)
	    else
	      ier_num = -101
	      ier_typ = ER_APPL
	    endif
c
c------ - Save fit results 
c
	  elseif (cdummy(1:2).eq.'RE') then
	    call del_params (1,ianz,cpara,lpara,maxw)
	    call do_build_name (ianz,cpara,lpara,werte,maxw,1)
	    write (output_io,1502) cpara(1)(1:lpara(1))
	    call oeffne (57,cpara(1),'unknown',.false.)
	    if (ier_num.ne.0) return
	    write(57,9000) version,cdate
	    do ipha=1,cr_npha
	      call output_phase(57,ipha)
	    enddo
	    do iset=1,pdf_nset
	      call output_pdf(57,iset)
	    enddo
	    call output_par(57)
	    call output_fit(57)
	    write(57,9010)
	    close(57)
c
c------ - Save parameter constraint definitions
c
	  elseif (cdummy(1:2).eq.'CO') then
	    call del_params (1,ianz,cpara,lpara,maxw)
	    call do_build_name (ianz,cpara,lpara,werte,maxw,1)
	    write (output_io,1502) cpara(1)(1:lpara(1))
	    call oeffne (57,cpara(1),'unknown',.false.)
	    if (ier_num.ne.0) return
	    write(57,9000) version,cdate
	    call output_const(57,-1)
	    write(57,9010)
	    close(57)
c
c------ - Save PDF (G(r))
c
	  elseif (cdummy(1:2).eq.'PD' .or. 
     &	          cdummy(1:3).eq.'DIF'    ) then
	    call del_params (1,ianz,cpara,lpara,maxw)
	    iianz = 1
	    call ber_params(iianz,cpara,lpara,werte,maxw)
	    if (ier_num.ne.0) return
c
	    iset = nint(werte(1))
	    if (iset.lt.1 .or. iset.gt.pdf_nset) then
	      ier_num = -106
	      ier_typ = ER_APPL
	    else
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call do_build_name (ianz,cpara,lpara,werte,maxw,1)
	      if (ier_num.ne.0) return
	      call oeffne (57,cpara(1),'unknown',.false.)
	      if (ier_num.eq.0) then
	        if (cdummy(1:3).eq.'PDF') then
	          write (output_io,1505) iset,cpara(1)(1:lpara(1))
	          do i=pdf_nfmin(iset),pdf_nfmax(iset)
	            r = (i-1)*pdf_deltar(iset) + pdf_rmin(iset)
	            write (57,5000) r,pdf_tot(i,iset),0.0,
     &	                            1.0/sqrt(pdf_wic(i,iset))
	          enddo
	        elseif (cdummy(1:3).eq.'DIF') then
	          write (output_io,1507) iset,cpara(1)(1:lpara(1))
	          do i=pdf_nfmin(iset),pdf_nfmax(iset)
	            r = (i-1)*pdf_deltar(iset) + pdf_rmin(iset)
	            write (57,5010) r,pdf_obs(i,iset)-pdf_tot(i,iset)
	          enddo
	        endif
	        close (57)
	      endif
	    endif
c
c------ --unknown subcommand given
c
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
1502	format (' Saving fit results to file : ',A,' ...')
1505	format (' Saving PDF data set ',I3,' to file : ',A,' ...')
1507	format (' Saving difference data set ',I3,' to file : ',
     &	          A,' ...')
1510	format (' Saving structure (ATOMS format) phase ',I3,
     &	        ' to file : ',A,' ...')
1520	format (' Saving structure (DISCUS format) phase ',I3,
     &	        ' to file : ',A,' ...')
1530	format (' Saving structure phase ',I3,' to file : ',A,' ...')
5000	format (F9.4,3X,F16.5,10X,F3.1,2X,F16.5)
5010	format (F9.4,3X,F16.5)
9000	format (1x,78('='),/,' PDF REFINEMENT ',/,
     &	        3x,'Using PDFFIT version : ',a,/,
     &	        3x,'            compiled : ',a,/,1x,78('='))
9010	format (1x,78('='))
	end
c*****7*****************************************************************
	subroutine do_xray (zeile,lp)
c-
c	Setting Q to calculate f(xray) ..
c+
	implicit      	none
c
	include 	'config.inc'
	include 	'prompt.inc'
	include 	'pdf.inc'
	include 	'errlist.inc'
c
	integer       	maxw
	parameter    	(maxw=2)
c
	character*(*)	zeile
	integer		lp
c
	character*200 	cpara(maxw)
	integer       	lpara(maxw),length
	integer       	ianz
	real          	werte(maxw)
c
	call get_params (zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if     (ianz.eq.0) then
	  write (output_io,1000) pdf_xq
	elseif (ianz.eq.1) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  pdf_xq = werte(1)
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
1000	format (1x,'------ > Current Q for X-ray weights : ',g14.6)
	end
c*****7*****************************************************************
	subroutine celltoindex (icell,isite,iatom,ip)
c-
c 	calculates in which unit cell on which site the atom <ia> is
c+
	implicit	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'errlist.inc'
c
	integer		ip,iatom,isite,icell(3)
c
	iatom = ((icell(3)-1)*cr_icc(1,ip)*cr_icc(2,ip) +
     &	         (icell(2)-1)*cr_icc(1,ip)              + 
     &	         (icell(1)-1)                          )*
     &	                                   cr_ncatoms(ip)+isite
c
	end
c*****7*****************************************************************
	subroutine indextocell (iatom,ic,is,ip)
c-
c 	calculates in which unit cell on which site the atom <ia> is
c+
	implicit	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'errlist.inc'
c
	integer		iatom,is,ip,ic(3)
	integer		ia
c
        ia       = iatom-1
c
        ic(3)=int(ia/cr_icc(1,ip)/cr_icc(2,ip)/cr_ncatoms(ip))+1
        ia   =ia-(ic(3)-1)*cr_icc(1,ip)*cr_icc(2,ip)*cr_ncatoms(ip)
        ic(2)=int(ia/cr_icc(1,ip)/cr_ncatoms(ip))+1
        ia   =ia-(ic(2)-1)*cr_icc(1,ip)*cr_ncatoms(ip)
        ic(1)=int(ia/cr_ncatoms(ip))+1
	is   =ia-(ic(1)-1)*cr_ncatoms(ip)+1
c
	end
