	program pdffit
c
	implicit 	none
	character*10	aktuell
	parameter	(aktuell= '1.2      ')
c*****7*****************************************************************
c
c	Main program for PDFFIT
c
c	This is the main program for PDFFIT. It sets up most
c	variables and calls the loop interpreting the commands.
c
c	Authors : Th. Proffen (tproffen@lanl.gov)
c	          S. Billinge (billinge@.pa.msu.edu)
c
c*****7*****************************************************************
	include 	'errlist.inc'
	include 	'doact.inc'
	include 	'learn.inc'
	include 	'macro.inc'
	include 	'prompt.inc'
c
	character*200	line,zeile
	character*4	befehl
	logical       	lend
	integer       	laenge,lp,lbef
c                                         
	lend              = .false.
	blank             = ' '
	version           = aktuell
	pname             = 'pdffit'
	pname_cap         = 'PDFFIT'
	prompt            = pname
	prompt_status     = PROMPT_ON
	prompt_status_old = PROMPT_ON
c
c------ Setting up variables and print start screen
c
	call setup
	call no_error
c
c------ This is the main loop: reading commands ..
c
	do while(.not.lend)
	  call get_command (line,laenge,befehl,lbef,zeile,lp,prompt)
	  if(ier_num.eq.0 .and. laenge.gt.0) then
c
c------	- If not a comment continue
c
	    if(.not.(line(1:1).eq.'#' .or. line(1:1).eq.'!')) then
c
c------	- execute command
c
	      if(line(1:3).eq.'do ' .OR. line(1:2).eq.'if') then
	        call do_loop   (line,lend,laenge)
	      else
	        call mache_kdo (line,lend,laenge)
	      endif
	    endif
	  endif
c
c------	- Handle error message
c
	  if(ier_num.ne.0) then
	    call errlist
	    if(lmakro) then
	      call macro_close
	      prompt_status = PROMPT_ON
	    endif
	    lblock  = .false.
	    call no_error
	  endif
	enddo
c                             
9999	continue
c
	if (output_io.ne.OUTPUT_SCREEN) then
	  close(output_io)
	endif
c
	end
c*****7*****************************************************************
	subroutine setup
c
c	This routine makes inital setup of DISCUS
c
	implicit      	none
c
	include 	'wink.inc'
	include 	'prompt.inc'
	include 	'date.inc'
c
	fpi = 16.00*atan(1.00)
	zpi =  8.00*atan(1.00)
	pi  =  4.00*atan(1.00)
	rad = zpi/360.00
	call ini_ran(0)
c
c------ Write starting screen
c
	write(*,1000) version,cdate
c
c------	Call initialization routine
c
	call initarrays
	call init_sysarrays
	call do_reset
c
c------	get envirmonment information
c
	call appl_env
c
c------	try to read default file
c
	call autodef
c
c------	try to read command line arguments
c
	call cmdline_args
c
1000    format (/,10x,59('*'),/,10x,'*',15x,
     &            'P D F F I T   Version ',
     &            a10,10x,'*',/,10x,'*',57(' '),'*',/
     &            10x,'*         Created : ',a35,3x,'*',/,10x,'*',
     &            57('-'),'*',/,
     &	          10x,'* (c) Thomas Proffen  -     ',
     &            'Email: tproffen@lanl.gov      *',/,
     &            10x,'*     Simon Billinge  -     ',
     &            'Email: billinge@pa.msu.edu    *',/,
     &            10x,59('*'),/)
	end
