C****************************************************************************
C	PDFCONV - PDF conversion program
C
C	This program converts ascii PDFFIT files back to binary PDFs 
C	(Simon's format).
C
C	Version: 1.0
C	Author : Thomas Proffen
C
C****************************************************************************
	program pdfconv
c
	parameter	(pi     = 3.141592654)
	parameter	(maxdat = 2500)
c
	character*80    fname,aname,title,hist
	real		xa(maxdat),pdf(maxdat),dpdf(maxdat),y2(maxdat)
c
	write (*,1000)
	read(*,5000) fname
	write (*,1100)
	read(*,5000) aname
c
	open (1,file=fname,status='old')
	n = 1
10	continue
	  read (1,*,end=20) xa(n),pdf(n),dummy,dpdf(n)
	  y2(n) = 0.0
	  n = n+1
	goto 10
20	continue
	close(1)
c
	dr = xa(2)-xa(1)
	j  = 1
	do i=j,n
	   pdf(i) = pdf(i)  / (4.0*pi*xa(i))
	  dpdf(i) = dpdf(i) / (4.0*pi*xa(i))
	enddo
c
	title='Converted file from PDFFIT'
	rho=0.075
	j = int(xa(1)/dr)
c
	call pdfwrite(aname,xa,pdf,dpdf,y2,dr,rho,j,n,title,hist)
c
c
1000	format ('Give name of input ascii   PDF file  : ',$)
1100	format ('Give name of output binary PDF file  : ',$)
5000	format (a)
	end
C****************************************************************************
	SUBROUTINE PDFWRITE(FILROOT,XA,PDF,DPDF,Y2,DELTAR,RHOINP,J
     1         ,NRDF,TITLE,HISTRY)

C****************************************************************************
C* PURPOSE: subroutine to write .PDF files.  
C****************************************************************************
C*CALLING ARGUMENTS:

C*    Character variables modified to use length matching to 
C*    actual call variables

	CHARACTER*(80) 	FILROOT	!(i)name of file to be read (no extension)
	REAL*4          XA(*)   !(o)array for first column of data	
	REAL*4 		PDF(*)  !(o)array for pdf
	REAL*4          DPDF(*) !(o)array for pdf error (DRDF)
	REAL*4          Y2(*)   !(o)array for fourth column of data
	REAL*4		DELTAR	!(o)spacing of r-points 	
	REAL*4		RHOINP	!(o)number density (no longer used)
	INTEGER*4	J 	!(o)number of the first point in the PDF
	INTEGER*4	NRDF	!(o)number of points in PDF.
	CHARACTER*(*)	HISTRY	!(o)header information
	CHARACTER*(*)	TITLE	!(o)header information

!INCLUDE STATEMENTS:

C*   Modified to use Standard format instead of DEC extension 

        OPEN(UNIT=2,FILE=FILROOT,
     1	STATUS='UNKNOWN',FORM='UNFORMATTED',ACCESS='SEQUENTIAL')

	WRITE(2) TITLE
	WRITE(2) HISTRY
	WRITE(2) j,Nrdf,DELTAR,rhoinp
        WRITE(2) (1.0,PDF(I),DPDF(I),1.0,I=1,Nrdf)
	CLOSE(2)

	return
	END 

