	program inp2mac
c*****7***************************************************************
c	This program converts a 'Simon style' input file into
c	a PDFFIT structure file.
c
c	Version: 1.0
c	Date:    01. December 1998
c	Author:  Thomas Proffen
c*****7***************************************************************
c
	parameter	(maxat = 250)
c
 	character*80	line,ifile,sfile,title
	character*4	name(maxat)
	real		pos(3,maxat),occ(maxat),u(3,maxat)
c
	write (*,1000)
	read (*,5000) ifile
c
	sfile = ifile(1:len_str(ifile))//'.stru'
	ifile = ifile(1:len_str(ifile))//'.inp'
c
c------ First we read the input file
c
	open (1,file=ifile,status='old')
	read (1,5000) title
	read (1,5000)
	read (1,*) nat
	read (1,5000)
	read (1,*) a,b,c,alpha,beta,gamma
	read (1,5000)
	read (1,5000)
c
	do ia=1,nat
	  read (1,2000) name(ia),ii,ii,(pos(i,ia),i=1,3),occ(ia)
	enddo
c
	do ia=1,nat
	  read (1,*) ii,(u(i,ia),i=1,3)
	enddo
	close (1)
c
c------ Now we write PDFFIT structure file
c
	write (*,1010) sfile(1:len_str(sfile))
	open (1,file=sfile,status='unknown')
	write (1,3000) title(1:len_str(title))
	write (1,3005)
	write (1,3008) 1.0
	write (1,3010) 'P1'
	write (1,3020) a,b,c,alpha,beta,gamma
	write (1,3025) 0.0,0.0,0.0,0.0,0.0,0.0
	write (1,3030) 1,1,1,nat
	write (1,3900)
	do ia=1,nat
	  write (1,4000) name(ia),(pos(i,ia),i=1,3),occ(ia),
     &	                 0.0,0.0,0.0, 0.0,
     &	                 (u(i,ia)**2,i=1,3),0.0,0.0,0.0,
     &	                 0.0,0.0,0.0,  0.0,0.0,0.0
	enddo	
	close (1)
c
1000	format ('Give name of input file without extension .inp : ',$)
1010	format ('Writing structure file ',a,' ...')
2000	format (7x,a4,2i3,1x,4f8.4)
3000	format('title  ',a)
3005	format('format pdffit')
3008	format('scale ',f12.4)
3010	format('spcgr  ',a16)
3020	format('cell  ',5(f10.6,','),f10.6)
3025	format('dcell ',5(f10.6,','),f10.6)
3030	format('ncell ',3(i8,','),i10)
3900	format('atoms ')
4000	format(a4,3(2x,f16.8),1x,f12.4,/,4x,3(2x,f16.8),1x,f12.4,
     &	       4(/,4x,3(2x,f16.8)))
5000	format (a)
c
	end
c*****7***************************************************************
	integer function len_str(string)
c-
c	Determines the position of the last non-blank character
c+
	implicit       none
c
	character*(*)  string
	integer        laenge,i
c
	laenge=len(string)
	i=laenge
	do while (i.gt.0 .and. string(i:i).eq.' ')
	  i=i-1
	enddo
	len_str=i
	end
