C****************************************************************************
C	PDFCONV - PDF conversion program
C
C	This program converts binary PDFs (Simon's format) to ASCII
C	files that can be used by PDFFIT.
C
C	Version: 1.0
C	Author : Thomas Proffen
C
C****************************************************************************
	program pdfconv
c
	parameter	(pi     = 3.141592654)
	parameter	(maxdat = 2500)
c
	character*80    fname,aname,title,hist
	real		xa(maxdat),pdf(maxdat),dpdf(maxdat),y2(maxdat)
c
	write (*,1000)
	read(*,5000) fname
	write (*,1100)
	read(*,5000) aname
c
	call pdfread(fname,xa,pdf,dpdf,y2,dr,rho,j,n,title,hist)
c
	open (1,file=aname,status='unknown')
	do i=j,n
	   r = float(i)*dr
	   g = 4.0*pi*r* pdf(i)
	  dg = 4.0*pi*r*dpdf(i)
	  write(1,2000) r,g,0.0,dg
	enddo
	close(1)
c
1000	format ('Give name of input binary PDF file  : ',$)
1100	format ('Give name of output ascii PDF file  : ',$)
2000	format (2(f11.6,2x),4x,f3.1,4x,f11.6)
5000	format (a)
	end
C****************************************************************************
	SUBROUTINE PDFREAD(FILROOT,XA,PDF,DPDF,Y2,DELTAR,RHOINP,J
     1         ,NRDF,TITLE,HISTRY)

C****************************************************************************
C* PURPOSE: subroutine to read .PDF files.  
C*
C*PROGRAMMED by Simon Billinge 1990. Cleaned up 1995 by Wayne C. Tonjes
C*
C* $Id: pdfread.f,v 1.1 1997/05/06 19:50:45 billinge Exp $
C*
C****************************************************************************
C*CALLING ARGUMENTS:

C*    Character variables modified to use length matching to 
C*    actual call variables

	CHARACTER*(80) 	FILROOT	!(i)name of file to be read (no extension)
	REAL*4          XA(*)   !(o)array for first column of data	
	REAL*4 		PDF(*)  !(o)array for pdf
	REAL*4          DPDF(*) !(o)array for pdf error (DRDF)
	REAL*4          Y2(*)   !(o)array for fourth column of data
	REAL*4		DELTAR	!(o)spacing of r-points 	
	REAL*4		RHOINP	!(o)number density (no longer used)
	INTEGER*4	J 	!(o)number of the first point in the PDF
	INTEGER*4	NRDF	!(o)number of points in PDF.
	CHARACTER*(*)	HISTRY	!(o)header information
	CHARACTER*(*)	TITLE	!(o)header information

!INCLUDE STATEMENTS:

C*   Modified to use Standard format instead of DEC extension 
        OPEN(UNIT=2,FILE=FILROOT,
     1	STATUS='OLD',FORM='UNFORMATTED',ACCESS='SEQUENTIAL')

	READ(2) TITLE
	READ(2) HISTRY
	READ(2) j,Nrdf,DELTAR,rhoinp
        READ(2) (XA(I),PDF(I),DPDF(I),Y2(I),I=J,Nrdf)
	CLOSE(2)

	return
	END 

